<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_article.php                                        ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("articles");

	$html_editor = get_setting_value($settings, "html_editor", 1);
	$category_id = get_param("category_id");
	if (!strlen($category_id)) {
		header("Location: admin.php");
		exit;
	} else {
		$sql  = " SELECT category_path, parent_category_id, allowed_rate ";
		$sql .= " FROM " . $table_prefix . "articles_categories ";
		$sql .= " WHERE category_id=" . $db->tosql($category_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$category_allowed_rate = $db->f("allowed_rate");
			$parent_category_id = $db->f("parent_category_id");
			$category_path = $db->f("category_path");
			if($parent_category_id == 0) {
				$parent_category_id = $category_id;
			} else {
				$categories_ids = explode(",", $category_path);
				$parent_category_id = $categories_ids[1];
			}
		}
	}
	$sql  = " SELECT article_list_fields,article_details_fields,article_required_fields ";
	$sql .= " FROM " . $table_prefix . "articles_categories ";
	$sql .= " WHERE category_id=" . $db->tosql($parent_category_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$shown_fields = ",," . $db->f("article_list_fields") . "," . $db->f("article_details_fields") . ",,";
		$required_fields = ",," . $db->f("article_required_fields") . ",,";
	}

	$content_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$article_fields = array(
		"article_date", "date_end", "article_title", "author_name", "author_email", 
		"author_url", "link_url", "download_url", "short_description", "full_description",
		"image_small", "image_large", "keywords", "notes"
	);

 	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_var("css_file", "../styles/" . $settings["style_name"] . ".css");
 	$t->set_file("main","admin_article.html");

	$t->set_var("admin_articles_top_href", "admin_articles_top.php");
	$t->set_var("admin_article_href", "admin_article.php");
	$t->set_var("admin_upload_href",  "admin_upload.php");
	$t->set_var("admin_select_href",  "admin_select.php");
	$t->set_var("admin_articles_href", "admin_articles.php");
	$t->set_var("datetime_format", join("", $datetime_edit_format));
	$t->set_var("html_editor", $html_editor);


	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree", "");
	$tree->show($category_id);

	$r = new VA_Record($table_prefix . "articles");

	$r->add_where("article_id", INTEGER);
	$r->change_property("article_id", USE_IN_INSERT, true);
	$r->add_hidden("category_id", INTEGER);
	
	//Common info
	$r->add_textbox("article_order", INTEGER, "Order");
	$r->change_property("article_order", REQUIRED, true);
	$r->add_textbox("total_views", INTEGER);
	$r->change_property("total_views", USE_IN_INSERT, false);
	$r->change_property("total_views", USE_IN_UPDATE, false);
	$r->add_textbox("article_title", TEXT, "Title");
	$r->change_property("article_title", MAX_LENGTH, 255);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("article_date", DATETIME, "Date");
	$r->change_property("article_date", VALUE_MASK, $datetime_edit_format);
	$r->add_textbox("date_end", DATETIME, "Date End");
	$r->change_property("date_end", VALUE_MASK, $datetime_edit_format);
	//$r->add_textbox("language_code", TEXT, "Language Code");
	//$r->change_property("language_code", MAX_LENGTH, 2);
	//$r->add_textbox("article_template", TEXT, "Article Template");
	//$r->change_property("article_template", MAX_LENGTH, 255);
	
	// author information
	$r->add_textbox("author_name", TEXT, "Author Name");
	$r->change_property("author_name", MAX_LENGTH, 255);
	$r->add_textbox("author_email", TEXT, "Author Email");
	$r->change_property("author_email", MAX_LENGTH, 255);
	$r->change_property("author_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("author_url", TEXT, "Author URL");
	$r->change_property("author_url", MAX_LENGTH, 255);
	$r->add_hidden("author_remote_address", TEXT);
	$r->change_property("author_remote_address", USE_IN_INSERT, true);
	
	// statuses
	$statuses = get_db_values("SELECT * FROM " . $table_prefix . "articles_statuses WHERE is_shown=1", array(array("", "")));
	$r->add_select("status_id", INTEGER, $statuses, "Status");
	$r->change_property("status_id", REQUIRED, true);
	$r->add_checkbox("allowed_rate", INTEGER);
	
	// links 
	$r->add_textbox("link_url", TEXT, "Link URL");
	$r->add_textbox("download_url", TEXT, "Download URL");
	// $r->add_textbox("is_link_direct", TEXT, "Link is direct");
	
	// article editors and date edit
	$r->add_hidden("created_user_id", INTEGER);
	$r->change_property("created_user_id", USE_IN_INSERT, true);
	$r->add_hidden("updated_user_id", INTEGER);
	$r->change_property("updated_user_id", USE_IN_INSERT, true);
	$r->change_property("updated_user_id", USE_IN_UPDATE, true);
	$r->add_hidden("created_admin_id", INTEGER);
	$r->change_property("created_admin_id", USE_IN_INSERT, true);
	$r->add_hidden("updated_admin_id", INTEGER);
	$r->change_property("updated_admin_id", USE_IN_INSERT, true);
	$r->change_property("updated_admin_id", USE_IN_UPDATE, true);

	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_INSERT, true);
	$r->add_textbox("date_updated", DATETIME);	
	$r->change_property("date_updated", USE_IN_INSERT, true);
	$r->change_property("date_updated", USE_IN_UPDATE, true);
	
	// images
	$r->add_textbox("image_small", TEXT, "Small Image");
	$r->add_textbox("image_small_alt", TEXT);
	$r->add_textbox("image_large", TEXT, "Large Image");
	$r->add_textbox("image_large_alt", TEXT);

	// descs
	$r->add_checkbox("is_hot", INTEGER, "Show on main page");
	$r->add_textbox("hot_description", TEXT, "Hot Description");
	$r->add_textbox("short_description", TEXT, "Short Description");
	$r->add_radio("is_html", INTEGER, $content_types);
	$r->add_textbox("full_description", TEXT, "Full Description");
	$r->add_textbox("keywords", TEXT, "Keywords");
	$r->add_textbox("notes", TEXT, "Notes");

	// meta data
	$r->add_textbox("meta_title", TEXT);
	$r->add_textbox("meta_keywords", TEXT);
	$r->add_textbox("meta_description", TEXT);
	
	// stats 
	$r->add_hidden("total_votes",  INTEGER, "Total Votes");
	$r->change_property("total_votes", USE_IN_INSERT, true);
	$r->add_hidden("total_points", INTEGER, "Total Points");
	$r->change_property("total_points", USE_IN_INSERT, true);
	$r->add_hidden("rating", INTEGER, "Rating");
	$r->change_property("rating", USE_IN_INSERT, true);
	$r->add_hidden("total_clicks", INTEGER, "Total Clicks");
	$r->change_property("total_clicks", USE_IN_INSERT, true);

	$r->get_form_values();

	for ($i = 0; $i < sizeof($article_fields); $i++) {
		$field_name = $article_fields[$i];
		if (!strpos($shown_fields, "," . $field_name . ",")) {
			$r->change_property($field_name, SHOW, false);
			if($field_name == "article_date") {
				$r->set_value($field_name, va_time());
			}
		}
		if (strpos($required_fields, "," . $field_name . ",")) {
			$r->change_property($field_name, REQUIRED, true);
		}
	}

	if(!$r->parameters["image_small"][SHOW]) {
		$r->change_property("image_small_alt", SHOW, false);
	}
	if(!$r->parameters["image_large"][SHOW]) {
		$r->change_property("image_large_alt", SHOW, false);
	}


	$article_id = get_param("article_id");
	$operation = get_param("operation");
	$return_page = "admin_articles.php?category_id=" . $category_id;

	if(strlen($operation))
	{
		if($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} //cancel
		else if($operation == "delete" && $article_id) {			
			$categories = "";
			$sql  = " SELECT category_id FROM " . $table_prefix . "articles_assigned ";
			$sql .= " WHERE article_id = " . $db->tosql($article_id, INTEGER);
			$db->query($sql);
			while($db->next_record()) $categories[] = $db->f("category_id");
			if(is_array($categories)) {
				for($i = 0; $i < sizeof($categories); $i++) {
					$db->query("UPDATE " . $table_prefix . "articles_categories SET total_articles = total_articles - 1 WHERE category_id = " . $db->tosql($categories[$i], INTEGER));
				}
			}
			// tables with article_id: articles, articles_assigned, articles_related, articles_images, articles_reviews
			$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles_related WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles_images WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles_reviews WHERE article_id = " . $db->tosql($article_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "articles WHERE article_id = " . $db->tosql($article_id, INTEGER));
			
			header("Location: " . $return_page);
			exit;
		} //delete

		$is_valid = $r->validate();
		
		if($is_valid) {
			if(strlen($article_id)) {
				set_friendly_url();
				$r->set_value("date_updated", va_time());
				$r->set_value("updated_admin_id", get_session("session_admin_id"));
				$record_updated = $r->update_record();
			} else {
				set_friendly_url();
				$db->query("SELECT MAX(article_id) FROM " . $table_prefix . "articles");
				$db->next_record();
				$article_id = $db->f(0) + 1;
				$remote_address = get_ip("REMOTE_ADDR");
				$r->set_value("article_id", $article_id);
				$r->set_value("author_remote_address", $remote_address);
				if ($r->is_empty("total_views")) {
					$r->set_value("total_views", 0);
				}
				$r->set_value("total_votes",  0);
				$r->set_value("total_points", 0);
				$r->set_value("rating", 0);
				$r->set_value("total_clicks", 0);
				$r->set_value("created_admin_id", get_session("session_admin_id"));
				$r->set_value("updated_admin_id", get_session("session_admin_id"));
				$r->set_value("date_added", va_time());
				$r->set_value("date_updated", va_time());
				$record_updated = $r->insert_record();
				if ($record_updated) {
					$sql  = " INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (";
					$sql .= $db->tosql($article_id, INTEGER) . ",";
					$sql .= $db->tosql($category_id, INTEGER) . ")";
					$db->query($sql);
					$db->query("UPDATE " . $table_prefix . "articles_categories SET total_articles = total_articles + 1 WHERE category_id = " . $category_id);
				} else {
					$article_id = "";
					$r->set_value("article_id", "");
				}
			}
	
			if ($record_updated) {
				header("Location: " . $return_page);
				exit;
			}
		}
	}
	else if(strlen($article_id)) {
		$r->get_db_values();
	}	else { // set default values for new records
		$sql  = " SELECT MAX(article_order) FROM " . $table_prefix . "articles a, " . $table_prefix . "articles_assigned aa ";
		$sql .= " WHERE a.article_id = aa.article_id ";
		$sql .= " AND aa.category_id = " . $db->tosql($category_id, INTEGER);
		$article_order = get_db_value($sql);
		$article_order = ($article_order) ? ($article_order + 1) : 1;
		$r->set_value("article_order", $article_order);
		$r->set_value("article_date", va_time());
		$r->set_value("status_id", 1);
		$r->set_value("allowed_rate", $category_allowed_rate);
		$r->set_value("is_html", 0);
	}

	$r->set_form_parameters();

	if (strpos($shown_fields, ",link_url,") || strpos($shown_fields, ",download_url,")) {
		$t->parse("links_title", false);
	} else {
		$t->set_var("links_title", "");
	}
	if (strpos($shown_fields, ",author_name,") || strpos($shown_fields, ",author_email,") || strpos($shown_fields, ",author_url,")) {
		$t->parse("author_title", false);
	} else {
		$t->set_var("author_title", "");
	}

	if(strlen($article_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>