<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_articles_assign.php                                ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("articles");

	$article_id = get_param("article_id");

 	$t = new VA_Template($settings["admin_templates_dir"]);
 	$t->set_file("main","admin_articles_assign.html");

	$t->set_var("admin_articles_top_href", "admin_articles_top.php");
	$t->set_var("admin_articles_assign_href", "admin_articles_assign.php");
	$t->set_var("admin_articles_href", "admin_articles.php");
	$t->set_var("admin_article_href",  "admin_article.php");

	$sql  = " SELECT article_title FROM " . $table_prefix . "articles ";
	$sql .= " WHERE article_id = " . $db->tosql($article_id, INTEGER);
	$db->query($sql);
	if($db->next_record())
		$t->set_var("article_title", get_translation($db->f("article_title")));
	else
		die("Article with such ID no longer exists in database.");

	$category_id = get_param("category_id");
	$top_id = 0;
	if (!strlen($category_id)) {
		header("Location: admin.php");
		exit;
	} else {
		$sql  = " SELECT category_path,parent_category_id ";
		$sql .= " FROM " . $table_prefix . "articles_categories ";
		$sql .= " WHERE category_id=" . $db->tosql($category_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$parent_category_id = $db->f("parent_category_id");
			$category_path = $db->f("category_path");
			if($parent_category_id == 0) {
				$top_id = $category_id;
			} else {
				$categories_ids = explode(",", $category_path);
				$top_id = $categories_ids[1];
			}
		}
	}


	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree", "");
	$tree->show($category_id);

	$operation = get_param("operation");
	$return_page = "admin_articles.php?category_id=" . $category_id;
	$errors = "";

	if($operation == "cancel")
	{
		header("Location: " . $return_page);
		exit;
	}
	else if($operation == "save")
	{
		$categories = get_param("categories");
		if(!strlen($categories))
			$errors .= "No categories was selected.<br>";
		
		if(!strlen($errors))
		{
			$categories = split(",", $categories);
			$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE article_id = " . $article_id);
			for($i = 0; $i < sizeof($categories); $i++)
				$db->query("INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (" . $article_id . "," . $db->tosql($categories[$i], INTEGER) . ")");
	
			header("Location: " . $return_page);
			exit;
		}
	}

	$sql  = " SELECT category_id, parent_category_id, category_name ";
	$sql .= " FROM " . $table_prefix . "articles_categories ";
	$sql .= " WHERE (category_id=" . $db->tosql($top_id, INTEGER);
	$sql .= " OR category_path LIKE '0," . $top_id . ",%') ";
	$sql .= " ORDER BY category_path";
	$db->query($sql);
	while($db->next_record())
	{
		$t->set_var("category_id", $db->f("category_id"));
		$t->set_var("parent_category_id", $db->f("parent_category_id"));
		$t->set_var("category_name", str_replace("\"", "\\\"", get_translation($db->f("category_name"))));
		$t->parse("categories");
	}

	$sql = " SELECT category_id FROM " . $table_prefix . "articles_assigned WHERE article_id = " . $article_id;
	$db->query($sql);
	while($db->next_record())
	{
		$t->set_var("category_id", $db->f("category_id"));
		$t->parse("selected_categories");
	}

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("article_id", $article_id);
	$t->set_var("category_id", $category_id);
	$t->set_var("top_id", $top_id);
	$t->set_var("selected_name", "selected[]");

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>