<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_category_edit.php                                  ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_category_edit.html");

	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_category_edit_href", "admin_category_edit.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$category_id = get_param("category_id");

	$r = new VA_Record($table_prefix . "categories");
	
	$r->add_where("category_id", INTEGER);
	$r->add_checkbox("is_showing", INTEGER, "Show on Site");
	$r->add_textbox("category_order", TEXT, "Category Order");
	$r->change_property("category_order", REQUIRED, true);
	$r->add_textbox("total_views", INTEGER);
	$r->change_property("total_views", USE_IN_INSERT, false);
	$r->change_property("total_views", USE_IN_UPDATE, false);
	$r->add_textbox("category_name", TEXT, "Category Name");
	$r->change_property("category_name", REQUIRED, true);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("short_description", TEXT);
	$r->add_textbox("full_description", TEXT);
	$r->add_checkbox("show_sub_products", INTEGER);
	$r->add_checkbox("allowed_post", INTEGER);
	$r->add_textbox("image", TEXT);
	$r->add_textbox("image_alt", TEXT);
	$r->add_textbox("image_large", TEXT);
	$r->add_textbox("image_large_alt", TEXT);

	//-- parent items
	$sql  = " SELECT * FROM " . $table_prefix . "categories ";
	$sql .= " ORDER BY category_path, category_order ";
	$db->query($sql);
	while($db->next_record()) {
		$list_id = $db->f("category_id");
		$list_parent_id = $db->f("parent_category_id");
		$list_title = get_translation($db->f("category_name"));

		$category_values = array(
			"category_name" => $list_title, "category_path" => $db->f("category_path")
		);
		$categories[$list_id] = $category_values;
		$categories[$list_parent_id]["subs"][] = $list_id;
		$parent_categories[$list_id] = $list_parent_id;
	}

	$items = array();
	$items[] = array(0, "[Top]");
	build_category_list(0);

	$r->add_select("parent_category_id", TEXT, $items, "Parent Category");
	$r->change_property("parent_category_id", REQUIRED, true);

	$r->add_textbox("category_path", TEXT);

	// templates settings
	$r->add_textbox("list_template", TEXT);
	$r->add_textbox("details_template", TEXT);

	// meta data
	$r->add_textbox("meta_title", TEXT);
	$r->add_textbox("meta_keywords", TEXT);
	$r->add_textbox("meta_description", TEXT);
	
	// editing information
	$r->add_textbox("admin_id_added_by", INTEGER);
	$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
	$r->add_textbox("admin_id_modified_by", INTEGER);
	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("date_modified", DATETIME);

	$r->get_form_values();

	if(!strlen($r->get_value("parent_category_id"))) $r->set_value("parent_category_id", "0");
	$parent_category_id = $r->get_value("parent_category_id");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($parent_category_id);

	$operation = get_param("operation");
	$return_page = "admin_items_list.php?category_id=" . $parent_category_id;
	if(strlen($operation))
	{
		$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "");

		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $r->get_value("category_id"))
		{
			$categories = "";
			$category_path = $tree->get_path($category_id);
			$sql  = " SELECT category_id FROM " . $table_prefix . "categories ";
			$sql .= " WHERE category_id=" . $db->tosql($category_id, INTEGER);
			$sql .= " OR category_path LIKE '" . $db->tosql($category_path, TEXT, false) . "%'";
			$db->query($sql);
			while($db->next_record())
				$categories[] = $db->f("category_id");

			if(is_array($categories))
			{
				for($i = 0; $i < sizeof($categories); $i++)
				{
					$db->query("DELETE FROM " . $table_prefix . "categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
					$db->query("DELETE FROM " . $table_prefix . "items_categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
				}
			}
	
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();
		
		if($is_valid)
		{
			// build path for current category
			$category_path = ""; 
			$category_id = $r->get_value("category_id");
			$parent_category_id = $r->get_value("parent_category_id");
			if ($category_id) {
				$parent_categories[$category_id] = $parent_category_id;
				if ($parent_category_id == $category_id) {
					$parent_category_id = 0;
				}
			}
			$current_parent_id = $parent_category_id;
			while ($current_parent_id) {
				$category_path = $current_parent_id.",".$category_path;
				$parent_id = isset($parent_categories[$current_parent_id]) ? $parent_categories[$current_parent_id] : 0;
				if ($parent_id == $current_parent_id) {
					$current_parent_id = 0;
				} else {
					$current_parent_id = $parent_id;
				}
			}
			$category_path = "0,".$category_path;

			$r->set_value("admin_id_added_by", get_session("session_admin_id"));
			$r->set_value("admin_id_modified_by", get_session("session_admin_id"));
			$r->set_value("date_added", va_time());
			$r->set_value("date_modified", va_time());
			$r->set_value("category_path", $category_path);
			$r->set_value("parent_category_id", $parent_category_id);

			if(strlen($r->get_value("category_id")))
			{
				set_friendly_url();
				$record_updated = $r->update_record();
				update_category_tree($category_id, $category_path);
			}
			else
			{
				set_friendly_url();
				$record_updated = $r->insert_record();
			}
			if ($record_updated) {
				header("Location: " . $return_page);
				exit;
			}
		}
	} else if(strlen($r->get_value("category_id")))	{
		$r->get_db_values();
	} else {
		$category_order = get_db_value("SELECT MAX(category_order) FROM " . $table_prefix . "categories WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER));
		$category_order++;
		$r->set_value("category_order", $category_order);
	}

	$r->set_parameters();

	if(strlen($category_id)) {
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}	else {
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

function spaces_level($level)
{
	$spaces = "";
	for ($i =1; $i <= $level; $i++) {
		$spaces .= "--";
	}
	return $spaces . " ";
}


function update_category_tree($parent_category_id, $category_path)
{
	global $db, $table_prefix, $categories, $parent_categories;

	if (isset($categories[$parent_category_id]["subs"])) {
		$category_path .= $parent_category_id . ",";

		$subs = $categories[$parent_category_id]["subs"];
		for ($s = 0; $s < sizeof($subs); $s++) {
			$sub_id = $subs[$s];
    
			$sql  = " UPDATE " . $table_prefix . "categories SET ";
			$sql .= " category_path=" . $db->tosql($category_path, TEXT);
			$sql .= " WHERE category_id=" . $db->tosql($sub_id, INTEGER);
			$db->query($sql);

			if (isset($categories[$sub_id]["subs"])) {
				update_category_tree($sub_id, $category_path);
			}
		}
	}

}

function build_category_list($parent_id) {
	global $t, $categories, $items;
	$subs = $categories[$parent_id]["subs"];
	for ($m = 0; $m < sizeof($subs); $m++) {
		$category_id = $subs[$m];
		$category_path = $categories[$category_id]["category_path"];
		$category_name = $categories[$category_id]["category_name"];
		$category_level = preg_replace("/\d/", "", $category_path);
		$spaces = spaces_level(strlen($category_level));

		$items[] = array($category_id, $spaces.$category_name);

		if (isset($categories[$category_id]["subs"])) {
			build_category_list($category_id);
		}
	}
}


?>