<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_coupon.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	$order_id = get_param("order_id");

	if ($order_id > 0) {
		check_admin_security("order_vouchers");
	} else {
		check_admin_security("coupons");
	}

	$s = get_param("s");
	$s_a = get_param("s_a");
	$discount_type = get_param("discount_type");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_coupon.html");

	$t->set_var("admin_coupon_href", "admin_coupon.php");

	$r = new VA_Record($table_prefix . "coupons");
	if ($order_id > 0) {
		$r->return_page  = "admin_order_vouchers.php?order_id=" . urlencode($order_id);
	} else {
		$r->return_page  = "admin_coupons.php?s=" . $s . "&s_a=" . $s_a;
	}

	$yes_no = 
		array( 
			array(1, "Yes"), array(0, "No")
		);

	$r->add_where("coupon_id", INTEGER);
	$r->add_textbox("order_id", INTEGER);
	$r->change_property("order_id", DEFAULT_VALUE, $order_id);
	$r->change_property("order_id", USE_IN_UPDATE, false);
	$r->add_select("order_item_id", INTEGER, "");

	$r->add_radio("is_active", INTEGER, $yes_no);
	$r->change_property("is_active", REQUIRED, true);
	$r->change_property("is_active", DEFAULT_VALUE, 1);

	$r->add_textbox("coupon_code", TEXT, "Coupon Code");
	$r->change_property("coupon_code", REQUIRED, true);
	$r->change_property("coupon_code", UNIQUE, true);
	$r->change_property("coupon_code", TRIM, true);
	$r->change_property("coupon_code", MIN_LENGTH, 4);
	$r->change_property("coupon_code", MAX_LENGTH, 64);
	$r->change_property("coupon_code", DEFAULT_VALUE, strtoupper(substr(md5(va_timestamp()), 0, 8)));
	$r->add_textbox("coupon_title", TEXT, "Coupon Title");
	$r->change_property("coupon_title", REQUIRED, true);
	$r->add_radio("discount_type", INTEGER, "");
	$r->change_property("discount_type", REQUIRED, true);
	$r->change_property("discount_type", DEFAULT_VALUE, $discount_type);
	$r->add_textbox("discount_type_text", INTEGER);
	$r->change_property("discount_type_text", COLUMN_NAME, "discount_type");
	$r->change_property("discount_type_text", CONTROL_NAME, "discount_type");
	$r->change_property("discount_type_text", DEFAULT_VALUE, $discount_type);

	$r->add_textbox("discount_amount", NUMBER, "Discount Amount");
	$r->change_property("discount_amount", REQUIRED, true);
	$r->change_property("discount_amount", DEFAULT_VALUE, 0);

	$r->add_checkbox("free_postage", NUMBER);
	$r->add_checkbox("tax_free", NUMBER);

	$r->add_checkbox("items_all", INTEGER);
	$r->change_property("items_all", DEFAULT_VALUE, 1);
	$r->add_textbox("items_ids", TEXT);

	$r->add_textbox("expiry_date", DATETIME, "Expiration Date");
	$r->change_property("expiry_date", VALUE_MASK, $date_edit_format);
	if ($discount_type != 5) {
		$r->change_property("expiry_date", DEFAULT_VALUE, va_time(va_timestamp() + (60*60*24*366)));
	}

	$r->add_textbox("minimum_amount", NUMBER);
	$r->add_checkbox("is_exclusive", NUMBER);

	$r->add_textbox("quantity_limit", INTEGER);
	$r->change_property("quantity_limit", DEFAULT_VALUE, 1);
	$r->add_textbox("coupon_uses", INTEGER);
	$r->change_property("coupon_uses", DEFAULT_VALUE, 0);
	$r->events[BEFORE_SHOW] = "set_record_controls";
	$r->events[AFTER_VALIDATE] = "set_record_controls";
	$r->process();

	$t->set_var("s", $s);
	$t->set_var("s_a", $s_a);


	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("date_added_format", join("", $date_edit_format));
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_coupons_href", "admin_coupons.php");
	$t->set_var("admin_orders_href",  "admin_orders.php");
	$t->set_var("admin_order_href",   "admin_order.php");
	$t->set_var("admin_order_vouchers_href", "admin_order_vouchers.php");

	if ($order_id > 0) {
		$t->parse("orders_path", false);
	} else {
		$t->parse("coupons_path", false);
	}

	$t->pparse("main");

	function set_record_controls()
	{
		global $t, $r, $db, $table_prefix;
		$discount_type = $r->get_value("discount_type");

		if ($r->get_value("order_id") < 1) {
			$r->set_value("order_id", 0);
			$r->set_value("order_item_id", 0);
			$r->change_property("order_item_id", SHOW, false);
		} else {
			$order_items = array();
			$sql  = " SELECT oi.order_item_id,oi.item_name ";
			$sql .= " FROM (" . $table_prefix . "orders_items oi ";
			$sql .= " LEFT JOIN " . $table_prefix . "item_types it ON oi.item_type_id=it.item_type_id) ";
			$sql .= " WHERE oi.order_id=" . $db->tosql($r->get_value("order_id"), INTEGER);
			$sql .= " AND it.is_gift_voucher=1 ";
			$order_items = get_db_values($sql, array(array("", "")));
			$r->change_property("order_item_id", VALUES_LIST, $order_items);
		}
		if ($discount_type <= 2) {
			$discount_types = array( array(1, "Percentage per order"), array(2, "Amount per order") );
			$r->change_property("discount_type", VALUES_LIST, $discount_types);
			$r->change_property("items_ids", SHOW, false);
			$r->change_property("discount_type_text", SHOW, false);
			$r->change_property("discount_type_text", USE_IN_INSERT, false);
			$r->change_property("discount_type_text", USE_IN_UPDATE, false);
			$t->set_var("minimum_amount_title", "Minimum purchase amount of order");
			$t->set_var("items_script", "");
		} else if ($discount_type == 5) {
			$r->change_property("items_ids",     SHOW, false);
			$r->change_property("free_postage",  SHOW, false);
			$r->change_property("tax_free",      SHOW, false);
			$r->change_property("minimum_amount",SHOW, false);
			$r->change_property("discount_type", SHOW, false);
			$r->change_property("is_exclusive",  SHOW, false);
			$r->change_property("quantity_limit",SHOW, false);
			$r->set_value("quantity_limit", 0);
			$r->change_property("discount_type", USE_IN_INSERT, false);
			$r->change_property("discount_type", USE_IN_UPDATE, false);
		} else  {
			$discount_types = array( array(3, "Percentage per product"), array(4, "Amount per product") );
			$r->change_property("discount_type", VALUES_LIST, $discount_types);
			$r->change_property("free_postage", SHOW, false);
			$r->change_property("tax_free", SHOW, false);
			$r->change_property("discount_type_text", SHOW, false);
			$r->change_property("discount_type_text", USE_IN_INSERT, false);
			$r->change_property("discount_type_text", USE_IN_UPDATE, false);
			$t->set_var("minimum_amount_title", "Minimum price of product");
			$t->parse("items_script", false);

			$items_ids = ",," . $r->get_value("items_ids") . ",,";
			$sql  = " SELECT i.item_id, i.item_name ";
			$sql .= " FROM " . $table_prefix . "items i ";
			$sql .= " ORDER BY i.item_name ";
			$db->query($sql);
			while($db->next_record())
			{
				$row_item_id = $db->f("item_id");
				$item_name = $db->f("item_name");
				$category_name = $db->f("category_name");
				$t->set_var("related_id", $row_item_id);
				$t->set_var("item_name", str_replace("\"", "&quot;", $item_name));
				if(strpos($items_ids, "," . $row_item_id . ",")) {
					$t->parse("selected_items", true);
				} else {
					$t->parse("available_items", true);
				}
			}
		}

	}


?>