<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_export.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	@set_time_limit (900);
	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/url.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("import_export");

	$eol = get_eol();
	$delimiters_symbols = array("comma" => ",", "tab" => "\t", "semicolon" => ";", "row" => "row", "space" => " ", "newline" => $eol);

	$delimiters = array(array("comma", "Comma"), array("tab", "Tab"), array("semicolon", "Semicolon"));
	$related_delimiters = array(array("row", "Rows"), array("comma", "Comma"), array("tab", "Tab"), array("space", "Space"), array("semicolon", "Semicolon"), array("newline", "Newline"));

	$errors = "";
	$sql_where = "";
	$rnd = get_param("rnd");
	$table = get_param("table");
	$csv_delimiter = get_param("csv_delimiter");
	$related_delimiter = get_param("related_delimiter");
	$delimiter_symbol = isset($delimiters_symbols[$csv_delimiter]) ? $delimiters_symbols[$csv_delimiter] : ",";
	$related_delimiter_symbol = isset($delimiters_symbols[$related_delimiter]) ? $delimiters_symbols[$related_delimiter] : "row";
	$operation = get_param("operation");
	$category_id = get_param("category_id");
	$session_rnd = get_session("session_rnd");
	$id = get_param("id");
	$ids = get_param("ids");
	$s_on = get_param("s_on");
	$s_ne = get_param("s_ne");
	$s_kw = get_param("s_kw");
	$s_sd = get_param("s_sd");
	$s_ed = get_param("s_ed");
	$s_os = get_param("s_os");
	$s_cc = get_param("s_cc");
	$s_sc = get_param("s_sc");
	$s_ex = get_param("s_ex");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_export.html");

	$t->set_var("admin_select_href",     "admin_select.php");
	$t->set_var("admin_export_href",     "admin_export.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$admin_export_custom_url = new VA_URL("admin_export_custom.php", true, array("table"));
	$admin_export_custom_url->add_parameter("table", CONSTANT, $table);
	$t->set_var("admin_export_custom_url", $admin_export_custom_url->get_url());

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	if ($table == "items") {
		include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");
		include("./admin_table_items.php");
	} else if ($table == "categories") {
		include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");
		include("./admin_table_categories.php");
	} else if ($table == "users") {
		include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("export_users");
		include("./admin_table_users.php");
		if (strlen($id)) {
			$sql_where = " WHERE user_id>" . $db->tosql($id, INTEGER);
		} else if (strlen($ids)) {
			$sql_where = " WHERE user_id IN (" . $db->tosql($ids, TEXT, false) . ")";
		}
	} else if ($table == "orders") {
		include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("sales_orders");
		include("./admin_table_orders.php");
		$sql_where .= " WHERE o.order_id=oi.order_id ";
		if (strlen($id)) {
			$sql_where .= " AND o.order_id>" . $db->tosql($id, INTEGER);
		} else if (strlen($ids)) {
			$sql_where .= " AND o.order_id IN (" . $db->tosql($ids, TEXT, false) . ")";
		} else {

			$sql  = " SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info' ";
			//$sql .= " AND setting_name LIKE '%country_code%'";
			$db->query($sql);
			while($db->next_record()) {
				$order_info[$db->f("setting_name")] = $db->f("setting_value");
			}

			if (preg_match("/^(\d+)(,\d+)*$/", $s_on))	{
				$sql_where .= " AND (o.order_id IN (" . $db->tosql($s_on, TEXT, false) . ") ";
				$sql_where .= " OR o.transaction_id=" . $db->tosql($s_on, TEXT) . ") ";
			} else if (strlen($s_on)) {
				$sql_where .= " AND o.transaction_id=" . $db->tosql($s_on, TEXT) . " ";
			}
	  
			if(strlen($s_ne)) {
				$s_ne_sql = $db->tosql($s_ne, TEXT, false);
				$sql_where .= " AND (o.email LIKE '%" . $s_ne_sql . "%'";
				$sql_where .= " OR o.name LIKE '%" . $s_ne_sql . "%'";
				$sql_where .= " OR o.first_name LIKE '%" . $s_ne_sql . "%'";
				$sql_where .= " OR o.last_name LIKE '%" . $s_ne_sql . "%')";
			}
	  
			if(strlen($s_kw)) {
				$sql_where .= " AND (oi.item_name LIKE '%" . $db->tosql($s_kw, TEXT, false) . "%'";
				$sql_where .= " OR oi.item_properties LIKE '%" . $db->tosql($s_kw, TEXT, false) . "%'";
				$sql_where .= " OR o.shipping_type_desc LIKE '%" . $db->tosql($s_kw, TEXT, false) . "%')";
			}
	  
			if(strlen($s_sd)) {
				$s_sd_value = parse_date($s_sd, $date_edit_format, $date_errors);
				$sql_where .= " AND o.order_placed_date>=" . $db->tosql($s_sd_value, DATE);
			}
	  
			if(strlen($s_ed)) {
				$end_date = parse_date($s_ed, $date_edit_format, $date_errors);
				$day_after_end = mktime (0, 0, 0, $end_date[MONTH], $end_date[DAY] + 1, $end_date[YEAR]);
				$sql_where .= " AND o.order_placed_date<" . $db->tosql($day_after_end, DATE);
			}
	  
			if(strlen($s_os)) {
				$sql_where .= " AND o.order_status=" . $db->tosql($s_os, INTEGER);
			}
	  
			if(strlen($s_cc)) {
				if ($order_info["show_delivery_country_code"] == 1) {
					$sql_where .= " AND o.delivery_country_code=" . $db->tosql($s_cc, TEXT);
				} else if ($order_info["show_country_code"] == 1) {
					$sql_where .= " AND o.country_code=" . $db->tosql($s_cc, TEXT);
				} 
			}

			if(strlen($s_sc)) {
				if ($order_info["show_delivery_state_code"] == 1) {
					$sql_where .= " AND o.delivery_state_code=" . $db->tosql($s_sc, TEXT);
				} else if ($order_info["show_state_code"] == 1) {
					$sql_where .= " AND o.state_code=" . $db->tosql($s_sc, TEXT);
				} 
			}

			if (strlen($s_ex)) {
				$sql_where .= ($s_ex == 1) ? " AND o.is_exported=1 " : " AND (o.is_exported<>1 OR o.is_exported IS NULL) ";
			}


		}
	} else {
		$table_name = "";
		$table_title = "";
		$errors = "Can't find table to import.";
	}

	if (strlen(!$errors)) {
		$admin_export_custom_url->add_parameter("table", CONSTANT, $table);

		$sql  = " SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings ";
		$sql .= " WHERE setting_type=" . $db->tosql($table, TEXT);
		$db->query($sql);
		while ($db->next_record()) {
			$custom_field = $db->f("setting_name");
			$custom_value = $db->f("setting_value");
			$admin_export_custom_url->add_parameter("field", CONSTANT, $custom_field);

			$edit_link = " &nbsp; <a href=\"" . $admin_export_custom_url->get_url() . "\"><font color=blue size=1>Edit</font></a>";
			$db_columns[$custom_field]  = array($custom_field, TEXT, CUSTOM_FIELD, false, $custom_value, $edit_link);
		}
		if(isset($related_columns)) {
			$admin_export_custom_url->add_parameter("table", CONSTANT, $related_table);

			$sql  = " SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= " WHERE setting_type=" . $db->tosql($related_table, TEXT);
			$db->query($sql);
			while ($db->next_record()) {
				$custom_field = $db->f("setting_name");
				$custom_value = $db->f("setting_value");
				$admin_export_custom_url->add_parameter("field", CONSTANT, $custom_field);
				$edit_link = " &nbsp; <a href=\"" . $admin_export_custom_url->get_url() . "\"><font color=blue size=1>Edit</font></a>";
				$related_columns[$custom_field]  = array($custom_field, TEXT, CUSTOM_FIELD, false, $custom_value, $edit_link);
			}
		}
	}

	$t->set_var("table", $table);
	$t->set_var("table_title", $table_title);

	if($operation == "export")
	{


		if(!strlen($errors)) {

			// prepare categories for items table
			$categories = array();
			if ($table == "items") {
				$sql = "SELECT category_id,category_name FROM " . $table_prefix . "categories ";
				$db->query($sql);
				while ($db->next_record()) {
					$category_id = $db->f("category_id");
					$category_name = $db->f("category_name");
					$categories[$category_id] = get_translation($category_name);
				}
			}

			// connection for additional operations 
			$dbh = new VA_SQL();
		  $dbh->DBType       = $db->DBType;
			$dbh->DBDatabase   = $db->DBDatabase;
			$dbh->DBUser       = $db->DBUser;
			$dbh->DBPassword   = $db->DBPassword;
			$dbh->DBHost       = $db->DBHost;
  		$dbh->DBPort       = $db->DBPort;
		  $dbh->DBPersistent = $db->DBPersistent;

			$columns = array();
			$total_columns = get_param("total_columns");
			$columns_selected = 0;
			$db_column        = 0;
			$columns_list     = "";
			$csv_columns_list = "";
			$exported_fields  = "";

			// generate db columns list
			foreach ($db_columns as $column_name => $column_info) {
				if($column_info[2] != RELATED_DB_FIELD && $column_info[2] != CUSTOM_FIELD) {
					if (!preg_match("/^order_property_/", $column_name) && !preg_match("/^item_property_/", $column_name)) {
						$db_column++;
						if($db_column > 1) {
							$columns_list .= ", ";
						}
						$columns_list .= $table_alias . "." . $column_name;
					}
				}
			}

			// generate selected columns
			for($col = 1; $col <= $total_columns; $col++) {
				$column_name = get_param("db_column_" . $col);
				$column_title = get_param("column_title_" . $col);
				if($column_name) {
					$columns_selected++;
					if($columns_selected > 1) {
						//$columns_list .= ",";
						$exported_fields .= ",";
						$csv_columns_list .= $delimiter_symbol;
					}
					//$columns_list .= $table_alias . "." . $column_name;
					$exported_fields .= $table_alias . "." . $column_name;
					$csv_columns_list .= $column_title;

					$columns[] = $column_name;
				}
			}

			//CUSTOM_FIELD

			if (isset($related_columns)) {
				// generate db columns list
				foreach ($related_columns as $column_name => $column_info) {
					if($column_info[2] != RELATED_DB_FIELD && $column_info[2] != CUSTOM_FIELD) {
						$column_alias = $related_table_alias."_".$column_name; 
						if (!preg_match("/^order_item_property_/", $column_name)) {
							$columns_list .= ",";
							$columns_list .= $related_table_alias.".".$column_name . " AS " . $column_alias;
						}
					}
				}
			}

			//$exported_fields = $columns_list;
			$total_related = get_param("total_related");
			$related_selected = 0;
			for($col = 1; $col <= $total_related; $col++) {
				$column_name = get_param("related_column_" . $col);
				if ($column_name) {
					$related_selected++;
					$columns_selected++;
					if ($related_columns[$column_name][2] == CUSTOM_FIELD) {
						$column_alias = $column_name; 
					} else {
						$column_alias = $related_table_alias."_".$column_name; 
					}
					if (preg_match("/^order_item_property_/", $column_name)) {
						if ($columns_selected > 1) {
							$csv_columns_list .= $delimiter_symbol;
							$exported_fields .= ",";
						}
					} else {
						if ($columns_selected > 1) {
							//$columns_list .= ",";
							$csv_columns_list .= $delimiter_symbol;
							$exported_fields .= ",";
						}
						//$columns_list .= $related_table_alias.".".$column_name . " AS " . $column_alias;
					}
					$csv_columns_list .= $related_columns[$column_name][0];
					$exported_fields .= $column_alias;
					$columns[] = $column_alias;
					$selected_related_columns[$column_alias] = 1;
				}
			}

			$exported_fields .= ",csv_delimiter" . $csv_delimiter. "csv_delimiter";
			$exported_fields .= ",related_delimiter" . $related_delimiter . "related_delimiter";
			// update default columns list
			if ($table == "users") {
				$sql  = " UPDATE " . $table_prefix . "admins SET exported_user_fields=" . $db->tosql($exported_fields, TEXT);
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$db->query($sql);
			} else if ($table == "orders") {
				$sql = " UPDATE " . $table_prefix . "admins SET exported_order_fields=" . $db->tosql($exported_fields, TEXT);
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$db->query($sql);
			} else if ($table == "items") {
				$sql = " UPDATE " . $table_prefix . "admins SET exported_item_fields=" . $db->tosql($exported_fields, TEXT);
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$db->query($sql);
			} 

			$csv_filename = $table_name . ".csv";
			header("Pragma: private");
			header("Expires: 0");
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			header("Cache-Control: private", false);
			header("Content-Type: application/octet-stream"); 
			header("Content-Disposition: attachment; filename=" . $csv_filename); 
			header("Content-Transfer-Encoding: binary"); 

			echo $csv_columns_list . $eol;

			$exported_user_id = 0; $exported_order_id = 0;
			if ($table == "users") {
				$sql  = " SELECT exported_user_id FROM " . $table_prefix . "admins ";
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$exported_user_id = get_db_value($sql);
			} else if ($table == "orders") {
				$sql  = " SELECT exported_order_id FROM " . $table_prefix . "admins ";
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$exported_order_id = get_db_value($sql);
			} 
			$max_id = 0;
			$sql = "SELECT " . $columns_list . " FROM " . $table_name . " " . $table_alias;
			if ($table == "orders") {
				$sql  = " SELECT " . $columns_list . " FROM " . $table_name . " " . $table_alias;
				$sql .= " , " . $related_table_name . " " . $related_table_alias;
			}
			$db->query($sql . $sql_where);
			if ($db->next_record()) {
				$row_data = array();
				$record_number = 0; $related_number = 0;
				$prev_id = $db->f($table_pk);
				do {
					$record_number++;
					$row_id = $db->f($table_pk);
					if ($row_id > $max_id) { $max_id = $row_id; }
					if ($prev_id != $row_id || ($record_number > 1 && $related_delimiter == "row" && $related_selected > 0)) {
						// output csv
						$csv_row = "";
						for($i = 0; $i < $columns_selected; $i++) {
							$column_name = $columns[$i];
							$field_value = $row_data[$column_name];
							if ($column_name == "oi_item_properties") {
								$field_value = preg_replace("/^\<br\>/", "", $field_value);
								$field_value = preg_replace("/\<br\>/", "; ", $field_value);
							} 
							if (preg_match("/[,;\"\n\r\t\s]/", $field_value)) {
								$field_value = "\"" . str_replace("\"", "\"\"", $field_value) . "\"";
							}
							if($i > 0) {
								$csv_row .= $delimiter_symbol;
							}
							$csv_row .= $field_value;
						}
						echo $csv_row . $eol;
						// end output
						$related_number = 0;

						// update exported status
						if ($table_name == $table_prefix . "orders") {
							$dbh->query("UPDATE " . $table_prefix . "orders SET is_exported=1 WHERE order_id=" . $prev_id);
						}
					} 
					$related_number++;

					// collect data for next step
					for($i = 0; $i < $columns_selected; $i++) {
						$column_name = $columns[$i];
						$field_value = "";
						if ($column_name == "item_category") {
							$item_id = $db->f("item_id");
							$sql  = " SELECT ic.category_id, c.category_path FROM " . $table_prefix . "items_categories ic ";
							$sql .= " LEFT JOIN " . $table_prefix . "categories c ON ic.category_id=c.category_id ";
							$sql .= " WHERE  ic.item_id=" . $db->tosql($item_id, INTEGER);
							$dbh->query($sql);
							while ($dbh->next_record()) {
								$category = "";
								$category_path = $dbh->f("category_path") . $dbh->f("category_id");
								// build full category path if available
								$categories_ids = explode(",", $category_path);
								for ($ci = 0; $ci < sizeof($categories_ids); $ci++) {
									$category_id = $categories_ids[$ci];
									if ($category_id > 0) {
										if (strlen($category)) { $category .= " > "; }
										$category .= $categories[$category_id];
									}
								}
								if (strlen($field_value)) { $field_value .= ";"; }
								// for top category use zero number
								if (!strlen($category)) { $category = 0; } 
								$field_value .= $category;
							}

						} else if (preg_match("/^item_property_/", $column_name)) {
							$property_name = substr($column_name, 14);
							$item_id = $db->f("item_id");
							$sql  = " SELECT property_id, control_type,property_description FROM " . $table_prefix . "items_properties ";
							$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
							$sql .= " AND property_name=" . $db->tosql($property_name, TEXT);
							$dbh->query($sql);
							if ($dbh->next_record()) {
								$property_id = $dbh->f("property_id");
								$control_type = $dbh->f("control_type");
								if ($control_type == "LABEL" || $control_type == "TEXTBOX" || $control_type == "TEXTAREA") {
									$field_value = get_translation($dbh->f("property_description"));
								} else {
									$sql  = " SELECT property_value,additional_price FROM " . $table_prefix . "items_properties_values ";
									$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
									$dbh->query($sql);
									while($dbh->next_record()) {
										$option_value = $dbh->f("property_value");
										$additional_price = $dbh->f("additional_price");
										if (strlen($field_value)) { $field_value .= ";"; }
										$field_value .= $option_value;
										if (strlen($additional_price)) {
											$field_value .= "=".$additional_price;
										}
									}

								}
							} 
						} else if (preg_match("/^order_property_/", $column_name)) {
							$property_name = substr($column_name, 15);
							$order_id = $db->f("order_id");
							$sql  = " SELECT property_value FROM " . $table_prefix . "orders_properties ";
							$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
							$sql .= " AND property_name=" . $db->tosql($property_name, TEXT);
							$dbh->query($sql);
							if ($dbh->next_record()) {
								$field_value = get_translation($dbh->f("property_value"));
							}
						} else if (preg_match("/^oi_order_item_property_/", $column_name)) {
							$property_name = substr($column_name, 23);
							$order_item_id = $db->f("oi_order_item_id");
							$sql  = " SELECT property_value FROM " . $table_prefix . "orders_items_properties ";
							$sql .= " WHERE order_item_id=" . $order_item_id;
							$sql .= " AND property_name=" . $db->tosql($property_name, TEXT);
							$dbh->query($sql);
							if ($dbh->next_record()) {
								$field_value = get_translation($dbh->f("property_value"));
							}
						} else if ($column_name == "manufacturer_name") {
							$manufacturer_id = $db->f("manufacturer_id");
							if (strlen($manufacturer_id)) {
								$sql  = " SELECT manufacturer_name FROM " . $table_prefix . "manufacturers ";
								$sql .= " WHERE manufacturer_id=" . $db->tosql($manufacturer_id, INTEGER);
								$dbh->query($sql);
								if ($dbh->next_record()) {
									$field_value = get_translation($dbh->f("manufacturer_name"));
								}
							}
						} else {
							if ((isset($db_columns[$column_name]) && $db_columns[$column_name][2] == CUSTOM_FIELD)) {
								$field_source = $db_columns[$column_name][4];
								$field_value  = get_field_value($field_source);
							} else if ((isset($related_columns) && isset($related_columns[$column_name]) && $related_columns[$column_name][2] == CUSTOM_FIELD)) {
								$field_source = $related_columns[$column_name][4];
								$field_value  = get_field_value($field_source);
							} else {
								$field_value = get_translation($db->f($column_name));
							}
						}
						if (isset($selected_related_columns[$column_name]) && $related_number > 1) {
							$row_data[$column_name] .= $related_delimiter_symbol . $field_value;
						} else {
							$row_data[$column_name] = $field_value;
						}
					}
					$prev_id = $row_id;

				} while ($db->next_record());

				// last row output csv
				$csv_row = "";
				for($i = 0; $i < $columns_selected; $i++) {
					$column_name = $columns[$i];
					$field_value = $row_data[$column_name];
					if ($column_name == "oi_item_properties") {
						$field_value = preg_replace("/^\<br\>/", "", $field_value);
						$field_value = preg_replace("/\<br\>/", "; ", $field_value);
					}
					if(preg_match("/[,;\"\n\r\t\s]/", $field_value)) {
						$field_value = "\"" . str_replace("\"", "\"\"", $field_value) . "\"";
					}
					if($i > 0) {
						$csv_row .= $delimiter_symbol;
					}
					$csv_row .= $field_value;
				}
				echo $csv_row . $eol;
				// end output

				// update exported status
				if ($table_name == $table_prefix . "orders") {
					$dbh->query("UPDATE " . $table_prefix . "orders SET is_exported=1 WHERE order_id=" . $prev_id);
				}
			}

			if ($table == "users") {
				if ($max_id > $exported_user_id) {
					$sql  = " UPDATE " . $table_prefix . "admins SET exported_user_id=" . $db->tosql($max_id, INTEGER);
					$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
					$db->query($sql);
				}
			} else if ($table == "orders") {
				if ($max_id > $exported_order_id) {
					$sql = " UPDATE " . $table_prefix . "admins SET exported_order_id=" . $db->tosql($max_id, INTEGER);
					$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
					$db->query($sql);
				}
			} 

			exit;
		}
	}


	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("category_id", htmlspecialchars($category_id));
	$t->set_var("id", htmlspecialchars($id));
	$t->set_var("ids", htmlspecialchars($ids));
	$t->set_var("s_on", htmlspecialchars($s_on));
	$t->set_var("s_ne", htmlspecialchars($s_ne));
	$t->set_var("s_kw", htmlspecialchars($s_kw));
	$t->set_var("s_sd", htmlspecialchars($s_sd));
	$t->set_var("s_ed", htmlspecialchars($s_ed));
	$t->set_var("s_os", htmlspecialchars($s_os));
	$t->set_var("s_cc", htmlspecialchars($s_cc));
	$t->set_var("s_sc", htmlspecialchars($s_sc));
	$t->set_var("s_ex", htmlspecialchars($s_ex));

	$t->set_var("rnd", va_timestamp());

	if ($table_name == ($table_prefix . "items") || $table_name == ($table_prefix . "categories")) {
		$t->parse("products_path", false);
	} else if ($table == "orders") {
		$admin_orders_url = new VA_URL("admin_orders.php", false);
		$admin_orders_url->add_parameter("ids", REQUEST, "ids");
		$admin_orders_url->add_parameter("page", REQUEST, "page");
		$admin_orders_url->add_parameter("s_on", REQUEST, "s_on");
		$admin_orders_url->add_parameter("s_ne", REQUEST, "s_ne");
		$admin_orders_url->add_parameter("s_kw", REQUEST, "s_kw");
		$admin_orders_url->add_parameter("s_sd", REQUEST, "s_sd");
		$admin_orders_url->add_parameter("s_ed", REQUEST, "s_ed");
		$admin_orders_url->add_parameter("s_os", REQUEST, "s_os");
		$admin_orders_url->add_parameter("s_cc", REQUEST, "s_cc");
		$admin_orders_url->add_parameter("s_sc", REQUEST, "s_sc");
		$admin_orders_url->add_parameter("s_ex", REQUEST, "s_ex");
		$admin_orders_url->add_parameter("sort_ord", REQUEST, "sort_ord");
		$admin_orders_url->add_parameter("sort_dir", REQUEST, "sort_dir");

		$t->set_var("admin_orders_url", $admin_orders_url->get_url());

		$t->parse("orders_path", false);
	}

	$default_columns = "";
	if ($table == "users") {
		$sql  = " SELECT exported_user_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		$default_columns = get_db_value($sql);
	} else if ($table == "orders") {
		$sql  = " SELECT exported_order_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		$default_columns = get_db_value($sql);
	} else if ($table == "items") {
		$sql  = " SELECT exported_item_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		$default_columns = get_db_value($sql);
	} 
	$checked_columns = explode(",", $default_columns);

	// get default delimiters
	if(strpos($default_columns, "csv_delimiter")) {
		$start_delimiter = strpos($default_columns, "csv_delimiter");
		$end_delimiter = strpos($default_columns, "csv_delimiter", $start_delimiter + 13);
		$csv_delimiter = substr($default_columns, $start_delimiter + 13, $end_delimiter - $start_delimiter - 13);
	}
	if(strpos($default_columns, "related_delimiter")) {
		$start_delimiter = strpos($default_columns, "related_delimiter");
		$end_delimiter = strpos($default_columns, "related_delimiter", $start_delimiter + 17);
		$related_delimiter = substr($default_columns, $start_delimiter + 17, $end_delimiter - $start_delimiter - 17);
	}
	
	set_options($delimiters, $csv_delimiter, "delimiter");
	set_options($delimiters, $csv_delimiter, "delimiter_bottom");
	set_options($related_delimiters, $related_delimiter, "related_delimiter");
	set_options($related_delimiters, $related_delimiter, "related_delimiter_bottom");


	$total_columns = 0;
	$t->set_var("table_name", $table_name);

	foreach($db_columns as $column_name => $column_info) {
		if ($column_info[2] == RELATED_DB_FIELD) {
			if ($table == "items" && $column_name == "property_name") {
				$sql = " SELECT property_name FROM " . $table_prefix . "items_properties GROUP BY property_name ";
				$db->query($sql);
				while ($db->next_record()) {
					$property_name = $db->f("property_name");
					$column_name   = "item_property_" . $property_name;
					$column_title  = get_translation($property_name);
					set_db_column($column_name, $column_title);
				}
			} else if ($table == "items" && $column_name == "category_name") {
				$column_title  = $db_columns[$column_name][0];
				set_db_column("item_category", $column_title);
			} else if ($table == "items" && $column_name == "manufacturer_name") {
				$column_title  = $db_columns[$column_name][0];
				set_db_column("manufacturer_name", $column_title);
			}

		} else if ($column_info[2] != HIDE_DB_FIELD) {
			$column_title = $column_info[0];
			$column_link = ($column_info[2] == CUSTOM_FIELD) ? $column_info[5] : "";
			set_db_column($column_name, $column_title, $column_link);
		}
	}
	if($total_columns % 2 != 0) {
		$t->parse("columns", true);
	}
	$t->set_var("total_columns", $total_columns);

	// if available some related data
	$total_related = 0;
	if(isset($related_columns)) {
		$admin_export_custom_url->remove_parameter("field");
		$admin_export_custom_url->add_parameter("table", CONSTANT, $related_table);
		$t->set_var("admin_export_custom_related_url", $admin_export_custom_url->get_url());
		$t->set_var("related_table", $related_table);

		foreach ($related_columns as $column_name => $column_info) {
			if($column_info[2] != HIDE_DB_FIELD && $column_info[2] != RELATED_DB_FIELD) {
				if ($column_info[2] == CUSTOM_FIELD) {
					$column_title = $column_info[0] . " " . $column_info[5];
					$column_checked = in_array($column_name, $checked_columns) ? " checked " : "";
				} else {
					$column_title = $column_info[0];
					$column_checked = in_array($related_table_alias."_".$column_name, $checked_columns) ? " checked " : "";
				}
				$total_related++;
				$t->set_var("col", $total_related);
				$t->set_var("column_name", htmlspecialchars($column_name));
				$t->set_var("column_checked", $column_checked);
				$t->set_var("column_title", $column_title);
				$t->parse("related_columns", true);
			}
		}
	}
	$t->set_var("total_related", $total_related);
	if($total_related > 0) {
		$t->parse("related_data", false);
	} else {
		$t->set_var("related_data", "");
	}


	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

	function get_field_value($field_source) 
	{
		global $db, $db_columns, $related_columns;
		if (preg_match_all("/\{(\w+)\}/i", $field_source, $matches)) {
			$field_value = $field_source;
			for($p = 0; $p < sizeof($matches[1]); $p++) {
				$f_source = strtolower($matches[1][$p]);
				$field_value = str_replace("{".$f_source."}", get_translation($db->f($f_source)), $field_value);
			}
		} else {
			$field_value = $field_source;
		}

		return $field_value;
	}

	function set_db_column($column_name, $column_title, $column_link = "") 
	{
		global $t, $db, $total_columns, $table_alias, $checked_columns;

		$total_columns++;
		$column_checked = in_array($table_alias.".".$column_name, $checked_columns) ? " checked " : "";
		$t->set_var("col", $total_columns);
		$t->set_var("column_name", htmlspecialchars($column_name));
		$t->set_var("column_link", $column_link);
		$t->set_var("column_checked", $column_checked);
		$t->set_var("column_title", htmlspecialchars($column_title));
		$t->parse("rows", true);
		if($total_columns % 2 == 0) {
			$t->parse("columns", true);
			$t->set_var("rows", "");
		}

	}

?>