<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_forum_thread.php                                   ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/record.php");

	include_once($root_folder_path."messages/".$language_code."/forum_messages.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("forum");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_forum_thread.html");

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_forum_href", "admin_forum.php");
	$t->set_var("admin_forum_thread_href", "admin_forum_thread.php");
	$t->set_var("admin_forum_message_href", "admin_forum_message.php");
	$t->set_var("admin_forum_topic_href", "admin_forum_topic.php");

	$t->set_var("rnd", va_timestamp());

	$thread_id = get_param("thread_id");
	$operation = get_param("operation");
	$forum_id = "";
	$rnd = get_param("rnd");
	$message_id = get_param("message_id");
	$errors = "";

	$t->set_var("thread_id", htmlspecialchars($thread_id));

	$return_page = "admin_forum_thread.php?thread_id=" . $thread_id;

	$sql  = " SELECT f.user_name, f.user_email, f.remote_address, f.topic, f.description, f.email_notification, ";
	$sql .= " f.date_added, f.date_modified, f.thread_updated, ";
	$sql .= " f.views, f.replies, f.forum_id, fl.forum_name, fl.category_id, fc.category_name ";
	$sql .= " FROM " . $table_prefix . "forum f, " . $table_prefix . "forum_list fl, " . $table_prefix . "forum_categories fc ";
	$sql .= " WHERE thread_id = " . $db->tosql($thread_id, INTEGER);
	$sql .= " AND f.forum_id = fl.forum_id AND fl.category_id = fc.category_id ";
	$db->query($sql);
	if($db->next_record() && !strlen($errors)) {

		$topic = $db->f("topic");
		$description = $db->f("description");
		$topic_user_name = $db->f("user_name");
		$topic_user_email = $db->f("user_email");
		$t->set_var("topic_user_name", htmlspecialchars($topic_user_name));
		$t->set_var("topic_user_email", htmlspecialchars($topic_user_email));
		$t->set_var("topic_user_ip", $db->f("remote_address"));

		$date_added = va_date($datetime_show_format, $db->f("date_added", DATETIME));
		$t->set_var("topic_added", $date_added);

		$date_modified = va_date($datetime_show_format, $db->f("date_modified", DATETIME));
		$t->set_var("topic_modified", $date_modified);

		$thread_updated = va_date($datetime_show_format, $db->f("thread_updated", DATETIME));
		$t->set_var("thread_updated", $thread_updated);

		$t->set_var("topic", htmlspecialchars($db->f("topic")));
		$t->set_var("topic_description", nl2br(htmlspecialchars($description)));
		$t->set_var("views", $db->f("views"));
		$t->set_var("replies", $db->f("replies"));

		$email_notification = $db->f("email_notification");
		$last_message = $description;

		$forum_id = $db->f("forum_id");
		$t->set_var("forum_id", $forum_id);
		$t->set_var("current_forum", $db->f("forum_name"));
		$t->set_var("category_id", $db->f("category_id"));
		$t->set_var("current_category", $db->f("category_name"));

		$t->parse("topic_info", false);
	}	else {
		$t->set_var("errors_list", "No thread found.");
		$t->parse("global_errors", false);
		$t->set_var("topic_info", "");
		$t->set_var("topic_messages", "");
		$t->pparse("main", false);
		exit;
	}

	$r = new VA_Record($table_prefix . "forum_messages");

	$r->add_textbox("thread_id", INTEGER);
	$r->add_textbox("admin_id", INTEGER);
	$r->add_textbox("user_name", TEXT, "Nickname");
	$r->change_property("user_name", REQUIRED, true);
	$r->add_textbox("user_email", TEXT, "Email");
	$r->change_property("user_email", REQUIRED, true);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("message_text", TEXT, "Message");
	$r->change_property("message_text", REQUIRED, true);
	$r->add_textbox("date_added", DATETIME);

	$r->get_form_values();

	$session_rnd = get_session("session_rnd");
	$operation = get_param("operation");
	$rnd = get_param("rnd");

	if($operation && $rnd != $session_rnd) {
		$sql  = " SELECT admin_name, email FROM " . $table_prefix . "admins ";
		$sql .= " WHERE admin_id = " . $db->tosql(get_session("session_admin_id"), INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$r->set_value("user_name", $db->f("admin_name"));
			$r->set_value("user_email", $db->f("email"));
		}

		$is_valid = $r->validate();
		if($is_valid) {
			$date_updated = va_time();
			$remote_address = get_ip();
			$r->set_value("date_added", $date_updated);
			$r->set_value("remote_address", $remote_address);
			$r->set_value("admin_id", get_session("session_admin_id"));

			if($r->insert_record()) { 
				setcookie("cookie_forum_nick", $r->get_value("user_name"), va_timestamp() + 3600 * 24 * 366);  
				setcookie("cookie_forum_email", $r->get_value("user_email"), va_timestamp() + 3600 * 24 * 366);  

				$sql = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type = 'forum'";
				$db->query($sql);
				while($db->next_record()) {
					$forum_settings[$db->f("setting_name")] = $db->f("setting_value");
				}

				if($email_notification || (isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"])) {
					// Prepare variables
					$date_updated_string = va_date($datetime_show_format, $date_updated);
					$message_text = $r->get_value("message_text");
			  
					// Set variables for email
					$r->set_parameters();
					$t->set_var("date_added", $date_updated_string);
					$t->set_var("topic_modified", $date_modified);
					$t->set_var("thread_updated", $date_updated_string);

					$t->set_var("message_user_name", $r->get_value("user_name"));
					$t->set_var("message_user_email", $r->get_value("user_email"));
					$t->set_var("message_user_ip", $r->get_value("remote_address"));
					$t->set_var("message", $message_text);
					$t->set_var("topic_description", nl2br(htmlspecialchars($description)));

					// Send notification to site administrator
					if(isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"]) {			  
						$t->set_block("admin_subject", $forum_settings["admin_subject"]);
						$t->set_block("admin_message", $forum_settings["admin_message"]);

						$t->set_var("thread_user_name", $topic_user_name);
						$t->set_var("thread_user_email", $topic_user_email);
						$t->set_var("topic", $topic);
						$t->set_var("description", $description);
						$t->set_var("topic_description", $description);
						$t->set_var("message", $message_text);
						$t->parse("admin_subject", false);
						if ($mail_type) {
							$t->set_var("topic_user_name", htmlspecialchars($topic_user_name));
							$t->set_var("topic_user_email", htmlspecialchars($topic_user_email));
							$t->set_var("topic", htmlspecialchars($topic));
							$t->set_var("description", nl2br(htmlspecialchars($description)));
							$t->set_var("topic_description", nl2br(htmlspecialchars($description)));
							$t->set_var("message", nl2br(htmlspecialchars($message_text)));
						}
						$t->parse("admin_message", false);

						$mail_to = get_setting_value($forum_settings, "admin_email", $settings["admin_email"]);
						$mail_to = str_replace(";", ",", $mail_to);
						$mail_from = get_setting_value($forum_settings, "admin_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($forum_settings, "cc_emails");
						$mail_bcc = get_setting_value($forum_settings, "admin_mail_bcc");
						$mail_reply_to = get_setting_value($forum_settings, "admin_mail_reply_to");
						$mail_return_path = get_setting_value($forum_settings, "admin_mail_return_path");
						$mail_type = get_setting_value($forum_settings, "admin_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
						@mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}
					// Send notification to topic owner
					if($email_notification) {			  
						$t->set_block("user_subject", $forum_settings["user_subject"]);
						$t->set_block("user_message", $forum_settings["user_message"]);

						$t->set_var("thread_user_name", $topic_user_name);
						$t->set_var("thread_user_email", $topic_user_email);
						$t->set_var("topic", $topic);
						$t->set_var("description", $description);
						$t->set_var("topic_description", $description);
						$t->set_var("message", $message_text);
						$t->parse("user_subject", false);
						if ($mail_type) {
							$t->set_var("topic_user_name", htmlspecialchars($topic_user_name));
							$t->set_var("topic_user_email", htmlspecialchars($topic_user_email));
							$t->set_var("topic", htmlspecialchars($topic));
							$t->set_var("description", nl2br(htmlspecialchars($description)));
							$t->set_var("topic_description", nl2br(htmlspecialchars($description)));
							$t->set_var("message", nl2br(htmlspecialchars($message_text)));
						}
						$t->parse("user_message", false);

						$mail_from = get_setting_value($forum_settings, "user_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($forum_settings, "user_mail_cc");
						$mail_bcc = get_setting_value($forum_settings, "user_mail_bcc");
						$mail_reply_to = get_setting_value($forum_settings, "user_mail_reply_to");
						$mail_return_path = get_setting_value($forum_settings, "user_mail_return_path");
						$mail_type = get_setting_value($forum_settings, "user_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						$user_message = str_replace("\r", "", $t->get_var("user_message"));
						@mail($topic_user_email, $t->get_var("user_subject"), $user_message, $email_headers);
					}

				}

		        // update forum topic info
				$sql  = " UPDATE " . $table_prefix . "forum SET replies = replies + 1, ";
				$sql .= " thread_updated= " . $db->tosql($date_updated, DATETIME);
				$sql .= " WHERE thread_id = " . $db->tosql($thread_id, INTEGER);
				$db->query($sql);
		        // update forum info
				$sql  = " UPDATE " . $table_prefix . "forum_list SET messages_number = messages_number + 1, ";
				$sql .= " last_post_added = " . $db->tosql($date_updated, DATETIME);
				$sql .= " , last_post_thread_id = " . $db->tosql($thread_id, INTEGER);
				$sql .= " WHERE forum_id = " . $db->tosql($forum_id, INTEGER);
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
		else {
			set_session("session_rnd", "");
		}
	}
	// new (set default values)
	else {
		$r->set_value("user_name", get_cookie("cookie_forum_nick"));
		$r->set_value("user_email", get_cookie("cookie_forum_email"));
	}

	$t->set_var("thread_user_name", htmlspecialchars($topic_user_name));
	$t->set_var("thread_user_email", htmlspecialchars($topic_user_email));
	$t->set_var("topic", htmlspecialchars($topic));
	$t->set_var("description", nl2br(htmlspecialchars($description)));
	$t->set_var("topic_description", nl2br(htmlspecialchars($description)));

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_forum_thread.php");

	// Set variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "forum WHERE thread_id = " . $db->tosql($thread_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = get_param("q") > 0 ? get_param("q") : 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;

	$sql  = " SELECT message_id, admin_id, user_name, user_email, remote_address, message_text, date_added ";
	$sql .= " FROM " . $table_prefix . "forum_messages  ";
	$sql .= " WHERE thread_id = " . $db->tosql($thread_id, INTEGER);
	$sql .= " ORDER BY date_added DESC ";
	$db->query($sql);
	if($db->next_record()) {
		$last_message = $db->f("message_text");
		do {
			$t->set_var("message_user_name", htmlspecialchars($db->f("user_name")));
			$t->set_var("message_user_email", htmlspecialchars($db->f("user_email")));
			$t->set_var("message_user_ip", $db->f("remote_address"));
			$t->set_var("message_id", $db->f("message_id"));

			if(strlen($db->f("admin_id"))) {
				$t->parse("admin_block", false);
				$t->set_var("user_block", "");
			}
			else {
				$t->parse("user_block", false);
				$t->set_var("admin_block", "");
			}

			$t->set_var("date_added", va_date($datetime_show_format, $db->f("date_added", DATETIME)));
			$t->set_var("message_text", process_message($db->f("message_text")));

			$t->parse("records", true);
		} while($db->next_record());
	}
	else {
		$t->set_var("records", "");
	}

	// Set default message text for reply
	if(!strlen($operation)) {
		$last_message = ">" . str_replace("\n", "\n>", $last_message);
		$r->set_value("message_text", $last_message);
	}

	$r->set_parameters();
	$t->set_var("page", $page_number);
	$t->set_var("rp", urlencode($return_page));

	$t->parse("topic_messages", false);
	$t->pparse("main");

?>