<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_forum_topic.php                                    ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");
	include_once ("../messages/".$language_code."/forum_messages.php");
	include_once ($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("forum");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_forum_topic.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_forum_thread_href", "admin_forum_thread.php");
	$t->set_var("admin_forum_topic_href", "admin_forum_topic.php");
	$t->set_var("TOPIC_NOTIFY_FIELD",  TOPIC_NOTIFY_FIELD);

	$forums = array(array("", ""));
	$sql  = " SELECT fc.category_name, fl.forum_name, fl.forum_id ";
	$sql .= " FROM " . $table_prefix . "forum_list fl, " . $table_prefix . "forum_categories fc ";
	$sql .= " WHERE fl.category_id = fc.category_id ";
	$sql .= " ORDER BY fc.category_order, fl.forum_order ";
	$db->query($sql);
	while ($db->next_record()) {
		$option_id = $db->f("forum_id");
		$option_name = $db->f("category_name") . " > " . $db->f("forum_name");
		$forums[] = array($option_id, $option_name);
	}

	$r = new VA_Record($table_prefix . "forum");

	$r->add_where("thread_id", INTEGER);

	$r->add_select("forum_id", INTEGER, $forums, "Forum");
	$r->add_textbox("user_id", INTEGER, "User ID");
	$r->change_property("user_id", USE_SQL_NULL, false);
	$r->add_textbox("views", INTEGER);
	$r->change_property("views", USE_IN_INSERT, false);
	$r->change_property("views", USE_IN_UPDATE, false);
	$r->add_textbox("replies", INTEGER);
	$r->change_property("replies", USE_IN_UPDATE, false);
	$r->add_textbox("user_name", TEXT, "Nickname");
	$r->change_property("user_name", REQUIRED, true);
	$r->add_textbox("user_email", TEXT, "Email");
	$r->change_property("user_email", REQUIRED, true);
	$r->change_property("user_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("topic", TEXT, "Topic");
	$r->change_property("topic", REQUIRED, true);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("description", TEXT, "Description");
	$r->change_property("description", REQUIRED, true);
	$r->add_checkbox("email_notification", INTEGER);

	// editing information
	$r->add_textbox("admin_id_added_by", INTEGER);
	$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
	$r->add_textbox("admin_id_modified_by", INTEGER);
	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("date_modified", DATETIME);
	$r->change_property("date_modified", USE_IN_INSERT, false);
	$r->add_textbox("thread_updated", DATETIME);
	$r->change_property("thread_updated", USE_IN_UPDATE, false);

	$r->get_form_values();

	$operation = get_param("operation");
	$thread_id = get_param("thread_id");
	$rp = get_param("rp");

	if ($thread_id) {
		$sql  = " SELECT f.topic, f.forum_id, fl.forum_name, fl.category_id, fc.category_name ";
		$sql .= " FROM " . $table_prefix . "forum f, " . $table_prefix . "forum_list fl, " . $table_prefix . "forum_categories fc ";
		$sql .= " WHERE f.thread_id = " . $db->tosql($thread_id, INTEGER);
		$sql .= " AND f.forum_id = fl.forum_id AND fl.category_id = fc.category_id ";
		$db->query($sql);
		if ($db->next_record()) {
			$current_category_url  = "admin_forum.php?category_id=" . $db->f("category_id");
			$current_category_name = $db->f("category_name");
			$current_forum_url  = "admin_forum.php?forum_id=" . $db->f("forum_id");
			$current_forum_name = $db->f("forum_name");
			$current_topic_url  = "admin_forum_thread.php?thread_id=" . $thread_id;
			$current_topic_name = $db->f("topic");

			$t->set_var("current_category_url",  $current_category_url);
			$t->set_var("current_category_name", $current_category_name);
			$t->set_var("current_forum_url",  $current_forum_url);
			$t->set_var("current_forum_name", $current_forum_name);
			$t->set_var("current_topic_url",  $current_topic_url);
			$t->set_var("current_topic_name", $current_topic_name);
			$t->parse("category_breadcrumb", false);
		}
	}
	$return_page = (strlen($rp) && $operation != "delete") ? $rp : "admin_forum_thread.php?thread_id=" . $thread_id;

	if(strlen($operation)) {
		if ($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} else if ($operation == "delete" && $thread_id) {
			$sql = "SELECT forum_id, replies FROM ". $table_prefix . "forum WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
			$db->query($sql);
			if ($db->next_record()) {
				$forum_id = $db->f("forum_id");
				$replies = intval($db->f("replies"));
			} else {
				header ("Location: " . $return_page);
				exit;
			}

			$db->query("DELETE FROM " . $table_prefix . "forum_messages WHERE thread_id = " . $db->tosql($thread_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "forum WHERE thread_id = " . $db->tosql($thread_id, INTEGER));

			// update information when topic deleted
			$sql  = " SELECT thread_updated, user_id, admin_id_added_by, thread_id ";
			$sql .= " FROM " . $table_prefix . "forum ";
			$sql .= " WHERE forum_id=" . $db->tosql($forum_id, INTEGER);
			$sql .= " ORDER BY thread_updated DESC ";
			$db->RecordsPerPage = 1; $db->PageNumber = 1;
			$db->query($sql);
			if ($db->next_record()) {
				$last_post_added = $db->f("thread_updated", DATETIME);
				$last_post_user_id = $db->f("user_id");
				$last_post_admin_id = $db->f("admin_id_added_by");
				$last_post_thread_id = $db->f("thread_id");
			} else {
				$last_post_added = ""; $last_post_thread_id = 0;
				$last_post_user_id = 0; $last_post_admin_id = 0;
			}

			$sql  = " UPDATE ". $table_prefix . "forum_list ";
			$sql .= " SET threads_number=threads_number-1, messages_number=messages_number-" . $db->tosql($replies, INTEGER) . ", ";
			$sql .= " last_post_added=" . $db->tosql($last_post_added, DATETIME) . ", ";
			$sql .= " last_post_user_id=" . $db->tosql($last_post_user_id, INTEGER) . ", ";
			$sql .= " last_post_admin_id=" . $db->tosql($last_post_admin_id, INTEGER) . ", ";
			$sql .= " last_post_thread_id=" . $db->tosql($last_post_thread_id, INTEGER) . ", ";
			$sql .= " last_post_message_id=0 ";
			$sql .= " WHERE forum_id=" . $db->tosql($forum_id, INTEGER);
			$db->query($sql);

			header("Location: admin_forum.php?forum_id=" . $forum_id);
			exit;
		}

		$is_valid = $r->validate();

		if ($is_valid) {
			$remote_address = get_ip();
			$date_added = va_time();
			$r->set_value("date_modified", $date_added);
			$r->set_value("thread_updated", $date_added);
			$r->set_value("admin_id_added_by", get_session("session_admin_id"));
			$r->set_value("admin_id_modified_by", get_session("session_admin_id"));

			$new_forum_id = $r->get_value("forum_id");
			if (strlen($r->get_value("thread_id"))) {
				$sql = "SELECT forum_id, replies FROM ". $table_prefix . "forum WHERE thread_id = " . $db->tosql($thread_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$old_forum_id = $db->f("forum_id");
					$replies = intval($db->f("replies"));
				} else {
					header ("Location: " . $return_page);
					exit;
				}
				
				set_friendly_url();
				$r->update_record();

				// the topic moved to new location
				if ($new_forum_id != $old_forum_id) {
					// update information for old location
					$sql  = " SELECT thread_updated, user_id, admin_id_added_by, thread_id ";
					$sql .= " FROM " . $table_prefix . "forum ";
					$sql .= " WHERE forum_id=" . $db->tosql($old_forum_id, INTEGER);
					$sql .= " ORDER BY thread_updated DESC ";
					$db->RecordsPerPage = 1; $db->PageNumber = 1;
					$db->query($sql);
					if ($db->next_record()) {
						$last_post_added = $db->f("thread_updated", DATETIME);
						$last_post_user_id = $db->f("user_id");
						$last_post_admin_id = $db->f("admin_id_added_by");
						$last_post_thread_id = $db->f("thread_id");
					} else {
						$last_post_added = ""; $last_post_thread_id = 0;
						$last_post_user_id = 0; $last_post_admin_id = 0;
					}

					$sql  = " UPDATE ". $table_prefix . "forum_list ";
					$sql .= " SET threads_number=threads_number-1, messages_number=messages_number-" . $db->tosql($replies, INTEGER) . ", ";
					$sql .= " last_post_added=" . $db->tosql($last_post_added, DATETIME) . ", ";
					$sql .= " last_post_user_id=" . $db->tosql($last_post_user_id, INTEGER) . ", ";
					$sql .= " last_post_admin_id=" . $db->tosql($last_post_admin_id, INTEGER) . ", ";
					$sql .= " last_post_thread_id=" . $db->tosql($last_post_thread_id, INTEGER) . ", ";
					$sql .= " last_post_message_id=0 ";
					$sql .= " WHERE forum_id=" . $db->tosql($old_forum_id, INTEGER);
					$db->query($sql);

					// update information for new location
					$sql  = " SELECT thread_updated, user_id, admin_id_added_by, thread_id ";
					$sql .= " FROM " . $table_prefix . "forum ";
					$sql .= " WHERE forum_id=" . $db->tosql($new_forum_id, INTEGER);
					$sql .= " ORDER BY thread_updated DESC ";
					$db->RecordsPerPage = 1; $db->PageNumber = 1;
					$db->query($sql);
					if ($db->next_record()) {
						$last_post_added = $db->f("thread_updated", DATETIME);
						$last_post_user_id = $db->f("user_id");
						$last_post_admin_id = $db->f("admin_id_added_by");
						$last_post_thread_id = $db->f("thread_id");
					} else {
						$last_post_added = ""; $last_post_thread_id = 0;
						$last_post_user_id = 0; $last_post_admin_id = 0;
					}

					$sql  = " UPDATE ". $table_prefix . "forum_list ";
					$sql .= " SET threads_number=threads_number+1, ";
					$sql .= " messages_number=messages_number+" . $db->tosql($replies, INTEGER) . ", ";
					$sql .= " last_post_added=" . $db->tosql($last_post_added, DATETIME) . ", ";
					$sql .= " last_post_user_id=" . $db->tosql($last_post_user_id, INTEGER) . ", ";
					$sql .= " last_post_admin_id=" . $db->tosql($last_post_admin_id, INTEGER) . ", ";
					$sql .= " last_post_thread_id=" . $db->tosql($last_post_thread_id, INTEGER) . ", ";
					$sql .= " last_post_message_id=0 ";
					$sql .= " WHERE forum_id=" . $db->tosql($new_forum_id, INTEGER);
					$db->query($sql);
				} 

			} else {
				set_friendly_url();
				if ($db_type == "postgre") {
					$sql = " SELECT NEXTVAL('seq_" . $table_prefix . "forum') ";
					$thread_id = get_db_value($sql);
					$r->set_value("thread_id", $thread_id);
					$r->change_property("thread_id", USE_IN_INSERT, true);
				}
				$r->set_value("date_added", $date_added);
				if ($r->is_empty("views")) {
					$r->set_value("views", 0);
				}
				$r->set_value("replies", 0);

				$r->insert_record();

				if ($db_type == "mysql") {
					$sql = " SELECT LAST_INSERT_ID() ";
					$thread_id = get_db_value($sql);
				} else if ($db_type == "access") {
					$sql = " SELECT @@IDENTITY ";
					$thread_id = get_db_value($sql);
				}

				// update forum information
				$sql  = " UPDATE " . $table_prefix . "forum_list ";
				$sql .= " SET last_post_added=" . $db->tosql($date_added, DATETIME) . ", threads_number=threads_number+1,";
				$sql .= " last_post_admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER) . ", ";
				$sql .= " last_post_thread_id=" . $db->tosql($thread_id, INTEGER) . ", ";
				$sql .= " last_post_user_id=0, last_post_message_id=0 ";
				$sql .= " WHERE forum_id=" . $db->tosql($new_forum_id, INTEGER);
				$db->query($sql);

			}

			header("Location: " . $return_page);
			exit;
		}
	}	else if(strlen($r->get_value("thread_id"))) {
		$r->get_db_values();
	} else {
		// new item (set default values)
	}

	$r->set_parameters();
	
	if(strlen($thread_id)) {
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	} else {
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("rp", htmlspecialchars($return_page));

	$t->pparse("main");

?>