<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_global_settings.php                                ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/record.php");
	include_once($root_folder_path . "includes/friendly_functions.php");
	include_once($root_folder_path . "messages/" . $language_code . "/admin_messages.php");

	check_admin_security("site_settings");

	// additional connection 
	$dbs = new VA_SQL();
	$dbs->DBType      = $db_type;
	$dbs->DBDatabase  = $db_name;
	$dbs->DBUser      = $db_user;
	$dbs->DBPassword  = $db_password;
	$dbs->DBHost      = $db_host;
	$dbs->DBPort      = $db_port;
	$dbs->DBPersistent= $db_persistent;

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_global_settings.html");

	$t->set_var("admin_global_settings_href", "admin_global_settings.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_layout_scheme_href", "admin_layout_scheme.php");
	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");
	
	$va_license_code = va_license_code();

	$r = new VA_Record($table_prefix . "global_settings");

	// load data to listbox
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", "")));
	$states = get_db_values("SELECT state_code, state_name FROM " . $table_prefix . "states ORDER BY state_name ", array(array("", "")));
	$admin_templates_dir_values = get_db_values("SELECT layout_id,layout_name FROM " . $table_prefix . "layouts", "");

	$records_per_page = 
		array( 
			array(5, 5), array(10, 10), array(15, 15),
			array(20, 20), array(25, 25), array(50, 50),
			array(75, 75), array(100, 100)
			);

	$validation_types = 
		array( 
			array(2, "All Users"), array(1, "Unregistered User Only"), array(0, "Not Used")
		);

	$yes_no = 
		array( 
			array(1, YES_MSG), array(0, NO_MSG)
			);

	$password_encrypt = 
		array( 
			array(0, "None"), 
			array(1, "Use MD5 for encryption (if you choose this option all passwords in the database will be encrypted)")
			);


	$html_editors = 
		array( 
			array(1, "WYSIWYG HTML Editor"),
			array(0, "Textarea Editor")
			);

	$friendly_auto_options =
		array( 
			array(0, "Don't generate Friendly URL automatically"),
			array(1, "Always regenerate Friendly URL using latest title"),
			array(2, "Generate Friendly URL if it wasn't set manually")
			);

	$friendly_extensions =
		array( 
			array("", "[without extension] &nbsp;"),
			array(".html", ".html &nbsp;"),
			array(".htm", ".htm &nbsp;"),
			array(".php", ".php &nbsp;"),
			);

	//SMS notifications for unregistered users:
	$sms_allowed_options =
		array( 
			array(0, "sms notifications are not allowed"),
			array(1, "sms notifications are allowed"),
			array(2, "sms notifications are allowed if a user's sms number is in the allowed numbers list"),
			);

	// set up parameters
	$r->add_textbox("site_url", TEXT);
	$r->add_textbox("admin_email", TEXT);
	$r->add_select("country_code", TEXT, $countries);
	$r->add_select("state_code", TEXT, $states);
	$r->add_select("layout_id", INTEGER, $admin_templates_dir_values);
	$r->add_radio("password_encrypt", INTEGER, $password_encrypt);
	$r->change_property("password_encrypt", BEFORE_SHOW_VALUE, "disable_password_encrypt");
	$r->add_textbox("weight_measure", TEXT);
	$r->add_radio("html_editor", INTEGER, $html_editors);

	// run php code
	$r->add_checkbox("php_in_index_greetings", INTEGER);
	$r->add_checkbox("php_in_footer_body", INTEGER);
	$r->add_checkbox("php_in_custom_blocks", INTEGER);
	$r->add_checkbox("php_in_custom_pages", INTEGER);

	// logo settings
	$r->add_textbox("logo_image", TEXT);
	$r->add_textbox("logo_image_alt", TEXT);
	$r->add_textbox("logo_image_width", INTEGER, "Logo Image Width");
	$r->add_textbox("logo_image_height", INTEGER, "Logo Image Height");

	// text editor settings
	$r->add_checkbox("user_image_upload", INTEGER);
	$r->add_textbox("user_image_size", INTEGER);
	$r->add_textbox("user_image_width", INTEGER);
	$r->add_textbox("user_image_height", INTEGER);

	$r->add_radio("is_sms_allowed", INTEGER, $sms_allowed_options);

	$r->add_textbox("secure_url", TEXT);
	$r->add_checkbox("secure_user_profile", INTEGER);

	if ($va_name == "shop") {
		$r->add_checkbox("secure_order_profile", INTEGER);
		$r->add_checkbox("secure_payments", INTEGER);
		$r->add_checkbox("secure_admin_order_create", INTEGER);
	}

	$r->add_checkbox("secure_admin_login", INTEGER);

	$r->add_checkbox("friendly_urls", INTEGER);
	$r->add_radio("friendly_auto", INTEGER, $friendly_auto_options);
	$r->add_radio("friendly_extension", TEXT, $friendly_extensions);

	// tracking fields
	$r->add_checkbox("tracking_visits", INTEGER);
	$r->add_checkbox("tracking_pages", INTEGER);
	$r->add_checkbox("google_analytics", INTEGER);
	$r->add_textbox("google_tracking_code", TEXT);
	$r->change_property("google_tracking_code", TRIM, TRUE);

	$r->add_radio("approve_review", INTEGER, $yes_no);
	$r->add_select("reviews_per_page", INTEGER, $records_per_page);
	$r->add_radio("review_random_image", TEXT, $validation_types);		

	$r->add_textbox("min_rating", FLOAT);
	$r->add_textbox("min_votes", INTEGER);

	$r->add_textbox("index_title", TEXT);
	$r->add_textbox("index_description", TEXT);
	$r->add_textbox("index_keywords", TEXT);
	$r->add_textbox("html_on_index", TEXT);
	$r->add_textbox("html_below_footer", TEXT);

	// site map parameters	
	$r->add_checkbox("site_map_custom_pages", INTEGER);
	if ($va_license_code & 1) {
		$r->add_checkbox("site_map_categories", INTEGER);
		$r->add_checkbox("site_map_items", INTEGER);
		$r->change_property("site_map_items", SHOW, true);
	} else {
		$r->change_property("site_map_items", SHOW, false);
	}
	if ($va_license_code & 8) {
		$r->add_checkbox("site_map_forums", INTEGER);
		$r->add_checkbox("site_map_forum_categories", INTEGER);
		$r->change_property("site_map_forum_categories", SHOW, true);
	} else {
		$r->change_property("site_map_forum_categories", SHOW, false);
	}
	if ($va_license_code & 16) {
		$r->add_checkbox("site_map_ad_categories", INTEGER);
		$r->add_checkbox("site_map_ads", INTEGER);
		$r->change_property("site_map_ads", SHOW, true);
	} else {
		$r->change_property("site_map_ads", SHOW, false);
	}
	if ($va_license_code & 32) {
		$r->add_checkbox("site_map_manuals", INTEGER);
		$r->add_checkbox("site_map_manual_categories", INTEGER);
		$r->change_property("site_map_manual_categories", SHOW, true);
	} else {
		$r->change_property("site_map_manual_categories", SHOW, false);
	}

	$articles_categories = array();
	if ($va_license_code & 2) {
		$sql  = " SELECT ac.category_id, ac.category_name ";
		$sql .= " FROM " . $table_prefix . "articles_categories ac ";
		$sql .= " WHERE ac.parent_category_id=0 ";
		$db->query($sql);
		while ($db->next_record()) {
			$row_cat_id = $db->f("category_id");
			$row_cat_name = get_translation($db->f("category_name"), $language_code);
			$r->add_checkbox("site_map_articles_categories_" . $row_cat_id, INTEGER);
			$r->add_checkbox("site_map_articles_" . $row_cat_id, INTEGER);

			$articles_categories[$row_cat_id] = $row_cat_name;
		}
	}

	$r->get_form_values();

	$site_url = $r->get_value("site_url");
	if (strlen($site_url) && substr($site_url, strlen($site_url) - 1) != "/") {
		$site_url .= "/";
		$r->set_value("site_url", $site_url);
	}

	$secure_url = $r->get_value("secure_url");
	if (strlen($secure_url) && substr($secure_url, strlen($secure_url) - 1) != "/") {
		$secure_url .= "/";
		$r->set_value("secure_url", $secure_url);
	}

	$google_tracking_code = $r->get_value("google_tracking_code");
	if (preg_match("/^[\"'](.*)[\"']$/", $google_tracking_code, $match)) {
		$r->set_value("google_tracking_code", $match[1]);
	}

	$operation = get_param("operation");
	$tab = get_param("tab");
	if (!$tab) { $tab = "general"; }
	$return_page = get_param("rp");
	if (!strlen($return_page)) $return_page = "admin.php";
	
	$message_build_xml = "";

	$filename = "../sitemap_index.xml";
	if (file_exists($filename)){
		$size = filesize($filename);
		$fp = @fopen($filename, "r");
		$contents = fread($fp, $size);
		@fclose($fp);
		if (preg_match_all("/<lastmod>(.*)\<\/lastmod>/Uis", $contents, $matches, PREG_SET_ORDER)){
			$datetime_loc_format = array("YYYY", "-", "MM", "-", "DD", "T", "HH", ":", "mm", ":", "ss", "+00:00");
			$date_modified_value = parse_date($matches[0][1], $datetime_loc_format, $date_errors);
			$date_modified = va_date($datetime_show_format, $date_modified_value);
			$message_build_xml = str_replace("{creation_date}", $date_modified, SM_LATEST_BUILD);
			$message_build_xml = str_replace("{filename}", "sitemap_index.xml", $message_build_xml);
		}

	}

	if ($operation == "build_xml"){
		include("./admin_site_map_xml_build.php");
		$operation = "";
	}
	if (strlen($operation))	{
		$tab = "general";
		if ($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();

		if (!function_exists('imagecreate') && (($r->get_value("review_random_image") == 2) || ($r->get_value("review_random_image") == 1 ))) {	
			$r->errors .= "Sorry, to use Random Image Validation please install <a href='http://www.php.net/gd' target='_blank'> php graphical library gd</a>.";
			$r->set_value("review_random_image", 0);
		} 

		if (!strlen($r->errors))
		{
			// global settings
			$sql  = " SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= " WHERE setting_type='global' AND setting_name='password_encrypt' ";
			$old_password_encrypt = get_db_value($sql);
			$new_password_encrypt = $r->get_value("password_encrypt");

			$sql  = " SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= " WHERE setting_type='global' AND setting_name='friendly_auto' ";
			$old_friendly_auto = get_db_value($sql);

			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='global'";
			$db->query($sql);
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='site_map'";
			$db->query($sql);
			foreach ($r->parameters as $key => $value)
			{
				if (strpos($key, "site_map") === false) {
					$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
					$sql .= "'global', '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				} else {
					$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
					$sql .= "'site_map', '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				}
				$db->query($sql);
			}
			set_session("session_settings", "");
			session_unregister("session_settings");

			// check if password encrypt setting was changed to md5
			if ($new_password_encrypt == 1 && $new_password_encrypt != $old_password_encrypt) {
				$sql  = " SELECT user_id, password FROM " . $table_prefix . "users ";
				$db->query($sql);
				while ($db->next_record()) {
					$user_id = $db->f("user_id");
					$password = $db->f("password");
					if (!preg_match("/[0-9a-f]{32}/i", $password)) {
						$sql  = " UPDATE " . $table_prefix . "users SET ";
						$sql .= " password=" . $db->tosql(md5($password), TEXT);
						$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
						$dbs->query($sql);
					}
				}

				$sql  = " SELECT admin_id, password FROM " . $table_prefix . "admins ";
				$db->query($sql);
				while ($db->next_record()) {
					$admin_id = $db->f("admin_id");
					$password = $db->f("password");
					if (!preg_match("/[0-9a-f]{32}/i", $password)) {
						$sql  = " UPDATE " . $table_prefix . "admins SET ";
						$sql .= " password=" . $db->tosql(md5($password), TEXT);
						$sql .= " WHERE admin_id=" . $db->tosql($admin_id, INTEGER);
						$dbs->query($sql);
					}
				}
			}

			$friendly_urls = $r->get_value("friendly_urls");
			$friendly_auto = $r->get_value("friendly_auto");
			// check if friendly url functionality was turn on with automatic links generation
			if ($friendly_urls && ($friendly_auto == 1 || $friendly_auto == 2) && $friendly_auto != $old_friendly_auto) {

				foreach ($friendly_tables as $table_name => $table_info) {
					$key_field = $table_info[0];
					$title_field = $table_info[1];
					$sql  = " SELECT " . $key_field . ", " . $title_field . " FROM " . $table_name;
					$sql .= " WHERE friendly_url IS NULL OR friendly_url='' ";
					$dbs->query($sql);
					while ($dbs->next_record()) {
						$key_id = $dbs->f($key_field);
						$title_value = get_translation($dbs->f($title_field));
						$friendly_url = generate_friendly_url($title_value);
						$sql  = " UPDATE " . $table_name . " SET ";
						$sql .= " friendly_url=" . $db->tosql($friendly_url, TEXT);
						$sql .= " WHERE " . $key_field . "=" . $db->tosql($key_id, INTEGER);
						$db->query($sql);
					}
				}
			}

			header("Location: " . $return_page);
			exit;
		}
		else // parse errors
		{
			$t->set_var("errors_list", $r->errors);
			$t->parse("errors", false);
			foreach ($articles_categories as $row_cat_id => $row_cat_name)
			{
				$t->set_var("row_cat_id", $row_cat_id);
		
				if (defined("SM_SHOW_ARTICLES_CAT_MSG")) {
					$sm_show_articles_cat = str_replace("{row_cat_name}", $row_cat_name, SM_SHOW_ARTICLES_CAT_MSG);
					$sm_show_articles = str_replace("{row_cat_name}", $row_cat_name, SM_SHOW_ARTICLES_MSG);
				} else {
					$sm_show_articles_cat = $row_cat_name . " " . CATEGORIES_TITLE;
					$sm_show_articles = $row_cat_name  . " " . ARTICLES_TITLE;
				}
				$t->set_var("SM_SHOW_ARTICLES_CAT_MSG", $sm_show_articles_cat);
				$t->set_var("SM_SHOW_ARTICLES_MSG", $sm_show_articles);
				if ($r->get_value("site_map_articles_categories_" . $row_cat_id)) {
					$t->set_var("site_map_articles_categories", "checked");
				} else {
					$t->set_var("site_map_articles_categories", "");
				}
				if ($r->get_value("site_map_articles_" . $row_cat_id)) {
					$t->set_var("site_map_articles", "checked");
				} else {
					$t->set_var("site_map_articles", "");
				}
				$t->parse("map_articles_settings", true);
			}
		}
	}
	else // get global settings
	{
		$sql  = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings ";
		$sql .= "WHERE setting_type='global' ";
		$db->query($sql);
		while ($db->next_record()) {
			$setting_name = $db->f("setting_name");
			$setting_value = $db->f("setting_value");
			if ($r->parameter_exists($setting_name)) {
				$r->set_value($setting_name, $setting_value);
			}
		}
		// get site map settings
		$sql  = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings ";
		$sql .= "WHERE setting_type='site_map' ";
		$db->query($sql);
		while ($db->next_record()) {
			$setting_name = $db->f("setting_name");
			$setting_value = $db->f("setting_value");
			if ($r->parameter_exists($setting_name)) {
				$r->set_value($setting_name, $setting_value);
			}
		}
		foreach ($articles_categories as $row_cat_id => $row_cat_name)
		{
			$t->set_var("row_cat_id", $row_cat_id);
	
			if (defined("SM_SHOW_ARTICLES_CAT_MSG")) {
				$sm_show_articles_cat = str_replace("{row_cat_name}", $row_cat_name, SM_SHOW_ARTICLES_CAT_MSG);
				$sm_show_articles = str_replace("{row_cat_name}", $row_cat_name, SM_SHOW_ARTICLES_MSG);
			} else {
				$sm_show_articles_cat = $row_cat_name . " " . CATEGORIES_TITLE;
				$sm_show_articles = $row_cat_name  . " " . ARTICLES_TITLE;
			}
			$t->set_var("SM_SHOW_ARTICLES_CAT_MSG",$sm_show_articles_cat);
			$t->set_var("SM_SHOW_ARTICLES_MSG",$sm_show_articles);
			if ($r->get_value("site_map_articles_categories_".$row_cat_id)) {
				$t->set_var("site_map_articles_categories", "checked");
			} else {
				$t->set_var("site_map_articles_categories", "");
			}
			if ($r->get_value("site_map_articles_".$row_cat_id)) {
				$t->set_var("site_map_articles", "checked");
			} else {
				$t->set_var("site_map_articles", "");
			}
			$t->parse("map_articles_settings", true);
		}
	}

	if (strlen($message_build_xml)) {
		$t->set_var("message_build_xml", $message_build_xml);
		$t->sparse("success_build_xml", false);
	} 

	$r->set_parameters();
	$t->set_var("rp", htmlspecialchars($return_page));

	$layout_scheme = "";
	$active_layout_id = $settings["layout_id"];
	$sql = " SELECT layout_name FROM " . $table_prefix . "layouts WHERE layout_id=" . $db->tosql($active_layout_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$layout_lc = strtolower($db->f("layout_name"));
		if ($dir = @opendir($root_folder_path . "styles")) 
		{
			$dir_values = array();
			while ($file = readdir($dir)) {
				if (preg_match("/^" . $layout_lc . "\_/", $file)) { 
					$dir_values[] = $file;
				}
			}
			closedir($dir);
			if (sizeof($dir_values) > 1) {
				$layout_scheme = "<a href=\"#\" onCLick=\"window.location='admin_layout_scheme.php'; return false;\">Change Active Scheme</a>";
			}
		}
	}
	$t->set_var("layout_scheme", $layout_scheme);

	$tabs = array("general" => "General", "site_map" => "Site Map");
	foreach ($tabs as $tab_name => $tab_title) {
		$t->set_var("tab_id", "tab_" . $tab_name);
		$t->set_var("tab_name", $tab_name);
		$t->set_var("tab_title", $tab_title);
		if ($tab_name == $tab) {
			$t->set_var("tab_class", "adminTabActive");
			$t->set_var($tab_name . "_style", "display: block;");
		} else {
			$t->set_var("tab_class", "adminTab");
			$t->set_var($tab_name . "_style", "display: none;");
		}
		$t->parse("tabs", $tab_title);
	}
	$t->set_var("tab", $tab);

	include_once("./admin_header.php");
	include_once("./admin_footer.php");

	$t->pparse("main");

	function disable_password_encrypt($parameters)
	{
		global $r, $t;
		$current_value = $parameters["current_value"];
		if ($r->get_value("password_encrypt") == 1) {
			if ($current_value == "1") {
				$t->set_var("password_encrypt_disabled", "");
			} else {
				$t->set_var("password_encrypt_disabled", "disabled");
			}
		} else {
			$t->set_var("password_encrypt_disabled", "");
		}
	}

?>