<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_import.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	@set_time_limit (600);
	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path . "messages/".$language_code."/admin_messages.php");
	include_once ($root_folder_path . "messages/".$language_code."/download_messages.php");

	check_admin_security("import_export");

	$errors = "";
	$max_columns = 9;
	$rnd = get_param("rnd");
	$table = get_param("table");
	$csv_delimiter = get_param("csv_delimiter");
	$csv_file_path = get_param("csv_file_path");
	$operation = get_param("operation");
	$category_id = get_param("category_id");
	$use_first_row = get_param("use_first_row");
	$insert_data = get_param("insert_data");
	$session_rnd = get_session("session_rnd");
	$is_file_path = false;

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_import.html");

	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_import_href", "admin_import.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	if ($table == "items") {
		check_admin_security("products_categories");
		include("./admin_table_items.php");
	} else if ($table == "categories") {
		check_admin_security("products_categories");
		include("./admin_table_categories.php");
	} else if ($table == "users") {
		check_admin_security("import_users");
		include("./admin_table_users.php");
	} else {
		$table_name = "";
		$table_title = "";
		$errors = "Can't find table to import.";
	}

	$db_columns_options = array();
	$db_columns_options[] = array("", "");
	$db_columns_options[] = array("-1", "<-- Ignore this column");
	if(!$errors) {
		foreach($db_columns as $column_name => $column_info) {
			if($column_info[2] != HIDE_DB_FIELD) {
				$db_columns_options[] = array($column_name, $column_info[0]);
			}
		}
		foreach($db_columns as $column_name => $column_info) {
			$column_title = strtolower($column_info[0]);
			$db_aliases[$column_title] = $column_name;
		}
	}

	$t->set_var("table", $table);
	$t->set_var("table_title", $table_title);

	if($operation == "upload")
	{
		if (strlen($csv_file_path)) {
			$is_file_path = true;
			if (file_exists($csv_file_path)) {
				$fp = fopen($csv_file_path, "r");
				if(!$fp) {
					$errors = "Sorry can't open imported file. Please contact your administrator.";
				}
			} else {
				$errors = "File <b>$csv_file_path</b> doesn't exists.";
			}
		} else {
			if (isset($_FILES)) {
				$tmp_name = $_FILES["csv_file"]["tmp_name"];
				$filename = $_FILES["csv_file"]["name"];
				$filesize = $_FILES["csv_file"]["size"];
				$upload_error = isset($_FILES["csv_file"]["error"]) ? $_FILES["csv_file"]["error"] : "";
			} else {
				$tmp_name = $HTTP_POST_FILES["csv_file"]["tmp_name"];
				$filename = $HTTP_POST_FILES["csv_file"]["name"];
				$filesize = $HTTP_POST_FILES["csv_file"]["size"];
				$upload_error = isset($HTTP_POST_FILES["csv_file"]["error"]) ? $HTTP_POST_FILES["csv_file"]["error"] : "";
			}
	  
			if ($upload_error == 1) {
				$errors = "The uploaded file exceeds the max filesize directive.";
			} else if ($upload_error == 2) {
				$errors = "The uploaded file exceeds the max filesize parameter.";
			} else if ($upload_error == 3) {
				$errors = "The uploaded file was only partially uploaded.";
			} else if ($upload_error == 4) {
				$errors = "No file was uploaded.";
			} else if ($upload_error == 6) {
				$errors = "Missing a temporary folder.";
			} else if ($upload_error == 7) {
				$errors = "Failed to write file to disk.";
			} else if ($tmp_name == "none" || !strlen($tmp_name)) {
				$errors = "No file was uploaded.";
			}
	  
			if(!strlen($errors)) {
				$fp = fopen($tmp_name, "r");
				if(!$fp) {
					$errors = "Sorry can't open imported file. Please contact your administrator.";
				}
			}
		}

		if(!strlen($errors)) {
			if ($columns_data = fgetcsv($fp, 4096, $csv_delimiter)) {
				$columns_number = sizeof($columns_data);
				if($columns_number < $min_column_allowed) {
					$errors = "Sorry at least " . $min_column_allowed . " columns are required. Please check your CSV file and settings you selected.";
				} 
			} else {
				$errors = "Sorry can't parse columns data. Please check your CSV file.";
			}
		}

		if(!strlen($errors)) {

			$operation = "import";
			$row = 1; $column_number = 0;
			for($i = 0; $i < $columns_number; $i++) {
				$column_number++;
				$column_title = trim($columns_data[$i]);
				$db_column = strtolower($column_title);
				if(isset($db_aliases[$db_column])) {
					$db_column = $db_aliases[$db_column];
				}
				$field_name = "f_" . $row . "_" . $column_number;
				$t->set_var("field_name", $field_name);
				$t->set_var("field_value", htmlspecialchars($column_title));
				$t->set_var("column_number", $column_number);
				$t->set_var("column_title", htmlspecialchars($column_title));
				set_options($db_columns_options, $db_column, "db_column");
				$t->parse("columns", true);
				$t->parse("fields", true);
			}

			if (!$is_file_path) {
				while ($data = fgetcsv($fp, 32768, $csv_delimiter)) {
					if (sizeof($data) > 1 || $data[0]) {
						$row++;
						for($i = 0; $i < $columns_number; $i++) {
							$col = ($i + 1);
							$field_name = "f_" . $row . "_" . $col;
							$field_value = isset($data[$i]) ? $data[$i] : "";
							$t->set_var("field_name", $field_name);
							$t->set_var("field_value", htmlspecialchars($field_value));
							$t->parse("fields", true);
						}
						$t->set_var("row", $row);
						$t->parse("rows", true);
					}
				}
			}

			$t->set_var("total_rows", $row);
			$t->set_var("total_columns", $columns_number);
			fclose($fp);
		}
	} else if ($operation == "import") {
		$operation = "insert";
		$total_rows = get_param("total_rows");
		$total_columns = get_param("total_columns");
		$total_columns_left = $total_columns;
		$total_colspan = ($total_columns + 1);
		$total_errors = 0;
		$is_where = false;

		$r = new VA_Record($table_name);
		if ($table == "items") {
			// administrative information
			$r->add_textbox("admin_id_added_by", INTEGER);
			$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
			$r->add_textbox("admin_id_modified_by", INTEGER);
			$r->add_textbox("date_added", DATETIME);
			$r->change_property("date_added", USE_IN_UPDATE, false);
			$r->add_textbox("date_modified", DATETIME);
			$r->set_value("admin_id_added_by", get_session("session_admin_id"));
			$r->set_value("admin_id_modified_by", get_session("session_admin_id"));
			$r->set_value("date_added", va_time());
			$r->set_value("date_modified", va_time());
		}

		foreach($db_columns as $column_name => $column_info) {
			if ($column_info[2] == 1) {
				$where_column = $column_name;
				$r->add_where($column_name, $column_info[1], $column_info[0]);
				$r->change_property($where_column, USE_IN_INSERT, true);
			} else if($column_info[2] > 1 && $column_info[3] == true) {
				$r->add_textbox($column_name, $column_info[1], $column_info[0]);
				$r->change_property($column_name, REQUIRED, true);
				if(isset($column_info[4]) && (is_array($column_info[4]) || strlen($column_info[4]))) {
					$r->set_value($column_name, $column_info[4]);
					$r->change_property($column_name, USE_IN_UPDATE, false);
				}
			} else if($column_info[2] == USUAL_DB_FIELD && $column_info[3] == false && isset($column_info[4])) {
				$r->add_textbox($column_name, $column_info[1], $column_info[0]);
				if (strlen($column_info[4])) {
					$r->set_value($column_name, $column_info[4]);
				} else {
					// don't put null values if there empty value
					$r->change_property($column_name, USE_SQL_NULL, false);
				}
			}

		}

		$column_number = 0; $related_fields = array();
		for($col = 1; $col <= $total_columns; $col++) {
			$column_name = get_param("db_column_" . $col);
			$column_value = get_param("f_1_" . $col);
			if($column_name == "-1" || $column_name == "") { // ignoring column
				$total_columns_left--;
			} else {
				$column_number++;
				if ($db_columns[$column_name][2] == RELATED_DB_FIELD) {
					$related_fields[] = $col;
					$column_title = $column_value;
				} else if($db_columns[$column_name][2] == WHERE_DB_FIELD) {
					$column_title = $db_columns[$column_name][0];
					$is_where = true;
				} else {
					$column_title = $db_columns[$column_name][0];
					$r->add_textbox($column_name, $db_columns[$column_name][1], $db_columns[$column_name][0]);
					if ($db_columns[$column_name][1] == DATE) {
						$r->change_property($column_name, VALUE_MASK, $date_edit_format);
					} else if ($db_columns[$column_name][1] == DATETIME) {
						$r->change_property($column_name, VALUE_MASK, $datetime_edit_format);
					}
					$r->change_property($column_name, USE_IN_UPDATE, true);
					if($db_columns[$column_name][3] == true) {
						$r->change_property($column_name, REQUIRED, true);
					}
					if($db_columns[$column_name][2] == USUAL_DB_FIELD && $db_columns[$column_name][3] == false && isset($db_columns[$column_name][4])) {
						if (!strlen($db_columns[$column_name][4])) {
							$r->change_property($column_name, USE_SQL_NULL, false);
						}
					}
				}
				$t->set_var("col", $column_number);
				$t->set_var("column_name", $column_name);
				$t->set_var("column_value", htmlspecialchars($column_value));
				$t->set_var("column_title", $column_title);
				$t->parse("columns_data", true);
				if ($col <= $max_columns) {
					$t->parse("columns_titles", true);
				}
			} 
		}


		if ($total_columns_left > $max_columns) {
			$t->set_var("total_colspan", ($max_columns + 1));
		} else {
			$t->set_var("total_colspan", ($total_columns_left + 1));
		}
		$t->set_var("total_columns", $total_columns_left);


		if ($insert_data && $rnd == $session_rnd) {
			$records_error = get_session("session_records_error");
			$records_added = get_session("session_records_added");
			$records_updated = get_session("session_records_updated");
			$records_ignored = get_session("session_records_ignored");
			
			$operation = "result";
		} else {
			$records_error = 0; $records_added = 0; $records_updated = 0; $records_ignored = 0;

			// get max property_id
			$sql  = " SELECT MAX(property_id) FROM " . $table_prefix . "items_properties ";
			$max_property_id = get_db_value($sql);

			// start processing rows
			$is_next_row = false;
			$row = $use_first_row ? 1 : 2;
			if (strlen($csv_file_path)) {	
				$is_file_path = true;
				$fp = fopen($csv_file_path, "r");
				if ($fp) {
					if (!$use_first_row) {
						$data = fgetcsv($fp, 32768, $csv_delimiter);
					} 
					$data = fgetcsv($fp, 32768, $csv_delimiter);
					$is_next_row = is_array($data);
				} 
			} else {
				$is_next_row = ($row <= $total_rows);
			}

			while ($is_next_row) {
				$t->set_var("cols", "");
				$column_number = 0;
				foreach($db_columns as $column_name => $column_info) {
					if($column_info[2] > 1 && $column_info[3] == true) {
						if(isset($column_info[4]) && (is_array($column_info[4]) || strlen($column_info[4]))) {
							$r->set_value($column_name, $column_info[4]);
						}
					}
				}
				$imported_fields = "";
				for ($col = 1; $col <= $total_columns; $col++) {
					$column_name = get_param("db_column_" . $col);
					$imported_fields .= "," . $column_name;
					if($column_name != "-1" && $column_name != "") { 
						$column_number++;
						$param_name = "f_" . $row . "_" . $col;
						$field_name = "f_" . $row . "_" . $column_number;
						if ($is_file_path) {
							$field_value = isset($data[$col - 1]) ? $data[$col - 1] : "";
						} else {
							$field_value = get_param($param_name);
						}
						$strip_field_value = strip_tags($field_value);
						$short_field_value = (strlen($strip_field_value) > 15) ? substr($strip_field_value, 0, 15) . "..." : $strip_field_value;
						$column_name = get_param("db_column_" . $col);
						if ($db_columns[$column_name][2] != RELATED_DB_FIELD) {
							/* allow to replace wrong digit separator
							if ($db_columns[$column_name][1] == FLOAT || $db_columns[$column_name][1] == NUMBER) {
								$field_value = str_replace(",", ".", $field_value);
								$field_value = str_replace(";", ".", $field_value);
							}//*/
							$r->set_value($column_name, $field_value);
						}
						$t->set_var("short_field_value", htmlspecialchars($short_field_value));
						if (!$is_file_path) {
							$t->set_var("field_name", $field_name);
							$t->set_var("field_value", htmlspecialchars($field_value));
							$t->parse("fields_info", true);
						}
						if ($col <= $max_columns) {
							$t->parse("cols", true);
						}
					}
				}

				$r->errors = "";
				$r->validate();
	  
				if ($insert_data) {
					if ($r->errors) {
						$records_ignored++;
					} else {
						$is_exists = false;
						$is_where_set = ($is_where && strlen($r->get_value($where_column)));
						if ($is_where_set) {
							$sql  = " SELECT " . $where_column . " FROM " . $table_name . "";
							$sql .= " WHERE " . $where_column . "=" . $r->get_value($where_column);
							$db->query($sql);
							if($db->next_record()) {
								$is_exists = true;
							}
						}

						$inserted_id = ""; $updated_id = "";				  
						if($is_exists) {
							if ($r->update_record()) {
								$records_updated++;
								$updated_id = $r->get_value($where_column);
							} else {
								$records_error++;
							}
						} else {
							if (!$is_where_set) {
								$sql = "SELECT MAX(" . $where_column . ") FROM " . $table_name . "";
								$db->query($sql);
								$db->next_record();
								$max_id = $db->f(0);
								$r->set_value($where_column, ($max_id + 1));
							} 
							if ($r->insert_record()) {
								$records_added++;
								$inserted_id = $r->get_value($where_column);
							} else {
								$records_error++;
							}
						}

						// added data to related tables
						if(strlen($inserted_id) || strlen($updated_id))
						{
							$property_order = 0; $category_column = false;
							for ($ri = 0; $ri < sizeof($related_fields); $ri++) {
								$related_col = $related_fields[$ri];
								$column_value = get_param("f_1_" . $related_col);
								$column_name = get_param("db_column_" . $related_col);
								$related_table = $db_columns[$column_name][4];
								$related_field = "f_" . $row . "_" . $related_col;
								if ($is_file_path) {
									$related_value = isset($data[$related_col - 1]) ? $data[$related_col - 1] : "";
								} else {
									$related_value = get_param($related_field);
								}

								$item_id = strlen($inserted_id) ? $inserted_id : $updated_id;
								if ($related_table == $table_prefix . "items_properties") {
									update_items_properties($item_id, $related_value);
								} else if ($related_table == $table_prefix . "categories") {
									$category_column = true;
									update_items_categories($item_id, $related_value);
								} else if ($related_table == $table_prefix . "manufacturers") {
									update_manufacturer($item_id, $related_value);
								}
							}
					  
							// added link to category
							if ($table_name == $table_prefix . "items" && !$category_column && strlen($inserted_id)) {
								$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id, category_id) ";
								$sql .= " VALUES (" . $db->tosql($inserted_id, INTEGER) . ", " . $db->tosql($category_id, INTEGER) . ") ";
								$db->query($sql);
							}
						}


					}
				} else {
					if($r->errors) {
						$total_errors++;
						$t->set_var("status", "<font color=red>Error</font>");
						$t->set_var("error_value", "1");
						$t->set_var("row_class", "error");
						$t->set_var("errors_list", $r->errors);
						$t->parse("row_errors", false);
					} else {
						$is_exists = false;
						if($is_where) {
							$is_exists = $r->get_db_values();
						}
						$status = $is_exists ? "<font color=green>Exists</font>" : "<font color=blue>New</font>";
						$t->set_var("status", $status);
						$t->set_var("is_exists", intval($is_exists));
						$t->set_var("error_value", "0");
						$t->set_var("row_class", "usual");
						$t->set_var("row_errors", "");
					}
			  
					$t->set_var("row", $row);
					$t->parse("rows", true);
				}
				// check if there are more rows to process
				$row++;
				if ($is_file_path) {	
					$data = fgetcsv($fp, 32768, $csv_delimiter);
					$is_next_row = is_array($data);
				} else {
					$is_next_row = ($row <= $total_rows);
				}
			}
			// end processing rows
			if ($is_file_path) {	
				fclose($fp);
			}

			// update imported fields
			if ($table == "users") {
				$sql  = " UPDATE " . $table_prefix . "admins SET imported_user_fields=" . $db->tosql($imported_fields, TEXT);
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$db->query($sql);
			} else if ($table == "items") {
				$sql = " UPDATE " . $table_prefix . "admins SET imported_item_fields=" . $db->tosql($imported_fields, TEXT);
				$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
				$db->query($sql);
			} 

			if ($insert_data) {

				if ($table_name == $table_prefix . "categories") {
					prepare_categories_list();
					update_categories_tree(0, "");
				}

				set_session("session_records_error", $records_error);
				set_session("session_records_added", $records_added);
				set_session("session_records_updated", $records_updated);
				set_session("session_records_ignored", $records_ignored);
			  
				$operation = "result";
			}
		}

		$total_rows = $row - 1;
		$t->set_var("total_rows", $total_rows);

		//$t->set_var("total_rowspan", ($total_rows + $total_errors + $use_first_row));
	} else if ($operation == "insert") {
		if($rnd != $session_rnd) {
			set_session("session_rnd", $rnd);
			$total_rows = get_param("total_rows");
			$total_columns = get_param("total_columns");

			$r = new VA_Record($table_name);
			if ($table == "items") {
				// administrative information
				$r->add_textbox("admin_id_added_by", INTEGER);
				$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
				$r->add_textbox("admin_id_modified_by", INTEGER);
				$r->add_textbox("date_added", DATETIME);
				$r->change_property("date_added", USE_IN_UPDATE, false);
				$r->add_textbox("date_modified", DATETIME);
				$r->set_value("admin_id_added_by", get_session("session_admin_id"));
				$r->set_value("admin_id_modified_by", get_session("session_admin_id"));
				$r->set_value("date_added", va_time());
				$r->set_value("date_modified", va_time());
			}
			foreach($db_columns as $column_name => $column_info) {
				if ($column_info[2] == WHERE_DB_FIELD) {
					$where_column = $column_name;
					$r->add_where($column_name, $column_info[1], $column_info[0]);
					$r->change_property($where_column, USE_IN_INSERT, true);
				} else if($column_info[2] > 1 && $column_info[3] == true) {
					$r->add_textbox($column_name, $column_info[1], $column_info[0]);
					$r->change_property($column_name, REQUIRED, true);
					if(isset($column_info[4]) && (is_array($column_info[4]) || strlen($column_info[4]))) {
						$r->set_value($column_name, $column_info[4]);
						$r->change_property($column_name, USE_IN_UPDATE, false);
					}
				} else if($column_info[2] == USUAL_DB_FIELD && $column_info[3] == false && isset($column_info[4])) {
					$r->add_textbox($column_name, $column_info[1], $column_info[0]);
					if (strlen($column_info[4])) {
						$r->set_value($column_name, $column_info[4]);
					} else {
						// don't put null values if there empty value
						$r->change_property($column_name, USE_SQL_NULL, false);
					}
				}
			}

			$imported_fields = "";
			$is_where = false; $related_fields = array();
			for($col = 1; $col <= $total_columns; $col++) {
				$column_name = get_param("db_column_" . $col);
				$column_value = get_param("db_value_" . $col);
				$imported_fields .= "," . $column_name;
				if($db_columns[$column_name][2] == WHERE_DB_FIELD) {
					$is_where = true;
				} else if ($db_columns[$column_name][2] == RELATED_DB_FIELD) {
					$related_fields[] = $col;
				} else {
					$r->add_textbox($column_name, $db_columns[$column_name][1], $db_columns[$column_name][0]);
					if ($db_columns[$column_name][1] == DATE) {
						$r->change_property($column_name, VALUE_MASK, $date_edit_format);
					} else if ($db_columns[$column_name][1] == DATETIME) {
						$r->change_property($column_name, VALUE_MASK, $datetime_edit_format);
					}
					$r->change_property($column_name, USE_IN_UPDATE, true);
					if($db_columns[$column_name][2] == USUAL_DB_FIELD && $db_columns[$column_name][3] == false && isset($db_columns[$column_name][4])) {
						if (!strlen($db_columns[$column_name][4])) {
							$r->change_property($column_name, USE_SQL_NULL, false);
						}
					}
				}
			}

			// get max property_id
			$sql  = " SELECT MAX(property_id) FROM " . $table_prefix . "items_properties ";
			$max_property_id = get_db_value($sql);

			$records_error = 0;
			$records_added = 0;
			$records_updated = 0;
			$records_ignored = 0;

			// start processing rows
			$is_next_row = false;
			$row = $use_first_row ? 1 : 2;
			if (strlen($csv_file_path)) {	
				$is_file_path = true;
				$fp = fopen($csv_file_path, "r");
				if ($fp) {
					if (!$use_first_row) {
						$data = fgetcsv($fp, 32768, $csv_delimiter);
					} 
					$data = fgetcsv($fp, 32768, $csv_delimiter);
					$is_next_row = is_array($data);
				} 
			} else {
				$is_next_row = ($row <= $total_rows);
			}

			// start processing rows
			while ($is_next_row) {

				$use_row = get_param("use_" . $row);
				$error_row = get_param("error_" . $row);
				if ($use_row == 1 && $error_row != 1) {
					$is_exists = get_param("is_exists_" . $row);

					$is_where_set = false;
					for($col = 1; $col <= $total_columns; $col++) {
						$field_name = "f_" . $row . "_" . $col;
						if ($is_file_path) {
							$field_value = isset($data[$col - 1]) ? $data[$col - 1] : "";
						} else {
							$field_value = get_param($field_name);
						}
						$column_name = get_param("db_column_" . $col);
			  		if ($is_where && $where_column == $column_name && strlen($field_value)) {
							$is_where_set = true;
						}
						if ($db_columns[$column_name][2] != RELATED_DB_FIELD) {
							/* allow to replace wrong digit separator
							if ($db_columns[$column_name][1] == FLOAT || $db_columns[$column_name][1] == NUMBER) {
								$field_value = str_replace(",", ".", $field_value);
								$field_value = str_replace(";", ".", $field_value);
							}//*/
							$r->set_value($column_name, $field_value);
						}
					}
			  
					$inserted_id = ""; $updated_id = "";				  
					if($is_exists) {
						if ($r->update_record()) {
							$records_updated++;
							$updated_id = $r->get_value($where_column);
						} else {
							$records_error++;
						}
					} else {
						if (!$is_where_set) {
							$sql = "SELECT MAX(" . $where_column . ") FROM " . $table_name . "";
							$db->query($sql);
							$db->next_record();
							$max_id = $db->f(0);
							$r->set_value($where_column, ($max_id + 1));
						} 
						if ($r->insert_record()) {
							$records_added++;
							$inserted_id = $r->get_value($where_column);
						} else {
							$records_error++;
						}
					} 

					// added data to related tables
					if(strlen($inserted_id) || strlen($updated_id))
					{
						$property_order = 0; $category_column = false;
						for ($ri = 0; $ri < sizeof($related_fields); $ri++) {
							$related_col = $related_fields[$ri];
							$column_name = get_param("db_column_" . $related_col);
							$column_value = get_param("db_value_" . $related_col);
							$related_table = $db_columns[$column_name][4];
							$related_field = "f_" . $row . "_" . $related_col;
							if ($is_file_path) {
								$related_value = isset($data[$related_col - 1]) ? $data[$related_col - 1] : "";
							} else {
								$related_value = get_param($related_field);
							}

							$item_id = strlen($inserted_id) ? $inserted_id : $updated_id;
							if ($related_table == $table_prefix . "items_properties") {
								update_items_properties($item_id, $related_value);
							} else if ($related_table == $table_prefix . "categories") {
								$category_column = true;
								update_items_categories($item_id, $related_value);
							} else if ($related_table == $table_prefix . "manufacturers") {
								update_manufacturer($item_id, $related_value);
							}
						}
					
						// added link to category
						if ($table_name == $table_prefix . "items" && !$category_column && strlen($inserted_id)) {
							$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id, category_id) ";
							$sql .= " VALUES (" . $db->tosql($inserted_id, INTEGER) . ", " . $db->tosql($category_id, INTEGER) . ") ";
							$db->query($sql);
						}
					}


				} else {
					$records_ignored++;
				}
				// check if there are more rows to process
				$row++;
				if ($is_file_path) {	
					$data = fgetcsv($fp, 32768, $csv_delimiter);
					$is_next_row = is_array($data);
				} else {
					$is_next_row = ($row <= $total_rows);
				}
			}
			// end processing rows
			if ($is_file_path) {	
				fclose($fp);
			}

			if ($table_name == $table_prefix . "categories") {
				prepare_categories_list();
				update_categories_tree(0, "");
			}

			set_session("session_records_error", $records_error);
			set_session("session_records_added", $records_added);
			set_session("session_records_updated", $records_updated);
			set_session("session_records_ignored", $records_ignored);

			$operation = "result";
		} else {
			$operation = "result";
		}
	}

	if(strlen($errors))
	{
		//$t->set_var("after_upload", "");
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("operation", $operation);
	$t->set_var("category_id", $category_id);
	$t->set_var("csv_file_path", htmlspecialchars($csv_file_path));
	$t->set_var("csv_delimiter", htmlspecialchars($csv_delimiter));

	$t->set_var("use_first_row", $use_first_row);
	$t->set_var("rnd", va_timestamp());

	$t->set_var("import_block", "");
	$t->set_var("insert_block", "");
	$t->set_var("upload_block", "");
	$t->set_var("result_block", "");
	if ($operation == "import") {
		$imported_fields = "";
		if ($table == "users") {
			$sql  = " SELECT imported_user_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
			$imported_fields = get_db_value($sql);
		} else if ($table == "items") {
			$sql  = " SELECT imported_item_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
			$imported_fields = get_db_value($sql);
		} 
		if (strlen($imported_fields)) {
			$t->set_var("imported_fields", htmlspecialchars($imported_fields));
			$t->parse("match_option", false);
		} else {
			$t->set_var("match_option", "");
		}
		$t->parse("import_block", false);
	} else if ($operation == "insert") {
		$t->parse("insert_block", false);
	} else if ($operation == "result") {
		$records_error = get_session("session_records_error");
		$records_added = get_session("session_records_added");
		$records_updated = get_session("session_records_updated");
		$records_ignored = get_session("session_records_ignored");

		if($records_error > 0) {
			$t->set_var("records_error", $records_error);	
			$t->parse("db_errors", $records_error);	
		}
		$t->set_var("records_added", $records_added);
		$t->set_var("records_updated", $records_updated);
		$t->set_var("records_ignored", $records_ignored);

		$t->parse("result_block", false);
	} else {
		$operation = "upload";
		$delimiters = array(array(",", "Comma"), array("\t", "Tab"), array(";", "Semicolon"));
		set_options($delimiters, $csv_delimiter, "delimiter");
		$t->parse("upload_block", false);
	}

	if ($table_name == ($table_prefix . "items") || $table_name == ($table_prefix . "categories")) {
		$t->parse("products_path", false);
	} else {
		$t->set_var("products_path", "");
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");


	function update_items_categories($item_id, $categories_info)
	{
		global $db, $table_prefix;

		$categories_info = trim($categories_info);
		$sql = " DELETE FROM " . $table_prefix . "items_categories WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$db->query($sql);

		$categories_list = explode(";", $categories_info);
		for ($i = 0; $i < sizeof($categories_list); $i++) {
			$category_info = $categories_list[$i];
			$categories_names = explode(">", $category_info);

			$last_category_id = 0; $category_path = "";
			for ($ci = 0; $ci < sizeof($categories_names); $ci++) {
			  $category_name = trim($categories_names[$ci]);
				if (strval($category_name) == "0") {
					$category_path = "0,";
				} else if (strlen($category_name)) {
					$category_path .= $last_category_id . ",";
					$sql  = " SELECT category_id FROM " . $table_prefix . "categories ";
					$sql .= " WHERE parent_category_id=" . $db->tosql($last_category_id, INTEGER);
					$sql .= " AND category_name=" . $db->tosql($category_name, TEXT);
					$db->query($sql);
					if ($db->next_record()) {
						$last_category_id = $db->f("category_id");
					} else {
						$parent_category_id = $last_category_id;
						$sql  = " SELECT MAX(category_id) FROM " . $table_prefix . "categories ";
						$last_category_id = get_db_value($sql) + 1;

						$sql  = " SELECT MAX(category_order) FROM " . $table_prefix . "categories ";
						$sql .= " WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER);
						$category_order = get_db_value($sql) + 1;

						$sql  = " INSERT INTO " . $table_prefix . "categories ";
						$sql .= " (category_id, parent_category_id, category_path, category_name, category_order, is_showing) VALUES (";
						$sql .= $db->tosql($last_category_id, INTEGER) . ", ";
						$sql .= $db->tosql($parent_category_id, INTEGER) . ", ";
						$sql .= $db->tosql($category_path, TEXT) . ", ";
						$sql .= $db->tosql($category_name, TEXT) . ", ";
						$sql .= $db->tosql($category_order, INTEGER) . ", 1) ";
						$db->query($sql);
					}
				}
			}

			if (strlen($category_path)) {
				$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id, category_id) ";
				$sql .= " VALUES (" . $db->tosql($item_id, INTEGER) . ", " . $db->tosql($last_category_id, INTEGER) . ") ";
				$db->query($sql);
			}
		}
	}

	function update_items_properties($item_id, $properties_info)
	{
		global $db, $table_prefix, $column_value, $property_order, $max_property_id;

		$properties_info = trim($properties_info);

		$property_id = "";
		$sql  = " SELECT property_id FROM " . $table_prefix . "items_properties ";
		$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$sql .= " AND property_name=" . $db->tosql($column_value, TEXT);
		$db->query($sql);
		if ($db->next_record()) {
			$property_id = $db->f("property_id");
			$sql = " DELETE FROM " . $table_prefix . "items_properties_values WHERE property_id=" . $db->tosql($property_id, INTEGER);
			$db->query($sql);
		}

		if (strlen($properties_info)) {
			if (strpos($properties_info, ";") === false) {
				$control_type = "LABEL";
				$property_description = $properties_info;
			} else {
				$control_type = "LISTBOX";
				$property_description = "";
			}
			if (strlen($property_id)) {
				$sql  = " UPDATE " . $table_prefix . "items_properties SET ";
				$sql .= " property_description=" . $db->tosql($property_description, TEXT) . ", ";
				$sql .= " control_type=" . $db->tosql($control_type, TEXT);
				$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
 				$db->query($sql);
			} else {
				$property_order++;
				$max_property_id++;
				$property_id = $max_property_id;
				$item_type_id = 0;
				
				$sql  = " INSERT INTO " . $table_prefix . "items_properties ";
				$sql .= " (property_id, item_id, item_type_id, property_order, property_name, property_description, control_type, required, use_on_list, use_on_details, use_on_checkout) VALUES (";
				$sql .= $db->tosql($property_id, INTEGER) . ", ";
				$sql .= $db->tosql($item_id, INTEGER) . ", ";
				$sql .= $db->tosql($item_type_id, INTEGER) . ", ";
				$sql .= $db->tosql($property_order, INTEGER) . ", ";
				$sql .= $db->tosql($column_value, TEXT) . ", ";
				$sql .= $db->tosql($property_description, TEXT) . ", ";
				$sql .= $db->tosql($control_type, TEXT) . ", ";
				$sql .= "0, 1, 1, 0) ";
				$db->query($sql);
			}


			if ($control_type == "LISTBOX") {
				$property_values = explode(";", $properties_info);
				for($pv = 0; $pv < sizeof($property_values); $pv++) {
					$property_value = trim($property_values[$pv]);
					$additional_price = "";
					if (preg_match("/^(.+)=\s*([\-\+]?[\d]*\.?[\d]*)$/", $property_value, $matches)) {
						$property_value = $matches[1];
						$additional_price = $matches[2];
					}
					if (strlen($property_value)) {
						$sql  = " INSERT INTO " . $table_prefix . "items_properties_values ";
						$sql .= " (property_id, property_value, additional_price, hide_out_of_stock, hide_value) VALUES (";
						$sql .= $db->tosql($property_id, INTEGER) . ", ";
						$sql .= $db->tosql($property_value, TEXT) . ", ";
						$sql .= $db->tosql($additional_price, NUMBER) . ", ";
						$sql .= "0, 0) ";
						$db->query($sql);
					}
				}
			}
		} else {
			$sql = " DELETE FROM " . $table_prefix . "items_properties WHERE property_id=" . $db->tosql($property_id, INTEGER);
			$db->query($sql);
		}
	}

	function update_manufacturer($item_id, $manufacturer_name)
	{
		global $db, $table_prefix;

		$manufacturer_id = "";
		if (strlen($manufacturer_name)) {
			$sql  = " SELECT manufacturer_id FROM " . $table_prefix . "manufacturers ";
			$sql .= " WHERE manufacturer_name=" . $db->tosql($manufacturer_name, TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$manufacturer_id = $db->f("manufacturer_id");
			} else {
				$sql  = " SELECT MAX(manufacturer_id) FROM " . $table_prefix . "manufacturers ";
				$manufacturer_id = get_db_value($sql) + 1;
				
				$sql  = " INSERT INTO " . $table_prefix . "manufacturers ";
				$sql .= " (manufacturer_id, manufacturer_name) VALUES (";
				$sql .= $db->tosql($manufacturer_id, INTEGER) . ", ";
				$sql .= $db->tosql($manufacturer_name, TEXT) . ") ";
				$db->query($sql);
			}
		}

		$sql  = " UPDATE " . $table_prefix . "items SET manufacturer_id=" . $db->tosql($manufacturer_id, INTEGER);
		$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$db->query($sql);
	}

	function prepare_categories_list()
	{
		global $db, $table_prefix, $categories;

		//-- parent items
		$sql  = " SELECT category_id, parent_category_id FROM " . $table_prefix . "categories ";
		$db->query($sql);
		while($db->next_record()) {
			$list_id = $db->f("category_id");
			$list_parent_id = $db->f("parent_category_id");
			$categories[$list_parent_id]["subs"][] = $list_id;
		}
	}

	function update_categories_tree($parent_category_id, $category_path)
	{
		global $db, $table_prefix, $categories;

		if (isset($categories[$parent_category_id]["subs"])) {
			$category_path .= $parent_category_id . ",";
  
			$subs = $categories[$parent_category_id]["subs"];
			for ($s = 0; $s < sizeof($subs); $s++) {
				$sub_id = $subs[$s];
      
				$sql  = " UPDATE " . $table_prefix . "categories SET ";
				$sql .= " category_path=" . $db->tosql($category_path, TEXT);
				$sql .= " WHERE category_id=" . $db->tosql($sub_id, INTEGER);
				$db->query($sql);
  
				if (isset($categories[$sub_id]["subs"])) {
					update_categories_tree($sub_id, $category_path);
				}
			}
		}

	}

?>