<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_invoice_pdf.php                                    ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/record.php");
	include_once($root_folder_path . "includes/order_items.php");
	include_once($root_folder_path . "includes/parameters.php");
	include_once($root_folder_path . "includes/pdflib.php");
	include_once($root_folder_path . "includes/pdf.php");
	include_once("../messages/".$language_code."/cart_messages.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("sales_orders");

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$product_code_checkout = get_setting_value($settings, "product_code_checkout", 0);

	// additional connection 
	$dbi = new VA_SQL();
	$dbi->DBType      = $db_type;
	$dbi->DBDatabase  = $db_name;
	$dbi->DBUser      = $db_user;
	$dbi->DBPassword  = $db_password;
	$dbi->DBHost      = $db_host;
	$dbi->DBPort      = $db_port;
	$dbi->DBPersistent= $db_persistent;

	$invoice = array();
	$sql = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='printable'";
	$db->query($sql);
	while ($db->next_record()) {
		$invoice[$db->f("setting_name")] = $db->f("setting_value");
	}

	$sql = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while ($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	$ids = get_param("ids");
	$order_id = get_param("order_id");
	if ($order_id) {
		$ids = $order_id;
	}

	$r = new VA_Record($table_prefix . "orders");
	$r->add_where("order_id", INTEGER);

	$personal_number = 0;
	$delivery_number = 0;
	for ($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$personal_param = "show_" . $parameters[$i];
		$delivery_param = "show_delivery_" . $parameters[$i];
		$r->add_textbox($parameters[$i], TEXT);
		$r->add_textbox("delivery_" . $parameters[$i], TEXT);
		if (isset($order_info[$personal_param]) && $order_info[$personal_param] == 1) {
			$personal_number++;
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if (isset($order_info[$delivery_param]) && $order_info[$delivery_param] == 1) {
			$delivery_number++;
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_textbox("user_id", INTEGER);
	$r->add_textbox("payment_id", INTEGER);
	$r->add_textbox("order_placed_date", DATETIME);
	$r->add_textbox("currency_code", TEXT);
	$r->add_textbox("currency_rate", NUMBER);
	$r->add_textbox("shipping_tracking_id", TEXT);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("cc_name", TEXT);
	$r->add_textbox("cc_first_name", TEXT);
	$r->add_textbox("cc_last_name", TEXT);
	$r->add_textbox("cc_number", TEXT);
	$r->add_textbox("cc_start_date", DATETIME);
	$r->change_property("cc_start_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_expiry_date", DATETIME);
	$r->change_property("cc_expiry_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_type", INTEGER);
	$r->add_textbox("cc_issue_number", INTEGER);
	$r->add_textbox("cc_security_code", TEXT);
	$r->add_textbox("pay_without_cc", TEXT);
	$r->add_textbox("tax_name", TEXT);
	$r->add_textbox("tax_percent", NUMBER);
	$r->add_textbox("tax_total", NUMBER);
	$r->add_textbox("total_discount", NUMBER);
	$r->add_textbox("shipping_type_desc", TEXT);
	$r->add_textbox("shipping_cost", NUMBER);
	$r->add_textbox("processing_fee", NUMBER);
	$r->add_textbox("order_total", NUMBER);

	// General PDF settings
	$pdf_library = isset($invoice["pdf_lib"]) ? $invoice["pdf_lib"] : 1;
	if ($pdf_library == 2) {
		$pdf = new VA_PDFLib();
	} else {
		$pdf = new VA_PDF();
	}
	$pdf->set_creator("admin_invoice_pdf.php");
	$pdf->set_author("ViArt Ltd");
	$pdf->set_title("Invoice No: " . $ids);
	$pdf->set_font_encoding(CHARSET);
	$page_number = 0;

	$order_ids = explode(",", $ids);
	for ($i = 0; $i < sizeof($order_ids); $i++) 
	{
		$id = $order_ids[$i];
		$r->set_value("order_id", $id);
		$r->get_db_values();

		$order_placed_date = $r->get_value("order_placed_date");
		$order_date = va_date($date_show_format, $order_placed_date);
		$tax_name = $r->get_value("tax_name");
		$tax_percent = $r->get_value("tax_percent");
		$tax_total = $r->get_value("tax_total");
		$total_discount = $r->get_value("total_discount");
		$shipping_type_desc = strip_tags(get_translation($r->get_value("shipping_type_desc")));
		$shipping_cost = $r->get_value("shipping_cost");
		$processing_fee = $db->f("processing_fee");
		$order_total = $r->get_value("order_total");

		$order_currency_code = $r->get_value("currency_code");
		$order_currency_rate = $r->get_value("currency_rate");

		$orders_currency = get_setting_value($settings, "orders_currency", 0);
		if ($orders_currency != 1) {
			$order_currency_left = $currency_left;
			$order_currency_right = $currency_right;
			if (strtolower($currency_code) != strtolower($order_currency_code)) {
				$order_currency_rate = $currency_rate;
			}
		} else {
			$order_currency = get_currency($order_currency_code);
			$order_currency_left = $order_currency["left"];
			$order_currency_right = $order_currency["right"];
		}
  
		$r->set_value("company_id", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($r->get_value("company_id"), INTEGER)));
		$r->set_value("state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("state_code"), TEXT)));
		$r->set_value("country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("country_code"), TEXT)));
		$r->set_value("delivery_company_id", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($r->get_value("delivery_company_id"), INTEGER)));
		$r->set_value("delivery_state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("delivery_state_code"), TEXT)));
		$r->set_value("delivery_country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("delivery_country_code"), TEXT)));
		$r->set_value("cc_type", get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($r->get_value("cc_type"), INTEGER)));
  
		begin_new_page();		
		set_invoice_header();
		set_user_info();
		set_table_header();
  
		$goods_total = 0; $goods_taxable = 0; $goods_tax_total = 0;
		$sql  = " SELECT * FROM " . $table_prefix . "orders_items ";
		$sql .= " WHERE order_id=" . $db->tosql($id, INTEGER);
		$db->query($sql);
		while ($db->next_record()) {
			if ($height_position < 200) {
				$pdf->end_page();
				begin_new_page();		
				set_table_header();
			}
  
			$order_item_id = $db->f("order_item_id");
			$quantity = $db->f("quantity");
			$item_name = strip_tags(get_translation($db->f("item_name")));
			$manufacturer_code = $db->f("manufacturer_code");

			$price = $db->f("price");
			$tax_free = $db->f("tax_free");
			$item_tax_percent = $db->f("tax_percent");
			$discount_amount = $db->f("discount_amount");
  
			$item_total = $price * $quantity;
			$goods_total += $item_total;
			if ($tax_free != 1)  {
				$goods_taxable += $item_total;
				if (!strlen($item_tax_percent)) {
					$item_tax_percent = $tax_percent;
				}
				$item_tax_total = round(($item_total * $item_tax_percent) / 100, 2);
				$goods_tax_total += $item_tax_total;
			} else {
				$item_tax_percent = 0;
				$item_tax_total = 0;
			}
  
			$price_formatted = $order_currency_left . number_format($price * $order_currency_rate, 2) . $order_currency_right;
			$total_formatted = $order_currency_left . number_format($item_total * $order_currency_rate, 2) . $order_currency_right;
			$tax_formatted = $order_currency_left . number_format($item_tax_total * $order_currency_rate, 2) . $order_currency_right;
  
  
			$pdf->setfont("helvetica", "", 9);
			$fontsize = 9; 
  
			$item_height = $pdf->show_xy($item_name, 85, $height_position - 2, 240, 0);
			// show product code
			if ($product_code_checkout && $manufacturer_code) {
				$pdf->setfont("helvetica", "", 8);
				$code_height = $pdf->show_xy(PROD_CODE_MSG .": " . $manufacturer_code, 85, $height_position - $item_height - 2, 240, 0);
				$item_height += $code_height;
				$pdf->setfont("helvetica", "", 9);
			}
			$item_height += 6;
  
			$pdf->show_xy($quantity, 40, $height_position - 2, 40, 0, "center");
  
			$pdf->setfont("helvetica", "", 8);
			if ($tax_percent > 0 || strlen($tax_name)) {
				$pdf->show_xy($price_formatted, 330, $height_position - 2, 58, 0, "right");
				$pdf->show_xy($total_formatted, 390, $height_position - 2, 58, 0, "right");
				$pdf->show_xy($item_tax_percent."%", 450, $height_position - 2, 50, 0, "center");
				$pdf->show_xy($tax_formatted, 500, $height_position - 2, 53, 0, "right");
			} else {
				$pdf->show_xy($price_formatted, 330, $height_position - 2, 105, 0, "right");
				$pdf->show_xy($total_formatted, 440, $height_position - 2, 110, 0, "right");
			}
			$height_position -= $item_height;
  
			$pdf->setfont("helvetica", "", 8);
			$properties_height = 0;
			$sql  = " SELECT property_name, property_value FROM " . $table_prefix . "orders_items_properties ";
			$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
			$dbi->query($sql);
			while ($dbi->next_record()) {
				$property_name = strip_tags(get_translation($dbi->f("property_name")));
				$property_value = strip_tags(get_translation($dbi->f("property_value")));
				$property_line = $property_name . ": " . $property_value;
				$property_height = $pdf->show_xy($property_line, 85, $height_position - $properties_height + 2, 230, 0);
				$properties_height += $property_height;
			}
			if ($properties_height > 0) {
				$properties_height += 2;
				$height_position -= $properties_height;
			}
  
			$pdf->setlinewidth(1.0);
			$pdf->rect (40, $height_position, 515, $item_height + $properties_height);
			if ($tax_percent > 0 || strlen($tax_name)) {
				$pdf->line( 80, $height_position, 80, $height_position + $item_height + $properties_height);
				$pdf->line( 330, $height_position, 330, $height_position + $item_height + $properties_height);
				$pdf->line( 390, $height_position, 390, $height_position + $item_height + $properties_height);
				$pdf->line( 450, $height_position, 450, $height_position + $item_height + $properties_height);
				$pdf->line( 500, $height_position, 500, $height_position + $item_height + $properties_height);
			} else {
				$pdf->line( 80, $height_position, 80, $height_position + $item_height + $properties_height);
				$pdf->line( 330, $height_position, 330, $height_position + $item_height + $properties_height);
				$pdf->line( 440, $height_position, 440, $height_position + $item_height + $properties_height);
			}
  
		}
  
		// set total
		$height_position -= 14;
		$goods_total_formatted = $order_currency_left . number_format($goods_total * $order_currency_rate, 2) . $order_currency_right;
		$goods_tax_formatted = $order_currency_left . number_format($goods_tax_total * $order_currency_rate, 2) . $order_currency_right;
  
		$pdf->setfont("helvetica", "B", 8);
  
		$pdf->rect (40, $height_position, 515, 14);
		if ($tax_percent > 0 || strlen($tax_name)) {
			$desc_length = 348;
			$price_start = 390;
			$price_length = 58;
			$pdf->line( 390, $height_position, 390, $height_position + 14);
			$pdf->line( 450, $height_position, 450, $height_position + 14);
			$pdf->line( 500, $height_position, 500, $height_position + 14);
			$pdf->show_xy("Total", 40, $height_position + 14, 348, 12, "right");
			$pdf->show_xy($goods_tax_formatted, 500, $height_position + 14, 53, 12, "right");
			$pdf->show_xy($goods_total_formatted, 390, $height_position + 14, 58, 12, "right");
		} else {
			$desc_length = 395;
			$price_start = 440;
			$price_length = 110;
			$pdf->line( 440, $height_position, 440, $height_position + 14);
			$pdf->show_xy("Total", 40, $height_position + 14, 395, 12, "right");
			$pdf->show_xy($goods_total_formatted, 440, $height_position + 14, 110, 12, "right");
		}
  
		$height_position -= 12;
  
		if ($total_discount > 0) {
			$total_discount_formatted = "-" . $order_currency_left . number_format($total_discount * $order_currency_rate, 2) . $order_currency_right;
			$pdf->show_xy(TOTAL_DISCOUNT_MSG, 40, $height_position, $desc_length, 0, "right");
			$pdf->show_xy($total_discount_formatted, $price_start, $height_position, $price_length, 0, "right");
			$height_position -= 12;
		} 
  
		$pdf->setfont("helvetica", "", 8);
		$sql  = " SELECT * FROM " . $table_prefix . "orders_properties ";
		$sql .= " WHERE order_id=" . $db->tosql($id, INTEGER);
		$sql .= " AND property_type=1 ";
		$sql .= " ORDER BY property_order, property_id ";
		$db->query($sql);
		while ($db->next_record()) {
			$property_name = strip_tags($db->f("property_name"));
			$property_value = strip_tags($db->f("property_value"));
			$property_price = $db->f("property_price");
			$property_line  = $property_name . " (" . $property_value . ")";
			$price_formatted = $order_currency_left . number_format($property_price * $order_currency_rate, 2) . $order_currency_right;
  
			$property_height = $pdf->show_xy($property_line, 40, $height_position, $desc_length, 0, "right");
			$pdf->show_xy($price_formatted, $price_start, $height_position, $price_length, 0, "right");
			$height_position -= ($property_height + 4);
		}
  
		$pdf->setfont("helvetica", "B", 8);
  
		if ($shipping_cost > 0 || strlen($shipping_type_desc)) {
			$shipping_cost_formatted = $order_currency_left . number_format($shipping_cost * $order_currency_rate, 2) . $order_currency_right;
			$pdf->show_xy($shipping_type_desc, 40, $height_position, $desc_length, 0, "right");
			$pdf->show_xy($shipping_cost_formatted, $price_start, $height_position, $price_length, 0, "right");
			$height_position -= 12;
		} 
  
		if ($tax_total > 0 || strlen($tax_name)) {
			$tax_total_formatted = $order_currency_left . number_format($tax_total * $order_currency_rate, 2) . $order_currency_right;
			$pdf->show_xy($tax_name, 40, $height_position, $desc_length, 0, "right");
			$pdf->show_xy($tax_total_formatted, $price_start, $height_position, $price_length, 0, "right");
			$height_position -= 12;
		} 
  
		if ($processing_fee != 0) {
			$processing_fee_formatted = $order_currency_left . number_format($processing_fee * $order_currency_rate, 2) . $order_currency_right;
			$pdf->show_xy(PROCESSING_FEE_MSG, 40, $height_position, $desc_length, 0, "right");
			$pdf->show_xy($processing_fee_formatted, $price_start, $height_position, $price_length, 0, "right");
			$height_position -= 12;
		} 
  
		$height_position -= 12;
		$order_total_formatted = $order_currency_left . number_format($order_total * $order_currency_rate, 2) . $order_currency_right;
		$pdf->setfont("helvetica", "BU", 8);
		$pdf->show_xy("TOTAL", 40, $height_position, $desc_length, 0, "right");
		$pdf->show_xy($order_total_formatted, $price_start, $height_position, $price_length, 0, "right");
		$height_position -= 12;
  
		set_invoice_footer();
		$pdf->end_page();
	}

	$buffer = $pdf->get_buffer();
	$length = strlen($buffer);

	$pdf_filename = "invoice_" . str_replace(",", "_", $ids) . ".pdf";
	header("Pragma: private");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: private", false);
	header("Content-Type: application/octet-stream"); 
	header("Content-Length: " . $length); 
	header("Content-Disposition: attachment; filename=" . $pdf_filename); 
	header("Content-Transfer-Encoding: binary"); 

	echo $buffer;


function begin_new_page()
{
	global $pdf, $page_number, $height_position;

	$page_number++;
	$pdf->begin_page(595, 842);
	$height_position = 800;

	$pdf->setfont ("helvetica", "", 8);
	if ($page_number > 1) {
		//$pdf->show_xy("- " . $page_number . " -", 40, 20, 555, 0, "center");
	}
}

function set_table_header()
{
	global $pdf, $height_position;
	global $tax_name, $tax_percent;

	$pdf->setlinewidth(1.0);
	
	$height_position -= 12;
	$pdf->rect ( 40, $height_position - 24, 515, 24);
	if ($tax_percent > 0 || strlen($tax_name)) {
		$pdf->line( 80, $height_position - 24, 80, $height_position);
		$pdf->line( 330, $height_position - 24, 330, $height_position);
		$pdf->line( 390, $height_position - 24, 390, $height_position);
		$pdf->line( 450, $height_position - 24, 450, $height_position);
		$pdf->line( 500, $height_position - 24, 500, $height_position);

		$pdf->setfont ("helvetica", "B", 9);
		$pdf->show_xy("Qty", 40, $height_position - 6, 40, 0, "center");
		$pdf->show_xy("Description", 80, $height_position - 6, 250, 0, "center");
		$pdf->show_xy("Price", 330, $height_position - 6, 60, 0, "center");
		$pdf->show_xy("Total", 390, $height_position, 60, 0, "center");
		$pdf->show_xy("Price", 390, $height_position - 12, 60, 0, "center");
		$pdf->show_xy($tax_name, 450, $height_position, 50, 0, "center");
		$pdf->show_xy("(%)", 450, $height_position - 12, 50, 0, "center");
		$pdf->show_xy($tax_name, 500, $height_position, 55, 0, "center");
		$pdf->show_xy("net", 500, $height_position - 12, 55, 0, "center");
	} else {
		$pdf->line( 80, $height_position - 24, 80, $height_position);
		$pdf->line( 330, $height_position - 24, 330, $height_position);
		$pdf->line( 440, $height_position - 24, 440, $height_position);

		$pdf->setfont ("helvetica", "B", 9);
		$pdf->show_xy("Qty", 40, $height_position - 6, 40, 0, "center");
		$pdf->show_xy("Description", 80, $height_position - 6, 250, 0, "center");
		$pdf->show_xy("Price", 330, $height_position - 6, 110, 0, "center");
		$pdf->show_xy("Total Price", 440, $height_position - 6, 115, 0, "center");

	}
	$height_position -= 24;
}


function set_user_info()
{
	global $pdf, $height_position;
	global $r, $parameters, $personal_number, $delivery_number;

	$pdf->setfont ("helvetica", "BU", 10);
	$height_position -= 24;
	$pdf->show_xy(INVOICE_TO_MSG.":", 40, $height_position, 250, 0, "left");
	if ($delivery_number > 0) {
		$pdf->show_xy(DELIVERY_TO_MSG.":", 300, $height_position, 250, 0, "left");
	}

	$personal_height = $height_position;
	$pdf->setfont("helvetica", "", 10);

	$name = "";
	if ($r->parameters["name"][SHOW]) {
		$name = $r->get_value("name");
	}
	if ($r->parameters["first_name"][SHOW] && $r->get_value("first_name")) {
		if ($name) { $name .= " "; }
		$name .= $r->get_value("first_name");
	}
	if ($r->parameters["last_name"][SHOW] && $r->get_value("last_name")) {
		if ($name) { $name .= " "; }
		$name .= $r->get_value("last_name");
	}

	if (strlen($name)) {
		$personal_height -= 12;
		$pdf->show_xy($name, 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["company_id"][SHOW] && $r->get_value("company_id")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("company_id"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["company_name"][SHOW] && $r->get_value("company_name")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("company_name"), 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["address1"][SHOW] && $r->get_value("address1")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("address1"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["address2"][SHOW] && $r->get_value("address2")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("address2"), 40, $personal_height, 250, 0, "left");
	}

	$city = ""; $address_line = "";
	if ($r->parameters["city"][SHOW]) {
		$city = $r->get_value("city");
	}
	if ($r->parameters["province"][SHOW]) {
		$address_line = $r->get_value("province");
	}
	if ($r->parameters["state_code"][SHOW] && $r->get_value("state_code")) {
		if ($address_line) { $address_line .= " "; }
		$address_line .= $r->get_value("state_code");
	}
	if ($r->parameters["zip"][SHOW] && $r->get_value("zip")) {
		if ($address_line) { $address_line .= " "; }
		$address_line .= $r->get_value("zip");
	}
	if ($city && $address_line) {
		$address_line = $city . ", " . $address_line;
	} elseif ($city) {
		$address_line = $city;
	}

	if (strlen($address_line)) {
		$personal_height -= 12;
		$pdf->show_xy($address_line, 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["country_code"][SHOW] && $r->get_value("country_code")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("country_code"), 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["phone"][SHOW] && !$r->is_empty("phone")) {
		$personal_height -= 12;
		$pdf->show_xy(PHONE_FIELD.": ".$r->get_value("phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["daytime_phone"][SHOW] && !$r->is_empty("daytime_phone")) {
		$personal_height -= 12;
		$pdf->show_xy(DAYTIME_PHONE_FIELD.": ".$r->get_value("daytime_phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["evening_phone"][SHOW] && !$r->is_empty("evening_phone")) {
		$personal_height -= 12;
		$pdf->show_xy(EVENING_PHONE_FIELD.": ".$r->get_value("evening_phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["cell_phone"][SHOW] && !$r->is_empty("cell_phone")) {
		$personal_height -= 12;
		$pdf->show_xy(CELL_PHONE_FIELD.": ".$r->get_value("cell_phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["fax"][SHOW] && !$r->is_empty("fax")) {
		$personal_height -= 12;
		$pdf->show_xy(FAX_FIELD.": ".$r->get_value("fax"), 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["email"][SHOW] && strlen($r->get_value("email"))) {
		$personal_height -= 12;
		$pdf->show_xy(EMAIL_FIELD.": " . $r->get_value("email"), 40, $personal_height, 250, 0, "left");
	}

	$delivery_height = $height_position;

	$delivery_name = "";
	if ($r->parameters["delivery_name"][SHOW]) {
		$delivery_name = $r->get_value("delivery_name");
	}
	if ($r->parameters["delivery_first_name"][SHOW] && $r->get_value("delivery_first_name")) {
		if ($delivery_name) { $delivery_name .= " "; }
		$delivery_name .= $r->get_value("delivery_first_name");
	}
	if ($r->parameters["delivery_last_name"][SHOW] && $r->get_value("delivery_last_name")) {
		if ($delivery_name) { $delivery_name .= " "; }
		$delivery_name .= $r->get_value("delivery_last_name");
	}

	if (strlen($delivery_name)) {
		$delivery_height -= 12;
		$pdf->show_xy($delivery_name, 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_company_id"][SHOW] && $r->get_value("delivery_company_id")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_company_id"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_company_name"][SHOW] && $r->get_value("delivery_company_name")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_company_name"), 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_address1"][SHOW] && $r->get_value("delivery_address1")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_address1"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_address2"][SHOW] && $r->get_value("delivery_address2")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_address2"), 300, $delivery_height, 250, 0, "left");
	}

	$delivery_city = ""; $delivery_address = "";
	if ($r->parameters["delivery_city"][SHOW]) {
		$delivery_city = $r->get_value("delivery_city");
	}
	if ($r->parameters["delivery_province"][SHOW]) {
		$delivery_address = $r->get_value("delivery_province");
	}
	if ($r->parameters["delivery_state_code"][SHOW] && $r->get_value("delivery_state_code")) {
		if ($delivery_address) { $delivery_address .= " "; }
		$delivery_address .= $r->get_value("delivery_state_code");
	}
	if ($r->parameters["delivery_zip"][SHOW] && $r->get_value("delivery_zip")) {
		if ($delivery_address) { $delivery_address .= " "; }
		$delivery_address .= $r->get_value("delivery_zip");
	}
	if ($delivery_city && $delivery_address) {
		$delivery_address = $delivery_city . ", " . $delivery_address;
	} elseif ($delivery_city) {
		$delivery_address = $delivery_city;
	}

	if (strlen($delivery_address)) {
		$delivery_height -= 12;
		$pdf->show_xy($delivery_address, 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_country_code"][SHOW] && $r->get_value("delivery_country_code")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_country_code"), 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_phone"][SHOW] && !$r->is_empty("delivery_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(PHONE_FIELD.": ".$r->get_value("delivery_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_daytime_phone"][SHOW] && !$r->is_empty("delivery_daytime_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(DAYTIME_PHONE_FIELD.": ".$r->get_value("delivery_daytime_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_evening_phone"][SHOW] && !$r->is_empty("delivery_evening_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(EVENING_PHONE_FIELD.": ".$r->get_value("delivery_evening_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_cell_phone"][SHOW] && !$r->is_empty("delivery_cell_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(CELL_PHONE_FIELD.": ".$r->get_value("delivery_cell_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_fax"][SHOW] && !$r->is_empty("delivery_fax")) {
		$delivery_height -= 12;
		$pdf->show_xy(FAX_FIELD.": ".$r->get_value("delivery_fax"), 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_email"][SHOW] && strlen($r->get_value("delivery_email"))) {
		$delivery_height -= 12;
		$pdf->show_xy(EMAIL_FIELD.": " . $r->get_value("delivery_email"), 300, $delivery_height, 250, 0, "left");
	}

	if ($personal_height > $delivery_height) {
		$height_position = $delivery_height;
	} else {
		$height_position = $personal_height;
	}
	$height_position -= 12;

}

function set_invoice_header()
{
	global $pdf, $height_position;
	global $invoice, $order_date, $id;

	$image_height = 0;
	$start_position = $height_position;
	if (isset($invoice["invoice_logo"]) && strlen($invoice["invoice_logo"])) {
		$image_path = $invoice["invoice_logo"];
		$image_size = @getimagesize($image_path);
		$image_width = $image_size[0];
		$image_height = $image_size[1];
		if ($image_width > 0 && $image_height > 0) {
			if (preg_match("/((\.jpeg)|(\.jpg))$/i", $image_path)) {
				$image_type = "jpeg";
			} elseif (preg_match("/(\.gif)$/i", $image_path)) {
				$image_type = "gif";
			} elseif (preg_match("/((\.tif)|(\.tiff))$/i", $image_path)) {
				$image_type = "tiff";
			} elseif (preg_match("/(\.png)$/i", $image_path)) {
				$image_type = "png";
			}
		  $pdf->place_image($image_path, 555 - $image_width, $height_position - $image_height, $image_type);
		}
	}

	if (isset($invoice["invoice_header"])) {
		$invoice_header = strip_tags($invoice["invoice_header"]);
		if (strlen($invoice_header)) {
			$pdf->setfont("helvetica", "", 10);
			$header_lines = explode("\n", $invoice_header);
			for ($i = 0; $i < sizeof($header_lines); $i++) {
				$header_line = $header_lines[$i];
				$line_height = $pdf->show_xy($header_line, 40, $height_position, 200, 0, "left");
				$height_position -= ($line_height + 2);
			}
		}
	}

	$height_position -= 12;
	$pdf->setfont("helvetica", "B", 10);
	$pdf->show_xy("Invoice Date:", 40, $height_position, 80, 0, "left");
	$pdf->setfont("helvetica", "", 10);
	$pdf->show_xy($order_date, 125, $height_position, 200, 0, "left");

	$height_position -= 12;
	$pdf->setfont("helvetica", "B", 10);
	$pdf->show_xy("Invoice Number:", 40, $height_position, 80, 0, "left");
	$pdf->setfont("helvetica", "", 10);
	$pdf->show_xy($id, 125, $height_position, 200, 0, "left");

	if ($height_position > ($start_position - $image_height)) {
		$height_position = $start_position - $image_height;
	}

}

function set_invoice_footer()
{
	global $pdf, $height_position;
	global $invoice, $order_date, $id;

	$pdf->setfont("helvetica", "", 8);
	if (isset($invoice["invoice_footer"])) {
		$invoice_footer = strip_tags($invoice["invoice_footer"]);
		if (strlen($invoice_footer)) {
			$footer_lines = explode("\n", $invoice_footer);
			$height_position = 40 + sizeof($footer_lines) * 10;
			for ($i = 0; $i < sizeof($footer_lines); $i++) {
				$height_position -= 10;
				$footer_line = $footer_lines[$i];
				$pdf->show_xy($footer_line, 40, $height_position, 555, 0, "center");
			}
		}
	}

}

?>