<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_item_prices.php                                    ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/editgrid.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");

	include_once($root_folder_path."messages/".$language_code."/cart_messages.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_item_prices.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_item_prices_href", "admin_item_prices.php");
	$t->set_var("admin_product_href", "admin_product.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$operation = get_param("operation");
	$item_id = get_param("item_id");
	$category_id = get_param("category_id");
	$feature_values = array();

	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin_items_list.php?category_id=" . urlencode($category_id);
	$errors = "";

	$sql = "SELECT item_type_id, item_name, price, sales_price, is_sales FROM " . $table_prefix . "items WHERE item_id=" . $db->tosql($item_id, INTEGER);
	$db->query($sql);
	if($db->next_record()) {
		$item_type_id = $db->f("item_type_id");
		$item_name = get_translation($db->f("item_name"));
		$initial_price = $db->f("price");
		$sales_price = $db->f("sales_price");
		$is_sales = $db->f("is_sales");
		if ($is_sales && $sales_price > 0) {
			$initial_price = $sales_price;
		}

		$t->set_var("initial_price", $currency_left . round($initial_price * $currency_rate, 2) . $currency_right);
		$t->set_var("item_name", htmlspecialchars($item_name));
	} else {
		header("Location: " . $return_page);
		exit;
	}

	// set up html form parameters
	$r = new VA_Record($table_prefix . "items_prices", "prices");
	$r->add_where("price_id", INTEGER);
	$r->add_hidden("item_id", INTEGER);
	$r->change_property("item_id", USE_IN_INSERT, true);

	$discount_actions = array(
		array("", ""),
		array(0, "Don't use the price if user/group discount available"),
		array(1, "Don't apply user/group discount to the price"),
		array(2, "Apply user/group discount to the price")
	);


	$r->add_checkbox("is_active", INTEGER, "Active");
	$r->add_textbox("min_quantity", INTEGER, "Min Quantity");
	$r->change_property("min_quantity", REQUIRED, true);
	$r->change_property("min_quantity", MIN_VALUE, 1);
	$r->change_property("min_quantity", BEFORE_VALIDATE, "check_item_quantity");
	$r->add_textbox("max_quantity", INTEGER, "Max Quantity");
	$r->change_property("max_quantity", REQUIRED, true);
	$r->change_property("max_quantity", MIN_VALUE, 1);
	$r->add_textbox("price", NUMBER, "Individual Price");
	$r->parameters["price"][REQUIRED] = true;
	$r->add_textbox("properties_discount", NUMBER, "Options Discount");

	$user_types = get_db_values("SELECT type_id, type_name FROM " . $table_prefix . "user_types ", array(array("", ""), array("0", "All Users")));
	$r->add_select("user_type_id", INTEGER, $user_types, "User Type");
	$r->parameters["user_type_id"][REQUIRED] = true;

	$r->add_radio("discount_action", NUMBER, $discount_actions, "Discount Settings");
	$r->parameters["discount_action"][REQUIRED] = true;

	$more_prices = get_param("more_prices");
	$number_prices = get_param("number_prices");

	$eg = new VA_EditGrid($r, "prices");
	$eg->get_form_values($number_prices);

	if(strlen($operation) && !$more_prices)
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $item_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "items_prices WHERE item_id=" . $db->tosql($item_id, INTEGER));		
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $eg->validate(); 

		if($is_valid)
		{
			$eg->set_values("item_id", $item_id);
			$eg->update_all($number_prices);
			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($item_id) && !$more_prices)
	{
		$eg->set_value("item_id", $item_id);
		$eg->change_property("price_id", USE_IN_SELECT, true);
		$eg->change_property("price_id", USE_IN_WHERE, false);
		$eg->change_property("item_id", USE_IN_WHERE, true);
		$eg->change_property("item_id", USE_IN_SELECT, true);
		$number_prices= $eg->get_db_values();
		if($number_prices == 0)
			$number_prices = 5;

	}
	else if($more_prices)
	{
		$number_prices += 5;
	}
	else
	{
		$number_prices = 5;
	}

	$t->set_var("number_prices", $number_prices);
	$eg->set_parameters_all($number_prices);

	$t->set_var("item_id", $item_id);
	$t->set_var("category_id", $category_id);
	$t->set_var("rp", htmlspecialchars($return_page));

	$t->pparse("main");

	function check_item_quantity()
	{
		global $eg;
		$user_type_id = $eg->record->get_value("user_type_id");
		if (strlen($user_type_id) && $user_type_id == "0") {
			$min_quantity = $eg->record->get_value("min_quantity");
			$max_quantity = $eg->record->get_value("max_quantity");
			if ($min_quantity == 1 || $max_quantity == 1) {
				$eg->record->errors .= "For '<b>All Users</b>' the quantity should be greater than '<b>1</b>'.<br>";
			}
		}
	}

?>