<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_item_type.php                                      ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	include_once($root_folder_path."messages/".$language_code."/cart_messages.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("product_types");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_item_type.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_item_types_href", "admin_item_types.php");
	$t->set_var("admin_item_type_href", "admin_item_type.php");

	$commission_types = array( 
		array("", ""), array(0, "Not available"), array(1, "Percentage per product/option selling price"), 
		array(2, "Amount per product"), array(3, "Percentage per product selling price"),
		array(4, "Percentage per (selling price - buying price)")
	);

	$r = new VA_Record($table_prefix . "item_types");
	$r->return_page = "admin_item_types.php";
	
	$r->add_where("item_type_id", INTEGER);

	$r->add_textbox("item_type_name", TEXT, "Type Name");
	$r->change_property("item_type_name", REQUIRED, true);
	$r->add_checkbox("is_gift_voucher", INTEGER);
	$r->add_checkbox("is_bundle", INTEGER);
	$r->add_checkbox("is_user", INTEGER);
	// commissions
	$r->add_select("merchant_fee_type", INTEGER, $commission_types);
	$r->add_textbox("merchant_fee_amount", NUMBER, "Merchant Fee Amount");
	$r->add_select("affiliate_commission_type", INTEGER, $commission_types);
	$r->add_textbox("affiliate_commission_amount", NUMBER, "Affiliate Commision Amount");
	$r->events[AFTER_DELETE] = "delete_type_data";

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");
	
	function delete_type_data()
	{
		global $r, $db, $table_prefix;

		$item_type_id = $r->get_value("item_type_id");

		// delete all properties
		$properties_ids = "";
		$sql = " SELECT property_id FROM " . $table_prefix ."items_properties WHERE item_type_id=" . $db->tosql($item_type_id, INTEGER); 
		$db->query($sql);
		while ($db->next_record()) {
			if(strlen($properties_ids)) { $properties_ids .= ","; }
			$properties_ids .= $db->f("property_id");
		}
		if (strlen($properties_ids)) {
			$db->query("DELETE FROM " . $table_prefix . "items_properties_values WHERE property_id IN (" . $db->tosql($properties_ids, TEXT, false) . ") ");
			$db->query("DELETE FROM " . $table_prefix . "items_properties WHERE item_type_id=" . $db->tosql($item_type_id, INTEGER)); 
		}

		// delete predefined specification
		$db->query("DELETE FROM " . $table_prefix . "features_default WHERE item_type_id=" . $db->tosql($item_type_id, INTEGER));		
	}

?>