<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_items_list.php                                     ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/shopping_cart.php");
	include_once ($root_folder_path . "includes/navigator.php");
	include_once ($root_folder_path . "includes/sorter.php");
	include_once ("../messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

	$operation = get_param("operation");
	$items_ids = get_param("items_ids");
	if ($operation == "delete_items" && strlen($items_ids)) {
		delete_products($items_ids);
	}


  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_items_list.html");

	// set files names
	$t->set_var("admin_items_list_href",       "admin_items_list.php");
	$t->set_var("admin_layout_page_href",      "admin_layout_page.php");
	$t->set_var("admin_reviews_href",          "admin_reviews.php");
	$t->set_var("admin_category_edit_href",    "admin_category_edit.php");
	$t->set_var("admin_product_href",          "admin_product.php");
	$t->set_var("admin_properties_href",       "admin_properties.php");
	$t->set_var("admin_releases_href",         "admin_releases.php");
	$t->set_var("admin_item_related_href",     "admin_item_related.php");
	$t->set_var("admin_item_categories_href",  "admin_item_categories.php");
	$t->set_var("admin_categories_order_href", "admin_categories_order.php");
	$t->set_var("admin_products_order_href",   "admin_products_order.php");
	$t->set_var("admin_default_properties_href", "admin_default_properties.php");
	$t->set_var("admin_item_types_href",       "admin_item_types.php");
	$t->set_var("admin_features_groups_href",  "admin_features_groups.php");
	$t->set_var("admin_item_prices_href",      "admin_item_prices.php");
	$t->set_var("admin_item_features_href",    "admin_item_features.php");
	$t->set_var("admin_item_images_href",      "admin_item_images.php");
	$t->set_var("admin_item_accessories_href", "admin_item_accessories.php");
	$t->set_var("admin_export_froogle_href",   "admin_export_froogle.php");
	$t->set_var("admin_search_href",           "admin_search.php");
	$t->set_var("admin_tell_friend_href",      "admin_tell_friend.php");
	$t->set_var("admin_products_edit_href",  "admin_products_edit.php");
	$t->set_var("PRODUCTS_TITLE",     PRODUCTS_TITLE);

	$t->set_var("admin_import_href", "admin_import.php");
	$t->set_var("admin_export_href", "admin_export.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";
	// get search parameters
	$s = trim(get_param("s"));
	$sc = get_param("sc");
	$sl = get_param("sl");
	$ss = get_param("ss");
	$ap = get_param("ap");
	$search = (strlen($s) || strlen($sl) || strlen($ss) || strlen($ap)) ? true : false;
	if($sc) { $category_id = $sc; }
	$sa = "";

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	$sql  = " SELECT full_description FROM " . $table_prefix . "categories WHERE category_id = " . $db->tosql($category_id, INTEGER);
	$db->query($sql);
	if($db->next_record())
		$t->set_var("full_description", $db->f("full_description"));
	else
		$t->set_var("full_description", "");

	$t->set_var("parent_category_id", $category_id);
	$sql  = " SELECT category_id,category_name ";
	$sql .= " FROM " . $table_prefix . "categories WHERE parent_category_id = " . $db->tosql($category_id, INTEGER);
	$sql .= " ORDER BY category_order ";
	$db->query($sql);
	if($db->next_record())
	{
		$t->parse("categories_order_link", false);
		$t->set_var("no_categories", "");
		do
		{
			$row_category_id = $db->f("category_id");
			$row_category_name = $db->f("category_name");
			$row_category_name = get_translation($row_category_name, $language_code);
			$t->set_var("category_id", $row_category_id);
			$t->set_var("category_name", $row_category_name);
			$t->parse("categories");
		} while ($db->next_record());
		$t->parse("categories_header", false);
	}
	else
	{
		$t->set_var("categories", "");
		$t->set_var("categories_order_link", "");
		$t->parse("no_categories");
	}

	$sorter = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_items_list.php");
	$sorter->set_parameters(false, true, true, false);
	$sorter->set_default_sorting(10, "asc");
	$sorter->set_sorter(PROD_TITLE_COLUMN, "sorter_item_name", 1, "item_name");
	$sorter->set_sorter(PROD_PRICE_COLUMN, "sorter_price", 2, "price");
	$sorter->set_sorter(PROD_QTY_COLUMN, "sorter_qty", 3, "stock_level");
	$sorter->set_sorter("Order", "sorter_order", 10, "item_order");

	$where = "";
	if($search && $category_id != 0) {
		$where .= " AND c.category_id = ic.category_id ";
		$where .= " AND (ic.category_id = " . $db->tosql($category_id, INTEGER);
		$where .= " OR c.category_path LIKE '" . $db->tosql($tree->get_path($category_id), TEXT, false) . "%')";
	} else if(!$search) {
		$where .= " AND ic.category_id = " . $db->tosql($category_id, INTEGER);
	}
	if($s) {
		$sa = split(" ", $s);
		for($si = 0; $si < sizeof($sa); $si++) {
			$sa[$si] = str_replace("%","\%",$sa[$si]);
			$where .= " AND (i.item_name LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%'";
			$where .= " OR i.manufacturer_code LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%')";
		}
	}
	if(strlen($sl)) {
		if ($sl == 1) {
			$where .= " AND (i.stock_level>0 OR i.stock_level IS NULL) ";
		} else {
			$where .= " AND i.stock_level<1 ";
		}
	}
	if(strlen($ss)) {
		if ($ss == 1) {
			$where .= " AND i.is_showing=1 ";
		} else {
			$where .= " AND i.is_showing=0 ";
		}
	}
	if(strlen($ap)) {
		if ($ap == 1) {
			$where .= " AND i.is_approved=1 ";
		} else {
			$where .= " AND i.is_approved=0 ";
		}
	}


	$total_records = 0;
	if (strtolower($db_type) == "mysql") {
		$sql  = " SELECT COUNT(DISTINCT i.item_id) ";
	} else {
		$sql  = " SELECT COUNT(*) ";
	}
	$sql .= " FROM ((" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_categories ic ON i.item_id=ic.item_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "categories c ON c.category_id = ic.category_id)";
	$sql .= " WHERE 1=1 ";
	$sql .= $where;
	$total_records = 0;
	if (strtolower($db_type) == "mysql") {
		$db->query($sql);
		$db->next_record();
		$total_records = $db->f(0);
	} else {
		$sql .= " GROUP BY i.item_id";
		$db->query($sql);
		while ($db->next_record()) {
			$total_records++;
		}
	}

	// set up variables for navigator
	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_items_list.php");
	$records_per_page = 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", MOVING, $pages_number, $records_per_page, $total_records, false);

	$sql  = " SELECT i.item_id ";
	$sql .= " FROM ((" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_categories ic ON i.item_id=ic.item_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "categories c ON c.category_id = ic.category_id)";
	$sql .= " WHERE 1=1 ";
	$sql .= $where;
	$sql .= " GROUP BY i.item_id, i.item_name, i.item_order, i.price, i.stock_level ";
	$sql .= $sorter->order_by;

	$items_ids = ""; 
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql);
	if ($db->next_record()) {
		$items_ids .= $db->f("item_id");
		while ($db->next_record()) {
			$items_ids .= "," . $db->f("item_id");
		}
	} else {
		$total_records = 0;
	}


	$item_index = 0;
	if ($total_records > 0) {
		$sql  = " SELECT i.item_id,i.item_name, i.price, i.sales_price, i.is_sales, i.stock_level ";
		$sql .= " FROM " . $table_prefix . "items i ";
		$sql .= " WHERE i.item_id IN (" . $items_ids . ") ";
		$sql .= $sorter->order_by;
		$db->query($sql);
		if($db->next_record())
		{
      $t->parse("edit_items_link", false);
      $t->parse("delete_items_link", false);
			$t->parse("products_order_link", false);
			$t->set_var("category_id", $category_id);
			$t->set_var("no_items", "");
			do
			{
				$item_index++;
				$item_id = $db->f("item_id");
				$product_category_id = $db->f("category_id");
				$item_name = get_translation($db->f("item_name"));
				$price = $db->f("price");
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f("sales_price");
				$stock_level = $db->f("stock_level");
  
				$price = calculate_price($price, $is_sales, $sales_price);
				$price = $price * $currency_rate;
  
				$t->set_var("item_id", $item_id);
				$t->set_var("item_index", $item_index);
				$t->set_var("product_category_id", $product_category_id);

				$item_name = htmlspecialchars($item_name);
				if(is_array($sa)) {
					for($si = 0; $si < sizeof($sa); $si++) {
						$regexp = "";
						for($si = 0; $si < sizeof($sa); $si++) {
							if(strlen($regexp)) $regexp .= "|";
							$regexp.=htmlspecialchars(str_replace(
								array( "/", "|",  "$", "^", "?", ".", "{", "}", "[", "]", "(", ")", "*"),
								array("\/","\|","\\$","\^","\?","\.","\{","\}","\[","\]","\(","\)","\*"),$sa[$si]));
						}
						if (strlen($regexp))
						{						
							$item_name = preg_replace ("/(" . $regexp . ")/i", "<font color=blue><b>\\1</b></font>", $item_name);
						}
					}
				}
				$t->set_var("item_name", $item_name);
				$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
				if ($stock_level < 0) {
					$stock_level = "<font color=red>" . $stock_level . "</font>";
				}
				$t->set_var("stock_level", $stock_level);
				$t->parse("items_list");
			} while ($db->next_record());
			$t->parse("items_header", false);
		}
	}

	if ($item_index < 1) {
		$t->set_var("delete_items_link", "");
		$t->set_var("products_order_link", "");
		$t->set_var("items_list", "");
		$t->parse("no_items");
	}

	if ($total_records > 0) {
		$admin_froogle_filtered_url = new VA_URL("admin_export_froogle.php", false);
		if ($search) {
			$admin_froogle_filtered_url->add_parameter("sc", GET, "sc");
		} else {
			$admin_froogle_filtered_url->add_parameter("sc", CONSTANT, $category_id);
		}
		$admin_froogle_filtered_url->add_parameter("sl", GET, "sl");
		$admin_froogle_filtered_url->add_parameter("sa", GET, "sa");
		$admin_froogle_filtered_url->add_parameter("ss", GET, "ss");
		$admin_froogle_filtered_url->add_parameter("ap", GET, "ap");
		$admin_froogle_filtered_url->add_parameter("s", GET, "s");

		$t->set_var("admin_froogle_filtered_url", $admin_froogle_filtered_url->get_url());
		$t->set_var("total_filtered", $total_records);
		$t->parse("froogle_filtered", false);
	}

	// set up search form parameters
	$stock_levels = 
		array( 
			array("", ""), array(0, "Out of stock products"), array(1, "In stock products")
		);
	$sales = 
		array( 
			array("", ""), array(0, "Not available for sales"), array(1, "Available for sales")
		);
	$aproved_values = 
		array( 
			array("", ""), array(0, NO_MSG), array(1, YES_MSG)
		);

	set_options($stock_levels, $sl, "sl");
	set_options($sales, $ss, "ss");
	set_options($aproved_values, $ap, "ap");
	$values_before[] = array("", "All Categories");
	if($category_id != 0) {
		$values_before[] = array($category_id, "Current Category");
	}

	$sql  = " SELECT category_id,category_name ";
	$sql .= " FROM " . $table_prefix . "categories WHERE parent_category_id = " . $db->tosql($category_id, INTEGER);
	$sql .= " ORDER BY category_order ";
	$sc_values = get_db_values($sql, $values_before);
	set_options($sc_values, $sc, "sc");
	$t->set_var("s", $s);
	if($search) {
		$t->parse("s_d", false);
	}

	$hidden_params["s"] = get_param("s");
	$hidden_params["sl"] = get_param("sl");
	$hidden_params["sc"] = get_param("sc");
	$hidden_params["sort_ord"] = get_param("sort_ord");
	$hidden_params["sort_dir"] = get_param("sort_dir");
	get_query_string($hidden_params, "", "", true);

	$t->set_var("items_number", $item_index);
	$t->parse("items_block", false);

	$t->pparse("main");

?>
