<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_layout.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/record.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("layouts");

	$set_layout_id = get_param("set_layout_id");
	if ($set_layout_id) {
		$sql  = " SELECT layout_id FROM " . $table_prefix . "layouts WHERE layout_id=" . intval($set_layout_id);
		$db->query($sql);
		if($db->next_record()) {
			$sql  = " UPDATE " . $table_prefix . "global_settings SET setting_value=" . intval($set_layout_id);
			$sql .= " WHERE setting_type='global' AND setting_name='layout_id'";
			$db->query($sql);
			set_session("session_settings", "");
		}
		header("Location: admin_layouts.php");
		exit;
	}

	$top_menu_types = 
		array( 
			array(0, "Don't show any links"), array(1, "Image links first"), array(2, "Text links first"), array(3, "Image and text links together")
		);


	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_layout.html");

	$t->set_var("admin_layout_href", "admin_layout.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_layouts_href", "admin_layouts.php");

	$r = new VA_Record($table_prefix . "layouts");
	$r->return_page = "admin_layouts.php";

	// load data to listbox
	$dir_index = 0;
	$directory_list_values[$dir_index] = array("", " --- Select from list --- ");
	$dir_index++;

	if ($dir = @opendir("../templates")) 
	{
		while ($file = readdir($dir)) 
		{
			if ($file != "." && $file != ".." && is_dir("../templates/" . $file) && $file != "admin") 
			{ 
				$directory_list_values[$dir_index] = array($file, $file);
				$dir_index++;
			} 
		}
	closedir($dir);
	}

	$r->add_where("layout_id", INTEGER);
	$r->change_property("layout_id", USE_IN_INSERT, true);
	$r->add_textbox("layout_name", TEXT);
	$r->add_textbox("style_name", TEXT);
	$r->add_radio("top_menu_type", INTEGER, $top_menu_types);
	$r->add_textbox("templates_dir", TEXT);
	$r->add_textbox("admin_templates_dir", TEXT);

	set_options($directory_list_values, "", "directory_list");

	$r->get_form_values();

	$operation = get_param("operation");
	$layout_id = get_param("layout_id");
	$return_page = "admin_layouts.php";

	if (strlen($operation))
	{
		if ($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		elseif ($operation == "delete" && $layout_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "layouts WHERE layout_id=" . $db->tosql($layout_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "header_links WHERE layout_id=" . $db->tosql($layout_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "page_settings WHERE layout_id=" . $db->tosql($layout_id, INTEGER));		
			header("Location: " . $return_page);
			exit;
		}
		if ($r->is_empty("layout_name"))
			$r->errors .= "Field <b>Layout Name</b> is required.<br>";

		if ($r->is_empty("templates_dir"))
		{
			$r->errors .= "Field <b>Templates Directory</b> is required.<br>";
		}
		elseif (!file_exists("../" . $r->get_value("templates_dir"))) 
		{
			$r->errors .= "Directory <b>" . $r->get_value("templates_dir") . "</b> doesn't exists.<br>";
		}

		if ($r->is_empty("admin_templates_dir")) 
		{
			$r->errors .= "Field <b>Admin Templates Directory</b> is required.<br>";
		}
		elseif (!file_exists($r->get_value("admin_templates_dir"))) 
		{
			$r->errors .= "Directory <b>" . $r->get_value("admin_templates_dir") . "</b> doesn't exists.<br>";
		}
		
		if (!strlen($r->errors))
		{
			if (strlen($r->get_value("layout_id")))
			{
				$r->update_record();
				set_session("session_settings", "");
			} else {
				$db->query("SELECT MAX(layout_id) FROM " . $table_prefix . "layouts");
				$db->next_record();
				$layout_id = $db->f(0) + 1;
				$r->set_value("layout_id", $layout_id);

				$r->insert_record();
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	elseif (strlen($r->get_value("layout_id")))
	{
		$r->get_db_values();
	}
	else // new layout (set default values)
	{
		$r->set_value("admin_templates_dir", "../templates/admin");
		$r->set_value("top_menu_type", 1);
	}

	$r->set_form_parameters();
	
	if (strlen($layout_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>