<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_manufacturer.php                                   ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("manufacturers");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_manufacturer.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->set_var("admin_manufacturers_href", "admin_manufacturers.php");
	$t->set_var("admin_manufacturer_href", "admin_manufacturer.php");
	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");

	$r = new VA_Record($table_prefix . "manufacturers");
	$r->return_page = "admin_manufacturers.php";

	$r->add_where("manufacturer_id", INTEGER);

	$r->add_textbox("manufacturer_name", TEXT, "Manufacturer Name");
	$r->change_property("manufacturer_name", REQUIRED, true);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("affiliate_code", TEXT, "Affiliate Code");
	$r->add_textbox("short_description", TEXT, "Short Description");
	$r->add_textbox("full_description", TEXT, "Full Description");
	$r->add_textbox("image_small", TEXT, "Small Image");
	$r->add_textbox("image_small_alt", TEXT, "Small Image Alt");
	$r->add_textbox("image_large", TEXT, "Large Image");
	$r->add_textbox("image_large_alt", TEXT, "Large Image Alt");

	$r->events[BEFORE_INSERT] = "set_friendly_url";
	$r->events[BEFORE_UPDATE] = "set_friendly_url";

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>
