<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_order_call.php                                     ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/editgrid.php");
	include_once($root_folder_path . "includes/record.php");
	include_once($root_folder_path . "includes/order_items.php");
	include_once($root_folder_path . "includes/order_links.php");
	include_once($root_folder_path . "includes/date_functions.php");
	include_once($root_folder_path . "includes/parameters.php");
	include_once("../messages/" . $language_code . "/cart_messages.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("create_orders");

	// additional connection to get options details
	$db_op = new VA_SQL();
	$db_op->DBType      = $db_type;
	$db_op->DBDatabase  = $db_name;
	$db_op->DBHost      = $db_host;
	$db_op->DBPort      = $db_port;
	$db_op->DBUser      = $db_user;
	$db_op->DBPassword  = $db_password;
	$db_op->DBPersistent= $db_persistent;

	// Order settings
	$order_info = array();
	$sql  = " SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while ($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}
	
	// Shipping settings
	$shipping_settings = array();
	$sql = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='shipping'";
	$db->query($sql);
	while ($db->next_record()) {
		$shipping_settings[$db->f("setting_name")] = $db->f("setting_value");
	}


	$permissions = get_permissions();
	$eol = get_eol();
	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$currency_code = $currency["code"];
	$currency_value = $currency["value"];

	$operation = get_param("operation");
	$order_id = get_param("order_id");
	$same_as_personal = get_param("same_as_personal");
	$shipping_type_id_param = get_param("shipping_type_id");
	$sc_errors = "";

	$t = new VA_Template($settings["admin_templates_dir"]);
	$r = new VA_Record($table_prefix . "orders");
	$r->return_page = "admin_orders.php";
	$r->add_where("order_id", INTEGER);

	$companies = get_db_values("SELECT company_id, company_name FROM " . $table_prefix . "companies ", array(array("", SELECT_COMPANY_MSG)));
	$states = get_db_values("SELECT state_code, state_name FROM " . $table_prefix . "states ORDER BY state_name ", array(array("", SELECT_STATE_MSG)));
	$countries = get_db_values("SELECT country_code, country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ", array(array("", SELECT_COUNTRY_MSG)));

	$r->add_textbox("name", TEXT, NAME_FIELD);
	$r->change_property("name", USE_SQL_NULL, false);
	$r->add_textbox("first_name", TEXT, FIRST_NAME_FIELD);
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->add_textbox("last_name", TEXT, LAST_NAME_FIELD);
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->add_select("company_id", INTEGER, $companies, COMPANY_SELECT_FIELD);
	$r->add_textbox("company_name", TEXT, COMPANY_NAME_FIELD);
	$r->add_textbox("email", TEXT, EMAIL_FIELD);
	$r->change_property("email", USE_SQL_NULL, false);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("address1", TEXT, STREET_FIRST_FIELD);
	$r->add_textbox("address2", TEXT, STREET_SECOND_FIELD);
	$r->add_textbox("city", TEXT, CITY_FIELD);
	$r->add_textbox("province", TEXT, PROVINCE_FIELD);
	$r->add_select("state_code", TEXT, $states, STATE_FIELD);
	$r->add_textbox("zip", TEXT, ZIP_FIELD);
	$r->add_select("country_code", TEXT, $countries, COUNTRY_FIELD);
	$r->add_textbox("phone", TEXT, PHONE_FIELD);
	$r->add_textbox("daytime_phone", TEXT, DAYTIME_PHONE_FIELD);
	$r->add_textbox("evening_phone", TEXT, EVENING_PHONE_FIELD);
	$r->add_textbox("cell_phone", TEXT, CELL_PHONE_FIELD);
	$r->add_textbox("fax", TEXT, FAX_FIELD);
	
	$r->add_textbox("delivery_name", TEXT, DELIVERY_MSG." ".NAME_FIELD);
	$r->add_textbox("delivery_first_name", TEXT, DELIVERY_MSG." ".FIRST_NAME_FIELD);
	$r->add_textbox("delivery_last_name", TEXT, DELIVERY_MSG." ".LAST_NAME_FIELD);
	$r->add_select("delivery_company_id", INTEGER, $companies, DELIVERY_MSG." ".COMPANY_SELECT_FIELD);
	$r->add_textbox("delivery_company_name", TEXT, DELIVERY_MSG." ".COMPANY_NAME_FIELD);
	$r->add_textbox("delivery_email", TEXT, DELIVERY_MSG." ".EMAIL_FIELD);
	$r->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("delivery_address1", TEXT, DELIVERY_MSG." ".STREET_FIRST_FIELD);
	$r->add_textbox("delivery_address2", TEXT, DELIVERY_MSG." ".STREET_SECOND_FIELD);
	$r->add_textbox("delivery_city", TEXT, DELIVERY_MSG." ".CITY_FIELD);
	$r->add_textbox("delivery_province", TEXT, DELIVERY_MSG." ".PROVINCE_FIELD);
	$r->add_select("delivery_state_code", TEXT, $states, DELIVERY_MSG." ".STATE_FIELD);
	$r->add_textbox("delivery_zip", TEXT, DELIVERY_MSG." ".ZIP_FIELD);
	$r->add_select("delivery_country_code", TEXT, $countries, DELIVERY_MSG." ".COUNTRY_FIELD);
	$r->add_textbox("delivery_phone", TEXT, DELIVERY_MSG." ".PHONE_FIELD);
	$r->add_textbox("delivery_daytime_phone", TEXT, DELIVERY_MSG." ".DAYTIME_PHONE_FIELD);
	$r->add_textbox("delivery_evening_phone", TEXT, DELIVERY_MSG." ".EVENING_PHONE_FIELD);
	$r->add_textbox("delivery_cell_phone", TEXT, DELIVERY_MSG." ".CELL_PHONE_FIELD);
	$r->add_textbox("delivery_fax", TEXT, DELIVERY_MSG." ".FAX_FIELD);
	
	$personal_number = 0;
	$delivery_number = 0;
	for ($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$personal_param = "call_center_show_" . $parameters[$i];
		$delivery_param = "call_center_show_delivery_" . $parameters[$i];
		if (isset($order_info[$personal_param]) && $order_info[$personal_param] == 1) {
			$personal_number++;
			if ($order_info["call_center_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters[$parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if (isset($order_info[$delivery_param]) && $order_info[$delivery_param] == 1) {
			$delivery_number++;
			if ($order_info["call_center_delivery_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters["delivery_" . $parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", array(array("", "Select Order Status")));
	$r->add_select("order_status", INTEGER, $order_statuses, "Order Status");
	$r->change_property("order_status", USE_SQL_NULL, false);
	//$r->change_property("order_status", REQUIRED, true);
	$r->add_textbox("affiliate_code", TEXT);
	$r->change_property("affiliate_code", USE_SQL_NULL, false);
	$r->add_textbox("coupons_ids", TEXT);
	$r->add_textbox("currency_code", TEXT);
	$r->add_textbox("currency_rate", FLOAT);
	$r->add_textbox("total_buying", NUMBER);
	$r->add_textbox("goods_total", NUMBER);
	//$r->add_textbox("goods_taxable", NUMBER);
	$r->add_textbox("total_quantity", NUMBER);
	$r->add_textbox("weight_total", NUMBER);
	$r->add_textbox("total_discount", NUMBER);
	$r->add_textbox("properties_total", NUMBER);
	$r->add_textbox("properties_taxable", NUMBER);
	$r->add_textbox("shipping_type_id", INTEGER);
	$r->add_textbox("shipping_type_desc", TEXT);
	$r->add_textbox("shipping_cost", NUMBER);
	$r->add_textbox("shipping_taxable", INTEGER);
	$r->add_textbox("shipping_expecting_date", DATETIME, SHIPPING_EXPECTING_MSG);
	$r->change_property("shipping_expecting_date", VALUE_MASK, $date_edit_format);
	$r->add_textbox("tax_name", TEXT);
	$r->add_textbox("tax_percent", NUMBER);
	$r->add_textbox("tax_total", NUMBER);
	$r->add_textbox("order_total", NUMBER);
	$r->add_textbox("order_placed_date", DATETIME);
	$r->change_property("order_placed_date", VALUE_MASK, $date_show_format);
	$r->change_property("order_placed_date", USE_IN_UPDATE, false);
	$r->add_textbox("transaction_id", TEXT);
	$r->add_textbox("error_message", TEXT);
	$r->add_textbox("pending_message", TEXT);
	$r->add_textbox("shipping_tracking_id", TEXT);
	$r->add_textbox("remote_address", TEXT);

	$r->add_textbox("user_id", INTEGER);
	$r->add_textbox("is_placed", INTEGER);
	$r->change_property("is_placed", USE_IN_UPDATE, false);
	$r->add_textbox("is_call_center", INTEGER);
	$r->change_property("is_call_center", USE_IN_UPDATE, false);

	// Credit card params
	$r->add_textbox("payment_id", INTEGER);
	$r->add_textbox("cc_name", TEXT, CC_NAME_FIELD);
	$r->add_textbox("cc_first_name", TEXT, CC_FIRST_NAME_FIELD);
	$r->add_textbox("cc_last_name", TEXT, CC_LAST_NAME_FIELD);
	$r->add_textbox("cc_number", TEXT, CC_NUMBER_FIELD);
	$r->change_property("cc_number", MIN_LENGTH, 10);
	$r->add_textbox("cc_start_date", DATETIME, CC_START_DATE_FIELD);
	$r->add_textbox("cc_expiry_date", DATETIME, CC_EXPIRY_DATE_FIELD);
	$credit_cards = get_db_values("SELECT credit_card_id, credit_card_name FROM " . $table_prefix . "credit_cards", array(array("", PLEASE_CHOOSE_MSG)));
	$r->add_select("cc_type", INTEGER, $credit_cards, CC_TYPE_FIELD);
	$issue_numbers = get_db_values("SELECT issue_number AS issue_value, issue_number AS issue_description FROM " . $table_prefix . "issue_numbers", array(array("", NOT_AVAILABLE_MSG)));
	$r->add_select("cc_issue_number", INTEGER, $issue_numbers, CC_ISSUE_NUMBER_FIELD);
	$r->add_textbox("cc_security_code", TEXT, CC_SECURITY_CODE_FIELD);
	$r->add_textbox("pay_without_cc", TEXT, PAY_WITHOUT_CC_FIELD);

	$t->set_file("main", "admin_order_call.html");
	$t->set_var("order_id", $order_id);
	$t->set_var("currency_left", htmlspecialchars($currency_left));
	$t->set_var("currency_right", htmlspecialchars($currency_right));
	$t->set_var("currency_rate", htmlspecialchars($currency_rate));

	$t->set_var("admin_href",               "admin.php");
	$t->set_var("admin_orders_href",        "admin_orders.php");
	$t->set_var("admin_order_href",         "admin_order.php");
	$t->set_var("admin_order_links_href",   "admin_order_links.php");
	$t->set_var("admin_order_serial_href",  "admin_order_serial.php");
	$t->set_var("admin_order_serials_href", "admin_order_serials.php");
	$t->set_var("admin_order_vouchers_href","admin_order_vouchers.php");
	$t->set_var("admin_user_href",          "admin_user.php");
	$t->set_var("admin_coupon_href",        "admin_coupon.php");
	$t->set_var("admin_coupons_href",       "admin_coupons.php");
	$t->set_var("admin_order_notes_href",   "admin_order_notes.php");
	$t->set_var("admin_order_email_href",   "admin_order_email.php");
	$t->set_var("admin_order_sms_href",     "admin_order_sms.php");
	$t->set_var("admin_order_item_href",    "admin_order_item.php");
	$t->set_var("admin_packing_html_href",  "admin_packing_html.php");
	$t->set_var("admin_packing_pdf_href",   "admin_packing_pdf.php");
	$t->set_var("cc_security_code_help_href", "../cc_security_code_help.php");
	$t->set_var("admin_order_product_select_href", "admin_order_product_select.php");
	$t->set_var("admin_order_user_select_href", "admin_order_user_select.php");
	$t->set_var("date_edit_format", join("", $date_edit_format));

	$t->set_var("NAME_FIELD",         NAME_FIELD);
	$t->set_var("FIRST_NAME_FIELD",   FIRST_NAME_FIELD);
	$t->set_var("LAST_NAME_FIELD",    LAST_NAME_FIELD);
	$t->set_var("COMPANY_SELECT_FIELD",COMPANY_SELECT_FIELD);
	$t->set_var("COMPANY_NAME_FIELD", COMPANY_NAME_FIELD);
	$t->set_var("EMAIL_FIELD",        EMAIL_FIELD);
	$t->set_var("STREET_FIRST_FIELD", STREET_FIRST_FIELD);
	$t->set_var("STREET_SECOND_FIELD",STREET_SECOND_FIELD);
	$t->set_var("CITY_FIELD",         CITY_FIELD);
	$t->set_var("PROVINCE_FIELD",     PROVINCE_FIELD);
	$t->set_var("STATE_FIELD",        STATE_FIELD);
	$t->set_var("ZIP_FIELD",          ZIP_FIELD);
	$t->set_var("COUNTRY_FIELD",      COUNTRY_FIELD);
	$t->set_var("PHONE_FIELD",        PHONE_FIELD);
	$t->set_var("DAYTIME_PHONE_FIELD",DAYTIME_PHONE_FIELD);
	$t->set_var("EVENING_PHONE_FIELD",EVENING_PHONE_FIELD);
	$t->set_var("CELL_PHONE_FIELD",   CELL_PHONE_FIELD);
	$t->set_var("FAX_FIELD",		  FAX_FIELD);

	$t->set_var("CC_NAME_FIELD",         CC_NAME_FIELD);
	$t->set_var("CC_NAME_DESC",          CC_NAME_DESC);
	$t->set_var("CC_FIRST_NAME_FIELD",   CC_FIRST_NAME_FIELD);
	$t->set_var("CC_LAST_NAME_FIELD",    CC_LAST_NAME_FIELD);
	$t->set_var("CC_NUMBER_FIELD",       CC_NUMBER_FIELD);
	$t->set_var("CC_START_DATE_FIELD",   CC_START_DATE_FIELD);
	$t->set_var("CC_EXPIRY_DATE_FIELD",  CC_EXPIRY_DATE_FIELD);
	$t->set_var("CC_TYPE_FIELD",         CC_TYPE_FIELD);
	$t->set_var("CC_ISSUE_NUMBER_FIELD", CC_ISSUE_NUMBER_FIELD);
	$t->set_var("CC_ISSUE_NUMBER_DESC",  CC_ISSUE_NUMBER_DESC);
	$t->set_var("CC_SECURITY_CODE_FIELD",CC_SECURITY_CODE_FIELD);
	$t->set_var("CC_SECURITY_CODE_HELP_MSG",CC_SECURITY_CODE_HELP_MSG);
	$t->set_var("PAY_WITHOUT_CC_MSG",    PAY_WITHOUT_CC_MSG);
	$t->set_var("PAY_WITHOUT_CC_FIELD",  PAY_WITHOUT_CC_FIELD);
	$t->set_var("PAY_WITHOUT_CC_DESC",   PAY_WITHOUT_CC_DESC);
	$t->set_var("PAYMENT_GATEWAY_MSG",   PAYMENT_GATEWAY_MSG);

	$t->set_var("CART_TITLE",          CART_TITLE);
	$t->set_var("PRODUCTS_TITLE",      PRODUCTS_TITLE);
	$t->set_var("EMPTY_CART_MSG",      EMPTY_CART_MSG);     
	$t->set_var("PROD_TITLE_COLUMN",   PROD_TITLE_COLUMN);     
	$t->set_var("PROD_QTY_COLUMN",     PROD_QTY_COLUMN);         
	$t->set_var("PROD_PRICE_COLUMN",   PROD_PRICE_COLUMN);       
	$t->set_var("PROD_TOTAL_COLUMN",   PROD_TOTAL_COLUMN);  
	$t->set_var("GOODS_TOTAL_MSG",     GOODS_TOTAL_MSG); 
	$t->set_var("TOTAL_DISCOUNT_MSG",  TOTAL_DISCOUNT_MSG); 
	$t->set_var("GOODS_WITH_DISCOUNT_MSG", GOODS_WITH_DISCOUNT_MSG); 
	$t->set_var("CART_TOTAL_MSG",      CART_TOTAL_MSG);     
	$t->set_var("COUPON_MSG",          COUPON_MSG);     
	$t->set_var("ORDER_NUMBER_MSG",    ORDER_NUMBER_MSG);
	$t->set_var("ORDER_DATE_MSG",      ORDER_DATE_MSG);
	$t->set_var("SHIPPING_EXPECTING_MSG", SHIPPING_EXPECTING_MSG);
	$t->set_var("COUPON_CODE_FIELD",   COUPON_CODE_FIELD);

	$t->set_var("SELECT_PAYMENT_MSG", SELECT_PAYMENT_MSG);
	$t->set_var("PERSONAL_DETAILS_MSG", PERSONAL_DETAILS_MSG);
	$t->set_var("DELIVERY_DETAILS_MSG", DELIVERY_DETAILS_MSG);
	$t->set_var("PAYMENT_DETAILS_MSG",  PAYMENT_DETAILS_MSG);
	$t->set_var("DELIVERY_MSG",         DELIVERY_MSG);
	$t->set_var("INVOICE_TO_MSG",       INVOICE_TO_MSG);
	$t->set_var("DELIVERY_TO_MSG",      DELIVERY_TO_MSG);

	$t->set_var("SAME_DETAILS_MSG",   SAME_DETAILS_MSG);
	$t->set_var("REGISTER_BUTTON",    REGISTER_BUTTON);
	$t->set_var("UPDATE_BUTTON",      UPDATE_BUTTON);
	$t->set_var("CANCEL_BUTTON",      CANCEL_BUTTON);
	$t->set_var("LOGIN_FIELD",        LOGIN_FIELD);
	$t->set_var("PASSWORD_FIELD",     PASSWORD_FIELD);
	$t->set_var("CONFIRM_PASS_FIELD", CONFIRM_PASS_FIELD);

	// Get payment_id used for Call Center
	$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems WHERE is_call_center=1";
	$payment_id = get_db_value($sql);

	// Get CC settings
	$cc_info = array();
	if (strlen($payment_id)) {
		$setting_type = "credit_card_info_" . $payment_id;
		$sql  = " SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
		$db->query($sql);
		while ($db->next_record()) {
			$cc_info[$db->f("setting_name")] = $db->f("setting_value");
		}
	} else { // exit if there is no payment system to process orders
		$t->set_var("errors_list", "Please select a Payment System that you will use for processing orders in Call Center");
		$t->parse("errors", false);
		include_once("./admin_header.php");
		include_once("./admin_footer.php");
		$t->pparse("main");
		exit;
	}

	$payment_params = 0;
	for ($i = 0; $i < sizeof($cc_parameters); $i++)
	{                                    
		$payment_param = "call_center_show_" . $cc_parameters[$i];
		if (isset($cc_info[$payment_param]) && $cc_info[$payment_param] == 1) {
			$payment_params++;
			if ($cc_info["call_center_" . $cc_parameters[$i] . "_required"] == 1) {
				$r->parameters[$cc_parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$cc_parameters[$i]][SHOW] = false;
		}
	}
	$cc_number_split = get_setting_value($cc_info, "cc_number_split", 1);
	$cc_number_security = get_setting_value($cc_info, "cc_number_security", 1);
	$cc_code_security = get_setting_value($cc_info, "cc_code_security", 1);

	$r->get_form_values();


	$oi = new VA_Record($table_prefix . "orders_items", "items");
	$oi->add_where("order_item_id", INTEGER);
	$oi->add_hidden("order_id", INTEGER);
	$oi->change_property("order_id", USE_IN_INSERT, true);
	$oi->add_hidden("item_status", INTEGER);
	$oi->change_property("item_status", USE_IN_INSERT, true);
	$oi->change_property("item_status", USE_IN_UPDATE, true);
	$oi->change_property("item_status", USE_SQL_NULL, false);
	$oi->add_textbox("item_id", TEXT, "Item ID");
	$oi->change_property("item_id", REQUIRED, true);
	$oi->add_textbox("item_name", TEXT, "Item Name");
	$oi->change_property("item_name", REQUIRED, true);
	$oi->add_textbox("manufacturer_code", TEXT, "Item Code");
	$oi->add_textbox("quantity", INTEGER, "Quantity");
	$oi->change_property("quantity", REQUIRED, true);
	$oi->add_textbox("buying_price", NUMBER, "Price Each");
	$oi->add_textbox("price", NUMBER, "Price Each");
	$oi->add_textbox("weight", NUMBER, "Item Weight");
	
	$more_items = get_param("more_items");
	$number_items = get_param("number_items");

	$eg = new VA_EditGrid($oi, "items");
	$eg->get_form_values($number_items);
	
	$op = new VA_Record($table_prefix . "orders_properties");
	$op->add_textbox("order_id", INTEGER);
	$op->add_textbox("property_id", INTEGER);
	$op->add_textbox("property_order", INTEGER);
	$op->add_textbox("property_type", INTEGER);
	$op->add_textbox("property_name", TEXT);
	$op->add_textbox("property_value", TEXT);
	$op->add_textbox("property_price", FLOAT);
	$op->add_textbox("property_weight", FLOAT);
	$op->add_textbox("tax_free", INTEGER);


	$items = array(); $order_coupons_ids = ""; $gift_vouchers = array();

	$total_buying = 0; $goods_total = 0; $goods_taxable = 0;
	$total_items = 0; $total_quantity = 0; $weight_total = 0; 
	$total_discount = 0; 
	$order_total = 0;
	$max_availability_time = 0; $shipping_time = 0; $processing_time = 0;
	$free_postage = false; $tax_free = false; $use_taxes = true;

	$cc_start_year   = get_param("cc_start_year");
	$cc_start_month  = get_param("cc_start_month");
	$cc_expiry_year  = get_param("cc_expiry_year");
	$cc_expiry_month = get_param("cc_expiry_month");

	if (strlen($cc_start_year) && strlen($cc_start_month)) {
		$r->set_value("cc_start_date", array($cc_start_year, $cc_start_month, 1, 0, 0, 0));
	}

	if (strlen($cc_expiry_year) && strlen($cc_expiry_month)) {
		$r->set_value("cc_expiry_date", array($cc_expiry_year, $cc_expiry_month, 1, 0, 0, 0));
	}

	// Prepare custom options 
	$options_errors = "";
	$properties_total = 0; $properties_taxable = 0;
	$personal_properties = 0; $delivery_properties = 0; $payment_properties = 0;
	$custom_options = array();
	$vat_parameter = "";
	$sql  = " SELECT * ";
	$sql .= " FROM " . $table_prefix . "order_custom_properties ";
	$sql .= " WHERE (property_type IN (1,2,3) OR (property_type=4 AND payment_id=" . $db->tosql($payment_id, INTEGER) . ")) AND property_show IN (0,2) ";
	$sql .= " ORDER BY property_order, property_id ";
	$db->query($sql);
	if ($db->next_record()) {
		$order_properties = ""; $op_rows = array(); $rn = 0;
		do {
			$op_rows[$rn]["property_id"] = $db->f("property_id");
			$op_rows[$rn]["property_order"] = $db->f("property_order");
			$op_rows[$rn]["property_name"] = $db->f("property_name");
			$op_rows[$rn]["property_description"] = $db->f("property_description");
			$op_rows[$rn]["default_value"] = $db->f("default_value");
			$op_rows[$rn]["property_type"] = $db->f("property_type");
			$op_rows[$rn]["property_style"] = $db->f("property_style");
			$op_rows[$rn]["control_type"] = $db->f("control_type");
			$op_rows[$rn]["control_style"] = $db->f("control_style");
			$op_rows[$rn]["required"] = $db->f("required");
			$op_rows[$rn]["tax_free"] = $db->f("tax_free");
			$op_rows[$rn]["before_name_html"] = $db->f("before_name_html");
			$op_rows[$rn]["after_name_html"] = $db->f("after_name_html");
			$op_rows[$rn]["before_control_html"] = $db->f("before_control_html");
			$op_rows[$rn]["after_control_html"] = $db->f("after_control_html");
			$op_rows[$rn]["onchange_code"] = $db->f("onchange_code");
			$op_rows[$rn]["onclick_code"] = $db->f("onclick_code");
			$op_rows[$rn]["control_code"] = $db->f("control_code");

			$rn++;
		} while ($db->next_record());

		for ($rn = 0; $rn < sizeof($op_rows); $rn++) {
			$property_id = $op_rows[$rn]["property_id"];
			$property_order  = $op_rows[$rn]["property_order"];
			$property_name_initial = $op_rows[$rn]["property_name"];
			$property_name = get_translation($property_name_initial);
			$property_description = $op_rows[$rn]["property_description"];
			$default_value = $op_rows[$rn]["default_value"];
			$property_type = $op_rows[$rn]["property_type"];
			$property_style = $op_rows[$rn]["property_style"];
			$control_type = $op_rows[$rn]["control_type"];
			$control_style = $op_rows[$rn]["control_style"];
			$property_required = $op_rows[$rn]["required"];
			$property_tax_free = $op_rows[$rn]["tax_free"];
			$before_name_html = $op_rows[$rn]["before_name_html"];
			$after_name_html = $op_rows[$rn]["after_name_html"];
			$before_control_html = $op_rows[$rn]["before_control_html"];
			$after_control_html = $op_rows[$rn]["after_control_html"];
			$onchange_code = $op_rows[$rn]["onchange_code"];
			$onclick_code = $op_rows[$rn]["onclick_code"];
			$control_code = $op_rows[$rn]["control_code"];

			if (preg_match("/vat/i", $property_name_initial)) {
				$vat_parameter = "op_" . $property_id;
			}

			if ($property_type > 0) {
				if (strlen($order_properties)) { $order_properties .= ","; }
				$order_properties .= $property_id;
			}

			$selected_price = 0;
			$property_control  = "";
			$property_control .= "<input type=\"hidden\" name=\"op_name_" . $property_id . "\"";
			$property_control .= " value=\"" . strip_tags($property_name) . "\">";
			$property_control .= "<input type=\"hidden\" name=\"op_required_" . $property_id . "\"";
			$property_control .= " value=\"" . intval($property_required) . "\">";
			$property_control .= "<input type=\"hidden\" name=\"op_control_" . $property_id . "\"";
			$property_control .= " value=\"" . strtoupper($control_type) . "\">";
			$property_control .= "<input type=\"hidden\" name=\"op_tax_free_" . $property_id . "\"";
			$property_control .= " value=\"" . intval($property_tax_free) . "\">";
			

			$sql  = " SELECT * FROM " . $table_prefix . "order_custom_values ";
			$sql .= " WHERE property_id=" . $property_id . " AND hide_value=0";
			$sql .= " ORDER BY property_value_id ";
			if (strtoupper($control_type) == "LISTBOX") {
				$selected_value = get_param("op_" . $property_id);
				$properties_prices = "";
				$properties_values = "<option value=\"\">" . SELECT_MSG . " " . $property_name . "</option>" . $eol;
				$db->query($sql);
				while ($db->next_record())
				{
					$property_value = get_translation($db->f("property_value"));
					$property_price = $db->f("property_price");
					$property_value_id = $db->f("property_value_id");
					$is_default_value = $db->f("is_default_value");
					$property_selected  = "";
					$properties_prices .= "<input type=\"hidden\" name=\"op_option_price_" . $property_value_id . "\"";
					$properties_prices .= " value=\"" . $property_price . "\">";
					if (strlen($operation)) {
						if ($selected_value == $property_value_id) {
							$property_selected  = "selected ";
							$selected_price    += $property_price;
							$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $property_value, $selected_price, $property_tax_free);
						}
					} elseif ($is_default_value) {
						$property_selected  = "selected ";
						$selected_price    += $property_price;
					} 

					$properties_values .= "<option " . $property_selected . "value=\"" . htmlspecialchars($property_value_id) . "\">";
					$properties_values .= htmlspecialchars($property_value);
					if ($property_price > 0)
						$properties_values .= " (+ " . $currency_left . number_format($property_price * $currency_rate, 2) . $currency_right . ")";
					elseif ($property_price < 0)
						$properties_values .= " (- " . $currency_left . number_format(abs($property_price * $currency_rate), 2) . $currency_right . ")";
					$properties_values .= "</option>" . $eol;
				}
				$property_control .= $before_control_html;
				$property_control .= "<select name=\"op_" . $property_id . "\" onChange=\"changeProperty(document.record);";
				if ($onchange_code) {	$property_control .= $onchange_code; }
				$property_control .= "\"";
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				$property_control .= ">" . $properties_values . "</select>";
				$property_control .= $properties_prices;
				$property_control .= $after_control_html;
			} elseif (strtoupper($control_type) == "RADIOBUTTON" || strtoupper($control_type) == "CHECKBOXLIST") {
				$is_radio = (strtoupper($control_type) == "RADIOBUTTON");

				$selected_value = array();
				if (strlen($operation)) {
					if ($is_radio) {
						$selected_value[] = get_param("op_" . $property_id);
					} else {
						$total_options = get_param("op_total_" . $property_id);
						for ($op = 1; $op <= $total_options; $op++) {
							$selected_value[] = get_param("op_" . $property_id . "_" . $op);
						}
					}
				}

				$input_type = $is_radio ? "radio" : "checkbox";
				$property_control .= "<span";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				$property_control .= ">";
				$value_number = 0;
				$db->query($sql);
				while ($db->next_record())
				{
					$value_number++;
					$property_price = $db->f("property_price");
					$property_value_id = $db->f("property_value_id");
					$manufacturer_code = $db->f("manufacturer_code");
					$is_default_value = $db->f("is_default_value");
					$property_value = get_translation($db->f("property_value"));
					$property_checked = "";
					$property_control .= $before_control_html;
					$property_control .= "<input type=\"hidden\" name=\"op_option_price_" . $property_value_id . "\"";
					$property_control .= " value=\"" . $property_price . "\">";
					if (strlen($operation)) {
						if (in_array($property_value_id, $selected_value)) {
							$property_checked = "checked ";
							$selected_price  += $property_price;
							if (isset($custom_options[$property_id])) {
								$custom_options[$property_id][3] .= "; " . $property_value;
								$custom_options[$property_id][4] = $selected_price;
							} else {
								$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $property_value, $selected_price, $property_tax_free);
							}
						}
					} elseif ($is_default_value) {
						$property_checked = "checked ";
						$selected_price  += $property_price;
					} 

					$control_name = ($is_radio) ? ("op_".$property_id) : ("op_".$property_id."_".$value_number);
					$property_control .= "<input type=\"" . $input_type . "\" name=\"" . $control_name . "\" ". $property_checked;
					$property_control .= "value=\"" . htmlspecialchars($property_value_id) . "\" onClick=\"changeProperty(document.record); ";
					if ($onclick_code) {	
						$control_onclick_code = str_replace("{option_value}", $property_value, $onclick_code);
						$property_control .= $control_onclick_code; 
					}
					$property_control .= "\"";
					if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
					if ($control_code) {	$property_control .= " " . $control_code . " "; }
					$property_control .= ">";
					$property_control .= $property_value;
					if ($property_price > 0)
						$property_control .= " (+ " . $currency_left . number_format($property_price * $currency_rate, 2) . $currency_right . ")";
					elseif ($property_price < 0)
						$property_control .= " (- " . $currency_left . number_format(abs($property_price * $currency_rate), 2) . $currency_right . ")";
					$property_control .= $after_control_html;
				}
				$property_control .= "</span>";
				$property_control .= "<input type=\"hidden\" name=\"op_total_".$property_id."\" value=\"".$value_number."\">";
			} elseif (strtoupper($control_type) == "TEXTBOX") {
				if (strlen($operation)) {
					$control_value = get_param("op_" . $property_id);
					if (strlen($control_value)) {
						$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $control_value, 0, 0);
					}
				} else {
					$control_value = $default_value;
				}
				$property_control .= $before_control_html;
				$property_control .= "<input type=\"text\" name=\"op_" . $property_id . "\"";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				$property_control .= " value=\"". htmlspecialchars($control_value) . "\">";
				$property_control .= $after_control_html;
			} elseif (strtoupper($control_type) == "TEXTAREA") {
				if (strlen($operation)) {
					$control_value = get_param("op_" . $property_id);
					if (strlen($control_value)) {
						$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $control_value, 0, 0);
					}
				} else {
					$control_value = $default_value;
				}
				$property_control .= $before_control_html;
				$property_control .= "<textarea name=\"op_" . $property_id . "\"";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				$property_control .= ">". htmlspecialchars($control_value) ."</textarea>";
				$property_control .= $after_control_html;
			} else {
				$property_control .= $before_control_html;
				if ($property_required) {
					$property_control .= "<input type=\"hidden\" name=\"op_" . $property_id . "\" value=\"" . htmlspecialchars($property_description) . "\">";
				}
				if (strlen($default_value)) {
					$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $default_value, 0, 0);
				}
				$property_control .= "<span";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				$property_control .= ">" . get_translation($default_value) . "</span>";
				$property_control .= $after_control_html;
			}

			$properties_total += $selected_price;
			if ($property_tax_free != 1) {
				$properties_taxable += $selected_price;
			}
			$t->set_var("property_id", $property_id);
			//$t->set_var("property_block_id", $property_block_id);
			$t->set_var("property_name", $before_name_html . $property_name . $after_name_html);
			if ($selected_price == 0) {
				$t->set_var("op_price", "");
			} else {
				$t->set_var("op_price", $currency_left . number_format($selected_price * $currency_rate, 2) . $currency_right);
			}
			$t->set_var("property_style", $property_style);
			$t->set_var("property_control", $property_control);
			if ($property_required) {
				$t->set_var("property_required", "*");
			} else {
				$t->set_var("property_required", "");
			}

			if (strlen($operation) && $property_required && !isset($custom_options[$property_id])) {
				$property_message = str_replace("{field_name}", $property_name, REQUIRED_MESSAGE) . "<br>";
				if ($property_type == 1 || $property_type == 4) {
					$sc_errors .= $property_message;
				} elseif ($property_type == 2 || $property_type == 3) {
					$options_errors .= $property_message;
				}
			}

			if ($property_type == 1) {
				$t->sparse("cart_properties", true);
			} elseif ($property_type == 2) {
				$personal_properties++;
				$t->sparse("personal_properties", true);
			} elseif ($property_type == 3) {
				$delivery_properties++;
				$t->sparse("delivery_properties", true);
			} elseif ($property_type == 4) {
				$payment_properties++;
				$t->sparse("payment_properties", true);
			}
		}

		$t->set_var("order_properties", $order_properties);
		$t->set_var("properties_total", $properties_total);
		$t->set_var("properties_taxable", $properties_taxable);

	}
	// end custom options

	// Prepare state_code, postal_code and country_code for use
	$state_code = ""; $postal_code = ""; $country_code = "";
	if (strlen($operation)) {
		if ($order_info["show_delivery_state_code"] == 1) {
			if ($same_as_personal == 1 && $order_info["show_state_code"] == 1) {
				$state_code = get_param("state_code");
			} else {
				$state_code = get_param("delivery_state_code");
			}
		} elseif ($order_info["show_state_code"] == 1) {
			$state_code = get_param("state_code");
		} 

		if ($order_info["show_delivery_zip"] == 1) {
			if ($same_as_personal == 1 && $order_info["show_zip"] == 1) {
				$postal_code = get_param("zip");
			} else {
				$postal_code = get_param("delivery_zip");
			}
		} elseif ($order_info["show_zip"] == 1) {
			$postal_code = get_param("zip");
		} 

		if ($order_info["show_delivery_country_code"] == 1) {
			if ($same_as_personal == 1 && $order_info["show_country_code"] == 1) {
				$country_code = get_param("country_code");
			} else {
				$country_code = get_param("delivery_country_code");
			}
		} elseif ($order_info["show_country_code"] == 1) {
			$country_code = get_param("country_code");
		} else {
			$country_code = $settings["country_code"];
		}
	} else {
		$country_code = $settings["country_code"];
	}

	// Prepare shipping
	$shipping_types = array();
	$total_shipping_types = 0;
	if ($country_code) {
		$shipping_modules = array();
		$sql = "SELECT * FROM " . $table_prefix . "shipping_modules WHERE is_active=1";
		$db->query($sql);
		while ($db->next_record()) {
			$shipping_module_id = $db->f("shipping_module_id");
			$shipping_module_name = $db->f("shipping_module_name");
			$is_external = $db->f("is_external");
			$php_external_lib = $db->f("php_external_lib");
			// fix path to external library of Shipping Module
			if (strpos($php_external_lib, "./") === 0) {
				$php_external_lib = $root_folder_path . substr($php_external_lib, 2);
			} elseif (strpos($php_external_lib, "../") !== 0 || strpos($php_external_lib, "/") !== 0) {
				$php_external_lib = $root_folder_path . $php_external_lib;
			}
			$external_url = $db->f("external_url");
			$shipping_modules[] = array($shipping_module_id, $shipping_module_name, $is_external, $php_external_lib, $external_url);
		}
	
		for ($sm = 0; $sm < sizeof($shipping_modules); $sm++) {
			list ($shipping_module_id, $shipping_module_name, $is_external, $php_external_lib, $external_url) = $shipping_modules[$sm];
			$module_shipping = array();
			$sql  = " SELECT st.shipping_type_id, st.shipping_type_code, st.shipping_type_desc, st.shipping_time, ";
			$sql .= " st.cost_per_order, st.cost_per_product, st.cost_per_weight, st.tare_weight, st.is_taxable ";
			$sql .= " FROM " . $table_prefix . "shipping_types st, " . $table_prefix . "shipping_types_countries stc ";
			$sql .= " WHERE st.shipping_type_id=stc.shipping_type_id ";
			$sql .= " AND st.is_active=1 ";
			$sql .= " AND stc.country_code=" . $db->tosql($country_code, TEXT);
			$sql .= " AND st.min_weight<=" . $db->tosql($weight_total, NUMBER);
			$sql .= " AND st.max_weight>=" . $db->tosql($weight_total, NUMBER);
			$sql .= " AND st.min_goods_cost<=" . $db->tosql($goods_total, NUMBER);
			$sql .= " AND st.max_goods_cost>=" . $db->tosql($goods_total, NUMBER);
			$sql .= " AND st.shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER);
			$sql .= " ORDER BY st.shipping_order ";
			$db->query($sql);
			while ($db->next_record()) {
				$row_shipping_type_id = $db->f("shipping_type_id");
				$row_shipping_type_code = $db->f("shipping_type_code");
				$row_shipping_type_desc = $db->f("shipping_type_desc");
				$row_shipping_time = $db->f("shipping_time");
				$cost_per_order = $db->f("cost_per_order");
				$cost_per_product = $db->f("cost_per_product");
				$cost_per_weight = $db->f("cost_per_weight");
				$row_tare_weight = $db->f("tare_weight");
				$row_shipping_taxable = $db->f("is_taxable");
				$row_shipping_cost = $cost_per_order + ($cost_per_product * $total_quantity) + ($cost_per_weight * ($weight_total + $row_tare_weight));

				$shipping_type = array($row_shipping_type_id, $row_shipping_type_code, $row_shipping_type_desc, $row_shipping_cost, $row_tare_weight, $row_shipping_taxable, $row_shipping_time);
				$module_shipping[] = $shipping_type;
				if (!$is_external) {
					$shipping_types[] = $shipping_type;
				}
			}
			
			if ($is_external && strlen($php_external_lib)) {
				$module_params = array();
				$sql  = " SELECT * FROM " . $table_prefix . "shipping_modules_parameters ";
				$sql .= " WHERE shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER);
				$sql .= " AND not_passed<>1 ";
				$db->query($sql);
				while ($db->next_record()) {
					$param_name = $db->f("parameter_name");
					$param_source = $db->f("parameter_source");
					$module_params[$param_name] = $param_source;
				}
				if ($operation == "refresh") {
					include_once($php_external_lib);
				}
			}
		}
	}
	$total_shipping_types = sizeof($shipping_types);


	$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "orders_notes oc ";
	$sql .= " WHERE oc.order_id=" . $db->tosql($order_id, INTEGER);
	$total_notes = get_db_value($sql);
	$t->set_var("total_notes", $total_notes);
	if ($total_notes > 0) {
		$t->set_var("notes_style", "font-weight: bold; color: blue;");
	} else {
		$t->set_var("notes_style", "");
	}

	$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "orders_items oi ";
	$sql .= " WHERE oi.order_id=" . $db->tosql($order_id, INTEGER);
	$sql .= " AND oi.downloadable=1 ";
	$downloadable_products = get_db_value($sql);
	if ($downloadable_products) {
		$t->parse("downloadable_links", false);
	}

	$sql  = " SELECT COUNT(*) FROM (" . $table_prefix . "orders_items oi ";
	$sql .= " LEFT JOIN " . $table_prefix . "item_types it ON oi.item_type_id=it.item_type_id) ";
	$sql .= " WHERE oi.order_id=" . $db->tosql($order_id, INTEGER);
	$sql .= " AND it.is_gift_voucher=1 ";
	$vouchers_number = get_db_value($sql);
	if ($vouchers_number) {
		$t->parse("vouchers_link", false);
	}

	if ($r->is_empty("transaction_id")) {
		$r->parameters["transaction_id"][SHOW] = false;
	}

	if ($r->is_empty("error_message")) {
		$r->parameters["error_message"][SHOW] = false;
	}
	if ($r->is_empty("pending_message")) {
		$r->parameters["pending_message"][SHOW] = false;
	}

	/*
	if ($r->get_value("user_id") == 0) {
		$r->parameters["user_id"][SHOW] = false;
	}
	*/


/*
	// get payment info if available
	$sql = "SELECT payment_info FROM " . $table_prefix . "payment_systems WHERE payment_id=" . $db->tosql($r->get_value("payment_id"), INTEGER);
	$payment_info = get_db_value($sql);
	$payment_info = get_translation($payment_info);
	$payment_info = get_currency_message($payment_info);
	if (trim($payment_info)) {
		$payment_params++;
		$t->set_block("payment_info", $payment_info);
		$t->parse("payment_info", false);
		$t->global_parse("payment_info_block", false, false, true);
	} else {
		$t->set_var("payment_info_block", "");
	}
	
	if (strlen($operation) || strlen($order_id)) {
		// Payment systems
		$sql = " SELECT COUNT(*) FROM " . $table_prefix . "payment_systems WHERE is_active=1 ";
		$total_payments = intval(get_db_value($sql));
		if ($total_payments == 1) {
			$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems WHERE is_active=1 ";
			$payment_id = get_db_value($sql);
			$r->change_property("payment_id", SHOW, false);
		} elseif ($total_payments > 1) {
			$payment_id = get_param("payment_id");
		} else {
			$payment_id = "";
			$r->change_property("payment_id", SHOW, false);
		}
		if ($total_payments <= 1) {
			$r->set_value("payment_id", $payment_id);
		}
	}
*/

	// Process form submit
	$is_valid = true;
	if (strlen($operation) && !$more_items)
	{
		if ($operation == "cancel") {
			header("Location: " . $r->return_page);
			exit;
		/*
		} elseif ($operation == "delete") {
			if (!isset($permissions["remove_orders"]) || $permissions["remove_orders"] != 1) {
				$r->errors .= "Sorry, but you are not allowed to remove orders.<br>Please change your permissions before proceed.<br>";
			} elseif (!strlen($order_id)) {
				$r->errors .= "Missing <b>Order number</b>.<br>";
			} else {
				remove_orders($order_id);
			}
		*/
		} elseif ($operation == "save" || $operation == "process") {
			if ($cc_number_security == 2) {
				$r->set_value("cc_number", format_cc_number(va_decrypt($r->get_value("cc_number"))));
			}
			if ($cc_code_security == 2) {
				$r->set_value("cc_security_code", va_decrypt($r->get_value("cc_security_code")));
			}
		
			$r->set_value("shipping_type_id", $shipping_type_id_param);
			$r->set_value("shipping_type_desc", get_param("shipping_selected_desc"));
			$r->set_value("shipping_cost", get_param("shipping_selected_cost"));
			$r->errors .= $sc_errors;
			if ($total_shipping_types > 1 && !strlen($shipping_type_id_param)) {
				$r->errors .= REQUIRED_DELIVERY_MSG . "<br>";
			}
			$cc_number = $r->get_value("cc_number");
			if (strlen($cc_number) >= 10) {
				if (!check_cc_number($cc_number)) {
					$r->errors .= CC_NUMBER_ERROR_MSG . "<br>" . $eol;
				}
			}
			$r->validate();
			$r->errors .= $options_errors;
			if (strlen($r->errors)) {
				$is_valid = false;
			} else {
				$is_valid = true;
			}
			$is_valid = ($eg->validate() && $is_valid);
			if ($is_valid) {
				// Set user's information
				$user_info = array();
				for ($i = 0; $i < sizeof($call_center_user_parameters); $i++) { 
					$user_param = $call_center_user_parameters[$i];
					$user_info[$user_param] = $r->get_value($user_param);
				}
				
				// Set CC number and security code
				$cc_number = clean_cc_number($cc_number);
				$cc_number_len = strlen($cc_number);
				$cc_security_code = $r->get_value("cc_security_code");
				$r->set_value("cc_number", $cc_number);
				set_session("session_cc_number", $r->get_value("cc_number"));
				set_session("session_cc_code",   $r->get_value("cc_security_code"));
				if ($cc_number_len > 6) {
					$cc_number_first = substr($cc_number, 0, 6);
				} else {
					$cc_number_first = $cc_number;
				}
				if ($cc_number_len > 4) {
					$cc_number_last = substr($cc_number, $cc_number_len - 4);
					if ($cc_info["cc_number_split"]) {
						$r->set_value("cc_number", substr($cc_number, 0, $cc_number_len - 4) . "****");
					}
				} else {
					$cc_number_last = $cc_number;
				}
				set_session("session_cc_number_first", $cc_number_first);
				set_session("session_cc_number_last", $cc_number_last);

				if ($cc_number_security == 0) {
					$r->set_value("cc_number", "");
				} elseif ($cc_number_security == 2) {
					$r->set_value("cc_number", va_encrypt($r->get_value("cc_number")));
				}
	
				if ($cc_code_security == 0) {
					$r->set_value("cc_security_code", "");
				} elseif ($cc_code_security == 2) {
					$r->set_value("cc_security_code", va_encrypt($r->get_value("cc_security_code")));
				}

				if (!isset($permissions["update_orders"]) || $permissions["update_orders"] != 1) {
					$r->errors .= "Sorry, but you are not allowed to update orders information.<br>Please change your permissions before proceed.<br>";
				} elseif (strlen($r->get_value("order_id"))) {
					// Insert user for the order
					$user_id = insert_user_info($user_info);
					$r->set_value("user_id", $user_id);

					$r->update_record();

					// Insert items
					$db->query("DELETE FROM " . $table_prefix . "orders_items WHERE order_id = " . $db->tosql($order_id, INTEGER));
					$eg->set_values("order_id", $order_id);
					$eg->set_values("item_status", $r->get_value("order_status"));
					$eg->update_all($number_items);

					// Update properties
					$db->query("DELETE FROM " . $table_prefix . "orders_properties WHERE order_id = " . $db->tosql($order_id, INTEGER) . " AND property_type IN (1,2,3)");
					foreach ($custom_options as $property_id => $property_info) {
						list ($property_type, $property_order, $property_name, $property_value, $property_price, $property_tax_free) = $property_info;
						$t->set_var("field_name_" . $property_id, $property_name);
						$t->set_var("field_value_" . $property_id, $property_value);
						$t->set_var("field_price_" . $property_id, $property_price);
						$t->set_var("field_" . $property_id, $property_value);
						$op->set_value("property_id", $property_id);
						$op->set_value("order_id", $order_id);
						$op->set_value("property_order", $property_order);
						$op->set_value("property_type", $property_type);
						$op->set_value("property_name", $property_name);
						$op->set_value("property_value", $property_value);
						$op->set_value("property_price", $property_price);
						$op->set_value("property_weight", 0);
						$op->set_value("tax_free", $property_tax_free);
						$op->insert_record();
					}
				} else {
					if ($db_type == "postgre") {
						$order_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "orders') ");
						//$variables["order_id"] = $order_id;
						$r->change_property("order_id", USE_IN_INSERT, true);
						$r->set_value("order_id", $order_id);
					}
					$user_id = insert_user_info($user_info);
					$r->set_value("user_id", $user_id);
					$r->set_value("order_placed_date", va_time());
					$r->set_value("is_placed", "1");
					$r->insert_record();

					if ($db_type == "mysql") {
						$order_id = get_db_value(" SELECT LAST_INSERT_ID() ");
						$r->set_value("order_id", $order_id);
						//$variables["order_id"] = $order_id;
					} elseif ($db_type == "access") {
						$order_id = get_db_value(" SELECT @@IDENTITY ");
						$r->set_value("order_id", $order_id);
						//$variables["order_id"] = $order_id;
					}

					$eg->set_values("order_id", $order_id);
					$eg->set_values("item_status", $r->get_value("order_status"));
					$eg->insert_all($number_items);
					
					// Insert properties
					foreach ($custom_options as $property_id => $property_info) {
						list ($property_type, $property_order, $property_name, $property_value, $property_price, $property_tax_free) = $property_info;
						$t->set_var("field_name_" . $property_id, $property_name);
						$t->set_var("field_value_" . $property_id, $property_value);
						$t->set_var("field_price_" . $property_id, $property_price);
						$t->set_var("field_" . $property_id, $property_value);
						$op->set_value("property_id", $property_id);
						$op->set_value("order_id", $order_id);
						$op->set_value("property_order", $property_order);
						$op->set_value("property_type", $property_type);
						$op->set_value("property_name", $property_name);
						$op->set_value("property_value", $property_value);
						$op->set_value("property_price", $property_price);
						$op->set_value("property_weight", 0);
						$op->set_value("tax_free", $property_tax_free);
						$op->insert_record();
					}
					
				}
				// Processing order
				if ($operation == "process" && !strlen($r->errors)) {
					// Coupon processing
					$coupon_id = "";
					$coupon_errors = "";
					$coupons_enable = get_setting_value($settings, "coupons_enable");
					$coupon_code = trim(get_param("coupon_code"));
					if ($coupons_enable && strlen($coupon_code)) {
						$r->set_value("coupons_ids", "");
					}
					// Payment processing
					if (strlen($r->get_value("order_id"))) {
						include_once("./admin_order_payment.php");
						$sql = "SELECT error_message, pending_message, success_message FROM " . $table_prefix . "orders WHERE order_id = " . $db->tosql($r->get_value("order_id"), INTEGER);
						$db->query($sql);
						if ($db->next_record($sql)) {
							$error_message = $db->f("error_message");
							$pending_message = $db->f("pending_message");
							$success_message = $db->f("success_message");
							if (strlen($error_message)) {
								$r->errors = "An error occured while processing order. Error message: '" . $error_message . "'<br>";
							} elseif (strlen($pending_message)) {
								$r->errors = "<font color='#808000'>Order is pending: '" . $pending_message . "'</font><br>";
							} else {
								$r->errors = "<font color='#009900'>Order was successfully charged. " . $success_message . "</font><br>";
								$r->get_db_values();
							}
						}
					}
				} 
				/*
				else {
					$r->return_page = "admin_order_call.php?order_id=" . $order_id;
				}
				*/
			}
		}

		if ($is_valid && !strlen($r->errors) && strlen($r->return_page) && $operation != "refresh")
		{
			header("Location: " . $r->return_page);
			exit;
		}
	}
	elseif ($more_items) 
	{
		$number_items += 5;
	}
	elseif (strlen($r->get_value("order_id")) && !$more_items) // show existing values 
	{
		$r->get_db_values();
		$eg->set_value("order_id", $order_id);
		$eg->change_property("order_item_id", USE_IN_SELECT, true);
		$eg->change_property("order_item_id", USE_IN_WHERE, false);
		$eg->change_property("order_id", USE_IN_WHERE, true);
		$eg->change_property("order_id", USE_IN_SELECT, true);
		$number_items = $eg->get_db_values();
		if ($number_items == 0) $number_items = 5;

		// Month and Year lists
		$start_date = $r->get_value("cc_start_date");
		$expiry_date = $r->get_value("cc_expiry_date");
		if (is_array($start_date)) {
			$cc_start_year   = intval($start_date[0]);
			$cc_start_month  = intval($start_date[1]);
		}
		if (is_array($expiry_date)) {
			$cc_expiry_year  = intval($expiry_date[0]);
			$cc_expiry_month = intval($expiry_date[1]);
		}
	}
	else // set default values
	{
		$r->set_value("user_id", "0");
		$r->set_value("is_placed", "0");
		$r->set_value("is_call_center", "1");
		$number_items = 5;

		$r->set_value("currency_code", $currency_code);
		$r->set_value("currency_rate", $currency_rate);	
		$r->set_value("payment_id", $payment_id);
	}

	$t->set_var("number_items", $number_items);
	
	// Credit card date lists
	$current_date = va_time();
	$cc_start_years = get_db_values("SELECT start_year AS year_value, start_year AS year_description FROM " . $table_prefix . "cc_start_years", array(array("", YEAR_MSG)));
	if (sizeof($cc_start_years) < 2) {
		$cc_start_years = array(array("", YEAR_MSG));
		for ($y = 7; $y >= 0; $y--) {
			$cc_start_years[] = array($current_date[YEAR] - $y, $current_date[YEAR] - $y);
		}
	}
	$cc_expiry_years = get_db_values("SELECT expiry_year AS year_value, expiry_year AS year_description FROM " . $table_prefix . "cc_expiry_years", array(array("", YEAR_MSG)));
	if (sizeof($cc_expiry_years) < 2) {
		$cc_expiry_years = array(array("", YEAR_MSG));
		for ($y = 0; $y <= 7; $y++) {
			$cc_expiry_years[] = array($current_date[YEAR] + $y, $current_date[YEAR] + $y);
		}
	}
	set_options($cc_start_years, $cc_start_year, "cc_start_year");
	set_options($cc_expiry_years, $cc_expiry_year, "cc_expiry_year");

	$cc_months = array_merge (array(array("", MONTH_MSG)), $months);
	set_options($cc_months, $cc_start_month, "cc_start_month");
	set_options($cc_months, $cc_expiry_month, "cc_expiry_month");

	$eg->set_parameters_all($number_items);
	$r->set_parameters();
	

	// Show shipping types
	$shipping_type_id = ""; $shipping_type_desc = ""; $tare_weight = 0; $shipping_cost = 0; $shipping_taxable = 0; $shipping_taxable_value = 0;
	if ($country_code) {
		for ($st = 0; $st < sizeof($shipping_types); $st++) {
			list ($row_shipping_type_id, $row_shipping_type_code, $row_shipping_type_desc, $row_shipping_cost, $row_tare_weight, $row_shipping_taxable, $row_shipping_time) = $shipping_types[$st];
			
			if ($free_postage) { $row_shipping_cost = 0; }
			if /*(($row_shipping_type_id == $shipping_type_id_param) ||*/ ($row_shipping_type_id == $r->get_value("shipping_type_id"))/*)*/ {
				$shipping_type_id   = $row_shipping_type_id;
				$shipping_type_desc = $row_shipping_type_desc;
				$shipping_time = $row_shipping_time;
				$shipping_cost = $row_shipping_cost;
				$tare_weight = $row_tare_weight;
				$shipping_taxable = $row_shipping_taxable;
				if ($shipping_taxable) {
					$shipping_taxable_value = $shipping_cost;
				}
				$t->set_var("shipping_type_checked", "checked");
				$t->set_var("shipping_cost_selected", $currency_left . number_format($row_shipping_cost * $currency_rate, 2) . $currency_right);
			} else {
				$t->set_var("shipping_type_checked", "");
				$t->set_var("shipping_cost_selected", "");
			}
			$t->set_var("shipping_type_id", $row_shipping_type_id);
			$t->set_var("shipping_value", round($row_shipping_cost, 2));
			$t->set_var("shipping_cost_desc", $currency_left . number_format($row_shipping_cost * $currency_rate, 2) . $currency_right);
			$t->set_var("shipping_type_desc", $row_shipping_type_desc);
			$t->set_var("shipping_taxable", intval($row_shipping_taxable));
			$t->parse("shipping_types", true);
		}

		if ($total_shipping_types == 1) {
			$shipping_type_id = $row_shipping_type_id;
			$shipping_type_desc = $row_shipping_type_desc;
			$shipping_time = $row_shipping_time;
			$shipping_cost = $row_shipping_cost;
			$tare_weight = $row_tare_weight;
			$shipping_taxable = $row_shipping_taxable;
			if ($shipping_taxable) {
				$shipping_taxable_value = $shipping_cost;
			}
			$t->set_var("shipping_types", "");
			$t->parse("shipping_type", false);
		}
	}
	$t->set_var("shipping_selected_desc", $shipping_type_desc);
	$t->set_var("shipping_selected_cost", $shipping_cost);
	$t->set_var("shipping_taxable_value", $shipping_taxable_value);
	if ($total_shipping_types > 0) {
		$t->parse("shipping", false);
	}


	if ($personal_number > 0 || $personal_properties) {
		$t->sparse("personal", false);
	}

	if ($delivery_number > 0 || $delivery_properties) {
		$t->sparse("delivery", false);
	}
	
	if ($payment_params > 0 || $payment_properties) {
		$t->parse("payment", false);
	}

	// Parse JavaScript that calculates order total
	if ($order_id) {
		$t->parse("existing_order_js", false);
	}

	// Parse buttons
	if (strlen($r->get_value("order_id"))) {
		if ($r->get_value("is_placed") == 0) {
			$t->set_var("process_button", "Update & Process");
			$t->parse("process_button_block", false);
			$t->set_var("save_button_block", "");
		} else {
			// redirect to order info screen
			header("Location: admin_order.php?order_id=" . $r->get_value("order_id"));
			exit;;
		}
		$t->sparse("packing_slip", false);
		$t->sparse("notes", false);
		if (isset($permissions["remove_orders"]) && $permissions["remove_orders"] == 1) {
			$t->sparse("remove_order_link", false);
		}
		$t->set_var("delete", "");
	} else {
		$t->set_var("save_button_block", "");
		$t->set_var("process_button", "Save & Process");
		$t->parse("process_button_block", false);
		$t->set_var("delete", "");
		$t->set_var("remove_order_link", "");
	}

	
	$t->parse("order_details", false);

	include_once("./admin_header.php");
	include_once("./admin_footer.php");

	$t->pparse("main");

	
	function make_seed()
	{
	    list($usec, $sec) = explode(' ', microtime());
    	return (float) $sec + ((float) $usec * 100000);
	}

	function insert_user_info($user_info) 
	{
		global $settings, $table_prefix, $db, $call_center_user_parameters;

		$user_id = intval($user_info["user_id"]);

		if (isset($user_info["phone"]) && strlen($user_info["phone"]) && !$user_id) {
			// erase all symbols from phone number except digits
			$login = preg_replace("/\D+/i", "", $user_info["phone"]);
			$user_id = intval(get_db_value("SELECT user_id FROM " . $table_prefix . "users WHERE login = " . $db->tosql($login, TEXT)));
		} else {
			$login = "";
		}

		$usr = new VA_Record($table_prefix . "users");
		$usr->add_where("user_id", INTEGER);
		$usr->set_value("user_id", $user_id);
		
		if (!$user_id) {
			$usr->add_textbox("login", TEXT, "Login");
			$usr->change_property("login", REQUIRED, true);
			$usr->change_property("login", UNIQUE, true);
			//$usr->change_property("login", MIN_LENGTH, 3);
			$usr->set_value("login", $login);
			$usr->add_textbox("password", TEXT, PASSWORD_FIELD);
			//$usr->change_property("password", REQUIRED, true);
			//$usr->change_property("password", MIN_LENGTH, 3);
			mt_srand(make_seed());
			$usr->set_value("password", mt_rand());
			$type_id = intval(get_db_value("SELECT type_id FROM " . $table_prefix . "user_types WHERE is_default = 1"));
			$usr->add_textbox("user_type_id", INTEGER);
			$usr->set_value("user_type_id", $type_id);
		}
		$usr->add_textbox("name", TEXT, NAME_FIELD);
		$usr->change_property("name", USE_SQL_NULL, false);
		$usr->add_textbox("first_name", TEXT, FIRST_NAME_FIELD);
		$usr->change_property("first_name", USE_SQL_NULL, false);
		$usr->add_textbox("last_name", TEXT, LAST_NAME_FIELD);
		$usr->change_property("last_name", USE_SQL_NULL, false);
		$usr->add_textbox("company_id", INTEGER, COMPANY_SELECT_FIELD);
		$usr->add_textbox("company_name", TEXT, COMPANY_NAME_FIELD);
		$usr->add_textbox("email", TEXT, EMAIL_FIELD);
		$usr->change_property("email", USE_SQL_NULL, false);
		$usr->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
		$usr->add_textbox("address1", TEXT, STREET_FIRST_FIELD);
		$usr->add_textbox("address2", TEXT, STREET_SECOND_FIELD);
		$usr->add_textbox("city", TEXT, CITY_FIELD);
		$usr->add_textbox("province", TEXT, PROVINCE_FIELD);
		$usr->add_textbox("state_code", TEXT, STATE_FIELD);
		$usr->add_textbox("zip", TEXT, ZIP_FIELD);
		$usr->add_textbox("country_code", TEXT, COUNTRY_FIELD);
		$usr->add_textbox("phone", TEXT, PHONE_FIELD);
		$usr->add_textbox("daytime_phone", TEXT, DAYTIME_PHONE_FIELD);
		$usr->add_textbox("evening_phone", TEXT, EVENING_PHONE_FIELD);
		$usr->add_textbox("cell_phone", TEXT, CELL_PHONE_FIELD);
		$usr->add_textbox("fax", TEXT, FAX_FIELD);
		
		$usr->add_textbox("delivery_name", TEXT, DELIVERY_MSG." ".NAME_FIELD);
		$usr->add_textbox("delivery_first_name", TEXT, DELIVERY_MSG." ".FIRST_NAME_FIELD);
		$usr->add_textbox("delivery_last_name", TEXT, DELIVERY_MSG." ".LAST_NAME_FIELD);
		$usr->add_textbox("delivery_company_id", INTEGER, DELIVERY_MSG." ".COMPANY_SELECT_FIELD);
		$usr->add_textbox("delivery_company_name", TEXT, DELIVERY_MSG." ".COMPANY_NAME_FIELD);
		$usr->add_textbox("delivery_email", TEXT, DELIVERY_MSG." ".EMAIL_FIELD);
		$usr->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
		$usr->add_textbox("delivery_address1", TEXT, DELIVERY_MSG." ".STREET_FIRST_FIELD);
		$usr->add_textbox("delivery_address2", TEXT, DELIVERY_MSG." ".STREET_SECOND_FIELD);
		$usr->add_textbox("delivery_city", TEXT, DELIVERY_MSG." ".CITY_FIELD);
		$usr->add_textbox("delivery_province", TEXT, DELIVERY_MSG." ".PROVINCE_FIELD);
		$usr->add_textbox("delivery_state_code", TEXT, DELIVERY_MSG." ".STATE_FIELD);
		$usr->add_textbox("delivery_zip", TEXT, DELIVERY_MSG." ".ZIP_FIELD);
		$usr->add_textbox("delivery_country_code", TEXT, DELIVERY_MSG." ".COUNTRY_FIELD);
		$usr->add_textbox("delivery_phone", TEXT, DELIVERY_MSG." ".PHONE_FIELD);
		$usr->add_textbox("delivery_daytime_phone", TEXT, DELIVERY_MSG." ".DAYTIME_PHONE_FIELD);
		$usr->add_textbox("delivery_evening_phone", TEXT, DELIVERY_MSG." ".EVENING_PHONE_FIELD);
		$usr->add_textbox("delivery_cell_phone", TEXT, DELIVERY_MSG." ".CELL_PHONE_FIELD);
		$usr->add_textbox("delivery_fax", TEXT, DELIVERY_MSG." ".FAX_FIELD);
		
		$usr->add_textbox("registration_date", DATETIME);
		$usr->change_property("registration_date", USE_IN_SELECT, false);
		$usr->change_property("registration_date", USE_IN_UPDATE, false);
		$usr->add_textbox("modified_date", DATETIME);
		$usr->change_property("modified_date", USE_IN_SELECT, false);

		for ($i = 0; $i < sizeof($call_center_user_parameters); $i++) { 
			$user_param = $call_center_user_parameters[$i];
			if (isset($user_info[$user_param])) {
				$usr->set_value($user_param, $user_info[$user_param]);
			}
		}

		$usr->validate();

		if (!strlen($usr->errors)) {
			$current_date = va_time();
			if ($user_id) {
				$usr->set_value("modified_date", $current_date);
				$usr->update_record();
			} else {
				$password_encrypt = get_setting_value($settings, "password_encrypt", 0);
				if ($password_encrypt == 1) {
					$usr->set_value("password", md5($r->get_value("password")));
				}
				$usr->set_value("registration_date", $current_date);
				$usr->set_value("modified_date", $current_date);
				$usr->insert_record();
				$user_id = intval(get_db_value("SELECT MAX(user_id) FROM " . $table_prefix . "users"));
			}
		}
		
		return $user_id;
	}

?>