<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_order_links.php                                    ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/sorter.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/order_items.php");
	include_once ($root_folder_path . "includes/order_links.php");
	include_once ("../messages/".$language_code."/cart_messages.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("sales_orders");
	check_admin_security("order_links");

	$eol = get_eol();
	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_order_links.html");
	$t->set_var("site_url", $settings["site_url"]);

	$message_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$r = new VA_Record("");

	$r->add_where("order_id", INTEGER);
	$r->add_textbox("message_from", TEXT, "From");
	$r->change_property("message_from", REQUIRED, true);
	$r->add_textbox("message_to", TEXT, "To");
	$r->change_property("message_to", REQUIRED, true);
	$r->add_textbox("message_cc", TEXT);
	$r->add_textbox("message_bcc", TEXT);
	$r->add_textbox("message_reply_to", TEXT);
	$r->add_textbox("message_return_path", TEXT);
	$r->add_textbox("message_subject", TEXT);
	$r->add_radio("message_type", TEXT, $message_types);
	$r->add_textbox("message_body", TEXT, "Message Body");
	$r->change_property("message_body", REQUIRED, true);

	$site_url = $settings["site_url"];

	$operation = get_param("operation");
	$order_id = get_param("order_id");
	$send_links = get_param("send_links");

	$message_sent = false;

	$r->get_form_values();

	if(strlen($operation))
	{
		$is_valid = $r->validate();

		if($is_valid) {

			$email_headers = get_email_headers($r->get_value("message_from"), $r->get_value("message_cc"), $r->get_value("message_bcc"), $r->get_value("message_reply_to"), $r->get_value("message_return_path"), $r->get_value("message_type"));
			$message_body = preg_replace("/\r\n|\r|\n/", $eol, $r->get_value("message_body"));
			$message_sent = @mail($r->get_value("message_to"), $r->get_value("message_subject"), $message_body, $email_headers);
			if(!$message_sent) {
				$r->errors = "Mail server error. Message wasn't sent";
			} else {
				$oe = new VA_Record($table_prefix . "orders_events");
				$oe->add_textbox("order_id", INTEGER);
				$oe->add_textbox("status_id", INTEGER);
				$oe->add_textbox("admin_id", INTEGER);
				$oe->add_textbox("order_items", TEXT);
				$oe->add_textbox("event_date", DATETIME);
				$oe->add_textbox("event_name", TEXT);
				$oe->add_textbox("event_description", TEXT);
				$oe->set_value("order_id", $order_id);
				$oe->set_value("status_id", 0);
				$oe->set_value("admin_id", get_session("session_admin_id"));
				$oe->set_value("event_date", va_time());
				$oe->set_value("event_name", "Links sent");
				$oe->set_value("event_description", $r->get_value("message_subject"));
				$oe->insert_record();
			}
		}

	} else {

		$download_info = array();
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='download_info'";
		$db->query($sql);
		while($db->next_record()) {
			$download_info[$db->f("setting_name")] = $db->f("setting_value");
		}


		// prepare email fields
		$mail_from = get_setting_value($download_info, "links_from", $settings["admin_email"]);
		$mail_cc = get_setting_value($download_info, "links_cc");
		$mail_bcc = get_setting_value($download_info, "links_bcc");
		$mail_reply_to = get_setting_value($download_info, "links_reply_to");
		$mail_return_path = get_setting_value($download_info, "links_return_path");
		$mail_type = get_setting_value($download_info, "links_message_type");

		$r->set_value("message_from", $mail_from);
		$r->set_value("message_cc", $mail_cc);
		$r->set_value("message_bcc", $mail_bcc);
		$r->set_value("message_reply_to", $mail_reply_to);
		$r->set_value("message_return_path", $mail_return_path);
		$r->set_value("message_type", $mail_type);

	  // get customer email
		$sql = "SELECT delivery_email, email FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$message_to = strlen($db->f("delivery_email")) ? $db->f("delivery_email") : $db->f("email");
			$r->set_value("message_to", $message_to);
		} 

		// get download links
		$order_links = get_order_links($order_id);
		$links = ($mail_type) ? $order_links["html"] : $order_links["text"];

		// get serial numbers 
		$order_serials = get_serial_numbers($order_id);
		$serial_numbers = ($mail_type) ? $order_serials["html"] : $order_serials["text"];

		// get gift vouchers
		$order_vouchers = get_gift_vouchers($order_id);
		$gift_vouchers = ($mail_type) ? $order_vouchers["html"] : $order_vouchers["text"];

		if(isset($download_info["links_subject"]) && $download_info["links_subject"]) {
			$links_subject = $download_info["links_subject"];
		} else {
			$links_subject = "Links For Your Order #" . $order_id;
		}

		if(isset($download_info["links_message"]) && $download_info["links_message"]) {
			$links_message = $download_info["links_message"];
		} else {
			$links_message = $links;
		}

		$t->set_block("message_subject", $links_subject);
		$t->set_block("message_body", $links_message);

		$items_text = show_order_items($order_id, false);
		$t->set_var("basket", $items_text);
		$t->set_var("items", $items_text);
		$t->set_var("products", $items_text);
		$sql = "SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		$db->next_record();
		$state_code = $db->f("state_code");
		$country_code = $db->f("country_code");
		$delivery_state_code = $db->f("delivery_state_code");
		$delivery_country_code = $db->f("delivery_country_code");
		$cc_type = $db->f("cc_type");
		$order_placed_date = $db->f("order_placed_date", DATETIME);
		$goods_total = $db->f("goods_total");
		$total_discount = $db->f("total_discount");
		$shipping_cost = $db->f("shipping_cost");
		$tax_name = $db->f("tax_name");
		$tax_percent = $db->f("tax_percent");
		$order_total = round($goods_total, 2) - round($total_discount, 2) + round($shipping_cost, 2);
		if(strlen($tax_name) || $tax_percent > 0) {
			$tax_cost = ($order_total / 100) * $tax_percent;
			$tax_cost = round($tax_cost, 2);
			$order_total += $tax_cost;
			$t->set_var("tax_cost", $currency_left . number_format($tax_cost * $currency_rate, 2) . $currency_right);
		}

		$t->set_vars($db->Record);
		$t->set_var("goods_total", $currency_left . number_format($goods_total * $currency_rate, 2) . $currency_right);
		$t->set_var("total_discount", $currency_left . number_format($total_discount * $currency_rate, 2) . $currency_right);
		$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost * $currency_rate, 2) . $currency_right);
		$t->set_var("order_total", $currency_left . number_format($order_total * $currency_rate, 2) . $currency_right);
		$t->set_var("tax_percent", number_format($db->f("tax_percent"), 2) . "%");

		$date_formated = va_date($datetime_show_format, $order_placed_date);
		$cc_start = va_date(array("MM", " / ", "YYYY"), $db->f("cc_start_date", DATETIME));
		$cc_expiry = va_date(array("MM", " / ", "YYYY"), $db->f("cc_expiry_date", DATETIME));

		$state = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($state_code, TEXT));
		$delivery_state = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($delivery_state_code, TEXT));
		$country = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($country_code, TEXT));
		$delivery_country = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($delivery_country_code, TEXT));
		$cc_type = get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($cc_type, INTEGER));

		$t->set_var("order_placed_date", $date_formated);
		$t->set_var("order_placed", $date_formated);
		$t->set_var("links", $links);
		$t->set_var("serials", $serial_numbers);
		$t->set_var("serial_numbers", $serial_numbers);
		$t->set_var("vouchers", $gift_vouchers);
		$t->set_var("gift_vouchers", $gift_vouchers);

		$t->set_var("state", $state);
		$t->set_var("country", $country);
		$t->set_var("delivery_state", $delivery_state);
		$t->set_var("delivery_country", $delivery_country);
		$t->set_var("cc_type", $cc_type);
		$t->set_var("cc_start_date", $cc_start);
		$t->set_var("cc_expiry_date", $cc_expiry);

		$t->parse("message_subject", false);
		$t->parse("message_body", false);

		$r->set_value("message_subject", $t->get_var("message_subject"));
		$r->set_value("message_body",  $t->get_var("message_body"));
	}

	$r->set_parameters();

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_order_links.php");
	$s->set_sorter("ID", "sorter_download_id", "1", "download_id");
	$s->set_sorter("Product", "sorter_item_name", "2", "item_name");
	$s->set_sorter("Activated", "sorter_activated", "3", "activated");

	$t->set_var("admin_order_href", "admin_order.php");
	$t->set_var("admin_order_link_href", "admin_order_link.php");
	$t->set_var("admin_order_links_href", "admin_order_links.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_orders_href", "admin_orders.php");

	$sql  = " SELECT id.download_id,oi.item_name,id.activated,id.download_added FROM " . $table_prefix . "items_downloads id, " . $table_prefix . "orders_items oi ";
	$sql .= " WHERE id.order_item_id=oi.order_item_id";
	$sql .= " AND id.order_id=" . $db->tosql($order_id, INTEGER);
	//$db->RecordsPerPage = $records_per_page;
	//$db->PageNumber = $page_number;
	$db->query($sql . $s->order_by);
	if($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do {
			$download_id = $db->f("download_id");
			$download_added = $db->f("download_added", DATETIME);
			$item_download_url  = $site_url . "download.php?download_id=" . $download_id;
			$vc = md5($download_id . $download_added[3].$download_added[4].$download_added[5]);
			$item_download_url .= "&vc=" . urlencode($vc);
			$activated = $db->f("activated") ? "Yes" : "No";
			$item_name = get_translation($db->f("item_name"));

			$t->set_var("item_name", htmlspecialchars($item_name));
			$t->set_var("download_id", $download_id);
			$t->set_var("download_url", $item_download_url);
			$t->set_var("activated", $activated);
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->parse("no_records", false);
	}

	$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "orders_items oi ";
	$sql .= " WHERE oi.order_id=" . $db->tosql($order_id, INTEGER);
	$sql .= " AND oi.downloadable=1 ";
	$downloadable_products = get_db_value($sql);
	if($downloadable_products) {
		$t->parse("download_links", false);
	}


	if(strlen($message_sent)) {
		$t->parse("message_sent", false);
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>