<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_order_status.php                                   ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("sales_orders");
	check_admin_security("order_statuses");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_order_status.html");

	$t->set_var("admin_href", "admin.php");  
	$t->set_var("admin_lookup_tables_href",  "admin_lookup_tables.php");
	$t->set_var("admin_order_statuses_href", "admin_order_statuses.php");
	$t->set_var("admin_order_status_href",   "admin_order_status.php");
	$t->set_var("admin_email_help_href",     "admin_email_help.php");
	$t->set_var("admin_order_help_href",     "admin_order_help.php");


	$paid_statuses = 
		array( 
			array(1, PAID_MSG), array(0, NOT_PAID_MSG)
		);

	$activations_values = 
		array( 
			array(1, "Activate"), array(0, "Disable")
		);

	$commission_values = 
		array( 
			array(1, "Add commissions"), array(-1, "Subtract commissions"), array(0, "No commissions actions")
		);

	$mail_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$r = new VA_Record($table_prefix . "order_statuses");
	$r->return_page = "admin_order_statuses.php";

	$r->add_where("status_id", INTEGER);

	$r->add_textbox("status_name", TEXT, "Status Name");
	$r->parameters["status_name"][REQUIRED] = true;
	$r->add_checkbox("allow_user_cancel", INTEGER);
	$r->add_checkbox("is_user_cancel", INTEGER);
	$r->add_checkbox("is_dispatch", INTEGER);
	$r->add_checkbox("is_list", INTEGER);
	$r->change_property("is_list", DEFAULT_VALUE, 1);
	$r->add_checkbox("show_for_user", INTEGER);
	$r->add_checkbox("item_notify", INTEGER);
	$r->add_radio("paid_status", INTEGER, $paid_statuses, PAID_STATUS_MSG);
	$r->add_radio("download_activation", INTEGER, $activations_values);
	$r->add_radio("commission_action", INTEGER, $commission_values);


	$r->add_checkbox("mail_notify", INTEGER);
	$r->add_textbox("mail_from", TEXT);
	$r->add_textbox("mail_cc", TEXT);
	$r->add_textbox("mail_bcc", TEXT);
	$r->add_textbox("mail_reply_to", TEXT);
	$r->add_textbox("mail_return_path", TEXT);
	$r->add_textbox("mail_subject", TEXT);
	$r->add_radio("mail_type", INTEGER, $mail_types);
	$r->parameters["mail_type"][DEFAULT_VALUE] = 0;
	$r->add_textbox("mail_body", TEXT);

	$r->add_checkbox("sms_notify", INTEGER);
	$r->add_textbox("sms_recipient", TEXT, "SMS Recipient");
	$r->add_textbox("sms_originator",TEXT, "SMS Originator");
	$r->add_textbox("sms_message",   TEXT, "SMS Message");
	$r->set_event(BEFORE_VALIDATE, "check_status_options");

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

	function check_status_options()
	{
		global $r;
		if ($r->get_value("sms_notify")) {
			$r->change_property("sms_message", REQUIRED, true);
		}
		    
	}

?>