<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_page.php                                           ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("web_pages");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_var("css_file", "../styles/" . $settings["style_name"] . ".css");
	$t->set_var("html_editor", get_setting_value($settings, "html_editor", 1));
	$t->set_file("main","admin_page.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("page_href", "page.php");
	$t->set_var("admin_pages_href", "admin_pages.php");
	$t->set_var("admin_page_href", "admin_page.php");

	$r = new VA_Record($table_prefix . "pages");
	$r->return_page = "admin_pages.php";

	$is_html_options = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$page_types = 
		array( 
			array(1, "Usual Window"), array(2, "Popup Window")
		);

	$r->add_where("page_id", INTEGER);
	$r->add_textbox("page_code", TEXT, "Page Code");
	$r->parameters["page_code"][REQUIRED] = true;
	$r->parameters["page_code"][UNIQUE] = true;
	$r->add_textbox("page_title", TEXT, "Page Title");
	$r->parameters["page_title"][REQUIRED] = true;
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("page_url", TEXT);
	$r->add_textbox("page_order", INTEGER, "Page Order");
	$r->parameters["page_order"][REQUIRED] = true;
	$r->parameters["page_order"][DEFAULT_VALUE] = get_db_value("SELECT MAX(page_order) FROM " . $table_prefix . "pages") + 1;
	$r->add_checkbox("is_showing", INTEGER);
	$r->parameters["is_showing"][DEFAULT_VALUE] = 1;
	$r->add_checkbox("link_in_footer", INTEGER);
	$r->add_radio("is_html", INTEGER, $is_html_options);
	$r->parameters["is_html"][DEFAULT_VALUE] = 0;
	$r->add_radio("page_type", INTEGER, $page_types);
	$r->parameters["page_type"][DEFAULT_VALUE] = 1;
	$r->add_textbox("page_path", TEXT);
	$r->add_textbox("page_body", TEXT);
	$r->add_textbox("meta_title", TEXT);
	$r->add_textbox("meta_keywords", TEXT);
	$r->add_textbox("meta_description", TEXT);

	$r->events[BEFORE_INSERT] = "set_friendly_url";
	$r->events[BEFORE_UPDATE] = "set_friendly_url";

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>