<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_payment_system.php                                 ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/editgrid.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path . "messages/".$language_code."/admin_messages.php");

	check_admin_security("payment_systems");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_payment_system.html");

	// set up html form parameters
	$r = new VA_Record($table_prefix . "payment_systems");
	$r->add_where("payment_id", INTEGER);
	$r->change_property("payment_id", USE_IN_INSERT, true);

	$r->add_checkbox("is_active", INTEGER);
	$r->add_checkbox("is_default", INTEGER);
	$r->add_checkbox("is_call_center", INTEGER);
	$r->add_textbox("payment_name", TEXT, "Payment Name");
	$r->change_property("payment_name", REQUIRED, true);
	$r->add_textbox("processing_time", INTEGER, "Processing Time");

	$r->add_textbox("processing_fee", FLOAT, "Processing Fee");
	$fee_types = array( array(1, "Percentage per order total amount"), array(2, "Amount per order") );
	$r->add_radio("fee_type", INTEGER, $fee_types, "Fee Type");
	$r->add_textbox("fee_min_goods", NUMBER, "Minimum Goods Cost");
	$r->add_textbox("fee_max_goods", NUMBER, "Maximum Goods Cost");

	$recurring_methods = array( 
		array(0, RECURRING_NOT_ALLOWED_MSG), array(1, RECURRING_AUTO_CREATE_MSG), array(2, RECURRING_AUTO_BILL_MSG)
	);
	$r->add_radio("recurring_method", INTEGER, $recurring_methods, RECURRING_METHOD_MSG);

	$r->add_textbox("payment_info", TEXT, "Payment Info");
	$r->add_textbox("payment_notes", TEXT, "Payment Notes");
	$r->add_textbox("payment_url", TEXT, "Payment URL");
	$r->change_property("payment_url", REQUIRED, true);
	$methods = array(array("GET", "GET"), array("POST", "POST"));
	$r->add_radio("submit_method", TEXT, $methods, "Form Submit Method");

	// advanced parameters
	$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", array(array("", "")));

	$failure_actions = array(
		array(0, "Go to the final step"), 
		array(1, "Redirect user back to the payment details page")
	);

	$r->add_checkbox("is_advanced", TEXT);
	$r->add_textbox("advanced_url", TEXT, "Advanced URL");
	$r->add_textbox("advanced_php_lib", TEXT, "Advanced PHP Library");
	$r->add_select("success_status_id", INTEGER, $order_statuses, "Success Status");
	$r->add_select("pending_status_id", INTEGER, $order_statuses, "Pending Status");
	$r->add_select("failure_status_id", INTEGER, $order_statuses, "Failure Status");
	$r->add_radio("failure_action", INTEGER, $failure_actions, "On Failure Action");
	$is_advanced = get_param("is_advanced");
	if ($is_advanced) {
		$r->change_property("advanced_url", REQUIRED, true);
		$r->change_property("advanced_php_lib", REQUIRED, true);
		$r->change_property("success_status_id", REQUIRED, true);
		$r->change_property("failure_status_id", REQUIRED, true);
	}
	$r->get_form_values();

	$rp = new VA_Record($table_prefix . "payment_parameters", "parameters");
	$rp->add_where("parameter_id", INTEGER);
	$rp->add_hidden("payment_id", INTEGER);
	$rp->change_property("payment_id", USE_IN_INSERT, true);
	$rp->add_textbox("parameter_name", TEXT, "Parameter Name");
	$rp->change_property("parameter_name", REQUIRED, true);

	$parameter_types = array(
		array("", ""), 
		array("CONSTANT", "Constant"), 
		array("VARIABLE", "Variable")
	);


	$rp->add_select("parameter_type", TEXT, $parameter_types, "Parameter Type");
	$rp->change_property("parameter_type", REQUIRED, true);

	$rp->add_textbox("parameter_source", TEXT, "Parameter Source");
	$rp->add_checkbox("not_passed", INTEGER, "Not Passed");
	
	$payment_id = get_param("payment_id");

	$more_parameters = get_param("more_parameters");
	$number_parameters = get_param("number_parameters");

	$eg = new VA_EditGrid($rp, "parameters");
	$eg->get_form_values($number_parameters);

	$operation = get_param("operation");

	$return_page = "admin_payment_systems.php";

	if(strlen($operation) && !$more_parameters)
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $payment_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "payment_systems WHERE payment_id=" . $db->tosql($payment_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));		
			$sql  = " DELETE FROM " . $table_prefix . "global_settings ";
			$sql .= " WHERE setting_type=" . $db->tosql("credit_card_info_" . $payment_id, TEXT);
			$sql .= " OR setting_type=" . $db->tosql("order_final_" . $payment_id, TEXT);
			$sql .= " OR setting_type=" . $db->tosql("recurring_" . $payment_id, TEXT);
			$db->query($sql);

			header("Location: " . $return_page);
			exit;
		}
		if ($r->get_value("processing_fee")) {
			$r->change_property("fee_type", REQUIRED, true);
		}
		$is_valid = $r->validate();
		$is_valid = ($eg->validate() && $is_valid); 

		if($is_valid)
		{
			if(strlen($payment_id))
			{
				$r->update_record();
				$eg->set_values("payment_id", $payment_id);
				$eg->update_all($number_parameters);
			}
			else
			{
				$db->query("SELECT MAX(payment_id) FROM " . $table_prefix . "payment_systems");
				$db->next_record();
				$payment_id = $db->f(0) + 1;
				$r->set_value("payment_id", $payment_id);
				$r->insert_record();
				$eg->set_values("payment_id", $payment_id);
				$eg->insert_all($number_parameters);
				// redirect to payment details page settings
				$return_page = "admin_credit_card_info.php?payment_id=" . urlencode($payment_id);
			}
			if ($r->get_value("is_default") == 1) {
				$sql = "UPDATE " . $table_prefix . "payment_systems SET is_default=0 WHERE payment_id<>" . $db->tosql($payment_id, INTEGER);
				$db->query($sql);
			}
			if ($r->get_value("is_advanced") == 1 && $r->get_value("is_call_center") == 1) {
				$sql = "UPDATE " . $table_prefix . "payment_systems SET is_call_center=0 WHERE payment_id<>".$db->tosql($payment_id, INTEGER);
				$db->query($sql);
			}
			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($payment_id) && !$more_parameters)
	{
		$r->get_db_values();
		$eg->set_value("payment_id", $payment_id);
		$eg->change_property("parameter_id", USE_IN_SELECT, true);
		$eg->change_property("parameter_id", USE_IN_WHERE, false);
		$eg->change_property("payment_id", USE_IN_WHERE, true);
		$eg->change_property("payment_id", USE_IN_SELECT, true);
		$number_parameters = $eg->get_db_values();
		if($number_parameters == 0)
			$number_parameters = 5;
	}
	else if($more_parameters)
	{
		$number_parameters += 5;
	}
	else
	{
		$r->set_value("submit_method", "GET");
		$number_parameters = 5;
	}

	$t->set_var("number_parameters", $number_parameters);

	$eg->set_parameters_all($number_parameters);
	$r->set_parameters();

	if(strlen($payment_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_payment_systems_href", "admin_payment_systems.php");
	$t->set_var("admin_payment_system_href",  "admin_payment_system.php");
	$t->set_var("admin_payment_help_href",    "admin_payment_help.php");
	$t->set_var("admin_order_final_href",     "admin_order_final.php");

	$t->pparse("main");

?>