<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_products_report.php                                ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/shopping_cart.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_products_report.html");
	$t->set_var("admin_products_report_href", "admin_products_report.php");

	$category_id = "";
	// get search parameters
	$s = trim(get_param("s"));
	$sc = get_param("sc");
	$sl = get_param("sl");
	if(strlen($sc)) { $category_id = $sc; }
	$search = (strlen($s) || strlen($sl) || strlen($category_id)) ? true : false;
	$sa = "";

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];

	// Top categogy
		$where = "";
		if(strlen($category_id)) {
			$where .= (!strlen($where)) ? " WHERE " : " AND ";
			$where .= "ic.category_id = " . $db->tosql($category_id, INTEGER);
		} else {
			$where .= (!strlen($where)) ? " WHERE " : " AND ";
			$where .= "ic.category_id = 0";
		}
		if($s) {
			$sa = split(" ", $s);
			for($si = 0; $si < sizeof($sa); $si++) {
				$where .= (!strlen($where)) ? " WHERE " : " AND ";
				$where .= " (i.item_name LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%'";
				$where .= " OR i.manufacturer_code LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%')";
			}
		}
		if(strlen($sl)) {
			if ($sl == 1) {
				$where .= (!strlen($where)) ? " WHERE " : " AND ";
				$where .= "(i.stock_level>0 OR i.stock_level IS NULL) ";
			} else {
				$where .= (!strlen($where)) ? " WHERE " : " AND ";
				$where .= "i.stock_level<1 ";
			}
		}

		$sql  = " SELECT i.item_id, i.manufacturer_code, i.item_name, i.price, i.is_sales, i.sales_price, i.stock_level, c.category_id";
 		$sql .= " FROM ((" . $table_prefix . "items i LEFT JOIN " . $table_prefix . "items_categories ic ON ic.item_id = i.item_id)";
		$sql .= " LEFT JOIN " . $table_prefix . "categories c ON c.category_id = ic.category_id)";
		$sql .= $where;
		$db->query($sql);
		if ($db->num_rows()) {
			$t->set_var("records", "");
			$parse_block=false;
			while($db->next_record()){
				$item_id = $db->f("item_id");
				$manufacturer_code = $db->f("manufacturer_code");
				$item_name = get_translation($db->f("item_name"));
				// higlight search text
				if(is_array($sa)) {
					for($si = 0; $si < sizeof($sa); $si++) {
						$manufacturer_code = preg_replace ("/(" . $sa[$si] . ")/i", "<font color=blue><b>\\1</b></font>", $manufacturer_code);
						$item_name = preg_replace ("/(" . $sa[$si] . ")/i", "<font color=blue><b>\\1</b></font>", $item_name);
					}
				}
				$price = $db->f("price");
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f("sales_price");
				$price = calculate_price($price, $is_sales, $sales_price);
				$price = $price * $currency_rate;
				$stock_level = $db->f("stock_level");
				if ($stock_level < 0) {
					$stock_level = "<font color=red>" . $stock_level . "</font>";
				}
				if ($db->f("category_id") == 0){
					$parse_block=true;
					$t->set_var("product_id",$item_id);
					$t->set_var("manufacturer_code",$manufacturer_code);
					$t->set_var("product_name",$item_name);
					$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
					$t->set_var("stock_level",$stock_level);
					$t->parse("records", true);
				}
			}
			if ($parse_block){
				$t->set_var("report_title", "Top");
				$t->parse("category", true);
			}
		}

	$categories = array();
	$sql  = " SELECT category_id, parent_category_id, category_name, category_path ";
	$sql .= " FROM " . $table_prefix . "categories ";
	$sql .= " ORDER BY category_order ";
	$db->query($sql);
	while ($db->next_record()) {
		$cur_category_id = $db->f("category_id");
		$category_name = get_translation($db->f("category_name"), $language_code);
		$parent_category_id = $db->f("parent_category_id");
		$category_path = $db->f("category_path");
		$categories[$cur_category_id]["category_name"] = $category_name;
		$categories[$cur_category_id]["category_path"] = $category_path;
		$categories[$parent_category_id]["subs"][] = $cur_category_id;
	}
		
	$sc_values[] = array("", "All Categories");
	$sc_values[] = array("0", "Top");
	if (sizeof($categories) > 0)
	{
		set_sub_categories(0, 0);
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	// set up search form parameters
	$stock_levels = 
		array( 
			array("", "All products"), array(0, "Out of stock products"), array(1, "In stock products")
		);
	set_options($stock_levels, $sl, "sl");

	set_options($sc_values, $sc, "sc");
	$t->set_var("s", $s);
	if($search) {
		$t->parse("search_results", false);
	}

	$t->parse("products_links", false);
	$t->pparse("main", false);

function set_sub_categories($top_id, $level) 
{
	global $t, $categories, $category_number, $db, $table_prefix, $search, $category_id, $s, $sl;
	global $currency_left, $currency_right, $currency_rate, $sc_values, $sa;

	$subs = $categories[$top_id]["subs"];
	$sub_indent = "";
	for ($i = 0; $i < $level; $i++) {
		$sub_indent .= "&bull;";
	}
	for ($i = 0; $i < sizeof($subs); $i++)
	{
		$category_number++;
		$show_category_id = $subs[$i];
		$category_name  = $categories[$show_category_id]["category_name"];

		$categories_path = "";
		foreach (explode(",", $categories[$show_category_id]["category_path"]) as $key => $value) {
			if ($value != "0"){
				if ($value == "") {$categories_path .= $category_name;}
				else {$categories_path .= $categories[$value]["category_name"]." > ";}
			}
		}
		$sc_values[]=array($show_category_id, $categories_path);

		$where = "";
		if(strlen($category_id)) {
			$where .= (!strlen($where)) ? " WHERE " : " AND ";
			$where .= "ic.category_id = " . $db->tosql($category_id, INTEGER);
		} else {
			$where .= (!strlen($where)) ? " WHERE " : " AND ";
			$where .= "ic.category_id = " . $db->tosql($show_category_id, INTEGER);
		}
		if($s) {
			$sa = split(" ", $s);
			for($si = 0; $si < sizeof($sa); $si++) {
				$where .= (!strlen($where)) ? " WHERE " : " AND ";
				$where .= " (i.item_name LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%'";
				$where .= " OR i.manufacturer_code LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%')";
			}
		}
		if(strlen($sl)) {
			if ($sl == 1) {
				$where .= (!strlen($where)) ? " WHERE " : " AND ";
				$where .= "(i.stock_level>0 OR i.stock_level IS NULL) ";
			} else {
				$where .= (!strlen($where)) ? " WHERE " : " AND ";
				$where .= "i.stock_level<1 ";
			}
		}

		$sql  = " SELECT i.item_id, i.manufacturer_code, i.item_name, i.price, i.is_sales, i.sales_price, i.stock_level, c.category_id";
 		$sql .= " FROM ((" . $table_prefix . "items i LEFT JOIN " . $table_prefix . "items_categories ic ON ic.item_id = i.item_id)";
		$sql .= " LEFT JOIN " . $table_prefix . "categories c ON c.category_id = ic.category_id)";
		$sql .= $where;
		$db->query($sql);
		if ($db->num_rows()) {
			$t->set_var("records", "");
			$parse_block=false;
			while($db->next_record()){
				$item_id = $db->f("item_id");
				$manufacturer_code = $db->f("manufacturer_code");
				$item_name = get_translation($db->f("item_name"));
				// higlight search text
				if(is_array($sa)) {
					for($si = 0; $si < sizeof($sa); $si++) {
						$manufacturer_code = preg_replace ("/(" . $sa[$si] . ")/i", "<font color=blue><b>\\1</b></font>", $manufacturer_code);
						$item_name = preg_replace ("/(" . $sa[$si] . ")/i", "<font color=blue><b>\\1</b></font>", $item_name);
					}
				}

				$price = $db->f("price");
				if ($db->f("is_sales")) {$price = $db->f("sales_price");}
				$stock_level = $db->f("stock_level");
				if ($stock_level < 0) {
					$stock_level = "<font color=red>" . $stock_level . "</font>";
				}
				if ($db->f("category_id") == $show_category_id){
					$parse_block=true;
					$t->set_var("product_id",$item_id);
					$t->set_var("manufacturer_code",$manufacturer_code);
					$t->set_var("product_name",$item_name);
					$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
					$t->set_var("stock_level",$stock_level);
					$t->parse("records", true);
				}
			}
			if ($parse_block){
				$t->set_var("report_title", $categories_path);
				$t->parse("category", true);
			}
		}

		if (isset($categories[$show_category_id]["subs"]) && is_array($categories[$show_category_id]["subs"])) {
			set_sub_categories($show_category_id, $level + 1);
		}

	}
}
?>