<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_properties_add.php                                 ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/tree.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_properties_add.html");

	$t->set_var("admin_property_href", "admin_property.php");
	$t->set_var("admin_properties_add_href", "admin_properties_add.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_product_href", "admin_product.php");

	$item_id = get_param("item_id");
	$category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	include("./admin_header.php");
	include("./admin_footer.php");


	$sql  = " SELECT item_name FROM " . $table_prefix . "items ";
	$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
	$db->query($sql);
	if($db->next_record())
		$t->set_var("item_name", $db->f("item_name"));
	else
		die("Product with such ID no longer exists in database.");


	$errors = "";
	$properties = array();
	$properties_number = get_param("properties_number");
	$operation = get_param("operation");
	$rp = get_param("rp");
	if(!strlen($rp)) {
		$rp = "admin_items_list.php?category_id=" . $category_id;
	}

	if(strlen($operation))
	{
		if ($operation == "cancel") {
			header("Location: " . $rp);
			exit;
		} else if ($operation == "save") {
			$property_order = 0;
			for ($i = 1; $i <= $properties_number; $i++) {
				$property_name = get_param("property_name_" . $i);
				$property_text = get_param("property_text_" . $i);
				if(strlen($property_name) && strlen($property_text)) {
					$property_order++;
					$sql  = "INSERT INTO " . $table_prefix . "items_properties (item_id, property_order, property_name, property_description, control_type, required, use_on_list, use_on_details, use_on_checkout) VALUES (";
					$sql .= $item_id . ", " . $db->tosql($property_order, INTEGER) . ", ";
					$sql .= $db->tosql($property_name, TEXT) . ", " . $db->tosql($property_text, TEXT) . ", 'LABEL', 0, 1, 1, 0)";
					$db->query($sql);
				}
			}

			header("Location: " . $rp);
			exit;
		}
	}
	else // get default settings
	{
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "items_properties ";
		$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$db->query($sql);
		$db->next_record();
		$total_properties = $db->f(0);
		if($total_properties > 0) {
			$rp = "admin_properties.php?category_id=" . $category_id . "&item_id=" . urlencode($item_id);
			header("Location: " . $rp);
			exit;
		}

		$sql  = " SELECT setting_name FROM " . $table_prefix . "global_settings ";
		$sql .= " WHERE setting_type='default_property'";
		$sql .= " ORDER BY setting_value ";
		$db->query($sql);
		if($db->next_record()) {
			do {
				$properties[] = $db->f("setting_name");
			} while ($db->next_record());
		} else {
			header("Location: " . $rp);
			exit;
		}
	}

	for ($i = 0; $i < sizeof($properties); $i++) {
		$t->set_var("property_number", ($i + 1));
		$t->set_var("property_name", $properties[$i]);
		$t->set_var("property_translation", get_translation($properties[$i]));
		$t->parse("default_properties", true);
	}

	$t->set_var("properties_number", sizeof($properties));
	$t->set_var("rp", htmlspecialchars($rp));
	$t->set_var("item_id", htmlspecialchars($item_id));
	$t->set_var("category_id", htmlspecialchars($category_id));


	$t->pparse("main");

?>