<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_select.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/sorter.php");
	//include_once($root_folder_path . "includes/image_functions.php");
	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_select.html");

	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");

	$filetype = get_param("filetype");
	$sort_dir = get_param("sort_dir");
	if (!$sort_dir) { $sort_dir = "asc"; }
	$search_image = get_param("s_im");
	$image_index = get_param("image_index");

	$downloads_dir = ""; 
	if ($filetype == "downloads") {
		$download_info = array();
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='download_info'";
		$db->query($sql);
		while ($db->next_record()) {
			$download_info[$db->f("setting_name")] = $db->f("setting_value");
		}
		$downloads_dir = get_setting_value($download_info, "downloads_admins_dir", "../");
		if (!preg_match("/[\/\\\\]$/", $downloads_dir)) { $downloads_dir .= "/"; }
	}

	$t->set_var("s_im", $search_image);

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_select.php");
	$s->set_parameters(false, true, true, true);
	$s->set_default_sorting("1", "asc");
	$s->set_sorter("Image Filename", "image_filename", "1", "");

	$t->set_var("filetype", $filetype);
	$t->set_var("image_index", $image_index);

	if ($filetype == "small_image") {
		$files_dir = "../images/small/";
	} elseif ($filetype == "big_image") {
		$files_dir = "../images/big/";
	} elseif ($filetype == "super_image") {
		$files_dir = "../images/super/";
	} elseif ($filetype == "article_small") {
		$files_dir = "../images/articles/small/";
	} elseif ($filetype == "article_large") {
		$files_dir = "../images/articles/large/";
	} elseif ($filetype == "category" || $filetype == "category_small") {
		$files_dir = "../images/categories/";
	} elseif ($filetype == "category_large") {
		$files_dir = "../images/categories/large/";
	} elseif ($filetype == "company_small" || $filetype == "company_large") {
		$files_dir = "../images/companies/";
	} elseif ($filetype == "ad_small") {
		$files_dir = "../images/ads/small/";
	} elseif ($filetype == "ad_large") {
		$files_dir = "../images/ads/large/";
	} elseif ($filetype == "forum_small") {
		$files_dir = "../images/forum/small/";
	} elseif ($filetype == "forum_large") {
		$files_dir = "../images/forum/large/";	
	} elseif ($filetype == "banner") {
		$files_dir = "../images/bnrs/";
	} elseif ($filetype == "personal") {
		$files_dir = "../images/users/";
	} elseif ($filetype == "downloads") {
		$files_dir = $downloads_dir;
	} elseif ($filetype == "manufacturer_small") { 
		$files_dir = "../images/manufacturers/small/"; 
	} elseif ($filetype == "manufacturer_large") {
		$files_dir = "../images/manufacturers/large/";
	} else {
		$files_dir = "../images/";
	}

	$dir_values = array();
	if ($dir = @opendir($files_dir)) 
	{
		$dir_index = 0;
		while ($file = readdir($dir))
		{
			if ($file != "." && $file != ".." && is_file($files_dir . $file)) 
			{ 
				$dir_values[$dir_index] = $file;
				$dir_index++;
			} 
		}  
		closedir($dir);
	}

	if ($sort_dir == "desc") {
		array_multisort($dir_values, SORT_DESC);
	}
	if ($sort_dir == "asc") {
		array_multisort($dir_values, SORT_ASC);
	}

	if (strlen($search_image)) {
		$search_image = preg_quote($search_image, "/");
		$found_image=array();
		for ($i = 0; $i < sizeof($dir_values); $i++)
		{
			if (strlen($search_image) <= strlen($dir_values[$i])) {
				if (preg_match("/".$search_image."/i", $dir_values[$i])) {
					$found_image[]=$dir_values[$i];
				}
			}
		}
		$dir_values = $found_image;
	}

	$image_number = isset($dir_values) ? sizeof($dir_values) : 0;
	
	if ($image_number)
	{
		for ($i = 0; $i < sizeof($dir_values); $i++)
		{
			$image_name = $dir_values[$i];
			$image_name_js = str_replace("'", "\\'", $image_name);
			if ($filetype == "downloads") {
				$downloads_dir_js = str_replace("\\", "\\\\", $downloads_dir);
				$downloads_dir_js = preg_replace("/^\.\.\//", "", $downloads_dir_js);
				$image_name_js = $downloads_dir_js . $image_name_js;
			}
			$t->set_var("image_href", $files_dir . $dir_values[$i]);
			$t->set_var("image_name", $image_name);
			$t->set_var("image_name_js", $image_name_js);

			/*
			$image_preview_dir = $files_dir."preview/";
			$t->set_var("image_anchor_name", "anchor_".$i);
			$t->set_var("image_preview_href", $image_preview_dir . $dir_values[$i]);
			$resize_errors="";
			if (!file_exists($image_preview_dir)){
				@mkdir($image_preview_dir,0777);
			}
			resize($filename, $origin_dir, $dest_dir, $width, $height, &$resize_errors);
			resize($dir_values[$i], $files_dir, $image_preview_dir, 32, 32, $resize_errors);
			*/

			$t->parse("image_row", true);
		}

		$t->set_var("no_images", "");
		$t->parse("images", false);
	}
	else
	{
		$t->parse("no_images", false);
		$t->set_var("images", "");
	}

	if (!$image_number and !strlen($search_image)) {	
		$t->set_var("search_images", "");
	} else {
		$t->parse("search_images", false);
	}


	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>