<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_shipping_type.php                                  ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("shipping_methods");

	$shipping_module_id = get_param("shipping_module_id");
	$shipping_type_id = get_param("shipping_type_id");
	$weight_measure = get_setting_value($settings, "weight_measure", "");

	if ($shipping_module_id) {
		$sql  = " SELECT shipping_module_id, shipping_module_name ";
		$sql .= " FROM " . $table_prefix . "shipping_modules WHERE shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER);
	} else {
		$sql  = " SELECT sm.shipping_module_id, sm.shipping_module_name ";
		$sql .= " FROM (" . $table_prefix . "shipping_modules sm ";
		$sql .= " INNER JOIN " . $table_prefix . "shipping_types st ON sm.shipping_module_id=st.shipping_module_id) ";
		$sql .= " WHERE st.shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER);
	}
	$db->query($sql);
	if ($db->next_record()) {
		$shipping_module_id = $db->f("shipping_module_id");
		$shipping_module_name = $db->f("shipping_module_name");
	} else {
		header ("Location: admin_shipping_modules.php");
		exit;
	}

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_shipping_type.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href",    "admin_lookup_tables.php");
	$t->set_var("admin_shipping_types_href",   "admin_shipping_types.php");
	$t->set_var("admin_shipping_type_href",    "admin_shipping_type.php");
	$t->set_var("admin_shipping_modules_href", "admin_shipping_modules.php");
	$t->set_var("admin_shipping_module_href",  "admin_shipping_module.php");
	$t->set_var("shipping_module_id",          $shipping_module_id);
	$t->set_var("shipping_module_name",        $shipping_module_name);
	$t->set_var("weight_measure",              $weight_measure);

	$r = new VA_Record($table_prefix . "shipping_types");
	$r->return_page = "admin_shipping_types.php";

	$r->add_where("shipping_type_id", INTEGER);
	$r->add_hidden("shipping_module_id", INTEGER);
	$r->change_property("shipping_module_id", USE_IN_INSERT, true);
	$r->change_property("shipping_module_id", USE_IN_SELECT, true);
	$r->add_checkbox("is_active", INTEGER);
	$r->change_property("is_active", DEFAULT_VALUE, 1);
	$r->add_textbox("shipping_order", INTEGER, "Shipping Order");
	$r->change_property("shipping_order", REQUIRED, true);
	$r->add_textbox("shipping_time", INTEGER, "Shipping Time");

	$r->add_textbox("shipping_type_code", TEXT, "Shipping Code");
	$r->add_textbox("shipping_type_desc", TEXT, "Shipping Description");
	$r->change_property("shipping_type_desc", REQUIRED, true);
	$r->add_textbox("min_goods_cost", NUMBER, "Minimum Goods Cost");
	$r->change_property("min_goods_cost", REQUIRED, true);
	$r->add_textbox("max_goods_cost", NUMBER, "Maximum Goods Cost");
	$r->change_property("max_goods_cost", REQUIRED, true);
	$r->add_textbox("min_weight", NUMBER, "Minimum Weight");
	$r->change_property("min_weight", REQUIRED, true);
	$r->add_textbox("max_weight", NUMBER, "Maximum Weight");
	$r->change_property("max_weight", REQUIRED, true);
	$r->add_textbox("tare_weight", NUMBER, "Tare Weight");
	$r->add_textbox("cost_per_order", NUMBER);
	$r->add_textbox("cost_per_product", NUMBER);
	$r->add_textbox("cost_per_weight", NUMBER);
	$r->add_checkbox("is_taxable", INTEGER);
	$r->change_property("is_taxable", DEFAULT_VALUE, 1);
	$r->events[BEFORE_INSERT] = "set_shipping_type_id";
	$r->events[AFTER_INSERT] = "update_shipping_countries";
	$r->events[AFTER_UPDATE] = "update_shipping_countries";
	$r->events[AFTER_DELETE] = "delete_shipping_countries";
	$r->set_event(BEFORE_DEFAULT, "set_shipping_order");

	$r->add_hidden("page", INTEGER);

	$r->process();

	$t->set_var("countries", "");
	$t->set_var("selected_countries", "");

	$sql = " SELECT country_code, country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ";
	$db->query($sql);
	while($db->next_record())
	{
		$t->set_var("country_code", strtoupper($db->f("country_code")));
		$t->set_var("country_name", str_replace("\"", "\\\"", $db->f("country_name")));
		$t->parse("countries");
	}

	$operation = get_param("operation");
	if ($operation == "save") {
		$countries = get_param("countries");
		if($countries) {
			$selected_countries = split(",", $countries);
			for($i = 0; $i < sizeof($selected_countries); $i++) {
				$t->set_var("country_code", strtoupper($selected_countries[$i]));
				$t->parse("selected_countries");
			}
		}
	} else if($r->get_value("shipping_type_id")) {
		$sql = " SELECT country_code FROM " . $table_prefix . "shipping_types_countries WHERE shipping_type_id=" . $db->tosql($r->get_value("shipping_type_id"), INTEGER);
		$db->query($sql);
		while($db->next_record())
		{
			$t->set_var("country_code", strtoupper($db->f("country_code")));
			$t->parse("selected_countries");
		}
	}

	include("./admin_header.php");
	include("./admin_footer.php");


	$t->pparse("main");

	function set_shipping_type_id()  {
		global $db, $table_prefix, $r;
		$sql = "SELECT MAX(shipping_type_id) FROM " . $table_prefix . "shipping_types";
		$db->query($sql);
		if($db->next_record()) {
			$shipping_type_id = $db->f(0) + 1;
			$r->change_property("shipping_type_id", USE_IN_INSERT, true);
			$r->set_value("shipping_type_id", $shipping_type_id);
		}	
	}

	function set_shipping_order()  {
		global $db, $table_prefix, $r;
		$sql = "SELECT MAX(shipping_order) FROM " . $table_prefix . "shipping_types";
		$db->query($sql);
		if($db->next_record()) {
			$shipping_order = $db->f(0) + 1;
			$r->change_property("shipping_order", DEFAULT_VALUE, $shipping_order);
		}	
	}

	function update_shipping_countries()  {
		global $db, $table_prefix, $r;

		$shipping_type_id = $r->get_value("shipping_type_id");
		$db->query("DELETE FROM " . $table_prefix . "shipping_types_countries WHERE shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER));

		$countries = get_param("countries");
		if (strlen($countries)) {
			$selected_countries = split(",", $countries);
			for($i = 0; $i < sizeof($selected_countries); $i++) {
				$db->query("INSERT INTO " . $table_prefix . "shipping_types_countries (shipping_type_id, country_code) VALUES (" . $db->tosql($shipping_type_id, INTEGER) . "," . $db->tosql($selected_countries[$i], TEXT) . ")");
			}
		}
	}

	function delete_shipping_countries()  {
		global $db, $table_prefix, $r;
		$shipping_type_id = $r->get_value("shipping_type_id");
		$db->query("DELETE FROM " . $table_prefix . "shipping_types_countries WHERE shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER));
	}

?>