<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  admin_upload.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/image_functions.php");
	include_once($root_folder_path . "messages/".$language_code."/download_messages.php");

	include_once($root_folder_path."messages/".$language_code."/admin_messages.php");

	check_admin_security("products_categories");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_upload.html");

	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_upload_href", "admin_upload.php");

	$filetype = get_param("filetype");
	$image_index = get_param("image_index");
	$t->set_var("image_index", $image_index);
	$operation = get_param("operation");
	$current_index = 0;

	$downloads_dir = ""; $files_regexp = "";
	if ($filetype == "downloads") {
		$download_info = array();
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='download_info'";
		$db->query($sql);
		while ($db->next_record()) {
			$download_info[$db->f("setting_name")] = $db->f("setting_value");
		}
		$downloads_dir = get_setting_value($download_info, "downloads_admins_dir", "../");
		if (!preg_match("/\/|\\$/", $downloads_dir)) { $downloads_dir .= "/"; }
		$downloads_mask = get_setting_value($download_info, "downloads_admins_mask", "");
		if ($downloads_mask) {
			$files_regexp = preg_replace("/\s/", "", $downloads_mask);
			$s = array("\\","^","\$",".","[","]","|","(",")","+","{","}");
			$r = array("\\\\","\\^","\\\$","\\.","\\[","\\]","\\|","\\(","\\)","\\+","\\{","\\}");
			$files_regexp = str_replace($s, $r, $files_regexp);
			$files_regexp = str_replace(array(",", ";", "*", "?"), array(")|(", ")|(", ".*", "."), $files_regexp);
			$files_regexp = "/^((" . $files_regexp . "))$/i";
		}
	}

	$errors = "";

	if ($operation == "1")
	{
		//BEGIN Image Resizing changes
		$is_generate_small_image = get_param("is_generate_small_image");
		$is_generate_big_image = get_param("is_generate_big_image");
		$sql = "UPDATE " . $table_prefix . "admins SET is_generate_small_image=" . $db->tosql($is_generate_small_image, INTEGER);
		$sql .= ", is_generate_big_image=" . $db->tosql($is_generate_big_image, INTEGER);
		$sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		$db->query($sql);
		//END Image Resizing changes

		if (isset($_FILES)) {
			$tmp_name = $_FILES["newfile"]["tmp_name"];
			$filename = $_FILES["newfile"]["name"];
			$filesize = $_FILES["newfile"]["size"];
			$upload_error = isset($_FILES["newfile"]["error"]) ? $_FILES["newfile"]["error"] : "";
		} else {
			$tmp_name = $HTTP_POST_FILES["newfile"]["tmp_name"];
			$filename = $HTTP_POST_FILES["newfile"]["name"];
			$filesize = $HTTP_POST_FILES["newfile"]["size"];
			$upload_error = isset($HTTP_POST_FILES["newfile"]["error"]) ? $HTTP_POST_FILES["newfile"]["error"] : "";
		}
		$filename = strip($filename);

		if ($upload_error == 1) {
			$errors = "The uploaded file exceeds the max filesize directive.";
		} elseif ($upload_error == 2) {
			$errors = "The uploaded file exceeds the max filesize parameter.";
		} elseif ($upload_error == 3) {
			$errors = "The uploaded file was only partially uploaded.";
		} elseif ($upload_error == 4) {
			$errors = UPLOAD_SELECT_ERROR;
		} elseif ($upload_error == 6) {
			$errors = "Missing a temporary folder.";
		} elseif ($upload_error == 7) {
			$errors = "Failed to write file to disk.";
		} elseif ($tmp_name == "none" || !strlen($tmp_name)) {
			$errors = UPLOAD_SELECT_ERROR;
		} elseif (strlen($files_regexp)) {
			if (!preg_match($files_regexp, $filename)) {
				$errors = UPLOAD_FORMAT_ERROR;
			}
		} elseif (!(preg_match("/((.gif)|(.jpg)|(.jpeg)|(.bmp)|(.tiff)|(.tif)|(.png)|(.ico)|(.doc)|(.txt)|(.rtf)|(.pdf)|(.swf))$/i", $filename)) ) {
			$errors = UPLOAD_FORMAT_ERROR;
		}

		if (!strlen($errors))
		{
			$images_root = "../images/";
			$small_dir_suffix = "small/";
			$big_dir_suffix = "big/";
			$large_dir_suffix = "large/";
			$super_dir_suffix = "super/";
			
			if ($filetype == "small_image") { $filepath = $images_root . $small_dir_suffix; }
			elseif ($filetype == "big_image") { $filepath = $images_root . $big_dir_suffix; }
			elseif ($filetype == "super_image") { $filepath = $images_root . $super_dir_suffix; }
			elseif ($filetype == "article_small") { $filepath = $images_root . "articles/" . $small_dir_suffix; }
			elseif ($filetype == "article_large") { $filepath = $images_root . "articles/" . $large_dir_suffix; }
			elseif ($filetype == "category" || $filetype == "category_small") { $filepath = $images_root . "categories/"; }
			elseif ($filetype == "category_large") { $filepath = $images_root . "categories/" . $large_dir_suffix; }
			elseif ($filetype == "company_small" || $filetype == "company_large") { $filepath = $images_root . "companies/"; }
			elseif ($filetype == "document") { $filepath = $images_root . "documents/"; }
			elseif ($filetype == "ad_small") { $filepath = $images_root . "ads/" . $small_dir_suffix; }
			elseif ($filetype == "ad_large") { $filepath = $images_root . "ads/" . $large_dir_suffix; }
			elseif ($filetype == "forum_small") { $filepath = $images_root . "forum/" . $small_dir_suffix; }
			elseif ($filetype == "forum_large") { $filepath = $images_root . "forum" . $large_dir_suffix; }
			elseif ($filetype == "banner") { $filepath = $images_root . "bnrs/"; }
			elseif ($filetype == "personal") { $filepath = $images_root . "users/"; }
			elseif ($filetype == "downloads") { $filepath = $downloads_dir; }
			elseif ($filetype == "manufacturer_small") { $filepath = $images_root . "manufacturers/" . $small_dir_suffix; }
			elseif ($filetype == "manufacturer_large") { $filepath = $images_root . "manufacturers/" . $large_dir_suffix; }
			else { $filepath = $images_root; }
			// add slash at the end of file path if it's absent
			if (substr($filepath, -1) != "/") {
				$filepath .= "/";
			}

			$check_filepaths = array();
			if ($filetype == "small_image" || $filetype == "big_image" || $filetype == "super_image") {
				$check_filepaths[] = $images_root .	$small_dir_suffix;
				$check_filepaths[] = $images_root .	$big_dir_suffix;
				$check_filepaths[] = $images_root .	$super_dir_suffix;
			} else {
				$check_filepaths[] = $filepath;
			}

			$uploaded_filename = get_new_file_name ($check_filepaths, $filename);

			if (!@move_uploaded_file($tmp_name, $filepath . $uploaded_filename)) 
			{
				if (!is_dir($filepath)) {
					$errors = "The folder '" . $filepath . "' doesn't exist.";
				} elseif (!is_writable($filepath)) {
					$errors = str_replace("{folder_name}", $filepath, FOLDER_PERMISSION_MESSAGE);
				} else {
					$errors = "System can't create the file <b>" . $filepath . $uploaded_filename . "</b>";
				}
			} 
			else 
			{
				chmod($filepath . $filename, 0666);
				$filename_js = str_replace("'", "\\'", $uploaded_filename);
				if ($filetype == "downloads") {
					$filename_js = $downloads_dir . $filename_js;
				}
				$t->set_var("filename", $filename);
				$t->set_var("filename_js", $filename_js);
				$uploaded_file = str_replace("{filename}", $uploaded_filename, UPLOADED_FILE_MSG);
				$t->set_var("UPLOADED_FILE_MSG", $uploaded_file);
				
				$t->set_var("generate_small", $is_generate_small_image);
				$t->set_var("generate_big", $is_generate_big_image);
				
				$resize_small_image = get_setting_value($settings, "resize_small_image", 0);
				$resize_big_image = get_setting_value($settings, "resize_big_image", 0);
				$resize_super_image = get_setting_value($settings, "resize_super_image", 0);
				
				$errors = "";
				$gd_loaded = true;                                       
				if ($filetype == "small_image" || $filetype == "big_image" || $filetype == "super_image") {
					if ($is_generate_small_image || $resize_small_image) {
						$small_width = get_setting_value($settings, "small_image_max_width", 100);
						$small_height = get_setting_value($settings, "small_image_max_height", 100);
						if (@resize($uploaded_filename, $filepath, $images_root.$small_dir_suffix, $small_width, $small_height, $errors))	{
							chmod($images_root . $small_dir_suffix . $uploaded_filename, 0666);
						}						
					}
					if ($is_generate_big_image || $resize_big_image) {
						$big_width = get_setting_value($settings, "big_image_max_width", 300);
						$big_height = get_setting_value($settings, "big_image_max_height", 300);
						if (@resize($uploaded_filename, $filepath, $images_root.$big_dir_suffix, $big_width, $big_height, $errors))	{
							chmod($images_root.$big_dir_suffix.$uploaded_filename, 0766);
						}
					}
					if ($resize_super_image) {
						$super_width = get_setting_value($settings, "super_image_max_width", 1024);
						$super_height = get_setting_value($settings, "super_image_max_height", 768);
						if (@resize($uploaded_filename, $filepath, $images_root.$super_dir_suffix, $super_width, $super_height, $errors))	{
							chmod($images_root.$super_dir_suffix.$uploaded_filename, 0766);
						}
					}
				}
			}
		}

		if (strlen($errors)) {
			$t->set_var("after_upload", "");
			$t->set_var("errors_list", $errors);
			$t->parse("errors", false);
		} else {
			$t->set_var("errors", "");
		}
	}

	$t->set_var("filetype", $filetype);

	if ($operation == "1" && !strlen($errors))
	{
		$t->set_var("before_upload", "");
		$t->parse("after_upload", false);
	} else {
		if ($filetype == "small_image")
		{
			$resize_small_image = get_setting_value($settings, "resize_small_image", 0);
			if ($resize_small_image) {
				$t->set_var("resize_small_image", $resize_small_image);
			} else {
				$t->set_var("resize_small_image", "");
			}
		}
		elseif ($filetype == "big_image")
		{
			$resize_big_image = get_setting_value($settings, "resize_big_image", 0);
			if ($resize_big_image) {
				$t->set_var("resize_big_image", $resize_big_image);
			} else {
				$t->set_var("resize_big_image", "");
			}
			
			$sql = " SELECT is_generate_small_image FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
			$is_generate_small = get_db_value($sql);
			if ($is_generate_small) {
				$t->set_var("is_generate_small_image", 'checked="checked"');
			} else {
				$t->set_var("is_generate_small_image", "");
			}
			$t->parse("generate_small_image", false);
		}
		elseif ($filetype == "super_image")
		{
			$resize_super_image = get_setting_value($settings, "resize_super_image", 0);
			if ($resize_super_image) {
				$t->set_var("resize_super_image", $resize_super_image);
			} else {
				$t->set_var("resize_super_image", "");
			}
		
			$sql = " SELECT is_generate_small_image, is_generate_big_image FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
			$db->query($sql);
			if ($db->next_record()) {
				$is_generate_small = $db->f("is_generate_small_image");
				$is_generate_big = $db->f("is_generate_big_image");
			}
			if ($is_generate_small) {
				$t->set_var("is_generate_small_image", 'checked="checked"');
			} else {
				$t->set_var("is_generate_small_image", "");
			}
			if ($is_generate_big) {
				$t->set_var("is_generate_big_image", 'checked="checked"');
			} else {
				$t->set_var("is_generate_big_image", "");
			}
			$t->parse("generate_small_image", false);
			$t->parse("generate_big_image", false);
		}
		$t->parse("before_upload", false);
		$t->set_var("after_upload", "");
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");
	
?>