<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  barcode_image.php                                        ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/



	include_once ("./includes/barcode_functions.php");

	$text = isset($_REQUEST['text']) ? $_REQUEST['text'] : '123456789012';
	$imgtype = isset($_REQUEST['imgtype']) ? $_REQUEST['imgtype'] : 'png';
	$codetype = isset($_REQUEST['codetype']) ? $_REQUEST['codetype'] : 'code128';

	$errors = "";
	if (!gd_error($errors)) {
 	 	switch ($codetype) {
			case "code128":
			if ((preg_match( "/[^0-9A-Z\-*+\$%\/. ]/i", $text )) || (strlen($text) < 1)) {
				$errors	.= "Code-128 string must consist 12 symbols";
			}	else {
				$img = barcode_code128($text);
			}
			break;
			case "ean13":
			if ((!preg_match("/[0-9]/",$text)) || (strlen($text) != 12)) {
				$errors	.= "EAN string must consist 12 symbols (13th is checksum)";
			}	else {
				$img = barcode_ean13($text);
			}
			break;
			case "code39":
			if ((preg_match( "/[^0-9A-Z\-*+\$%\/. ]/", $text )) || (strlen($text)!=12)) {
				$errors	.= "Invalid text for Code39";
			}	else {
				$img = barcode_code39($text);
			}
			break;
			case "int25":
			if ((!preg_match("/[0-9]/",$text)) || (strlen($text)!=12)) {
				$errors	.= "Invalid text for Int25";
			}	else {
				$img = barcode_int25($text);
			}
			break;
			case "upca":
			if ((!preg_match("/[0-9]/",$text)) || (strlen($text)!=12)) {
				$errors	.= "Invalid text for Int25";
			}	else {
				$img = barcode_upca($text);
			}
			break;
			case "postnet":
			if (!preg_match("/[0-9]/",$text)) {
				$errors	.= "Code-128 string must consist 12 symbols";
			}	else {
				$img = barcode_postnet($text);
			}
			break;
			default:	      	  
				$errors	.= "Invalid code type. Supported codes: code128, code39, upca, ean13, int25, postnet.";
		}

		if ($errors!="") {
			die($errors);
		}
	  
 	 	switch ($imgtype) {
			case "gif":
				if (imagetypes() & IMG_GIF) {
					header("Content-type: image/gif");
					imagegif($img);
				} else {
					$errors	.= "GIF image format is not supported by GD.";
				}
			break;
			case "jpg":
				if (imagetypes() & IMG_JPG) {
					header("Content-type: image/jpeg");
					imagejpeg($img);      	
				} else {
					$errors	.= "JPEG image format is not supported by GD.";
				}
			break;
			case "png":
				if (imagetypes() & IMG_PNG) {
					header("Content-type: image/png");
					imagepng($img);    	
				} else {
					$errors	.= "PNG image format is not supported by GD.";
				}
			break;            
			default:	      	  
				$errors	.= "Invalid image format. Format must be png, jpg or png";	
		}

		if ($errors!="") {
			imagedestroy($img);
			die($errors);
		}

		imagedestroy($img);

	}else {
		die($errors);
	}
	                
?>