<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_ads_breadcrumb.php                                 ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function ads_breadcrumb($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$t->set_file("block_body", "block_ads_breadcrumb.html");

	$category_id = get_param("category_id");
	$search_category_id = get_param("search_category_id");
	if(strlen($search_category_id)) {
		$category_id = $search_category_id;
	}
	$user = get_param("user");

	$item_id = get_param("item_id");
	if (!strlen($category_id) && strlen($item_id)) {
		$category_id = get_db_value("SELECT category_id FROM " . $table_prefix . "ads_assigned WHERE item_id=" . $db->tosql($item_id, INTEGER));
	}

	$t->set_var("index_href", "index.php");
	$t->set_var("HOME_PAGE_TITLE", HOME_PAGE_TITLE);

	if ($category_id) {
		$current_id = $category_id;
		$sql  = " SELECT category_id, category_name, friendly_url, parent_category_id ";
		$sql .= " FROM " . $table_prefix . "ads_categories";
		$sql .= " WHERE category_id=";
		while ($current_id)
		{
			$db->query($sql . $db->tosql($current_id, INTEGER));
			if($db->next_record()) {
				$category_name = $db->f("category_name");
				$category_name = get_translation($category_name);
				$friendly_url = $db->f("friendly_url");
				if ($friendly_urls && $friendly_url) {
					$tree_url = $friendly_url . $friendly_extension;
				} else {
					$tree_url = "ads.php?category_id=". $current_id;
				}
				$t->set_var("tree_url", $tree_url);
				$t->set_var("tree_title", $category_name);
				$t->rparse("tree");
				$current_id= $db->f("parent_category_id");
			} else {
				$current_id = "0";
			}
		}
	}

	$t->set_var("tree_url", "ads.php");
	$t->set_var("tree_title", ADS_TITLE);
	$t->rparse("tree");


	if (strlen($user)) {
		$sql = "SELECT login,name,first_name,last_name FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$name = $db->f("name");
			$login = $db->f("login");
			$first_name = $db->f("first_name");
			$last_name = $db->f("last_name");
			if (strlen($name)) {
				$user_name = $name;
			} else if (strlen($first_name) || strlen($last_name)) {
				$user_name = $first_name." ".$last_name;
			} else {
				$user_name = $login;
			}

			$tree_url = "ads.php?category_id=" . urlencode($category_id) . "&user=" . urlencode($user);
			$t->set_var("tree_url", $tree_url);
			$t->set_var("tree_title", htmlspecialchars($user_name));
			$t->parse("tree", true);
		}
	}

	if (strlen($item_id)) {
		$sql = "SELECT item_title, friendly_url FROM " . $table_prefix . "ads_items WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$item_title = get_translation($db->f("item_title"));
			$friendly_url = $db->f("friendly_url");
			if ($friendly_urls && $friendly_url) {
				$tree_url = $friendly_url . $friendly_extension;
				if ($category_id) {
					$tree_url .= "?category_id=" . urlencode($category_id);
				}
			} else if ($category_id) {
				$tree_url = "ads_details.php?category_id=" . urlencode($category_id) . "&item_id=" . urlencode($item_id);
			} else {
				$tree_url = "ads_details.php?item_id=" . urlencode($item_id);
			}
			$t->set_var("tree_url", $tree_url);
			$t->set_var("tree_title", htmlspecialchars($item_title));
			$t->parse("tree", true);
		}
	}

	$t->parse("block_body", false);
	$t->parse($block_name, true);

}

?>