<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_articles_top_viewed.php                            ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function articles_top_viewed($block_name, $top_id, $top_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $datetime_show_format;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	if (!strlen($top_name)) {
		$sql  = " SELECT category_name ";
		$sql .= " FROM " . $table_prefix . "articles_categories ";
		$sql .= " WHERE category_id=" . $db->tosql($top_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$top_name = get_translation($db->f("category_name"));
		}
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$t->set_file("block_body", "block_articles_top_viewed.html");
	$t->set_var("top_viewed_rows", "");
	$t->set_var("top_viewed_rows", "");
	$t->set_var("top_category_name",$top_name);

	$sql  = " SELECT a.article_id, a.article_title, a.total_views, a.friendly_url, a.article_date, a.short_description ";
	$sql .= " FROM " . $table_prefix . "articles a ";
	$sql .= " , " . $table_prefix . "articles_statuses st ";
	$sql .= " , " . $table_prefix . "articles_assigned aa ";
	$sql .= " , " . $table_prefix . "articles_categories ac ";
	$sql .= " WHERE a.status_id=st.status_id AND a.article_id=aa.article_id AND aa.category_id=ac.category_id ";
	$sql .= " AND (ac.category_id=" . $db->tosql($top_id, INTEGER);
	$sql .= " OR ac.category_path LIKE '0," . $top_id . ",%') ";
	$sql .= " AND st.allowed_view=1 ";
	$sql .= " GROUP BY a.article_id, a.total_views, a.image_small, a.short_description, a.article_date, a.date_end, a.article_title, a.friendly_url, a.article_order, a.date_added, a.date_updated ";
	$sql .= " ORDER BY a.total_views DESC, a.article_order, a.article_title ";

	$records_per_page = get_setting_value($page_settings, "a_top_viewed_recs_" . $top_id, 10);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$top_columns = get_setting_value($page_settings, "a_top_viewed_cols_" . $top_id, 1);
		$t->set_var("top_viewed_column", (100 / $top_columns) . "%");
		$top_number = 0;
		do
		{
			$top_number++;
			$article_id = $db->f("article_id");
			$article_title = get_translation($db->f("article_title"));
			$friendly_url = $db->f("friendly_url");
			$total_views = $db->f("total_views");
			$short_description = get_translation($db->f("short_description"));
			if ($friendly_urls && $friendly_url) {
				$t->set_var("article_url", $friendly_url . $friendly_extension);
			} else {
				$t->set_var("article_url", "article.php?article_id=" . $article_id);
			}
		
			$t->set_var("top_position", $top_number);
			$t->set_var("article_id", $article_id);
			$t->set_var("article_title", $article_title);
			$t->set_var("total_views", $total_views);
			$t->set_var("short_description", $short_description);

			$article_date = $db->f("article_date", DATETIME);
			$article_date_string  = va_date($datetime_show_format, $article_date);
			$t->set_var("article_date", $article_date_string);

			$t->parse("top_viewed_cols");
			if($top_number % $top_columns == 0)
			{
				$t->parse("top_viewed_rows");
				$t->set_var("top_viewed_cols", "");
			}
			
		} while ($db->next_record());              	

		if ($top_number % $top_columns != 0) {
			$t->parse("top_viewed_rows");
		}

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>