<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_cart.php                                           ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function small_cart($block_name)
{
	global $t, $db, $table_prefix;
	global $category_id;
	global $page_settings, $settings;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}
	$t->set_file("block_body", "block_cart.html");

	$currency = get_currency();
	$currency_left  = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate  = $currency["rate"];
	$tax_prices = get_setting_value($settings, "tax_prices", 0);

	$tax_rates = get_session("session_tax_rates");
	$shopping_cart = get_session("shopping_cart");
	$total_quantity = 0; $total_price = 0;
	if(is_array($shopping_cart) && sizeof($shopping_cart) > 0) {
		$t->set_var("empty_small_cart", "");
		$t->set_var("small_cart_items", "");

		$user_info = get_session("session_user_info");
		$user_tax_free = get_setting_value($user_info, "tax_free", 0);
		$discount_type = get_session("session_discount_type");
		$discount_amount = get_session("session_discount_amount");

		foreach($shopping_cart as $cart_id => $item)
		{
			$item_id = $item["ITEM_ID"];
			if (!$item_id) { 
				continue;
			}

			$properties_more = $item["PROPERTIES_MORE"];
			if ($properties_more > 0) { continue; }

			$item_type_id = $item["ITEM_TYPE_ID"];
			$item_name = get_translation($item["ITEM_NAME"]);
			$short_name = substr($item_name, 0, 10);
			$properties = $item["PROPERTIES"];
			$quantity = $item["QUANTITY"];
			$tax_free = $item["TAX_FREE"];
			if ($user_tax_free) { $tax_free = $user_tax_free; }
			$discount_applicable = $item["DISCOUNT"];
			$buying_price = $item["BUYING_PRICE"];
			$price = $item["PRICE"];
			$is_price_edit = $item["PRICE_EDIT"];
			$properties_price = $item["PROPERTIES_PRICE"];
			$properties_percentage = $item["PROPERTIES_PERCENTAGE"];
			$properties_buying = $item["PROPERTIES_BUYING"];
			$properties_discount = $item["PROPERTIES_DISCOUNT"];
			$components = $item["COMPONENTS"];
			//$discount_total = 0;
			if ($discount_applicable) {
				if (!$is_price_edit) {
					if ($discount_type == 1) {
						$price -= round(($price * $discount_amount) / 100, 2);
					} else if ($discount_type == 2) {
						$price -= round($discount_amount, 2);
					} else if ($discount_type == 3) {
						$price -= round(($price * $discount_amount) / 100, 2);
					} else if ($discount_type == 4) {
						$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
					}
				}
			} 
			if ($properties_percentage && $price) {
				$properties_price += round(($price * $properties_percentage) / 100, 2);
			}
			if ($properties_discount > 0) {
				$properties_price -= round(($properties_price * $properties_discount) / 100, 2);
			}
			if ($discount_applicable) {
				if ($discount_type == 1) {
					$properties_price -= round((($properties_price) * $discount_amount) / 100, 2);
				} else if ($discount_type == 4) {
					$properties_price -= round((($properties_price - $properties_buying) * $discount_amount) / 100, 2);
				}
			}

			$price += $properties_price;

			// check the price including the tax
			if ($tax_prices > 0) {
				$tax_amount = get_tax_amount($tax_rates, $item_type_id, $price, $tax_free);
				$price += $tax_amount[1];	
			}

			// add components prices
			if (is_array($components) && sizeof($components) > 0) {
				foreach ($components as $property_id => $component_values) {
					foreach ($component_values as $property_item_id => $component) {
						$component_price = $component["price"];
						$component_tax_free = $component["tax_free"];
						if ($user_tax_free) { $component_tax_free = $user_tax_free; }
						$sub_item_id = $component["sub_item_id"];
						$sub_type_id = $component["item_type_id"];
						if (!strlen($component_price)) {
							$sub_price = $component["base_price"];
							$sub_buying = $component["buying"];
							$sub_user_price = $component["user_price"];
							$sub_user_action = $component["user_price_action"];
							$sub_prices = get_product_price($sub_item_id, $sub_price, $sub_buying, 0, 0, $sub_user_price, $sub_user_action, $discount_type, $discount_amount);
							$component_price = $sub_prices["base"];
						}
						// check the price including the tax
						if ($tax_prices > 0) {
							$component_tax_amount = get_tax_amount($tax_rates, $sub_type_id, $component_price, $component_tax_free); 
							$component_price += $component_tax_amount[1];
						}

						$price += $component_price;
					}
				}
			}

			$price = $price * $currency_rate;
			$properties_price = $properties_price * $currency_rate;

			if (isset($item["COUPONS"]) && is_array($item["COUPONS"])) {
				foreach ($item["COUPONS"] as $coupon_id => $coupon_info) {
					$price -= $coupon_info["DISCOUNT_AMOUNT"];
				}
			}

			$total_quantity += $quantity;
			$total_price += ($quantity * $price);

			$t->set_var("short_name", $short_name);
			$t->set_var("quantity", $quantity);
			$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);

			$t->parse("small_cart_items", true);
		}
	}

	if ($total_quantity > 0) {

		$t->set_var("total_quantity", $total_quantity);
		$t->set_var("total_price", $currency_left . number_format($total_price, 2) . $currency_right);

		$t->set_var("checkout_href", "checkout.php");
		$t->set_var("basket_href", "basket.php");

		$t->parse("small_cart", false);
	} else {
		$t->set_var("EMPTY_CART_MSG", EMPTY_CART_MSG);
		$t->parse("empty_small_cart", false);
		$t->set_var("small_cart", "");
	}

	$t->parse("block_body", false);
	$t->parse($block_name, true);

}

?>