<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_forum_latest.php                                   ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function forum_latest($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $datetime_show_format;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$user_id = get_session("session_user_id");		
	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$t->set_file("block_body", "block_forum_latest.html");
	$t->set_var("latest_rows", "");
	$t->set_var("latest_cols", "");

	$sql  = " SELECT f.thread_id, f.topic, f.friendly_url, f.thread_updated ";
	$sql .= " FROM " . $table_prefix . "forum f, ";
	$sql .= $table_prefix . "forum_list fl, ";
	$sql .= $table_prefix . "forum_categories fc ";
	$sql .= " WHERE fl.forum_id=f.forum_id AND fc.category_id=fl.category_id ";		
	if (strlen($user_id)) {
		$sql .= " AND fl.allowed_view IN (1,2) AND fl.allowed_view_topics IN (1,2) ";
	} else {
		$sql .= " AND fl.allowed_view=1 AND fl.allowed_view_topics=1 ";
	}
	$sql .= " ORDER BY f.thread_updated DESC ";

	$records_per_page = get_setting_value($page_settings, "forum_latest_recs", 10);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$latest_columns = get_setting_value($page_settings, "forum_latest_cols", 1);
		$t->set_var("latest_column", (100 / $latest_columns) . "%");
		$latest_number = 0;
		do
		{
			$latest_number++;
			$thread_id = $db->f("thread_id");
			$topic_title = get_translation($db->f("topic"));
			$friendly_url = $db->f("friendly_url");
			if ($friendly_urls && $friendly_url) {
				$t->set_var("forum_topic_url", $friendly_url . $friendly_extension);
			} else {
				$t->set_var("forum_topic_url", "forum_topic.php?thread_id=" . $thread_id);
			}
		
			$t->set_var("thread_id", $thread_id);
			$t->set_var("topic_title", $topic_title);

			$latest_updated = $db->f("thread_updated", DATETIME);
			$t->set_var("latest_updated", va_date($datetime_show_format, $latest_updated));

			$t->parse("latest_cols");
			if($latest_number % $latest_columns == 0)
			{
				$t->parse("latest_rows");
				$t->set_var("latest_cols", "");
			}
			
		} while ($db->next_record());              	

		if ($latest_number % $latest_columns != 0) {
			$t->parse("latest_rows");
		}

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>