<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_forum_topic.php                                    ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function forum_show_topic($block_name, $forum_id, $allowed_post_replies, $page_friendly_url = "", $page_friendly_params = array())
{

	global $t, $r, $db, $db_type, $table_prefix;
	global $datetime_show_format, $settings;
	global $html_title, $meta_description, $meta_keywords;

	$eol = get_eol();
	$user_id = get_session("session_user_id");		
	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	if ($friendly_urls && $page_friendly_url) {
		$pass_parameters = get_transfer_params($page_friendly_params);
		$remove_parameters = $page_friendly_params;
		$forum_topic_page = $page_friendly_url . $friendly_extension;
	} else {
		$pass_parameters = get_transfer_params();
		$remove_parameters = array();
		$forum_topic_page = "forum_topic.php";
	}

	$t->set_file("block_body","block_forum_topic.html");
	$t->set_var("site_url", $settings["site_url"]);

	$forum_thread_url = new VA_URL("forum_topic.php");
	$forum_thread_url->add_parameter("u", REQUEST, "u");
	$forum_thread_url->add_parameter("thread_id", REQUEST, "thread_id");
	$forum_thread_url->add_parameter("page", REQUEST, "page");
	$return_page = $forum_thread_url->get_url();

	$thread_id = get_param("thread_id");
	$action = get_param("action");
	$rnd = get_param("rnd");
	$category_id = get_param("category_id");
	$user_id = get_session("session_user_id");
	$edit_message = get_param("edit_message");
	$message_text = get_param("message_text");

	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("forum_thread_href", "forum_topic.php");
	$t->set_var("rnd", va_timestamp());
	$t->set_var("thread_id", $thread_id);
	
	$errors = "";

	if (!strlen($thread_id)) {
		$errors = TOPIC_MISS_ID_ERROR;
	}

	// get forum settings
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='forum'";
	$db->query($sql);
	while ($db->next_record()) {
		$forum_settings[$db->f("setting_name")] = $db->f("setting_value");
	}

	$use_random_image = get_setting_value($forum_settings, "use_random_image", 0); 
	if (($use_random_image == 2) || ($use_random_image == 1 && !$user_id)) { 
		$use_validation = true;
	} else {
		$use_validation = false;
	}
	$reply_form = get_setting_value($forum_settings, "reply_form", 1); 
	$topic_information = get_setting_value($forum_settings, "topic_information", 1); 
	$sort_messages = get_setting_value($forum_settings, "sort_messages", 1); 
	$user_images = get_setting_value($forum_settings, "user_images", 1); 
	$forum_user_info = get_setting_value($forum_settings, "user_info", 1); 
	$user_no_image = get_setting_value($forum_settings, "user_no_image", ""); 

	$sql  = " SELECT f.admin_id_added_by, f.user_id, f.user_name, f.user_email,  ";
	$sql .= " f.remote_address, f.topic, ";
	$sql .= " f.description, f.email_notification, f.date_added, f.date_modified, f.thread_updated, f.views, f.replies ";
	$sql .= " FROM " . $table_prefix . "forum f ";
	$sql .= " WHERE f.thread_id=" . $db->tosql($thread_id, INTEGER);
	$db->query($sql);
	if($db->next_record() && !strlen($errors))
	{
		$thread_admin_id = $db->f("admin_id_added_by");
		$thread_admin_image = $db->f("admin_image");

		$thread_user_id = $db->f("user_id");
		$thread_user_name = $db->f("user_name");
		$thread_user_email = $db->f("user_email");
		$thread_user_image = $db->f("user_image");
		$date_updated = $db->f("thread_updated", DATETIME);
		$date_added = $db->f("date_added", DATETIME);
		$topic = get_translation($db->f("topic"));
		$topic_description = get_translation($db->f("description"));
		$email_notification = $db->f("email_notification");

		$views = intval($db->f("views"));
		$replies = intval($db->f("replies"));
		$thread_remote_address = $db->f("remote_address");

		$thread_user_name .= " (" . GUEST_MSG . ")";
		$thread_user_class = "forumGuest";
		$thread_personal_image = "";
		$t->set_var("user_id", $thread_user_id);
		$t->set_var("thread_remote_address", $thread_remote_address);
		// topic author
		$t->set_var("thread_user_name", htmlspecialchars($thread_user_name));
		$t->set_var("thread_user_class", "forumGuest");
		if ($thread_user_id) {
			$sql  = " SELECT login, nickname, email, personal_image FROM " . $table_prefix . "users ";
			$sql .= " WHERE user_id=" . $db->tosql($thread_user_id, INTEGER);
			$db->query($sql);
			if ($db->next_record()) {
				$thread_personal_image = $db->f("personal_image");
				if ($db->f("email")) { $thread_user_email = $db->f("email"); }
				$thread_user_name = $db->f("nickname");
				if (!strlen($thread_user_name)) { $thread_user_name = $db->f("login"); }
				$thread_user_class = "forumUser";
				$t->set_var("thread_user_class", "forumUser");
				$t->set_var("thread_user_name", htmlspecialchars($thread_user_name));
			}
		} else if ($thread_admin_id) {
			$sql  = " SELECT admin_name, nickname, email, personal_image FROM " . $table_prefix . "admins ";
			$sql .= " WHERE admin_id=" . $db->tosql($thread_admin_id, INTEGER);
			$db->query($sql);
			if ($db->next_record()) {
				$thread_personal_image = $db->f("personal_image");
				if ($db->f("email")) { $thread_user_email = $db->f("email"); }
				$thread_user_name = $db->f("nickname");
				if (!strlen($thread_user_name)) { $thread_user_name = $db->f("admin_name"); }
				$thread_user_class = "forumAdmin";
				$t->set_var("thread_user_class", "forumAdmin");
				$t->set_var("thread_user_name", htmlspecialchars($thread_user_name));
			}
		}
		$t->set_var("thread_user_email", htmlspecialchars($thread_user_email));
		if (!$thread_personal_image && $forum_user_info == 1) {
			$thread_personal_image = $user_no_image;
		}

		$date_updated_string = va_date($datetime_show_format, $date_updated);
		$t->set_var("date_modified", $date_updated_string);
		$t->set_var("thread_modified", $date_updated_string);
		$t->set_var("thread_updated", $date_updated_string);

		$date_added_string = va_date($datetime_show_format, $date_added);
		$thread_added_string = $date_added_string;
		$t->set_var("thread_added", $date_added_string);

		$html_title = strip_tags($topic);
		$t->set_var("topic", htmlspecialchars($topic));
		$last_message = $topic_description;
		$meta_description = $topic_description;
		$t->set_var("topic_description", nl2br(htmlspecialchars($topic_description)));

		$t->set_var("views", $views);
		$t->set_var("replies", $replies);

		$topic_viewed = get_session("session_topics_viewed");
		if (!isset($topic_viewed[$thread_id])) {
			$sql  = " UPDATE " . $table_prefix . "forum SET views=" . $db->tosql(($views + 1), INTEGER);
			$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
			$db->query($sql);

			$topic_viewed[$thread_id] = true;
			set_session("session_topics_viewed", $topic_viewed);
		}
		
	}
	else if(!strlen($errors))
	{
		$errors = TOPIC_WRONG_ID_ERROR;
	}

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("global_errors", false);
		$t->pparse("main", false);
		return;
	}

	$r = new VA_Record($table_prefix . "forum_messages");
	$r->add_where("message_id", INTEGER);
	$r->add_textbox("thread_id", INTEGER);
	$r->add_hidden("u", INTEGER);
	//$r->add_textbox("admin_id", INTEGER);
	$r->add_textbox("user_name", TEXT, TOPIC_NICKNAME_FIELD);
	$r->change_property("user_name", REQUIRED, true);
	$r->add_textbox("user_email", TEXT, TOPIC_EMAIL_FIELD);
	$r->change_property("user_email", REQUIRED, true);
	$r->change_property("user_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("message_text", TEXT, TOPIC_MESSAGE_FIELD);
	$r->change_property("message_text", REQUIRED, true);
	$r->change_property("message_text", TRIM, true);
	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("user_id", INTEGER);
	$r->change_property("user_id", USE_SQL_NULL, false);
	$r->add_textbox("validation_number", TEXT, VALIDATION_CODE_FIELD);
	$r->change_property("validation_number", USE_IN_INSERT, false);
	$r->change_property("validation_number", USE_IN_UPDATE, false);
	$r->change_property("validation_number", USE_IN_SELECT, false);
	if ($use_validation) {
		$r->change_property("validation_number", REQUIRED, true);
		$r->change_property("validation_number", SHOW, true);
	} else {
		$r->change_property("validation_number", REQUIRED, false);
		$r->change_property("validation_number", SHOW, false);
	}
	
	$r->get_form_values();
	// if user registered there is no necessity to submit his data
	if ($user_id) {	
		$user_info = get_session("session_user_info");
		$user_nickname = get_setting_value($user_info, "nickname", "");
		$user_email = get_setting_value($user_info, "email", "");
		if (strlen($user_nickname)) {
			$r->set_value("user_name", $user_nickname);
			$r->change_property("user_name", SHOW, false);
		}
		if (strlen($user_email)) {
			$r->set_value("user_email", $user_email);
			$r->change_property("user_email", SHOW, false);
		}
	}

	$session_rnd = get_session("session_rnd");
	$action = get_param("action");
	$rnd = get_param("rnd");
	$button = get_param("button");

	// check if use allowed to post replies
	if ($allowed_post_replies == 1 || ($allowed_post_replies && strlen($user_id))) {

		if($action && $rnd != $session_rnd)
		{
  
			$r->validate();
  
			if ($use_validation && !$r->is_empty("validation_number")) { 
				if(!check_image_validation($r->get_value("validation_number"))) {
					$r->errors .= str_replace("{field_name}", VALIDATION_CODE_FIELD, VALIDATION_MESSAGE);
				}
			}
  
			if(!$r->errors) {
				if (check_black_ip()) {
					$r->errors = BLACK_IP_MSG; 
				} else if (check_banned_content($r->get_value("message_text"))) {
					$r->errors = BANNED_CONTENT_MSG; 
				}
			}
  
			if(!strlen($r->errors) && $button == TOPIC_MESSAGE_BUTTON)
			{
				$date_updated = va_time();
				$remote_address = get_ip();
				$r->set_value("date_added", $date_updated);
				$r->set_value("remote_address", $remote_address);
				$r->set_value("user_id", $user_id);
				if ($db_type == "postgre") {
					$sql = " SELECT NEXTVAL('seq_" . $table_prefix . "forum_messages') ";
					$message_id = get_db_value($sql);
					$r->set_value("message_id", $message_id);
					$r->change_property("message_id", USE_IN_INSERT, true);
				}
  
				//$r->set_value("admin_id", get_session("session_admin_id"));
  
				if($r->insert_record())
				{ 
					if ($db_type == "mysql") {
						$sql = " SELECT LAST_INSERT_ID() ";
						$message_id = get_db_value($sql);
					} else if ($db_type == "access") {
						$sql = " SELECT @@IDENTITY ";
						$message_id = get_db_value($sql);
					}
					$r->set_value("message_id", $message_id);

					setcookie("cookie_forum_nick", $r->get_value("user_name"), va_timestamp() + 3600 * 24 * 366);  
					setcookie("cookie_forum_email", $r->get_value("user_email"), va_timestamp() + 3600 * 24 * 366);  
  
					if($email_notification || (isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"]))
					{
						// prepare variables
						$date_updated_string = va_date($datetime_show_format, $date_updated);
				  
						// set variables for email
						$r->set_parameters();
						$t->set_var("date_added", $date_updated_string);
						$t->set_var("message_added", $date_updated_string);
						$t->set_var("date_modified", $date_updated_string);
						$t->set_var("thread_modified", $date_updated_string);
						$t->set_var("thread_updated", $date_updated_string);
  
						$msg_user_name = htmlspecialchars($r->get_value("user_name"));
						$msg_user_email = htmlspecialchars($r->get_value("user_email"));
						$t->set_var("added_by", $msg_user_name);
						$t->set_var("nickname", $msg_user_name);
						$t->set_var("message_added_by", $msg_user_name);
						$t->set_var("message_user_name", $msg_user_name);
						$t->set_var("message_nickname", $msg_user_name);
  
						$t->set_var("user_email", $msg_user_email);
						$t->set_var("message_user_email", $msg_user_email);
  
						$t->set_var("message_remote_address", $r->get_value("remote_address"));
						$t->set_var("message_user_ip", $r->get_value("remote_address"));
  
						$t->set_var("message", $r->get_value("message_text"));
  
						$t->set_var("topic_description", $topic_description);
						$t->set_var("description", $topic_description);
						$t->set_var("topic_message", $topic_description);
  
						// send notification to site administrator
						if(isset($forum_settings["admin_notification"]) && $forum_settings["admin_notification"])
						{			  
							$t->set_block("admin_subject", $forum_settings["admin_subject"]);
							$t->set_block("admin_message", $forum_settings["admin_message"]);

							$t->set_var("thread_user_name", $thread_user_name);
							$t->set_var("thread_user_email", $thread_user_email);
							$t->set_var("topic", $topic);
							$t->set_var("description", $topic_description);
							$t->set_var("message", $message_text);
							$t->parse("admin_subject", false);
							if ($mail_type) {
								$t->set_var("thread_user_name", htmlspecialchars($thread_user_name));
								$t->set_var("thread_user_email", htmlspecialchars($thread_user_email));
								$t->set_var("topic", htmlspecialchars($topic));
								$t->set_var("description", nl2br(htmlspecialchars($topic_description)));
								$t->set_var("message", nl2br(htmlspecialchars($message_text)));
							}
							$t->parse("admin_message", false);
  
							$mail_to = get_setting_value($forum_settings, "admin_email", $settings["admin_email"]);
							$mail_to = str_replace(";", ",", $mail_to);
							$mail_from = get_setting_value($forum_settings, "admin_mail_from", $settings["admin_email"]);
							$mail_cc = get_setting_value($forum_settings, "cc_emails");
							$mail_bcc = get_setting_value($forum_settings, "admin_mail_bcc");
							$mail_reply_to = get_setting_value($forum_settings, "admin_mail_reply_to");
							$mail_return_path = get_setting_value($forum_settings, "admin_mail_return_path");
							$mail_type = get_setting_value($forum_settings, "admin_message_type");
							$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
  
							$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
							@mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
						}
						// send notification to topic owner
						if($email_notification)
						{			  
							$t->set_block("user_subject", $forum_settings["user_subject"]);
							$t->set_block("user_message", $forum_settings["user_message"]);

							$t->set_var("thread_user_name", $thread_user_name);
							$t->set_var("thread_user_email", $thread_user_email);
							$t->set_var("topic", $topic);
							$t->set_var("description", $topic_description);
							$t->set_var("message", $message_text);
							$t->parse("user_subject", false);
							if ($mail_type) {
								$t->set_var("thread_user_name", htmlspecialchars($thread_user_name));
								$t->set_var("thread_user_email", htmlspecialchars($thread_user_email));
								$t->set_var("topic", htmlspecialchars($topic));
								$t->set_var("description", nl2br(htmlspecialchars($topic_description)));
								$t->set_var("message", nl2br(htmlspecialchars($message_text)));
							}
							$t->parse("user_message", false);
  
							$mail_from = get_setting_value($forum_settings, "user_mail_from", $settings["admin_email"]);
							$mail_cc = get_setting_value($forum_settings, "user_mail_cc");
							$mail_bcc = get_setting_value($forum_settings, "user_mail_bcc");
							$mail_reply_to = get_setting_value($forum_settings, "user_mail_reply_to");
							$mail_return_path = get_setting_value($forum_settings, "user_mail_return_path");
							$mail_type = get_setting_value($forum_settings, "user_message_type");
							$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
  
							$user_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("user_message"));
							@mail($thread_user_email, $t->get_var("user_subject"), $user_message, $email_headers);
						}
  
					}
          // update forum thread info
					$sql  = " UPDATE " . $table_prefix . "forum SET replies=replies+1 ";
					$sql .= " , thread_updated=" . $db->tosql($date_updated, DATETIME);
					$sql .= " , last_post_added=" . $db->tosql($date_updated, DATETIME);
					$sql .= " , last_post_user_id=" . $db->tosql($user_id, INTEGER);
					$sql .= " , last_post_admin_id=0";
					$sql .= " , last_post_message_id=" . $db->tosql($message_id, INTEGER);
					$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
					$db->query($sql);
  
					$sql  = " UPDATE " . $table_prefix . "forum_list SET messages_number=messages_number+1 ";
					$sql .= " , last_post_added=" . $db->tosql($date_updated, DATETIME);
					$sql .= " , last_post_user_id=" . $db->tosql($user_id, INTEGER);
					$sql .= " , last_post_admin_id=0";
					$sql .= " , last_post_thread_id=" . $db->tosql($thread_id, INTEGER);
					$sql .= " , last_post_message_id=" . $db->tosql($message_id, INTEGER);
					$sql .= " WHERE forum_id=" . $db->tosql($forum_id, INTEGER);
					$db->query($sql);
					
				}
  
				header("Location: " . $return_page);
				exit;
			} else if (!strlen($r->errors) && $button == PREVIEW_BUTTON) {
				$message_text = get_param("message_text");
				$t->set_var("message_text", process_message($message_text));
				$t->parse("topic_preview", false);
			}
			else
			{
				//$errors .= "Please provide information in the sections with red, italicized headings, then click 'Submit'.<br>";	
				set_session("session_rnd", "");
			}
		} else if(strlen(get_session("session_user_id"))) { // new page (set default values)
			$r->set_value("user_name", get_session("session_user_name"));
			$r->set_value("user_email", get_session("session_user_email"));
		} else {
			$r->set_value("user_name", get_cookie("cookie_forum_nick"));
			$r->set_value("user_email", get_cookie("cookie_forum_email"));
		}
	}

	$t->set_var("thread_user_name", htmlspecialchars($thread_user_name));
	$t->set_var("thread_user_email", htmlspecialchars($thread_user_email));
	$t->set_var("topic", htmlspecialchars($topic));
	$t->set_var("description", nl2br(htmlspecialchars($topic_description)));

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", $forum_topic_page);
	$n->set_parameters(true, true, false);

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "forum_messages WHERE thread_id=" . $db->tosql($thread_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$last_page = ceil($total_records / $records_per_page);
	$pages_number = 10;
	$page_number = $n->set_navigator("navigator", "page", CENTERED, $pages_number, $records_per_page, $total_records, false, $pass_parameters);

	$t->set_var("records", "");
	// show topic message as a first message in the thread for ASC order
	if ($sort_messages == 1 && $page_number <= 1 && !$topic_information) {
		parse_topic_message($thread_admin_id, $thread_user_id, $thread_user_class, $thread_user_name, $thread_user_email, $thread_personal_image, $thread_remote_address, $thread_added_string, $topic_description, $forum_user_info);
	}

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT fm.message_id,fm.admin_id, a.personal_image AS admin_image, ";
	$sql .= " fm.user_name,fm.user_email,fm.remote_address, u.personal_image AS user_image, ";
	$sql .= " fm.message_text, fm.date_added, fm.user_id ";
	$sql .= " FROM ((" . $table_prefix . "forum_messages fm ";
	$sql .= " LEFT JOIN " . $table_prefix . "users u ON u.user_id=fm.user_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "admins a ON a.admin_id=fm.admin_id) ";
	$sql .= " WHERE fm.thread_id=" . $db->tosql($thread_id, INTEGER);
	if ($sort_messages == 1) {
		$sql .= " ORDER BY fm.date_added ASC ";
	} else {
		$sql .= " ORDER BY fm.date_added DESC ";
	}
	$db->query($sql);
	$messages = array(); $ms = 0;
	while ($db->next_record()) {
		$messages[$ms]["message_id"] = $db->f("message_id");
		$messages[$ms]["user_id"] = $db->f("user_id");
		$messages[$ms]["admin_id"] = $db->f("admin_id");
		$messages[$ms]["user_name"] = $db->f("user_name");
		$messages[$ms]["user_email"] = $db->f("user_email");
		$messages[$ms]["remote_address"] = $db->f("remote_address");
		$messages[$ms]["message_text"] = $db->f("message_text");
		$messages[$ms]["date_added"] = $db->f("date_added", DATETIME);
		$messages[$ms]["date_modified"] = $db->f("date_modified", DATETIME);
		$ms++;
	}

	if ($ms > 0) {
		for ($i = 0; $i < $ms; $i++) {
			$message_id = $messages[$i]["message_id"];
			$message_user_id = $messages[$i]["user_id"];
			$message_admin_id = $messages[$i]["admin_id"];
			$message_user_name = $messages[$i]["user_name"];
			$message_user_email = $messages[$i]["user_email"];
			$message_user_ip = $messages[$i]["remote_address"];
			$message_text = $messages[$i]["message_text"];
			$date_added = $messages[$i]["date_added"];
			$date_modified = $messages[$i]["date_modified"];

			$t->set_var("message_id", $message_id);
			$t->set_var("message_user_ip", $message_user_ip);

			$personal_image = "";
			$forum_user_class = "forumGuest";
			$message_user_name .= " (" . GUEST_MSG . ")";
			if ($message_user_id) {
				$sql  = " SELECT login, nickname, personal_image FROM " . $table_prefix . "users ";
				$sql .= " WHERE user_id=" . $db->tosql($message_user_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$message_user_name = $db->f("nickname");
					if (!strlen($message_user_name)) { $message_user_name = $db->f("login"); }
					if ($db->f("email")) { $message_user_email = $db->f("email"); }
					$forum_user_class = "forumUser";
					$personal_image = $db->f("personal_image");
				}
			} else if ($message_admin_id) {
				$sql  = " SELECT admin_name, nickname, personal_image FROM " . $table_prefix . "admins ";
				$sql .= " WHERE admin_id=" . $db->tosql($message_admin_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$message_user_name = $db->f("nickname");
					if (!strlen($message_user_name)) { $message_user_name = $db->f("admin_name"); }
					if ($db->f("email")) { $message_user_email = $db->f("email"); }
					$forum_user_class = "forumAdmin";
					$personal_image = $db->f("personal_image");
				}
			}
			$t->set_var("message_user_name", htmlspecialchars($message_user_name));
			$t->set_var("message_user_email", htmlspecialchars($message_user_email));
			$t->set_var("forum_user_class", $forum_user_class);

			if($message_admin_id) {
				$t->sparse("admin_block", false);
				$t->set_var("user_block", "");
			} else {
				$t->sparse("user_block", false);
				$t->set_var("admin_block", "");
			}
			if (!$personal_image && $forum_user_info == 1) {
				$personal_image = $user_no_image;
			}
	
			if (strlen($personal_image)) {
				if (preg_match("/^http\:\/\//", $personal_image)) {
					$image_size = "";
				} else {
					$image_size = @GetImageSize($personal_image);
				}
				if (is_array($image_size)) {
					$t->set_var("image_size", $image_size[3]);
				} else {
					$t->set_var("image_size", "");
				}

				$t->set_var("personal_image", $personal_image);
				$t->sparse("user_image_block", false);
			} else {
				$t->set_var("user_image_block", "");
			}

			$message_text = process_message(get_translation($message_text));
			$date_added_string = va_date($datetime_show_format, $date_added);
			$t->set_var("date_added", $date_added_string);

			if ($forum_user_info == 1) {
				$t->sparse("user_info_left", false);
			} else {
				$t->sparse("user_info_top", false);
			}

			$t->set_var("message_text", $message_text);
			$t->parse("records", true);
		} while($db->next_record());

	}

	// show topic message as a last message in the thread for DESC order
	if ($sort_messages != 1 && $page_number == $last_page && !$topic_information) {
		parse_topic_message($thread_admin_id, $thread_user_id, $thread_user_class, $thread_user_name, $thread_user_email, $thread_personal_image, $thread_remote_address, $thread_added_string, $topic_description, $forum_user_info);
	}


	if(!strlen($action)) // (set default message text for reply)
	{
		// get the latest message in forum and set it as default message
		/*
		$sql  = " SELECT message_text ";
		$sql .= " FROM " . $table_prefix . "forum_messages ";
		$sql .= " WHERE thread_id=" . $db->tosql($thread_id, INTEGER);
		$sql .= " ORDER BY date_added DESC ";

		$db->RecordsPerPage = 1;
		$db->PageNumber = 1;
		$db->query($sql);
		if ($db->next_record()) {
			$last_message = get_translation($db->f("message_text"));
		}
		$last_message = ">" . str_replace("\n", "\n>", $last_message);
		$r->set_value("message_text", $last_message);
		//*/
	}
	$r->set_parameters();
	$t->set_var("page", $page_number);

	if ($allowed_post_replies == 1 || ($allowed_post_replies && strlen($user_id))) {
		$t->parse("message_form", false);
		if ($reply_form == 2) {
			$t->set_var("message_form_bottom", $t->get_var("message_form"));
			$t->set_var("message_form", "");
		}
	} else {
		$t->set_var("message_form", "");
	}
	if ($topic_information) {
		$t->parse("topic_info", false);
	}

	$t->parse("block_body", false);
	$t->parse($block_name, true);
}


function parse_topic_message($thread_admin_id, $thread_user_id, $thread_user_class, $thread_user_name, $thread_user_email, $thread_personal_image, $thread_remote_address, $thread_added_string, $topic_description, $forum_user_info)
{
	global $t;

	$t->set_var("message_user_name", htmlspecialchars($thread_user_name));
	$t->set_var("message_user_email", htmlspecialchars($thread_user_email));
	$t->set_var("message_user_ip", $thread_remote_address);
	$t->set_var("message_id", 0);

	if ($thread_user_id) {
		$t->sparse("user_block", false);
		$t->set_var("admin_block", "");
	} else {
		$t->sparse("admin_block", false);
		$t->set_var("user_block", "");
	}
	$t->set_var("forum_user_class", $thread_user_class);

	if (strlen($thread_personal_image)) {
		if (preg_match("/^http\:\/\//", $thread_personal_image)) {
			$image_size = "";
		} else {
			$image_size = @GetImageSize($thread_personal_image);
		}
		if (is_array($image_size)) {
			$t->set_var("image_size", $image_size[3]);
		} else {
			$t->set_var("image_size", "");
		}

		$t->set_var("personal_image", $thread_personal_image);
		$t->set_var("forum_user_class", $forum_user_class);

		$t->sparse("user_image_block", false);
	} else {
		$t->set_var("user_image_block", "");
	}
	$t->set_var("date_added", $thread_added_string);

	if ($forum_user_info == 1) {
		$t->sparse("user_info_left", false);
	} else {
		$t->sparse("user_info_top", false);
	}

	$t->set_var("message_text", process_message($topic_description));
	$t->parse("records", true);

}
?>