<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_language.php                                       ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function language_form($block_name, $language_selection, $block_prefix = "", $page_friendly_url = "", $page_friendly_params = array())
{
	global $t, $db, $table_prefix, $settings, $language_code, $current_page;

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	if($block_name) {
	  $t->set_file("block_body", "block_language.html");
	}

	$t->set_var("LANGUAGE_TITLE", LANGUAGE_TITLE);
	$t->set_var("APPLY_BUTTON",   APPLY_BUTTON);

	$remove_parameters = array();
	if ($friendly_urls && $page_friendly_url) {
		$current_page = $page_friendly_url . $friendly_extension;
		$query_string = transfer_params($page_friendly_params, true);
	} else {
		$query_string = transfer_params("", true);
	}
	$t->set_var("current_href", $current_page);

	$sql  = " SELECT language_code, language_name, language_image ";
	$sql .= " FROM " . $table_prefix . "languages WHERE show_for_user=1 ORDER BY language_order, language_code ";
	$db->query($sql);
	while ($db->next_record()) {
		$row_language_code = $db->f("language_code");
		$row_language_name = $db->f("language_name");
		$language_image = $db->f("language_image");
		$language_selected = ($language_code == $row_language_code) ? "selected" : "";
		$t->set_var("language_selected", $language_selected);
		$t->set_var("language_code", $row_language_code);
		$t->set_var("language_name", $row_language_name);
		if ($language_image) {
			$image_size = preg_match("/^http\:\/\//", $language_image) ? "" : @GetImageSize($language_image);
      $t->set_var("src", htmlspecialchars($language_image));
			if (is_array($image_size)) {
        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
			} else {
        $t->set_var("width", "");
	      $t->set_var("height", "");
			}

			$language_query = $query_string;
			if($language_query) {
				$language_query .= "&";
			} else {
				$language_query .= "?";
			}
 			$language_query .= "language_code=" . $row_language_code; 
			$language_url = $current_page . $language_query;
			$t->set_var("language_query", $language_query);
			$t->set_var("language_url", $language_url);

			$t->parse($block_prefix . "languages_images", true);
		}
		$t->parse($block_prefix . "languages", true);
	}

	if ($language_selection == 1) {
		$t->sparse($block_prefix . "select_image", false);
	} else {
		$t->set_var("languages_images", "");
		$t->parse($block_prefix . "select_languages", false);
	}

	if($block_name) {
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>