<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_manufacturers.php                                  ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function manufacturers($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $language_code;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$manufacturers_selection = get_setting_value($page_settings, "manufacturers_selection", 1);
	$category_id = get_param("category_id");
	$search_category_id = get_param("search_category_id");
	$manf = get_param("manf");
	if ($search_category_id) { $category_id = $search_category_id; }

	$t->set_file("block_body",        "block_manufacturers.html");
	$t->set_var("products_href",      "products.php");
	$t->set_var("category_id",        htmlspecialchars($category_id));

	$list_page = "products.php";
	$manf_url = new VA_URL($list_page);
	$manf_url->add_parameter("category_id", CONSTANT, $category_id);

	$search_tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree", TOP_CATEGORY_MSG);

	$sql  = " SELECT m.manufacturer_id, m.manufacturer_name, m.friendly_url, COUNT(*) AS manufacturer_products ";
	$sql .= " FROM (((" . $table_prefix . "items i ";
	$sql .=	" INNER JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
	$sql .=	" LEFT JOIN " . $table_prefix . "items_categories ic ON ic.item_id=i.item_id ) ";
	$sql .=	" LEFT JOIN " . $table_prefix . "categories c ON ic.category_id=c.category_id ) ";
	$sql .= " WHERE i.is_showing=1 AND i.is_approved=1 ";
	$sql .= " AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	if ($category_id > 0) {
		$sql .= " AND (ic.category_id=" . $db->tosql($category_id, INTEGER);
		$sql .= " OR c.category_path LIKE '%" . $db->tosql($search_tree->get_path($category_id), TEXT, false) . "%')";
	}
	$sql .= " GROUP BY m.manufacturer_id, m.manufacturer_name, m.friendly_url ";
	$sql .= " ORDER BY m.manufacturer_name ";
	$db->query($sql);
	if ($db->next_record()) {

		do {
			$manufacturer_id = $db->f("manufacturer_id");
			$manufacturer_name = $db->f("manufacturer_name");
			$friendly_url = $db->f("friendly_url");
			$manufacturer_products = $db->f("manufacturer_products");

			if ($friendly_urls && $friendly_url) {
				$manf_url->remove_parameter("manf");
				$manufacturer_href = $manf_url->get_url($friendly_url. $friendly_extension);
			} else {
				$manf_url->add_parameter("manf", CONSTANT, $manufacturer_id);
				$manufacturer_href = $manf_url->get_url($list_page);
			}

			//$manufacturer_href = "products.php?category_id=" . urlencode($category_id) . "&manf=" . $manufacturer_id;
			$manufacturer_selected = ($manf == $manufacturer_id) ? "selected" : "";

			$t->set_var("manufacturer_id", $manufacturer_id);
			$t->set_var("manufacturer_name", $manufacturer_name);
			$t->set_var("manufacturer_href", $manufacturer_href);
			$t->set_var("manufacturer_selected", $manufacturer_selected);
			$t->set_var("manufacturer_products", $manufacturer_products);

			$t->sparse("manufacturers", true);
			$t->sparse("manufacturers_options", true);

		} while ($db->next_record());

		if ($manufacturers_selection == 2) {
			$t->sparse("manufacturers_select", false);
		} else {
			$t->sparse("manufacturers_list", false);
		}


		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>