<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_merchants.php                                      ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function merchants($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $language_code;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$merchants_selection = get_setting_value($page_settings, "merchants_selection", 1);
	$user = get_param("user");

	$t->set_file("block_body",    "block_merchants.html");
	$t->set_var("MERCHANTS_TITLE", MERCHANTS_TITLE);
	$t->set_var("GO_BUTTON",       GO_BUTTON);
	$t->set_var("user_list_href", "user_list.php");

	$sql  = " SELECT u.user_id, u.company_name, u.name, u.login, u.friendly_url, COUNT(*) AS merchant_products ";
	$sql .= " FROM (" . $table_prefix . "items i ";
	$sql .=	" INNER JOIN " . $table_prefix . "users u ON i.user_id=u.user_id) ";
	$sql .= " WHERE i.is_showing=1 AND i.is_approved=1 ";
	$sql .= " AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " GROUP BY u.user_id, u.company_name, u.name, u.login, u.friendly_url ";
	$sql .= " ORDER BY u.company_name, u.name, u.login ";
	$db->query($sql);
	if ($db->next_record()) {

		do {
			$merchant_id = $db->f("user_id");
			$merchant_name = $db->f("company_name");
			if (!strlen($merchant_name)) {
				$merchant_name = $db->f("name");
			}
			if (!strlen($merchant_name)) {
				$merchant_name = $db->f("login");
			}
			$friendly_url = $db->f("friendly_url");
			$merchant_products = $db->f("merchant_products");

			if ($friendly_urls && $friendly_url) {
				$merchant_url = $friendly_url. $friendly_extension;
			} else {
				$merchant_url = "user_list.php?user=" . $merchant_id;
			}

			$merchant_selected = ($user == $merchant_id) ? "selected" : "";

			$t->set_var("merchant_id",   $merchant_id);
			$t->set_var("merchant_name", $merchant_name);
			$t->set_var("merchant_url",  $merchant_url);
			$t->set_var("merchant_selected", $merchant_selected);
			$t->set_var("merchant_products", $merchant_products);

			$t->sparse("merchants", true);
			$t->sparse("merchants_options", true);

		} while ($db->next_record());

		if ($merchants_selection == 2) {
			$t->sparse("merchants_select", false);
		} else {
			$t->sparse("merchants_list", false);
		}


		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>