<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_product_details.php                                ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function product_details($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $restrict_products_images;
	global $HTTP_GET_VARS;
	global $datetime_show_format, $language_code;
	global $sc_item_id, $item_added, $sc_errors;
	global $html_title, $meta_keywords, $meta_description;
	global $currency_left, $currency_right, $currency_rate;

	if (get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_product_details.html");
	
	$user_info = get_session("session_user_info");
	$user_tax_free = get_setting_value($user_info, "tax_free", 0);
	$discount_type = get_session("session_discount_type");
	$discount_amount = get_session("session_discount_amount");
	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$use_tabs = get_setting_value($page_settings, "use_tabs", 0);
	$image_effect = get_setting_value($page_settings, "image_effect", 1);
	$display_products = get_setting_value($settings, "display_products", 0);
	$product_no_image = get_setting_value($settings, "product_no_image", "");
	$product_code_details = get_setting_value($settings, "product_code_details", 0);
	$hide_weight_details = get_setting_value($settings, "hide_weight_details", 0);
	$shop_hide_add_details = get_setting_value($settings, "hide_add_details", 0);
	$shop_hide_view_details = get_setting_value($settings, "hide_view_details", 0);
	$shop_hide_checkout_details = get_setting_value($settings, "hide_checkout_details", 0);
	$weight_measure = get_setting_value($settings, "weight_measure", "");
	$reviews_availability = get_setting_value($settings, "reviews_availability", 0);

	$user_id = get_session("session_user_id");		
	$user_type_id = get_session("session_user_type_id");
	$price_type = get_session("session_price_type");
	if ($price_type == 1) {
		$price_field = "trade_price";
		$sales_field = "trade_sales";
	} else {
		$price_field = "price";
		$sales_field = "sales_price";
	}

	$category_id = get_param("category_id");
	$item_id = get_param("item_id");
	if (!strlen($category_id) && strlen($item_id)) {
		$category_id = get_db_value("SELECT category_id FROM " . $table_prefix . "items_categories WHERE item_id=" . $db->tosql($item_id, INTEGER));
	}
	$tab = get_param("tab");
	if (!strlen($tab)) { $tab = "desc"; }

	// build query string
	$transfer_query = transfer_params("", true);
	$reviews_url = "reviews.php" . $transfer_query;
	$tell_friend_href = "tell_friend.php?item_id=" . urlencode($item_id) . "&type=products";

	$t->set_var("products_href", "products.php");
	$t->set_var("product_details_href", "product_details.php");
	$t->set_var("basket_href",      "basket.php");
	$t->set_var("checkout_href",    "checkout.php");
	$t->set_var("reviews_url",      $reviews_url);
	$t->set_var("reviews_href",     $reviews_url);
	$t->set_var("tell_friend_href", $tell_friend_href);
	$t->set_var("product_print_href", "product_print.php");
	$t->set_var("cl",               $currency_left);
	$t->set_var("cr",               $currency_right);
	$t->set_var("tab",              htmlspecialchars($tab));
	$t->set_var("MORE_MSG",         MORE_MSG);
	$t->set_var("READ_MORE_MSG",    READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",   CLICK_HERE_MSG);
	$t->set_var("TELL_FRIEND_TITLE",TELL_FRIEND_TITLE);
	$t->set_var("PRINTER_FRIENDLY_MSG", PRINTER_FRIENDLY_MSG);
	$t->set_var("PRICE_MSG",        PRICE_MSG);
	$t->set_var("OUR_PRICE_MSG",    OUR_PRICE_MSG);
	$t->set_var("YOU_SAVE_MSG",     YOU_SAVE_MSG);
	$t->set_var("RATING_MSG",       RATING_MSG);
	$t->set_var("PROD_AVAILABILITY_MSG", PROD_AVAILABILITY_MSG);
	$t->set_var("ADD_TO_CART_MSG",  ADD_TO_CART_MSG);
	$t->set_var("VIEW_CART_MSG",    VIEW_CART_MSG);
	$t->set_var("AMEND_CART_MSG",   AMEND_CART_MSG);
	$t->set_var("PROD_PREVIEW_MSG", PROD_PREVIEW_MSG);
	$t->set_var("PROD_PREVIEW_CLICK_MSG",PROD_PREVIEW_CLICK_MSG);
	$t->set_var("GOTO_CHECKOUT_MSG",GOTO_CHECKOUT_MSG);
	$t->set_var("PROD_HIGHLIGHT_MSG",PROD_HIGHLIGHT_MSG);
	$t->set_var("PROD_NOTE_MSG",     PROD_NOTE_MSG);
	$t->set_var("PROD_SHIPPING_MSG", PROD_SHIPPING_MSG);
	$t->set_var("PROD_WEIGHT_MSG",   PROD_WEIGHT_MSG);
	$t->set_var("WRITE_REVIEW_MSG",  WRITE_REVIEW_MSG);
	$t->set_var("RATE_PRODUCT_MSG",  RATE_PRODUCT_MSG);
	$t->set_var("PROD_SUPER_IMAGE_MSG",  PROD_SUPER_IMAGE_MSG);
	$t->set_var("NOT_RATED_PRODUCT_MSG", NOT_RATED_PRODUCT_MSG);
	$t->set_var("AVERAGE_RATING_MSG",    AVERAGE_RATING_MSG);
	$t->set_var("PROD_DESCRIPTION_MSG",  PROD_DESCRIPTION_MSG);
	$t->set_var("PROD_SPECIFICATION_MSG",PROD_SPECIFICATION_MSG);
	$t->set_var("PROD_IMAGES_MSG",       PROD_IMAGES_MSG);
	$t->set_var("PROD_ACCESSORIES_MSG",  PROD_ACCESSORIES_MSG);
	$t->set_var("REVIEWS_MSG",           REVIEWS_MSG);
	$t->set_var("PROD_CODE_MSG",         PROD_CODE_MSG);
	$t->set_var("PROD_QTY_COLUMN",       PROD_QTY_COLUMN);
	$t->set_var("PRODUCT_OUT_STOCK_MSG", htmlspecialchars(PRODUCT_OUT_STOCK_MSG));
	$t->set_var("out_stock_alert",       str_replace("'", "\\'", htmlspecialchars(PRODUCT_OUT_STOCK_MSG)));

	// generate page link with query parameters
	$page = "product_details.php";
	$remove_parameters = array("rnd", "cart", "item_id");
	$get_vars = isset($_GET) ? $_GET : $HTTP_GET_VARS;
	$query_string = get_query_string($get_vars, $remove_parameters, "", false);
	$page	.= $query_string;
	$page .= strlen($query_string) ? "&" : "?";
	$cart_link  = $page;
	srand ((double) microtime() * 1000000);
	$random_value = rand();
	$page .= "item_id=" . urlencode($item_id);
	$cart_link .= "rnd=" . $random_value . "&";

	$t->set_var("rnd", $random_value);
	$t->set_var("rp_url", urlencode($page));
	$t->set_var("rp", htmlspecialchars($page));

	$t->set_var("current_category_id", $category_id);

	$sql  = " SELECT i.item_id, i.item_type_id, i.special_offer,i.item_name, i.friendly_url, ";
	$sql .= " i.features, i.full_desc_type, i.short_description, i.full_description, ";
	$sql .= " i.big_image, i.big_image_alt, i.small_image, i.small_image_alt, i.super_image, ";
	$sql .= " i.meta_title, i.meta_keywords, i.meta_description, ";
	$sql .= " i.buying_price, i." . $price_field . ", i.is_price_edit, i.properties_price, i." . $sales_field . ", i.discount_percent, i.tax_free, i.buy_link, ";
	$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action, ";
	$sql .= " i.total_views, i.votes, i.points, i.is_sales, i.is_compared, ";
	$sql .= " i.manufacturer_code, m.manufacturer_name, m.affiliate_code, m.image_large AS manufacturer_image_src, m.image_large_alt AS manufacturer_image_alt, ";
	$sql .= " i.template_name, i.hide_add_details, i.preview_url, i.preview_width, i.preview_height, ";
	$sql .= " i.stock_level, st_in.shipping_time_desc AS in_stock_message, st_out.shipping_time_desc AS out_stock_message, ";
	$sql .= " sr.shipping_rule_desc, notes, weight, i.use_stock_level, i.disable_out_of_stock, i.hide_out_of_stock ";
	$sql .= " FROM (((((" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.is_active=1 AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
	$sql .= " LEFT JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_rules sr ON i.shipping_rule_id=sr.shipping_rule_id) ";
	$sql .= " WHERE i.item_id = " . $db->tosql($item_id, INTEGER);
	$sql .= " AND i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";

	$t->set_var("category_id", $category_id);

	$db->query($sql);
	if ($db->next_record())
	{
		$item_number = 0;
		$tabs = array("desc");

		//-- set custom template for specific product
		$template_name = $db->f("template_name");
		if (strlen($template_name)) {
			$t->set_file("block_body", $template_name);
		}

		$item_number++;
		$item_id = $db->f("item_id");
		$item_type_id = $db->f("item_type_id");

		$item_name_initial = $db->f("item_name");
		$item_name = get_translation($item_name_initial);
		$friendly_url = $db->f("friendly_url");
		$form_id = $item_id;
		$short_description = get_translation($db->f("short_description"));
		$full_description = get_translation($db->f("full_description"));
		$special_offer = get_translation($db->f("special_offer"));
		$full_desc_type = $db->f("full_desc_type");
		$is_compared = $db->f("is_compared");
		$notes = get_translation($db->f("notes"));

		$price = $db->f($price_field);
		$is_price_edit = $db->f("is_price_edit");
		$is_sales = $db->f("is_sales");
		$sales_price = $db->f($sales_field);
		$user_price = $db->f("user_price");
		$user_price_action = $db->f("user_price_action");
		$properties_price = $db->f("properties_price");
		$buying_price = $db->f("buying_price");

		$weight = $db->f("weight");
		$item_tax_free = $db->f("tax_free");
		$tax_free = ($item_tax_free || $user_tax_free);
		$manufacturer_code = $db->f("manufacturer_code");
		$manufacturer_name = $db->f("manufacturer_name");
		$manufacturer_image_src = $db->f("manufacturer_image_src");
		$manufacturer_image_alt = $db->f("manufacturer_image_alt");
		$stock_level = $db->f("stock_level");
		$use_stock_level = $db->f("use_stock_level");
		$disable_out_of_stock = $db->f("disable_out_of_stock");
		$hide_out_of_stock = $db->f("hide_out_of_stock");
		$hide_add_details = $db->f("hide_add_details");
		$quantity_limit = ($use_stock_level && ($disable_out_of_stock || $hide_out_of_stock));
		$total_views = $db->f("total_views");
		// meta files
		$html_title = $db->f("meta_title");
		$meta_keywords = $db->f("meta_keywords");
		$meta_description = $db->f("meta_description");
		// preview data
		$preview_url = $db->f("preview_url");
		$preview_width = $db->f("preview_width");
		$preview_height = $db->f("preview_height");

		if (!$full_description) { $full_description = $short_description; }

		if (!strlen($html_title)) { $html_title = $item_name; }
		if (!strlen($meta_description)) {
			if (strlen($short_description)) {
				$meta_description = $short_description;
			} elseif (strlen($full_description)) {
				$meta_description = $full_description;
			} else {
				$meta_description = $item_name;
			}
		}

		// calculate price
		if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
			if ($is_sales && $sales_price > 0) {
				$sales_price = $user_price;
			} else {
				$price = $user_price;
			}
		}

		if ($user_price_action != 1) {
			if ($discount_type == 1 || $discount_type == 3) {
				$price -= round(($price * $discount_amount) / 100, 2);
				$sales_price -= round(($sales_price * $discount_amount) / 100, 2);
			} elseif ($discount_type == 2) {
				$price -= round($discount_amount, 2);
				$sales_price -= round($discount_amount, 2);
			} elseif ($discount_type == 4) {
				$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
				$sales_price -= round((($sales_price - $buying_price) * $discount_amount) / 100, 2);
			}
		}
		$item_price = calculate_price($price, $is_sales, $sales_price);

		$properties = show_items_properties($item_id, $item_type_id, $item_price, $tax_free, "details");
		$is_properties  = $properties["is_any"];
		$properties_ids = $properties["ids"];
		$selected_price = $properties["price"];
		$components_price = $properties["components_price"];
		$components_tax_price = $properties["components_tax_price"];

		$t->set_var("item_id", $item_id);
		$t->set_var("form_id", $form_id);
		$t->set_var("item_name", $item_name);
		$t->set_var("product_name", $item_name);
		$t->set_var("product_title", $item_name);
		$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));
		$t->set_var("manufacturer_code", htmlspecialchars($manufacturer_code));
		$t->set_var("manufacturer_name", htmlspecialchars($manufacturer_name));
		$t->set_var("manufacturer_image_src", htmlspecialchars($manufacturer_image_src));
		$t->set_var("manufacturer_image_alt", htmlspecialchars($manufacturer_image_alt));
		$t->set_var("total_views", $total_views);
		$t->set_var("tax_price", "");
		$t->set_var("tax_sales", "");

		// show product code
		if ($product_code_details && $manufacturer_code) {
			$t->sparse("product_code", false);
		} else {
			$t->set_var("product_code", "");
		}

		// show manufacturer's image
		if (strlen($manufacturer_image_src)) {
			$t->sparse("manufacturer_image", false);
		} else {
			$t->set_var("manufacturer_image", "");
		}

		$t->set_var("item_added", "");
		$t->set_var("sc_errors", "");
		if ($item_id == $sc_item_id) {
			if ($sc_errors) {
				$t->set_var("errors_list", $sc_errors);
				$t->parse("sc_errors", false);
			} elseif ($item_added) {
				$added_message = str_replace("{product_name}", $item_name, ADDED_PRODUCT_MSG);
				$t->set_var("added_message", $added_message);
				$t->parse("item_added", false);
			}
		} 

		$t->set_var("stock_level", $stock_level);
		if ($stock_level > 0) {
			$shipping_time_desc = $db->f("in_stock_message");
		} else {
			$shipping_time_desc = $db->f("out_stock_message");
		}
		if (strlen($shipping_time_desc))
		{
			$t->set_var("shipping_time_desc", get_translation($shipping_time_desc));
			$t->parse("availability", false);
		}
		if (strlen($db->f("shipping_rule_desc")))
		{
			$t->set_var("shipping_rule_desc", get_translation($db->f("shipping_rule_desc")));
			$t->parse("shipping_block", false);
		}

		$features_list = get_translation($db->f("features"));
		if ($features_list)
		{
			$features_list = str_replace("{item_name}", $item_name, $features_list);
			$features_list = str_replace("{manufacturer_code}", $manufacturer_code, $features_list);
			$features_list = str_replace("{manufacturer_image_src}", $manufacturer_image_src, $features_list);
			$features_list = str_replace("{manufacturer_image_alt}", $manufacturer_image_alt, $features_list);
			$t->set_var("features_list", $features_list);
			$t->sparse("features_list_block", false);
		}
		$t->set_var("special_offer", $special_offer);

		$big_image = $db->f("big_image");
		if (!$big_image) { $big_image = $db->f("small_image"); }
		if (!$big_image) { $big_image = $product_no_image; }
		$big_image_alt = $db->f("big_image_alt");
		if (!$big_image_alt) { $big_image_alt = $db->f("small_image_alt"); }
		if ($big_image)
		{
			if (preg_match("/^http\:\/\//", $big_image)) {
				$image_size = "";
			} else {
				$image_size = @getimagesize($big_image);
				if (isset($restrict_products_images) && $restrict_products_images) { $big_image = "image_show.php?item_id=".$item_id."&type=large"; }
			}
			if (!strlen($big_image_alt)) {
				$big_image_alt = $item_name;
			}
			$t->set_var("alt", htmlspecialchars($big_image_alt));
			$t->set_var("src", htmlspecialchars($big_image));
			if (is_array($image_size)) {
				$t->set_var("width", "width=\"" . $image_size[0] . "\"");
				$t->set_var("height", "height=\"" . $image_size[1] . "\"");
			} else {
				$t->set_var("width", "");
				$t->set_var("height", "");
			}
			$t->parse("big_image", false);
		}
		else
		{
			$t->set_var("big_image", "");
		}

		$super_image = $db->f("super_image");
		if (strlen($super_image))
		{
			if (preg_match("/^http\:\/\//", $super_image)) {
				$image_size = "";
			} else {
				$image_size = @getimagesize($super_image);
				if (isset($restrict_products_images) && $restrict_products_images) {
					$super_image = "image_show.php?item_id=".$item_id."&type=super";
				}
			}
			$t->set_var("src", htmlspecialchars($super_image));
			if (is_array($image_size)) {
				$t->set_var("width", $image_size[0]);
				$t->set_var("height", $image_size[1]);
			} else {
				$t->set_var("width", 0);
				$t->set_var("height", 0);
			}
			$t->sparse("super_image", false);
		}
		else
		{
			$t->set_var("super_image", "");
		}

		if (strlen($preview_url)) {
			if (!$preview_width) { $preview_width = 500; }
			if (!$preview_height) { $preview_height = 400; }
			$t->set_var("preview_url", $preview_url);
			$t->set_var("preview_width", $preview_width);
			$t->set_var("preview_height", $preview_height);
			$t->sparse("product_preview", false);
		} else {
			$t->set_var("product_preview", "");
		}

		$recent_price = 0;
		if ($display_products != 2 || strlen($user_id)) {
			set_quantity_control($quantity_limit, $stock_level);

			// calculate recent price
			$recent_price  = calculate_price($price, $is_sales, $sales_price);
			$recent_price += $properties_price;

			// add currency rate
			$price = $price * $currency_rate;
			$sales_price = $sales_price * $currency_rate;
			$components_price = $components_price * $currency_rate;
			$components_tax_price = $components_tax_price * $currency_rate;
	  
			$base_price = calculate_price($price, $is_sales, $sales_price);
			$t->set_var("base_price", $base_price);
			if ($is_price_edit) {
				$t->set_var("price_class", "editprice");
				$t->set_var("price_readonly", "");
				if ($price > 0) {
					$control_price = number_format($price, 2);
				} else {
					$control_price = "";
				}
				$t->set_var("pe", "1");
				$t->set_var("price", $control_price);
				$t->set_var("price_control", "<input name=\"price\" type=\"text\" class=\"editprice\" value=\"" . $control_price . "\">");
				$t->sparse("price_block", false);
				$t->set_var("sales", "");
				$t->set_var("save", "");
			} elseif ($sales_price > 0 && $sales_price != $price && $is_sales) {
				$discount_percent = round($db->f("discount_percent"), 0);
				if (!$discount_percent && $price > 0) 
					$discount_percent = round(($price - $sales_price) / ($price / 100), 0);
	  
				$t->set_var("discount_percent", $discount_percent);

				set_tax_price($item_id, $item_type_id, $price, $sales_price + $selected_price, $tax_free, "price", "sales_price", "tax_sales", true, $components_price, $components_tax_price);
	  
				$t->set_var("pe", "0");
				$t->set_var("price_class", "realprice");
				$t->sparse("price_block", false);
				$t->sparse("sales", false);
				$t->sparse("save", false);
			}
			else
			{
				set_tax_price($item_id, $item_type_id, $price + $selected_price, 0, $tax_free, "price", "", "tax_price", true, $components_price, $components_tax_price);

				$t->set_var("pe", "0");
				$t->set_var("price_class", "ourprice");
				$t->sparse("price_block", false);
				$t->set_var("sales", "");
				$t->set_var("save", "");
			}
	  
			$product_quantity = isset($settings["product_quantity"]) ? $settings["product_quantity"] : "";
			$buy_link = $db->f("buy_link");
			if ($buy_link) {
				$t->set_var("buy_href", $db->f("buy_link") . $db->f("affiliate_code"));
			} elseif ($is_properties || $product_quantity == "LISTBOX" || $product_quantity == "TEXTBOX" || $is_price_edit) {
				$t->set_var("buy_href", "javascript:document.form_" . $item_id . ".submit();");
			} else {
				$t->set_var("buy_href", $cart_link . "cart=ADD&item_id=" . $item_id . "&rp=" . urlencode($page));
			}
	  
			// parse 'add to cart' button
			if ($hide_add_details || $shop_hide_add_details) {
				$t->set_var("add_button", "");
				$t->set_var("add_button_disabled", "");
			} else {
				if ($use_stock_level && $stock_level < 1 && $disable_out_of_stock) {
					$t->set_var("add_button", "");
					$t->sparse("add_button_disabled", false);
				} else {
					$t->set_var("add_button_disabled", "");
					$t->sparse("add_button", false);
				}
			}
			if (!$shop_hide_view_details) {
				$t->sparse("view_button", false);
			}
			if (!$shop_hide_checkout_details) {
				$t->sparse("checkout_button", false);
			}
		}

		// description block
		$t->set_var("description_block", "");
		if (!$use_tabs || $tab == "desc") {
			if ($use_tabs) {
				$t->set_var("title_desc", "");
			} else {
				$t->global_parse("title_desc", false, false, true);
			}

			if ($full_description) {
				if ($full_desc_type != 1)
					$full_description = nl2br(htmlspecialchars($full_description));
				$t->set_var("full_description", $full_description);
				$t->parse("description", false);
			} else {
				$t->set_var("description", "");
			}

			if (strlen($notes)) {
				$t->set_var("notes", $notes);
				$t->parse("notes_block", false);
			}

			if (!$hide_weight_details && $weight > 0) {
				if (strpos ($weight, ".") !== false) {
					while (substr($weight, strlen($weight) - 1) == "0")
						$weight = substr($weight, 0, strlen($weight) - 1);
				}
				if (substr($weight, strlen($weight) - 1) == ".")
					$weight = substr($weight, 0, strlen($weight) - 1);
				$t->set_var("weight", $weight . " " . $weight_measure);
				$t->sparse("weight_block", false);
			}
			$t->global_parse("description_block", false, false, true);
		}

		// specification details
		$t->set_var("specification", "");
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "features WHERE item_id=" . intval($item_id);
		$db->query($sql);
		$db->next_record();
		$total_spec = $db->f(0);
		if ($total_spec > 0) {
			$tabs[] = "spec";
			if (!$use_tabs || $tab == "spec") {
				if ($use_tabs) {
					$t->set_var("title_spec", "");
				} else {
					$t->global_parse("title_spec", false, false, true);
				}

				$sql  = " SELECT fg.group_id,fg.group_name,f.feature_name,f.feature_value ";
				$sql .= " FROM " . $table_prefix . "features f, " . $table_prefix . "features_groups fg ";
				$sql .= " WHERE f.group_id=fg.group_id ";
				$sql .= " AND f.item_id=" . intval($item_id);
				$sql .= " ORDER BY fg.group_order, f.feature_id ";
				$db->query($sql);
				if ($db->next_record()) {
					$last_group_id = $db->f("group_id");
					do {
						$group_id = $db->f("group_id");
						$feature_name = get_translation($db->f("feature_name"));
						$feature_value = get_translation($db->f("feature_value"));
						if ($group_id != $last_group_id) {
							$t->set_var("group_name", $last_group_name);
							$t->parse("groups", true);
							$t->set_var("features", "");
						}
      
						$t->set_var("feature_name", $feature_name);
						$t->set_var("feature_value", $feature_value);
						$t->parse("features", true);
      
						$last_group_id = $group_id;
						$last_group_name = get_translation($db->f("group_name"));
					} while ($db->next_record());
					$t->set_var("group_name", $last_group_name);
					$t->parse("groups", true);
					$t->parse("specification", false);
				} 
			}
		}
		// end specification


		// product images 
		$t->set_var("images", "");
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "items_images WHERE item_id=" . intval($item_id);
		$db->query($sql);
		$db->next_record();
		$total_images = $db->f(0);
		if ($total_images > 0) {
			$tabs[] = "images";
			if (!$use_tabs || $tab == "images") {
				if ($use_tabs) {
					$t->set_var("title_images", "");
				} else {
					$t->global_parse("title_images", false, false, true);
				}

				$image_number = 0;
				$sql  = " SELECT image_id, image_title, image_small, image_large, image_description  ";
				$sql .= " FROM " . $table_prefix . "items_images ";
				$sql .= " WHERE item_id=" . intval($item_id);
				$db->query($sql);
				while ($db->next_record()) {
					$image_number++;
	    
					$image_id = $db->f("image_id");
					$image_title = $db->f("image_title");
					$image_small = $db->f("image_small");
					$image_large = $db->f("image_large");
					$image_size  = "";
					if (!preg_match("/^http\:\/\//", $image_small)) {
						$image_size = @getimagesize($image_small);
						if (is_array($image_size)) {	
							$image_size = $image_size[3];
						}
					}

					if (isset($restrict_products_images) && $restrict_products_images) { 
						if ($image_small && !preg_match("/^http\:\/\//", $image_small)) {
							$image_small = "image_show.php?image_id=".$image_id."&type=small"; 
						}
						if ($image_large && !preg_match("/^http\:\/\//", $image_large)) {
							$image_large = "image_show.php?image_id=".$image_id."&type=large"; 
						}
					}

					if (!strlen($image_large)) {
						$image_large = $image_small;
					}
					$image_description = $db->f("image_description");
					$rollover_js = "";
      
					$t->set_var("image_id", $image_id);
					$t->set_var("image_title", $image_title);
					$t->set_var("image_small", $image_small);
					$t->set_var("image_size",  $image_size);
					$t->set_var("image_large", $image_large);
					$t->set_var("image_description", $image_description);
					if ($image_effect == 2) {
						$rollover_js = "roChange(roImage" . $image_id. "); return false;";
						if ($image_number == 1) {
							$t->set_var("rollover_image", $image_large);
						}
						$t->sparse("rollover_images", true);
					}
					$t->set_var("rollover_js", $rollover_js);

					$t->parse("images_cols", true);
					if ($image_number % 2 == 0) {
						$t->parse("images_rows", true);
						$t->set_var("images_cols", "");
					}
				}	    
				if ($image_number % 2 != 0) {
					$t->parse("images_rows", true);
				}

				if ($image_effect == 2) {
					$t->sparse("rollover_effect", false);
				}
				$t->parse("images", false);
			} 
		}
		// end images 


		// product accessories
		$t->set_var("accessories_block", "");
		$sql  = " SELECT COUNT(*) FROM (" . $table_prefix . "items i ";
		$sql .= " INNER JOIN " . $table_prefix . "items_accessories ia ON ";
		$sql .= " (i.item_id=ia.accessory_id AND ia.item_id=" . $db->tosql($item_id, INTEGER) . ")) ";
		$sql .= " WHERE ia.item_id=" . $db->tosql($item_id, INTEGER);
		$sql .= " AND i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
		$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
		$db->query($sql);
		$db->next_record();
		$total_accessories = $db->f(0);
		if ($total_accessories > 0) {
			$tabs[] = "accessories";
			if (!$use_tabs || $tab == "accessories") {
				if ($use_tabs) {
					$t->set_var("title_accessories", "");
				} else {
					$t->global_parse("title_accessories", false, false, true);
				}

				$accessory_number = 0;
				$sql  = " SELECT i.item_id, i.item_type_id, i.item_name, i.friendly_url, i.short_description, ";
				$sql .= " i.buying_price, i." . $price_field . ", i.properties_price, i." . $sales_field . ", i.is_sales, i.tax_free, ";
				$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action ";
				$sql .= " FROM (((" . $table_prefix . "items i ";
				$sql .= " INNER JOIN " . $table_prefix . "items_accessories ia ON ";
				$sql .= " (i.item_id=ia.accessory_id AND ia.item_id=" . $db->tosql($item_id, INTEGER) . ")) ";
				$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
				$sql .= " LEFT JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
				$sql .= " WHERE ia.item_id=" . $db->tosql($item_id, INTEGER);
				$sql .= " AND i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
				$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
				$sql .= " ORDER BY ia.accessory_order ";
				$db->query($sql);
				while ($db->next_record()) {
					$accessory_number++;
					$accessory_id = $db->f("item_id");
					$accessory_type_id = $db->f("item_type_id");
					$accessory_name = $db->f("item_name");
					$accessory_friendly_url = $db->f("friendly_url");
					$accessory_description = $db->f("short_description");
					$buy_accessory_href = $page . "&rnd=" . $random_value . "&cart=ADD&accessory_id=" . $accessory_id;
					if ($friendly_urls && $accessory_friendly_url) {
						$t->set_var("accessory_details_url", $accessory_friendly_url . $friendly_extension);
					} else {
						$t->set_var("accessory_details_url", "product_details.php?item_id=" . $accessory_id);
					}

					$price = $db->f($price_field);
					$buying_price = $db->f("buying_price");
					$sales_price = $db->f($sales_field);
					$is_sales = $db->f("is_sales");
					$user_price = $db->f("user_price");
					$user_price_action = $db->f("user_price_action");
					$properties_price = $db->f("properties_price");
					if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
						if ($sales_price > 0) {
							$sales_price = $user_price;
						} else {
							$price = $user_price;
						}
					}
					$accessory_tax_free = $db->f("tax_free");
					if ($user_tax_free) { $accessory_tax_free = $user_tax_free; }
					$accessory_price = calculate_price($price, $is_sales, $sales_price);
					if ($user_price_action != 1) {
						if ($discount_type == 1 || $discount_type == 3) {
							$accessory_price -= round(($accessory_price * $discount_amount) / 100, 2);
						} elseif ($discount_type == 2) {
							$accessory_price -= round($discount_amount, 2);
						} elseif ($discount_type == 4) {
							$accessory_price -= round((($accessory_price - $buying_price) * $discount_amount) / 100, 2);
						}
					}
					// add properties and components prices
					$accessory_price += $properties_price;
					$accessory_price = $currency_rate * $accessory_price;

					set_tax_price($accessory_id, $accessory_type_id, $accessory_price, 0, $accessory_tax_free, "accessory_price", "", "accessory_tax_price");

					$t->set_var("accessory_id", $accessory_id);
					$t->set_var("accessory_name", $accessory_name);
					$t->set_var("accessory_description", $accessory_description);
					if ($display_products != 2 || strlen($user_id)) {
						$t->set_var("buy_accessory_href", $buy_accessory_href);
						$t->sparse("accessory_price_block", false);
					}
	    
					$t->parse("accessories_cols", true);
					if ($accessory_number % 2 == 0) {
						$t->parse("accessories_rows", true);
						$t->set_var("accessories_cols", "");
					}
				} while ($db->next_record());

				if ($accessory_number % 2 != 0) {
					$t->parse("accessories_rows", true);
				}
				$t->parse("accessories_block", false);
			}
		}

		$t->parse("item");
		$t->set_var("no_item", "");

		$t->set_var("reviews", "");
		if ($reviews_availability && (!$use_tabs || $tab == "desc")) {
			// count reviews
			$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE approved=1 AND item_id=" . $db->tosql($item_id, INTEGER);
			$total_votes = get_db_value($sql);
			
			if ($total_votes)
			{
				// parse summary statistic
				$t->set_var("total_votes", $total_votes);
				$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
				$total_rating_votes = get_db_value($sql);
	  
				$average_rating_float = 0;
				if ($total_rating_votes)
				{
					$sql = " SELECT SUM(rating) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
					$average_rating_float = round(get_db_value($sql) / $total_rating_votes, 2);
				}
				$average_rating = round($average_rating_float, 0);
				$average_rating_image = $average_rating ? "rating_" . $average_rating . ".gif" : "not_rated.gif";
				$t->set_var("average_rating_image", $average_rating_image);
				$t->set_var("average_rating_alt", $average_rating_float);
	  
				$based_on_message = str_replace("{total_votes}", $total_votes, BASED_ON_REVIEWS_MSG);
				$t->set_var("BASED_ON_REVIEWS_MSG", $based_on_message);
				$t->parse("summary_statistic", false);
	  
				$is_reviews = false;
				$sql  = " SELECT * FROM " . $table_prefix . "reviews ";
				$sql .= " WHERE recommended=1 AND approved=1 AND comments IS NOT NULL ";
				$sql .= " AND item_id=" . $db->tosql($item_id, INTEGER);
				$sql .= " ORDER BY date_added DESC";  
				$db->RecordsPerPage = 1;
				$db->PageNumber = 1;
				$db->query($sql);
				if ($db->next_record())
				{
					$is_reviews = true;
					$rating = round($db->f("rating"), 0);
					$rating_image = $rating ? "rating_" . $rating . ".gif" : "not_rated.gif";
					$t->set_var("rating_image", $rating_image);
					$t->set_var("review_user_name", htmlspecialchars($db->f("user_name")));
					$date_added = $db->f("date_added", DATETIME);
					$date_added_string = va_date($datetime_show_format, $date_added);
					$t->set_var("review_date_added", $date_added_string);
					$t->set_var("review_summary", htmlspecialchars($db->f("summary")));
					$t->set_var("review_comments", nl2br(htmlspecialchars($db->f("comments"))));
        
					$t->set_var("POSITIVE_REVIEW_MSG",  POSITIVE_REVIEW_MSG);
					$t->parse("positive_review", false);
				}
	  
				$sql  = " SELECT * FROM " . $table_prefix . "reviews ";
				$sql .= " WHERE recommended=0 AND approved=1 AND comments IS NOT NULL ";
				$sql .= " AND item_id=" . $db->tosql($item_id, INTEGER);
				$sql .= " ORDER BY date_added DESC";  
				$db->RecordsPerPage = 1;
				$db->PageNumber = 1;
				$db->query($sql);
				if ($db->next_record())
				{
					$is_reviews = true;
					$rating = round($db->f("rating"), 0);
					$rating_image = $rating ? "rating_" . $rating . ".gif" : "not_rated.gif";
					$t->set_var("rating_image", $rating_image);
					$t->set_var("review_user_name", htmlspecialchars($db->f("user_name")));
					$date_added = $db->f("date_added", DATETIME);
					$date_added_string = va_date($datetime_show_format, $date_added);
					$t->set_var("review_date_added", $date_added_string);
					$t->set_var("review_summary", htmlspecialchars($db->f("summary")));
					$t->set_var("review_comments", nl2br(htmlspecialchars($db->f("comments"))));
        
					$t->set_var("NEGATIVE_REVIEW_MSG",  NEGATIVE_REVIEW_MSG);
					$t->parse("negative_review", false);
				}
	  
				if ($is_reviews) {
					$t->set_var("SEE_ALL_REVIEWS_MSG",  SEE_ALL_REVIEWS_MSG);
					$t->parse("all_reviews_link", false);
				}
	  
			}
			else
			{
				$t->parse("not_rated", false);
			}
			$t->parse("reviews", false);
		}

		// parse tabs
		if ($use_tabs) {
			if ($friendly_urls && $friendly_url) {
				$tab_transfer_query = transfer_params(array("item_id"), true);
				$tab_href = $friendly_url . $friendly_extension . $tab_transfer_query;
			} else {
				$tab_href = "product_details.php" . $transfer_query;
			}
			if (strrpos ($tab_href, "?")) {
				$tab_href .= "&tab=";
			} else {
				$tab_href .= "?tab=";
			}

			for ($i = 0; $i < sizeof($tabs); $i++) {
				$tab_name = $tabs[$i];
				$tab_style = ($tab == $tab_name) ? "tabActive" : "tab";
				$t->set_var("tab_href", $tab_href . $tab_name);
				$t->set_var("tab_style", $tab_style);
				$t->global_parse("tab_" . $tab_name, false, false, true);
			}
			$t->global_parse("tabs", false, false, true);
		} else {
			$t->set_var("tabs", false);
		}

		// update total views for product
		$products_viewed = get_session("session_products_viewed");
		if (!isset($products_viewed[$item_id])) {
			$sql  = " UPDATE " . $table_prefix . "items SET total_views=" . $db->tosql(($total_views + 1), INTEGER);
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
			$db->query($sql);

			$products_viewed[$item_id] = true;
			set_session("session_products_viewed", $products_viewed);
		}


		// fill in recently viewed products
		$recent_records = get_setting_value($page_settings, "recent_records", 10);
		$recently_viewed = get_session("session_recently_viewed");
		if (!is_array($recently_viewed)) {
			$recently_viewed = array();
		} 
		$recent_index = 0;
		foreach ($recently_viewed as $key => $recent_info) {
			if ($recently_viewed[$key][0] == $item_id) {
				unset($recently_viewed[$key]);
			} else {
				$recent_index++;
				if ($recent_index >= $recent_records) {
					unset($recently_viewed[$key]);
				}
			}
		}
		$recent_info = array($item_id, $item_type_id, $item_name_initial, $friendly_url, $recent_price, $buying_price, $item_tax_free, $is_compared);
		array_unshift($recently_viewed, $recent_info);
		set_session("session_recently_viewed", $recently_viewed);
	}
	else
	{
		$t->set_var("item", "");
		$t->set_var("NO_PRODUCT_MSG", NO_PRODUCT_MSG);
		$t->parse("no_item", false);
	}

	$t->parse("block_body", false);
	$t->parse($block_name, true);
}

?>