<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_products_top_rated.php                             ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function top_products($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $category_id, $language_code;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$product_no_image = get_setting_value($settings, "product_no_image", "");
	$top_rated_image = get_setting_value($page_settings, "top_rated_image",  0);
	$top_rated_desc = get_setting_value($page_settings, "top_rated_desc", 0);

	$image_field = ""; $image_alt_field = ""; $desc_field = "";
	if ($top_rated_image == 1) {
		$image_field = "tiny_image";
		$image_alt_field = "tiny_image_alt";
	} else if ($top_rated_image == 2) {
		$image_field = "small_image";
		$image_alt_field = "small_image_alt";
	} else if ($top_rated_image == 3) {
		$image_field = "big_image";
		$image_alt_field = "big_image_alt";
	} else if ($top_rated_image == 4) {
		$image_field = "super_image";
		$image_alt_field = "big_image_alt";
	}
	if ($top_rated_desc == 1) {
		$desc_field = "short_description";
	} else if ($top_rated_desc == 2) {
		$desc_field = "full_description";
	} else if ($top_rated_desc == 3) {
		$desc_field = "features";
	} else if ($top_rated_desc == 4) {
		$desc_field = "special_offer";
	}

	$t->set_file("block_body", "block_top_rated.html");
	$t->set_var("top_category_name",PRODUCTS_TITLE);
	$t->set_var("TOP_RATED_TITLE",  TOP_RATED_TITLE);
	$t->set_var("top_rated_items",  "");

	$sql  = " SELECT i.item_id, i.item_name, i.friendly_url, i.rating ";
	if ($image_field) { $sql .= " , i." . $image_field; }
	if ($image_alt_field) { $sql .= " , i." . $image_alt_field; }
	if ($desc_field) { $sql .= " , i." . $desc_field; }
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic";
	$sql .= " WHERE i.item_id=ic.item_id ";
	$sql .= " AND i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " AND i.votes>=" . $db->tosql(get_setting_value($settings, "min_votes", 10), INTEGER);
	$sql .= " AND i.rating>=" . $db->tosql(get_setting_value($settings, "min_rating", 1), FLOAT);
	$sql .= " GROUP BY i.item_id, i.item_name, i.friendly_url, i.rating, i.item_order ";
	if ($image_field) { $sql .= " , " . $image_field; }
	if ($image_alt_field) { $sql .= " , " . $image_alt_field; }
	if ($desc_field) { $sql .= " , " . $desc_field; }
	$sql .= " ORDER BY i.rating DESC, i.item_order, i.item_name  ";

	$db->RecordsPerPage = 10;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$item_number = 0;
		do
		{
			$item_number++;
			$item_id = $db->f("item_id");
			$item_name = get_translation($db->f("item_name"));
			$friendly_url = $db->f("friendly_url");
			$item_image = ""; $item_image_alt = ""; $item_desc = "";
			if ($image_field) {
				$item_image = $db->f($image_field);	
				$item_image_alt = $db->f($image_alt_field);	
				if (!$item_image) {
					$item_image = $product_no_image;
				}
			}
			if ($desc_field) {
				$item_desc = $db->f($desc_field);	
			}

			if ($friendly_urls && $friendly_url) {
				$details_href = $friendly_url . $friendly_extension;
			} else {
				$details_href = "product_details.php?item_id=".urlencode($item_id);
			}

			$t->set_var("top_position", $item_number);
			$t->set_var("top_name", $item_name);
			$t->set_var("top_rating", number_format($db->f("rating"), 2));
			$t->set_var("details_href", $details_href);

			if($item_image)
			{
				if (preg_match("/^http\:\/\//", $item_image)) {
					$image_size = "";
				} else {
	        $image_size = @GetImageSize($item_image);
					if (isset($restrict_products_images) && $restrict_products_images) { $item_image = "image_show.php?item_id=".$item_id."&type=small"; }
				}
				if (!strlen($item_image_alt)) { $item_image_alt = $item_name; }
        $t->set_var("alt", htmlspecialchars($item_image_alt));
        $t->set_var("src", htmlspecialchars($item_image));
				if(is_array($image_size)) {
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				} else {
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->sparse("top_image", false);
			} else {
				$t->set_var("top_image", "");
			}
			if ($item_desc) {
				$t->set_var("desc_text", $item_desc);
				$t->sparse("top_desc", false);
			} else {
				$t->set_var("top_desc", "");
			}

			$t->parse("top_rated_items", true);
		} while ($db->next_record());              	
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>