<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_products_top_viewed.php                            ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function products_top_viewed($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $language_code;

	if (get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$product_no_image = get_setting_value($settings, "product_no_image", "");
	$top_viewed_image = get_setting_value($page_settings, "top_viewed_image",  0);
	$top_viewed_desc = get_setting_value($page_settings, "top_viewed_desc", 0);

	$image_field = ""; $image_alt_field = ""; $desc_field = "";
	if ($top_viewed_image == 1) {
		$image_field = "tiny_image";
		$image_alt_field = "tiny_image_alt";
	} elseif ($top_viewed_image == 2) {
		$image_field = "small_image";
		$image_alt_field = "small_image_alt";
	} elseif ($top_viewed_image == 3) {
		$image_field = "big_image";
		$image_alt_field = "big_image_alt";
	} elseif ($top_viewed_image == 4) {
		$image_field = "super_image";
		$image_alt_field = "big_image_alt";
	}
	if ($top_viewed_desc == 1) {
		$desc_field = "short_description";
	} elseif ($top_viewed_desc == 2) {
		$desc_field = "full_description";
	} elseif ($top_viewed_desc == 3) {
		$desc_field = "features";
	} elseif ($top_viewed_desc == 4) {
		$desc_field = "special_offer";
	}


	$t->set_file("block_body", "block_products_top_viewed.html");
	$t->set_var("top_viewed_rows", "");
	$t->set_var("top_viewed_rows", "");

	$sql  = " SELECT i.item_id, i.item_name, i.friendly_url, i.total_views ";
	if ($image_field) { $sql .= " , i." . $image_field; }
	if ($image_alt_field) { $sql .= " , i." . $image_alt_field; }
	if ($desc_field) { $sql .= " , i." . $desc_field; }
	$sql .= " FROM " . $table_prefix . "items i ";
	$sql .= " WHERE i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " AND (i.issue_date IS NULL OR i.issue_date<=" . $db->tosql(va_time(), DATETIME) . ") ";
	$sql .= " ORDER BY i.total_views DESC, i.item_order, i.item_name ";

	$records_per_page = get_setting_value($page_settings, "prod_top_viewed_recs", 10);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = 1;
	$db->query($sql);
	if ($db->next_record())
	{
		$top_columns = get_setting_value($page_settings, "prod_top_viewed_cols", 1);
		$t->set_var("top_viewed_column", (100 / $top_columns) . "%");
		$top_number = 0;
		do
		{
			$top_number++;
			$item_id = $db->f("item_id");
			$item_name = get_translation($db->f("item_name"));
			$friendly_url = $db->f("friendly_url");
			$total_views = $db->f("total_views");
			$item_image = ""; $item_image_alt = ""; $item_desc = "";
			if ($image_field) {
				$item_image = $db->f($image_field);	
				$item_image_alt = $db->f($image_alt_field);	
				if (!$item_image) {
					$item_image = $product_no_image;
				}
			}
			if ($desc_field) {
				$item_desc = $db->f($desc_field);	
			}

			if ($friendly_urls && $friendly_url) {
				$t->set_var("product_url", $friendly_url . $friendly_extension);
			} else {
				$t->set_var("product_url", "product_details.php?item_id=" . $item_id);
			}
		
			$t->set_var("top_position", $top_number);
			$t->set_var("item_id", $item_id);
			$t->set_var("item_name", $item_name);
			$t->set_var("total_views", $total_views);

			if ($item_image)
			{
				if (preg_match("/^http\:\/\//", $item_image)) {
					$image_size = "";
				} else {
					$image_size = @getimagesize($item_image);
					if (isset($restrict_products_images) && $restrict_products_images) { $item_image = "image_show.php?item_id=".$item_id."&type=small"; }
				}
				if (!strlen($item_image_alt)) { $item_image_alt = $item_name; }
				$t->set_var("alt", htmlspecialchars($item_image_alt));
				$t->set_var("src", htmlspecialchars($item_image));
				if (is_array($image_size)) {
					$t->set_var("width", "width=\"" . $image_size[0] . "\"");
					$t->set_var("height", "height=\"" . $image_size[1] . "\"");
				} else {
					$t->set_var("width", "");
					$t->set_var("height", "");
				}
				$t->sparse("top_image", false);
			} else {
				$t->set_var("top_image", "");
			}
			if ($item_desc) {
				$t->set_var("desc_text", $item_desc);
				$t->sparse("top_desc", false);
			} else {
				$t->set_var("top_desc", "");
			}

			$t->parse("top_viewed_cols");
			if ($top_number % $top_columns == 0)
			{
				$t->parse("top_viewed_rows");
				$t->set_var("top_viewed_cols", "");
			}
			
		} while ($db->next_record());

		if ($top_number % $top_columns != 0) {
			$t->parse("top_viewed_rows");
		}

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}
}

?>