<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  block_site_map.php                                       ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function site_map($block_name)
{
	global $t, $db, $table_prefix, $language_code;
	global $page_settings;
	global $categories, $settings;

	include_once ("./messages/".$language_code."/manuals_messages.php");

//	$support_deps = get_db_values("SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='site_map' ");
//print_r($support_deps);


	$site_map_custom_pages = allowed_site_map("site_map_custom_pages");
	$site_map_categories = allowed_site_map("site_map_categories");
	$site_map_forums = allowed_site_map("site_map_forums");
	$site_map_ad_categories = allowed_site_map("site_map_ad_categories");
	$site_map_manuals = allowed_site_map("site_map_manuals");

	$t->set_var("SITE_MAP",SITE_MAP_TITLE);
	
	$t->set_file("block_body", "block_site_map.html");

	$show_map=false;
// custom_pages
	if($site_map_custom_pages){
		$sql  = " SELECT page_code, page_title, page_url ";
		$sql .= " FROM " . $table_prefix . "pages ";
		$sql .= " WHERE is_showing=1 ";
		$sql .= " ORDER BY page_order, page_title ";
		$db->query($sql);
		while ($db->next_record()) {
			$item_name = get_translation($db->f('page_title'), $language_code);
			if ($db->f('page_url')) {
				$item_url = $db->f('page_url');
			}else{
				$item_url = $settings["site_url"]."page.php?page=".$db->f('page_code');
			}

			$t->set_var("item_tr_class", "topCategory");
			$t->set_var("item_url", $item_url);
			$t->set_var("item_name", $item_name);

			$t->parse("item");
			$t->parse("items_rows");
			$t->set_var("item", "");
		}
	}
// custom_pages
// product		
	if($site_map_categories){
		$categories = array();
		$categories[-1]["subs"][] = 0;
		$categories[0]["category_name"] = PRODUCTS_TITLE;
		$categories[0]["parent_id"] = -1;
		$sql  = " SELECT category_id, category_name, parent_category_id ";
		$sql .= " FROM " . $table_prefix . "categories ";
		$sql .= " WHERE is_showing=1";
		$sql .= " ORDER BY category_order, category_name ";
		$db->query($sql);
		while ($db->next_record()) {
			$cur_category_id = $db->f("category_id");
			$category_name = get_translation($db->f("category_name"), $language_code);
			$parent_category_id = $db->f("parent_category_id");
			$categories[$cur_category_id]["parent_id"] = $parent_category_id;
			$categories[$cur_category_id]["category_name"] = $category_name;
			$categories[$parent_category_id]["subs"][] = $cur_category_id;
		}
			
		if (sizeof($categories) > 0)
		{
			show_map(-1, 0, -1, 'item');
			$show_map=true;
		}
	}
// product		

// Articles		
	$categories_allowed = array();
	$sql  = " SELECT category_id, category_name, parent_category_id ";
	$sql .= " FROM " . $table_prefix . "articles_categories ";
	$sql .= " WHERE allowed_view=1";
	$sql .= " AND parent_category_id=0";
	$sql .= " ORDER BY category_order, category_name ";
	$db->query($sql);
	while ($db->next_record()) {
		if(allowed_site_map("site_map_articles_categories_".$db->f("category_id"))){
			$categories_allowed[]=$db->f("category_id");
		}
	}

	$is_show=false;
	foreach ($categories_allowed as $row => $category_id)
	{
		$categories = array();
		$sql  = " SELECT category_id, category_name, parent_category_id ";
		$sql .= " FROM " . $table_prefix . "articles_categories ";
		$sql .= " WHERE allowed_view=1";
		$sql .= " AND (category_path LIKE '%".$category_id.",%'";
		$sql .= " OR category_id=".$category_id.")";
		$sql .= " ORDER BY category_order, category_name ";
		$db->query($sql);
		while ($db->next_record()) {
			$site_map_articles_categories = get_setting_value($page_settings, "site_map_articles_categories");
			$cur_category_id = $db->f("category_id");
			$category_name = get_translation($db->f("category_name"), $language_code);
			$parent_category_id = $db->f("parent_category_id");
			$categories[$cur_category_id]["parent_id"] = $parent_category_id;
			$categories[$cur_category_id]["category_name"] = $category_name;
			$categories[$parent_category_id]["subs"][] = $cur_category_id;
			if (allowed_site_map("site_map_articles_categories_".$category_id)){
				$categories[$cur_category_id]["allowed_view"] = 1;
			}else{
				$categories[$cur_category_id]["allowed_view"] = 0;
			}
		}
		show_map(0, 0, 0, 'article');
		$is_show=true;
	}

	if ($is_show)
	{
		$show_map=true;
	}
// Articles		

// Forum
	if($site_map_forums){
		$categories = array();
		$categories[-1]["subs"][] = 0;
		$categories[0]["category_name"] = FORUM_TITLE;
		$categories[0]["parent_id"] = -1;
		$sql  = " SELECT category_id, category_name ";
		$sql .= " FROM " . $table_prefix . "forum_categories ";
		$sql .= " WHERE allowed_view=1";
		$sql .= " ORDER BY category_order, category_name ";
		$db->query($sql);
		while ($db->next_record()) {
			$cur_category_id = $db->f("category_id");
			$category_name = get_translation($db->f("category_name"), $language_code);
			$categories[$cur_category_id]["parent_id"] = 0;
			$categories[$cur_category_id]["category_name"] = $category_name;
			$categories[0]["subs"][] = $cur_category_id;
		}
			
		if (sizeof($categories) > 0)
		{
			show_map(-1, 0, -1, 'forum');
			$show_map=true;
		}
	}
// Forum

// ads
	if($site_map_ad_categories){
		$categories = array();
		$categories[-1]["subs"][] = 0;
		$categories[0]["category_name"] = ADS_TITLE;
		$categories[0]["parent_id"] = -1;
		$sql  = " SELECT category_id, category_name, parent_category_id ";
		$sql .= " FROM " . $table_prefix . "ads_categories ";
		$sql .= " WHERE allowed_view=1";
		$sql .= " ORDER BY category_order, category_name ";
		$db->query($sql);
		while ($db->next_record()) {
			$cur_category_id = $db->f("category_id");
			$category_name = get_translation($db->f("category_name"), $language_code);
			$parent_category_id = $db->f("parent_category_id");
			$categories[$cur_category_id]["parent_id"] = $parent_category_id;
			$categories[$cur_category_id]["category_name"] = $category_name;
			$categories[$parent_category_id]["subs"][] = $cur_category_id;
		}
			
		if (sizeof($categories) > 0)
		{
			show_map(-1, 0, -1, 'ads');
			$show_map=true;
		}
	}
// ads

// manual
	if($site_map_manuals){
		$categories = array();
		$categories[-1]["subs"][] = 0;
		$categories[0]["category_name"] = MANUALS_TITLE;
		$categories[0]["parent_id"] = -1;
		$sql  = " SELECT category_id, category_name ";
		$sql .= " FROM " . $table_prefix . "manuals_categories ";
		$sql .= " WHERE allowed_view=1";
		$sql .= " ORDER BY category_order, category_name ";
		$db->query($sql);
		while ($db->next_record()) {
			$cur_category_id = $db->f("category_id");
			$category_name = get_translation($db->f("category_name"), $language_code);
			$categories[$cur_category_id]["parent_id"] = 0;
			$categories[$cur_category_id]["category_name"] = $category_name;
			$categories[0]["subs"][] = $cur_category_id;
		}
			
		if (sizeof($categories) > 0)
		{
			show_map(-1, 0, -1, 'manual');
			$show_map=true;
		}
	}
// manual

	if($show_map){
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}
}
	
	function show_map($parent_id, $level, $top_id, $item_type)
//	$item_type 'item', 'article', 'forum', 'ads', 'manual'
	{
		global $t, $categories, $settings;
		global $db, $table_prefix, $language_code;
	
		$site_map_items = allowed_site_map("site_map_items");
		$site_map_forum_categories = allowed_site_map("site_map_forum_categories");
		$site_map_ads = allowed_site_map("site_map_ads");
		$site_map_manual_categories = allowed_site_map("site_map_manual_categories");
		$tw = 14; $th = 20;
		if (file_exists("images/".$settings["style_name"]."/tree_space.gif")) {
			$image_tree_space = "images/".$settings["style_name"]."/tree_space.gif";
			$image_tree_line = "images/".$settings["style_name"]."/tree_line.gif";
			$image_tree_begin = "images/".$settings["style_name"]."/tree_begin.gif";
			$image_tree_end = "images/".$settings["style_name"]."/tree_end.gif";
			$image_tree_top = "images/".$settings["style_name"]."/tree_top.gif";
		} else {
			$image_tree_space = "images/tree_space.gif";
			$image_tree_line = "images/tree_line.gif";
			$image_tree_begin = "images/tree_begin.gif";
			$image_tree_end = "images/tree_end.gif";
			$image_tree_top = "images/tree_top.gif";
		}
	
		$subs = isset($categories[$parent_id]) ? $categories[$parent_id]["subs"] : array();
		for ($i = 0; $i < sizeof($subs); $i++)
		{
			$show_category_id = $subs[$i];
			$category_name  = $categories[$show_category_id]["category_name"];
			if ($item_type == 'article'){
				$item_url = $settings["site_url"]."articles.php?category_id=".$show_category_id;
			}
			if ($item_type == 'item'){
				$item_url = $settings["site_url"]."products.php?category_id=".$show_category_id;
			}
			if ($item_type == 'forum'){
				$item_url = $settings["site_url"]."forums.php?category_id=".$show_category_id;
			}
			if ($item_type == 'ads'){
				$item_url = $settings["site_url"]."ads.php?category_id=".$show_category_id;
			}
			if ($item_type == 'manual'){
				$item_url = $settings["site_url"]."manuals.php?category_id=".$show_category_id;
			}
			$t->set_var("item_url", $item_url);
			$category_image = $image_tree_top;
			if ($i == sizeof($subs) - 1) {
				$categories[$show_category_id]["last"] = true;
			} else {
				$categories[$show_category_id]["last"] = false;
			}
	
			$t->set_var("category_id", $show_category_id);
	
			$tree_images = "";
			if ($parent_id != $top_id) {
				$tree_id = $parent_id; 
				if (isset($categories[$tree_id]["parent_id"])) {
					while ($categories[$tree_id]["parent_id"] != $top_id) {
						if ($categories[$tree_id]["last"]) {
							$tree_image = $image_tree_space;
						} else {
							$tree_image = $image_tree_line;
						}
						$tree_images = "<img border=0 align=left src=$tree_image hspace=0 width=$tw height=$th>" . $tree_images;
						$tree_id = $categories[$tree_id]["parent_id"];
					}
				}
			}
			if ($level > 0) {
				if ($categories[$show_category_id]["last"]) {
					$tree_images .= "<img border=0 align=left src=$image_tree_end hspace=0 width=$tw height=$th>"; 
				} else {
					$tree_images .= "<img border=0 align=left src=$image_tree_begin hspace=0 width=$tw height=$th>"; 
				}
				$t->set_var("item_tr_class", "subCategory");
			} else {
				$t->set_var("item_tr_class", "topCategory");
			}
	
			$t->set_var("item_name", $tree_images . $category_name);
			$t->parse("item");
			$t->parse("items_rows");
			$t->set_var("item", "");
//begin items
			$sql="";
			if ($item_type == 'article' && $categories[$show_category_id]["allowed_view"]){
				$sql  = "SELECT a.article_id AS item_id, a.article_title AS item_name FROM (" . $table_prefix . "articles a LEFT JOIN " . $table_prefix . "articles_assigned aa ON aa.article_id=a.article_id) ";
				$sql .= " WHERE aa.category_id=".$db->tosql($show_category_id, INTEGER)."  ORDER BY a.article_order, a.article_id";
			}
			if ($item_type == 'item' && $site_map_items){
				$sql  = "SELECT i.item_id AS item_id, i.item_name AS item_name FROM (" . $table_prefix . "items i LEFT JOIN " . $table_prefix . "items_categories ic ON ic.item_id=i.item_id) ";
				$sql .= " WHERE ic.category_id=".$db->tosql($show_category_id, INTEGER)."  ORDER BY i.item_order, i.item_name";
			}
			if ($item_type == 'forum' && $site_map_forum_categories){
				$sql  = "SELECT f.forum_id AS item_id, f.forum_name AS item_name FROM " . $table_prefix . "forum_list f ";
				$sql .= " WHERE f.category_id=".$db->tosql($show_category_id, INTEGER)."  ORDER BY f.forum_order, f.forum_name";
			}
			if ($item_type == 'ads' && $site_map_ads){
				$sql  = "SELECT ai.item_id AS item_id, ai.item_title AS item_name FROM (" . $table_prefix . "ads_items ai LEFT JOIN " . $table_prefix . "ads_assigned aa ON aa.item_id=ai.item_id) ";
				$sql .= " WHERE aa.category_id=".$db->tosql($show_category_id, INTEGER)."  ORDER BY ai.item_order, ai.item_title";
			}
			if ($item_type == 'manual' && $site_map_manual_categories){
				$sql  = "SELECT m.manual_id AS item_id, m.manual_title AS item_name FROM " . $table_prefix . "manuals_list m ";
				$sql .= " WHERE m.category_id=".$db->tosql($show_category_id, INTEGER)."  ORDER BY m.manual_order, m.manual_title";
			}
			if ($sql){
				$item_rows_count = 0;
				$items_tree_images = '';
				$db->query($sql);
				$item_rows = $db->num_rows();
				if ($level > 0) {
					$t->set_var("item_tr_class", "subCategory");
				}
				if (isset($categories[$show_category_id]["subs"])){
					$items_tree_images = "<img border=0 align=left src=$image_tree_line hspace=0 width=$tw height=$th>".$items_tree_images;
				}
				if (isset($categories[$show_category_id]["parent_id"])){
					$item_parent_id = $categories[$show_category_id]["parent_id"];
					$child_id = $show_category_id;
					while ($item_parent_id != $top_id){
						$subs_t = isset($categories[$item_parent_id]) ? $categories[$item_parent_id]["subs"] : array();
						if (isset($subs_t[sizeof($subs_t)-1])){
							if ($child_id == $subs_t[sizeof($subs_t)-1]) {
								$last = true;
							} else {
								$last = false;
							}
						}

						if ($last){
							$items_tree_images = "<img border=0 align=left src=$image_tree_space hspace=0 width=$tw height=$th>".$items_tree_images;
						}else{
							$items_tree_images = "<img border=0 align=left src=$image_tree_line hspace=0 width=$tw height=$th>".$items_tree_images;
						}
						$child_id = $item_parent_id;
						if (isset($categories[$item_parent_id]["parent_id"])){
							$item_parent_id = $categories[$item_parent_id]["parent_id"];
						}else{
							$item_parent_id = $top_id;
						}
					}
				}
				while ($db->next_record()) {
					$item_rows_count++;
					$t->set_var("item_tr_class", "subCategory");

					if($item_rows == $item_rows_count){
						$tree_image_item = $items_tree_images."<img border=0 align=left src=$image_tree_space hspace=0 width=$tw height=$th>"."<img border=0 align=left src=$image_tree_end hspace=0 width=$tw height=$th>"; 
					}else{
						$tree_image_item = $items_tree_images."<img border=0 align=left src=$image_tree_space hspace=0 width=$tw height=$th>"."<img border=0 align=left src=$image_tree_begin hspace=0 width=$tw height=$th>"; 
					}
					if ($item_type == 'article' && $categories[$show_category_id]["allowed_view"]){
						$item_url = $settings["site_url"]."article.php?category_id=".$show_category_id."&article_id=".$db->f('item_id');
					}
					if ($item_type == 'item' && $site_map_items){
						$item_url = $settings["site_url"]."product_details.php?category_id=".$show_category_id."&item_id=".$db->f('item_id');
					}
					if ($item_type == 'forum' && $site_map_forum_categories){
						$item_url = $settings["site_url"]."forum.php?forum_id=".$db->f('item_id');
					}
					if ($item_type == 'ads' && $site_map_ads){
						$item_url = $settings["site_url"]."ads_details.php?category_id=".$show_category_id."&item_id=".$db->f('item_id');
					}
					if ($item_type == 'manual' && $site_map_manual_categories){
						$item_url = $settings["site_url"]."manuals_articles.php?manual_id=".$db->f('item_id');
					}
					$t->set_var("item_url", $item_url);
					$item_name = get_translation($db->f("item_name"), $language_code);
					$t->set_var("item_name", $tree_image_item . $item_name);
					$t->parse("item");
					$t->parse("items_rows");
					$t->set_var("item", "");
	
				}
			}
//end items

			if (isset($categories[$show_category_id]["subs"]) && is_array($categories[$show_category_id]["subs"])) {
				show_map($show_category_id, $level + 1, $top_id, $item_type);
			}
	
		}
	}

	function allowed_site_map($value_mane)
	{
		global $db, $table_prefix;
		$dbs = new VA_SQL();
		$dbs->DBType     = $db->DBType;
		$dbs->DBDatabase = $db->DBDatabase;
		$dbs->DBUser     = $db->DBUser;
		$dbs->DBPassword = $db->DBPassword;
		$dbs->DBHost     = $db->DBHost;
		$dbs->DBPort       = $db->DBPort;
		$dbs->DBPersistent = $db->DBPersistent;

		$sql  = " SELECT setting_value ";
		$sql .= " FROM " . $table_prefix . "global_settings ";
		$sql .= " WHERE setting_type=".$dbs->tosql("site_map", TEXT);
		$sql .= " AND setting_name=".$dbs->tosql($value_mane, TEXT);
		$dbs->query($sql);
		if ($dbs->next_record()) {
			return $dbs->f("setting_value");
		}else{
			return "";
		}
		$dbs->close();
	}

?>