<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  forum_topic_new.php                                      ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./messages/".$language_code."/forum_messages.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/tree.php");
	include_once ("./includes/record.php");
	include_once ("./includes/sorter.php");
	include_once ("./includes/friendly_functions.php");
	
	// include blocks
	include_once ("./block_custom.php");
	include_once ("./block_banners.php");

	$display_forums = get_setting_value($settings, "display_forums", 0);
	if ($display_forums == 1) {
		// user need to be logged in before viewing forum 
		check_user_session();
	}
	$user_id = get_session("session_user_id");		
	$page_settings = va_page_settings("forum_topics", 0);
	$currency = get_currency();
	$forum_id = get_param("forum_id");
	$search_string = get_param("search");

	$forum_name = ""; $forum_description = ""; $forum_image = "";
	$desc_image = get_setting_value($page_settings, "forum_description_image", 3);
	$desc_type = get_setting_value($page_settings, "forum_description_type", 2);

	// retrieve forum info
	$sql  = " SELECT * FROM " . $table_prefix . "forum_list fl ";
	$sql .= " WHERE fl.forum_id=" . $db->tosql($forum_id, INTEGER);
	if (strlen($user_id)) {
		$sql .= " AND fl.allowed_view IN (1,2) ";
	} else {
		$sql .= " AND fl.allowed_view=1 ";
	}
	$db->query($sql);
	if ($db->next_record()) {
		$forum_name = get_translation($db->f("forum_name"));
		$allowed_view_topics = $db->f("allowed_view_topics");
		$allowed_post_topics = $db->f("allowed_post_topics");
		if ($desc_image == 3) {
			$forum_image = $db->f("large_image");
		} else if ($desc_image == 2) {
			$forum_image = $db->f("small_image");
		}
		if ($desc_type == 2) {
			$forum_description = get_translation($db->f("full_description"));
		} else if ($desc_type == 1) {
			$forum_description = get_translation($db->f("short_description"));
		}
	} else {
		header ("Location: forums.php");
		exit;
	}


	$html_title = FORUM_TITLE; $meta_description = NEW_TOPIC_MSG; $meta_keywords = ""; 
	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","forum_topic_new.html");
	$t->set_var("FORUM_TITLE", FORUM_TITLE);
	$t->set_var("ALL_FORUM_TOPICS_MSG", ALL_FORUM_TOPICS_MSG);
	$t->set_var("current_href", "forum_topic_new.php");
	include_once ("./header.php");
	if(is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if ($setting_name == "top_products_block") {
				include_once ("./block_top_products.php");
				top_products($setting_value);
			} else if ($setting_name == "products_top_sellers") {
				include_once ("./block_products_top_sellers.php");
				products_top_sellers($setting_value);
			} else if ($setting_name == "products_latest") {
				include_once ("./block_products_latest.php");
				products_latest($setting_value);
			} else if ($setting_name == "products_top_viewed") {
				include_once ("./block_products_top_viewed.php");
				products_top_viewed($setting_value);
			} else if ($setting_name == "search_block") {
				include_once ("./block_search.php");
				search_form($setting_value);
			} else if ($setting_name == "products_recently_viewed") {
				include_once ("./block_products_recently.php");
				products_recently_viewed($setting_value);
			} else if ($setting_name == "login_block") {
				login_form($setting_value);
			} else if ($setting_name == "cart_block") {
				include_once ("./block_cart.php");
				small_cart($setting_value);
			} else if ($setting_name == "subscribe_block") {
				include_once ("./block_subscribe.php");
				subscribe_form($setting_value);
			} else if ($setting_name == "sms_test_block") {
				include_once ("./block_sms_test.php");
				sms_test_form($setting_value);
			} else if ($setting_name == "poll_block") {
				include_once ("./block_poll.php");
				poll_form($setting_value);
			} else if ($setting_name == "language_block") {
				include_once ("./block_language.php");
				language_form($setting_value, $page_settings["language_selection"]);
			} else if ($setting_name == "currency_block") {
				include_once ("./block_currency.php");
				currency_form($setting_value);
			} else if($setting_name == "forum_search_block") {
				include_once ("./block_forum_search.php");
				forum_search($setting_value);
			} else if ($setting_name == "forum_latest") {
				include_once ("./block_forum_latest.php");
				forum_latest($setting_value);
			} else if ($setting_name == "forum_top_viewed") {
				include_once ("./block_forum_top_viewed.php");
				forum_top_viewed($setting_value);
			} else if($setting_name == "forum_list") {
				include_once ("./block_forum_list.php");
				forum_list($setting_value);
			} else if($setting_name == "forum_description") {
				include_once ("./block_forum_description.php");
				forum_description($setting_value, $forum_id, $forum_name, $forum_description, $forum_image);
			} else if($setting_name == "forum_topics_block") {
				include_once ("./block_forum_topic_new.php");
				forum_topic_new($setting_value, $forum_id, $allowed_post_topics);
			} else if($setting_name == "forum_breadcrumb") {
				include_once("./block_forum_breadcrumb.php");
				forum_breadcrumb($setting_value);
			} else if (preg_match("/^navigation_block_(\d+)$/", $setting_name, $matches)) {
				include_once("./block_navigation.php");
				navigation_menu($setting_value, $matches[1]);
			} else if (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} else if (preg_match("/^banners_group_/", $setting_name)) {
				banners_group($setting_value, substr($setting_name, 14));
			}
		}
	}
	if(!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if(!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if(!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}
	include_once ("./footer.php");

	$t->set_var("html_title", $html_title);
	$t->set_var("meta_keywords", $meta_keywords);
	$t->set_var("meta_description", get_meta_desc($meta_description));
	$t->pparse("main");
?>