<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  common_functions.php                                     ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	function get_query_string($variables, $remove_parameters, $query_string = "", $set_hidden_parameters = false)
	{
		global $t;

		if(is_array($variables))
		{
			$hidden_parameters = "";
			reset($variables);
			while(list($key, $value) = each($variables)) {
				$remove = false;
				if (is_array($remove_parameters)) {
					for($i = 0; $i < sizeof($remove_parameters); $i++) {
						if($key == $remove_parameters[$i]) {
							$remove = true;
							break;
						}
					}
				} else if($key == $remove_parameters) {
					$remove = true;
				}

				if (!$remove && strlen($value)) {
					$query_string .= strlen($query_string) ? "&" : "";
					$query_string .= $key . "=" . urlencode($value);
					if ($set_hidden_parameters) {
						$hidden_parameters .= "<input type=\"hidden\" name=\"$key\" value=\"";
						$hidden_parameters .= htmlspecialchars($value) . "\">";
					}
				}
			}
			if ($set_hidden_parameters) {
				$t->set_var("hidden_parameters", $hidden_parameters);
			}
		}

		if($query_string) {$query_string = "?" . $query_string; }

		return $query_string;
	}

	function get_transfer_params($remove_parameters = "")
	{
		$pass_parameters = array();
		$available_params = array(
			"search_string", "category_id", "search_category_id", "item_id", "article_id",
			"s_tit", "s_cod", "s_sds", "s_fds", "manf", "user", "lprice", "hprice",
			"lweight", "hweight", "page", "sw", "sf", "forum_id", "thread_id",
			"sort_ord", "sort_dir"
		);

		for ($si = 0; $si < sizeof($available_params); $si++) {
			$param_name  = $available_params[$si];
			$param_value = get_param($param_name);
			if (strlen($param_value)) {
				$pass_parameters[$param_name] = $param_value;
			}
		}

		$pq = get_param("pq");
		$fq = get_param("fq");
		if ($pq > 0) {
			for($pi = 1; $pi <= $pq; $pi++) {
				$property_name = get_param("pn_" . $pi);
				$property_value = get_param("pv_" . $pi);
				if (strlen($property_name) && strlen($property_value)) {
					$pass_parameters["pq"] = $pq;
					$pass_parameters["pn_" . $pi] = $property_name;
					$pass_parameters["pv_" . $pi] = $property_value;
				}
			}
		}
		if ($fq > 0) {
			for($fi = 1; $fi <= $fq; $fi++) {
				$feature_name = get_param("fn_" . $fi);
				$feature_value = get_param("fv_" . $fi);
				if (strlen($feature_name) && strlen($feature_value)) {
					$pass_parameters["fq"] = $fq;
					$pass_parameters["fn_" . $fi] = $feature_name;
					$pass_parameters["fv_" . $fi] = $feature_value;
				}
			}
		}
		// check parameters to be removed
		if (is_array($remove_parameters)) {
			for ($rp = 0; $rp < sizeof($remove_parameters); $rp++) {
				$param_name = $remove_parameters[$rp];
				if (isset($pass_parameters[$param_name])) {
					unset($pass_parameters[$param_name]);
				}
			}
		}
		return $pass_parameters;
	}

	function transfer_params($remove_parameters, $set_hidden_parameters = false)
	{
		$pass_parameters = get_transfer_params($remove_parameters);
		return get_query_string($pass_parameters, "", "", $set_hidden_parameters);
	}

	function get_param($param_name, $param_type = 0)
	{
	  global $HTTP_POST_VARS, $HTTP_GET_VARS;

	  $param_value = "";
		if (isset($_POST)) {
		  if(isset($_POST[$param_name]) && $param_type != GET)
	  	  $param_value = $_POST[$param_name];
		  else if(isset($_GET[$param_name]) && $param_type != POST)
	  	  $param_value = $_GET[$param_name];
		} else {
		  if(isset($HTTP_POST_VARS[$param_name]) && $param_type != GET)
	  	  $param_value = $HTTP_POST_VARS[$param_name];
		  else if(isset($HTTP_GET_VARS[$param_name]) && $param_type != POST)
	  	  $param_value = $HTTP_GET_VARS[$param_name];
		}

	  return strip($param_value);
	}

	function get_cookie($parameter_name)
	{
	  global $HTTP_COOKIE_VARS;
		if (isset($_COOKIE)) {
			return isset($_COOKIE[$parameter_name]) ? $_COOKIE[$parameter_name] : "";
		} else {
			return isset($HTTP_COOKIE_VARS[$parameter_name]) ? $HTTP_COOKIE_VARS[$parameter_name] : "";
		}
	}

	function get_session($parameter_name)
	{
		global $session_prefix;
		$parameter_name = $session_prefix . $parameter_name;
	  return isset($_SESSION[$parameter_name]) ? $_SESSION[$parameter_name] : "";
	}

	function set_session($parameter_name, $parameter_value)
	{
		global $session_prefix;
		$parameter_name = $session_prefix . $parameter_name;
		$_SESSION[$parameter_name] = $parameter_value;
	}

	function get_options($values, $selected_value)
	{
		$eol = get_eol();
		$options = "";
		if(is_array($values))
		{
			for($i = 0; $i < sizeof($values); $i++)
			{
				if($values[$i][0] == $selected_value && strlen($values[$i][0]) == strlen($selected_value))
					$selected = "selected";
				else
					$selected = "";
				$options .= "<option " . $selected;
				$options .= " value=\"" . htmlspecialchars($values[$i][0]) . "\">";
				$options .= htmlspecialchars($values[$i][1]) . "</option>". $eol;
			}
		}
		return $options;
	}

	function set_options($values, $value, $block_name, $events = "")
	{
		global $t;
		$t->set_var($block_name, "");
		if(is_array($values))
		{
			for($i = 0; $i < sizeof($values); $i++)
			{
				$cur_val = $values[$i][0];
				call_event($events, BEFORE_SHOW_VALUE, array("current_value" => $cur_val));
				$checked = ""; $selected = "";
				if(is_array($value)) {
					for($j = 0; $j < sizeof($value); $j++) {
						if($cur_val == $value[$j] && strlen($cur_val) == strlen($value[$j])) {
							$checked = "checked"; $selected = "selected";
							break;
						}
					}
				} else if($cur_val == $value && strlen($cur_val) == strlen($value)) {
					$checked = "checked"; $selected = "selected";
				}
				$t->set_var($block_name . "_index", ($i + 1));
				$t->set_var($block_name . "_checked", $checked);
				$t->set_var($block_name . "_selected", $selected);
				$t->set_var($block_name . "_value", htmlspecialchars($cur_val));
				$t->set_var($block_name . "_description", $values[$i][1]);
				$t->parse($block_name);
				call_event($events, AFTER_SHOW_VALUE, array("current_value" => $cur_val));
			}
		}
	}

	function get_ip()
	{
		return get_var("REMOTE_ADDR");
	}

	function prepare_regexp($regexp)
	{
		$escape_symbols = array("\\","/","^","\$",".","[","]","|","(",")","?","*","+","-","{","}");
		for ($i = 0; $i < sizeof($escape_symbols); $i++) {
			$regexp = str_replace($escape_symbols[$i], "\\" . $escape_symbols[$i], $regexp);
		}
		return $regexp;
	}

	function get_array_value($value_ids, $values, $glue = "")
	{
		$value_desc = "";
		if(is_array($values) && (is_array($value_ids) || strlen($value_ids))) {
			for($i = 0; $i < sizeof($values); $i++) {
				if (is_array($value_ids)) {
					if (in_array($values[$i][0], $value_ids)) {
						if (strlen($value_desc)) { $value_desc .= $glue; }
						$value_desc .= $values[$i][1];
					}
				} else if($values[$i][0] == $value_ids) {
					$value_desc = $values[$i][1];
					break;
				}
			}
		}
		return $value_desc;
	}

	function get_array_id($value_desc, $values)
	{
		$value_id = "";
		if(is_array($values) && strlen($value_desc))
			for($i = 0; $i < sizeof($values); $i++)
				if($values[$i][1] == $value_desc) {
					$value_id = $values[$i][0];
					break;
				}
		return $value_id;
	}


	function get_db_values($sql, $values_before, $shown_symbols = 0)
	{
		global $db;
		$values = array();

		$db_list = new VA_SQL();
		$db_list->DBType       = $db->DBType;
		$db_list->DBDatabase   = $db->DBDatabase;
		$db_list->DBUser       = $db->DBUser;
		$db_list->DBPassword   = $db->DBPassword;
		$db_list->DBHost       = $db->DBHost;
		$db_list->DBPort       = $db->DBPort;
		$db_list->DBPersistent = $db->DBPersistent;

		$i = 0;
		if(is_array($values_before))
		{
			for($j = 0; $j < sizeof($values_before); $j++)
			{
				$value_desciption = get_translation($values_before[$j][1]);
				if ($value_desciption && defined($value_desciption)) { $value_desciption = constant($value_desciption); }
				$values[$i][0] = $values_before[$j][0];
				$values[$i][1] = $value_desciption;
				$i++;
			}
		}

		$db_list->query($sql);
		if($db_list->next_record())
		{
			do
			{
				$value_desciption = get_translation($db_list->f(1));
				if ($value_desciption && defined($value_desciption)) { $value_desciption = constant($value_desciption); }
				if ($shown_symbols > 0 && strlen($value_desciption) > $shown_symbols) {
					$value_desciption = substr($value_desciption, 0, $shown_symbols) . "...";
				}
				$values[$i][0] = $db_list->f(0);
				$values[$i][1] = $value_desciption;
				$i++;
			} while ($db_list->next_record());
		}

		return $values;
	}

	function get_setting_value($settings_array, $setting_name, $default_value = "")
	{
		return (is_array($settings_array) && isset($settings_array[$setting_name]) && strlen($settings_array[$setting_name])) ? $settings_array[$setting_name] : $default_value;
	}

	function get_meta_desc($meta_description)
	{
		$meta_description = strip_tags($meta_description);
		if (strlen($meta_description) > 255) {
			$meta_description = substr($meta_description, 0, 250) . " ...";
		}
		$meta_description = str_replace("\"", "&quot;", $meta_description);
		return $meta_description;
	}

	function get_eol()
	{
		if (strtoupper(substr(PHP_OS,0,3)=='WIN')) {
			$eol = "\r\n";
		} else if (strtoupper(substr(PHP_OS,0,3)=='MAC')) {
			$eol = "\r";
		} else {
			$eol = "\n";
		}
		return $eol;
	}

	function get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type)
	{
		$mail_headers  = "";

		$eol = get_eol();

		if ($mail_from) { $mail_headers .= "From: " . $mail_from . $eol; }
		if ($mail_cc)  {
			$mail_cc = str_replace(";", ",", $mail_cc);
			$mail_headers .= "cc: " . $mail_cc . $eol;
		}
		if ($mail_bcc)  {
			$mail_bcc = str_replace(";", ",", $mail_bcc);
			$mail_headers .= "Bcc: " . $mail_bcc . $eol;
		}
		if ($mail_reply_to) { $mail_headers .= "Reply-To: " . $mail_reply_to . $eol; }
		if ($mail_return_path)  { $mail_headers .= "Return-path: " . $mail_return_path . $eol; }
		$mail_headers .= "MIME-Version: 1.0";
		if (strlen($mail_type)) {
			if ($mail_type) {
  		  $mail_headers .= $eol . "Content-Type: text/html;" . $eol;
			} else {
	      $mail_headers .= $eol . "Content-Type: text/plain;" . $eol;
			}
      $mail_headers .= "\tcharset=\"" . CHARSET . "\"";
		}

		return $mail_headers;
	}

	function strip($value)
	{
	  if(get_magic_quotes_gpc() == 0)
	    return $value;
	  else
	    return stripslashes($value);
	}

	function call_event($events, $event_name, $additional_parameters = "")
	{
		if (is_array($events) && isset($events[$event_name]) && function_exists($events[$event_name])) {
			if (isset($events[$event_name . "_params"]) && is_array($events[$event_name . "_params"])) {
				$event_parameters = $events[$event_name . "_params"];
			} else {
				$event_parameters = array();
			}
			if (is_array($additional_parameters)) {
				foreach ($additional_parameters as $key => $value) {
					$event_parameters[$key] = $value;
				}
			}
			call_user_func($events[$event_name], $event_parameters);
		}
	}

	function get_db_value($sql)
	{
		global $db;

		$db->query($sql);
		if ($db->next_record()) {
			return $db->f(0);
		} else  {
			return "";
		}
	}

	function get_page_url()
	{
		$server_name = getenv("SERVER_NAME");
		$request_uri = getenv("REQUEST_URI");
	}

	function get_script_name()
	{
		global $current_page;
		if (isset($current_page) && $current_page) {
			$script_name = $current_page;
		} else if (get_var("PHP_SELF")) {
			$script_name = get_var("PHP_SELF");
		} else if (get_var("SCRIPT_NAME")) {
			$script_name = get_var("SCRIPT_NAME");
		} else if (get_var("SCRIPT_FILENAME")) {
			$script_name = get_var("SCRIPT_FILENAME");
		} else if (get_var("REQUEST_URI")) {
			$script_name = get_var("REQUEST_URI");
		} else {
			$script_name = get_var("SCRIPT_URL");
		}

		return basename($script_name);
	}

	function get_request_page()
	{
		global $current_page;
		$request_page = get_var("REQUEST_URI");
		$request_page = preg_replace("/\?.*$/", "", $request_page);
		if (!$request_page || substr($request_page, -1) == "/") {
			if (get_var("SCRIPT_URL")) {
				$request_page = get_var("SCRIPT_URL");
			} else if (isset($current_page) && $current_page) {
				$request_page = $current_page;
			} else if (get_var("SCRIPT_NAME")) {
				$request_page = get_var("SCRIPT_NAME");
			} else if (get_var("PHP_SELF")) {
				$request_page = get_var("PHP_SELF");
			}
		}

		return basename($request_page);
	}

	function get_request_uri()
	{
		$request_uri = get_var("REQUEST_URI");
		if (!strlen($request_uri)) {
			$request_uri = get_var("SCRIPT_NAME");
			if (!$request_uri) { $request_uri = get_var("SCRIPT_URL"); }
			if (!$request_uri) { $request_uri = get_var("PHP_SELF"); }
			$query_string = get_var("QUERY_STRING");
			if (strlen($query_string)) {
				$request_uri .= "?" . $query_string;
			}
		}
		return $request_uri;
	}

	function check_user_session()
	{
	  if (!strlen(get_session("session_user_id"))) {
			$request_uri = get_request_uri();
			header ("Location: user_login.php?return_page=" . urlencode($request_uri) . "&type_error=1");
			exit;
		}
	}

	function check_black_ip($ip_address = "", $address_action = 1)
	{
		global $db, $table_prefix;

		if (!$ip_address) {
			$ip_address = get_ip();
		}
		$ip_parts = explode(".", $ip_address);
		$where = " WHERE address_action=" . $db->tosql($address_action, INTEGER) . " AND (";
		$ip_where = "";
		for ($i = 0; $i < sizeof($ip_parts); $i++) {
			if ($i) {
				$ip_where .= ".";
				$where .= " OR ";
			}
			$ip_where .= $ip_parts[$i];
			$where .= " ip_address=" . $db->tosql($ip_where, TEXT);
		}
		$where .= ") ";
		$sql = " SELECT COUNT(*) FROM ".$table_prefix."black_ips " . $where;

		$black_ips = get_db_value($sql);

		return $black_ips;
	}

	function check_banned_content($message)
	{
		global $db, $table_prefix;

		$is_banned = false; $banned_regexp = "";
		$sql = " SELECT content_text FROM ".$table_prefix."banned_contents ";
		$db->query($sql);
		while ($db->next_record()) {
			if ($banned_regexp) { $banned_regexp .= "|"; }
			$content_text = $db->f("content_text");
			$banned_regexp .= "(" . prepare_regexp($content_text) . ")";
		}

		if ($banned_regexp) {
			$is_banned = preg_match("/".$banned_regexp."/is", $message);
		}

		return $is_banned;
	}

	function hmac_md5 ($data, $key)
	{
		// RFC 2104 HMAC implementation for php.
		// Creates an md5 HMAC.

		$b = 64; // byte length for md5
		if (strlen($key) > $b) {
			$key = pack("H*",md5($key));
		}
		$key  = str_pad($key, $b, chr(0x00));
		$ipad = str_pad('', $b, chr(0x36));
		$opad = str_pad('', $b, chr(0x5c));
		$k_ipad = $key ^ $ipad ;
		$k_opad = $key ^ $opad;

		return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
	}

	function set_categories($parent_id, $level, $columns, $top_id, $image_type = 1)
	{
		global $t, $categories, $category_number, $restrict_categories_images, $settings, $page_settings, $category_id;
		global $list_url, $list_page;

		$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
		$friendly_extension = get_setting_value($settings, "friendly_extension", "");

		$tw = 14; $th = 20;
		if (file_exists("images/".$settings["style_name"]."/tree_space.gif")) {
			$image_tree_space = "images/".$settings["style_name"]."/tree_space.gif";
			$image_tree_line = "images/".$settings["style_name"]."/tree_line.gif";
			$image_tree_begin = "images/".$settings["style_name"]."/tree_begin.gif";
			$image_tree_end = "images/".$settings["style_name"]."/tree_end.gif";
			$image_tree_top = "images/".$settings["style_name"]."/tree_top.gif";
		} else {
			$image_tree_space = "images/tree_space.gif";
			$image_tree_line = "images/tree_line.gif";
			$image_tree_begin = "images/tree_begin.gif";
			$image_tree_end = "images/tree_end.gif";
			$image_tree_top = "images/tree_top.gif";
		}

		$subs = isset($categories[$parent_id]) ? $categories[$parent_id]["subs"] : array();
		for ($i = 0; $i < sizeof($subs); $i++)
		{
			$category_number++;
			$show_category_id = $subs[$i];
			$category_name  = $categories[$show_category_id]["category_name"];
			$friendly_url = $categories[$show_category_id]["friendly_url"];
			if ($friendly_urls && $friendly_url) {
				$list_url->remove_parameter("category_id");
				$t->set_var("list_url", $list_url->get_url($friendly_url . $friendly_extension));
			} else {
				$list_url->add_parameter("category_id", CONSTANT, $show_category_id);
				$t->set_var("list_url", $list_url->get_url($list_page));
			}
			if ($image_type == 2) {
				$category_image = $categories[$show_category_id]["image"];
			} else {
				$category_image = $image_tree_top;
			}
			$image_alt = $categories[$show_category_id]["image_alt"];
			$short_description = $categories[$show_category_id]["short_description"];
			$is_rss = isset($categories[$show_category_id]["is_rss"]) ? $categories[$show_category_id]["is_rss"] : false;
			if ($i == sizeof($subs) - 1) {
				$categories[$show_category_id]["last"] = true;
			} else {
				$categories[$show_category_id]["last"] = false;
			}

			$t->set_var("category_id", $show_category_id);

			$tree_images = "";
			if ($parent_id != $top_id) {
				$tree_id = $parent_id;
				if (isset($categories[$tree_id]["parent_id"])) {
					while ($categories[$tree_id]["parent_id"] != $top_id) {
						if ($categories[$tree_id]["last"]) {
							$tree_image = $image_tree_space;
						} else {
							$tree_image = $image_tree_line;
						}
						$tree_images = "<img border=0 align=left src=$tree_image hspace=0 width=$tw height=$th>" . $tree_images;
						$tree_id = $categories[$tree_id]["parent_id"];
					}
				}
			}
			if ($level > 0) {
				if ($categories[$show_category_id]["last"]) {
					$tree_images .= "<img border=0 align=left src=$image_tree_end hspace=0 width=$tw height=$th>";
				} else {
					$tree_images .= "<img border=0 align=left src=$image_tree_begin hspace=0 width=$tw height=$th>";
				}
				$t->set_var("category_tr_class", "subCategory");
			} else {
				$t->set_var("category_tr_class", "topCategory");
			}
			if ($show_category_id == $category_id) {
				if ($level > 0) {
					$t->set_var("category_tr_class", "selectedsubCategory");
				} else {
					$t->set_var("category_tr_class", "selectedtopCategory");
				}
			}

			$t->set_var("category_name", $tree_images . $category_name);
			if ($is_rss) {
				$t->parse("category_rss", false);
			} else {
				$t->set_var("category_rss", "");
			}
			if ($level > 0 || !$category_image) {
				$t->set_var("alt", "");
				$t->set_var("src", "images/tr.gif");
				$t->set_var("width", "width=\"1\"");
				$t->set_var("height", "height=\"1\"");
				$t->parse("category_image", false);
			} else {
				if (preg_match("/^http\:\/\//", $category_image)) {
					$image_size = "";
				} else {
					$image_size = @GetImageSize($category_image);
					if (isset($restrict_categories_images) && $restrict_categories_images) {
						$category_image = "image_show.php?category_id=".$show_category_id;
					}
				}
				if (!strlen($image_alt)) { $image_alt = $category_name; }
				$t->set_var("alt", htmlspecialchars($image_alt));
				$t->set_var("src", htmlspecialchars($category_image));
				if(is_array($image_size))
				{
					$t->set_var("width", "width=\"" . $image_size[0] . "\"");
					$t->set_var("height", "height=\"" . $image_size[1] . "\"");
				}
				else
				{
					$t->set_var("width", "");
					$t->set_var("height", "");
				}
				$t->parse("category_image", false);
			}
			$t->parse("categories");
			if($category_number % $columns == 0)
			{
				$t->parse("categories_rows");
				$t->set_var("categories", "");
			}
			if (isset($categories[$show_category_id]["subs"]) && is_array($categories[$show_category_id]["subs"])) {
				set_categories($show_category_id, $level + 1, $columns, $top_id, $image_type);
			}

		}
	}

	function process_message($message, $level_colors = "")
	{
		$eol = get_eol();
		// set level colors
		if (!is_array($level_colors)) {
			$level_colors = array(
				"0"=>"black", "1"=>"blue", "2"=>"red", "3"=>"green", "4"=>"gray", "5"=>"navy", "6"=>"olive", "7"=>"brown", "8"=>"purple"
			);
		}

		$message = preg_replace("/</","&lt;",$message);
		$message = preg_replace("/!^>/","&gt;",$message);
		$message = str_replace("\r","", $message);
		$msg_strings = split("\n", $message);
		$message     = "";
		$last_level  = 0;
		$ln = 0;

		$message .= "<div style='color:".$level_colors[0].";'>";
		foreach ($msg_strings as $line) {
			$ln++;
			//-- get current level
			if (preg_match("/^>+/", $line, $match)) {
				$cur_level = strlen($match[0]);
			} else {
				$cur_level = 0;
			}
			$line = preg_replace("/^>+/","",$line);
			if (!trim($line)) $line="&nbsp;";
			$level_diff = $last_level - $cur_level;
			if ($level_diff > 0) {
				$tags = "";
				for($t = 1; $t <= $level_diff; $t++) {
					$tags .="</div>" . $eol;
				}
				$line = $tags . $line;
			} else if ($level_diff < 0) {
				$tags = "";
			  for ($t = $last_level; $t < $cur_level; $t++) {
	  		  $tags .="<div style='color:". $level_colors[($t + 1) % 9] ."; margin-left: 5pt; padding-left: 5pt; border-left-style:solid; border-left-width:thin;'>" . $eol;
			  }
				$line = $tags.$line;
			} else {
				if ($ln > 1) {
					$line = "<br>" . $line;
				}
			}
			$last_level = $cur_level;
			$message .= $line;
		}

		//-- add end tags
		$tags = "";
		for($t = 1; $t <= $last_level; $t++) {
			$tags .="</div>" . $eol;
		}
		$message .= $tags . "</div>";

		return $message;
	}

	function get_tax_amount($tax_rates, $item_type_id, $price, $tax_free)
	{
		$tax_amount = 0; $tax_percent = 0;
		if (!$tax_free) {
			if (isset($tax_rates[$item_type_id]) && strlen($tax_rates[$item_type_id])) {
				$tax_percent = $tax_rates[$item_type_id];
			} else if (isset($tax_rates[0]) && strlen($tax_rates[0])) {
				$tax_percent = $tax_rates[0];
			}
		}
		$tax_amount = round(($price * $tax_percent) / 100, 2);

		return array($tax_percent, $tax_amount);
	}

	function check_image_validation($validation_number)
	{
		$session_random_arr = get_session("session_random_arr");
		if(strlen($validation_number) == 0 || !in_array($validation_number, $session_random_arr)) {
			return false;
		} else {
			unset($session_random_arr[array_search($validation_number, $session_random_arr)]);
			set_session("session_random_arr", $session_random_arr);
			return true;
		}
	}

	function get_nice_bytes($bytes)
	{
	  if ($bytes >= 1024 && $bytes < 1048576) {
			return round($bytes / 1024) . "Kb";
		} else if ($bytes >= 1048576) {
			return round($bytes / 1048576, 1) . "Mb";
		} else {
			return $bytes." bytes";
		}
	}

	function set_curl_options(&$ch, $curl_options)
	{
		if (isset($curl_options["CURLOPT_PROXY"]) && strlen($curl_options["CURLOPT_PROXY"])) {
			curl_setopt($ch, CURLOPT_PROXY, $curl_options["CURLOPT_PROXY"]);
			if (isset($curl_options["CURLOPT_PROXYUSERPWD"]) && strlen($curl_options["CURLOPT_PROXYUSERPWD"])) {
				curl_setopt($ch, CURLOPT_PROXYUSERPWD, $curl_options["CURLOPT_PROXYUSERPWD"]);
			}
		}

	}

	/**
	 * Return file size of remote file
	 *
	 * @param string $url
	 * @return integer
	 */
	function remote_filesize($url)
	{
		$size = 0;
		$parsed_url = parse_url($url);
		$sch = isset($parsed_url["scheme"]) ? $parsed_url["scheme"] : "";
		$host = isset($parsed_url["host"]) ? $parsed_url["host"] : "";
		$port = isset($parsed_url["port"]) ? $parsed_url["port"] : "";
		$user = isset($parsed_url["user"]) ? $parsed_url["user"] : "";
		$pass = isset($parsed_url["pass"]) ? $parsed_url["pass"] : "";
		$path = isset($parsed_url["path"]) ? $parsed_url["path"] : "";
		$query = isset($parsed_url["query"]) ? $parsed_url["query"] : "";
		if (in_array($sch, array("http", "https", "ftp", "ftps"))) {
			if (($sch == "http") || ($sch == "https")) {
				switch ($sch) {
					case "http":
						if (!$port) { $port = 80; } break;
					case "https";
						if (!$port) { $port = 443; } break;
				}
				$socket = @fsockopen($host, $port);
				if ($socket) {
					$out  = "HEAD $path?$query HTTP/1.0\r\n";
					$out .= "Host: $host\r\n";
					$out .= "UserAgent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)\r\n";
					$out .= "Connection: Close\r\n\r\n";
					fwrite($socket, $out);
					// read the response header
					$header = "";
					while (!feof($socket)){
						$header .= fread($socket, 1024*8);
					}
					fclose($socket);
					if (strlen($header)) {
						// try to acquire Content-Length within the response
						preg_match('/Content-Length:\s(\d+)/', $header, $matches);
						if (isset($matches[1])) {
							$size = $matches[1];
						}
					}
				}
			} elseif (($sch == "ftp") || ($sch == "ftps")) {
				if (strlen($host) && strlen($path)) {
					if (!$port) { $port = 21; }
					if (!$user) { $user = "anonymous"; }
					if (!$pass) { $pass = ""; }
					switch ($sch) {
						case "ftp":
							$ftpid = @ftp_connect($host, $port); break;
						case "ftps":
							$ftpid = @ftp_ssl_connect($host, $port); break;
						default:
							$ftpid = 0;
					}
					$ftpsize = 0;
					if ($ftpid) {
						$login = ftp_login($ftpid, $user, $pass);
						if ($login) {
							$ftpsize = ftp_size($ftpid, $path);
						}
						ftp_close($ftpid);
					}
					if ($ftpsize > 0) { $size = $ftpsize; }
				}
			}
		}

		return $size;
	}

	function eval_php_code(&$block_body)
	{
		if (preg_match_all("/(<\?php|<\?)(.*)\?>/is", $block_body, $matches)) {
			for ($p = 0; $p < sizeof($matches[0]); $p++) {
				$block_body = str_replace($matches[0][$p], "", $block_body);
				eval($matches[2][$p]);
			}
		}
	}

	function split_long_words(&$text, $symbols = 128)
	{
		if (preg_match_all("/[^\s\r\n]{".$symbols.",}/i", $text, $matches)) {
			$correction = $symbols - intval($symbols / 6);
			for ($p = 0; $p < sizeof($matches[0]); $p++) {
				$long_word = $matches[0][$p];
				$original_word = $long_word;
				$new_word = ""; $word_length = strlen($long_word);
				while ($word_length) {
					if ($word_length > $symbols) {
						$word_part = substr($long_word, 0, $symbols);
						if ($word_length > $correction && preg_match("/^(.{".$correction."}.*[,\.\-\!\?\&\*_]).*/", $word_part, $word_match)) {
							$word_part = $word_match[1];
						}
					} else {
						$word_part = $long_word;
					}
					$word_part_len = strlen($word_part);
					$new_word .= $word_part . " ";
					$long_word = substr($long_word, $word_part_len);
					$word_length = strlen($long_word);
				}
				$text = str_replace($original_word, $new_word, $text);
			}
		}
	}

	function user_login($login, $password, $user_id, $remember_me, $redirect_page, $make_redirects, &$errors)
	{
		global $db, $table_prefix, $settings;
		$is_errors = false;
		$password_encrypt = get_setting_value($settings, "password_encrypt", 0);
		if ($password_encrypt == 1) {
			$password_match = md5($password);
		} else {
			$password_match = $password;
		}

		$sql  = " SELECT u.user_id, u.user_type_id, u.is_approved,";
		$sql .= " u.login, u.nickname, u.name, u.first_name, u.last_name, u.email, ";
		$sql .= " u.discount_type AS user_discount_type, u.discount_amount AS user_discount_amount, ";
		$sql .= " ut.discount_type AS group_discount_type, ut.discount_amount AS group_discount_amount, ";
		$sql .= " u.registration_last_step, u.registration_total_steps, ";
		$sql .= " ut.is_subscription, u.expiry_date, u.is_sms_allowed, ";
		$sql .= " u.tax_free AS user_tax_free, ut.tax_free AS group_tax_free, ";
		$sql .= " ut.price_type, c.currency_code ";
		$sql .= " FROM ((" . $table_prefix . "users u ";
		$sql .= " LEFT JOIN " . $table_prefix . "user_types ut ON u.user_type_id=ut.type_id) ";
		$sql .= " LEFT JOIN " . $table_prefix . "countries c ON u.country_code=c.country_code) ";
		if ($user_id) {
			$sql .= " WHERE u.user_id=" . $db->tosql($user_id, INTEGER);
		} else {
			$sql .= " WHERE u.login=" . $db->tosql($login, TEXT);
			$sql .= " AND u.password=" . $db->tosql($password_match, TEXT);
		}
		$db->query($sql);
		if($db->next_record())
		{
			$current_ts = va_timestamp();
			$user_id = $db->f("user_id");
			$is_approved = $db->f("is_approved");
			$is_sms_allowed = $db->f("is_sms_allowed");
			$expiry_date = $db->f("expiry_date", DATETIME);
			if (is_array($expiry_date)) {
				$expiry_date_ts = mktime (0, 0, 0, $expiry_date[MONTH], $expiry_date[DAY] + 1, $expiry_date[YEAR]);
			} else {
				$expiry_date_ts = $current_ts;
			}
			$user_type_id = $db->f("user_type_id");
			$is_subscription = $db->f("is_subscription");
			$registration_last_step = $db->f("registration_last_step");
			$registration_total_steps = $db->f("registration_total_steps");
			if ($registration_last_step < $registration_total_steps) {
				if ($make_redirects) {
					// if registration process wasn't finished
					set_session("session_new_user_id", $user_id);
					set_session("session_new_user", "registration");
					// check secure option
					$secure_url = get_setting_value($settings, "secure_url", "");
					$secure_user_profile = get_setting_value($settings, "secure_user_profile", 0);
					if ($secure_user_profile) {
						$user_profile_url = $secure_url . "user_profile.php";
					} else {
						$user_profile_url = "user_profile.php";
					}
					header ("Location: " . $user_profile_url);
					exit;
				} else {
					$is_errors = true;
				}
			} else if ($current_ts > $expiry_date_ts && $is_subscription) {
				if ($make_redirects) {
					// if user have to pay for subscription
					set_session("session_new_user_id", $user_id);
					set_session("session_new_user", "expired");
					include_once ("./includes/shopping_cart.php");
					add_subscription($user_type_id);
					// check secure option
					$secure_url = get_setting_value($settings, "secure_url", "");
					$secure_order_profile = get_setting_value($settings, "secure_order_profile", 0);
					if ($secure_order_profile) {
						$order_info_url = $secure_url . "order_info.php";
					} else {
						$order_info_url = "order_info.php";
					}
					header("Location: " . $order_info_url);
					exit;
				} else {
					$is_errors = true;
				}
			} else if ($current_ts <= $expiry_date_ts && $is_approved) {
				$login = $db->f("login");
				$nickname = $db->f("nickname");
				if (!strlen($nickname)) { $nickname = $login; }
				$email = $db->f("email");
				$currency_code = $db->f("currency_code");
				$user_discount_type = $db->f("user_discount_type");
				$user_discount_amount = $db->f("user_discount_amount");
				$group_discount_type = $db->f("group_discount_type");
				$group_discount_amount = $db->f("group_discount_amount");
				$price_type = $db->f("price_type");
				$user_tax_free = $db->f("user_tax_free");
				$group_tax_free = $db->f("group_tax_free");
				$tax_free = ($user_tax_free || $group_tax_free);

				set_session("session_new_user", "");
				set_session("session_new_user_id", "");
				set_session("session_user_id", $user_id);
				set_session("session_user_type_id", $user_type_id);
				set_session("session_user_login", $login);
				if(strlen($db->f("name"))) {
					$user_name = $db->f("name");
				} else if (strlen($db->f("first_name")) || strlen($db->f("last_name"))) {
					$user_name = $db->f("first_name") . " " . $db->f("last_name");
				} else {
					$user_name = $login;
				}
				set_session("session_user_name", $user_name);
				set_session("session_user_email", $email);
				$discount_type = ""; $discount_amount = "";
				if ($user_discount_type > 0) {
					$discount_type = $user_discount_type;
					$discount_amount = $user_discount_amount;
				} else if ($group_discount_type)  {
					$discount_type = $group_discount_type;
					$discount_amount = $group_discount_amount;
				}
				set_session("session_discount_type", $discount_type);
				set_session("session_discount_amount", $discount_amount);
				set_session("session_price_type", $price_type);

				$user_info = array(
					"user_id" => $user_id, "user_type_id" => $user_type_id, 
					"login" => $login, "nickname" => $nickname, "name" => $user_name,
					"email" => $email, "discount_type" => $discount_type, "discount_amount" => $discount_amount,
					"price_type" => $price_type, "tax_free" => $tax_free, "is_sms_allowed" => $is_sms_allowed
				);
				set_session("session_user_info", $user_info);

				if ($remember_me && $login && $password)
				{
					setcookie("cookie_user_login", $login, va_timestamp() + 3600 * 24 * 366);
					setcookie("cookie_user_password", $password, va_timestamp() + 3600 * 24 * 366);
				}

				// get currency if available
				if ($currency_code) {
					get_currency($currency_code);
				}

				// update last visit time
				$sql  = " UPDATE " . $table_prefix . "users SET last_visit_date=" . $db->tosql(va_time(), DATETIME);
				$sql .= ", last_visit_ip=" . $db->tosql(get_ip(), TEXT);
				$sql .= ", last_visit_page=" . $db->tosql(get_request_page(), TEXT);
				$sql .= ", last_logged_date=" . $db->tosql(va_time(), DATETIME);
				$sql .= ", last_logged_ip=" . $db->tosql(get_ip(), TEXT);
				$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
				$db->query($sql);

				if ($make_redirects && $redirect_page) {
					header("Location: " . $redirect_page);
					exit;
				}
			} else if ($current_ts > $expiry_date_ts) {
				$is_errors = true;
				$errors .= ACCOUNT_EXPIRED_MSG . "<br>";
			} else {
				$is_errors = true;
				$errors .= ACCOUNT_APPROVE_ERROR . "<br>";
			}
		}
		else
		{
			$is_errors = true;
			if ($user_id) {
				$errors .= "Can't find the customer.<br>";
			} else {
				$errors .= LOGIN_PASSWORD_ERROR . "<br>";
			}
		}
		if ($is_errors) {
			setcookie("cookie_user_login");
			setcookie("cookie_user_password");
		}
		return (!$is_errors);
	}

	function user_logout()
	{
		global $settings;

		set_session("session_user_id", "");
		set_session("session_new_user_id", "");
		set_session("session_new_user", "");
		set_session("session_user_type_id", "");
		set_session("session_user_login", "");
		set_session("session_user_name", "");
		set_session("session_user_email", "");
		set_session("session_discount_type", "");
		set_session("session_discount_amount", "");
		set_session("session_price_type", "");
		set_session("session_user_info", "");
		if (get_setting_value($settings, "logout_cart_clear", 0) == 1) {
			set_session("shopping_cart", "");
			set_session("session_coupons", "");
		}
		setcookie("cookie_user_login");
		setcookie("cookie_user_password");
	}

	function auto_user_login()
	{
		// automatically login customer
		$session_user_id = get_session("session_user_id");
		if (!$session_user_id) {
			$cookie_login = get_cookie("cookie_user_login");
			$cookie_password = get_cookie("cookie_user_password");
			if ($cookie_login && $cookie_password) {
				user_login($cookie_login, $cookie_password, "", false, "", false, $errors);
			}
		}
	}

	function sms_send_allowed($cell_phone_number)
	{
		global $settings, $db, $table_prefix;
		$user_id = get_session("session_user_id");
		if ($user_id) {
			$user_info = get_session("session_user_info");
			$is_sms_allowed = get_setting_value($user_info, "is_sms_allowed", 0);
		} else {
			$is_sms_allowed = get_setting_value($settings, "is_sms_allowed", 0);
		}
		if ($is_sms_allowed == 2) {
			// check if number in allowed list
			$cell_phone_number = preg_replace("/[^\d]/", "", $cell_phone_number);
			$sql = " SELECT cell_phone_id FROM " . $table_prefix . "allowed_cell_phones WHERE cell_phone_number=" . $db->tosql($cell_phone_number, TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$is_sms_allowed = 1;
			} else {
				$sql = " SELECT is_sms_allowed FROM " . $table_prefix . "users WHERE cell_phone=" . $db->tosql($cell_phone_number, TEXT);
				$db->query($sql);
				if ($db->next_record()) {
					$is_sms_allowed = $db->f("is_sms_allowed");
				} else {
					$is_sms_allowed = 0;
				}
			}
		} 

		return $is_sms_allowed;
	}

	// Trancate text to desired length.
	// The last word is not trancated, so the length of result string may be greater than param $length
	function trancate_to_word($text, $length)
	{
		return preg_replace('/(^.{'.$length.'}.*?\s).+/is', '$1', $text);
	}


?>
