<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  image_functions.php                                      ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function gd_error(&$errors)
{	
	if (!function_exists("gd_info"))	{
		$errors .= "GD library not loaded";
		return true;
	} else {
		return false;
	}
}

function image_error($filename, &$errors)
{
	if (gd_error($errors)) {
		return true;
	} else {
		if (!file_exists($filename)) {
			$errors .= "The file does not exist: ".$filename;
			return true;			
		} else {
			$file_info = @getimagesize ($filename);	
			if (!empty($file_info)) {
				return false;
			}	else {
				$errors .= "Image file error";
				return true;
			}
		}
	}
}

function image_supported($filename, &$errors) {
	if (image_error($filename, $errors))	{
		return false;
	} else {
		$file_info = @getimagesize ($filename);	
		$format = $file_info [2];
		switch ($format) { 	//1 = GIF, 2 = JPG, 3 = PNG, 
												//4 = SWF, 5 = PSD, 6 = BMP, 7 = TIFF(intel), 8 = TIFF(motorola), 9 = JPC, 10 = JP2, 11 = JPX. 
			case 1:
				if (imagetypes() & IMG_GIF) {
		    	return true;			
				} else {
					$errors	.= "GIF image format is not supported";
		    	return false;			
				}
			break;
			case 2:
				if (imagetypes() & IMG_JPG) {
		    	return true;			
				} else {
					$errors	.= "JPG image format is not supported";
		    	return false;			
				}
			break;
			case 3:
				if (imagetypes() & IMG_PNG) {
		    	return true;			
				} else {
					$errors	.= "PNG image format is not supported";
		    	return false;			
				}
			break;
			default :
				$errors	.= "Format is not supported";
	 			return false;
			break;
  	}
	}
}

function set_image_watermark ($path_image,$path_mark,$position,$pct,$mark_text) 
{

	$text_len = strlen($mark_text);
 	$font = "./includes/font/comic.ttf";

	if ($text_len>0){ // use text watermark
		$watermark = @imagecreate (150, 50)
		   	or die ("Cannot Initialize new GD image stream");
		$background_color = imagecolorallocate ($watermark, 255, 255, 255); // better use the same as text_color
		imagecolortransparent($watermark, $background_color);
		$text_color = imagecolorallocate ($watermark, 255, 255, 255); 

		if (function_exists("imagettftext")) {
			$text_size = 30;
			$text_angle = 0;
			$text_width = 10;
			$text_height = 30;
			imagettftext ($watermark, $text_size, $text_angle, $text_width, $text_height, $text_color, $font, $mark_text);  
		} else {
			imagestring ($watermark, 1, 5, 5,  $mark_text, $text_color);
		}

	} else { // use image watermark	  
	  
		if (intval(@imagesx($path_mark)) > 0) {
				$watermark = $path_mark;
		} else {
			if (!image_supported($path_mark,$errors)) {
				die ($errors);
			}
/*
			$imginfo = getimagesize($path_mark);
	  
			switch($imginfo[2]) { // Determine type
				case 1:
					$type = "GIF";
					if (function_exists("imagecreatefromgif")) {
						$watermark = imagecreatefromgif($path_mark);
					} else die("Unsupported image type: $type");
					break;
				case 2:
					$type = "JPG";
					if (function_exists("imagecreatefromjpeg")) {
						$watermark = imagecreatefromjpeg($path_mark);
					} else die("Unsupported image type: $type");
					break;
				case 3:
					$type = "PNG";
					if (function_exists("imagecreatefrompng")) {
						$watermark = imagecreatefrompng($path_mark);
					} else die("Unsupported image type: $type");
					break;
			}
*/
		}
	}

	$position = strtoupper($position);
	$valid_positions = array(
		"TL", "TM", "TR", "CL", "C", "CR", "BL", "BM", "BR", "RND"
	);

	if (in_array($position, $valid_positions)) {
		if ($position == "RND") {
			$position = $valid_positions[rand(0, sizeof($valid_positions) - 2)];
		}
	} else {
		die("Unsupported position: $position");
	}

	$width_mark = imagesx($watermark);  
	$height_mark = imagesy($watermark);  
	$image = imagecreatefromjpeg($path_image);  
	$size = getimagesize($path_image);  

	$width_left = $size[0] - $width_mark;
	$height_left = $size[1] - $height_mark; 

	switch ($position) {
		case "TL": // Top Left
			$dest_x = $width_left >= 5 ? 5 : $width_left;
			$dest_y = $height_left >= 5 ? 5 : $height_left;
			break;
		case "TM": // Top middle 
			$dest_x = intval(($size[0] - $width_mark) / 2);
			$dest_y = $height_left >= 5 ? 5 : $height_left;
			break;
		case "TR": // Top right
			$dest_x = $size[0] - $width_mark - 5;
			$dest_y = $height_left >= 5 ? 5 : $height_left;
			break;
		case "CL": // Center left
			$dest_x = $width_left >= 5 ? 5 : $width_left;
			$dest_y = intval(($size[1] - $height_mark) / 2);
			break;
		default:
		case "C": // Center (the default)
			$dest_x = intval(($size[0] - $width_mark) / 2);
			$dest_y = intval(($size[1] - $height_mark) / 2);
			break;
		case "CR": // Center right
			$dest_x = $size[0] - $width_mark - 5;
			$dest_y = intval(($size[1] - $height_mark) / 2);
			break;
		case "BL": // Bottom left
			$dest_x = $width_left >= 5 ? 5 : $width_left;
			$dest_y = $size[1] - $height_mark - 5;
			break;
		case "BM": // Bottom middle
			$dest_x = intval(($size[0] - $width_mark) / 2);
			$dest_y = $size[1] - $height_mark - 5;
			break;
		case "BR": // Bottom right
			$dest_x = $size[0] - $width_mark - 5;
			$dest_y = $size[1] - $height_mark - 5;
			break;
	}

	imagecopymerge($image, $watermark, $dest_x, $dest_y, 0, 0, $width_mark, $height_mark, $pct);  
	imagejpeg($image, $path_image);  
	imagedestroy($image);  
	imagedestroy($watermark);  

	//header("content-type: image/jpeg");  
}

function get_new_file_name ($filepaths, $filename)  // generate new filename adding a number e.g. 'example_2.gif'
{
	if (!is_array($filepaths)) {
		$filepaths = array($filepaths);
	}
	$current_index = 0;
	$new_filename = $filename;
	do {
		$is_file_exists = false;
		for ($i = 0; $i < sizeof($filepaths); $i++) {
			$is_file_exists = ($is_file_exists || file_exists($filepaths[$i] . $new_filename));
		}
		if ($is_file_exists) {
			$current_index++; 
			$delimiter_pos = strpos($filename, ".");
			if ($delimiter_pos) {
				$new_filename = substr($filename, 0, $delimiter_pos) . "_" . $current_index . substr($filename, $delimiter_pos);
			} else { 			
				$new_filename = $filename . "_" . $current_index;
			}
		}
	} while ($is_file_exists);

	return $new_filename;
}

//resize image 'filename' using destination name 'dest'
function resize($filename, $origin, $dest, $width, $height, &$errors) 
{  
	
	if (empty($filename) || empty($origin) || empty($dest) || empty($width) || empty($height)) {
		$errors .= "Missing resizing parameter";
		return false;
		exit;
	}
	if (!image_supported($origin.$filename, $errors)) {
		return false;
		exit;		
	}
	if (!is_dir($dest))	{
  	$errors .= "The folder ". $dest ." doesn't exist.";
		return false;
		exit;
	} else if (!is_writable($dest)){ 
  	$errors .= str_replace("{folder_name}", $dest, FOLDER_PERMISSION_MESSAGE);
		return false;
		exit;
	}

	list($width_orig, $height_orig, $format) = getimagesize($origin.$filename);

  // Get new dimensions
  if ($width_orig < $height_orig) {
		if ($height < $height_orig)
        $width = ($height / $height_orig) * $width_orig;
     else {
        $width = $width_orig;
        $height = $height_orig;
     }
  }
  else {
     if ($width < $width_orig)
        $height = ($width / $width_orig) * $height_orig;
     else {
        $width = $width_orig;
        $height = $height_orig;
     }
  }

  $width = round($width);
  $height = round($height);
  $img_n = imagecreatetruecolor ($width, $height);

	//get image type	
  switch($format) { //1 = GIF, 2 = JPG, 3 = PNG, 
	case '1' :
   	$img = imagecreatefromgif($origin.$filename);
  	imagecopyresampled($img_n, $img, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
  	imagegif($img_n, $dest.$filename);		
	break;
  case '2' :
  	$img = imagecreatefromjpeg($origin.$filename);
  	imagecopyresampled($img_n, $img, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
  	imagejpeg($img_n, $dest.$filename);
   	break;
	case '3' :
   	$img = imagecreatefrompng($origin.$filename);
	  imagecopyresampled($img_n, $img, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
  	imagepng($img_n, $dest.$filename);
		break;
  }
  return true;
}

?>