<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  items_properties.php                                     ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	function show_items_properties($item_id, $item_type_id, $item_price, $tax_free, $type, $discount_applicable = true, $properties_percent = 0)
	{
	 	global $t, $db, $table_prefix;
		global $settings, $currency;

		// connection for properties
		$dbp = new VA_SQL();
		$dbp->DBType     = $db->DBType;
		$dbp->DBDatabase = $db->DBDatabase;
		$dbp->DBUser     = $db->DBUser;
		$dbp->DBPassword = $db->DBPassword;
		$dbp->DBHost     = $db->DBHost;
		$dbp->DBPort       = $db->DBPort;
		$dbp->DBPersistent = $db->DBPersistent;
  
		$eol = get_eol();
		$currency_left = $currency["left"];
		$currency_right = $currency["right"];
		$currency_rate = $currency["rate"];
		$discount_type = get_session("session_discount_type");
		$discount_amount = get_session("session_discount_amount");
		$display_products = get_setting_value($settings, "display_products", 0);
		$tax_prices = get_setting_value($settings, "tax_prices", 0);
		$user_id = get_session("session_user_id");		
		$user_type_id = get_session("session_user_type_id");
		$price_type = get_session("session_price_type");
		if ($price_type == 1) {
			$price_field = "trade_price";
			$sales_field = "trade_sales";
		} else {
			$price_field = "price";
			$sales_field = "sales_price";
		}

		// check product properites
		$properties_ids = "";
		$selected_price = 0;
		$is_properties = false;
		$t->set_var("properties", "");

		$options = array(); $row = 0; $components = array(); $components_price = 0; $components_tax_price = 0;
		$sql  = " SELECT * ";
		$sql .= " FROM " . $table_prefix . "items_properties ";
		$sql .= " WHERE (item_id=" . $item_id . " OR item_type_id=" . $db->tosql($item_type_id, INTEGER) . ")";
		if ($type == "list") {
			$sql .= " AND use_on_list=1 ";
		} elseif ($type == "options") {
			$sql .= " AND use_on_second=1 ";
		} else {
			$sql .= " AND use_on_details=1 ";
		}
		$sql .= " ORDER BY property_order, property_id ";
		$dbp->query($sql);
		while ($dbp->next_record()) {
			$property_id = $dbp->f("property_id");
			$property_type_id = $dbp->f("property_type_id");
			if ($property_type_id == 2) {
				$sub_item_id = $dbp->f("sub_item_id");
				$components[] = $sub_item_id;
			} else {
				$options[$row]["property_id"] = $property_id;
				$options[$row]["property_type_id"] = $property_type_id;
				$options[$row]["property_name"] = get_translation($dbp->f("property_name"));
				$options[$row]["property_description"] = $dbp->f("property_description");
				$options[$row]["property_style"] = $dbp->f("property_style");
				$options[$row]["control_type"] = $dbp->f("control_type");
				$options[$row]["control_style"] = $dbp->f("control_style");
				$options[$row]["required"] = $dbp->f("required");
				$options[$row]["start_html"] = $dbp->f("start_html");
				$options[$row]["middle_html"] = $dbp->f("middle_html");
				$options[$row]["before_control_html"] = $dbp->f("before_control_html");
				$options[$row]["after_control_html"] = $dbp->f("after_control_html");
				$options[$row]["end_html"] = $dbp->f("end_html");
				$options[$row]["onchange_code"] = $dbp->f("onchange_code");
				$options[$row]["onclick_code"] = $dbp->f("onclick_code");
				$options[$row]["control_code"] = $dbp->f("control_code");
				$row++;
			}
		}

		// calculate subcomponents price
		if (sizeof($components) > 0) {
			for ($i = 0; $i < sizeof($components); $i++) {
				$sub_item_id = $components[$i];
				$price = 0;
				$sql  = " SELECT i.item_type_id, i.buying_price, i." . $price_field . ", i.is_sales, i." . $sales_field . ", i.tax_free, ";
				$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action, pr.additional_price ";
				$sql .= " FROM ((" . $table_prefix . "items_properties pr ";
				$sql .= " INNER JOIN " . $table_prefix . "items i ON pr.sub_item_id=i.item_id)";
				$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
				$sql .= " WHERE i.item_id=" . $db->tosql($sub_item_id, INTEGER);
				$dbp->query($sql);
				if ($dbp->next_record()) {
					$sub_type_id = $dbp->f("item_type_id");
					$sub_tax_free = $dbp->f("tax_free");
					$additional_price = $dbp->f("additional_price");
					if (strlen($additional_price)) {
						$price = $additional_price;
					} else {
						$price = $dbp->f($price_field);
						$buying_price = $dbp->f("buying_price");
						$is_sales = $dbp->f("is_sales");
						$sales_price = $dbp->f($sales_field);
						$user_price = $dbp->f("user_price");
						$user_price_action = $dbp->f("user_price_action");
						if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
							$price = $user_price;
						} elseif ($is_sales && $sales_price > 0) {
							$price = $sales_price; 
						}
						if ($user_price_action != 1) {
							if ($discount_type == 1 || $discount_type == 3) {
								$price -= round(($price * $discount_amount) / 100, 2);
							} elseif ($discount_type == 2) {
								$price -= round($discount_amount, 2);
							} elseif ($discount_type == 4) {
								$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
							}
						}
					}

				}

				$components_price += $price;
				$tax_amount = set_tax_price($sub_item_id, $sub_type_id, $price, 0, $sub_tax_free);
				$components_tax_price += $tax_amount;
			}
		}

		// check product prices based on quantity
		$quantity_price = "";
		$sql  = " SELECT i.buying_price, ip.is_active, ip.min_quantity, ip.max_quantity, ";
		$sql .= " ip.price, ip.properties_discount, ip.discount_action ";
		$sql .= " FROM " . $table_prefix . "items_prices ip, " . $table_prefix . "items i ";
		$sql .= " WHERE ip.item_id=i.item_id ";
		$sql .= " AND ip.item_id=" . $db->tosql($item_id, INTEGER);
		$sql .= " AND ip.is_active=1 ";
		if ($user_type_id) {
			$sql .= " AND (ip.user_type_id=0 OR ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ") ";
		} else {
			$sql .= " AND ip.user_type_id=0 ";
		}
		$sql .= " ORDER BY ip.user_type_id DESC ";
		$dbp->query($sql);
		while ($dbp->next_record()) {
			$is_active = $dbp->f("is_active");
			$min_quantity = $dbp->f("min_quantity");
			$max_quantity = $dbp->f("max_quantity");
			$price = $dbp->f("price");
			$properties_discount = $dbp->f("properties_discount");
			$discount_action = $dbp->f("discount_action");
			$buying_price = $dbp->f("buying_price");
			if ($discount_type > 0) {	
				if ($discount_action == 0) {
					$is_active = 0;
				} elseif ($discount_action == 2) {
					if ($discount_type == 1 || $discount_type == 3) {
						$price -= round(($price * $discount_amount) / 100, 2);
					} elseif ($discount_type == 2) {
						$price -= round($discount_amount, 2);
					} elseif ($discount_type == 4) {
						$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
					}
				}
			}
			if ($is_active) {
				if ($quantity_price) { $quantity_price .= ","; }
				$quantity_price .= $min_quantity . "," . $max_quantity . "," . $price . "," . round($properties_discount, 2);
			}
		}
		$t->set_var("quantity_price", $quantity_price);

		// show options and components selection
		if (sizeof($options) > 0)
		{
			$is_properties = true;
			for ($row = 0; $row < sizeof($options); $row++) 
			{
				$property_id = $options[$row]["property_id"];
				$property_type_id = $options[$row]["property_type_id"];
				$property_block_id = "pr_" . $item_id . "_" . $property_id;
				$property_name = $options[$row]["property_name"];
				$property_description = $options[$row]["property_description"];
				$property_style = $options[$row]["property_style"];
				$control_type = $options[$row]["control_type"];
				$control_style = $options[$row]["control_style"];
				$property_required = $options[$row]["required"];
				$start_html = $options[$row]["start_html"];
				$middle_html = $options[$row]["middle_html"];
				$before_control_html = $options[$row]["before_control_html"];
				$after_control_html = $options[$row]["after_control_html"];
				$end_html = $options[$row]["end_html"];
				$onchange_code = $options[$row]["onchange_code"];
				$onclick_code = $options[$row]["onclick_code"];
				$control_code = $options[$row]["control_code"];
				
				if ($properties_ids) $properties_ids .= ",";
				$properties_ids .= $property_id;
				$tags_replace = array("{form_id}", "{item_id}", "{option_id}", "{property_id}", "{type}");
				$tags_values  = array($item_id, $item_id, $property_id, $property_id, $type);
				if ($onchange_code) {	
					$onchange_code = str_replace($tags_replace, $tags_values, $onchange_code); 
				}
				if ($onclick_code) {	
					$onclick_code = str_replace($tags_replace, $tags_values, $onclick_code); 
				}
				if ($control_code) {	
					$control_code = str_replace($tags_replace, $tags_values, $control_code); 
				}

				$property_control  = "";
				$property_control .= "<input type=\"hidden\" name=\"property_name_" . $property_id . "\"";
				$property_control .= " value=\"" . strip_tags($property_name) . "\">";
				$property_control .= "<input type=\"hidden\" name=\"property_required_" . $property_id . "\"";
				$property_control .= " value=\"" . intval($property_required) . "\">";
				$property_control .= "<input type=\"hidden\" name=\"property_control_" . $property_id . "\"";
				$property_control .= " value=\"" . strtoupper($control_type) . "\">";

				$sql  = " SELECT ipv.item_property_id, ipv.is_default_value, ipv.percentage_price, ";
				$sql .= " ipv.additional_price, ipv.property_value, ipv.sub_item_id, ";
				if ($property_type_id == 3) {
					$sql .= " i.item_type_id, i.buying_price, i.manufacturer_code, i." . $price_field . ", i.is_sales, i." . $sales_field . ", i.tax_free, ";
					$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action ";
					$sql .= " FROM ((" . $table_prefix . "items_properties_values ipv ";
					$sql .= " INNER JOIN " . $table_prefix . "items i ON i.item_id=ipv.sub_item_id) ";
					$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
				} else {
					$sql .= " ipv.buying_price, ipv.manufacturer_code ";
					$sql .= " FROM " . $table_prefix . "items_properties_values ipv ";
				}
				$sql .= " WHERE ipv.property_id=" . $property_id;
				$sql .= " AND ipv.hide_value=0 ";
				$sql .= " AND ((ipv.hide_out_of_stock=1 AND ipv.stock_level > 0) OR ipv.hide_out_of_stock=0 OR ipv.hide_out_of_stock IS NULL)";
				$sql .= " ORDER BY ipv.item_property_id ";
			
				if (strtoupper($control_type) == "LISTBOX") {
					$properties_prices = "";
					$properties_values = "<option value=\"\">" . SELECT_MSG . " " . $property_name . "</option>" . $eol;
					$dbp->query($sql);
					while ($dbp->next_record())
					{
						$property_value = get_translation($dbp->f("property_value"));

						$additional_price_tax = 0;
						if ($display_products != 2 || strlen($user_id)) {
							$additional_price = $dbp->f("additional_price");	
							$percentage_price = $dbp->f("percentage_price");
							if ($percentage_price && $item_price) {
								$additional_price += round(($item_price * $percentage_price) / 100, 2);
							}
							$buying_price = $dbp->f("buying_price");	
							if ($property_type_id == 3) {
								$sub_item_id = $dbp->f("sub_item_id");
								$sub_type_id = $dbp->f("item_type_id");
								$sub_tax_free = $dbp->f("tax_free");
								if (!strlen($additional_price)) {
									$sub_price = $dbp->f($price_field);
									$sub_buying = $dbp->f("buying_price");
									$sub_is_sales = $dbp->f("is_sales");
									$sub_sales = $dbp->f($sales_field);
									$sub_user_price = $dbp->f("user_price");
									$sub_user_action = $dbp->f("user_price_action");
									$prices = get_product_price($sub_item_id, $sub_price, $sub_buying, $sub_is_sales, $sub_sales, $sub_user_price, $sub_user_action, $discount_type, $discount_amount);
									$additional_price = $prices["base"];
								}
								if ($tax_prices == 2 || $tax_prices == 3) {
									$additional_price_tax = set_tax_price($sub_item_id, $sub_type_id, $additional_price, 0, $sub_tax_free);
								}
							} else {
								$additional_price = get_option_price($additional_price, $buying_price, $properties_percent, $discount_applicable, $discount_type, $discount_amount);
								if ($tax_prices == 2 || $tax_prices == 3) {
									$additional_price_tax = set_tax_price($item_id, $item_type_id, $additional_price, 0, $tax_free);
								}
							}
							$additional_price = $additional_price * $currency_rate;
							$additional_price_tax = $additional_price_tax * $currency_rate;
						} else {
							$additional_price = 0;
						}
						$item_property_id = $dbp->f("item_property_id");
						$is_default_value = $dbp->f("is_default_value");
						$property_selected  = "";
						$properties_prices .= "<input type=\"hidden\" name=\"option_price_" . $item_property_id . "\"";
						$properties_prices .= " value=\"" . $additional_price . "\">";
						if ($is_default_value) {
							$property_selected  = "selected ";
							$selected_price    += $additional_price;
						} 

						$properties_values .= "<option " . $property_selected . "value=\"" . htmlspecialchars($item_property_id) . "\">";
						$properties_values .= htmlspecialchars($property_value);
						if ($additional_price > 0)
							$properties_values .= " (+ " . $currency_left . number_format($additional_price + $additional_price_tax, 2) . $currency_right . ")";
						elseif ($additional_price < 0)
							$properties_values .= " (- " . $currency_left . number_format(abs($additional_price + $additional_price_tax), 2) . $currency_right . ")";
						$properties_values .= "</option>" . $eol;
					}
					$property_control .= $before_control_html;
					$property_control .= "<select name=\"property_" . $property_id . "\" onChange=\"changeProperty(document.form_".$item_id.");";
					if ($onchange_code) {	$property_control .= $onchange_code; }
					$property_control .= "\"";
					if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
					if ($control_code) {	$property_control .= " " . $control_code . " "; }
					if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
					$property_control .= ">" . $properties_values . "</select>";
					$property_control .= $properties_prices;
					$property_control .= $after_control_html;
				} elseif (strtoupper($control_type) == "RADIOBUTTON" || strtoupper($control_type) == "CHECKBOXLIST") {
					$is_radio = (strtoupper($control_type) == "RADIOBUTTON");
					$input_type = $is_radio ? "radio" : "checkbox";
					$property_control .= "<span";
					if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
					$property_control .= ">";
					$value_number = 0;
					$dbp->query($sql);
					while ($dbp->next_record())
					{
						$value_number++;
						$additional_price_tax = 0;
						if ($display_products != 2 || strlen($user_id)) {
							$additional_price = $dbp->f("additional_price");	
							$percentage_price = $dbp->f("percentage_price");
							if ($percentage_price && $item_price) {
								$additional_price += round(($item_price * $percentage_price) / 100, 2);
							}
							$buying_price = $dbp->f("buying_price");	
							if ($property_type_id == 3) {
								$sub_item_id = $dbp->f("sub_item_id");
								$sub_type_id = $dbp->f("item_type_id");
								$sub_tax_free = $dbp->f("tax_free");
								if (!strlen($additional_price)) {
									$sub_price = $dbp->f($price_field);
									$sub_buying = $dbp->f("buying_price");
									$sub_is_sales = $dbp->f("is_sales");
									$sub_sales = $dbp->f($sales_field);
									$sub_user_price = $dbp->f("user_price");
									$sub_user_action = $dbp->f("user_price_action");
									$prices = get_product_price($sub_item_id, $sub_price, $sub_buying, $sub_is_sales, $sub_sales, $sub_user_price, $sub_user_action, $discount_type, $discount_amount);
									$additional_price = $prices["base"];
								}
								if ($tax_prices == 2 || $tax_prices == 3) {
									$additional_price_tax = set_tax_price($sub_item_id, $sub_type_id, $additional_price, 0, $sub_tax_free);
								}
							} else {
								$additional_price = get_option_price($additional_price, $buying_price, $properties_percent, $discount_applicable, $discount_type, $discount_amount);
								if ($tax_prices == 2 || $tax_prices == 3) {
									$additional_price_tax = set_tax_price($item_id, $item_type_id, $additional_price, 0, $tax_free);
								}
							}
							$additional_price = $additional_price * $currency_rate;
							$additional_price_tax = $additional_price_tax * $currency_rate;
						} else {
							$additional_price = 0;
						}

						$item_property_id = $dbp->f("item_property_id");
						$manufacturer_code = $dbp->f("manufacturer_code");
						$is_default_value = $dbp->f("is_default_value");
						$property_value = get_translation($dbp->f("property_value"));
						$property_checked = "";
						$property_control .= $before_control_html;
						$property_control .= "<input type=\"hidden\" name=\"option_price_" . $item_property_id . "\"";
						$property_control .= " value=\"" . $additional_price . "\">";
						if ($is_default_value) {
							$property_checked = "checked ";
							$selected_price  += $additional_price;
						} 

						$control_name = ($is_radio) ? ("property_".$property_id) : ("property_".$property_id."_".$value_number);
						$property_control .= "<input type=\"" . $input_type . "\" id=\"item_property_" . $item_property_id . "\" name=\"" . $control_name . "\" ". $property_checked;
						$property_control .= "value=\"" . htmlspecialchars($item_property_id) . "\" onClick=\"changeProperty(document.form_".$item_id."); ";
						if ($onclick_code) {	
							$control_onclick_code = str_replace("{manufacturer_code}", $manufacturer_code, $onclick_code);
							$control_onclick_code = str_replace("{option_value}", $property_value, $control_onclick_code);
							$property_control .= $control_onclick_code; 
						}
						$property_control .= "\"";
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						if ($control_code) {	$property_control .= " " . $control_code . " "; }
						$property_control .= ">";
						$property_control .= $property_value;
						if ($additional_price > 0) {
							$property_control .= " (+ " . $currency_left . number_format($additional_price + $additional_price_tax, 2) . $currency_right . ")";
						} elseif ($additional_price < 0) {
							$property_control .= " (- " . $currency_left . number_format(abs($additional_price + $additional_price_tax), 2) . $currency_right . ")";
						}
						$property_control .= $after_control_html;
						// added here to have a possibilty to use id like item_property_10 for any option in HTML, JavaScript or CSS
						$property_control = str_replace("{item_property_id}", $item_property_id, $property_control);
					}
					$property_control .= "</span>";
					$property_control .= "<input type=\"hidden\" name=\"property_total_".$property_id."\" value=\"".$value_number."\">";
				} elseif (strtoupper($control_type) == "TEXTBOX" || strtoupper($control_type) == "IMAGEUPLOAD") {
					$property_control .= $before_control_html;
					$property_control .= "<input type=\"text\" name=\"property_" . $property_id . "\"";
					if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
					if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
					if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
					if ($control_code) {	$property_control .= " " . $control_code . " "; }
					$property_control .= " value=\"\">";
					$property_control .= $after_control_html;
					if (strtoupper($control_type) == "IMAGEUPLOAD") {
						$upload_url = "user_upload.php?filetype=option_image&fid=" . $item_id . "&control_name=property_" . $property_id;
						$property_control .= " <a href=\"javascript:properyImageUpload('" . $upload_url . "')\">" . UPLOAD_IMAGE_MSG . "</a>";
					}
				} elseif (strtoupper($control_type) == "TEXTAREA") {
					$property_control .= $before_control_html;
					$property_control .= "<textarea name=\"property_" . $property_id . "\"";
					if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
					if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
					if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
					if ($control_code) {	$property_control .= " " . $control_code . " "; }

					$property_control .= "></textarea>";
					$property_control .= $after_control_html;
				} else {
					$property_control .= $before_control_html;
					if ($property_required) {
						$property_control .= "<input type=\"hidden\" name=\"property_" . $property_id . "\" value=\"" . htmlspecialchars($property_description) . "\">";
					}
					$property_control .= "<span";
					if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
					if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
					if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
					if ($control_code) {	$property_control .= " " . $control_code . " "; }
					$property_control .= ">" . get_translation($property_description) . "</span>";
					$property_control .= $after_control_html;
				}
				$t->set_var("property_id", $property_id);
				$t->set_var("property_block_id", $property_block_id);
				$t->set_var("property_name", $start_html . $property_name);
				$t->set_var("property_style", $property_style);
				$t->set_var("property_control", $middle_html . $property_control . $end_html);

				$t->parse("properties", true);
			} 
		}
		$t->set_var("properties_ids", $properties_ids);

		$properties["is_any"] = $is_properties;
		$properties["ids"] = $properties_ids;
		$properties["price"] = $selected_price;
		$properties["components_price"] = $components_price;
		$properties["components_tax_price"] = $components_tax_price;

		return $properties;
	}

?>