<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  order_items.php                                          ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	function show_order_items($order_id, $parse_template = true, $page_type = "")
	{
	 	global $t, $db, $table_prefix, $settings, $date_show_format;
		global $items_text, $cart_items, $total_items;
		global $cart_properties, $personal_properties, $delivery_properties, $payment_properties;

		$dbd = new VA_SQL();
		$dbd->DBType       = $db->DBType;
		$dbd->DBDatabase   = $db->DBDatabase;
		$dbd->DBUser       = $db->DBUser;
		$dbd->DBPassword   = $db->DBPassword;
		$dbd->DBHost       = $db->DBHost;
		$dbd->DBPort       = $db->DBPort;
		$dbd->DBPersistent = $db->DBPersistent;

		$eol = get_eol();
		$currency = get_currency();
		$currency_left = $currency["left"];
		$currency_right = $currency["right"];
		$currency_rate = $currency["rate"];
		$currency_code = $currency["code"];

		$orders_currency = get_setting_value($settings, "orders_currency", 0);
		$product_code_checkout = get_setting_value($settings, "product_code_checkout", 0);

		// get information about order
		$sql  = " SELECT o.coupons_ids, o.total_discount, o.total_discount_tax, o.shipping_type_desc, o.shipping_cost, o.shipping_taxable, o.tax_name, o.tax_percent, ";
		$sql .= " o.processing_fee, o.shipping_type_id, o.country_code, o.delivery_country_code, o.weight_total, o.order_placed_date, ";
		$sql .= " o.currency_code, o.currency_rate, c.symbol_right, c.symbol_left ";
		$sql .= " FROM (" . $table_prefix . "orders o ";
		$sql .= " LEFT JOIN " . $table_prefix . "currencies c ON o.currency_code=c.currency_code) ";
		$sql .= " WHERE o.order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		$db->next_record();
		// get order values
		$order_coupons_ids = $db->f("coupons_ids");
		$total_discount = $db->f("total_discount");
		$total_discount_tax = $db->f("total_discount_tax");
		$shipping_type_id = $db->f("shipping_type_id");
		$shipping_type_desc = $db->f("shipping_type_desc");
		$shipping_cost = $db->f("shipping_cost");
		$shipping_taxable = $db->f("shipping_taxable");
		$shipping_taxable_value = ($shipping_taxable == 1) ? $shipping_cost : 0;
		$tax_name = $db->f("tax_name");
		$tax_percent = $db->f("tax_percent");
		if (strlen($tax_name)) {
			$tax_available = true;
		} else {
			$tax_available = false;
		}
		$processing_fee = $db->f("processing_fee");
		$country_code = $db->f("delivery_country_code");
		$weight_total = $db->f("weight_total");
		$order_placed_date = $db->f("order_placed_date", DATETIME);
		$order_date = va_date($date_show_format, $order_placed_date);
		if (!$country_code) {
			$country_code = $db->f("country_code");
		}
		$order_currency_code = $db->f("currency_code");
		$order_currency_rate = $db->f("currency_rate");
		$order_currency_left = $db->f("symbol_left");
		$order_currency_right = $db->f("symbol_right");
		if ($orders_currency != 1) {
			$order_currency_left = $currency_left;
			$order_currency_right = $currency_right;
			if (strtolower($currency_code) != strtolower($order_currency_code)) {
				$order_currency_rate = $currency_rate;
			}
		}

		/*
		if (strtolower($currency_code) == strtolower($order_currency_code)) {
			$currency_rate = $order_currency_rate;
		}//*/

		if ($parse_template) {
			$t->set_var("CART_TITLE",          CART_TITLE);     
			$t->set_var("EMPTY_CART_MSG",      EMPTY_CART_MSG);     
			$t->set_var("PROD_TITLE_COLUMN",   PROD_TITLE_COLUMN);     
			$t->set_var("PROD_QTY_COLUMN",     PROD_QTY_COLUMN);         
			$t->set_var("PROD_PRICE_COLUMN",   PROD_PRICE_COLUMN);       
			$t->set_var("PROD_TOTAL_COLUMN",   PROD_TOTAL_COLUMN);  
			$t->set_var("PROD_TAX_TOTAL_COLUMN", PROD_TAX_TOTAL_COLUMN);  
			$t->set_var("GOODS_TOTAL_MSG",     GOODS_TOTAL_MSG); 
			$t->set_var("TOTAL_DISCOUNT_MSG",  TOTAL_DISCOUNT_MSG); 
			$t->set_var("GOODS_WITH_DISCOUNT_MSG",GOODS_WITH_DISCOUNT_MSG); 
			$t->set_var("CART_TOTAL_MSG",      CART_TOTAL_MSG);     
			$t->set_var("PROCESSING_FEE_MSG",  PROCESSING_FEE_MSG);     

			$t->set_var("items", "");
			$t->set_var("cart_properties", "");
			$t->set_var("personal_properties", "");
			$t->set_var("delivery_properties", "");
			if ($order_currency_rate != 1) {
				$t->set_var("order_currency_code", $order_currency_code);
				$t->set_var("order_currency_rate", $order_currency_rate);
				$t->sparse("order_currency", false);
			}
			if ($tax_available) {
				$t->set_var("sc_colspan", "5");
				$t->set_var("tax_name", $tax_name);
				$t->sparse("tax_headers", false);
			} else {
				$t->set_var("sc_colspan", "3");
			}
		}

		$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", "");
		$items_text = ""; $order_items = ""; $cart_items = array(); 
		$goods_total = 0; $goods_tax_total = 0; $goods_taxable = 0; $total_quantity = 0; $total_items = 0;
		$sql  = " SELECT order_item_id,item_id,item_type_id,item_status,manufacturer_code,item_name, ";
		$sql .= " is_recurring, recurring_last_payment, recurring_next_payment, ";
		$sql .= " price,tax_free,tax_percent, discount_amount,real_price,quantity,coupons_ids ";
		$sql .= " FROM " . $table_prefix . "orders_items WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		while($db->next_record())
		{
			$total_items++;
			$order_item_id = $db->f("order_item_id");
			$item_id = $db->f("item_id");
			$item_status = $db->f("item_status");
			$real_price = $db->f("real_price");
			$coupons_ids = $db->f("coupons_ids");

			if (strlen($order_items)) { $order_items .= ","; }
			$order_items .= $order_item_id;

			if ($page_type == "user_order") {
				$sql  = " SELECT id.download_id,i.item_name,id.download_added, ";
				$sql .= " i.download_path AS product_path, id.download_path, ";
				$sql .= " id.download_expiry ";
				$sql .= " FROM " . $table_prefix . "items_downloads id, " . $table_prefix . "items i ";
				$sql .= " WHERE id.item_id=i.item_id ";
				$sql .= " AND id.order_item_id=" . $db->tosql($order_item_id, INTEGER);
				$sql .= " AND id.order_id=" . $db->tosql($order_id, INTEGER);
				$sql .= " AND id.activated=1";
				$t->set_var("download_links", "");
				$dbd->query($sql);
				while($dbd->next_record()) {
					$download_id = $dbd->f("download_id");
					$product_path = trim($dbd->f("product_path"));
					$download_path = trim($dbd->f("download_path"));
					if(!$download_path) {
						$download_path = $product_path;
					}
					$download_added = $dbd->f("download_added", DATETIME);
					$download_expiry = $dbd->f("download_expiry", DATETIME);
					$expiry_date = mktime (0,0,0, $download_expiry[MONTH], $download_expiry[DAY], $download_expiry[YEAR]);
					$current_date = mktime(0,0,0, date("m"), date("d"), date("Y"));
					$item_download_url  = $settings["site_url"] . "download.php?download_id=" . $download_id;
					$vc = md5($download_id . $download_added[3].$download_added[4].$download_added[5]);
					$item_download_url .= "&vc=" . urlencode($vc);
					if($expiry_date > $current_date) {
						$product_paths = split(";", $download_path);
						for($di = 0; $di < sizeof($product_paths); $di++) {
							$sub_path = $product_paths[$di];
							if($sub_path) {
								$sub_url = $item_download_url . "&path_id=" . ($di + 1);
								$t->set_var("filename", basename($sub_path));
								$t->set_var("download_id", $download_id);
								$t->set_var("vc", $vc);
								$t->set_var("download_url", $sub_url);
								$t->parse("download_links");
							}
						}
					}
				}
				$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "releases  ";
				$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);;
				$dbd->query($sql);
				$dbd->next_record();
				$releases_number = $dbd->f(0);
				if($releases_number > 0) {
					$t->set_var("order_item_id", $order_item_id);
					$t->parse("releases_link", false);
				} else {
					$t->set_var("releases_link", "");
				}
			}

			$serial_numbers = ""; $gift_vouchers = "";
			if ($page_type == "user_order" || $page_type == "admin_order") {
				$t->set_var("serial_numbers", "");
				$sql  = " SELECT serial_id, serial_number, activations_number ";
				$sql .= " FROM " . $table_prefix . "orders_items_serials ";
				$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
				$sql .= " AND order_id=" . $db->tosql($order_id, INTEGER);
				if ($page_type == "user_order") {
					$sql .= " AND activated=1";
				}
				$dbd->query($sql);
				while ($dbd->next_record()) {
					$serial_id = $dbd->f("serial_id");
					$serial_number = $dbd->f("serial_number");
					$t->set_var("serial_id", $serial_id);
					$t->set_var("serial_number", $serial_number);
					$t->sparse("serial_numbers", true);
				}

				$t->set_var("gift_vouchers", "");
				$sql  = " SELECT coupon_id, coupon_code ";
				$sql .= " FROM " . $table_prefix . "coupons ";
				$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
				$sql .= " AND order_id=" . $db->tosql($order_id, INTEGER);
				if ($page_type == "user_order") {
					$sql .= " AND is_active=1";
				}
				$dbd->query($sql);
				while ($dbd->next_record()) {
					$coupon_id = $dbd->f("coupon_id");
					$coupon_code = $dbd->f("coupon_code");
					$t->set_var("coupon_id", $coupon_id);
					$t->set_var("coupon_code", $coupon_code);
					$t->sparse("gift_vouchers", true);
				}
			}

			// show information about coupons used
			if ($parse_template && strlen($coupons_ids)) {
				$t->set_var("item_coupons", "");
				$sql  = " SELECT coupon_id, coupon_code, coupon_title, discount_type, discount_amount ";
				$sql .= " FROM " . $table_prefix . "coupons ";
				$sql .= " WHERE coupon_id IN (" . $db->tosql($coupons_ids, TEXT, false) . ") ";
				$dbd->query($sql);
				while ($dbd->next_record()) {
					$coupon_id = $dbd->f("coupon_id");
					$coupon_code = $dbd->f("coupon_code");
					$coupon_title = $dbd->f("coupon_title");
					$coupon_type = $dbd->f("discount_type");
					$coupon_discount = $dbd->f("discount_amount");
					if($coupon_type == 3) {
						$item_discount = round(($real_price / 100) * $coupon_discount, 2);
					} else {
						$item_discount = $coupon_discount;
					}
					$coupon_title .= " (-" . $currency_left . number_format($item_discount * $order_currency_rate, 2) . $currency_right . ")";

					$t->set_var("coupon_id", $coupon_id);
					$t->set_var("coupon_code", $coupon_code);
					$t->set_var("coupon_title", $coupon_title);

					$t->sparse("item_coupons", true);
				}
			}

			if ($page_type == "admin_order") {
				set_options($order_statuses, $item_status, "item_status");
				$t->set_var("current_item_status", $item_status);
			}


			$item_name = get_translation($db->f("item_name"));
			$manufacturer_code = $db->f("manufacturer_code");
			$is_recurring = $db->f("is_recurring");
			$recurring_last_payment = $db->f("recurring_last_payment", DATETIME);
			$recurring_next_payment = $db->f("recurring_next_payment", DATETIME);

			$price = $db->f("price");
			$tax_free = $db->f("tax_free");
			$item_tax_percent = $db->f("tax_percent");
			$discount_amount = $db->f("discount_amount");
			$real_price = $db->f("real_price");
			$quantity = $db->f("quantity");
			$weight = $db->f("weight");
			$buying_price = $db->f("buying_price");
			$downloadable = $db->f("downloadable");
			$item_type_id = $db->f("item_type_id");
			$stock_level = "";
			$short_description = "";
			$full_description = "";

			$item_total = $price * $quantity;
			$goods_total += $item_total;
			if ($tax_free != 1)  {
				$goods_taxable += $item_total;
				if (!strlen($item_tax_percent)) {
					$item_tax_percent = $tax_percent;
				}
				$item_tax_total   = round(($item_total * $item_tax_percent) / 100, 2);
				$goods_tax_total += $item_tax_total;
			} else {
				$item_tax_percent = 0;
				$item_tax_total = 0;
			}
			$total_quantity += $quantity;

			$item_text = $item_name;
			// get options for every product
			$item_properties = ""; $item_properties_text = "";
			$sql  = " SELECT property_name, property_value, additional_price ";
			$sql .= " FROM " . $table_prefix . "orders_items_properties ";
			$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
			$sql .= " AND order_item_id=" . $db->tosql($order_item_id, INTEGER);
			$dbd->query($sql);
			while ($dbd->next_record()) {
				$property_name = get_translation($dbd->f("property_name"));
				$property_value = get_translation($dbd->f("property_value"));
				$property_price = $dbd->f("additional_price");
				$property_text = $property_name . ": " . $property_value;
				if ($property_price > 0) { 
					$property_text .= " (+ " . $order_currency_left . number_format($property_price * $order_currency_rate, 2) . $order_currency_right . ")";
				} else if ($property_price < 0) {
					$property_text .= " (- " . $order_currency_left . number_format(abs($property_price) * $order_currency_rate, 2) . $order_currency_right . ")";
				}
				$item_properties .= "<br>" . $property_text;
				if ($item_properties_text) { $item_properties_text .= "; "; }
				$item_properties_text .= $property_text;
			}

			if ($item_properties) {
				$item_text .= " (" . $item_properties_text . ")";
			}
			$item_text .= " " . PROD_QTY_COLUMN . ": " . $quantity . " " . $order_currency_left . number_format($item_total * $order_currency_rate, 2) . $order_currency_right;
			$items_text .= $item_text . $eol;

			// get additional fields
			$sql  = " SELECT short_description, full_description FROM " . $table_prefix . "items ";
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
			$dbd->query($sql);
			if($dbd->next_record()) {
				$stock_level = $dbd->f("stock_level");
				$short_description = strip_tags($dbd->f("short_description"));
				$full_description = strip_tags($dbd->f("full_description"));
			} 

			$cart_items[] = array(
				"item_id" => $item_id, "id" => $item_id, "product_id" => $item_id, 
				"weight" => $weight, "price" => $price, "quantity" => $quantity, "tax_free" => $tax_free, 
				"discount_amount" => $discount_amount, "real_price" => $real_price, 
				"buying_price" => $buying_price, "item_name" => $item_name, "product_name" => $item_name, 
				"product_title" => $item_name, "item_title" => $item_name, "item_total" => $item_total,
				"downloadable" => $downloadable, "item_type_id" => $item_type_id, "stock_level" => $stock_level,
				"short_description" => $short_description, "description" => $short_description, 
				"full_description" => $full_description
			);

			if($parse_template) { // set item variables into html
				$t->set_var("item_id", $item_id);
				$t->set_var("order_item_id", $order_item_id);
				$t->set_var("item_name", $item_name);
				$t->set_var("item_title", $item_name);
				$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));
				$t->set_var("manufacturer_code", $manufacturer_code);
				// show product code
				if ($product_code_checkout && $manufacturer_code) {
					$t->sparse("product_code", false);
				} else {
					$t->set_var("product_code", "");
				}
				if ($is_recurring) {
					$t->set_var("next_payment_date", va_date($date_show_format, $recurring_next_payment));
					$t->sparse("next_recurring_payment", false);
				} else {
					$t->set_var("next_recurring_payment", "");
				}
				if (preg_match_all("/http\:\/\/[^\s<>\n]+/mi", $item_properties, $matches)) { 
					for($m = 0; $m < sizeof($matches[0]); $m++) {
						$link_url = $matches[0][$m];
						$html_link_url = "<a href=\"".$link_url."\" target=\"_blank\">" . basename($link_url) . "</a>";
						$item_properties = str_replace($link_url, $html_link_url, $item_properties);
					}
				}
				$t->set_var("item_properties", $item_properties);
				$t->set_var("item_options", $item_properties);
				$t->set_var("quantity", $quantity);				
				$t->set_var("price", $order_currency_left . number_format($price * $order_currency_rate, 2) . $order_currency_right);
				$t->set_var("item_total", $order_currency_left . number_format($item_total * $order_currency_rate, 2) . $order_currency_right);
				if ($tax_available) {
					$t->set_var("item_tax_percent", $item_tax_percent . "%");
					$t->set_var("item_tax_total", $order_currency_left . number_format($item_tax_total * $order_currency_rate, 2) . $order_currency_right);
					$t->sparse("item_tax", false);
				}
				if (($page_type == "admin_invoice_html" || $page_type == "user_invoice_html") && strlen($tax_name)) {
					$t->parse("tax_columns", false);
				}

				$t->sparse("items", true);
			}
		}

		$items_text .= GOODS_TOTAL_MSG . ": " . $order_currency_left . number_format($goods_total * $order_currency_rate, 2) . $order_currency_right . $eol;
		if ($parse_template) {
			$t->set_var("tax_name", $tax_name);
			$t->set_var("order_date", $order_date);
			$t->set_var("order_items", $order_items);
			$t->set_var("total_quantity", $total_quantity);
			$t->set_var("goods_total", $order_currency_left . number_format($goods_total * $order_currency_rate, 2) . $order_currency_right);
			if ($tax_available) {
				$t->set_var("goods_tax_total", $order_currency_left . number_format($goods_tax_total * $order_currency_rate, 2) . $order_currency_right);
				$t->sparse("goods_tax", false);
			}
			if (($page_type == "admin_invoice_html" || $page_type == "user_invoice_html") && strlen($tax_name)) {
				$t->sparse("tax_headers", false);
				$t->sparse("tax_footers", false);
				$t->set_var("price_width", "75");
				$t->set_var("total_width", "85");
				$t->set_var("description_width", "420");
				$t->set_var("tax_columns_width", "135");
			} else {
				$t->set_var("price_width", "140");
				$t->set_var("total_width", "150");
				$t->set_var("description_width", "490");
				$t->set_var("tax_columns_width", "0");
			}
		}

		// show information about order coupons used
		if ($parse_template && strlen($order_coupons_ids)) {
			$max_discount = $goods_total;
			$max_tax_discount = $goods_tax_total;

			$t->set_var("order_coupons", "");
			$sql  = " SELECT coupon_id, coupon_code, coupon_title, discount_type, discount_amount ";
			$sql .= " FROM " . $table_prefix . "coupons ";
			$sql .= " WHERE coupon_id IN (" . $db->tosql($order_coupons_ids, TEXT, false) . ") ";
			$dbd->query($sql);
			while ($dbd->next_record()) {
				$coupon_id = $dbd->f("coupon_id");
				$coupon_code = $dbd->f("coupon_code");
				$coupon_title = $dbd->f("coupon_title");
				$coupon_type = $dbd->f("discount_type");
				$coupon_discount = $dbd->f("discount_amount");
				if($coupon_type == 1) {
					$discount_amount = round(($goods_total / 100) * $coupon_discount, 2);
				} else {
					$discount_amount = $coupon_discount;
				}
				if ($discount_amount > $max_discount) {
					$discount_amount = $max_discount;
				}
				$max_discount -= $discount_amount; 

				// check discount tax
				$discount_tax_amount = round(($discount_amount * $goods_tax_total) / $goods_total, 2);
				if ($discount_tax_amount > $max_tax_discount) {
					$discount_tax_amount = $max_tax_discount;
				}
				$max_tax_discount -= $discount_tax_amount;

				$t->set_var("coupon_id", $coupon_id);
				$t->set_var("coupon_code", $coupon_code);
				$t->set_var("coupon_title", $coupon_title);
				$t->set_var("discount_amount", "-" . $currency_left . number_format($discount_amount * $currency_rate, 2) . $currency_right);
				if ($tax_available) {
					$t->set_var("discount_amount_tax", "-" . $currency_left . number_format($discount_tax_amount * $currency_rate, 2) . $currency_right);
					$t->sparse("order_coupon_tax", false);
				}

				$t->sparse("order_coupons", true);
			}
		}


		if($total_discount > 0) {
			$items_text .= TOTAL_DISCOUNT_MSG . ": -" . $order_currency_left . number_format($total_discount * $order_currency_rate, 2) . $order_currency_right . $eol;
			$items_text .= GOODS_WITH_DISCOUNT_MSG. ": " . $order_currency_left . number_format(($goods_total - $total_discount) * $order_currency_rate, 2) . $order_currency_right . $eol;
			if (!$total_discount_tax && $goods_tax_total > 0) {
				$total_discount_tax = round(($total_discount * $goods_tax_total) / $goods_total, 2);
			}
			if ($parse_template) {
				$t->set_var("total_discount", "-" . $order_currency_left . number_format($total_discount * $order_currency_rate, 2) . $order_currency_right);
				$t->set_var("goods_with_discount", $order_currency_left . number_format(($goods_total - $total_discount) * $order_currency_rate, 2) . $order_currency_right);
				if ($tax_available) {
					$t->set_var("total_discount_tax_amount", "- " . $order_currency_left . number_format($total_discount_tax * $order_currency_rate, 2) . $order_currency_right);
					$t->set_var("discounted_tax_amount", $order_currency_left . number_format(($goods_tax_total - $total_discount_tax)* $order_currency_rate, 2) . $order_currency_right);
					$t->sparse("total_discount_tax", false);
					$t->sparse("discounted_tax", false);
				}
				$t->sparse("discount", false);
			}
		} 
		$goods_with_discount = $goods_total - $total_discount;
		$goods_tax_value = $goods_tax_total - $total_discount_tax;
		if ($total_discount > 0) {
			$goods_taxable = $goods_taxable - round(($goods_taxable * $total_discount) / $goods_total, 2);
		}

		$cart_properties = 0; $personal_properties = 0;
		$delivery_properties = 0; $payment_properties = 0;
		$properties_total = 0; $properties_taxable = 0;
		$sql  = " SELECT * FROM " . $table_prefix . "orders_properties ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		if ($page_type == "cc_info") {
			$sql .= " AND property_type IN (1,2,3) ";
		}
		$sql .= " ORDER BY property_order, property_id ";
		$db->query($sql);
		while ($db->next_record()) {
			$property_id   = $db->f("property_id");
			$property_type = $db->f("property_type");
			$property_name = $db->f("property_name");
			$property_value = $db->f("property_value");
			$property_price = $db->f("property_price");
			$tax_free = $db->f("tax_free");
			$properties_total += $property_price;
			if ($tax_free != 1) {
				$properties_taxable += $property_price;
			}
			if ($property_type == 1) {
				$items_text .= $property_name . "(" . $property_value . "): " . $order_currency_left . number_format($property_price * $order_currency_rate, 2) . $order_currency_right . $eol;
			}
			if ($parse_template) {
				$t->set_var("field_name_" . $property_id, $property_name);
				$t->set_var("field_value_" . $property_id, $property_value);
				$t->set_var("field_price_" . $property_id, $property_price);
				$t->set_var("field_" . $property_id, $property_value);
				$t->set_var("property_name", $property_name);
				$t->set_var("property_value", $property_value);
				if ($property_price == 0) {
					$t->set_var("property_price", "");
				} else {
					$t->set_var("property_price", $order_currency_left . number_format($property_price * $order_currency_rate, 2) . $order_currency_right);
				}
				if ($property_type == 1) {
			    $cart_properties++;
					$t->sparse("cart_properties", true);
				} else if ($property_type == 2) {
					$personal_properties++;
					$t->sparse("personal_properties", true);
				} else if ($property_type == 3) {
					$delivery_properties++;
					$t->sparse("delivery_properties", true);
				} else if ($property_type == 4) {
					$payment_properties++;
					$t->sparse("payment_properties", true);
				}
			}
		}
		if ($parse_template) {
			$t->set_var("properties_total", $properties_total); 
			$t->set_var("properties_taxable", $properties_taxable);
		}

		if(strlen($shipping_type_desc) || $shipping_cost > 0) {
			$items_text .= $shipping_type_desc . ": " . $order_currency_left . number_format($shipping_cost * $order_currency_rate, 2) . $order_currency_right . $eol;
			if($parse_template) {
				$t->set_var("current_shipping_id", $shipping_type_id);
				$t->set_var("shipping_type_desc",  $shipping_type_desc);
				$t->set_var("shipping_cost", $order_currency_left . number_format($shipping_cost * $order_currency_rate, 2) . $order_currency_right);
				$t->set_var("shipping_cost_desc", $order_currency_left . number_format($shipping_cost * $order_currency_rate, 2) . $order_currency_right);
				$t->sparse("shipping_type", false);
			}
		}

		if ($page_type == "admin_order") {
			$t->set_var("currency_left", $order_currency_left);
			$t->set_var("currency_right", $order_currency_right);
			$t->set_var("currency_rate", $order_currency_rate);
			$t->set_var("goods_value", $goods_with_discount);
			$t->set_var("goods_tax_value", $goods_tax_value);
			$t->set_var("taxable_value", $goods_taxable);
			$t->set_var("tax_percent", $tax_percent);

			// prepare shipping
			$total_shipping_types = 0; 
			if (strlen($country_code) && strlen($shipping_type_id)) {
				$sql  = " SELECT tare_weight ";
				$sql .= " FROM " . $table_prefix . "shipping_types ";
				$sql .= " WHERE shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$weight_total = $weight_total - $db->f("tare_weight");
				}
			}

			$shipping_type_exists = false; $free_postage = false;
			$sql  = " SELECT st.shipping_type_id, st.shipping_type_desc, st.cost_per_order, ";
			$sql .= " st.cost_per_product, st.cost_per_weight, st.tare_weight, st.is_taxable ";
			$sql .= " FROM " . $table_prefix . "shipping_modules sm, " . $table_prefix . "shipping_types st, " . $table_prefix . "shipping_types_countries stc ";
			$sql .= " WHERE st.shipping_module_id=sm.shipping_module_id ";
			$sql .= " AND st.shipping_type_id=stc.shipping_type_id ";
			$sql .= " AND sm.is_active=1 ";
			$sql .= " AND sm.is_external<>1 ";
			$sql .= " AND st.is_active=1 ";
			$sql .= " AND stc.country_code=" . $db->tosql($country_code, TEXT);
			$sql .= " AND st.min_weight<=" . $db->tosql($weight_total, NUMBER);
			$sql .= " AND st.max_weight>=" . $db->tosql($weight_total, NUMBER);
			$sql .= " AND st.min_goods_cost<=" . $db->tosql($goods_total, NUMBER);
			$sql .= " AND st.max_goods_cost>=" . $db->tosql($goods_total, NUMBER);
			$db->query($sql);
			while($db->next_record()) {
				$total_shipping_types++;
				$row_shipping_id = $db->f("shipping_type_id");
				$row_shipping_desc = $db->f("shipping_type_desc");
				$cost_per_order = $db->f("cost_per_order");
				$cost_per_product = $db->f("cost_per_product");
				$cost_per_weight = $db->f("cost_per_weight");
				$row_tare_weight = $db->f("tare_weight");
				$row_shipping_taxable = $db->f("is_taxable");
				$row_shipping_cost = $free_postage ? 0 : $cost_per_order + ($cost_per_product * $total_quantity) + ($cost_per_weight * ($weight_total + $row_tare_weight));
				$row_shipping_cost_desc = $order_currency_left . number_format($row_shipping_cost * $order_currency_rate, 2) . $order_currency_right;

				if ($row_shipping_id == $shipping_type_id) {
					$shipping_type_exists = true;
					$shipping_selected = "selected";
				} else {
					$shipping_selected = "";
				}
				$t->set_var("row_shipping_id", $row_shipping_id);
				$t->set_var("row_shipping_desc", $row_shipping_desc . " (" . $row_shipping_cost_desc . ")");
				$t->set_var("shipping_selected", $shipping_selected);
				$t->set_var("shipping_value", round($row_shipping_cost, 2));
				$t->set_var("shipping_taxable", intval($row_shipping_taxable));
				$t->parse("shipping_types", true);
				$t->parse("shipping_values", true);
			}
			if ($total_shipping_types > 1 && $shipping_type_exists) {
				$t->set_var("shipping_type", "");
				$t->parse("shipping_selection", false);
			} 			
		} 

		$tax_cost = 0;
		if($tax_available) {
			//$taxable_amount = (round($goods_taxable, 2) + round($properties_taxable, 2) + round($shipping_taxable_value, 2));
			$taxable_amount = round($properties_taxable, 2) + round($shipping_taxable_value, 2);
			$tax_cost = ($taxable_amount * $tax_percent) / 100;
			$tax_cost = $goods_tax_total - $total_discount_tax + round($tax_cost, 2);
			$items_text .= $tax_name . ": " . $order_currency_left . number_format($tax_cost * $order_currency_rate, 2) . $order_currency_right . $eol;
			if($parse_template) {
				$t->set_var("tax_name", $tax_name);
				$t->set_var("tax_cost", $order_currency_left . number_format($tax_cost * $order_currency_rate, 2) . $order_currency_right);
				$t->sparse("tax");
			}
		}
		$order_total = round($goods_with_discount, 2) + round($properties_total, 2) + round($shipping_cost, 2) + $tax_cost;

		if ($processing_fee != 0) {
			$items_text .= PROCESSING_FEE_MSG . ": " . $order_currency_left . number_format($processing_fee * $order_currency_rate, 2) . $order_currency_right . $eol;
			if ($parse_template) {
				$t->set_var("PROCESSING_FEE_MSG", PROCESSING_FEE_MSG);
				$t->set_var("fee_value", round($processing_fee, 2));
				$t->set_var("processing_fee_cost", $order_currency_left . number_format($processing_fee * $order_currency_rate, 2) . $order_currency_right);
				$t->sparse("fee");
			}
			$order_total += $processing_fee;
		} 
		
		$items_text .= CART_TOTAL_MSG . ": " . $order_currency_left . number_format($order_total * $order_currency_rate, 2) . $order_currency_right;

		if ($parse_template) {
			$t->set_var("order_total", $order_currency_left . number_format($order_total * $order_currency_rate, 2) . $order_currency_right);
			$t->sparse("basket", false);
		}

		return $items_text;
	}

	function check_order($order_id, $vc, $final_check = false)
	{
		global $db, $table_prefix;
		$errors = "";
		$sql  = " SELECT order_placed_date,is_placed FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			$is_placed = $db->f("is_placed");
			$order_placed_date = $db->f("order_placed_date", DATETIME);
			if(!$final_check && $vc != md5($order_id . $order_placed_date[3].$order_placed_date[4].$order_placed_date[5])) {
				$errors .= ORDER_CODE_ERROR . "<br>";
			}
			if($is_placed && (!$final_check || ($final_check && $order_id != get_session("session_order_id")))) {
				$errors .= ORDER_PLACED_ERROR;
			}
		} else {
			$errors .= ORDER_EXISTS_ERROR . "<br>";
		}
		return $errors;
	}

	function get_order_id() 
	{
		$order_id = get_session("session_order_id");
		if (!strlen($order_id)) { $order_id = get_param("cart_order_id"); }
		if (!strlen($order_id)) { $order_id = get_param("oid"); }
		if (!strlen($order_id)) { $order_id = get_param("cartId"); }
		if (!strlen($order_id)) { $order_id = get_param("x_invoice_num"); }
		return $order_id;
	}

	function check_payment($order_id, $payment_total, $payment_currency = "")
	{
		global $db, $table_prefix;
		$errors = "";
		$exchange_rate = 1;
		if (strlen($payment_currency)) {
			$sql  = " SELECT * FROM " . $table_prefix . "currencies ";
			$sql .= " WHERE currency_code=" . $db->tosql($payment_currency, TEXT);
			$db->query($sql);
			if ($db->next_record()) {
  			$exchange_rate = $db->f("exchange_rate");
			} else {
				$errors .= "Currency code has wrong value.";
			}
		}
		$sql  = " SELECT order_placed_date,order_total,order_status FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			$order_total = $db->f("order_total");
			$order_total = round(($order_total * $exchange_rate), 2);
			if($order_total != $payment_total) {
				$errors .= "<b>Transaction Amount</b> and <b>Order Amount</b> doesn't match.";
			}
		} else {
			$errors .= "Such <b>Order</b> doesn't exists.<br>";
		}

		return $errors;
	}

	function update_order_status($order_id, $status_id, $order_event = true, $order_items = "")
	{
		global $t, $db, $db_type, $table_prefix, $settings;
		global $datetime_show_format;

		$is_valid = true; $is_update = false;
		$sql  = " SELECT * FROM " . $table_prefix . "order_statuses ";
		$sql .= " WHERE status_id=" . $db->tosql($status_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$status_id = $db->f("status_id");
			$paid_status = $db->f("paid_status");
			$download_activation = $db->f("download_activation");
			$commission_action = $db->f("commission_action");
			$status_name = $db->f("status_name");
			// email settings
			$mail_notify = $db->f("mail_notify");
			$mail_from = $db->f("mail_from");
			if (!strlen($mail_from)) { $mail_from = $settings["admin_email"]; }
			$mail_cc = $db->f("mail_cc");
			$mail_bcc = $db->f("mail_bcc");
			$mail_reply_to = $db->f("mail_reply_to");
			$mail_return_path = $db->f("mail_return_path");
			$mail_type = $db->f("mail_type");
			$mail_subject = $db->f("mail_subject");
			$mail_body = $db->f("mail_body");
			$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
			// sms settings
			$sms_notify = $db->f("sms_notify");
			$sms_recipient = $db->f("sms_recipient");
			$sms_originator = $db->f("sms_originator");
			$sms_message = $db->f("sms_message");
		} else {
			$is_valid = false;
		}

		$sql  = " SELECT o.*,os.status_name,os.paid_status FROM (" . $table_prefix . "orders o ";
		$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON os.status_id=o.order_status) ";
		$sql .= " WHERE o.order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$order_id = $db->f("order_id");
			$current_status_id = $db->f("order_status");
			$current_status = $db->f("status_name");
			$current_paid_status = $db->f("paid_status");

			$affiliate_user_id = $db->f("affiliate_user_id");
			$tax_total = $db->f("tax_total");
			$order_info = $db->Record;
			$order_info["tax_cost"] = $tax_total;
			$user_mail = strlen($order_info["email"]) ? $order_info["email"] : $order_info["delivery_email"];

			$t->set_vars($order_info);
			$t->set_var("site_url", $settings["site_url"]);
		  
			$order_placed_date = $db->f("order_placed_date", DATETIME);
			$date_formated = va_date($datetime_show_format, $order_placed_date);
			$t->set_var("order_placed_date", $date_formated);

			// preparing downloadable data
			// get download links
			$links = get_order_links($order_id);
			// get serial numbers 
			$order_serials = get_serial_numbers($order_id);
			// get gift vouchers
			$order_vouchers = get_gift_vouchers($order_id);
		} else {
			$is_valid = false;
		}

		$items_statuses = array(); $items_paid = array(); $other_statuses = false; $order_items_ids = "";
		if (strlen($order_items)) {
			$sql  = " SELECT oi.order_item_id, oi.item_name, os.status_id, os.status_name, os.paid_status, os.download_activation ";
			$sql .= " FROM (" . $table_prefix . "orders_items oi ";
			$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON os.status_id=oi.item_status) ";
			$sql .= " WHERE oi.order_item_id IN (" . $db->tosql($order_items, TEXT, false) . ")" ;
			$db->query($sql);
			while ($db->next_record()) {
				$order_item_id = $db->f("order_item_id");
				$item_name = get_translation($db->f("item_name"));
				$cur_item_status = $db->f("status_id");
				$item_status_name = $db->f("status_name");
				$item_paid_status = $db->f("paid_status");
				$items_paid[$order_item_id] = $item_paid_status;
				$new_item_status = get_param("item_status_" . $order_item_id);
				if ($new_item_status != $status_id || $cur_item_status == $new_item_status) {
					$other_statuses = true;
				}
				// check items with updated statuses
				if ($cur_item_status != $new_item_status) {
					if ($order_items_ids) { $order_items_ids .= ","; }
					$order_items_ids .= $order_item_id;
					$items_statuses[$new_item_status][] = array($order_item_id, $item_name, $item_status_name);
				}
			}
		}

		if ($is_valid) {

			$r = new VA_Record($table_prefix . "orders_events");
			$r->add_textbox("order_id", INTEGER);
			$r->add_textbox("status_id", INTEGER);
			$r->add_textbox("admin_id", INTEGER);
			$r->add_textbox("order_items", TEXT);
			$r->add_textbox("event_date", DATETIME);
			$r->add_textbox("event_name", TEXT);
			$r->add_textbox("event_description", TEXT);
			$r->set_value("order_id", $order_id);
			$r->set_value("admin_id", get_session("session_admin_id"));
			$r->set_value("event_date", va_time());

			if ($current_status_id != $status_id) {
				// update status
				$is_update = true;
				$sql  = " UPDATE " . $table_prefix . "orders ";
				$sql .= " SET order_status=" . $db->tosql($status_id, INTEGER);
				$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
				$db->query($sql);

				if (!$other_statuses) {
					// update items status
					$sql  = " UPDATE " . $table_prefix . "orders_items ";
					$sql .= " SET item_status=" . $db->tosql($status_id, INTEGER);
					$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
					$db->query($sql);

					if($download_activation == 1) {
						$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=1 WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "orders_items_serials SET activated=1 WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "coupons SET is_active=1 WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
					} else if($download_activation == 0) {
						$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=0 WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "orders_items_serials SET activated=0 WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "coupons SET is_active=0 WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
					}

				}
		  
				if ($order_event) {
					// save event with updated status
					$r->set_value("status_id", $status_id);
					$r->set_value("event_name", "Update status");
					$r->set_value("event_description", $current_status . " &ndash;&gt; " . $status_name);
					$r->insert_record();
				}

				if ($mail_notify || $sms_notify) {
		  
					$company_select = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($order_info["company_id"], INTEGER));
					$delivery_company_select = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($order_info["delivery_company_id"], INTEGER));
					$state = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($order_info["state_code"], TEXT));
					$delivery_state = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($order_info["delivery_state_code"], TEXT));
					$country = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($order_info["country_code"], TEXT));
					$delivery_country = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($order_info["delivery_country_code"], TEXT));
		  
					$t->set_var("company_select", $company_select);
					$t->set_var("state", $state);
					$t->set_var("country", $country);
					$t->set_var("delivery_company_select", $delivery_company_select);
					$t->set_var("delivery_state", $delivery_state);
					$t->set_var("delivery_country", $delivery_country);
		  
				}

				if ($mail_notify) {
					$t->set_block("mail_subject", $mail_subject);
					$t->set_block("mail_body", $mail_body);

					// set download links
					if ($mail_type) {
						$t->set_var("links", $links["html"]);
					} else {
						$t->set_var("links", $links["text"]);
					}
					// set serial numbers
					if ($mail_type) {
						$t->set_var("serials", $order_serials["html"]);
						$t->set_var("serial_numbers", $order_serials["html"]);
					} else {
						$t->set_var("serials", $order_serials["text"]);
						$t->set_var("serial_numbers", $order_serials["text"]);
					}
					// set serial numbers
					if ($mail_type) {
						$t->set_var("vouchers", $order_vouchers["html"]);
						$t->set_var("gift_vouchers", $order_vouchers["html"]);
					} else {
						$t->set_var("vouchers", $order_vouchers["text"]);
						$t->set_var("gift_vouchers", $order_vouchers["text"]);
					}
		  
					$t->parse("mail_subject", false);
					$t->parse("mail_body", false);
					$mail_body = str_replace("\r", "", $t->get_var("mail_body"));
					$notify_sent = @mail($user_mail, $t->get_var("mail_subject"), $mail_body, $email_headers);
					if ($notify_sent) {
						$r->set_value("event_date", va_time());
						$r->set_value("event_name", "Email notification sent");
						$r->set_value("event_description", $t->get_var("mail_subject"));
						$r->insert_record();
					}
				}

				if ($sms_notify) {
					if (!$sms_recipient) { $sms_recipient = $order_info["cell_phone"]; }
					$t->set_block("sms_recipient", $sms_recipient);
					$t->set_block("sms_originator", $sms_originator);
					$t->set_block("sms_message", $sms_message);

					// set download links
					$t->set_var("links",    $links["text"]);
					// set serial numbers
					$t->set_var("serials", $order_serials["text"]);
					$t->set_var("serial_numbers", $order_serials["text"]);
					// set serial numbers
					$t->set_var("vouchers", $order_vouchers["text"]);
					$t->set_var("gift_vouchers", $order_vouchers["text"]);
		  
					$t->parse("sms_recipient", false);
					$t->parse("sms_originator", false);
					$t->parse("sms_message", false);

					if (sms_send_allowed($t->get_var("sms_recipient"))) {
						$sms_sent = sms_send($t->get_var("sms_recipient"), $t->get_var("sms_message"), $t->get_var("sms_originator"));
					}
					if ($sms_sent) {
						$event_description = $t->get_var("sms_message");
						$event_description = (strlen($event_description) > 50) ? substr($event_description, 0, 50) . "..." : $event_description;

						$r->set_value("event_date", va_time());
						$r->set_value("event_name", "SMS notification sent");
						$r->set_value("event_description", $event_description);
						$r->insert_record();
					}
				}
			}

			if ($other_statuses && sizeof($items_statuses) > 0) {
				$is_update = true;

				foreach ($items_statuses as $new_item_status => $items) {
					$items_ids = ""; $items_names = ""; $old_status_name = "";
					for($i = 0; $i < sizeof($items); $i++) {
						list($order_item_id, $item_name, $item_status_name) = $items[$i];
						if (strlen($items_ids)) {
							$items_ids .= ",";
						}
						$items_ids .= $order_item_id;
						$items_names .= "<br>" . $item_name;
						$old_status_name = $item_status_name;
					}

					// update items statuses
					$sql  = " UPDATE " . $table_prefix . "orders_items ";
					$sql .= " SET item_status=" . $db->tosql($new_item_status, INTEGER);
					$sql .= " WHERE order_item_id IN (" . $items_ids . ") ";
					$db->query($sql);

					$sql  = " SELECT status_name,download_activation FROM " . $table_prefix . "order_statuses ";
					$sql .= " WHERE status_id=" . $db->tosql($new_item_status, INTEGER);
					$db->query($sql);
					if ($db->next_record()) {
						$new_status_name = $db->f("status_name");
						$item_activation = $db->f("download_activation");
					}

					if($item_activation == 1) {
						$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=1 WHERE order_item_id IN (" . $items_ids . ") ";
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "orders_items_serials SET activated=1 WHERE order_item_id IN (" . $items_ids . ") ";
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "coupons SET is_active=1 WHERE order_item_id IN (" . $items_ids . ") ";
						$db->query($sql);
					} else if($item_activation == 0) {
						$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=0 WHERE order_item_id IN (" . $items_ids . ") ";
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "orders_items_serials SET activated=0 WHERE order_item_id IN (" . $items_ids . ") ";
						$db->query($sql);
						$sql = "UPDATE " . $table_prefix . "coupons SET is_active=0 WHERE order_item_id IN (" . $items_ids . ") ";
						$db->query($sql);
					}

					$r->set_value("status_id", $new_item_status);
					$r->set_value("order_items", $items_ids);
					$r->set_value("event_name", "Update status");
					$r->set_value("event_description", $old_status_name . " &ndash;&gt; " . $new_status_name . $items_names);
					$r->insert_record();
				}

			}

			// check product notification, commissions and subscriptions
			if ($order_items_ids || (!$other_statuses && $current_status_id != $status_id)) {
				$events = array();
				$commissions = array();
				$users_commissions = array();
				$parent_items = array();
				$subscriptions = array();

				$uc = new VA_Record($table_prefix . "users_commissions");
				$uc->add_textbox("payment_id", INTEGER);
				$uc->add_textbox("user_id", INTEGER);
				$uc->add_textbox("order_id", INTEGER);
				$uc->add_textbox("order_item_id", INTEGER);
				$uc->add_textbox("commission_amount", NUMBER);
				$uc->add_textbox("commission_action", INTEGER);
				$uc->add_textbox("commission_type", INTEGER);
				$uc->add_textbox("date_added", DATETIME);

				$uc->set_value("payment_id", 0);
				$uc->set_value("order_id", $order_id);
				$uc->set_value("date_added", va_time());

				$sql  = " SELECT oi.order_item_id, oi.parent_order_item_id, ";
				$sql .= " os.status_id, os.status_name, os.paid_status, os.item_notify, ";
				$sql .= " oi.item_name, oi.manufacturer_code, oi.price, oi.quantity, i.short_description, i.full_description, ";
				$sql .= " oi.item_user_id, oi.merchant_commission, oi.affiliate_commission, ";
				$sql .= " i.mail_notify, i.mail_to, i.mail_from, i.mail_subject, i.mail_cc, i.mail_bcc, i.mail_reply_to, i.mail_return_path, ";
				$sql .= " i.mail_type, i.mail_subject, i.mail_body, ";
				$sql .= " i.sms_notify, i.sms_recipient, i.sms_originator, i.sms_message, ";
				$sql .= " oi.user_id, oi.is_subscription, oi.subscription_period, oi.subscription_interval, oi.subscription_suspend ";
				$sql .= " FROM ((" . $table_prefix . "orders_items oi ";
				$sql .= " LEFT JOIN " . $table_prefix . "items i ON i.item_id=oi.item_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON os.status_id=oi.item_status) ";
				if ($other_statuses && $order_items_ids) {
					$sql .= " WHERE oi.order_item_id IN (" . $db->tosql($order_items_ids, TEXT, false) . ")" ;
				} else {
					$sql .= " WHERE oi.order_id=" . $db->tosql($order_id, INTEGER);
				}
				$db->query($sql); 
				while ($db->next_record()) {

					$order_item_id = $db->f("order_item_id");
					$parent_order_item_id = $db->f("parent_order_item_id");
					$new_status_id = $db->f("status_id");
					$new_item_paid = $db->f("paid_status");
					$item_user_id = $db->f("item_user_id");
					$item_name = $db->f("item_name");
					$manufacturer_code = $db->f("manufacturer_code");
					$price = $db->f("price");
					$merchant_commission = $db->f("merchant_commission");
					$affiliate_commission = $db->f("affiliate_commission");
					$quantity = $db->f("quantity");
					$short_description = $db->f("short_description");
					$full_description = $db->f("full_description");
					$item_notify = $db->f("item_notify");

					$user_id = $db->f("user_id");
					$is_subscription = $db->f("is_subscription");
					$subscription_period = $db->f("subscription_period");
					$subscription_interval = $db->f("subscription_interval");
					$subscription_suspend = $db->f("subscription_suspend");

					if ($is_subscription) {
						$old_item_paid = isset($items_paid[$order_item_id]) ? $items_paid[$order_item_id] : $current_paid_status;
						if (($old_item_paid || $new_item_paid) && $old_item_paid != $new_item_paid) {
							$subscriptions[] = array($user_id, $new_item_paid, $subscription_period, $subscription_interval, $subscription_suspend);
						}
					}

					if ($parent_order_item_id) {
						$old_item_paid = isset($items_paid[$order_item_id]) ? $items_paid[$order_item_id] : $current_paid_status;
						if (($old_item_paid || $new_item_paid) && $old_item_paid != $new_item_paid) {
							$parent_items[] = array($parent_order_item_id, $new_item_paid);
						}
					}
					
					if ($item_notify == 1) {
						$mail_notify = $db->f("mail_notify");
						$mail_to = $db->f("mail_to");
						if (!strlen($mail_to)) { $mail_to = $user_mail; }
						$mail_from = $db->f("mail_from");
						if (!strlen($mail_from)) { $mail_from = $settings["admin_email"]; }
						$mail_cc = $db->f("mail_cc");
						$mail_bcc = $db->f("mail_bcc");
						$mail_reply_to = $db->f("mail_reply_to");
						$mail_return_path = $db->f("mail_return_path");
						$mail_type = $db->f("mail_type");
						$mail_subject = $db->f("mail_subject");
						$mail_body = $db->f("mail_body");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
				  
						// sms settings
						$sms_notify = $db->f("sms_notify");
						$sms_recipient = $db->f("sms_recipient");
						$sms_originator = $db->f("sms_originator");
						$sms_message = $db->f("sms_message");
						
						$t->set_var("item_name", $item_name);
						$t->set_var("item_title", $item_name);
						$t->set_var("product_title", $item_name);
						$t->set_var("product_name", $item_name);
						$t->set_var("product_code", $manufacturer_code);
						$t->set_var("price", $price);
						$t->set_var("quantity", $quantity);
						$t->set_var("product_quantity", $quantity);
						$t->set_var("short_description", $short_description);
						$t->set_var("full_description", $full_description);
				  
						if ($mail_notify) {
							$t->set_block("mail_subject", $mail_subject);
							$t->set_block("mail_body", $mail_body);
				  
							// set download links
							if (!isset($links["html_" . $order_item_id])) {
								$t->set_var("links", "");
							} else if ($mail_type) {
								$t->set_var("links", $links["html_" . $order_item_id]);
							} else {
								$t->set_var("links", $links["text_" . $order_item_id]);
							}
							// set serial numbers
							if (!isset($order_serials["html_" . $order_item_id])) {
								$t->set_var("serials", "");
								$t->set_var("serial_numbers", "");
							} else if ($mail_type) {
								$t->set_var("serials", $order_serials["html_" . $order_item_id]);
								$t->set_var("serial_numbers", $order_serials["html_" . $order_item_id]);
							} else {
								$t->set_var("serials", $order_serials["text_" . $order_item_id]);
								$t->set_var("serial_numbers", $order_serials["text_" . $order_item_id]);
							}
							// set serial numbers
							if (!isset($order_vouchers["html_" . $order_item_id])) {
								$t->set_var("vouchers", "");
								$t->set_var("gift_vouchers", "");
							} else if ($mail_type) {
								$t->set_var("vouchers", $order_vouchers["html_" . $order_item_id]);
								$t->set_var("gift_vouchers", $order_vouchers["html_" . $order_item_id]);
							} else {
								$t->set_var("vouchers", $order_vouchers["text_" . $order_item_id]);
								$t->set_var("gift_vouchers", $order_vouchers["text_" . $order_item_id]);
							}
		        
							$t->parse("mail_subject", false);
							$t->parse("mail_body", false);
				  
							$mail_subject = $t->get_var("mail_subject");
							$mail_body = str_replace("\r", "", $t->get_var("mail_body"));
							$notify_sent = @mail($mail_to, $mail_subject, $mail_body, $email_headers);
							if ($notify_sent) {
								$event_name    = "Email notification sent";
								$event_description = $item_name . "<br>" . $mail_subject;
								$events[] = array($new_status_id, $order_item_id, va_time(), $event_name, $event_description);
							}
						}
						if ($sms_notify) {
							if (!$sms_recipient) { $sms_recipient = $order_info["cell_phone"]; }
							$t->set_block("sms_recipient", $sms_recipient);
							$t->set_block("sms_originator", $sms_originator);
							$t->set_block("sms_message", $sms_message);
				  
							// set download links
							if (!isset($links["html_" . $order_item_id])) {
								$t->set_var("links", "");
							} else {
								$t->set_var("links", $links["text_" . $order_item_id]);
							}
							// set serial numbers
							if (!isset($order_serials["html_" . $order_item_id])) {
								$t->set_var("serials", "");
								$t->set_var("serial_numbers", "");
							} else {
								$t->set_var("serials", $order_serials["text_" . $order_item_id]);
								$t->set_var("serial_numbers", $order_serials["text_" . $order_item_id]);
							}
							// set serial numbers
							if (!isset($order_vouchers["html_" . $order_item_id])) {
								$t->set_var("vouchers", "");
								$t->set_var("gift_vouchers", "");
							} else {
								$t->set_var("vouchers", $order_vouchers["text_" . $order_item_id]);
								$t->set_var("gift_vouchers", $order_vouchers["text_" . $order_item_id]);
							}
				  
							$t->parse("sms_recipient", false);
							$t->parse("sms_originator", false);
							$t->parse("sms_message", false);
				  
							$sms_message = $t->get_var("sms_message");
				  
							if (sms_send_allowed($t->get_var("sms_recipient"))) {
								$sms_sent = sms_send($t->get_var("sms_recipient"), $sms_message, $t->get_var("sms_originator"));
							}
							if ($sms_sent) {
								$event_name    = "SMS notification sent";
								$event_description = $item_name . "<br>" . $sms_message;
								$events[] = array($new_status_id, $order_item_id, va_time(), $event_name, $event_description);
							}
						}
					}

					// save commisions information
					if ($commission_action && ($affiliate_commission > 0 || $merchant_commission > 0)) {
						$commissions[] = array($order_item_id, $item_user_id, $quantity, $affiliate_commission, $merchant_commission);
					}
				}

				// update payment plan date for recurring items
				$current_date = va_time();
				$current_ts = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY], $current_date[YEAR]);
				for ($i = 0; $i < sizeof($parent_items); $i++) {
					list($parent_order_item_id, $new_item_paid) = $parent_items[$i];
					$sql  = " SELECT oi.is_recurring, oi.recurring_period, oi.recurring_interval, ";
					$sql .= " oi.recurring_payments_total, oi.recurring_payments_made, oi.recurring_payments_failed, ";
					$sql .= " oi.recurring_end_date, oi.recurring_last_payment, oi.recurring_next_payment, oi.recurring_plan_payment ";
					$sql .= " FROM " . $table_prefix . "orders_items oi ";
					$sql .= " WHERE oi.order_item_id=" . $db->tosql($parent_order_item_id, INTEGER);
					$db->query($sql);
					if ($db->next_record()) {
						$is_recurring = $db->f("is_recurring");
						$recurring_period = $db->f("recurring_period");
						$recurring_interval = $db->f("recurring_interval");
						$recurring_payments_total = $db->f("recurring_payments_total");
						$recurring_payments_made = $db->f("recurring_payments_made");
						$recurring_payments_failed = $db->f("recurring_payments_failed");
						$recurring_end_date = $db->f("recurring_end_date", DATETIME);
						$recurring_last_payment = $db->f("recurring_last_payment", DATETIME);
						$recurring_next_payment = $db->f("recurring_next_payment", DATETIME);
						$recurring_plan_payment = $db->f("recurring_plan_payment", DATETIME);

						if ($is_recurring) {
							if ($new_item_paid) {
								$recurring_payments_made++;
								$recurring_payments_failed = 0;
								$recurring_last_ts = $current_ts;
							} else {
								$recurring_payments_made--;
								$recurring_interval = -$recurring_interval;
								$recurring_last_ts = 0;
							}

							$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $recurring_plan_payment[DAY], $recurring_plan_payment[YEAR]);
						
							if ($recurring_period == 1) {
								$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $recurring_plan_payment[DAY] + $recurring_interval, $recurring_plan_payment[YEAR]);
							} elseif ($recurring_period == 2) {
								$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $current_date[DAY] + ($recurring_interval * 7), $recurring_plan_payment[YEAR]);
							} elseif ($recurring_period == 3) {
								$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH] + $recurring_interval, $recurring_plan_payment[DAY], $recurring_plan_payment[YEAR]);
							} else {
								$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $recurring_plan_payment[DAY], $recurring_plan_payment[YEAR] + $recurring_interval);
							}

							$recurring_end_ts = 0;
							if (is_array($recurring_end_date)) {
								$recurring_end_ts = mktime (0, 0, 0, $recurring_end_date[MONTH], $recurring_end_date[DAY], $recurring_end_date[YEAR]);
							}
							if (($recurring_payments_total && $recurring_payments_made >= $recurring_payments_total) 
								|| ($recurring_end_ts && $recurring_end_ts < $recurring_plan_ts)) {
								$is_recurring = 0;
							}
							$sql  = " UPDATE " . $table_prefix . "orders_items SET ";
							$sql .= " recurring_payments_failed=" . $db->tosql($recurring_payments_failed, INTEGER) . ", ";
							$sql .= " recurring_payments_made=" . $db->tosql($recurring_payments_made, INTEGER) . ", ";
							if ($recurring_last_ts) {
								$sql .= " recurring_last_payment=" . $db->tosql($recurring_last_ts, DATETIME) . ", ";
							}
							$sql .= " recurring_plan_payment=" . $db->tosql($recurring_plan_ts, DATETIME) . ", ";
							$sql .= " is_recurring=" . $db->tosql($is_recurring, INTEGER);
							$sql .= " WHERE order_item_id=" . $db->tosql($parent_order_item_id, INTEGER);
							$db->query($sql);
						}
					}
				}

				for ($i = 0; $i < sizeof($subscriptions); $i++) {
					list($user_id, $new_item_paid, $subscription_period, $subscription_interval, $subscription_suspend) = $subscriptions[$i];
					$sql  = " SELECT expiry_date FROM " . $table_prefix . "users ";
					$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
					$db->query($sql);
					if ($db->next_record()) {
						$current_date = va_time();
						$current_date_ts = mktime (0,0,0, $current_date[MONTH], $current_date[DAY], $current_date[YEAR]);
						$expiry_date = $db->f("expiry_date", DATETIME);
						$expiry_date_ts = $current_date_ts;
						if (is_array($expiry_date)) {
							$expiry_date_ts = mktime (0,0,0, $expiry_date[MONTH], $expiry_date[DAY], $expiry_date[YEAR]);
						}
						if ($expiry_date_ts < $current_date_ts) {
							$expiry_date_ts = $current_date_ts;
						}
						$new_expiry_date = va_time($expiry_date_ts);
						if (!$new_item_paid) {
							$subscription_interval = -$subscription_interval;
						}
						if ($subscription_period == 1) {
							$new_expiry_date_ts = mktime (0, 0, 0, $new_expiry_date[MONTH], $new_expiry_date[DAY] + $subscription_interval, $new_expiry_date[YEAR]);
						} elseif ($subscription_period == 2) {
							$new_expiry_date_ts = mktime (0, 0, 0, $new_expiry_date[MONTH], $new_expiry_date[DAY] + ($subscription_interval * 7), $new_expiry_date[YEAR]);
						} elseif ($subscription_period == 3) {
							$new_expiry_date_ts = mktime (0, 0, 0, $new_expiry_date[MONTH] + $subscription_interval, $new_expiry_date[DAY], $new_expiry_date[YEAR]);
						} else {
							$new_expiry_date_ts = mktime (0, 0, 0, $new_expiry_date[MONTH], $new_expiry_date[DAY], $new_expiry_date[YEAR] + $subscription_interval);
						}
						$new_suspend_date_ts = $new_expiry_date_ts + (intval($subscription_suspend) * 86400);
						$sql  = " UPDATE " . $table_prefix . "users SET ";
						$sql .= " expiry_date=" . $db->tosql($new_expiry_date_ts, DATETIME);
						$sql .= ", suspend_date=" . $db->tosql($new_suspend_date_ts, DATETIME);
						$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
						$db->query($sql);
					}
				}

				// add or subtract commisions
				for ($i = 0; $i < sizeof($commissions); $i++) {
					list($order_item_id, $item_user_id, $quantity, $affiliate_commission, $merchant_commission) = $commissions[$i];
					if ($merchant_commission > 0) {
						$users_commissions[$item_user_id] = true;
						$uc->set_value("user_id", $item_user_id);
						$uc->set_value("order_item_id", $order_item_id);
						$uc->set_value("commission_amount", ($merchant_commission * $quantity));
						$uc->set_value("commission_type", 1);

						$sql  = " SELECT SUM(commission_action) FROM " . $table_prefix . "users_commissions ";
						$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
						$sql .= " AND commission_type=1 ";
						$sum_commission = get_db_value($sql);
						if ($commission_action == 1 && $sum_commission != 1) { // add merchant commissions
							$uc->set_value("commission_action", 1);
							$uc->insert_record();
						} else if ($commission_action == -1 && $sum_commission == 1) { // subtract merchant commissions
							$uc->set_value("commission_action", -1);
							$uc->insert_record();
						}
					}
					if ($affiliate_commission > 0) {
						$users_commissions[$affiliate_user_id] = true;
						$uc->set_value("user_id", $affiliate_user_id);
						$uc->set_value("order_item_id", $order_item_id);
						$uc->set_value("commission_amount", ($affiliate_commission * $quantity));
						$uc->set_value("commission_type", 2);

						$sql  = " SELECT SUM(commission_action) FROM " . $table_prefix . "users_commissions ";
						$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
						$sql .= " AND commission_type=2 ";
						$sum_commission = get_db_value($sql);
						if ($commission_action == 1 && $sum_commission != 1) { // add affiliate commissions
							$uc->set_value("commission_action", 1);
							$uc->insert_record();
						} else if ($commission_action == -1 && $sum_commission == 1) { // subtract affiliate commissions
							$uc->set_value("commission_action", -1);
							$uc->insert_record();
						}
					}
				}

				// check if new user payment should be generated
				if (sizeof($users_commissions) > 0) {
					$min_payment_amount = get_setting_value($settings, "min_payment_amount", 100);
					foreach ($users_commissions as $user_id => $user_value) {
						$total_commissions = 0; $commissions_ids = ""; $commission_start = va_timestamp(); $commission_end = 0;
						$sql  = " SELECT commission_id, commission_action, commission_amount, date_added ";
						$sql .= " FROM " . $table_prefix . "users_commissions ";
						$sql .= " WHERE payment_id=0 AND user_id=" . $db->tosql($user_id, INTEGER);
						$db->query($sql);
						while ($db->next_record()) {
							$commission_id = $db->f("commission_id");
							$commission_action = $db->f("commission_action");
							$commission_amount = $db->f("commission_amount");
							$date_added = $db->f("date_added", DATETIME);
							$date_added_ts = mktime ($date_added[HOUR], $date_added[MINUTE], $date_added[SECOND], $date_added[MONTH], $date_added[DAY], $date_added[YEAR]);
							if ($date_added_ts > $commission_end) {
								$commission_end = $date_added_ts;
							}
							if ($date_added_ts < $commission_start) {
								$commission_start = $date_added_ts;
							}
							if ($commissions_ids) { $commissions_ids .= ","; }
							$commissions_ids .= $commission_id;
							$total_commissions += ($commission_action * $commission_amount);
						}
						if ($total_commissions >= $min_payment_amount) {
							$up = new VA_Record($table_prefix . "users_payments");
							if ($db_type == "postgre") {
								$payment_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "users_payments') ");
								$up->add_textbox("payment_id", INTEGER);
								$up->set_value("payment_id", $payment_id);
							}
							$up->add_textbox("user_id", INTEGER);
							$up->add_textbox("is_paid", INTEGER);
							$up->add_textbox("transaction_id", TEXT);
							$up->add_textbox("payment_total", NUMBER);
							$up->add_textbox("payment_name", TEXT);
							$up->add_textbox("payment_notes", TEXT);
							$up->add_textbox("date_added", DATETIME);
							$up->add_textbox("admin_id_added_by", INTEGER);
							$up->add_textbox("admin_id_modified_by", INTEGER);
							
							
							// generate payment name 
							$payment_name = va_date($datetime_show_format, $commission_start) . " - " . va_date($datetime_show_format, $commission_end);

							$up->set_value("user_id", $user_id);
							$up->set_value("is_paid", 0);
							$up->set_value("payment_total", $total_commissions);
							$up->set_value("payment_name", $payment_name);
							$up->set_value("payment_notes", "Auto-submitted payment");
							$up->set_value("date_added", va_time());
							$up->set_value("admin_id_added_by", 0);
							$up->set_value("admin_id_modified_by", 0);
							$up->insert_record();
							if ($db_type == "mysql") {
								$payment_id = get_db_value(" SELECT LAST_INSERT_ID() ");
							} else if ($db_type == "access") {
								$payment_id = get_db_value(" SELECT @@IDENTITY ");
							}

							$sql  = " UPDATE " . $table_prefix . "users_commissions ";
							$sql .= " SET payment_id=" . $db->tosql($payment_id, INTEGER);
							$sql .= " WHERE payment_id=0 AND user_id=" . $db->tosql($user_id, INTEGER);
							$sql .= " AND commission_id IN (" . $commissions_ids . ")";
							$db->query($sql);

							// check and update total amount for generated payment if it was change
							$sql  = " SELECT SUM(commission_action * commission_amount) ";
							$sql .= " FROM " . $table_prefix . "users_commissions ";
							$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
							$payment_total = get_db_value($sql);
							if ($payment_total != $total_commissions) {
								$sql  = " UPDATE " . $table_prefix . "users_payments ";
								$sql .= " SET payment_total=" . $db->tosql($payment_total, NUMBER);
								$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
								$db->query($sql);
							}
						}
					}
				}

				// save events
				for ($i = 0; $i < sizeof($events); $i++) {
					list($new_status_id, $order_item_id, $event_date, $event_name, $event_description) = $events[$i];
					$r->set_value("status_id",   $new_status_id);
					$r->set_value("order_items", $order_item_id);
					$r->set_value("event_date",  va_time());
					$r->set_value("event_name",  $event_name);
					$r->set_value("event_description", $event_description);
					$r->insert_record();
				}

			}

		}

		return $is_update;
	}

	function update_order_shipping($order_id, $shipping_type_id)
	{
		global $db, $table_prefix;

		$sql  = " SELECT shipping_type_id, shipping_type_desc, country_code, delivery_country_code, ";
		$sql .= " weight_total, total_quantity, goods_total, goods_taxable, properties_total, properties_taxable, ";
		$sql .= " total_discount, tax_percent, processing_fee ";
		$sql .= " FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$current_shipping_id = $db->f("shipping_type_id");
			$current_shipping_type = $db->f("shipping_type_desc");
			$weight_total = $db->f("weight_total");
			$total_quantity = $db->f("total_quantity");
			$goods_total = $db->f("goods_total");
			$goods_taxable = $db->f("goods_taxable");
			$properties_total = $db->f("properties_total");
			$properties_taxable = $db->f("properties_taxable");
			$total_discount = $db->f("total_discount");
			$processing_fee = $db->f("processing_fee");
			$goods_with_discount = $goods_total - $total_discount;
			if ($total_discount > 0) {
				$goods_taxable = $goods_taxable - round(($goods_taxable * $total_discount) / $goods_total, 2);
			}
			
			$tax_percent = $db->f("tax_percent");
			$free_postage = false;
			$country_code = $db->f("delivery_country_code");
			if(!strlen($country_code)) {
				$country_code = $db->f("country_code");
			}
		} else {
			$shipping_type_id = "";
		}
		if (strlen($shipping_type_id) && $shipping_type_id != $current_shipping_id) {
			if (strlen($current_shipping_id)) {
				$sql  = " SELECT tare_weight FROM " . $table_prefix . "shipping_types ";
				$sql .= " WHERE shipping_type_id=" . $db->tosql($current_shipping_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$tare_weight = $db->f("tare_weight");
					if ($tare_weight > 0) {
						$weight_total = $weight_total - $tare_weight;
						$sql  = " UPDATE " . $table_prefix ."orders SET weight_total=weight_total-" . $db->tosql($tare_weight, NUMBER);
						$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
						$db->query($sql);
					}
				} else {
					$shipping_type_id = "";
				}
			}
			if (strlen($shipping_type_id)) {
				$sql  = " SELECT st.shipping_type_id, st.shipping_type_desc, st.cost_per_order, ";
				$sql .= " st.cost_per_product, st.cost_per_weight, st.tare_weight, st.is_taxable ";
				$sql .= " FROM " . $table_prefix . "shipping_types st, " . $table_prefix . "shipping_types_countries stc ";
				$sql .= " WHERE st.shipping_type_id=stc.shipping_type_id ";
				$sql .= " AND stc.country_code=" . $db->tosql($country_code, TEXT);
				$sql .= " AND st.min_weight<=" . $db->tosql($weight_total, NUMBER);
				$sql .= " AND st.max_weight>=" . $db->tosql($weight_total, NUMBER);
				$sql .= " AND st.min_goods_cost<=" . $db->tosql($goods_total, NUMBER);
				$sql .= " AND st.max_goods_cost>=" . $db->tosql($goods_total, NUMBER);
				$sql .= " AND st.shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$shipping_type_desc = $db->f("shipping_type_desc");
					$cost_per_order = $db->f("cost_per_order");
					$cost_per_product = $db->f("cost_per_product");
					$cost_per_weight = $db->f("cost_per_weight");
					$tare_weight = $db->f("tare_weight");
					if (!strlen($tare_weight)) $tare_weight = 0;
					$shipping_taxable = $db->f("is_taxable");
					$shipping_cost = $free_postage ? 0 : $cost_per_order + ($cost_per_product * $total_quantity) + ($cost_per_weight * ($weight_total + $tare_weight));
					$shipping_cost = round($shipping_cost, 2);
					$taxable_amount = ($shipping_taxable == 1) ? (round($goods_taxable, 2) + round($properties_taxable, 2) + round($shipping_cost, 2)) : (round($goods_taxable, 2) + round($properties_taxable, 2));
					$tax_cost = ($taxable_amount * $tax_percent) / 100;
					$tax_cost = round($tax_cost, 2);
					$order_total = $goods_with_discount + $properties_total + round($shipping_cost, 2) + $tax_cost + $processing_fee;

					$sql  = " UPDATE " . $table_prefix . "orders SET ";
					$sql .= " weight_total=weight_total+" . $db->tosql($tare_weight, NUMBER) . ", ";
					$sql .= " shipping_type_id=" . $db->tosql($shipping_type_id, INTEGER) . ", ";
					$sql .= " shipping_type_desc=" . $db->tosql($shipping_type_desc, TEXT) . ", ";
					$sql .= " shipping_cost=" . $db->tosql($shipping_cost, NUMBER) . ", ";
					$sql .= " shipping_taxable=" . $db->tosql($shipping_taxable, INTEGER) . ", ";
					$sql .= " tax_total=" . $db->tosql($tax_cost, NUMBER) . ", ";
					$sql .= " order_total=" . $db->tosql($order_total, NUMBER) . " ";
					$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
					$db->query($sql);

					// save event with updated shipping 
					$r = new VA_Record($table_prefix . "orders_events");
					$r->add_textbox("order_id", INTEGER);
					$r->add_textbox("status_id", INTEGER);
					$r->add_textbox("admin_id", INTEGER);
					$r->add_textbox("event_date", DATETIME);
					$r->add_textbox("event_name", TEXT);
					$r->add_textbox("event_description", TEXT);
					$r->set_value("order_id", $order_id);
					$r->set_value("status_id", 0);
					$r->set_value("admin_id", get_session("session_admin_id"));
					$r->set_value("event_date", va_time());
					$r->set_value("event_name", "Update shipping");
					$r->set_value("event_description", $current_shipping_type . " &ndash;&gt; " . $shipping_type_desc);
					$r->insert_record();

					
				}
			}

			
		} else {
			$shipping_type_id = "";
		}

		return $shipping_type_id;
	}

	function update_order_items($order_id)
	{
		global $db, $table_prefix;

		$sql  = " SELECT o.shipping_cost, o.shipping_taxable, st.tare_weight, o.properties_total, o.properties_taxable, ";
		$sql .= " o.total_discount, o.total_discount_tax, o.tax_percent, o.processing_fee ";
		$sql .= " FROM (" . $table_prefix . "orders o ";
		$sql .= " LEFT JOIN " . $table_prefix . "shipping_types st ON st.shipping_type_id=o.shipping_type_id) ";
		$sql .= " WHERE o.order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			
			$shipping_cost = $db->f("shipping_cost");
			$shipping_taxable = $db->f("shipping_taxable");
			$tare_weight = $db->f("tare_weight");

			$properties_total = $db->f("properties_total");
			$properties_taxable = $db->f("properties_taxable");
			$total_discount = $db->f("total_discount");
			$total_discount_tax = $db->f("total_discount_tax");
			$goods_taxable = $db->f("goods_taxable");
			$tax_percent = $db->f("tax_percent");
			$processing_fee = $db->f("processing_fee");
		} else {
			return false;
		}

		$total_buying = 0; $goods_total = 0; $goods_tax_total = 0; $goods_taxable = 0; $total_quantity = 0;
		$weight_total = 0; $tax_total = 0; $order_total = 0;
		$sql  = " SELECT * FROM " . $table_prefix . "orders_items ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		while ($db->next_record()) {
			$weight = $db->f("weight");
			$buying_price = $db->f("buying_price");
			$price = $db->f("price");
			$quantity = $db->f("quantity");
			$tax_free = $db->f("tax_free");
			$item_tax_percent = $db->f("tax_percent");

			$total_quantity += $quantity;
			$weight_total += ($weight * $quantity);
			$total_buying += ($buying_price * $quantity);
			$item_total = $price * $quantity;
			$goods_total += $item_total;
			if ($tax_free != 1) {
				if (!strlen($item_tax_percent)) { $item_tax_percent = $tax_percent; }
				$tax_amount = round(($item_total * $item_tax_percent) / 100, 2);
				$goods_tax_total += $tax_amount;
				$goods_taxable += ($price * $quantity);
			}
		}
		$weight_total += $tare_weight;
		if (!$total_discount_tax && $goods_tax_total > 0) {
			$total_discount_tax = round(($total_discount * $goods_tax_total) / $goods_total, 2);
		}
		if ($total_discount > 0) {
			$goods_taxable = $goods_taxable - round(($goods_taxable * $total_discount) / $goods_total, 2);
		}

		$shipping_taxable_amount = 0;
		if ($shipping_taxable) {
			$shipping_taxable_amount += round($shipping_cost, 2);
		}
		$tax_total = $goods_tax_total - $total_discount_tax + round((($properties_taxable + $shipping_taxable_amount) * $tax_percent) / 100, 2);
		$order_total = round($goods_total, 2) - round($total_discount, 2) + round($properties_total, 2) + round($shipping_cost, 2) + $tax_total + $processing_fee;

		$sql  = " UPDATE " . $table_prefix . "orders SET ";
		$sql .= " total_buying=" . $db->tosql($total_buying, FLOAT) . ", ";
		$sql .= " goods_total=" . $db->tosql($goods_total, FLOAT) . ", ";
		$sql .= " goods_taxable=" . $db->tosql($goods_taxable, FLOAT) . ", ";
		$sql .= " total_quantity=" . $db->tosql($total_quantity, FLOAT) . ", ";
		$sql .= " weight_total=" . $db->tosql($weight_total, FLOAT) . ", ";
		$sql .= " tax_total=" . $db->tosql($tax_total, FLOAT) . ", ";
		$sql .= " order_total=" . $db->tosql($order_total, FLOAT);
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);

	}

	function remove_orders($orders_ids, $delete_orders = true) 
	{
		global $db, $table_prefix;

		$downloads_ids = "";
		$sql = "SELECT download_id FROM " . $table_prefix . "items_downloads WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")";
		$db->query($sql);
		while ($db->next_record()) {
			if(strlen($downloads_ids)) { $downloads_ids .= ","; }
			$downloads_ids .= $db->f("download_id");
		}
		$items = array();
		$sql = "SELECT item_id, quantity FROM " . $table_prefix . "orders_items WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")";
		$db->query($sql);
		while ($db->next_record()) {
			$item_id  = $db->f("item_id");
			$quantity = $db->f("quantity");
			if (isset($items[$item_id])) {
				$items[$item_id] += $quantity;
			} else {
				$items[$item_id] = $quantity;
			}
		}
		$serials = array();
		$sql  = " SELECT ois.item_id, ois.serial_number ";
		$sql .= " FROM " . $table_prefix . "orders_items_serials ois, " . $table_prefix . "items i ";
		$sql .= " WHERE ois.item_id=i.item_id ";
		$sql .= " AND i.generate_serial=2 ";
		$sql .= " AND ois.order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")";
		$sql .= " GROUP BY ois.item_id, ois.serial_number ";
		$db->query($sql);
		while ($db->next_record()) {
			$item_id  = $db->f("item_id");
			$serial_number = $db->f("serial_number");
			if (isset($serials[$item_id])) {
				$serials[$item_id] .= "," . $db->tosql($serial_number, TEXT);
			} else {
				$serials[$item_id] = $db->tosql($serial_number, TEXT);
			}
		}
		$options_values_ids = array();
		$sql  = " SELECT oip.property_values_ids, oi.quantity FROM " . $table_prefix . "orders_items_properties oip, ";
		$sql .= $table_prefix . "orders_items oi ";
		$sql .= " WHERE oip.order_item_id=oi.order_item_id ";
		$sql .= " AND oip.order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")";
		$db->query($sql);
		while ($db->next_record()) {
			$property_values_ids = $db->f("property_values_ids");
			$quantity = $db->f("quantity");
			if ($property_values_ids) {
				$values_ids = explode(",", $property_values_ids);
				for ($v = 0; $v < sizeof($values_ids); $v++) {
					$value_id = $values_ids[$v];
					if (isset($options_values_ids[$value_id])) {
						$options_values_ids[$value_id] += $quantity;
					} else {
						$options_values_ids[$value_id] = $quantity;
					}
				}
			}
		}

		if ($delete_orders) {
			$db->query("DELETE FROM " . $table_prefix . "orders WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		}
		$db->query("DELETE FROM " . $table_prefix . "orders_properties WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "orders_items WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "orders_items_properties WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "users_commissions WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ") AND payment_id=0");
		foreach ($items as $item_id => $quantity) {
			$sql  = " UPDATE " . $table_prefix . "items SET ";	
			$sql .= " stock_level=stock_level+" . $db->tosql($quantity, INTEGER);
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
			$sql .= " AND use_stock_level=1 ";
			$db->query($sql);
		}
		foreach ($serials as $item_id => $serial_numbers) {
			$sql  = " UPDATE " . $table_prefix . "items_serials SET ";	
			$sql .= " used=0 ";
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
			$sql .= " AND serial_number IN (" . $serial_numbers . ") ";
			$db->query($sql);
		}
		foreach ($options_values_ids as $value_id => $quantity) {
			$sql  = " UPDATE " . $table_prefix . "items_properties_values SET ";	
			$sql .= " stock_level=stock_level+" . $db->tosql($quantity, INTEGER);
			$sql .= " WHERE item_property_id=" . $db->tosql($value_id, INTEGER);
			$sql .= " AND use_stock_level=1 ";
			$db->query($sql);
		}
		$db->query("DELETE FROM " . $table_prefix . "orders_events WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "orders_notes WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "orders_items_serials WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "orders_serials_activations WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		$db->query("DELETE FROM " . $table_prefix . "coupons WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
		if (strlen($downloads_ids)) {
			$db->query("DELETE FROM " . $table_prefix . "items_downloads WHERE order_id IN (" . $db->tosql($orders_ids, TEXT, false) . ")");
			$db->query("DELETE FROM " . $table_prefix . "items_downloads_statistic WHERE download_id IN (" . $db->tosql($downloads_ids, TEXT, false) . ")");
		}
	}

	function get_payment_rate($payment_id, $currency_rate)
	{
		global $db, $table_prefix;
		$payment_rate = 1;
		$sql  = " SELECT parameter_type,parameter_source FROM " . $table_prefix . "payment_parameters ";
		$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
		$sql .= " AND parameter_name IN ('currency_code', 'x_currency_code', 'currency', 'currencycode') ";
		$sql .= " AND not_passed<>1 ";
		$db->query($sql);
		if ($db->next_record()) {
			$parameter_type = $db->f("parameter_type");
			$parameter_source = $db->f("parameter_source");
			if (strtoupper($parameter_type) == "VARIABLE") {
				if ($parameter_source == "currency_code" || $parameter_source == "{currency_code}"
					|| $parameter_source == "currency_value" || $parameter_source == "{currency_value}") {
					$payment_rate = $currency_rate;
				}
			} else {
				$sql  = " SELECT exchange_rate FROM " . $table_prefix . "currencies ";
				$sql .= " WHERE currency_code=" . $db->tosql($parameter_source, TEXT);
				$sql .= " OR currency_value=" . $db->tosql($parameter_source, TEXT);
				$db->query($sql);
				if ($db->next_record()) {
  				$payment_rate = $db->f("exchange_rate");	
				}
			}
		}
		return $payment_rate;		
	}

	function generate_serial($order_item_id, $sn, $product_info, $generation_type = 1)
	{
		global $db, $table_prefix;

		$serial_number = "";
		if ($generation_type == 1) {
			// random generation
			while ($serial_number == "") 
			{
				$random_value  = mt_rand();
				$serial_hash   = strtoupper(md5($order_item_id . $sn . $random_value . va_timestamp()));
				$serial_number = substr($serial_hash,0,4)."-".substr($serial_hash,4,4)."-".substr($serial_hash,8,4)."-".substr($serial_hash,12,4);
				$sql = " SELECT serial_id FROM " .$table_prefix. "orders_items_serials WHERE serial_number=" . $db->tosql($serial_number, TEXT);
				$db->query($sql);
				if ($db->next_record()) {
					$serial_number = "";
				}
			}
		} else if ($generation_type == 2) {
			// get from predefined list
			$item_id = $product_info["item_id"];
			$sql  = " SELECT serial_id, serial_number FROM " . $table_prefix . "items_serials ";
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
			$sql .= " AND (used=0 OR used IS NULL) ";
			$db->RecordsPerPage = 1;
			$db->PageNumber = 1;
			$db->query($sql);
			if ($db->next_record()) {
				$serial_id = $db->f("serial_id");
				$serial_number = $db->f("serial_number");
				$sql  = " UPDATE " . $table_prefix . "items_serials SET used=1 ";
				$sql .= " WHERE serial_id=" . $db->tosql($serial_id, INTEGER);
				$db->query($sql);
			}
		}
		
		return $serial_number;
	}
	
	function generate_gift_voucher($order_id, $order_item_id, $voucher_name, $voucher_price)
	{
		global $db, $table_prefix;
		
		$voucher_code = "";
		while ($voucher_code == "") 
		{
			$random_value = mt_rand();
			$voucher_hash = strtoupper(md5($order_id . $order_item_id . $voucher_price . $random_value . va_timestamp()));
			$voucher_code = substr($voucher_hash, 0, 8);
			$sql = " SELECT coupon_id FROM " .$table_prefix. "coupons WHERE coupon_code=" . $db->tosql($voucher_code, TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$voucher_code = "";
			}
		}

		$vr = new VA_Record($table_prefix . "coupons");
		$vr->add_textbox("order_id", INTEGER);
		$vr->add_textbox("order_item_id", INTEGER);
		$vr->add_textbox("coupon_code", TEXT);
		$vr->add_textbox("coupon_title", TEXT);
		$vr->add_textbox("is_active", INTEGER);
		$vr->add_textbox("discount_type", INTEGER);
		$vr->add_textbox("discount_amount", NUMBER);
		$vr->add_textbox("quantity_limit", INTEGER);
		$vr->add_textbox("coupon_uses", INTEGER);

		$vr->set_value("order_id", $order_id);
		$vr->set_value("order_item_id", $order_item_id);
		$vr->set_value("coupon_code", $voucher_code);
		$vr->set_value("coupon_title", $voucher_name);
		$vr->set_value("is_active", 0);
		$vr->set_value("discount_type", 5);
		$vr->set_value("discount_amount", $voucher_price);
		$vr->set_value("quantity_limit", 0);
		$vr->set_value("coupon_uses", 0);

		$vr->insert_record();

		return $voucher_code;
	}

	// calculate fingerprint for Authorize.net
	function calculate_fp ($login_id, $trankey, $amount, $sequence, $timestamp, $currency = "") 
	{
  	return (hmac_md5 ($login_id."^".$sequence."^".$timestamp."^".$amount."^".$currency, $trankey));
	}


	function get_final_message($message, $message_type)
	{
		$message = preg_replace("/\[" . $message_type . "\]/si", "", $message);
		$message = preg_replace("/\[\/" . $message_type . "\]/si", "", $message);
		$message = preg_replace("/\[success].*\[\/success]/s", "", $message);
		$message = preg_replace("/\[pending].*\[\/pending]/s", "", $message);
		$message = preg_replace("/\[failure].*\[\/failure]/s", "", $message);

		return $message;
	}

	function clean_cc_number($cc_number)
	{
		return ereg_replace ("[^0-9]+", "", $cc_number); 
	}

	function format_cc_number($cc_number, $delimiter = "-", $hide_first = false)
	{
		$cc_formatted = "";
		$total_digit = strlen($cc_number);
		if ($total_digit) {
			for ($i = 0; $i < $total_digit; $i++) {
				if ($i && $i % 4 == 0) {
					$cc_formatted .= $delimiter;
				}
				if ($hide_first && ($i + 4) < $total_digit) {
					$cc_formatted .= "*";
				} else {
					$cc_formatted .= $cc_number[$i];
				}
			}
		}
		return $cc_formatted;
	}

	function check_cc_number($cc_number) 
	{ 
		$cc_number = strrev (clean_cc_number($cc_number)); 

		$digits = ""; $sum = 0;
		// Loop through the number one digit at a time 
		// Double the value of every second digit (starting from the right) 
		// Concatenate the new values with the unaffected digits 
		for ($i = 0; $i < strlen ($cc_number); ++$i) {
			$digits .= ($i % 2) ? $cc_number[$i] * 2 : $cc_number[$i]; 
		}
     
		// Add all of the single digits together 
		for ($i = 0; $i < strlen ($digits); ++$i) {
			$sum += $digits[$i]; 
		}

		// Valid card numbers will be transformed into a multiple of 10 
		return ($sum % 10) ? false : true; 
	} 

	function get_expecting_date($handle_hours)
	{
		$expecting_date = va_timestamp();
		// add one day if today is Sunday
		if (date("w", $expecting_date) == 0) {
			$expecting_date += 86400;
		}
		while ($handle_hours > 0) {
			if ($handle_hours < 24) {
				$expecting_date += $handle_hours * 3600;
			} else {
				$expecting_date += 86400;
			}
			$handle_hours -= 24;
			if (date("w", $expecting_date) == 0) {
				$expecting_date += 86400;
			}
		}

		return $expecting_date;
	}

	function get_commission($item_user_id, $affiliate_user_id, $price, $options_price, $buying_price, $item_commision_type, $item_commision_amount)
	{
		global $db, $table_prefix, $settings;
		$item_commissions = 0;
		if ($item_user_id || $affiliate_user_id) {
			$commission_type = ""; $commission_amount = 0;
			if (strlen($item_commision_type)) {
				$commission_type = $item_commision_type;
				$commission_amount = $item_commision_amount;
			} else {
				if ($item_user_id) {
					$sql  = " SELECT u.merchant_fee_type AS user_commision_type, u.merchant_fee_amount AS user_commision_amount, ";
					$sql .= " ut.merchant_fee_type AS type_commision_type, ut.merchant_fee_amount AS type_commision_amount ";
				} else {
					$sql  = " SELECT u.affiliate_commission_type AS user_commision_type, u.affiliate_commission_amount AS user_commision_amount, ";
					$sql .= " ut.affiliate_commission_type AS type_commision_type, ut.affiliate_commission_amount AS type_commision_amount ";
				}
				$sql .= " FROM (" . $table_prefix . "users u ";
				$sql .= " LEFT JOIN " . $table_prefix . "user_types ut ON u.user_type_id=ut.type_id) ";
				if ($item_user_id) {
					$sql .= " WHERE u.user_id=" . $db->tosql($item_user_id, INTEGER);
				} else {
					$sql .= " WHERE u.user_id=" . $db->tosql($affiliate_user_id, INTEGER);
				}
				$db->query($sql);
				if ($db->next_record()) {
					$user_commision_type = $db->f("user_commision_type");
					$user_commision_amount = $db->f("user_commision_amount");
					$type_commision_type = $db->f("type_commision_type");
					$type_commision_amount = $db->f("type_commision_amount");
					if (strlen($user_commision_type)) {
						$commission_type = $user_commision_type;
						$commission_amount = $user_commision_amount;
					} else if (strlen($type_commision_type)) {
						$commission_type = $type_commision_type;
						$commission_amount = $type_commision_amount;
					} else { // check global products commissions
						if ($item_user_id) {
							$commission_type = get_setting_value($settings, "merchant_fee_type", "");
							$commission_amount = get_setting_value($settings, "merchant_fee_amount", 0);
						} else {
							$commission_type = get_setting_value($settings, "affiliate_commission_type", "");
							$commission_amount = get_setting_value($settings, "affiliate_commission_amount", 0);
						}
					}
				}
			}
			if ($commission_type == 1) { // percentage to the whole price
				$item_commissions = round((($price + $options_price) * $commission_amount) / 100, 2);
			} else if ($commission_type == 2) { // fixed amount
				$item_commissions = $commission_amount;
			} else if ($commission_type == 3) { // percentage to the product price
				$item_commissions = round(($price * $commission_amount) / 100, 2);
			} else if ($commission_type == 3) { // percentage to the margin price
				$item_commissions = round((($price + $options_price - $buying_price) * $commission_amount) / 100, 2);
			}
			if ($item_commissions < 0) { $item_commissions = 0; }
		}
		if ($item_user_id) {
			// for merchant subtract fees to get commision
			$item_commissions = $price + $options_price - $item_commissions;
		}
		return $item_commissions;
	}

	function get_merchant_commission($item_user_id, $price, $options_price, $buying_price, $item_commision_type, $item_commision_amount)
	{
		return get_commission($item_user_id, "", $price, $options_price, $buying_price, $item_commision_type, $item_commision_amount);
	}

	function get_affiliate_commission($affiliate_user_id, $price, $options_price, $buying_price, $item_commision_type, $item_commision_amount)
	{
		return get_commission("", $affiliate_user_id, $price, $options_price, $buying_price, $item_commision_type, $item_commision_amount);
	}

	function get_payment_parameters($order_id, &$payment_parameters, &$pass_parameters, &$post_parameters, &$pass_data)
	{
		global $db, $table_prefix;
		global $parameters, $cc_parameters;
		global $datetime_show_format, $cart_items, $total_items;

		// get orders variables
		$cart_items = array(); $total_items = 0;
		$items_text = show_order_items($order_id, false);

		$variables = array();
		$variables["charset"] = CHARSET;
		$variables["order_id"] = $order_id;
		$variables["items"] = $items_text;
		$variables["basket"] = $items_text;
		$variables["description"] = $items_text;
		$variables["remote_address"] = get_ip();

		$sql = "SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$variables["user_ip"] = $db->f("remote_address");
			$variables["order_ip"] = $db->f("remote_address");
			$variables["initial_ip"] = $db->f("initial_ip");
			$variables["cookie_ip"] = $db->f("cookie_ip");

			for($i = 0; $i < sizeof($parameters); $i++) {
				$variables[$parameters[$i]] = $db->f($parameters[$i]);
				$variables["delivery_" . $parameters[$i]] = $db->f("delivery_" . $parameters[$i]);
			}
			for($i = 0; $i < sizeof($cc_parameters); $i++) {
				$variables[$cc_parameters[$i]] = $db->f($cc_parameters[$i]);
			}
			if (strlen($variables["cc_name"]) && !strlen($variables["cc_first_name"]) && !strlen($variables["cc_last_name"])) {
				$cc_name = $variables["cc_name"];
				$name_parts = explode(" ", $cc_name, 2);
				if (sizeof($name_parts) == 2) {
					$variables["cc_first_name"] = $name_parts[0];
					$variables["cc_last_name"] = $name_parts[1];
				} else {
					$variables["cc_first_name"] = $name_parts[0];
					$variables["cc_last_name"] = "";
				}
			} else if (!strlen($variables["cc_name"]) && (strlen($variables["cc_first_name"]) || strlen($variables["cc_last_name"]))) {
				$variables["cc_name"] = trim($variables["cc_first_name"] . " " . $variables["cc_last_name"]);
			}
			$address = $variables["address2"] ? ($variables["address1"] . " " . $variables["address2"]) : $variables["address1"];
			$delivery_address = $variables["delivery_address2"] ? ($variables["delivery_address1"] . " " . $variables["delivery_address2"]) : $variables["delivery_address1"];
			$address_number = (preg_match("/\d+/", $address, $match)) ? $match[0] : ""; 
			$delivery_address_number = (preg_match("/\d+/", $delivery_address, $match)) ? $match[0] : ""; 
			$variables["address"] = $address;
			$variables["address_number"] = $address_number;
			$variables["delivery_address"] = $delivery_address;
			$variables["delivery_address_number"] = $delivery_address_number;
	  
			$order_placed_date = $db->f("order_placed_date", DATETIME);
			$cc_start_date = $db->f("cc_start_date", DATETIME);
			$cc_expiry_date = $db->f("cc_expiry_date", DATETIME);

			$timestamp = mktime ($order_placed_date[HOUR], $order_placed_date[MINUTE], $order_placed_date[SECOND], $order_placed_date[MONTH], $order_placed_date[DAY], $order_placed_date[YEAR]);
			$vc = md5($order_id . $order_placed_date[HOUR].$order_placed_date[MINUTE].$order_placed_date[SECOND]);

			$payment_id = $db->f("payment_id");
			$user_id = $db->f("user_id");
			$affiliate_code = $db->f("affiliate_code");
			$order_currency_code = $db->f("currency_code");
			$order_currency_rate = $db->f("currency_rate");
			$goods_total = $db->f("goods_total");
			$total_discount = $db->f("total_discount");
			$properties_total = $db->f("properties_total");
			$properties_taxable = $db->f("properties_taxable");
			$shipping_cost = $db->f("shipping_cost");
			$shipping_taxable = $db->f("shipping_taxable");
			$total_quantity = $db->f("total_quantity");
			$weight_total = $db->f("weight_total");
			$total_discount = $db->f("total_discount");
			$tax_name = $db->f("tax_name");
			$tax_percent = $db->f("tax_percent");
			$tax_cost = $db->f("tax_total");
			$processing_fee = $db->f("processing_fee");
			$order_total = $db->f("order_total");

			// get payment rate for the selected gateway
			$payment_rate = get_payment_rate($payment_id, $order_currency_rate);
	  
			// get numeric code
			$order_currency = get_currency($order_currency_code);
			$order_currency_value = $order_currency["value"];

			$variables["vc"] = $vc;
			$variables["timestamp"] = $timestamp;
			$variables["order_placed_timestamp"] = $timestamp;
			$variables["order_placed_date"] = va_date($datetime_show_format, $order_placed_date);
			$variables["cc_start_date"] = ""; $variables["cc_start_date_short"] = "";
			$variables["cc_start_year"] = ""; $variables["cc_start_yyyy"] = ""; $variables["cc_start_month"] = "";
			if (is_array($cc_start_date)) {
				$variables["cc_start_date"] = va_date(array("MM"," / ","YYYY"), $cc_start_date);
				$variables["cc_start_date_short"] = va_date(array("MM"," / ","YY"), $cc_start_date);
				$variables["cc_start_year"] = va_date(array("YY"), $cc_start_date);
				$variables["cc_start_yyyy"] = va_date(array("YYYY"), $cc_start_date);
				$variables["cc_start_month"] = va_date(array("MM"), $cc_start_date);
			}
			$variables["cc_expiry_date"] = ""; $variables["cc_expiry_date_short"] = "";
			$variables["cc_expiry_year"] = ""; $variables["cc_expiry_yyyy"] = ""; $variables["cc_expiry_month"] = "";
			if (is_array($cc_expiry_date)) {
				$variables["cc_expiry_date"] = va_date(array("MM"," / ","YYYY"), $cc_expiry_date);
				$variables["cc_expiry_date_short"] = va_date(array("MM"," / ","YY"), $cc_expiry_date);
				$variables["cc_expiry_year"] = va_date(array("YY"), $cc_expiry_date);
				$variables["cc_expiry_yyyy"] = va_date(array("YYYY"), $cc_expiry_date);
				$variables["cc_expiry_month"] = va_date(array("MM"), $cc_expiry_date);
			}
	  
			$variables["user_id"] = $user_id;
			$variables["affiliate_code"] = $affiliate_code;
			$variables["currency_code"] = $order_currency_code;
			$variables["currency_value"] = $order_currency_value;
			$variables["currency_rate"] = $order_currency_rate;
			$variables["goods_total"] = round($goods_total * $payment_rate, 2);
			$variables["total_discount"] = round($total_discount * $payment_rate, 2);
			$goods_with_discount = $goods_total - $total_discount;
			$variables["goods_with_discount"] = round($goods_with_discount * $payment_rate, 2);
			$variables["total_quantity"] = $total_quantity;
			$variables["total_items"] = $total_items;
			$variables["weight_total"] = $weight_total;
			$variables["total_weight"] = $weight_total;
			$variables["properties_total"] = number_format($properties_total * $payment_rate, 2, ".", "");
			$variables["properties_taxable"] = $properties_taxable;
			$variables["shipping_cost"] = round($shipping_cost * $payment_rate, 2);
			$variables["shipping_taxable"] = $shipping_taxable;
			$variables["total_discount"] = $total_discount;
			$variables["tax_name"] = $tax_name;
			$variables["tax_percent"] = $tax_percent;
			$variables["tax_cost"] = $tax_cost;
			$variables["processing_fee"] = number_format($processing_fee * $payment_rate, 2, ".", "");
			$variables["order_total"] = number_format($order_total * $payment_rate, 2, ".", "");
			$variables["order_total_100"] = round($order_total * $payment_rate * 100, 0);

			$variables["company_select"] = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($variables["company_id"], INTEGER));
			$variables["state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["state_code"], TEXT));
			if (strlen($variables["state_code"])) {
				$variables["state_code_or_province"] = $variables["state_code"];
				$variables["state_or_province"] = $variables["state"];
			} else {
				$variables["state_code_or_province"] = $variables["province"];
				$variables["state_or_province"] = $variables["province"];
			}
			$country_name = ""; $country_number = "";
			$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$country_name = $db->f("country_name");
				$country_number = $db->f("country_iso_number");
			}
			$variables["country"] = $country_name;
			$variables["country_number"] = $country_number;
			$variables["delivery_company_select"] = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($variables["delivery_company_id"], INTEGER));
			$variables["delivery_state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["delivery_state_code"], TEXT));
			if (strlen($variables["delivery_state_code"])) {
				$variables["delivery_state_code_or_province"] = $variables["delivery_state_code"];
				$variables["delivery_state_or_province"] = $variables["delivery_state"];
			} else {
				$variables["delivery_state_code_or_province"] = $variables["delivery_province"];
				$variables["delivery_state_or_province"] = $variables["delivery_province"];
			}
			$delivery_country_name = ""; $delivery_country_number = "";
			$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["delivery_country_code"], TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$delivery_country_name = $db->f("country_name");
				$delivery_country_number = $db->f("country_iso_number");
			}
			$variables["delivery_country"] = $delivery_country_name;
			$variables["delivery_country_number"] = $delivery_country_number;
			$variables["cc_type"] = get_db_value("SELECT credit_card_code FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($variables["cc_type"], INTEGER));

			$cc_info = array();
			$setting_type = "credit_card_info_" . $payment_id;
			$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
			$db->query($sql);
			while($db->next_record()) {
				$cc_info[$db->f("setting_name")] = $db->f("setting_value");
			}
			$cc_number_security = get_setting_value($cc_info, "cc_number_security", 1);
			$cc_code_security = get_setting_value($cc_info, "cc_code_security", 1);
			if ($cc_number_security == 2) {
				$variables["cc_number"] = va_decrypt($variables["cc_number"]);
			}
			if ($cc_code_security == 2) {
				$variables["cc_security_code"] = va_decrypt($variables["cc_security_code"]);
			}
			$cc_number_len = strlen($variables["cc_number"]);
			if ($cc_number_len > 6) {
				$variables["cc_number_first"] = substr($variables["cc_number"], 0, 6);
			} else {
				$variables["cc_number_first"] = $variables["cc_number"];
			}
			if ($cc_number_len > 4) {
				$variables["cc_number_last"] = substr($variables["cc_number"], $cc_number_len - 4);
			} else {
				$variables["cc_number_last"] = $variables["cc_number"];
			}

			$fp_hash_name = "";
			$db->query("SELECT * FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
			while($db->next_record())
			{
				$parameter_source = $db->f("parameter_source");
				$parameter_name = $db->f("parameter_name");
				$parameter_type = $db->f("parameter_type");
				$not_passed = $db->f("not_passed");
				if (strtolower($parameter_name) == "x_fp_hash" && $parameter_type == "VARIABLE") {
					$fp_hash_name = $parameter_name;
					$fp_not_passed = $not_passed;
				} else if (preg_match("/\{digit\}/", $parameter_name) || preg_match("/\{no_digit\}/", $parameter_name)) {
					for($i = 0; $i < sizeof($cart_items); $i++) {
						$cart_item = $cart_items[$i];
						$digit_parameter = str_replace("{digit}", ($i + 1), $parameter_name);
						$digit_parameter = str_replace("{no_digit}", "", $digit_parameter);
						if($parameter_type == "CONSTANT") {
							$parameter_value = $parameter_source;
						} else if($parameter_type == "VARIABLE") {
							if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
								$parameter_value = $parameter_source;
								for($p = 0; $p < sizeof($matches[1]); $p++) {
									$l_source = strtolower($matches[1][$p]);
									if (isset($cart_item[$l_source])) {
										$parameter_value = str_replace("{".$l_source."}", $cart_item[$l_source], $parameter_value);
									}
								}
							} else {
								$l_source = strtolower($parameter_source);
								$parameter_value = isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_source;
							}
						}
						$payment_parameters[strtolower($digit_parameter)] = $parameter_value;
						$payment_parameters[$digit_parameter] = $parameter_value;
						if (!$not_passed) {
							$pass_data[strtolower($digit_parameter)] = $parameter_value;
							$pass_data[$digit_parameter] = $parameter_value;
							$pass_parameters[strtolower($digit_parameter)] = 1;
							$pass_parameters[$digit_parameter] = 1;
							if ($post_parameters) { $post_parameters .= "&"; } 
							$post_parameters .= $digit_parameter . "=" . urlencode($parameter_value);
						} else {
							$pass_parameters[strtolower($digit_parameter)] = 0;
							$pass_parameters[$digit_parameter] = 0;
						}
					}
				} else {
					if($parameter_type == "CONSTANT") {
						$parameter_value = $parameter_source;
					} else if($parameter_type == "VARIABLE") {
						if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
							$parameter_value = $parameter_source;
							for($p = 0; $p < sizeof($matches[1]); $p++) {
								$l_source = strtolower($matches[1][$p]);
								if (isset($variables[$l_source])) {
									$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
								}
							}
						} else {
							$l_source = strtolower($parameter_source);
							$parameter_value = isset($variables[$l_source]) ? $variables[$l_source] : $parameter_source;
						}
					}
					$payment_parameters[strtolower($parameter_name)] = $parameter_value;
					$payment_parameters[$parameter_name] = $parameter_value;
					if (!$not_passed) {
						$pass_data[strtolower($parameter_name)] = $parameter_value;
						$pass_data[$parameter_name] = $parameter_value;
						$pass_parameters[strtolower($parameter_name)] = 1;
						$pass_parameters[$parameter_name] = 1;
						if ($post_parameters) { $post_parameters .= "&"; } 
						$post_parameters .= $parameter_name . "=" . urlencode($parameter_value);
					} else {
						$pass_parameters[strtolower($parameter_name)] = 0;
						$pass_parameters[$parameter_name] = 0;
					}
				}
			}
	    
			if (strlen($fp_hash_name)) {
				$x_login = isset($payment_parameters["x_login"]) ? $payment_parameters["x_login"] : "";
				$x_tran_key = isset($payment_parameters["x_tran_key"]) ? $payment_parameters["x_tran_key"] : "";
				$x_currency_code = isset($payment_parameters["x_currency_code"]) ? $payment_parameters["x_currency_code"] : "";
	    
				$fp_hash_value = calculate_fp ($x_login, $x_tran_key, $variables["order_total"], $variables["order_id"], $variables["timestamp"], $x_currency_code);
				$payment_parameters["x_fp_hash"] = $fp_hash_value;
				if(!$fp_not_passed) {
					$pass_data["x_fp_hash"] = $fp_hash_value;
					if ($post_parameters) { $post_parameters .= "&"; } 
					$post_parameters .= $fp_hash_name . "=" . urlencode($fp_hash_value);
				}
			}
		}


	}

?>