<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  order_info.php                                           ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./includes/common.php");
	include_once("./includes/record.php");
	include_once("./includes/shopping_cart.php");
	include_once("./includes/order_items.php");
	include_once("./includes/order_links.php");
	include_once("./includes/order_items_properties.php");
	include_once("./includes/parameters.php");
	include_once("./messages/".$language_code."/cart_messages.php");

	$user_id = get_session("session_user_id");
	if (!$user_id) {
		$user_id = get_session("session_new_user_id");
	}
	$user_registration = get_setting_value($settings, "user_registration", 0);
	if ($user_registration == 1 && !strlen($user_id)) {
		// user need to be logged in before proceed
		header("Location: checkout.php");
		exit;
	}

	$shopping_cart = get_session("shopping_cart");
	if (!is_array($shopping_cart) || sizeof($shopping_cart) < 1)
	{
		header("Location: basket.php");
		exit;
	}

	// get order profile settings
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while ($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	$eol = get_eol();
	$sess_currency = get_currency();
	$currency = get_currency($sess_currency["code"]);
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$currency_code = $currency["code"];
	$currency_value = $currency["value"];

	$user_info = get_session("session_user_info");
	$user_tax_free = get_setting_value($user_info, "tax_free", 0);
	$user_type_id = get_session("session_user_type_id");
	$user_discount_type = get_session("session_discount_type");
	$user_discount_amount = get_session("session_discount_amount");
	$user_ip = get_ip();
	$referer = get_session("session_referer");
	$initial_ip = get_session("session_initial_ip");
	$cookie_ip = get_session("session_cookie_ip");
	$visit_id = get_session("session_visit_id");
	if (!$visit_id) { $visit_id = 0; }
	$affiliate_code = get_session("session_af");
	$affiliate_user_id = 0;
	if (strlen($affiliate_code)) {
		$sql = " SELECT user_id FROM " . $table_prefix . "users WHERE affiliate_code=" . $db->tosql($affiliate_code, TEXT);
		$affiliate_user_id = get_db_value($sql);
	}
	$keywords = get_session("session_kw");
	$visit_number = get_session("session_visit_number");
	$secure_url = get_setting_value($settings, "secure_url", "");
	$secure_payments = get_setting_value($settings, "secure_payments", 0);
	$secure_order_profile = get_setting_value($settings, "secure_order_profile", 0);
	$product_code_checkout = get_setting_value($settings, "product_code_checkout", 0);
	$subscribe_block = get_setting_value($order_info, "subscribe_block", 0);

	$price_type = get_session("session_price_type");
	if ($price_type == 1) {
		$price_field = "trade_price";
		$sales_field = "trade_sales";
	} else {
		$price_field = "price";
		$sales_field = "sales_price";
	}
	$download_activated = 0;

	$operation = get_param("operation");
	$is_update = ($operation == "save");
	$same_as_personal = get_param("same_as_personal");

	if ($secure_order_profile) {
		$order_info_url = $secure_url . "order_info.php";
	} else {
		$order_info_url = "order_info.php";
	}

	// prepare state_code, postal_code and country_code for use
	$state_code = ""; $postal_code = ""; $country_code = "";
	if (strlen($operation)) {
		if ($order_info["show_delivery_state_code"] == 1) {
			if ($same_as_personal == 1 && $order_info["show_state_code"] == 1) {
				$state_code = get_param("state_code");
			} else {
				$state_code = get_param("delivery_state_code");
			}
		} elseif ($order_info["show_state_code"] == 1) {
			$state_code = get_param("state_code");
		} 

		if ($order_info["show_delivery_zip"] == 1) {
			if ($same_as_personal == 1 && $order_info["show_zip"] == 1) {
				$postal_code = get_param("zip");
			} else {
				$postal_code = get_param("delivery_zip");
			}
		} elseif ($order_info["show_zip"] == 1) {
			$postal_code = get_param("zip");
		} 

		if ($order_info["show_delivery_country_code"] == 1) {
			if ($same_as_personal == 1 && $order_info["show_country_code"] == 1) {
				$country_code = get_param("country_code");
			} else {
				$country_code = get_param("delivery_country_code");
			}
		} elseif ($order_info["show_country_code"] == 1) {
			$country_code = get_param("country_code");
		} else {
			$country_code = $settings["country_code"];
		}

	} elseif ($user_id) { // get user details 
		$sql  = " SELECT state_code,zip,country_code,delivery_state_code,delivery_zip,delivery_country_code ";
		$sql .= " FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			if ($order_info["show_delivery_state_code"] == 1) {
				$state_code = $db->f("delivery_state_code");
			} else {
				$state_code = $db->f("state_code");
			}
			if ($order_info["show_delivery_zip"] == 1) {
				$postal_code = $db->f("delivery_zip");
			} else {
				$postal_code = $db->f("zip");
			}
			if ($order_info["show_delivery_country_code"] == 1) {
				$country_code = $db->f("delivery_country_code");
			} elseif ($order_info["show_country_code"] == 1) {
				$country_code = $db->f("country_code");
			} else {
				$country_code = $settings["country_code"];
			}
		}
	} else { // get default country and state from cookies
		$cookie_order_info = get_cookie("cookie_order_info");
		// get state_code from cookies
		if ($order_info["show_delivery_state_code"] == 1) {
			if (preg_match("/delivery_state_code=([^\|]*)/", $cookie_order_info, $match)) {
				$state_code = $match[1];
			}
		} elseif ($order_info["show_state_code"] == 1) {
			if (preg_match("/state_code=([^\|]*)/", $cookie_order_info, $match)) {
				$state_code = $match[1];
			}
		} 
		// get postal_code from cookies
		if ($order_info["show_delivery_zip"] == 1) {
			if (preg_match("/delivery_zip=([^\|]*)/", $cookie_order_info, $match)) {
				$postal_code = $match[1];
			}
		} elseif ($order_info["show_zip"] == 1) {
			if (preg_match("/zip=([^\|]*)/", $cookie_order_info, $match)) {
				$postal_code = $match[1];
			}
		} 
		// get country_code from cookies
		if ($order_info["show_delivery_country_code"] == 1) {
			if (preg_match("/delivery_country_code=([^\|]*)/", $cookie_order_info, $match)) {
				$country_code = $match[1];
			}
		} elseif ($order_info["show_country_code"] == 1) {
			if (preg_match("/country_code=([^\|]*)/", $cookie_order_info, $match)) {
				$country_code = $match[1];
			}
		} 
		if (!strlen($country_code)) {
			$country_code = get_setting_value($settings, "country_code", "");
		}
		if (!strlen($state_code)) {
			$state_code = get_setting_value($settings, "state_code", "");
		}
	}


	$variables = array();
	$variables["charset"] = CHARSET;
	$variables["site_url"] = $settings["site_url"];
	$variables["secure_url"] = $secure_url;
	$variables["http_host"] = get_var("HTTP_HOST");
	$variables["session_id"] = session_id();
	$variables["user_ip"] = $user_ip;
	$variables["order_ip"] = $user_ip;
	$variables["initial_ip"] = $initial_ip;
	$variables["cookie_ip"] = $cookie_ip;

	$t = new VA_Template("./js");
	$t->set_file("ordering_js","ordering.js");
	$t->set_var("REQUIRED_PROPERTY_MSG", REQUIRED_PROPERTY_MSG);
	$t->set_var("REQUIRED_DELIVERY_MSG", REQUIRED_DELIVERY_MSG);
	$t->parse("ordering_js", false);

	$t->templates_path = $settings["templates_dir"];
	$t->set_file("main","order_info.html");
	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("order_info_href", "order_info.php");
	$t->set_var("current_href",  "order_info.php");
	$t->set_var("order_info_url",  $order_info_url);
	$t->set_var("currency_left", htmlspecialchars($currency_left));
	$t->set_var("currency_right", htmlspecialchars($currency_right));
	$t->set_var("currency_rate", htmlspecialchars($currency_rate));
	$t->set_var("referer", $referer);
	$t->set_var("referrer", $referer);
	$t->set_var("HTTP_REFERER", $referer);
	$t->set_var("initial_ip", $initial_ip);
	$t->set_var("cookie_ip", $cookie_ip);
	$t->set_var("user_ip", $user_ip);
	$t->set_var("remote_address", $user_ip);
	$t->set_var("visit_number", $visit_number);

	// prepare custom options 
	$options_errors = "";
	$properties_total = 0; $properties_taxable = 0;
	$order_properties = ""; $op_rows = array(); $pn = 0;
	$custom_options = array();
	$sql  = " SELECT * ";
	$sql .= " FROM " . $table_prefix . "order_custom_properties ";
	$sql .= " WHERE property_type IN (1,2,3) AND property_show IN (0,1) "; // show not hidden properties for all orders and web orders
	$sql .= " ORDER BY property_order, property_id ";
	$db->query($sql);
	if ($db->next_record()) {
		do {
			$op_rows[$pn]["property_id"] = $db->f("property_id");
			$op_rows[$pn]["property_order"] = $db->f("property_order");
			$op_rows[$pn]["property_name"] = $db->f("property_name");
			$op_rows[$pn]["property_description"] = $db->f("property_description");
			$op_rows[$pn]["default_value"] = $db->f("default_value");
			$op_rows[$pn]["property_type"] = $db->f("property_type");
			$op_rows[$pn]["property_style"] = $db->f("property_style");
			$op_rows[$pn]["control_type"] = $db->f("control_type");
			$op_rows[$pn]["control_style"] = $db->f("control_style");
			$op_rows[$pn]["required"] = $db->f("required");
			$op_rows[$pn]["tax_free"] = $db->f("tax_free");
			$op_rows[$pn]["before_name_html"] = $db->f("before_name_html");
			$op_rows[$pn]["after_name_html"] = $db->f("after_name_html");
			$op_rows[$pn]["before_control_html"] = $db->f("before_control_html");
			$op_rows[$pn]["after_control_html"] = $db->f("after_control_html");
			$op_rows[$pn]["onchange_code"] = $db->f("onchange_code");
			$op_rows[$pn]["onclick_code"] = $db->f("onclick_code");
			$op_rows[$pn]["control_code"] = $db->f("control_code");
			$op_rows[$pn]["validation_regexp"] = $db->f("validation_regexp");
			$op_rows[$pn]["regexp_error"] = ($db->f("regexp_error")) ? get_translation($db->f("regexp_error")) : INCORRECT_VALUE_MESSAGE;

			$pn++;
		} while ($db->next_record());
	}

	$sc_errors = ""; $delivery_errors = "";
	// VAT validation
	$vat_parameter = ""; $vat_number = ""; $is_vat_valid = false; $use_taxes = true;
	// add $vat_validation = true; into includes/var_definition.php to activate this validation
	if (isset($vat_validation) && $vat_validation) {
		// check vat_parameter
		if (sizeof($op_rows) > 0) {
			for ($pn = 0; $pn < sizeof($op_rows); $pn++) {
				$property_id = $op_rows[$pn]["property_id"];
				$property_name = $op_rows[$pn]["property_name"];
  
				if (preg_match("/vat/i", $property_name)) {
					$vat_parameter = "op_" . $property_id;
					break;
				}
			}
		}
		if ($vat_parameter) {
			include("./includes/vat_check.php");
			$vat_number = get_param($vat_parameter);
			if ($vat_number) {
				$is_vat_valid = vat_check($vat_number, $country_code);
				if ($is_vat_valid) {
					if (!isset($vat_obligatory_countries) || !is_array($vat_obligatory_countries)
						|| !in_array(strtoupper($country_code), $vat_obligatory_countries)) {
							$use_taxes = false;
						}
				} else {
					$sc_errors .= "Your VAT Number is invalid. Please check it and try again.<br>";
				}
			}
		}
	}

	// get taxes rates
	$tax_available = false; $tax_percent = 0; $tax_name = "";	$tax_cost = 0;
	if ($use_taxes) {
		$tax_rates = get_tax_rates(true, $country_code, $state_code, $postal_code);
		if (sizeof($tax_rates) > 0) {
			$tax_available = true;
			$tax_percent = $tax_rates[0];
			$tax_name = $tax_rates["tax_name"];
		}
	}

	if ($tax_available) {
		$t->set_var("property_colspan", "4");
		$t->set_var("sc_colspan", "5");
		$t->set_var("payment_colspan", "6");
		$t->set_var("tax_name", $tax_name);
		$t->sparse("tax_headers", false);
	} else {
		$t->set_var("property_colspan", "2");
		$t->set_var("sc_colspan", "3");
		$t->set_var("payment_colspan", "4");
	}

	$items_text = ""; $order_coupons_ids = ""; $gift_vouchers = array();

	$total_buying = 0; $total_merchants_commission=0; $total_affiliate_commission = 0;
	$goods_total = 0; $goods_tax_total = 0; $goods_taxable = 0;
	$total_items = 0; 
	$total_quantity = 0; $weight_total = 0; 
	$total_discount = 0; $total_discount_tax = 0;
	$order_total = 0;
	$max_availability_time = 0; $shipping_time = 0;
	$free_postage = false; $tax_free = false; 
	if ($user_tax_free) { $tax_free = $user_tax_free; }
	$recurring_items = false;
	
	// show custom options 
	if (sizeof($op_rows) > 0) 
	{
		for ($pn = 0; $pn < sizeof($op_rows); $pn++) {
			$property_id = $op_rows[$pn]["property_id"];
			$property_order  = $op_rows[$pn]["property_order"];
			$property_name_initial = $op_rows[$pn]["property_name"];
			$property_name = get_translation($property_name_initial);
			$property_description = $op_rows[$pn]["property_description"];
			$default_value = $op_rows[$pn]["default_value"];
			$property_type = $op_rows[$pn]["property_type"];
			$property_style = $op_rows[$pn]["property_style"];
			$control_type = $op_rows[$pn]["control_type"];
			$control_style = $op_rows[$pn]["control_style"];
			$property_required = $op_rows[$pn]["required"];
			$property_tax_free = $op_rows[$pn]["tax_free"];
			$before_name_html = $op_rows[$pn]["before_name_html"];
			$after_name_html = $op_rows[$pn]["after_name_html"];
			$before_control_html = $op_rows[$pn]["before_control_html"];
			$after_control_html = $op_rows[$pn]["after_control_html"];
			$onchange_code = $op_rows[$pn]["onchange_code"];
			$onclick_code = $op_rows[$pn]["onclick_code"];
			$control_code = $op_rows[$pn]["control_code"];
			$validation_regexp = $op_rows[$pn]["validation_regexp"];
			$regexp_error = $op_rows[$pn]["regexp_error"];

			if ($property_type > 0) {
				if (strlen($order_properties)) { $order_properties .= ","; }
				$order_properties .= $property_id;
			}

			$selected_price = 0;
			$property_control  = "";
			$property_control .= "<input type=\"hidden\" name=\"op_name_" . $property_id . "\"";
			$property_control .= " value=\"" . strip_tags($property_name) . "\">";
			$property_control .= "<input type=\"hidden\" name=\"op_required_" . $property_id . "\"";
			$property_control .= " value=\"" . intval($property_required) . "\">";
			$property_control .= "<input type=\"hidden\" name=\"op_control_" . $property_id . "\"";
			$property_control .= " value=\"" . strtoupper($control_type) . "\">";
			$property_control .= "<input type=\"hidden\" name=\"op_tax_free_" . $property_id . "\"";
			$property_control .= " value=\"" . intval($property_tax_free) . "\">";
			

			$sql  = " SELECT * FROM " . $table_prefix . "order_custom_values ";
			$sql .= " WHERE property_id=" . $property_id . " AND hide_value=0";
			$sql .= " ORDER BY property_value_id ";
			if (strtoupper($control_type) == "LISTBOX") {
				$selected_value = get_param("op_" . $property_id);
				$properties_prices = "";
				$properties_values = "<option value=\"\">" . SELECT_MSG . " " . $property_name . "</option>" . $eol;
				$db->query($sql);
				while ($db->next_record())
				{
					$property_value = get_translation($db->f("property_value"));
					$property_price = $db->f("property_price");
					$property_value_id = $db->f("property_value_id");
					$is_default_value = $db->f("is_default_value");
					$property_selected  = "";
					$properties_prices .= "<input type=\"hidden\" name=\"op_option_price_" . $property_value_id . "\"";
					$properties_prices .= " value=\"" . $property_price . "\">";
					if (strlen($operation)) {
						if ($selected_value == $property_value_id) {
							$property_selected  = "selected ";
							$selected_price    += $property_price;
							$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $property_value, $selected_price, $property_tax_free);
						}
					} elseif ($is_default_value) {
						$property_selected  = "selected ";
						$selected_price    += $property_price;
					} 

					$properties_values .= "<option " . $property_selected . "value=\"" . htmlspecialchars($property_value_id) . "\">";
					$properties_values .= htmlspecialchars($property_value);
					if ($property_price > 0)
						$properties_values .= " (+ " . $currency_left . number_format($property_price * $currency_rate, 2) . $currency_right . ")";
					elseif ($property_price < 0)
						$properties_values .= " (- " . $currency_left . number_format(abs($property_price * $currency_rate), 2) . $currency_right . ")";
					$properties_values .= "</option>" . $eol;
				}
				$property_control .= $before_control_html;
				$property_control .= "<select name=\"op_" . $property_id . "\" onChange=\"changeProperty(document.order_info);";
				if ($onchange_code) {	$property_control .= $onchange_code; }
				$property_control .= "\"";
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				$property_control .= ">" . $properties_values . "</select>";
				$property_control .= $properties_prices;
				$property_control .= $after_control_html;
			} elseif (strtoupper($control_type) == "RADIOBUTTON" || strtoupper($control_type) == "CHECKBOXLIST") {
				$is_radio = (strtoupper($control_type) == "RADIOBUTTON");

				$selected_value = array();
				if (strlen($operation)) {
					if ($is_radio) {
						$selected_value[] = get_param("op_" . $property_id);
					} else {
						$total_options = get_param("op_total_" . $property_id);
						for ($op = 1; $op <= $total_options; $op++) {
							$selected_value[] = get_param("op_" . $property_id . "_" . $op);
						}
					}
				}

				$input_type = $is_radio ? "radio" : "checkbox";
				$property_control .= "<span";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				$property_control .= ">";
				$value_number = 0;
				$db->query($sql);
				while ($db->next_record())
				{
					$value_number++;
					$property_price = $db->f("property_price");
					$property_value_id = $db->f("property_value_id");
					$manufacturer_code = $db->f("manufacturer_code");
					$is_default_value = $db->f("is_default_value");
					$property_value = get_translation($db->f("property_value"));
					$property_checked = "";
					$property_control .= $before_control_html;
					$property_control .= "<input type=\"hidden\" name=\"op_option_price_" . $property_value_id . "\"";
					$property_control .= " value=\"" . $property_price . "\">";
					if (strlen($operation)) {
						if (in_array($property_value_id, $selected_value)) {
							$property_checked = "checked ";
							$selected_price  += $property_price;
							if (isset($custom_options[$property_id])) {
								$custom_options[$property_id][3] .= "; " . $property_value;
								$custom_options[$property_id][4] = $selected_price;
							} else {
								$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $property_value, $selected_price, $property_tax_free);
							}
						}
					} elseif ($is_default_value) {
						$property_checked = "checked ";
						$selected_price  += $property_price;
					} 

					$control_name = ($is_radio) ? ("op_".$property_id) : ("op_".$property_id."_".$value_number);
					$property_control .= "<input type=\"" . $input_type . "\" name=\"" . $control_name . "\" ". $property_checked;
					$property_control .= "value=\"" . htmlspecialchars($property_value_id) . "\" onClick=\"changeProperty(document.order_info); ";
					if ($onclick_code) {	
						$control_onclick_code = str_replace("{option_value}", $property_value, $onclick_code);
						$property_control .= $control_onclick_code; 
					}
					$property_control .= "\"";
					if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
					if ($control_code) {	$property_control .= " " . $control_code . " "; }
					$property_control .= ">";
					$property_control .= $property_value;
					if ($property_price > 0)
						$property_control .= " (+ " . $currency_left . number_format($property_price * $currency_rate, 2) . $currency_right . ")";
					elseif ($property_price < 0)
						$property_control .= " (- " . $currency_left . number_format(abs($property_price * $currency_rate), 2) . $currency_right . ")";
					$property_control .= $after_control_html;
				}
				$property_control .= "</span>";
				$property_control .= "<input type=\"hidden\" name=\"op_total_".$property_id."\" value=\"".$value_number."\">";
			} elseif (strtoupper($control_type) == "TEXTBOX") {
				if (strlen($operation)) {
					$control_value = get_param("op_" . $property_id);
					if (strlen($control_value)) {
						$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $control_value, 0, 0);
					}
				} else {
					$control_value = $default_value;
				}
				$property_control .= $before_control_html;
				$property_control .= "<input type=\"text\" name=\"op_" . $property_id . "\"";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				$property_control .= " value=\"". htmlspecialchars($control_value) . "\">";
				$property_control .= $after_control_html;
			} elseif (strtoupper($control_type) == "TEXTAREA") {
				if (strlen($operation)) {
					$control_value = get_param("op_" . $property_id);
					if (strlen($control_value)) {
						$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $control_value, 0, 0);
					}
				} else {
					$control_value = $default_value;
				}
				$property_control .= $before_control_html;
				$property_control .= "<textarea name=\"op_" . $property_id . "\"";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				$property_control .= ">". htmlspecialchars($control_value) ."</textarea>";
				$property_control .= $after_control_html;
			} else {
				$property_control .= $before_control_html;
				if ($property_required) {
					$property_control .= "<input type=\"hidden\" name=\"op_" . $property_id . "\" value=\"" . htmlspecialchars($property_description) . "\">";
				}
				if (strlen($default_value)) {
					$custom_options[$property_id] = array($property_type, $property_order, $property_name_initial, $default_value, 0, 0);
				}
				$property_control .= "<span";
				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
				if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
				if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
				if ($control_code) {	$property_control .= " " . $control_code . " "; }
				$property_control .= ">" . get_translation($default_value) . "</span>";
				$property_control .= $after_control_html;
			}

			$properties_total += $selected_price;
			if ($property_tax_free != 1) {
				$properties_taxable += $selected_price;
			}
			$t->set_var("property_id", $property_id);
			//$t->set_var("property_block_id", $property_block_id);
			$t->set_var("property_name", $before_name_html . $property_name . $after_name_html);
			if ($selected_price == 0) {
				$t->set_var("op_price", "");
			} else {
				$t->set_var("op_price", $currency_left . number_format($selected_price * $currency_rate, 2) . $currency_right);
			}
			$t->set_var("property_style", $property_style);
			$t->set_var("property_control", $property_control);
			if ($property_required) {
				$t->set_var("property_required", "*");
			} else {
				$t->set_var("property_required", "");
			}

			if (strlen($operation) && $property_required && !isset($custom_options[$property_id])) {
				$property_message = str_replace("{field_name}", $property_name, REQUIRED_MESSAGE) . "<br>";
				if ($property_type == 1) {
					$sc_errors .= $property_message;
				} elseif ($property_type == 2 || $property_type == 3) {
					$options_errors .= $property_message;
				}
			}
			
			// check option with regexp
			if (strlen($operation) && isset($custom_options[$property_id]) && strlen($custom_options[$property_id][3]) && strlen($validation_regexp) && !preg_match($validation_regexp, $custom_options[$property_id][3])) {
				$regexp_valid = false;
			} else {
				$regexp_valid = true;
			}
			if (!$regexp_valid) {
				$property_message = str_replace("{field_name}", $property_name, $regexp_error) . "<br>";
				if ($property_type == 1) {
					$sc_errors .= $property_message;
				} elseif ($property_type == 2 || $property_type == 3) {
					$options_errors .= $property_message;
				}
			}

			if ($property_type == 1) {
				$t->parse("cart_properties", true);
			} elseif ($property_type == 2) {
				$t->parse("personal_properties", true);
			} elseif ($property_type == 3) {
				$t->parse("delivery_properties", true);
			}
		}

		$t->set_var("order_properties", $order_properties);
		$t->set_var("properties_total", $properties_total);
		$t->set_var("properties_taxable", $properties_taxable);

	}
	// end custom options

	$coupons = get_session("session_coupons");
	$cart_items = array();
	if (!strlen($user_id)) $user_id = 0;

	if (is_array($shopping_cart))
	{
		$properties_ids = "";
		foreach ($shopping_cart as $cart_id => $item)
		{
			$item_id = $item["ITEM_ID"];
			$quantity = $item["QUANTITY"];
			$subscription_id = isset($item["USER_TYPE_ID"]) ? $item["USER_TYPE_ID"] : "";
			// check subscription
			if ($subscription_id) { 
				$sql  = " SELECT is_subscription, is_subscription_recurring, subscription_name, subscription_fee, ";
				$sql .= " subscription_period, subscription_interval, subscription_suspend ";
				$sql .= " FROM " . $table_prefix . "user_types ";
				$sql .= " WHERE type_id=" . $db->tosql($subscription_id, INTEGER) . " AND is_active=1 ";
				$db->query($sql);
				if ($db->next_record()) {
					$total_items++;
					$is_subscription = $db->f("is_subscription");
					$is_recurring = $db->f("is_subscription_recurring");
					$subscription_fee = $db->f("subscription_fee");
					$subscription_name_initial = $db->f("subscription_name");
					$subscription_name = get_translation($subscription_name_initial);
					$subscription_period = $db->f("subscription_period");
					$subscription_interval = $db->f("subscription_interval");
					$subscription_suspend = $db->f("subscription_suspend");
					if ($is_recurring) {
						$recurring_period = $subscription_period;
						$recurring_interval = $subscription_interval;
					} else {
						$recurring_period = ""; $recurring_interval = "";
					}

					$t->set_var("item_name", $subscription_name);
					$t->set_var("item_name_strip", htmlspecialchars(strip_tags($subscription_name)));
					$t->set_var("product_code", "");
					$t->set_var("properties_values", "");
					$t->set_var("quantity", $quantity);

					$merchant_commission = 0; $affiliate_commission = 0;
					//$total_merchants_commission += ($merchant_commission * $quantity); 
					//$total_affiliate_commission += ($affiliate_commission * $quantity);
					$item_total = $subscription_fee * $quantity;
					$goods_total += $item_total;
					if (!$tax_free) {
						$goods_taxable += $item_total;
					}
					$total_quantity += $quantity;
			   
					$item_text = $subscription_name;
					$item_text .= " " . PROD_QTY_COLUMN . ":" . $quantity . " " . $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right;
					$items_text .= $item_text . $eol;
			  
					$t->set_var("price", $currency_left . number_format($subscription_fee * $currency_rate, 2) . $currency_right);
					$t->set_var("item_total", $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right);
					if ($tax_available) {
						$subscription_tax = get_tax_amount($tax_rates, 0, $item_total, $tax_free);
						list($subscription_tax_percent, $subscription_tax_total) = $subscription_tax;
						$goods_tax_total += $subscription_tax_total;
						$t->set_var("item_tax_percent",  $subscription_tax_percent . "%");
						$t->set_var("item_tax_total", $currency_left . number_format($subscription_tax_total * $currency_rate, 2) . $currency_right);
						$t->sparse("item_tax", false);
					} else {
						$subscription_tax_percent = 0; 
					}

					$t->parse("items", true);

					$cart_items[] = array(
						"item_id" => 0, "id" => 0, "product_id" => 0, "parent_item_id" => 0,
						"item_user_id" => 0, "item_type_id" => 0,
						"manufacturer_code" => "", "small_image" => "",
						"weight" => 0, "price" => $subscription_fee, "quantity" => $quantity, 
						"tax_free" => $tax_free, "tax_percent" => $subscription_tax_percent,  
						"real_price" => $subscription_fee, "discount_amount" => 0, "coupons_ids" => "", 
						"merchant_commission" => $merchant_commission, "affiliate_commission" => $affiliate_commission,
						"buying_price" => 0, "item_name" => $subscription_name_initial, "product_name" => $subscription_name_initial, 
						"product_title" => $subscription_name_initial, "item_title" => $subscription_name_initial, "properties_info" => "", 
						"downloadable" => 0, "download_period" => "", "download_path" => "",
						"stock_level" => "", "availability_time" => "", "item_total" => $item_total,
						"short_description" => "", "description" => "", "full_description" => "",
						"generate_serial" => 0, "serial_period" => "", "activations_number" => "", "is_gift_voucher" => 0,
						"is_recurring" => $is_recurring, "recurring_period" => $recurring_period, 
						"recurring_interval" => $recurring_interval, "recurring_payments_total" => "", 
						"recurring_start_date" => "", "recurring_end_date" => "",
						"is_subscription" => $is_subscription, "subscription_period" => $subscription_period,
						"subscription_interval" => $subscription_interval, "subscription_suspend" => $subscription_suspend,
					);
				}
				continue;
			}

			$properties_more = $item["PROPERTIES_MORE"];
			if ($properties_more) { 
				continue;
			}
			
			$properties = $item["PROPERTIES"];
			$components = $item["COMPONENTS"];
			$item_coupons = isset($item["COUPONS"]) ? $item["COUPONS"] : "";

			$sql  = " SELECT i.manufacturer_code, i.item_type_id, i.user_id, i.item_name, i.short_description, i.full_description, ";
			$sql .= " i.buying_price, i." . $price_field . ", i.is_price_edit, i.is_sales, i." . $sales_field . ", i.tax_free, i.stock_level, ";
			$sql .= " i.small_image, i.weight,  ";
			$sql .= " i.merchant_fee_type AS item_merchant_type, i.merchant_fee_amount AS item_merchant_amount, i.affiliate_commission_type AS item_affiliate_type, i.affiliate_commission_amount AS item_affiliate_amount, ";
			$sql .= " it.merchant_fee_type AS type_merchant_type, it.merchant_fee_amount AS type_merchant_amount, it.affiliate_commission_type AS type_affiliate_type, it.affiliate_commission_amount AS type_affiliate_amount, ";
			$sql .= " i.downloadable, i.download_period, i.download_path, i.generate_serial, i.serial_period, i.activations_number, ";
			$sql .= " st_in.availability_time AS in_stock_availability , st_out.availability_time AS out_stock_availability, ";
			$sql .= " i.shipping_rule_id, sr.is_country_restriction, ";
			$sql .= " i.is_recurring, i.recurring_period, i.recurring_interval, ";
			$sql .= " i.recurring_payments_total, i.recurring_start_date, i.recurring_end_date, ";
			$sql .= " it.is_gift_voucher, it.is_bundle ";
			$sql .= " FROM ((((" . $table_prefix . "items i ";
			$sql .= " LEFT JOIN " . $table_prefix . "item_types it ON i.item_type_id=it.item_type_id) ";
			$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
			$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
			$sql .= " LEFT JOIN " . $table_prefix . "shipping_rules sr ON i.shipping_rule_id=sr.shipping_rule_id) ";
			$sql .= " WHERE i.item_id=" . $db->tosql($item_id, INTEGER);

			$db->query($sql);
			if ($db->next_record())
			{
				$total_items++;

				$price = $db->f($price_field);
				$is_price_edit = $db->f("is_price_edit");
				if ($is_price_edit) {
					$price = $item["PRICE"];
				}
				$item_type_id = $db->f("item_type_id");
				$item_user_id = $db->f("user_id");
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f($sales_field);
				$manufacturer_code = $db->f("manufacturer_code");
				$buying_price = $db->f("buying_price");
				$item_name_initial = $db->f("item_name");
				$item_name = get_translation($item_name_initial);
				$downloadable = $db->f("downloadable");
				$download_period = $db->f("download_period");
				$download_path = $db->f("download_path");
				$generate_serial = $db->f("generate_serial");
				$serial_period = $db->f("serial_period");
				$activations_number = $db->f("activations_number");
				$is_gift_voucher = $db->f("is_gift_voucher");
				$is_bundle = $db->f("is_bundle");
				$stock_level = $db->f("stock_level");
				if ($stock_level > 0) {
					$availability_time = $db->f("in_stock_availability");
				} else {
					$availability_time = $db->f("out_stock_availability");
				}
				if ($availability_time > $max_availability_time) {
					$max_availability_time = $availability_time;
				}
				$shipping_rule_id = $db->f("shipping_rule_id");
				$is_country_restriction = $db->f("is_country_restriction");
				$weight = $db->f("weight");
				$item_tax_free = $db->f("tax_free");
				if ($user_tax_free) { $item_tax_free = $user_tax_free; }
				$short_description = strip_tags($db->f("short_description"));
				$full_description = strip_tags($db->f("full_description"));
				$small_image = $db->f("small_image");
				// get commission fields
				$item_merchant_type = $db->f("item_merchant_type");
				$item_merchant_amount = $db->f("item_merchant_amount");
				$item_affiliate_type = $db->f("item_affiliate_type");
				$item_affiliate_amount = $db->f("item_affiliate_amount");
				if (!strlen($item_merchant_type)) {
					$item_merchant_type = $db->f("type_merchant_type");
					$item_merchant_amount = $db->f("type_merchant_amount");
				}
				if (!strlen($item_affiliate_type)) {
					$item_affiliate_type = $db->f("type_affiliate_type");
					$item_affiliate_amount = $db->f("type_affiliate_amount");
				}
				$is_recurring = $db->f("is_recurring");
				$recurring_items = ($is_recurring || $recurring_items);
				$recurring_period = $db->f("recurring_period");
				$recurring_interval = $db->f("recurring_interval");
				$recurring_payments_total = $db->f("recurring_payments_total");
				$recurring_start_date = $db->f("recurring_start_date", DATETIME);
				$recurring_end_date = $db->f("recurring_end_date", DATETIME);

				if ($is_country_restriction && $country_code) {
					$sql  = " SELECT shipping_rule_id FROM " . $table_prefix . "shipping_rules_countries ";
					$sql .= " WHERE shipping_rule_id=" . $db->tosql($shipping_rule_id, INTEGER);
					$sql .= " AND country_code=" . $db->tosql($country_code, TEXT);
					$db->query($sql);
					if (!$db->next_record()) {
						$delivery_errors .= str_replace("{product_name}", $item_name, PROD_RESTRICTED_DELIVERY_MSG) . "<br>";
					}
				}

				// some price calculation
				$properties_discount = 0;
				$discount_applicable = 1;
				if (!$is_price_edit) {
					$price = calculate_price($price, $is_sales, $sales_price);
					$quantity_price = get_quantity_price($item_id, $quantity);
					if (sizeof($quantity_price)) {
						$price = $quantity_price[0];
						$properties_discount = $quantity_price[1];
						$discount_applicable = $quantity_price[2];
					}
					if ($discount_applicable) {
						if ($user_discount_type == 1 || $user_discount_type == 3) {
							$price -= round(($price * $user_discount_amount) / 100, 2);
						} elseif ($user_discount_type == 2) {
							$price -= round($user_discount_amount, 2);
						} elseif ($user_discount_type == 4) {
							$price -= round((($price - $buying_price) * $user_discount_amount) / 100, 2);
						}
					}
				}

				// set item variables into html
				$t->set_var("cart_id", $cart_id);
				$t->set_var("item_name", $item_name);
				$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));
				$t->set_var("short_description", get_translation($short_description));
				$t->set_var("quantity", $quantity);				
				$t->set_var("small_image", $small_image);				

				// show properties if there are any
				$properties_info = array();
				$properties_values = ""; $properties_values_text = ""; $properties_values_html = "";
				$additional_price = 0; $options_buying_price = 0; $additional_weight = 0;

				order_items_properties($item_id, $item_type_id, $price, 0, 0, $is_bundle, $discount_applicable, $properties_discount);
				// end item properties

				// show product code
				$t->set_var("manufacturer_code", $manufacturer_code);
				if ($product_code_checkout && $manufacturer_code) {
					$t->sparse("product_code", false);
				} else {
					$t->set_var("product_code", "");
				}

				// show product coupons if availble
				$item_discount = 0; $item_coupons_ids = "";
				if (is_array($item_coupons))
				{
					foreach ($item_coupons as $coupon_id => $coupon_info)
					{
						$sql  = " SELECT * ";
						$sql .= " FROM " . $table_prefix . "coupons ";
						$sql .= " WHERE coupon_id=" . $db->tosql($coupon_id, INTEGER);
						$db->query($sql);
						if ($db->next_record()) {
							$is_active = $db->f("is_active");
							$coupon_title = $db->f("coupon_title");
							$discount_type = $db->f("discount_type");
							$coupon_discount = $db->f("discount_amount");
							$minimum_amount = $db->f("minimum_amount");
							$quantity_limit = $db->f("quantity_limit");
							$coupon_uses = $db->f("coupon_uses");
							if (!$is_active) {
								remove_coupon($coupon_id);
							} elseif ($quantity_limit > 0 && $coupon_uses >= $quantity_limit) {
								remove_coupon($coupon_id);
							} elseif ($price < $minimum_amount) {
								remove_coupon($coupon_id);
							} else {
								if (strlen($item_coupons_ids)) { $item_coupons_ids .= ","; }
								$item_coupons_ids .= $coupon_id;

								if ($discount_type == 3) {
									$discount_amount = round((($price + $additional_price) / 100) * $coupon_discount, 2);
								} else {
									$discount_amount = $coupon_discount;
								}
								$item_discount += $discount_amount;
								if (strlen($properties_values_text)) $properties_values_text .= "; ";
								$properties_values .= "<br>" . $coupon_title . " (- " . $currency_left . number_format($discount_amount * $currency_rate, 2) . $currency_right . ")";
								$properties_values_text .= $coupon_title . " (- " . $currency_left . number_format($discount_amount * $currency_rate, 2) . $currency_right . ")";
								$properties_values_html .= "<br>" . $coupon_title . " (- " . $currency_left . number_format($discount_amount * $currency_rate, 2) . $currency_right . ")";
							}
						}
					}
				}

				$t->set_var("properties_values", $properties_values_html);

				if (!$is_bundle) {
					// calculate commissions
					$merchant_commission = get_merchant_commission($item_user_id, $price - $item_discount, $additional_price, $buying_price + $options_buying_price, $item_merchant_type, $item_merchant_amount);
					$affiliate_commission = get_affiliate_commission($affiliate_user_id, $price - $item_discount, $additional_price, $buying_price + $options_buying_price, $item_affiliate_type, $item_affiliate_amount);
					if ($merchant_commission && $affiliate_commission) {
						$merchant_commission -= $affiliate_commission;
					}

					// add options values to product and calculate summary
					$buying_price += $options_buying_price;
					$total_buying += ($buying_price * $quantity); 
					$real_price = round($price + $additional_price, 2);
					$price = round($price + $additional_price - $item_discount, 2);

					$total_merchants_commission += ($merchant_commission * $quantity); 
					$total_affiliate_commission += ($affiliate_commission * $quantity);
					$weight += $additional_weight;
					$item_total = $price * $quantity;
					$goods_total += $item_total;
					if ($item_tax_free != 1) {
						$goods_taxable += $item_total;
					}
					$total_quantity += $quantity;
					$weight_total += ($weight * $quantity);
			   
					$item_text = $item_name;
					if (strlen($properties_values_text)) {
						$item_text .= " (" . $properties_values_text . ")";
					}
					$item_text .= " " . PROD_QTY_COLUMN . ":" . $quantity . " " . $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right;
					$items_text .= $item_text . $eol;
			  
					$t->set_var("price", $currency_left . number_format($price * $currency_rate, 2) . $currency_right);
					$t->set_var("item_total", $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right);
					if ($tax_available) {
						$item_tax = get_tax_amount($tax_rates, $item_type_id, $item_total, $item_tax_free);
						list($item_tax_percent, $item_tax_total) = $item_tax;
						$goods_tax_total += $item_tax_total;
						$t->set_var("item_tax_percent",  $item_tax_percent . "%");
						$t->set_var("item_tax_total", $currency_left . number_format($item_tax_total * $currency_rate, 2) . $currency_right);
						$t->sparse("item_tax", false);
					} else {
						$item_tax_percent = 0; 
					}
			  
					$t->parse("items", true);

					$cart_items[] = array(
						"item_id" => $item_id, "id" => $item_id, "product_id" => $item_id, "parent_item_id" => 0,
						"item_user_id" => $item_user_id, "item_type_id" => $item_type_id,
						"manufacturer_code" => $manufacturer_code, "small_image" => $small_image,
						"weight" => $weight, "price" => $price, "quantity" => $quantity, 
						"tax_free" => $item_tax_free, "tax_percent" => $item_tax_percent,  
						"real_price" => $real_price, "discount_amount" => $item_discount,  "coupons_ids" => $item_coupons_ids, 
						"merchant_commission" => $merchant_commission, "affiliate_commission" => $affiliate_commission,
						"buying_price" => $buying_price, "item_name" => $item_name_initial, "product_name" => $item_name_initial, 
						"product_title" => $item_name_initial, "item_title" => $item_name_initial, "properties_info" => $properties_info, 
						"downloadable" => $downloadable, "download_period" => $download_period, "download_path" => $download_path,
						"stock_level" => $stock_level, "availability_time" => $availability_time, "item_total" => $item_total,
						"short_description" => $short_description, "description" => $short_description, "full_description" => $full_description,
						"generate_serial" => $generate_serial, "serial_period" => $serial_period, "activations_number" => $activations_number, 
						"is_gift_voucher" => $is_gift_voucher,
						"is_recurring" => $is_recurring, "recurring_period" => $recurring_period, 
						"recurring_interval" => $recurring_interval, "recurring_payments_total" => $recurring_payments_total, 
						"recurring_start_date" => $recurring_start_date, "recurring_end_date" => $recurring_end_date,
						"is_subscription" => 0, "subscription_period" => "", 
						"subscription_interval" => "", "subscription_suspend" => "",
					);

				} 
				
				if (sizeof($components) > 0) {
					// check for bundle components 
					$parent_item_id = $item_id;
					if ($is_bundle) {
						$parent_price = round($price + $additional_price - $item_discount, 2);
					} else {
						$parent_price = 0;
					}
					$components_ids = array();
					$components_price = 0; $components_base_price = 0;

					foreach ($components as $property_id => $component_values) {
						foreach ($component_values as $item_property_id => $component) {
							$property_type_id = $component["type_id"];
							$sub_item_id = $component["sub_item_id"];
							if ($property_type_id == 2) {
								$sql  = " SELECT i.item_id, i.manufacturer_code, i.user_id, i.item_type_id, i.item_name, i.short_description, i.full_description, ";
								$sql .= " i.downloadable, i.download_period, i.download_path, i.generate_serial, i.serial_period, i.activations_number, ";
								$sql .= " st_in.availability_time AS in_stock_availability , st_out.availability_time AS out_stock_availability, ";
								$sql .= " i.small_image, i.weight, it.is_gift_voucher, ";
								$sql .= " i.merchant_fee_type AS item_merchant_type, i.merchant_fee_amount AS item_merchant_amount, i.affiliate_commission_type AS item_affiliate_type, i.affiliate_commission_amount AS item_affiliate_amount, ";
								$sql .= " it.merchant_fee_type AS type_merchant_type, it.merchant_fee_amount AS type_merchant_amount, it.affiliate_commission_type AS type_affiliate_type, it.affiliate_commission_amount AS type_affiliate_amount, ";
								$sql .= " pr.property_name AS component_name, pr.additional_price AS component_price, ";
								$sql .= " i.buying_price, i." . $price_field . ", i.is_sales, i." . $sales_field . ", i.tax_free, ";
								$sql .= " i.stock_level, i.use_stock_level, i.hide_out_of_stock, i.disable_out_of_stock, i.shipping_rule_id, sr.is_country_restriction, ";
								$sql .= " i.is_recurring, i.recurring_period, i.recurring_interval, ";
								$sql .= " i.recurring_payments_total, i.recurring_start_date, i.recurring_end_date, ";
								$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action, ip.properties_discount ";
								$sql .= " FROM ((((((" . $table_prefix . "items_properties pr ";
								$sql .= " INNER JOIN " . $table_prefix . "items i ON pr.sub_item_id=i.item_id)";
								$sql .= " LEFT JOIN " . $table_prefix . "item_types it ON i.item_type_id=it.item_type_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "shipping_rules sr ON i.shipping_rule_id=sr.shipping_rule_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON ";
								$sql .= " (i.item_id=ip.item_id AND ip.min_quantity<=" . $db->tosql($quantity, INTEGER) . " AND ip.max_quantity>=" . $db->tosql($quantity, INTEGER);
								$sql .= " AND (ip.user_type_id=0 OR ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . "))) ";
								$sql .= " WHERE pr.property_id=" . $db->tosql($property_id, INTEGER);
								$sql .= " ORDER BY ip.user_type_id DESC ";
								$parent_property_id = $property_id ."_0";
							} else {
								$sql  = " SELECT i.item_id, i.manufacturer_code, i.user_id, i.item_type_id, i.item_name, i.short_description, i.full_description, ";
								$sql .= " i.downloadable, i.download_period, i.download_path, i.generate_serial, i.serial_period, i.activations_number, ";
								$sql .= " st_in.availability_time AS in_stock_availability , st_out.availability_time AS out_stock_availability, ";
								$sql .= " i.small_image, i.weight, it.is_gift_voucher, ";
								$sql .= " i.merchant_fee_type AS item_merchant_type, i.merchant_fee_amount AS item_merchant_amount, i.affiliate_commission_type AS item_affiliate_type, i.affiliate_commission_amount AS item_affiliate_amount, ";
								$sql .= " it.merchant_fee_type AS type_merchant_type, it.merchant_fee_amount AS type_merchant_amount, it.affiliate_commission_type AS type_affiliate_type, it.affiliate_commission_amount AS type_affiliate_amount, ";
								$sql .= " ipv.property_value AS component_name, ipv.additional_price AS component_price, ";
								$sql .= " i.buying_price, i." . $price_field . ", i.is_sales, i." . $sales_field . ", i.tax_free, ";
								$sql .= " i.stock_level, i.use_stock_level, i.hide_out_of_stock, i.disable_out_of_stock, i.shipping_rule_id, sr.is_country_restriction, ";
								$sql .= " i.is_recurring, i.recurring_period, i.recurring_interval, ";
								$sql .= " i.recurring_payments_total, i.recurring_start_date, i.recurring_end_date, ";
								$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action, ip.properties_discount ";
								$sql .= " FROM ((((((" . $table_prefix . "items_properties_values ipv ";
								$sql .= " INNER JOIN " . $table_prefix . "items i ON ipv.sub_item_id=i.item_id)";
								$sql .= " LEFT JOIN " . $table_prefix . "item_types it ON i.item_type_id=it.item_type_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "shipping_rules sr ON i.shipping_rule_id=sr.shipping_rule_id) ";
								$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON ";
								$sql .= " (i.item_id=ip.item_id AND ip.min_quantity<=" . $db->tosql($quantity, INTEGER) . " AND ip.max_quantity>=" . $db->tosql($quantity, INTEGER);
								$sql .= " AND (ip.user_type_id=0 OR ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . "))) ";
								$sql .= " WHERE ipv.item_property_id=" . $db->tosql($item_property_id, INTEGER);
								$sql .= " ORDER BY ip.user_type_id DESC ";
								$parent_property_id = $property_id ."_".$item_property_id;
							}
							$db->query($sql);
							if ($db->next_record()) {
								// price calculation
								$sub_item_id = $db->f("item_id");
								$item_user_id = $db->f("user_id");
								$item_type_id = $db->f("item_type_id");
								$component_price = $db->f("component_price");
								$buying_price = $db->f("buying_price");
								$item_price = $db->f($price_field);
								$is_sales = $db->f("is_sales");
								$sales_price = $db->f($sales_field);
								$user_price = $db->f("user_price");
								$user_action = $db->f("user_price_action");
								$discount_applicable = ($user_action == 2) ? 1 : 0;
								$properties_discount = $db->f("properties_discount");
										
								$prices = get_product_price($sub_item_id, $item_price, $buying_price, $is_sales, $sales_price, $user_price, $user_action, $user_discount_type, $user_discount_amount);
								$base_price = $prices["base"];
								if (strlen($component_price)) {
									$price = $component_price;
								} else {
									$price = $base_price;
								}
								$item_total = $price * $quantity;
								$components_price += $price;
								$components_base_price += $base_price;

								$manufacturer_code = $db->f("manufacturer_code");
								$item_name = $db->f("item_name");
								$downloadable = $db->f("downloadable");
								$download_period = $db->f("download_period");
								$download_path = $db->f("download_path");
								$generate_serial = $db->f("generate_serial");
								$serial_period = $db->f("serial_period");
								$activations_number = $db->f("activations_number");
								$is_gift_voucher = $db->f("is_gift_voucher");
								$stock_level = $db->f("stock_level");
								if ($stock_level > 0) {
									$availability_time = $db->f("in_stock_availability");
								} else {
									$availability_time = $db->f("out_stock_availability");
								}
								if ($availability_time > $max_availability_time) {
									$max_availability_time = $availability_time;
								}
								$shipping_rule_id = $db->f("shipping_rule_id");
								$is_country_restriction = $db->f("is_country_restriction");
								$weight = $db->f("weight");
								$item_tax_free = $db->f("tax_free");
								if ($user_tax_free) { $item_tax_free = $user_tax_free; }
								$short_description = strip_tags($db->f("short_description"));
								$full_description = strip_tags($db->f("full_description"));
								$small_image = $db->f("small_image");
								// get commission fields
								$item_merchant_type = $db->f("item_merchant_type");
								$item_merchant_amount = $db->f("item_merchant_amount");
								$item_affiliate_type = $db->f("item_affiliate_type");
								$item_affiliate_amount = $db->f("item_affiliate_amount");
								if (!strlen($item_merchant_type)) {
									$item_merchant_type = $db->f("type_merchant_type");
									$item_merchant_amount = $db->f("type_merchant_amount");
								}
								if (!strlen($item_affiliate_type)) {
									$item_affiliate_type = $db->f("type_affiliate_type");
									$item_affiliate_amount = $db->f("type_affiliate_amount");
								}
								$is_recurring = $db->f("is_recurring");
								$recurring_items = ($is_recurring || $recurring_items);
								$recurring_period = $db->f("recurring_period");
								$recurring_interval = $db->f("recurring_interval");
								$recurring_payments_total = $db->f("recurring_payments_total");
								$recurring_start_date = $db->f("recurring_start_date", DATETIME);
								$recurring_end_date = $db->f("recurring_end_date", DATETIME);

								if ($is_country_restriction && $country_code) {
									$sql  = " SELECT shipping_rule_id FROM " . $table_prefix . "shipping_rules_countries ";
									$sql .= " WHERE shipping_rule_id=" . $db->tosql($shipping_rule_id, INTEGER);
									$sql .= " AND country_code=" . $db->tosql($country_code, TEXT);
									$db->query($sql);
									if (!$db->next_record()) {
										$delivery_errors .= str_replace("{product_name}", get_translation($item_name), PROD_RESTRICTED_DELIVERY_MSG) . "<br>";
									}
								}

								$cart_items[] = array(
									"item_id" => $sub_item_id, "id" => $sub_item_id, "product_id" => $sub_item_id, 
									"item_user_id" => $item_user_id, "item_type_id" => $item_type_id,
									"parent_item_id" => $parent_item_id, "parent_property_id" => $parent_property_id,
									"manufacturer_code" => $manufacturer_code, "small_image" => $small_image,
									"weight" => $weight, "price" => $price, "quantity" => $quantity, 
									"tax_free" => $item_tax_free, "tax_percent" => 0, 
									"item_merchant_type" => $item_merchant_type, "item_merchant_amount" => $item_merchant_amount, 
									"item_affiliate_type" => $item_affiliate_type, "item_affiliate_amount" => $item_affiliate_amount, 
									"merchant_commission" => 0, "affiliate_commission" => 0,
									"real_price" => $base_price, "discount_amount" => 0,  "coupons_ids" => $item_coupons_ids, 
									"discount_applicable" => $discount_applicable, "properties_discount" => $properties_discount,
									"buying_price" => $buying_price, "item_name" => $item_name, "product_name" => $item_name, 
									"product_title" => $item_name, "item_title" => $item_name, "properties_info" => array(""), 
									"downloadable" => $downloadable, "download_period" => $download_period, "download_path" => $download_path,
									"stock_level" => $stock_level, "availability_time" => $availability_time, "item_total" => $item_total,
									"short_description" => $short_description, "description" => $short_description, "full_description" => $full_description,
									"generate_serial" => $generate_serial, "serial_period" => $serial_period, "activations_number" => $activations_number, 
									"is_gift_voucher" => $is_gift_voucher,
									"is_recurring" => $is_recurring, "recurring_period" => $recurring_period, 
									"recurring_interval" => $recurring_interval, "recurring_payments_total" => $recurring_payments_total, 
									"recurring_start_date" => $recurring_start_date, "recurring_end_date" => $recurring_end_date,
									"is_subscription" => 0, "subscription_period" => "", 
									"subscription_interval" => "", "subscription_suspend" => "",
								);
								end($cart_items); 
								$cart_item_id = key($cart_items);
								$components_ids[] = $cart_item_id;

							} else {
								// if some basket items were missed remove from the cart and move user to the basket page
								unset($shopping_cart[$cart_id]);
								set_session("shopping_cart", $shopping_cart);
								header ("Location: basket.php");
								exit;
							}	
						}
					}

					// if the bundle product has price apply it to it's subcomponents
					if ($parent_price) {
						$parent_price_left = $parent_price;
						if ($components_price > 0) {
							$field_name = "price"; $total_components_price = $components_price;
						} else {
							$field_name = "real_price"; $total_components_price = $components_base_price;
						}
						for ($c = 0; $c < sizeof($components_ids); $c++) {
							$cart_item = $cart_items[$components_ids[$c]];
							$price = $cart_item["price"];
							$field_price = $cart_item[$field_name];
							if (($c + 1) == sizeof($components_ids)) {
								$additional_price = $parent_price_left;
							} else {
								$additional_price = round($field_price * ($parent_price / $total_components_price), 2);
								$parent_price_left -= $additional_price;
							}
							$price += $additional_price;
							$item_total = $price * $quantity;

							$cart_items[$components_ids[$c]]["price"] = $price;
							$cart_items[$components_ids[$c]]["item_total"] = $item_total;
						}
					}

					for ($c = 0; $c < sizeof($components_ids); $c++) {
						$cart_item = $cart_items[$components_ids[$c]];
						$sub_item_id = $cart_item["item_id"];
						$item_user_id = $cart_item["item_user_id"];
						$item_type_id = $cart_item["item_type_id"];
						$parent_item_id = $cart_item["parent_item_id"];
						$parent_property_id = $cart_item["parent_property_id"];
						$manufacturer_code = $cart_item["manufacturer_code"];
						$item_name_initial = $cart_item["item_name"];
						$item_name = get_translation($item_name_initial);
						$short_description = get_translation($cart_item["short_description"]);
						$small_image = $cart_item["small_image"];
						$price = $cart_item["price"];
						$real_price = $cart_item["real_price"];
						$item_tax_free = $cart_item["tax_free"];
						if ($user_tax_free) { $item_tax_free = $user_tax_free; }
						$buying_price = $cart_item["buying_price"];
						$weight = $cart_item["weight"];
						$discount_applicable = $cart_item["discount_applicable"];
						$properties_discount = $cart_item["properties_discount"];
						$item_merchant_type = $cart_item["item_merchant_type"];
						$item_merchant_amount = $cart_item["item_merchant_amount"];
						$item_affiliate_type = $cart_item["item_affiliate_type"];
						$item_affiliate_amount = $cart_item["item_affiliate_amount"];

						$t->set_var("cart_id", $cart_id . "_" . $parent_property_id);
						$t->set_var("item_name", $item_name);
						$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));
						$t->set_var("short_description", $short_description);
						$t->set_var("quantity", $quantity);				
						$t->set_var("small_image", $small_image);				

						// show properties if there are any
						$properties_info = array(); 
						$properties_values = ""; $properties_values_text = ""; $properties_values_html = "";
						$additional_price = 0; $options_buying_price = 0; $additional_weight = 0;

						order_items_properties($sub_item_id, $item_type_id, $parent_item_id, $parent_property_id, false, $discount_applicable, $properties_discount);

						// show product code
						$t->set_var("manufacturer_code", $manufacturer_code);
						if ($product_code_checkout && $manufacturer_code) {
							$t->sparse("product_code", false);
						} else {
							$t->set_var("product_code", "");
						}

						// calculate commissions
						$merchant_commission = get_merchant_commission($item_user_id, $price, $additional_price, $buying_price + $options_buying_price, $item_merchant_type, $item_merchant_amount);
						$affiliate_commission = get_affiliate_commission($affiliate_user_id, $price, $additional_price, $buying_price + $options_buying_price, $item_affiliate_type, $item_affiliate_amount);
						if ($merchant_commission && $affiliate_commission) {
							$merchant_commission -= $affiliate_commission;
						}

						// add options values to product
						$price += $additional_price;
						$real_price += $additional_price;
						$buying_price += $options_buying_price;
						$weight += $additional_weight;
						$cart_items[$components_ids[$c]]["price"] = $price;
						$cart_items[$components_ids[$c]]["real_price"] += $real_price;
						$cart_items[$components_ids[$c]]["buying_price"] = $buying_price;
						$cart_items[$components_ids[$c]]["merchant_commission"] = $merchant_commission;
						$cart_items[$components_ids[$c]]["affiliate_commission"] = $affiliate_commission;
						$cart_items[$components_ids[$c]]["weight"] = $weight;
						$cart_items[$components_ids[$c]]["properties_info"] = $properties_info;
						$cart_items[$components_ids[$c]]["manufacturer_code"] = $manufacturer_code;

						$t->set_var("properties_values", $properties_values_html);

						$item_total = $price * $quantity;
						$total_buying += ($buying_price * $quantity); 
						$total_merchants_commission += ($merchant_commission * $quantity); 
						$total_affiliate_commission += ($affiliate_commission * $quantity);
						$goods_total += $item_total;
						if ($item_tax_free != 1) {
							$goods_taxable += $item_total;
						}
						$total_quantity += $quantity;
						$weight_total += ($weight * $quantity);

						$item_text  = $item_name;
						if (strlen($properties_values_text)) {
							$item_text .= " (" . $properties_values_text . ")";
						}
						$item_text .= " " . PROD_QTY_COLUMN . ":" . $quantity . " " . $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right;
						$items_text .= $item_text . $eol;

						$t->set_var("price", $currency_left . number_format($price * $currency_rate, 2) . $currency_right);
						$t->set_var("item_total", $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right);
						if ($tax_available) {
							$item_tax = get_tax_amount($tax_rates, $item_type_id, $item_total, $item_tax_free);
							list($item_tax_percent, $item_tax_total) = $item_tax;
							$goods_tax_total += $item_tax_total;
							$t->set_var("item_tax_percent",  $item_tax_percent . "%");
							$t->set_var("item_tax_total", $currency_left . number_format($item_tax_total * $currency_rate, 2) . $currency_right);
							$t->sparse("item_tax", false);
							$cart_items[$components_ids[$c]]["tax_percent"] = $item_tax_percent;
						}

						$t->parse("items", true);
					}
				}
			}

		}

		// show information about order coupons
		$max_discount = $goods_total; $max_tax_discount = $goods_tax_total;
		if (is_array($coupons)) {
			foreach ($coupons as $coupon_id => $coupon_info) {
				$coupon_id = $coupon_info["COUPON_ID"];
				$sql  = " SELECT * FROM " . $table_prefix . "coupons ";
				$sql .= " WHERE coupon_id=" . $db->tosql($coupon_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$is_active = $db->f("is_active");
					$discount_type = $db->f("discount_type");
					$coupon_discount = $db->f("discount_amount");
					$minimum_amount = $db->f("minimum_amount");
					$quantity_limit = $db->f("quantity_limit");
					$coupon_uses = $db->f("coupon_uses");
					$coupon_free_postage = $db->f("free_postage");
					$coupon_tax_free = $db->f("tax_free");
					if (!$is_active) {
						remove_coupon($coupon_id);
					} elseif ($quantity_limit > 0 && $coupon_uses >= $quantity_limit) {
						remove_coupon($coupon_id);
					} elseif ($goods_total < $minimum_amount) {
						remove_coupon($coupon_id);
					} else {
						// show coupon information if no errors occurred
						if ($coupon_free_postage) { $free_postage = true; }
						if ($coupon_tax_free) { $tax_free = true; }
						if (strlen($order_coupons_ids)) { $order_coupons_ids .= ","; }
						$order_coupons_ids .= $coupon_id;
						if ($discount_type == 1) {
							$discount_amount = round(($goods_total / 100) * $coupon_discount, 2);
						} else {
							$discount_amount = $coupon_discount;
						}
						if ($discount_amount > $max_discount) {
							$discount_amount = $max_discount;
						}
						$max_discount -= $discount_amount; 
						if ($discount_type == 5) {
							$gift_vouchers[$coupon_id] = $discount_amount;
						}
						$t->set_var("coupon_title", $db->f("coupon_title"));
						$t->set_var("discount_amount", "- " . $currency_left . number_format($discount_amount * $currency_rate, 2) . $currency_right);
						if ($tax_available) {
							$discount_tax_amount = round(($discount_amount * $goods_tax_total) / $goods_total, 2);
							if ($discount_tax_amount > $max_tax_discount) {
								$discount_tax_amount = $max_tax_discount;
							}
							$max_tax_discount -= $discount_tax_amount;
							$total_discount_tax += $discount_tax_amount;
							$t->set_var("discount_tax_amount", "- " . $currency_left . number_format($discount_tax_amount * $currency_rate, 2) . $currency_right);
							$t->sparse("discount_tax", false);
						}

						$total_discount += $discount_amount;
			      
						$t->parse("coupons", true);
					}
				} 
			}
		}
		// value for goods with applied discount
		$goods_value = $goods_total - $total_discount;
		$goods_tax_value = $goods_tax_total - $total_discount_tax;
		if ($total_discount > 0) {
			$goods_taxable = $goods_taxable - round(($goods_taxable * $total_discount) / $goods_total, 2);
		}


		if ($is_update) {
			set_session("shopping_cart", $shopping_cart);
		}
		$t->set_var("properties_ids", $properties_ids);

		$t->set_var("total_quantity", $total_quantity);
		$variables["total_quantity"] = $total_quantity;
		$t->set_var("total_items", $total_items);
		$variables["total_items"] = $total_items;

		$t->set_var("goods_value", $goods_value);
		$t->set_var("goods_tax_value", $goods_tax_value);

		$t->set_var("taxable_value", $goods_taxable);
		$t->set_var("goods_total", $currency_left . number_format($goods_total * $currency_rate, 2) . $currency_right);
		$t->set_var("goods_taxable", $currency_left . number_format($goods_taxable * $currency_rate, 2) . $currency_right);
		if ($tax_available) {
			$t->set_var("goods_tax_total", $currency_left . number_format($goods_tax_total * $currency_rate, 2) . $currency_right);
			$t->sparse("goods_tax", false);
		}

		$items_text .= GOODS_TOTAL_MSG . ": " . $currency_left . number_format($goods_total * $currency_rate, 2) . $currency_right . $eol;

		if ($total_discount > 0) {
			$items_text .= TOTAL_DISCOUNT_MSG . ": -" . $currency_left . number_format($total_discount * $currency_rate, 2) . $currency_right . $eol;
			$items_text .= GOODS_WITH_DISCOUNT_MSG. ": " . $currency_left . number_format(($goods_total - $total_discount) * $currency_rate, 2) . $currency_right . $eol;
			$t->set_var("total_discount", "- " . $currency_left . number_format($total_discount * $currency_rate, 2) . $currency_right);
			$t->set_var("goods_with_discount", $currency_left . number_format(($goods_total - $total_discount) * $currency_rate, 2) . $currency_right);
			if ($tax_available) {
				$t->set_var("total_discount_tax_amount", "- " . $currency_left . number_format($total_discount_tax * $currency_rate, 2) . $currency_right);
				$t->set_var("discounted_tax_amount", $currency_left . number_format(($goods_tax_total - $total_discount_tax)* $currency_rate, 2) . $currency_right);
				$t->sparse("total_discount_tax", false);
				$t->sparse("discounted_tax", false);
			}
			$t->parse("discount", false);
		} else {
			$t->set_var("discount", "");
		}

		$order_total = round($goods_value, 2);

	}
	$basket_parsed = false;

	// check order restrictions
	$order_min_goods_cost = get_setting_value($order_info, "order_min_goods_cost", "");
	$order_max_goods_cost = get_setting_value($order_info, "order_max_goods_cost", "");
	$order_min_weight = get_setting_value($order_info, "order_min_weight", "");
	$order_max_weight = get_setting_value($order_info, "order_max_weight", "");
	$weight_measure = get_setting_value($settings, "weight_measure", "");
	if ($order_min_goods_cost && $goods_total < $order_min_goods_cost) {
		$sc_errors .= str_replace("{min_cost}", $currency_left . number_format($order_min_goods_cost * $currency_rate, 2) . $currency_right, ORDER_MIN_PRODUCTS_COST_ERROR) . "<br>";
	}
	if ($order_max_goods_cost && $goods_total > $order_max_goods_cost) {
		$sc_errors .= str_replace("{max_cost}", $currency_left . number_format($order_max_goods_cost* $currency_rate, 2) . $currency_right, ORDER_MAX_PRODUCTS_COST_ERROR) . "<br>";
	}
	if ($order_min_weight && $weight_total < $order_min_weight) {
		$sc_errors .= str_replace("{min_weight}", $order_min_weight." ".$weight_measure, ORDER_MIN_WEIGHT_ERROR) . "<br>";
	}
	if ($order_max_weight && $weight_total > $order_max_weight) {
		$sc_errors .= str_replace("{max_weight}", $order_max_weight." ".$weight_measure, ORDER_MAX_WEIGHT_ERROR) . "<br>";
	}


	if (!$total_items)
	{
		header("Location: basket.php");
		exit;
	}

	// show currency block
	$currency_block = get_setting_value($order_info, "currency_block", 0);
	if ($currency_block) {
		include_once("./block_currency.php");
		currency_form("currency_block", $currency_block);
	}


	$r = new VA_Record($table_prefix . "orders");

	// prepare shipping
	$shipping_type_id = ""; $shipping_type_desc = ""; $tare_weight = 0; $shipping_cost = 0; $total_shipping_types = 0; 
	$shipping_taxable = 0; $shipping_taxable_value = 0;
	if ($country_code) {
		$shipping_modules = array();
	  $sql  = " SELECT * FROM " . $table_prefix . "shipping_modules ";
		$sql .= " WHERE is_active=1 ";
		$db->query($sql);
		while ($db->next_record()) {
			$shipping_module_id = $db->f("shipping_module_id");
			$shipping_module_name = $db->f("shipping_module_name");
			$is_external = $db->f("is_external");
			$php_external_lib = $db->f("php_external_lib");
			$external_url = $db->f("external_url");
			$shipping_modules[] = array($shipping_module_id, $shipping_module_name, $is_external, $php_external_lib, $external_url);
		}
	
		$shipping_types = array();
		for ($sm = 0; $sm < sizeof($shipping_modules); $sm++) {
			list ($shipping_module_id, $shipping_module_name, $is_external, $php_external_lib, $external_url) = $shipping_modules[$sm];
			$module_shipping = array();
			$sql  = " SELECT st.shipping_type_id, st.shipping_type_code, st.shipping_type_desc, st.shipping_time, ";
			$sql .= " st.cost_per_order, st.cost_per_product, st.cost_per_weight, st.tare_weight, st.is_taxable ";
			$sql .= " FROM " . $table_prefix . "shipping_types st, " . $table_prefix . "shipping_types_countries stc ";
			$sql .= " WHERE st.shipping_type_id=stc.shipping_type_id ";
			$sql .= " AND st.is_active=1 ";
			$sql .= " AND stc.country_code=" . $db->tosql($country_code, TEXT);
			$sql .= " AND st.min_weight<=" . $db->tosql($weight_total, NUMBER);
			$sql .= " AND st.max_weight>=" . $db->tosql($weight_total, NUMBER);
			$sql .= " AND st.min_goods_cost<=" . $db->tosql($goods_total, NUMBER);
			$sql .= " AND st.max_goods_cost>=" . $db->tosql($goods_total, NUMBER);
			$sql .= " AND st.shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER);
			$sql .= " ORDER BY st.shipping_order, st.shipping_type_id ";
			$db->query($sql);
			while ($db->next_record()) {
				$row_shipping_type_id = $db->f("shipping_type_id");
				$row_shipping_type_code = $db->f("shipping_type_code");
				$row_shipping_type_desc = $db->f("shipping_type_desc");
				$row_shipping_time = $db->f("shipping_time");
				$cost_per_order = $db->f("cost_per_order");
				$cost_per_product = $db->f("cost_per_product");
				$cost_per_weight = $db->f("cost_per_weight");
				$row_tare_weight = $db->f("tare_weight");
				$row_shipping_taxable = $db->f("is_taxable");
				$row_shipping_cost = $cost_per_order + ($cost_per_product * $total_quantity) + ($cost_per_weight * ($weight_total + $row_tare_weight));

				$shipping_type = array($row_shipping_type_id, $row_shipping_type_code, $row_shipping_type_desc, $row_shipping_cost, $row_tare_weight, $row_shipping_taxable, $row_shipping_time);
				$module_shipping[] = $shipping_type;
				if (!$is_external) {
					$shipping_types[] = $shipping_type;
				}
			}
			
			if ($is_external && strlen($php_external_lib)) {
				$module_params = array();
				$sql  = " SELECT * FROM " . $table_prefix . "shipping_modules_parameters ";
				$sql .= " WHERE shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER);
				$sql .= " AND not_passed<>1 ";
				$db->query($sql);
				while ($db->next_record()) {
					$param_name = $db->f("parameter_name");
					$param_source = $db->f("parameter_source");
					$module_params[$param_name] = $param_source;
				}
				include($php_external_lib);
			}

		}

		$shipping_type_id_param = get_param("shipping_type_id");
		for ($st = 0; $st < sizeof($shipping_types); $st++) {
			$total_shipping_types++;
			list ($row_shipping_type_id, $row_shipping_type_code, $row_shipping_type_desc, $row_shipping_cost, $row_tare_weight, $row_shipping_taxable, $row_shipping_time) = $shipping_types[$st];
			
			if ($free_postage) { $row_shipping_cost = 0; }
			if ($row_shipping_type_id == $shipping_type_id_param) {
				$shipping_type_id   = $row_shipping_type_id;
				$shipping_type_desc = $row_shipping_type_desc;
				$shipping_time = $row_shipping_time;
				$shipping_cost = $row_shipping_cost;
				$tare_weight = $row_tare_weight;
				$shipping_taxable = $row_shipping_taxable;
				if ($shipping_taxable) {
					$shipping_taxable_value = $shipping_cost;
				}
				$items_text .= $shipping_type_desc . ": " . $currency_left . number_format($shipping_cost * $currency_rate, 2) . $currency_right . $eol;
				$t->set_var("shipping_type_checked", "checked");
				$t->set_var("shipping_cost_selected", $currency_left . number_format($row_shipping_cost * $currency_rate, 2) . $currency_right);
			} else {
				$t->set_var("shipping_type_checked", "");
				$t->set_var("shipping_cost_selected", "");
			}
			$t->set_var("shipping_type_id", $row_shipping_type_id);
			$t->set_var("shipping_value", round($row_shipping_cost, 2));
			$t->set_var("shipping_cost_desc", $currency_left . number_format($row_shipping_cost * $currency_rate, 2) . $currency_right);
			$t->set_var("shipping_type_desc", $row_shipping_type_desc);
			$t->set_var("shipping_taxable", intval($row_shipping_taxable));
			$t->parse("shipping_types", true);
		}

		if ($total_shipping_types == 1) {
			$shipping_type_id   = $row_shipping_type_id;
			$shipping_type_desc = $row_shipping_type_desc;
			$shipping_time = $row_shipping_time;
			$shipping_cost = $row_shipping_cost;
			$tare_weight = $row_tare_weight;
			$shipping_taxable = $row_shipping_taxable;
			if ($shipping_taxable) {
				$shipping_taxable_value = $shipping_cost;
			}
			$items_text .= $shipping_type_desc . ": " . $currency_left . number_format($shipping_cost * $currency_rate, 2) . $currency_right . $eol;
			$t->set_var("shipping_types", "");
			$t->parse("shipping_type", false);
		}
	}
	$t->set_var("shipping_selected_cost", $shipping_cost);
	$t->set_var("shipping_taxable_value", $shipping_taxable_value);

	// calculate the tax
	if ($tax_available) {
		//$taxable_amount = (round($goods_taxable, 2) + round($properties_taxable, 2) + round($shipping_taxable_value, 2));
		$taxable_amount = round($properties_taxable, 2) + round($shipping_taxable_value, 2);
		$tax_percent = $tax_free ? 0 : $tax_percent;
		$tax_cost = $tax_free ? 0 : $goods_tax_total - $total_discount_tax + (($taxable_amount * $tax_percent) / 100);
		$tax_cost = round($tax_cost, 2);
		$t->set_var("tax_percent", $tax_percent);
		$t->set_var("tax_free", $tax_free);
		$t->set_var("tax_name", $tax_name);
		$t->set_var("tax_cost", $currency_left . number_format($tax_cost * $currency_rate, 2) . $currency_right);
		$t->set_var("tax_total", $currency_left . number_format($tax_cost * $currency_rate, 2) . $currency_right);
		$t->parse("tax", false);
		$items_text .= $tax_name . ": " . $currency_left . number_format($tax_cost * $currency_rate, 2) . $currency_right . $eol;
		if ($tax_free) {
			$goods_tax_total = 0;
			$goods_tax_value = 0;
			$total_discount_tax = 0;
		}
	}

	$order_total += round($properties_total, 2) + round($shipping_cost, 2) + $tax_cost;

	// payment systems
	$sql = " SELECT COUNT(*) FROM " . $table_prefix . "payment_systems WHERE is_active=1 ";
	$db->query($sql);
	$db->next_record();
	$total_payments = $db->f(0);
	$payment_id = ""; $is_processing_fee = false; $processing_fees = ""; $processing_fee = 0; $fee_type = 0; $processing_time = 0;
	$payment_url = ""; $payment_method = "GET"; $payment_advanced = 0;
	if ($total_payments == 1) {
		$sql  = " SELECT payment_id,payment_name,recurring_method,processing_fee,fee_type,fee_min_goods,fee_max_goods,processing_time, ";
		$sql .= " payment_url, submit_method, is_advanced ";
		$sql .= " FROM " . $table_prefix . "payment_systems WHERE is_active=1 ";
		$db->query($sql);
		if ($db->next_record()) {
			$payment_id = $db->f("payment_id");
			$payment_name = $db->f("payment_name");
			$payment_url = $db->f("payment_url");
			$payment_method = $db->f("submit_method");
			$payment_advanced = $db->f("is_advanced");

			$recurring_method = $db->f("recurring_method");
			if ($recurring_items && !$recurring_method) {
				$sc_errors = str_replace("{payment_name}", $row_payment_name, RECURRING_NOT_ALLOWED_ERROR) . "<br>";
			}
			$fee_type = $db->f("fee_type");
			$processing_fee = $db->f("processing_fee");
			$fee_min_goods = $db->f("fee_min_goods");
			$fee_max_goods = $db->f("fee_max_goods");
			if ((strlen($fee_max_goods) && $goods_total > $fee_max_goods) || $goods_total < $fee_min_goods) {
				$processing_fee = 0;
			}
			$processing_time = $db->f("processing_time");
			if ($processing_fee != 0) {
				$is_processing_fee = true;
			}
			$processing_fees = $payment_id . "," . intval($fee_type) . "," . round($processing_fee, 2);
		}
	} elseif ($total_payments > 0) {
		if (strlen($operation)) {
			$payment_id = get_param("payment_id");
		} else {
			$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems WHERE is_active=1 AND is_default=1 ";
			$payment_id = get_db_value($sql);
		}
		$payment_systems = array(array("", ""));
		$sql  = " SELECT payment_id,payment_name,recurring_method,processing_fee,fee_type,fee_min_goods,fee_max_goods,processing_time, ";
		$sql .= " payment_url, submit_method, is_advanced ";
		$sql .= " FROM " . $table_prefix . "payment_systems WHERE is_active=1";
		$db->query($sql);
		while ($db->next_record()) {
			$row_payment_id = $db->f("payment_id");
			$row_recurring_method = $db->f("recurring_method");
			$row_payment_name = get_translation($db->f("payment_name"));
			$row_processing_fee = $db->f("processing_fee");
			$fee_min_goods = $db->f("fee_min_goods");
			$fee_max_goods = $db->f("fee_max_goods");
			if ((strlen($fee_max_goods) && $goods_total > $fee_max_goods) || $goods_total < $fee_min_goods) {
				$row_processing_fee = 0;
			}
			$row_fee_type = $db->f("fee_type");
			$row_processing_time = $db->f("processing_time");
			if ($processing_fees) { $processing_fees .= ","; }
			$processing_fees .= $row_payment_id . "," . intval($row_fee_type) . "," . round($row_processing_fee, 2);
			if ($row_payment_id == $payment_id) {
				$payment_url = $db->f("payment_url");
				$payment_method = $db->f("submit_method");
				$payment_advanced = $db->f("is_advanced");
				if ($recurring_items && !$row_recurring_method) {
					$sc_errors = str_replace("{payment_name}", $row_payment_name, RECURRING_NOT_ALLOWED_ERROR) . "<br>";
				}
				$processing_fee = $row_processing_fee;
				$fee_type = $row_fee_type;
				$processing_time = $row_processing_time;
			}
			if ($row_processing_fee > 0) {
				$is_processing_fee = true;
				if ($row_fee_type == 1) {
					$row_payment_name .= " (+ " . number_format($row_processing_fee, 2) . "%)";
				} else {
					$row_payment_name .= " (+ " . $currency_left . number_format($row_processing_fee * $currency_rate, 2) . $currency_right . ")";
				}
			} elseif ($row_processing_fee < 0) {
				$is_processing_fee = true;
				if ($row_fee_type == 1) {
					$row_payment_name .= " (- " . abs(number_format($row_processing_fee, 2)) . "%)";
				} else {
					$row_payment_name .= " (- " . $currency_left . number_format(abs($row_processing_fee * $currency_rate), 2) . $currency_right . ")";
				}
			}
			$payment_systems[] = array($row_payment_id, $row_payment_name);
		}		
		set_options($payment_systems, $payment_id, "payment_id");
		$t->parse("payment_gateways", false);

	} else {
		$payment_id = "";
		$r->errors  = "Sorry, but there is no active payment system.";
	}

	if ($is_processing_fee) {
		if ($fee_type == 1) {
			$processing_fee = round(($order_total * $processing_fee) / 100, 2);
		} 
		$t->set_var("processing_fee_cost", $currency_left . number_format($processing_fee * $currency_rate, 2) . $currency_right);
		$t->sparse("fee", false);

		$items_text .= PROCESSING_FEE_MSG . ": " . $currency_left . number_format($processing_fee * $currency_rate, 2) . $currency_right;
		$order_total += $processing_fee;
	}
	$t->set_var("processing_fees", $processing_fees);


	// order total string
	$items_text .= CART_TOTAL_MSG . ": " . $currency_left . number_format($order_total * $currency_rate, 2) . $currency_right;
	$t->set_var("order_total_desc", $currency_left . number_format($order_total * $currency_rate, 2) . $currency_right);
	
	$r->add_where("order_id", INTEGER);
	$r->add_textbox("user_id", INTEGER);
	$r->add_textbox("user_type_id", INTEGER);
	$r->add_textbox("payment_id", INTEGER, PAYMENT_GATEWAY_MSG);
	if ($total_payments > 1) {
		$r->change_property("payment_id", REQUIRED, true);
	} 
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("initial_ip", TEXT);
	$r->add_textbox("cookie_ip", TEXT);
	$r->add_textbox("visit_id", INTEGER);
	$r->change_property("visit_id", USE_SQL_NULL, false);
	$r->add_textbox("affiliate_code", TEXT);
	$r->change_property("affiliate_code", USE_SQL_NULL, false);
	$r->add_textbox("affiliate_user_id", INTEGER);
	$r->change_property("affiliate_user_id", USE_SQL_NULL, false);
	$r->add_textbox("keywords", TEXT);
	$r->change_property("keywords", USE_SQL_NULL, false);
	$r->add_textbox("coupons_ids", TEXT);
	$r->add_textbox("currency_code", TEXT);
	$r->add_textbox("currency_rate", FLOAT);
	$r->add_textbox("order_status", INTEGER);
	$r->add_textbox("total_buying", NUMBER);
	$r->add_textbox("total_merchants_commission", NUMBER);
	$r->add_textbox("total_affiliate_commission", NUMBER);
	$r->add_textbox("goods_total", NUMBER);
	$r->add_textbox("goods_taxable", NUMBER);
	$r->add_textbox("total_quantity", NUMBER);
	$r->add_textbox("weight_total", NUMBER);
	$r->add_textbox("total_discount", NUMBER);
	$r->add_textbox("total_discount_tax", NUMBER);
	$r->add_textbox("properties_total", NUMBER);
	$r->add_textbox("properties_taxable", NUMBER);
	$r->add_textbox("shipping_type_id", INTEGER);
	$r->add_textbox("shipping_type_desc", TEXT);
	$r->add_textbox("shipping_cost", NUMBER);
	$r->add_textbox("shipping_taxable", INTEGER);
	$r->add_textbox("shipping_expecting_date", DATETIME);
	$r->add_textbox("tax_name", TEXT);
	$r->add_textbox("tax_percent", NUMBER);
	$r->add_textbox("tax_total", NUMBER);
	$r->add_textbox("processing_fee", NUMBER);
	$r->add_textbox("order_total", NUMBER);
	$r->add_textbox("order_placed_date", DATETIME);

	$companies = get_db_values("SELECT company_id,company_name FROM " . $table_prefix . "companies ", array(array("", SELECT_COMPANY_MSG)));
	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states ORDER BY state_name ", array(array("", SELECT_STATE_MSG)));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ", array(array("", SELECT_COUNTRY_MSG)));

	$r->add_textbox("name", TEXT, NAME_FIELD);
	$r->change_property("name", USE_SQL_NULL, false);
	$r->add_textbox("first_name", TEXT, FIRST_NAME_FIELD);
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->add_textbox("last_name", TEXT, LAST_NAME_FIELD);
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->add_select("company_id", INTEGER, $companies, COMPANY_SELECT_FIELD);
	$r->add_textbox("company_name", TEXT, COMPANY_NAME_FIELD);
	$r->add_textbox("email", TEXT, EMAIL_FIELD);
	$r->change_property("email", USE_SQL_NULL, false);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("address1", TEXT, STREET_FIRST_FIELD);
	$r->add_textbox("address2", TEXT, STREET_SECOND_FIELD);
	$r->add_textbox("city", TEXT, CITY_FIELD);
	$r->add_textbox("province", TEXT, PROVINCE_FIELD);
	$r->add_select("state_code", TEXT, $states, STATE_FIELD);
	$r->add_textbox("zip", TEXT, ZIP_FIELD);
	$r->add_select("country_code", TEXT, $countries, COUNTRY_FIELD);
	$r->add_textbox("phone", TEXT, PHONE_FIELD);
	$r->add_textbox("daytime_phone", TEXT, DAYTIME_PHONE_FIELD);
	$r->add_textbox("evening_phone", TEXT, EVENING_PHONE_FIELD);
	$r->add_textbox("cell_phone", TEXT, CELL_PHONE_FIELD);
	$r->add_textbox("fax", TEXT, FAX_FIELD);

	$r->add_textbox("delivery_name", TEXT, DELIVERY_MSG." ".NAME_FIELD);
	$r->add_textbox("delivery_first_name", TEXT, DELIVERY_MSG." ".FIRST_NAME_FIELD);
	$r->add_textbox("delivery_last_name", TEXT, DELIVERY_MSG." ".LAST_NAME_FIELD);
	$r->add_select("delivery_company_id", INTEGER, $companies, DELIVERY_MSG." ".COMPANY_SELECT_FIELD);
	$r->add_textbox("delivery_company_name", TEXT, DELIVERY_MSG." ".COMPANY_NAME_FIELD);
	$r->add_textbox("delivery_email", TEXT, DELIVERY_MSG." ".EMAIL_FIELD);
	$r->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("delivery_address1", TEXT, DELIVERY_MSG." ".STREET_FIRST_FIELD);
	$r->add_textbox("delivery_address2", TEXT, DELIVERY_MSG." ".STREET_SECOND_FIELD);
	$r->add_textbox("delivery_city", TEXT, DELIVERY_MSG." ".CITY_FIELD);
	$r->add_textbox("delivery_province", TEXT, DELIVERY_MSG." ".PROVINCE_FIELD);
	$r->add_select("delivery_state_code", TEXT, $states, DELIVERY_MSG." ".STATE_FIELD);
	$r->add_textbox("delivery_zip", TEXT, DELIVERY_MSG." ".ZIP_FIELD);
	$r->add_select("delivery_country_code", TEXT, $countries, DELIVERY_MSG." ".COUNTRY_FIELD);
	$r->add_textbox("delivery_phone", TEXT, DELIVERY_MSG." ".PHONE_FIELD);
	$r->add_textbox("delivery_daytime_phone", TEXT, DELIVERY_MSG." ".DAYTIME_PHONE_FIELD);
	$r->add_textbox("delivery_evening_phone", TEXT, DELIVERY_MSG." ".EVENING_PHONE_FIELD);
	$r->add_textbox("delivery_cell_phone", TEXT, DELIVERY_MSG." ".CELL_PHONE_FIELD);
	$r->add_textbox("delivery_fax", TEXT, DELIVERY_MSG." ".FAX_FIELD);

	$personal_number = 0;
	$delivery_number = 0;
	for ($i = 0; $i < sizeof($parameters); $i++)
	{                         
		$param_name = $parameters[$i];
		$r->change_property($param_name, TRIM, true);
		$r->change_property("delivery_" . $param_name, TRIM, true);
           
		$personal_param = "show_" . $parameters[$i];
		$delivery_param = "show_delivery_" . $parameters[$i];
		if (isset($order_info[$personal_param]) && $order_info[$personal_param] == 1) {
			$personal_number++;
			if ($order_info[$parameters[$i] . "_required"] == 1) {
				$r->parameters[$parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if (isset($order_info[$delivery_param]) && $order_info[$delivery_param] == 1) {
			$delivery_number++;
			if ($order_info["delivery_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters["delivery_" . $parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_checkbox("same_as_personal", INTEGER);
	$r->change_property("same_as_personal", USE_IN_SELECT, false);
	$r->change_property("same_as_personal", USE_IN_INSERT, false);
	$r->change_property("same_as_personal", USE_IN_UPDATE, false);
	if ($personal_number < 1 || $delivery_number < 1) {
		$r->parameters["same_as_personal"][SHOW] = false;
	}
	$r->add_checkbox("subscribe", INTEGER);
	$r->change_property("subscribe", USE_IN_SELECT, false);
	$r->change_property("subscribe", USE_IN_INSERT, false);
	$r->change_property("subscribe", USE_IN_UPDATE, false);
	if (!$subscribe_block) {
		$r->parameters["subscribe"][SHOW] = false;
	}

	$r->get_form_values();
	$r->set_value("user_id", $user_id);
	$r->set_value("user_type_id", $user_type_id);
	$r->set_value("payment_id", $payment_id);
	$r->set_value("remote_address", $user_ip);
	$r->set_value("initial_ip", $initial_ip);
	$r->set_value("cookie_ip", $cookie_ip);
	$r->set_value("visit_id", $visit_id);
	$r->set_value("affiliate_code", $affiliate_code);
	$r->set_value("affiliate_user_id", $affiliate_user_id);
	$r->set_value("keywords", $keywords);
	$r->set_value("properties_total", $properties_total);
	$r->set_value("properties_taxable", $properties_taxable);
	$r->set_value("tax_name", $tax_name);
	$r->set_value("tax_percent", $tax_percent);
	$r->set_value("tax_total", $tax_cost);
	$r->set_value("processing_fee", $processing_fee);
	$r->set_value("currency_code", $currency_code);
	$r->set_value("currency_rate", $currency_rate);
	if ($order_info["show_delivery_country_code"] != 1 && $order_info["show_country_code"] != 1) {
		$r->set_value("country_code", $country_code);
		$r->set_value("delivery_country_code", $country_code);
	} 
	$variables["user_id"] = $r->get_value("user_id");
	$variables["tax_name"] = $tax_name;
	$variables["tax_percent"] = $tax_percent;

	if ($delivery_errors) {
		$delivery_errors = str_replace("{country_name}", get_array_value($country_code, $countries), $delivery_errors);
		$sc_errors .= $delivery_errors;
	}

	if (strlen($operation))
	{
		if ($is_update) {
			if ($total_shipping_types > 1 && !strlen($shipping_type_id)) {
				$r->errors .= REQUIRED_DELIVERY_MSG;
			}
	    
			if ($r->get_value("same_as_personal")) {
				for ($i = 0; $i < sizeof($parameters); $i++) { 
					$personal_param = "show_" . $parameters[$i];
					$delivery_param = "show_delivery_" . $parameters[$i];
					if (isset($order_info[$delivery_param]) && isset($order_info[$personal_param]) &&
						$order_info[$delivery_param] == 1 && $order_info[$personal_param] == 1) {
						$r->set_value("delivery_" . $parameters[$i], $r->get_value($parameters[$i]));
					}
				}
			}
	  
			$r->validate();
			$r->errors .= $options_errors;	
			if (strlen($r->errors) || strlen($sc_errors)) {
				$is_valid = false;
			} else {
				$is_valid = true;
			}
		} else {
			$is_valid = false;
		}

		if ($is_valid && check_black_ip()) {
			$r->errors = BLACK_IP_MSG;
			$is_valid = false;
		}


		if ($is_valid)
		{
			// get payment rate for the selected gateway
			$payment_rate = get_payment_rate($payment_id, $currency_rate);
			$variables["tax_cost"] = number_format($tax_cost * $payment_rate, 2, ".", "");
			$variables["tax_total"] = number_format($tax_cost * $payment_rate, 2, ".", "");
			$variables["processing_fee"] = number_format($processing_fee * $payment_rate, 2, ".", "");

			$new_order_status = 1;
			// set status to zero when adding order
			$r->set_value("order_status", 0);

			$variables["total_buying"] = number_format($total_buying * $payment_rate, 2, ".", "");
			$variables["total_merchants_commission"] = number_format($total_merchants_commission * $payment_rate, 2, ".", "");
			$variables["total_affiliate_commission"] = number_format($total_affiliate_commission * $payment_rate, 2, ".", "");
			$variables["goods_total"] = number_format($goods_total * $payment_rate, 2, ".", "");
			$variables["goods_taxable"] = number_format($goods_taxable * $payment_rate, 2, ".", "");
			$variables["weight_total"] = ($weight_total + $tare_weight);

			$variables["coupons_ids"] = $order_coupons_ids;
			$variables["currency_code"] = $currency_code;
			$variables["currency_value"] = $currency_value;
			$variables["currency_rate"] = $currency_rate;
			$variables["total_discount"] = number_format($total_discount * $payment_rate, 2, ".", "");
			$variables["total_discount_tax"] = number_format($total_discount_tax * $payment_rate, 2, ".", "");
			$goods_with_discount = $goods_total - $total_discount;
			$variables["goods_with_discount"] = number_format($goods_with_discount * $payment_rate, 2, ".", "");
			$variables["properties_total"] = number_format($properties_total * $payment_rate, 2, ".", "");
			$variables["properties_taxable"] = number_format($properties_taxable * $payment_rate, 2, ".", "");
			$variables["shipping_type_id"] = $shipping_type_id;
			$variables["shipping_type"] = $shipping_type_desc;
			$variables["shipping_cost"] = number_format($shipping_cost * $payment_rate, 2, ".", "");
			$variables["shipping_taxable"] = $shipping_taxable;

			// calculate shipping expecting date excluding sundays
			$handle_hours = $max_availability_time + $shipping_time + $processing_time;
			$shipping_expecting_date = get_expecting_date($handle_hours);
			$variables["shipping_expecting_date"] = $shipping_expecting_date;

			$r->set_value("total_buying", $total_buying);
			$r->set_value("total_merchants_commission", $total_merchants_commission);
			$r->set_value("total_affiliate_commission", $total_affiliate_commission);
			$r->set_value("goods_total",  $goods_total);
			$r->set_value("goods_taxable",  $goods_taxable);
			$r->set_value("total_quantity", $total_quantity);
			$r->set_value("weight_total",  ($weight_total + $tare_weight));

			$r->set_value("coupons_ids", $order_coupons_ids);
			$r->set_value("total_discount", $total_discount);
			$r->set_value("total_discount_tax", $total_discount_tax);
			$r->set_value("shipping_type_id", $shipping_type_id);
			$r->set_value("shipping_type_desc", $shipping_type_desc);
			$r->set_value("shipping_cost", $shipping_cost);
			$r->set_value("shipping_taxable", $shipping_taxable);
			$r->set_value("shipping_expecting_date", va_time($shipping_expecting_date));


			for ($i = 0; $i < sizeof($parameters); $i++) { 
				$variables[$parameters[$i]] = $r->get_value($parameters[$i]);
				$variables["delivery_" . $parameters[$i]] = $r->get_value("delivery_" . $parameters[$i]);
			}
			// prepare user name variables
			if (strlen($variables["name"]) && !strlen($variables["first_name"]) && !strlen($variables["last_name"])) {
				$name = $variables["name"];
				$name_parts = explode(" ", $name, 2);
				if (sizeof($name_parts) == 2) {
					$variables["first_name"] = $name_parts[0];
					$variables["last_name"] = $name_parts[1];
				} else {
					$variables["first_name"] = $name_parts[0];
					$variables["last_name"] = "";
				}
			} elseif (!strlen($variables["name"]) && (strlen($variables["first_name"]) || strlen($variables["last_name"]))) {
				$variables["name"] = trim($variables["first_name"] . " " . $variables["last_name"]);
			}


			$address = $r->get_value("address2") ? ($r->get_value("address1") . " " . $r->get_value("address2")) : $r->get_value("address1");
			$delivery_address = $r->get_value("delivery_address2") ? ($r->get_value("delivery_address1") . " " . $r->get_value("delivery_address2")) : $r->get_value("delivery_address1");
			$variables["address"] = $address;
			$variables["delivery_address"] = $delivery_address;
			$variables["company_select"] = get_array_value($r->get_value("company_id"), $companies);
			$variables["state"] = get_array_value($r->get_value("state_code"), $states);
			if (strlen($variables["state_code"])) {
				$variables["state_code_or_province"] = $variables["state_code"];
				$variables["state_or_province"] = $variables["state"];
			} else {
				$variables["state_code_or_province"] = $variables["province"];
				$variables["state_or_province"] = $variables["province"];
			}
			$variables["country"] = get_array_value($r->get_value("country_code"), $countries); 
			$country_number = "";
			$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$country_number = $db->f("country_iso_number");
			}
			$variables["country_number"] = $country_number;
			$variables["delivery_company_select"] = get_array_value($r->get_value("delivery_company_id"), $companies);
			$variables["delivery_state"] = get_array_value($r->get_value("delivery_state_code"), $states);
			if (strlen($variables["delivery_state_code"])) {
				$variables["delivery_state_code_or_province"] = $variables["delivery_state_code"];
				$variables["delivery_state_or_province"] = $variables["delivery_state"];
			} else {
				$variables["delivery_state_code_or_province"] = $variables["delivery_province"];
				$variables["delivery_state_or_province"] = $variables["delivery_province"];
			}
			$variables["delivery_country"] = get_array_value($r->get_value("delivery_country_code"), $countries); 
			$delivery_country_number = "";
			$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["delivery_country_code"], TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$delivery_country_number = $db->f("country_iso_number");
			}
			$variables["delivery_country_number"] = $delivery_country_number;
			$t->set_var("company_select", $variables["company_select"]);
			$t->set_var("state", $variables["state"]);
			$t->set_var("country", $variables["country"]);
			$t->set_var("delivery_company_select", $variables["delivery_company_select"]);
			$t->set_var("delivery_state", $variables["delivery_state"]);
			$t->set_var("delivery_country", $variables["delivery_country"]);

			$r->set_value("order_total",  $order_total);
			$variables["order_total"] = number_format($order_total * $payment_rate, 2, ".", "");
			$variables["order_total_100"] = round($order_total * $payment_rate * 100, 0);
			$variables["items"] = $items_text;
			$variables["basket"] = $items_text;
			$variables["description"] = $items_text;
  
			$t->parse("basket", false);
			$basket_parsed = true;

			$order_placed_date = va_time();
			$order_placed_date_string = va_date($datetime_show_format, $order_placed_date);
			$timestamp = mktime ($order_placed_date[HOUR], $order_placed_date[MINUTE], $order_placed_date[SECOND], $order_placed_date[MONTH], $order_placed_date[DAY], $order_placed_date[YEAR]);

			$variables["timestamp"] = $timestamp;
			$variables["order_placed_timestamp"] = $timestamp;
			$variables["order_placed_date"] = $order_placed_date;
			$r->set_value("order_placed_date", $order_placed_date);
			$order_added = true;
			// check if order was already placed
			$user_order_id = get_session("session_user_order_id");
			if ($user_order_id) {
				$sql  = " SELECT o.transaction_id, o.is_placed, o.order_status, os.paid_status ";
				$sql .= " FROM (" . $table_prefix . "orders o ";
				$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON o.order_status=os.status_id) ";
				$sql .= " WHERE o.order_id=" . $db->tosql($user_order_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$is_placed = $db->f("is_placed");
					$paid_status = $db->f("paid_status");
					$transaction_id = $db->f("transaction_id");
					if ($is_placed || $paid_status || strlen($transaction_id)) {
						$user_order_id = "";
					}
				} else {
					$user_order_id = "";
				}
			}
			if ($user_order_id) {
				$order_id = $user_order_id;
				$variables["order_id"] = $user_order_id;
				$r->set_value("order_id", $user_order_id);
				remove_orders($user_order_id, false);
				$order_added = $r->update_record();
			} else {
				if ($db_type == "postgre") {
					$order_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "orders') ");
					$variables["order_id"] = $order_id;
					$r->change_property("order_id", USE_IN_INSERT, true);
					$r->set_value("order_id", $order_id);
				}
				$order_added = $r->insert_record();
			}
			if ($order_added)
			{
				if (!$user_order_id) {
					if ($db_type == "mysql") {
						$order_id = get_db_value(" SELECT LAST_INSERT_ID() ");
						$r->set_value("order_id", $order_id);
						$variables["order_id"] = $order_id;
					} elseif ($db_type == "access") {
						$order_id = get_db_value(" SELECT @@IDENTITY ");
						$r->set_value("order_id", $order_id);
						$variables["order_id"] = $order_id;
					}
				}
				// increment used order coupons by one if they exists
				if (strlen($order_coupons_ids)) {
					$sql  = " UPDATE " . $table_prefix . "coupons SET coupon_uses=coupon_uses+1 ";
					$sql .= " WHERE coupon_id IN (" . $order_coupons_ids . ") ";
					$db->query($sql);
				}
				foreach ($gift_vouchers as $coupon_id => $coupon_amount) {
					if ($coupon_amount > 0) {
						$sql  = " UPDATE " . $table_prefix . "coupons ";
						$sql .= " SET discount_amount=discount_amount-" . $db->tosql($coupon_amount, NUMBER);
						$sql .= " WHERE coupon_id=" . $db->tosql($coupon_id, INTEGER);
						$db->query($sql);
					}
				}

				// subscribe/unsubscribe user from newsletter
				if ($subscribe_block) {
					$subscribe_email = $r->get_value("email");
					if (!$subscribe_email && $r->get_value("delivery_email")) {
						$subscribe_email = $r->get_value("delivery_email");
					}
					if ($subscribe_email) {
						if ($r->get_value("subscribe") == 1) {
							$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "newsletters_users ";
							$sql .= " WHERE email=" . $db->tosql($subscribe_email, TEXT);
							$db->query($sql);
							$db->next_record();
							$email_count = $db->f(0);
							if ($email_count < 1) {
								$sql  = " INSERT INTO " . $table_prefix . "newsletters_users (email, date_added) ";
								$sql .= " VALUES (";
								$sql .= $db->tosql($subscribe_email, TEXT) . ", ";
								$sql .= $db->tosql(va_time(), DATETIME) . ") ";
								$db->query($sql);
							} 
						} else {
							$sql  = " DELETE FROM " . $table_prefix . "newsletters_users ";
							$sql .= " WHERE email=" . $db->tosql($subscribe_email, TEXT);
							$db->query($sql);
						}
					}
				}


				$op = new VA_Record($table_prefix . "orders_properties");
				$op->add_textbox("order_id", INTEGER);
				$op->set_value("order_id", $order_id);
				$op->add_textbox("property_id", INTEGER);
				$op->add_textbox("property_order", INTEGER);
				$op->add_textbox("property_type", INTEGER);
				$op->add_textbox("property_name", TEXT);
				$op->add_textbox("property_value", TEXT);
				$op->add_textbox("property_price", FLOAT);
				$op->add_textbox("property_weight", FLOAT);
				$op->add_textbox("tax_free", INTEGER);
				foreach ($custom_options as $property_id => $property_info) {
					list ($property_type, $property_order, $property_name, $property_value, $property_price, $property_tax_free) = $property_info;
					$t->set_var("field_name_" . $property_id, $property_name);
					$t->set_var("field_value_" . $property_id, $property_value);
					$t->set_var("field_price_" . $property_id, $property_price);
					$t->set_var("field_" . $property_id, $property_value);
					$op->set_value("property_id", $property_id);
					$op->set_value("property_order", $property_order);
					$op->set_value("property_type", $property_type);
					$op->set_value("property_name", $property_name);
					$op->set_value("property_value", $property_value);
					$op->set_value("property_price", $property_price);
					$op->set_value("property_weight", 0);
					$op->set_value("tax_free", $property_tax_free);

					$op->insert_record();
				}

				$oi = new VA_Record($table_prefix . "orders_items");
				$oi->add_where("order_item_id", INTEGER);
				$oi->add_textbox("order_id", INTEGER);
				$oi->set_value("order_id", $order_id);
				$oi->add_textbox("user_id", INTEGER);
				$oi->set_value("user_id", $user_id);
				$oi->add_textbox("user_type_id", INTEGER);
				$oi->set_value("user_type_id", $user_type_id);
				$oi->add_textbox("item_id", INTEGER);
				$oi->add_textbox("parent_item_id", INTEGER);
				$oi->add_textbox("item_user_id", INTEGER);
				$oi->change_property("item_user_id", USE_SQL_NULL, false);
				$oi->add_textbox("affiliate_user_id", INTEGER);
				$oi->change_property("affiliate_user_id", USE_SQL_NULL, false);
				$oi->add_textbox("item_type_id", INTEGER);
				$oi->add_textbox("manufacturer_code", TEXT);
				$oi->add_textbox("coupons_ids", TEXT);
				$oi->add_textbox("item_status", INTEGER);
				$oi->set_value("item_status", 0);
				$oi->add_textbox("item_name", TEXT);
				$oi->add_textbox("item_properties", TEXT);
				$oi->add_textbox("buying_price", NUMBER);
				$oi->add_textbox("real_price", NUMBER);
				$oi->add_textbox("discount_amount", NUMBER);
				$oi->add_textbox("price", NUMBER);
				$oi->add_textbox("tax_free", INTEGER);
				$oi->add_textbox("tax_percent", NUMBER);
				$oi->add_textbox("merchant_commission", NUMBER);
				$oi->add_textbox("affiliate_commission", NUMBER);
				$oi->add_textbox("weight", NUMBER);
				$oi->add_textbox("quantity", NUMBER);
				$oi->add_textbox("downloadable", NUMBER);
				$oi->add_textbox("shipping_expecting_date", DATETIME);
				// recurring fields
				$oi->add_textbox("is_recurring", INTEGER);
				$oi->add_textbox("recurring_period", INTEGER);
				$oi->add_textbox("recurring_interval", INTEGER);
				$oi->add_textbox("recurring_payments_total", INTEGER);
				$oi->add_textbox("recurring_payments_made", INTEGER);
				$oi->add_textbox("recurring_payments_failed", INTEGER);
				$oi->add_textbox("recurring_end_date", DATETIME);
				$oi->add_textbox("recurring_last_payment", DATETIME);
				$oi->add_textbox("recurring_next_payment", DATETIME);
				$oi->add_textbox("recurring_plan_payment", DATETIME);
				// recurring fields
				$oi->add_textbox("is_subscription", INTEGER);
				$oi->add_textbox("subscription_period",   INTEGER);
				$oi->add_textbox("subscription_interval", INTEGER);
				$oi->add_textbox("subscription_suspend",  INTEGER);

				$oip = new VA_Record($table_prefix . "orders_items_properties");
				$oip->add_textbox("order_id", INTEGER);
				$oip->set_value("order_id", $order_id);
				$oip->add_textbox("order_item_id", INTEGER);
				$oip->add_textbox("property_id", INTEGER);
				$oip->add_textbox("property_name", TEXT);
				$oip->add_textbox("property_value", TEXT);
				$oip->add_textbox("property_values_ids", TEXT);
				$oip->add_textbox("additional_price", NUMBER);
				$oip->add_textbox("additional_weight", NUMBER);

				$r_id = new VA_Record($table_prefix . "items_downloads");
				$r_id->add_textbox("order_id", INTEGER);
				$r_id->set_value("order_id", $order_id);
				$r_id->add_textbox("user_id", INTEGER);
				$r_id->set_value("user_id", $user_id);
				$r_id->add_textbox("order_item_id", INTEGER);
				$r_id->add_textbox("item_id", INTEGER);
				$r_id->add_textbox("download_path", TEXT);
				$r_id->add_textbox("activated", INTEGER);
				$r_id->add_textbox("max_downloads", INTEGER);
				$r_id->add_textbox("download_added", DATETIME);
				$r_id->add_textbox("download_expiry", DATETIME);

				$ois = new VA_Record($table_prefix . "orders_items_serials");
				$ois->add_textbox("order_id", INTEGER);
				$ois->set_value("order_id", $order_id);
				$ois->add_textbox("user_id", INTEGER);
				$ois->set_value("user_id", $user_id);
				$ois->add_textbox("order_item_id", INTEGER);
				$ois->add_textbox("item_id", INTEGER);
				$ois->add_textbox("serial_number", TEXT);
				$ois->add_textbox("activated", INTEGER);
				$ois->add_textbox("activations_number", INTEGER);
				$ois->add_textbox("serial_added", DATETIME);
				$ois->add_textbox("serial_expiry", DATETIME);

				$sql  = " SELECT setting_value FROM " . $table_prefix . "global_settings ";
				$sql .= " WHERE setting_type='download_info' ";
				$sql .= " AND setting_name='max_downloads' ";
				$max_downloads = get_db_value($sql);

				// for ($i = 0; $i < sizeof($items); $i++)
				for ($i = 0; $i < sizeof($cart_items); $i++)
				{
					$cart_item = $cart_items[$i];
					$item_id = $cart_item["item_id"];
					$parent_item_id = $cart_item["parent_item_id"];
					$item_user_id = $cart_item["item_user_id"];
					$item_type_id = $cart_item["item_type_id"];
					$manufacturer_code = $cart_item["manufacturer_code"];
					$item_coupons_ids = $cart_item["coupons_ids"];
					$item_name = $cart_item["item_name"];
					$properties_info = $cart_item["properties_info"];
					$buying_price = $cart_item["buying_price"];
					$real_price = $cart_item["real_price"];
					$item_discount = $cart_item["discount_amount"];
					$price = $cart_item["price"];
					$item_tax_free = $cart_item["tax_free"];
					$item_tax_percent = $cart_item["tax_percent"];
					if ($tax_free || $user_tax_free) {
						$item_tax_percent = 0;
					}
					$merchant_commission = $cart_item["merchant_commission"];
					$affiliate_commission = $cart_item["affiliate_commission"];
					$weight = $cart_item["weight"];
					$quantity = $cart_item["quantity"];
					$stock_level = $cart_item["stock_level"];
					$availability_time = $cart_item["availability_time"];
					$downloadable = $cart_item["downloadable"];
					$download_period = $cart_item["download_period"];
					$download_path = $cart_item["download_path"];
					$generate_serial = $cart_item["generate_serial"];
					$serial_period = $cart_item["serial_period"];
					$activations_number = $cart_item["activations_number"];
					$is_gift_voucher = $cart_item["is_gift_voucher"];
					//recurring fields
					$is_recurring = $cart_item["is_recurring"];
					$recurring_period = $cart_item["recurring_period"];
					$recurring_interval = $cart_item["recurring_interval"];
					$recurring_payments_total = $cart_item["recurring_payments_total"];
					$recurring_start_date = $cart_item["recurring_start_date"];
					$recurring_end_date = $cart_item["recurring_end_date"];

					$is_subscription = $cart_item["is_subscription"];
					$subscription_period = $cart_item["subscription_period"];
					$subscription_interval = $cart_item["subscription_interval"];
					$subscription_suspend = $cart_item["subscription_suspend"];

					$oi->set_value("item_id", $item_id);
					$oi->set_value("parent_item_id", $parent_item_id);
					$oi->set_value("item_user_id", $item_user_id);
					$oi->set_value("affiliate_user_id", $affiliate_user_id);
					$oi->set_value("item_type_id", $item_type_id);
					$oi->set_value("manufacturer_code", $manufacturer_code);
					$oi->set_value("coupons_ids", $item_coupons_ids);
					$oi->set_value("item_name", $item_name);
					$oi->set_value("buying_price", $buying_price);
					$oi->set_value("real_price", $real_price);
					$oi->set_value("discount_amount", $item_discount);
					$oi->set_value("price", $price);
					$oi->set_value("tax_free", $item_tax_free);
					$oi->set_value("tax_percent", $item_tax_percent);
					$oi->set_value("merchant_commission", $merchant_commission);
					$oi->set_value("affiliate_commission", $affiliate_commission);
					$oi->set_value("weight", $weight);
					$oi->set_value("quantity", $quantity);
					$oi->set_value("downloadable", $downloadable);
					// calculate shipping expecting date excluding sundays
					$handle_hours = $availability_time + $shipping_time + $processing_time;
					$shipping_expecting_date = get_expecting_date($handle_hours);
					$oi->set_value("shipping_expecting_date", va_time($shipping_expecting_date));

					// set subscription fields
					$oi->set_value("is_subscription", $is_subscription);
					$oi->set_value("subscription_period",   $subscription_period);
					$oi->set_value("subscription_interval", $subscription_interval);
					$oi->set_value("subscription_suspend",  $subscription_suspend);

					// set recurring payments
					$oi->set_value("is_recurring", $is_recurring);
					$oi->set_value("recurring_payments_made", 0);
					if ($is_recurring) {
						$current_date = va_time();
						$current_ts = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY], $current_date[YEAR]);
						$recurring_next_payment = 0; $recurring_end_ts = 0;
						if (is_array($recurring_start_date)) {
							$recurring_start_ts = mktime (0, 0, 0, $recurring_start_date[MONTH], $recurring_start_date[DAY], $recurring_start_date[YEAR]);
							if ($recurring_start_ts > $current_ts) {
								$recurring_next_payment = $recurring_start_ts;
							}
						}
						if (!$recurring_next_payment) {
							if ($recurring_period == 1) {
								$recurring_next_payment = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY] + $recurring_interval, $current_date[YEAR]);
							} elseif ($recurring_period == 2) {
								$recurring_next_payment = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY] + ($recurring_interval * 7), $current_date[YEAR]);
							} elseif ($recurring_period == 3) {
								$recurring_next_payment = mktime (0, 0, 0, $current_date[MONTH] + $recurring_interval, $current_date[DAY], $current_date[YEAR]);
							} else {
								$recurring_next_payment = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY], $current_date[YEAR] + $recurring_interval);
							}
						}
						if (is_array($recurring_end_date)) {
							$recurring_end_ts = mktime (0, 0, 0, $recurring_end_date[MONTH], $recurring_end_date[DAY], $recurring_end_date[YEAR]);
							if ($recurring_next_payment > $recurring_end_ts) {
								$recurring_next_payment = 0;
							}
						}

						$oi->set_value("recurring_period", $recurring_period);
						$oi->set_value("recurring_interval", $recurring_interval);
						$oi->set_value("recurring_payments_total", $recurring_payments_total);
						$oi->set_value("recurring_end_date", $recurring_end_date);
						if ($recurring_next_payment) {
							$oi->set_value("recurring_next_payment", $recurring_next_payment);
							$oi->set_value("recurring_plan_payment", $recurring_next_payment);
						}
					}

					if ($db_type == "postgre") {
						$order_item_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "orders_items') ");
						$oi->change_property("order_item_id", USE_IN_INSERT, true);
						$oi->set_value("order_item_id", $order_item_id);
					}

					if ($oi->insert_record())
					{
						if ($db_type == "mysql") {
							$order_item_id = get_db_value(" SELECT LAST_INSERT_ID() ");
							$oi->set_value("order_item_id", $order_item_id);
						} elseif ($db_type == "access") {
							$order_item_id = get_db_value(" SELECT @@IDENTITY ");
							$oi->set_value("order_item_id", $order_item_id);
						}

						// increment used product coupons by one
						if (strlen($item_coupons_ids)) {
							$sql  = " UPDATE " . $table_prefix . "coupons SET coupon_uses=coupon_uses+1 ";
							$sql .= " WHERE coupon_id IN (" . $item_coupons_ids . ") ";
							$db->query($sql);
						}


						// add download link
						if ($downloadable) {
							$download_paths = split(";", $download_path);
							for ($dl = 0; $dl < sizeof($download_paths); $dl++) {
								$download_path_cur = trim($download_paths[$dl]);
								if ($download_path_cur) {
									$r_id->set_value("order_item_id", $order_item_id);
									$r_id->set_value("item_id", $item_id);
									$r_id->set_value("download_path", $download_path_cur);
						  
									$r_id->set_value("activated", $download_activated);
									$r_id->set_value("max_downloads", $max_downloads * $quantity);
									$r_id->set_value("download_added", va_time());
									if (strlen($download_period)) {
										$download_expiry =  va_timestamp() + (intval($download_period) * 86400);
										$r_id->set_value("download_expiry", va_time($download_expiry));
									}
									$r_id->insert_record();
								}
							}
						}

						if ($generate_serial) {
							for ($sn = $quantity; $sn > 0; $sn--) {
								$serial_number = generate_serial($order_item_id, $sn, $cart_item, $generate_serial);
								if ($serial_number) {
									$ois->set_value("order_item_id", $order_item_id);
									$ois->set_value("item_id", $item_id);
									$ois->set_value("serial_number", $serial_number);
									$ois->set_value("activated", $download_activated);
									$ois->set_value("activations_number", $activations_number);
									$ois->set_value("serial_added", va_time());
									if (strlen($serial_period)) {
										$serial_expiry =  va_timestamp() + (intval($serial_period) * 86400);
										$ois->set_value("serial_expiry", va_time($serial_expiry));
									}
									$ois->insert_record();
								}
							}
						}

						if ($is_gift_voucher) {
							for ($gf = $quantity; $gf > 0; $gf--) {
								$gift_voucher = generate_gift_voucher($order_id, $order_item_id, $item_name, $price);
							}
						}

						if (strlen($stock_level)) {
							$sql  = " UPDATE " . $table_prefix . "items SET ";
							$sql .= " stock_level=stock_level-" . $db->tosql($quantity, NUMBER);
							$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
							$sql .= " AND use_stock_level=1 ";
							$db->query($sql);
						} else {
							$sql  = " UPDATE " . $table_prefix . "items SET ";
							$sql .= " stock_level=" . $db->tosql(-$quantity, NUMBER);
							$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
							$sql .= " AND use_stock_level=1 ";
							$db->query($sql);
						}

						// add properties
						if (is_array($properties_info) && sizeof($properties_info) > 0) {
							$oip->set_value("order_item_id", $order_item_id);
							for ($pi = 0; $pi < sizeof($properties_info); $pi++) {
								list($property_id, $property_name, $property_value, $pr_add_price, $pr_add_weight, $pr_values) = $properties_info[$pi];

								// get all property values ids
								$property_values_ids = "";
								for ($pv = 0; $pv < sizeof($pr_values); $pv++) {
									list($item_property_id, $pr_use_stock, $pr_stock_level, $pr_download_path, $pr_download_period) = $pr_values[$pv];
									if ($property_values_ids) { $property_values_ids .= ","; } 
									$property_values_ids .= $item_property_id;
								}

								$oip->set_value("property_id", $property_id);
								$oip->set_value("property_name", $property_name);
								$oip->set_value("property_value", $property_value);
								$oip->set_value("property_values_ids", $property_values_ids);
								$oip->set_value("additional_price", $pr_add_price);
								$oip->set_value("additional_weight", $pr_add_weight);
								$oip->insert_record();

								for ($pv = 0; $pv < sizeof($pr_values); $pv++) {
									list($item_property_id, $pr_use_stock, $pr_stock_level, $pr_download_path, $pr_download_period) = $pr_values[$pv];

									if ($pr_use_stock) {
										if (strlen($stock_level)) {
											$sql  = " UPDATE " . $table_prefix . "items_properties_values SET ";
											$sql .= " stock_level=stock_level-" . $db->tosql($quantity, NUMBER);
											$sql .= " WHERE item_property_id=" . $db->tosql($item_property_id, INTEGER);
											$db->query($sql);
										} else {
											$sql  = " UPDATE " . $table_prefix . "items_properties_values SET ";
											$sql .= " stock_level=" . $db->tosql(-$quantity, NUMBER);
											$sql .= " WHERE item_property_id=" . $db->tosql($item_property_id, INTEGER);
											$db->query($sql);
										}
									}

									if (strlen($pr_download_path)) {
										if (!$pr_download_period) {
											$pr_download_period = ($download_period) ? $download_period : 366;
										}
										$download_paths = split(";", $pr_download_path);
										for ($dl = 0; $dl < sizeof($download_paths); $dl++) {
											$download_path_cur = trim($download_paths[$dl]);
											if ($download_path_cur) {
												$r_id->set_value("order_item_id", $order_item_id);
												$r_id->set_value("item_id", $item_id);
												$r_id->set_value("download_path", $download_path_cur);
						        
												$r_id->set_value("activated", $download_activated);
												$r_id->set_value("max_downloads", $max_downloads * $quantity);
												$r_id->set_value("download_added", va_time());
												if (strlen($pr_download_period)) {
													$download_expiry =  va_timestamp() + (intval($pr_download_period) * 86400);
													$r_id->set_value("download_expiry", va_time($download_expiry));
												}
												$r_id->insert_record();
											}
										}


									}
								}
							}
						}
					}
				}

				// update order status
				update_order_status($order_id, $new_order_status, false);

				$order_admin_email = $order_info["admin_email"] ? $order_info["admin_email"] : $settings["admin_email"];
				$admin_notification = get_setting_value($order_info, "admin_notification", 0);
				$user_notification  = get_setting_value($order_info, "user_notification", 0);
				$admin_sms = get_setting_value($order_info, "admin_sms_notification", 0);
				$user_sms  = get_setting_value($order_info, "user_sms_notification", 0);

				if ($admin_notification || $user_notification || $admin_sms || $user_sms)
				{
					$r->set_parameters();
					$t->set_var("goods_total", $currency_left . number_format($goods_total * $currency_rate, 2) . $currency_right);
					$t->set_var("goods_tax_total", $currency_left . number_format($goods_tax_total * $currency_rate, 2) . $currency_right);
					$t->set_var("goods_taxable", $currency_left . number_format($goods_taxable * $currency_rate, 2) . $currency_right);
					$t->set_var("total_discount", " -" . $currency_left . number_format($total_discount * $currency_rate, 2) . $currency_right);
					$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost * $currency_rate, 2) . $currency_right);
					$t->set_var("tax_percent", number_format($tax_percent, 3) . "%");
					$t->set_var("order_total", $currency_left . number_format($order_total * $currency_rate, 2) . $currency_right);
					$t->set_var("order_placed_date", $order_placed_date_string);

					// preparing downloadable data
					// get download links
					$links = get_order_links($order_id);
					// get serial numbers 
					$order_serials = get_serial_numbers($order_id);
					// get gift vouchers
					$order_vouchers = get_gift_vouchers($order_id);
				}

				if ($admin_notification)
				{
					$admin_subject = get_setting_value($order_info, "admin_subject", "");
					$admin_message = get_setting_value($order_info, "admin_message", "");
					$admin_subject = get_translation($admin_subject);
					$admin_message = get_currency_message(get_translation($admin_message), $currency);

					$t->set_block("admin_subject", $admin_subject);
					$t->set_block("admin_message", $admin_message);

					$mail_to = get_setting_value($order_info, "admin_email", $settings["admin_email"]);
					$mail_to = str_replace(";", ",", $mail_to);
					$mail_from = get_setting_value($order_info, "admin_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($order_info, "cc_emails");
					$mail_bcc = get_setting_value($order_info, "admin_mail_bcc");
					$mail_reply_to = get_setting_value($order_info, "admin_mail_reply_to");
					$mail_return_path = get_setting_value($order_info, "admin_mail_return_path");
					$mail_type = get_setting_value($order_info, "admin_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					if (!$mail_type) {
						$t->set_var("basket", $items_text);
						$t->set_var("items", $items_text);
					}
					// set download links
					if ($mail_type) {
						$t->set_var("links", $links["html"]);
					} else {
						$t->set_var("links", $links["text"]);
					}
					// set serial numbers
					if ($mail_type) {
						$t->set_var("serials", $order_serials["html"]);
						$t->set_var("serial_numbers", $order_serials["html"]);
					} else {
						$t->set_var("serials", $order_serials["text"]);
						$t->set_var("serial_numbers", $order_serials["text"]);
					}
					// set serial numbers
					if ($mail_type) {
						$t->set_var("vouchers", $order_vouchers["html"]);
						$t->set_var("gift_vouchers", $order_vouchers["html"]);
					} else {
						$t->set_var("vouchers", $order_vouchers["text"]);
						$t->set_var("gift_vouchers", $order_vouchers["text"]);
					}

					$t->parse("admin_subject", false);
					$t->parse("admin_message", false);

					$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
					mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
				}		 
				if ($user_notification)
				{
					$user_subject = get_setting_value($order_info, "user_subject", "");
					$user_message = get_setting_value($order_info, "user_message", "");
					$user_subject = get_translation($user_subject);
					$user_message = get_currency_message(get_translation($user_message), $currency);

					$t->set_block("user_subject", $user_subject);
					$t->set_block("user_message", $user_message);

					$mail_from = get_setting_value($order_info, "user_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($order_info, "user_mail_cc");
					$mail_bcc = get_setting_value($order_info, "user_mail_bcc");
					$mail_reply_to = get_setting_value($order_info, "user_mail_reply_to");
					$mail_return_path = get_setting_value($order_info, "user_mail_return_path");
					$mail_type = get_setting_value($order_info, "user_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					if (!$mail_type) {
						$t->set_var("basket", $items_text);
						$t->set_var("items", $items_text);
					}
					// set download links
					if ($mail_type) {
						$t->set_var("links", $links["html"]);
					} else {
						$t->set_var("links", $links["text"]);
					}
					// set serial numbers
					if ($mail_type) {
						$t->set_var("serials", $order_serials["html"]);
						$t->set_var("serial_numbers", $order_serials["html"]);
					} else {
						$t->set_var("serials", $order_serials["text"]);
						$t->set_var("serial_numbers", $order_serials["text"]);
					}
					// set serial numbers
					if ($mail_type) {
						$t->set_var("vouchers", $order_vouchers["html"]);
						$t->set_var("gift_vouchers", $order_vouchers["html"]);
					} else {
						$t->set_var("vouchers", $order_vouchers["text"]);
						$t->set_var("gift_vouchers", $order_vouchers["text"]);
					}

					$t->parse("user_subject", false);
					$t->parse("user_message", false);

					$user_email = strlen($r->get_value("email")) ? $r->get_value("email") : $r->get_value("delivery_email");
					$user_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("user_message"));
					mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
				}		 
				if ($admin_sms) 
				{
					$admin_sms_recipient  = get_setting_value($order_info, "admin_sms_recipient", "");
					$admin_sms_originator = get_setting_value($order_info, "admin_sms_originator", "");
					$admin_sms_message    = get_setting_value($order_info, "admin_sms_message", "");

					$t->set_block("admin_sms_recipient",  $admin_sms_recipient);
					$t->set_block("admin_sms_originator", $admin_sms_originator);
					$t->set_block("admin_sms_message",    $admin_sms_message);

					$t->set_var("basket", $items_text);
					$t->set_var("items", $items_text);
					// set download links
					$t->set_var("links",    $links["text"]);
					// set serial numbers
					$t->set_var("serials", $order_serials["text"]);
					$t->set_var("serial_numbers", $order_serials["text"]);
					// set serial numbers
					$t->set_var("vouchers", $order_vouchers["text"]);
					$t->set_var("gift_vouchers", $order_vouchers["text"]);

					$t->parse("admin_sms_recipient", false);
					$t->parse("admin_sms_originator", false);
					$t->parse("admin_sms_message", false);

					sms_send($t->get_var("admin_sms_recipient"), $t->get_var("admin_sms_message"), $t->get_var("admin_sms_originator"));
				}		 

				if ($user_sms) 
				{
					$user_sms_recipient  = get_setting_value($order_info, "user_sms_recipient", $r->get_value("cell_phone"));
					$user_sms_originator = get_setting_value($order_info, "user_sms_originator", "");
					$user_sms_message    = get_setting_value($order_info, "user_sms_message", "");

					$t->set_block("user_sms_recipient",  $user_sms_recipient);
					$t->set_block("user_sms_originator", $user_sms_originator);
					$t->set_block("user_sms_message",    $user_sms_message);

					$t->set_var("basket", $items_text);
					$t->set_var("items", $items_text);
					// set download links
					$t->set_var("links",    $links["text"]);
					// set serial numbers
					$t->set_var("serials", $order_serials["text"]);
					$t->set_var("serial_numbers", $order_serials["text"]);
					// set serial numbers
					$t->set_var("vouchers", $order_vouchers["text"]);
					$t->set_var("gift_vouchers", $order_vouchers["text"]);

					$t->parse("user_sms_recipient", false);
					$t->parse("user_sms_originator", false);
					$t->parse("user_sms_message", false);

					if (sms_send_allowed($t->get_var("user_sms_recipient"))) {
						sms_send($t->get_var("user_sms_recipient"), $t->get_var("user_sms_message"), $t->get_var("user_sms_originator"));
					}
				}		 

			}
			$vc = md5($order_id . $order_placed_date[3].$order_placed_date[4].$order_placed_date[5]);
			$variables["vc"] = $vc;
			$variables["payment_id"] = $payment_id;
			set_session("session_order_id", $order_id);
			set_session("session_user_order_id", $order_id);
			set_session("session_vc", $vc);
			set_session("session_payment_id", $payment_id);
      if ($order_total == 0) {
				$payment_url = "order_confirmation.php";
			} else {

				if (!$payment_url) { $payment_url = "credit_card_info.php"; }

				if ($payment_advanced) {
					$payment_url .= "?order_id=" . urlencode($order_id) . "&vc=" . urlencode($vc) . "&payment_id=" . urlencode($payment_id);
				} elseif ($payment_method == "POST") {
					$payment_url  = "payment.php";
				} else {
					$payment_parameters = array(); $parameter_number = 0;	
					$fp_hash_name = ""; $epdqdata_name = ""; $protx_crypt_name = "";
					$db->query("SELECT * FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
					while ($db->next_record())
					{
						$parameter_name = $db->f("parameter_name");
						$parameter_source = $db->f("parameter_source");
						$parameter_type = $db->f("parameter_type");
						$not_passed = $db->f("not_passed");
						if (strtolower($parameter_name) == "x_fp_hash" && $parameter_type == "VARIABLE") {
							$fp_hash_name = $parameter_name;
							$fp_not_passed = $not_passed;
						} elseif (strtolower($parameter_name) == "epdqdata" && $parameter_type == "VARIABLE") {
							$epdqdata_name = $parameter_name;
							$epdqdata_not_passed = $not_passed;
						} elseif (strtolower($parameter_name) == "crypt" && strtolower($parameter_source) == "protx_crypt") {
							$protx_crypt_name = $parameter_name;
							$protx_crypt_not_passed = $not_passed;
						} elseif (preg_match("/\{digit\}/", $parameter_name) || preg_match("/\{no_digit\}/", $parameter_name)) {
							for ($i = 0; $i < sizeof($cart_items); $i++) {
								$cart_item = $cart_items[$i];
								$digit_parameter = str_replace("{digit}", ($i + 1), $parameter_name);
								$digit_parameter = str_replace("{no_digit}", "", $digit_parameter);
								if ($parameter_type == "CONSTANT") {
									$parameter_value = $parameter_source;
								} elseif ($parameter_type == "VARIABLE") {
									if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
										$parameter_value = $parameter_source;
										for ($p = 0; $p < sizeof($matches[1]); $p++) {
											$l_source = strtolower($matches[1][$p]);
											if (isset($cart_item[$l_source])) {
												$parameter_value = str_replace("{".$l_source."}", $cart_item[$l_source], $parameter_value);
											}
										}
									} else {
										$l_source = strtolower($parameter_source);
										$parameter_value = isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_source;
									}
								}
								$payment_parameters[$digit_parameter] = $parameter_value;
								if (!$not_passed) {
									$parameter_number++;
									$payment_url .= ($parameter_number == 1) ? "?" : "&";
									$payment_url .= $digit_parameter . "=" . urlencode($parameter_value);
								}
							}
						} else {
							if ($parameter_type == "CONSTANT") {
								$parameter_value = $parameter_source;
							} elseif ($parameter_type == "VARIABLE") {
								if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
									$parameter_value = $parameter_source;
									for ($p = 0; $p < sizeof($matches[1]); $p++) {
										$l_source = strtolower($matches[1][$p]);
										if (isset($variables[$l_source])) {
											$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
										}
									}
								} else {
									$l_source = strtolower($parameter_source);
									$parameter_value = isset($variables[$l_source]) ? $variables[$l_source] : $parameter_source;
								}
							}
							$payment_parameters[$parameter_name] = $parameter_value;
							if (!$not_passed) {
								$parameter_number++;
								$payment_url .= ($parameter_number == 1) ? "?" : "&";
								$payment_url .= $parameter_name . "=" . urlencode($parameter_value);
							}

						}
					}
					$additional_params = array();
					if (strlen($fp_hash_name)) {
						$x_login = isset($payment_parameters["x_login"]) ? $payment_parameters["x_login"] : "";
						$x_tran_key = isset($payment_parameters["x_tran_key"]) ? $payment_parameters["x_tran_key"] : "";
						$x_currency_code = isset($payment_parameters["x_currency_code"]) ? $payment_parameters["x_currency_code"] : "";
	      
						$fp_hash_value = calculate_fp ($x_login, $x_tran_key, $variables["order_total"], $variables["order_id"], $variables["timestamp"], $x_currency_code);
						$payment_parameters["x_fp_hash"] = $fp_hash_value;
						if (!$fp_not_passed) {
							$additional_params[$fp_hash_name] = $fp_hash_value;
						}
					}
					if (strlen($epdqdata_name) && !$epdqdata_not_passed) {
						include ("./payments/epdq_cpi_encryption.php");
						$epdqdata_value = get_epdqdata($payment_parameters);
						$additional_params[$epdqdata_name] = $epdqdata_value;
					}
					if (strlen($protx_crypt_name) && !$protx_crypt_not_passed) {
						include ("./payments/protx_form_encryption.php");
						$protx_crypt_value = get_protx_crypt($payment_parameters);
						$additional_params[$protx_crypt_name] = $protx_crypt_value;
  				}
					foreach ($additional_params as $param_name => $param_value) {
						$parameter_number++;
						$payment_url .= ($parameter_number == 1) ? "?" : "&";
						$payment_url .= $param_name . "=" . urlencode($param_value);
					}
				}
			}
			if (!$user_id) { // set cookies with user info for non-registered users
				$cookie_order_info = "";
				for ($i = 0; $i < sizeof($parameters); $i++) { 
					$cookie_order_info .= $parameters[$i] . "=" . $r->get_value($parameters[$i]) . "|";
					$cookie_order_info .= "delivery_" . $parameters[$i] . "=" . $r->get_value("delivery_" . $parameters[$i]) . "|";
				}
				setcookie("cookie_order_info", $cookie_order_info, va_timestamp() + 3600 * 24 * 366);
			}
			if ($payment_url == "credit_card_info.php") {
				$payment_url .= "?order_id=" . urlencode($order_id) . "&vc=" . urlencode($vc);
			}

			if ($secure_payments && !preg_match("/^http\:\/\//", $payment_url) && !preg_match("/^https\:\/\//", $payment_url)) {
				$payment_url = $secure_url . $payment_url;
			}

			header("Location: " . $payment_url);
			exit;
		}
	} else if ($user_id) {
		// get user details 
		$sql = " SELECT * FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user_id, INTEGER);
		$db->query($sql);
		if ($db->next_record())
		{
			for ($i = 0; $i < sizeof($parameters); $i++) { 
				$r->set_value($parameters[$i], $db->f($parameters[$i]));
				$r->set_value("delivery_" . $parameters[$i], $db->f("delivery_" . $parameters[$i]));
			}
		}

	} else { // set default values from cookies
		$cookie_order_info = trim(get_cookie("cookie_order_info"));
		if (strlen($cookie_order_info)) {
			$cookie_pairs = explode("|", $cookie_order_info);
			for ($i = 0; $i < sizeof($cookie_pairs); $i++) {
				$cookie_line = trim($cookie_pairs[$i]);
				if (strlen($cookie_line)) {
					$cookie_values = explode("=", $cookie_line, 2);
					if (isset($r->parameters[$cookie_values[0]])) {
						$r->set_value($cookie_values[0], $cookie_values[1]);
					}
				}
			}
		}
		if ($r->is_empty("country_code") && $r->is_empty("delivery_country_code")) {
			$r->set_value("country_code", $settings["country_code"]);
			$r->set_value("delivery_country_code", $settings["country_code"]);
		}
	}

	if (!strlen($operation)) {
		// check subscribe option
		if ($subscribe_block) {
			$subscribe_email = $r->get_value("email");
			if (!$subscribe_email && $r->get_value("delivery_email")) {
				$subscribe_email = $r->get_value("delivery_email");
			}
			if ($subscribe_email) {
				$sql  = " SELECT email_id FROM " . $table_prefix . "newsletters_users ";
				$sql .= " WHERE email=" . $db->tosql($subscribe_email, TEXT);
				$db->query($sql);
				if ($db->next_record()) {
					$r->set_value("subscribe", 1);
				} 
			}
		}
	}

	if (!$basket_parsed) {
		$t->parse("basket", false);
	}

	$r->set_parameters();

	if ($sc_errors) {
		$t->set_var("errors_list", $sc_errors);
		$t->parse("sc_errors", false);
	}

	if ($personal_number > 0) {
		$t->parse("personal", false);
	}

	if ($delivery_number > 0) {
		$t->parse("delivery", false);
	}

	$intro_text = trim($order_info["intro_text"]);
	$intro_text = get_translation($intro_text);
	$intro_text = get_currency_message($intro_text, $currency);

	if ($intro_text) {
		$t->set_var("intro_text", $intro_text);
		$t->parse("intro_block", false);
	}
	include("./header.php");
	include("./footer.php");

	$t->pparse("main");

?>