<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  payment.php                                              ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/shopping_cart.php");
	include_once ("./includes/order_items.php");
	include_once ("./includes/parameters.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","payment.html");
	$t->set_var("payment_url","payment.php");

	$vc = get_session("session_vc");
	$order_id = get_session("session_order_id");
	$payment_id = get_session("session_payment_id");
	$secure_url = get_setting_value($settings, "secure_url", "");
	$secure_payments = get_setting_value($settings, "secure_payments", 0);

	$order_errors = check_order($order_id, $vc);
	if($order_errors) {
		$t->set_var("errors_list", $order_errors);
		$t->parse("errors");
	} else {
		$variables = array();
		$cart_items = array();
		$total_items = 0;
		$items_text = show_order_items($order_id, false);
		$variables["charset"] = CHARSET;
		$variables["site_url"] = $settings["site_url"];
		$variables["secure_url"] = $secure_url;
		$variables["http_host"] = get_var("HTTP_HOST");
		$variables["session_id"] = session_id();
		$variables["remote_address"] = get_ip();

		$variables["order_id"] = $order_id;
		$variables["items"] = $items_text;
		$variables["basket"] = $items_text;
		$variables["description"] = $items_text;

		$sql = "SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$variables["user_ip"] = $db->f("remote_address");
			$variables["order_ip"] = $db->f("remote_address");
			$variables["initial_ip"] = $db->f("initial_ip");
			$variables["cookie_ip"] = $db->f("cookie_ip");

			for($i = 0; $i < sizeof($parameters); $i++) {
				$variables[$parameters[$i]] = $db->f($parameters[$i]);
				$variables["delivery_" . $parameters[$i]] = $db->f("delivery_" . $parameters[$i]);
			}
			// prepare user name variables
			if (strlen($variables["name"]) && !strlen($variables["first_name"]) && !strlen($variables["last_name"])) {
				$name = $variables["name"];
				$name_parts = explode(" ", $name, 2);
				if (sizeof($name_parts) == 2) {
					$variables["first_name"] = $name_parts[0];
					$variables["last_name"] = $name_parts[1];
				} else {
					$variables["first_name"] = $name_parts[0];
					$variables["last_name"] = "";
				}
			} else if (!strlen($variables["name"]) && (strlen($variables["first_name"]) || strlen($variables["last_name"]))) {
				$variables["name"] = trim($variables["first_name"] . " " . $variables["last_name"]);
			}
			$address = $variables["address2"] ? ($variables["address1"] . " " . $variables["address2"]) : $variables["address1"];
			$delivery_address = $variables["delivery_address2"] ? ($variables["delivery_address1"] . " " . $variables["delivery_address2"]) : $variables["delivery_address1"];
			$variables["address"] = $address;
			$variables["delivery_address"] = $delivery_address;

			$order_placed_date = $db->f("order_placed_date", DATETIME);
			$timestamp = mktime ($order_placed_date[HOUR], $order_placed_date[MINUTE], $order_placed_date[SECOND], $order_placed_date[MONTH], $order_placed_date[DAY], $order_placed_date[YEAR]);
			$vc = md5($order_id . $order_placed_date[HOUR].$order_placed_date[MINUTE].$order_placed_date[SECOND]);

			$user_id = $db->f("user_id");
			$affiliate_code = $db->f("affiliate_code");
			$currency_code = $db->f("currency_code");
			$currency_rate = $db->f("currency_rate");
			$goods_total = $db->f("goods_total");
			$total_discount = $db->f("total_discount");
			$properties_total = $db->f("properties_total");
			$properties_taxable = $db->f("properties_taxable");
			$shipping_cost = $db->f("shipping_cost");
			$shipping_taxable = $db->f("shipping_taxable");
			$total_quantity = $db->f("total_quantity");
			$weight_total = $db->f("weight_total");
			$total_discount = $db->f("total_discount");
			$tax_name = $db->f("tax_name");
			$tax_percent = $db->f("tax_percent");
			$tax_cost = $db->f("tax_total");
			$processing_fee = $db->f("processing_fee");
			$order_total = $db->f("order_total");

			// get payment rate for the selected gateway
			$payment_rate = get_payment_rate($payment_id, $currency_rate);

			// get numeric code
			$currency = get_currency($currency_code);
			$currency_value = $currency["value"];


			$variables["vc"] = $vc;
			$variables["timestamp"] = $timestamp;
			$variables["order_placed_timestamp"] = $timestamp;
			$variables["order_placed_date"] = va_date($datetime_show_format, $order_placed_date);

			$variables["user_id"] = $user_id;
			$variables["affiliate_code"] = $affiliate_code;
			$variables["currency_code"] = $currency_code;
			$variables["currency_value"] = $currency_value;
			$variables["currency_rate"] = $currency_rate;
			$variables["goods_total"] = number_format($goods_total * $payment_rate, 2, ".", "");
			$variables["total_discount"] = number_format($total_discount * $payment_rate, 2, ".", "");
			$goods_with_discount = $goods_total - $total_discount;
			$variables["goods_with_discount"] = number_format($goods_with_discount * $payment_rate, 2, ".", "");
			$variables["total_quantity"] = $total_quantity;
			$variables["total_items"] = $total_items;
			$variables["weight_total"] = $weight_total;
			$variables["total_weight"] = $weight_total;
			$variables["properties_total"] = number_format($properties_total * $payment_rate, 2, ".", "");
			$variables["properties_taxable"] = $properties_taxable;
			$variables["shipping_cost"] = number_format($shipping_cost * $payment_rate, 2, ".", "");
			$variables["shipping_taxable"] = $shipping_taxable;
			$variables["tax_name"] = $tax_name;
			$variables["tax_percent"] = $tax_percent;
			$variables["tax_cost"] = number_format($tax_cost * $payment_rate, 2, ".", "");
			$variables["processing_fee"] = number_format($processing_fee * $payment_rate, 2, ".", "");
			$variables["order_total"] = number_format($order_total * $payment_rate, 2, ".", "");
			$variables["order_total_100"] = round($order_total * $payment_rate * 100, 0);
			$variables["company_select"] = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($variables["company_id"], INTEGER));
			$variables["state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["state_code"], TEXT));
			if (strlen($variables["state_code"])) {
				$variables["state_code_or_province"] = $variables["state_code"];
				$variables["state_or_province"] = $variables["state"];
			} else {
				$variables["state_code_or_province"] = $variables["province"];
				$variables["state_or_province"] = $variables["province"];
			}
			$country_name = ""; $country_number = "";
			$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$country_name = $db->f("country_name");
				$country_number = $db->f("country_iso_number");
			}
			$variables["country"] = $country_name;
			$variables["country_number"] = $country_number;
			$variables["delivery_company_select"] = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($variables["delivery_company_id"], INTEGER));
			$variables["delivery_state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["delivery_state_code"], TEXT));
			if (strlen($variables["delivery_state_code"])) {
				$variables["delivery_state_code_or_province"] = $variables["delivery_state_code"];
				$variables["delivery_state_or_province"] = $variables["delivery_state"];
			} else {
				$variables["delivery_state_code_or_province"] = $variables["delivery_province"];
				$variables["delivery_state_or_province"] = $variables["delivery_province"];
			}
			$delivery_country_name = ""; $delivery_country_number = "";
			$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["delivery_country_code"], TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$delivery_country_name = $db->f("country_name");
				$delivery_country_number = $db->f("country_iso_number");
			}
			$variables["delivery_country"] = $delivery_country_name;
			$variables["delivery_country_number"] = $delivery_country_number;
		}

		if (!strlen($payment_id)) { // check for payment_id if we loose it somewhere
			$sql = "SELECT payment_id FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
			$payment_id = get_db_value($sql);
			if (!strlen($payment_id)) { // if we missed it again look for it in payment_systems table 
				$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems WHERE is_active=1 AND is_advanced=1 ";
				$payment_id = get_db_value($sql);
			}
		}
		$db->query("SELECT * FROM " . $table_prefix . "payment_systems WHERE is_active=1 AND payment_id=" . $db->tosql($payment_id, INTEGER));
		$db->next_record();
		$payment_url = $db->f("payment_url");
		$submit_method = $db->f("submit_method");
		$payment_name = get_translation($db->f("payment_name"));
		$is_advanced = $db->f("is_advanced");
		if ($is_advanced) {
			// for advanced orders we collect credit card info on our site
			$payment_url .= "?order_id=" . urlencode($order_id) . "&vc=" . urlencode($vc);
			if ($secure_payments && !preg_match("/^http\:\/\//", $payment_url) && !preg_match("/^https\:\/\//", $payment_url)) {
				$payment_url = $secure_url . $payment_url;
			}

			header("Location: " . $payment_url);
			exit;
		}

		$t->set_var("payment_url", htmlspecialchars($payment_url));
		$t->set_var("payment_name", $payment_name);
		$t->set_var("submit_method", $submit_method);

		$goto_payment_message = str_replace("{payment_system}", $payment_name, GOTO_PAYMENT_MSG);
		$goto_payment_message = str_replace("{button_name}", CONTINUE_BUTTON, $goto_payment_message);
		$t->set_var("GOTO_PAYMENT_MSG", $goto_payment_message);

		$payment_parameters = array(); $parameter_number = 0;	
		$fp_hash_name = ""; $epdqdata_name = ""; $protx_crypt_name = "";
		$db->query("SELECT * FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
		while($db->next_record())
		{
			$parameter_source = $db->f("parameter_source");
			$parameter_name = $db->f("parameter_name");
			$parameter_type = $db->f("parameter_type");
			$not_passed = $db->f("not_passed");
			if (strtolower($parameter_name) == "x_fp_hash" && $parameter_type == "VARIABLE") {
				$fp_hash_name = $parameter_name;
				$fp_not_passed = $not_passed;
			} else if (strtolower($parameter_name) == "epdqdata" && $parameter_type == "VARIABLE") {
				$epdqdata_name = $parameter_name;
				$epdqdata_not_passed = $not_passed;
			} else if (strtolower($parameter_name) == "crypt" && strtolower($parameter_source) == "protx_crypt") {
				$protx_crypt_name = $parameter_name;
				$protx_crypt_not_passed = $not_passed;
			} else if (preg_match("/\{digit\}/", $parameter_name) || preg_match("/\{no_digit\}/", $parameter_name)) {
				for($i = 0; $i < sizeof($cart_items); $i++) {
					$cart_item = $cart_items[$i];
					$digit_parameter = str_replace("{digit}", ($i + 1), $parameter_name);
					$digit_parameter = str_replace("{no_digit}", "", $digit_parameter);
					if($parameter_type == "CONSTANT") {
						$parameter_value = $parameter_source;
					} else if($parameter_type == "VARIABLE") {
						if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
							$parameter_value = $parameter_source;
							for($p = 0; $p < sizeof($matches[1]); $p++) {
								$l_source = strtolower($matches[1][$p]);
								if (isset($cart_item[$l_source])) {
									$parameter_value = str_replace("{".$l_source."}", $cart_item[$l_source], $parameter_value);
								}
							}
						} else {
							$l_source = strtolower($parameter_source);
							$parameter_value = isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_source;
						}
					}
					$payment_parameters[$digit_parameter] = $parameter_value;
					if (!$not_passed) {
						$parameter_number++;
						$payment_url .= ($parameter_number == 1) ? "?" : "&";
						$payment_url .= $digit_parameter . "=" . urlencode($parameter_value);
						$t->set_var("parameter_name", $digit_parameter);
						$t->set_var("parameter_value", htmlspecialchars($parameter_value));
						$t->parse("parameters", true);
					}
				}
			} else {
				if($parameter_type == "CONSTANT") {
					$parameter_value = $parameter_source;
				} else if($parameter_type == "VARIABLE") {
					if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
						$parameter_value = $parameter_source;
						for($p = 0; $p < sizeof($matches[1]); $p++) {
							$l_source = strtolower($matches[1][$p]);
							if (isset($variables[$l_source])) {
								$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
							}
						}
					} else {
						$l_source = strtolower($parameter_source);
						$parameter_value = isset($variables[$l_source]) ? $variables[$l_source] : $parameter_source;
					}
				}
				$payment_parameters[$parameter_name] = $parameter_value;
				if (!$not_passed) {
					$parameter_number++;
					$payment_url .= ($parameter_number == 1) ? "?" : "&";
					$payment_url .= $parameter_name . "=" . urlencode($parameter_value);
					$t->set_var("parameter_name", $parameter_name);
					$t->set_var("parameter_value", htmlspecialchars($parameter_value));
					$t->parse("parameters", true);
				}
			}
		}

		$additional_params = array();
		if (strlen($fp_hash_name)) {
			$x_login = isset($payment_parameters["x_login"]) ? $payment_parameters["x_login"] : "";
			$x_tran_key = isset($payment_parameters["x_tran_key"]) ? $payment_parameters["x_tran_key"] : "";
			$x_currency_code = isset($payment_parameters["x_currency_code"]) ? $payment_parameters["x_currency_code"] : "";

			$fp_hash_value = calculate_fp ($x_login, $x_tran_key, $variables["order_total"], $variables["order_id"], $variables["timestamp"], $x_currency_code);
			$payment_parameters["x_fp_hash"] = $fp_hash_value;
			if(!$fp_not_passed) {
				$additional_params[$fp_hash_name] = $fp_hash_value;
			}
		}

		if (strlen($epdqdata_name) && !$epdqdata_not_passed) {
			include ("./payments/epdq_cpi_encryption.php");
			$epdqdata_value = get_epdqdata($payment_parameters);
			$additional_params[$epdqdata_name] = $epdqdata_value;
		}

		if (strlen($protx_crypt_name) && !$protx_crypt_not_passed) {
			include ("./payments/protx_form_encryption.php");
			$protx_crypt_value = get_protx_crypt($payment_parameters);
			$additional_params[$protx_crypt_name] = $protx_crypt_value;
  	}

		foreach ($additional_params as $param_name => $param_value) {
			$parameter_number++;
			$payment_url .= ($parameter_number == 1) ? "?" : "&";
			$payment_url .= $param_name . "=" . urlencode($param_value);
			$t->set_var("parameter_name", $param_name);
			$t->set_var("parameter_value", htmlspecialchars($param_value));
			$t->parse("parameters", true);
		}
		$t->sparse("submit_payment", false);

		if($submit_method == "GET") {
			header("Location: " . $payment_url);
			exit;
		}
	}
	$t->pparse("main");

?>
