<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  authorize_check.php                                      ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * Authorize.net SIM (www.authorize.net) transaction handler by http://www.viart.com/
 */

	// get payments parameters for validation
	$x_login        = isset($payment_params["x_login"]) ? $payment_params["x_login"] : "";
	$x_secret       = isset($payment_params["x_secret"]) ? $payment_params["x_secret"] : "";

	// convert authorize parameters into lowercase
	$x_params = array();
	if (isset($_POST)) {
		foreach ($_POST as $param_name => $param_value) {
			$lower_name = strtolower($param_name);
			$x_params[$lower_name] = $param_value;
			$t->set_var($lower_name, $param_value);
		}
	} else {
		foreach ($HTTP_POST_VARS as $param_name => $param_value) {
			$lower_name = strtolower($param_name);
			$x_params[$lower_name] = $param_value;
			$t->set_var($lower_name, $param_value);
		}
	}

	// get parameters passed from Authorize.net
	$transaction_id  = isset($x_params["x_trans_id"]) ? $x_params["x_trans_id"] : ""; // Authorize.net transaction number
	$order_id        = isset($x_params["x_invoice_num"]) ? $x_params["x_invoice_num"] : ""; // Our order number
	$response_code   = isset($x_params["x_response_code"]) ? $x_params["x_response_code"] : ""; // 1 - Approved, 2 - Declined, 3 - Error, 4 - Held for review
	$reason_code     = isset($x_params["x_response_reason_code"]) ? $x_params["x_response_reason_code"] : ""; // Reason code
	$reason_text     = isset($x_params["x_response_reason_text"]) ? $x_params["x_response_reason_text"] : ""; // Reason text
	$amount          = isset($x_params["x_amount"]) ? $x_params["x_amount"] : ""; // Total purchase amount.
	$x_md5_hash      = isset($x_params["x_md5_hash"]) ? $x_params["x_md5_hash"] : ""; // Hash from Authorize.net

	$our_md5_hash = md5($x_secret.$x_login.$transaction_id.$amount); // Our key

	// check parameters
	if (!strlen($response_code)) {
		$error_message = "Can't obtain response code parameter.";
	} else if (!strlen($order_id)) {
		$error_message = "Can't obtain invoice number parameter.";
	} else if (!strlen($amount)) {
		$error_message = "Can't obtain amount parameter.";
	} else if (!strlen($x_login)) {
		$error_message = "Can't obtain login parameter.";
	} else if (!strlen($x_secret)) {
		$error_message = "Can't obtain secret parameter.";
	} else if ($response_code == "2") {
		if ($reason_text) { 
			$error_message = $reason_text; 
		} else { 
			$error_message = "Your transaction has been declined."; 
		}
		if ($reason_code) { $error_message .= " (" . $reason_code . ")"; }
	} else if ($response_code == "3") {
		if ($reason_text) { 
			$error_message = $reason_text; 
		} else { 
			$error_message = "There has been an error processing this transaction.";
		}
		if ($reason_code) { $error_message .= " (" . $reason_code . ")"; }
	} else if ($response_code == "4") {
		$pending_message = "Your transaction is being held for review.";
	} else if ($response_code != "1") {
		$error_message = "Your transaction has been declined. Wrong response code. ";
	} else if (strtoupper($our_md5_hash) != strtoupper($x_md5_hash)) {
		$error_message = "'Hash' parameter has wrong value.";
	} else {
		$error_message = check_payment($order_id, $amount);
	}

	// set available parameters
	$remote_address   = get_ip();
	$t->set_var("remote_address", $remote_address);
	$t->set_var("x_response_code", $response_code);
	$t->set_var("our_md5_hash", $our_md5_hash);
	$t->set_var("x_md5_hash", $x_md5_hash);
	$t->set_var("x_amount", $amount);

?>