<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  cybersource_process.php                                  ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
* Cybersource (www.cybersource.com) transaction handler by ViArt Ltd. (www.viart.com)
*/

	global $is_admin_path, $is_sub_folder;
	$root_folder_path = ((isset($is_admin_path) && $is_admin_path) || (isset($is_sub_folder) && $is_sub_folder)) ? "../" : "./";
	include_once($root_folder_path . "payments/cybersource_functions.php");

	$pass_data = array();
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if (isset($pass_parameters[$parameter_name]) && $pass_parameters[$parameter_name] == 1) {
			$pass_data[$parameter_name] = $parameter_value;
		}
	}

	$amount = isset($pass_data["amount"]) ? $pass_data["amount"] : "0.00";
	$currency = isset($pass_data["currency"]) ? $pass_data["currency"] : "usd";
	$card_type = isset($pass_data["card_cardType"]) ? $pass_data["card_cardType"] : "Visa";

	switch (strtoupper($card_type)) {
		case "VISA":
			$pass_data["card_cardType"] = "001";
			break;
		case "MC":
			$pass_data["card_cardType"] = "002";
			break;
		case "AMEX":
			$pass_data["card_cardType"] = "003";
			break;
		case "DISCOVER":
			$pass_data["card_cardType"] = "004";
			break;
		case "JCB":
			$pass_data["card_cardType"] = "007";
			break;
		case "SOLO":
			$pass_data["card_cardType"] = "024";
			break;
		default:
			$pass_data["card_cardType"] = "001";
	}

	$merchantID = getMerchantID();
	$timestamp = getmicrotime();
	$data = $merchantID . $amount . $currency . $timestamp;
	$pub = getPublicKey();
	$serialNumber = getSerialNumber();
	$pub_digest = hopHash($data, $pub);

	$pass_data["amount"] = $amount;
	$pass_data["currency"] = $currency;
	$payment_parameters["orderPage_timestamp"] = $timestamp;
	$payment_parameters["merchantID"] = $merchantID;
	$payment_parameters["orderPage_signaturePublic"] = $pub_digest;
	$payment_parameters["orderPage_version"] = 4;
	$payment_parameters["orderPage_serialNumber"] = $serialNumber;

	/* foreach ($payment_parameters as $parameter_name => $parameter_value) {
	echo $parameter_name . " - " . $parameter_value . "<br>";
	//$t->set_var($parameter_name, $parameter_value);
	}  */

	$post_params_encoded = "";
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if (strlen($post_params_encoded)) {
			$post_params_encoded .= "&";
		}
		$post_params_encoded .= $parameter_name . "=" . urlencode($parameter_value);
	}

	$ch = curl_init();
	if ($ch)
	{
		curl_setopt($ch, CURLOPT_URL, $advanced_url);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post_params_encoded);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
		set_curl_options($ch, $payment_parameters);

		$payment_response = curl_exec($ch);
		curl_close($ch);
		echo $payment_response;
		$payment_response = trim(strip_tags($payment_response));
		$t->set_var("payment_response", $payment_response);
		if (strlen($payment_response)) {
		} else {
			$error_message = "Can't obtain data for your transaction.";
		}
	} else {
		$error_message = "Can't initialize cURL.";
	}

	exit;

?>