<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  epdq_mpi.php                                             ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * ePDQ MPI (www.tele-pro.co.uk/epdq/) transaction handler by http://www.viart.com/
 */

	global $is_admin_path, $is_sub_folder;
	$root_folder_path = ((isset($is_admin_path) && $is_admin_path) || (isset($is_sub_folder) && $is_sub_folder)) ? "../" : "./";

	include_once($root_folder_path . "payments/epdq_mpi_functions.php");

	// get some variables from our payment settings
	$sslcert        = isset($payment_parameters["sslcert"]) ? $payment_parameters["sslcert"] : "";

	$pass_data = array();
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if(isset($pass_parameters[$parameter_name]) && $pass_parameters[$parameter_name] == 1) {
			$pass_data[$parameter_name] = $parameter_value;
		}
	}

	// 

	$xml = epdq_build_xml($pass_data);

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_URL, $advanced_url);
	curl_setopt ($ch, CURLOPT_POST, 1);
	curl_setopt ($ch, CURLOPT_POSTFIELDS, "CLRCMRC_XML=" . $xml);
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	if ($sslcert) {
		curl_setopt ($ch, CURLOPT_SSLCERT, $sslcert);
	}
	curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	set_curl_options ($ch, $payment_parameters);

	$epdq_response = curl_exec ($ch);
	curl_close ($ch);

	if (strlen($epdq_response)) {
		$CcErrCode = ""; $CcReturnMsg = "";
		$ProcReturnCode = ""; $ProcReturnMsg = "";
		$transaction_id = "";
		if (preg_match("/<CcErrCode[^>]*>(.*)<\/CcErrCode>/i", $epdq_response, $match)) {
			$CcErrCode = $match[1];
		}
		if (preg_match("/<CcReturnMsg[^>]*>(.*)<\/CcReturnMsg>/i", $epdq_response, $match)) {
			$CcReturnMsg = $match[1];
		}
		if (preg_match("/<ProcReturnCode[^>]*>(.*)<\/ProcReturnCode>/i", $epdq_response, $match)) {
			$ProcReturnCode = $match[1];
		}
		if (preg_match("/<ProcReturnMsg[^>]*>(.*)<\/ProcReturnMsg>/i", $epdq_response, $match)) {
			$ProcReturnMsg = $match[1];
		}
		if (preg_match("/<Transaction[^>]*>.*<Id[^>]*>(.*)<\/Id>.*<\/Transaction>/is", $epdq_response, $match)) {
			$transaction_id = $match[1];
		}

		if (!strlen($ProcReturnCode) && !strlen($CcErrCode)) {
			if (preg_match("/<MessageList>(.*)<\/MessageList>/is", $epdq_response, $match)) {
				$messages = trim($match[1]);
				if (preg_match_all("/<Message>.*<Text[^>]*>(.*)<\/Text>.*<\/Message>/isU", $messages, $matches)) {
					for($p = 0; $p < sizeof($matches[1]); $p++) {
						$message = trim($matches[1][$p]);
						if ($message) {
							$error_message .= $message . "<br>";
						}
					}
				}
			}
			if (!$error_message) {
				$error_message = "Can't obtain transaction status.";
			}
		} else if (!strlen($ProcReturnCode)) {
			$error_message = "Can't obtain transaction status.";
		} else if ($ProcReturnCode != "00") {
			$error_message  = "Some errors occurred during handling your transaction:<br>";
			$error_message .= $ProcReturnCode . ": " . $ProcReturnMsg;
		} else if (!strlen($CcErrCode)) {
			$error_message = "Can't obtain engine status.";
		} else if ($CcErrCode != 1) {
			$error_message  = "Some engine errors occurred during handling your transaction:<br>";
			$error_message .= $CcErrCode . ": " . $CcReturnMsg;
		} else if (!$transaction_id) {
			$error_message  = "Can't obtain transaction parameter.";
		} else {
			// transaction was approved
			$avs_response_code = ""; $cvv2_response = ""; $avs_message = "";
			if (preg_match("/<AvsDisplay [^>]*>(.*)<\/AvsDisplay>/i", $epdq_response, $match)) {
				$avs_response_code = $match[1];
			}
			if (preg_match("/<Cvv2Resp[^>]*>(.*)<\/Cvv2Resp>/i", $epdq_response, $match)) {
				$cvv2_response = $match[1];
			}
			if (preg_match("/<ProcAvsRespCode[^>]*>(.*)<\/ProcAvsRespCode>/i", $epdq_response, $match)) {
				$avs_message = $match[1];
			}
		}
	} else {
		$error_message  = "Empty response from engine, please check your payment settings.";
	}

	if ($error_message) {
		$error_message = str_replace("&apos;", "'", $error_message);
	}

?>