<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  google_process.php                                       ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/

/*
 * Google Checkout (https://checkout.google.com/) transaction handler by www.viart.com
 */

	$is_admin_path = true;
	$root_folder_path = "../";

	include_once ($root_folder_path ."includes/common.php");
	include_once ($root_folder_path ."includes/order_items.php");
	include_once ($root_folder_path ."includes/date_functions.php");
    include_once ($root_folder_path ."messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path ."payments/google_functions.php");

	$vc = get_session("session_vc");
	$order_id = get_session("session_order_id");

	$order_errors = check_order($order_id, $vc);
	if($order_errors) {
		echo $order_errors;
		exit;
	}
	$payment_params = g_c_payment_params($order_id);
	if(!is_array($payment_params)){
		$error_message = 'Payment parameters not send!';
		g_c_set_error($order_id, $error_message);
		echo $error_message;
		exit;
	}

	$variables = g_c_payment_variables($order_id);
	$xml  = '<?xml version="1.0" encoding="utf-8"?>'; //<?
	$xml .= '<checkout-shopping-cart xmlns="http://checkout.google.com/schema/2">';
	$xml .= '	<shopping-cart>';
	$xml .= '		<items>';
	foreach ($variables["items"] as $number => $item) {
		$xml .= '			<item>';
		$xml .= '				<item-name>'.$payment_params['item-name'].' '.$item['item_text'].'</item-name>';
		$xml .= '				<item-description>'.$item['item_text'].'</item-description>';
		$xml .= '				<unit-price currency="'.$payment_params['currency'].'">'.$item['price'].'</unit-price>';
		$xml .= '				<quantity>'.$item['quantity'].'</quantity>';
		$xml .= '				<tax-table-selector>item_'.$number.'</tax-table-selector>';
		$xml .= '			</item>';
	}

	if ($variables["total_discount_with_tax_cr"] != 0) {
		$xml .= '			<item>';
		$xml .= '				<item-name>'.TOTAL_DISCOUNT_MSG.'</item-name>';
		$xml .= '				<item-description>'.TOTAL_DISCOUNT_MSG.'</item-description>';
		$xml .= '				<unit-price currency="'.$payment_params['currency'].'">-'.$variables["total_discount_with_tax_cr"].'</unit-price>';
		$xml .= '				<quantity>1</quantity>';
		$xml .= '				<tax-table-selector>discount</tax-table-selector>';
		$xml .= '			</item>';
	}
	if ($variables["processing_fee"] != 0) {
		$xml .= '			<item>';
		$xml .= '				<item-name>'.PROCESSING_FEE_MSG.'</item-name>';
		$xml .= '				<item-description>'.PROCESSING_FEE_MSG.'</item-description>';
		$xml .= '				<unit-price currency="'.$payment_params['currency'].'">'.$variables["processing_fee_cr"].'</unit-price>';
		$xml .= '				<quantity>1</quantity>';
		$xml .= '				<tax-table-selector>processing</tax-table-selector>';
		$xml .= '			</item>';
	}
	$xml .= '		</items>';
	$xml .= '		<merchant-private-data>';
	$xml .= '			<merchant-note>'.$order_id.'</merchant-note>';
	$xml .= '		</merchant-private-data>';
	$xml .= '	</shopping-cart>';
	$xml .= '	<checkout-flow-support>';
	$xml .= '		<merchant-checkout-flow-support>';
	if ($variables["shipping_type_desc"]) {
		$xml .= '			<shipping-methods>';
		$xml .= '				<flat-rate-shipping name="'.$variables["shipping_type_desc"].'">';
		$xml .= '					<price currency="'.$payment_params['currency'].'">'.$variables["shipping_cost"].'</price>';
		$xml .= '				</flat-rate-shipping>';
		$xml .= '			</shipping-methods>';
	}
	$xml .= '			<tax-tables>';
	if ($variables["shipping_type_desc"] && $variables["shipping_tax"] !=0) {
		$xml .= '				<default-tax-table>';
		$xml .= '					<tax-rules>';
		$xml .= '						<default-tax-rule>';
		$xml .= '							<shipping-taxed>true</shipping-taxed>';
		$xml .= '							<rate>'.number_format($variables["shipping_tax"]/100, 4).'</rate>';
		$xml .= '							<tax-area>';
		$xml .= '								<us-country-area country-area="ALL"/>';
		$xml .= '							</tax-area>';
		$xml .= '						</default-tax-rule>';
		$xml .= '					</tax-rules>';
		$xml .= '				</default-tax-table>';
	}else{
		$xml .= '				<default-tax-table>';
		$xml .= '					<tax-rules>';
		$xml .= '						<default-tax-rule>';
		$xml .= '							<shipping-taxed>false</shipping-taxed>';
		$xml .= '							<rate>0</rate>';
		$xml .= '							<tax-area>';
		$xml .= '								<us-country-area country-area="ALL"/>';
		$xml .= '							</tax-area>';
		$xml .= '						</default-tax-rule>';
		$xml .= '					</tax-rules>';
		$xml .= '				</default-tax-table>';
	}
	$xml .= '				<alternate-tax-tables>';
	foreach ($variables["items"] as $number => $item) {
		if ($item['tax'] && $item['tax'] != 0) {
			$xml .= '					<alternate-tax-table standalone="true" name="item_'.$number.'">';
			$xml .= '						<alternate-tax-rules>';
			$xml .= '							<alternate-tax-rule>';
			$xml .= '								<rate>'.number_format($item['tax']/100, 4).'</rate>';
			$xml .= '								<tax-area>';
			$xml .= '									<us-country-area country-area="ALL"/>';
			$xml .= '								</tax-area>';
			$xml .= '							</alternate-tax-rule>';
			$xml .= '						</alternate-tax-rules>';
			$xml .= '					</alternate-tax-table>';
		}else{
			$xml .= '					<alternate-tax-table standalone="false" name="item_'.$number.'">';
			$xml .= '						<alternate-tax-rules>';
			$xml .= '							<alternate-tax-rule>';
			$xml .= '								<rate>0</rate>';
			$xml .= '								<tax-area>';
			$xml .= '									<us-country-area country-area="ALL"/>';
			$xml .= '								</tax-area>';
			$xml .= '							</alternate-tax-rule>';
			$xml .= '						</alternate-tax-rules>';
			$xml .= '					</alternate-tax-table>';
		}
	}
	if ($variables["total_discount_with_tax_cr"] != 0) {
			$xml .= '					<alternate-tax-table standalone="false" name="discount">';
			$xml .= '						<alternate-tax-rules>';
			$xml .= '							<alternate-tax-rule>';
			$xml .= '								<rate>0</rate>';
			$xml .= '								<tax-area>';
			$xml .= '									<us-country-area country-area="ALL"/>';
			$xml .= '								</tax-area>';
			$xml .= '							</alternate-tax-rule>';
			$xml .= '						</alternate-tax-rules>';
			$xml .= '					</alternate-tax-table>';
	}
	if ($variables["processing_fee"] != 0) {
			$xml .= '					<alternate-tax-table standalone="false" name="processing">';
			$xml .= '						<alternate-tax-rules>';
			$xml .= '							<alternate-tax-rule>';
			$xml .= '								<rate>0</rate>';
			$xml .= '								<tax-area>';
			$xml .= '									<us-country-area country-area="ALL"/>';
			$xml .= '								</tax-area>';
			$xml .= '							</alternate-tax-rule>';
			$xml .= '						</alternate-tax-rules>';
			$xml .= '					</alternate-tax-table>';
	}
	$xml .= '				</alternate-tax-tables>';
	$xml .= '			</tax-tables>';
	$xml .= '			<rounding-policy>';
	$xml .= '				<mode>HALF_UP</mode>';
	$xml .= '				<rule>PER_LINE</rule>';
	$xml .= '			</rounding-policy>';
	$xml .= '		</merchant-checkout-flow-support>';
	$xml .= '	</checkout-flow-support>';
	$xml .= '</checkout-shopping-cart>';

	$cart = base64_encode($xml);
	$signature = base64_encode(g_c_CalcHmacSha1($xml));

	$t = new VA_Template('.'.$settings["templates_dir"]);
	$t->set_file("main","payment.html");
	$payment_name = 'Google Checkout';
	$goto_payment_message = str_replace("{payment_system}", $payment_name, GOTO_PAYMENT_MSG);
	$goto_payment_message = str_replace("{button_name}", CONTINUE_BUTTON, $goto_payment_message);
	$t->set_var("GOTO_PAYMENT_MSG", $goto_payment_message);
	$t->set_var("payment_url",$payment_params['action_url']);
	$t->set_var("submit_method", "post");
	$t->set_var("parameter_name", "cart");
	$t->set_var("parameter_value", $cart);
	$t->parse("parameters", true);
	$t->set_var("parameter_name", "signature");
	$t->set_var("parameter_value", $signature);
	$t->parse("parameters", true);
	$t->sparse("submit_payment", false);
	$t->pparse("main");
		
	exit;
?>