<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  ideal_check.php                                          ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * iDEAL (www.ing-ideal.nl) transaction handler by www.viart.com
 */

    function stripsimbls( $message ) {
        $message = str_replace( " ", "", $message );
        $message = str_replace( "\t", "", $message );
        $message = str_replace( "\n", "", $message );
        return $message;
    }

    function createCertFingerprint($filename) {
        $fp = fopen($filename, "r");

        if(!$fp) {
            return false;
        }
        $cert = fread($fp, 8192);
        fclose($fp);

        $data = openssl_x509_read($cert);

        if(!openssl_x509_export($data, $data)) {

            return false;
        }

        $data = str_replace("-----BEGIN CERTIFICATE-----", "", $data);
        $data = str_replace("-----END CERTIFICATE-----", "", $data);

        $data = base64_decode($data);

        $fingerprint = sha1($data);

        $fingerprint = strtoupper( $fingerprint );

        return $fingerprint;

    }

    function signMessage($priv_keyfile, $key_pass, $data) {
        $fp = fopen( $priv_keyfile , "r");
        $priv_key = fread($fp, 8192);
        fclose($fp);
        $pkeyid = openssl_get_privatekey($priv_key, $key_pass);

        openssl_sign($data, $signature, $pkeyid);

        openssl_free_key($pkeyid);

        return $signature;

    }

    function PostToHost($url, $timeout, $data_to_send) {
    	$idx = strrpos($url, ":");
    	$host = substr($url, 0, $idx);
    	$url = substr($url, $idx + 1);
    	$idx = strpos($url, "/");
    	$port = substr($url, 0, $idx);
    	$path = substr($url, $idx);
        $fsp = fsockopen($host, $port, $errno, $errstr, $timeout);
        if($fsp) {
            fputs($fsp, "POST $path HTTP/1.0\r\n");
            fputs($fsp, "Accept: text/html\r\n");
            fputs($fsp, "Accept: charset=ISO-8859-1\r\n");
            fputs($fsp, "Content-Length:".strlen($data_to_send)."\r\n");
            fputs($fsp, "Content-Type: text/html; charset=ISO-8859-1\r\n\r\n");
            fputs($fsp, $data_to_send, strlen($data_to_send));

			$res="";
            while(!feof($fsp)) {
                $res .= fgets($fsp, 128);
            }
            fclose($fsp);
	    return $res;
        }
        else {
            return "Error: " . $errstr;
        }
    }

    function verifyMessage($certfile, $data, $signature) {

        $ok=0;
        $fp = fopen( $certfile, "r");

        if(!$fp) {
          return false;
        }

        $cert = fread($fp, 8192);
        fclose($fp);
        $pubkeyid = openssl_get_publickey($cert);

        $ok = openssl_verify($data, $signature, $pubkeyid);

        openssl_free_key($pubkeyid);

        return $ok;

    }

    $transaction_id = get_param("trxid");
    $entrance_code = get_param("ec");

	$sql  = " SELECT payment_id, order_id FROM " . $table_prefix . "orders ";
	$sql .= " WHERE transaction_id=" . $db->tosql($transaction_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$payment_id = $db->f("payment_id");
		$order_id = $db->f("order_id");
	}

	if (!(isset($payment_params["EntranceCode"])) || ($payment_params["EntranceCode"]!=$entrance_code)) {
		$error_message = "Incorrect Entrance Code";
		return;
	}

	$timestamp = gmdate("Y") . "-" . gmdate("m") . "-" . gmdate("d") . "T" . gmdate("H") . ":" . gmdate("i") . ":" . gmdate("s") . ".000Z";
	$token = "";
	$tokenCode = "";
	if ("SHA1_RSA" == $payment_params["AuthenticationType"]) {
		$message = $timestamp . $payment_params["MerchantID"] . $payment_params["SubID"] . $transaction_id;
		$message = stripsimbls( $message );

		$token = createCertFingerprint($payment_params["Privatecert"]);
		$tokenCode = signMessage( $payment_params["Privatekey"], $payment_params["PrivatekeyPass"], $message );
		$tokenCode = base64_encode( $tokenCode );
	}
	$reqMsg = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
	. "<AcquirerStatusReq xmlns=\"http://www.idealdesk.com/Message\" version=\"1.1.0\">\n"
	. "<createDateTimeStamp>" . $timestamp . "</createDateTimeStamp>\n"
	. "<Merchant>" . "<merchantID>" . $payment_params["MerchantID"] . "</merchantID>\n"
	. "<subID>" . $payment_params["SubID"] . "</subID>\n"
	. "<authentication>" . $payment_params["AuthenticationType"] . "</authentication>\n"
	. "<token>" . $token . "</token>\n"
	. "<tokenCode>" . $tokenCode . "</tokenCode>\n"
	. "</Merchant>\n"
	. "<Transaction>" . "<transactionID>" . $transaction_id . "</transactionID>\n"
	. "</Transaction>" . "</AcquirerStatusReq>";

	$answer = PostToHost($payment_params["AcquirerURL"], $payment_params["AcquirerTimeout"], $reqMsg);

	$response_parameters = array();
	preg_match_all ("/<([^>]*?)>([^<]*?)\<\/[^>]*>/", $answer, $matches, PREG_SET_ORDER);
	for($i = 0; $i < sizeof($matches); $i++) {
		$response_parameters[$matches[$i][1]] = ($matches[$i][2]);
	}

	if (isset($response_parameters["errorCode"])) {
		if (!(isset($response_parameters["errorMessage"])) || !(strlen($response_parameters["errorMessage"]))){
			$error_message = "Your transaction has been declined.";
		} else {
			$error_message = $response_parameters["errorMessage"];
		}
		return;
	}

	if (!(isset($response_parameters["status"]))){
		$error_message = "Your transaction has been declined.";
		return;
	}

	if ( $response_parameters["status"] != "Success" ){
		$error_message = $response_parameters["status"];
		return;
	}

	if ( !(isset($response_parameters["createDateTimeStamp"])) || !(isset($response_parameters["consumerAccountNumber"])) ||
		 !(isset($response_parameters["signatureValue"])) ) {
		$error_message = "Your transaction has been declined.";
		return;
	}

	$message = $response_parameters["createDateTimeStamp"] . $transaction_id . $response_parameters["status"] . $response_parameters["consumerAccountNumber"];
	$message = stripsimbls( $message );

	$sig = base64_decode($response_parameters["signatureValue"]);

	$valid = verifyMessage($payment_params["Certificate0"], $message, $sig );

	if( $valid != 1 ) {
		$error_message = "Bad signature!";
	}

?>