<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  paypal_details.php                                       ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * PayPal Express Checkout (www.paypal.com) transaction handler by http://www.viart.com/
 */

	$is_admin_path = true;
	$root_folder_path = "../";
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/order_items.php");
	include_once ($root_folder_path . "includes/order_links.php");
	include_once ($root_folder_path . "includes/date_functions.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");


	$vc = get_session("session_vc");
	$order_id = get_session("session_order_id");
	$token = get_param("token");
	set_session("session_token", $token);

	$order_errors = check_order($order_id, $vc);
	if($order_errors) {
		echo $order_errors;
		exit;
	}

	$variables = array();
	$variables["charset"] = CHARSET;
	$variables["site_url"] = $settings["site_url"];
	$sql  = " SELECT * FROM " . $table_prefix . "orders ";
	$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		// payment information
		$payment_id = $db->f("payment_id");
		$current_status = $db->f("order_status");

		// email variables
		$variables["email"] = $db->f("email");
		$delivery_email["delivery_email"] = $db->f("delivery_email");

		// shopping variables
		$variables["goods_total"] = $db->f("goods_total");
		$variables["total_discount"] = $db->f("total_discount");
		$variables["goods_with_discount"] = $variables["goods_total"] - $variables["total_discount"];
		$variables["shipping_cost"] = $db->f("shipping_cost");
		$variables["tax_percent"] = $db->f("tax_percent");
		$variables["tax_total"] = $db->f("tax_total");
		$variables["order_total"] = $db->f("order_total");
		$variables["order_placed_date"] = $db->f("order_placed_date", DATETIME);
	}

	if (strlen($payment_id)) {
		// get payment parameters
		$payment_params = array();
		$sql  = " SELECT parameter_name, parameter_source, not_passed ";
		$sql .= " FROM " . $table_prefix . "payment_parameters ";
		$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
		$db->query($sql);
		while ($db->next_record()) {
			$parameter_name = trim($db->f("parameter_name"));
			$parameter_source = trim($db->f("parameter_source"));
			$not_passed = trim($db->f("not_passed"));
			if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
				$parameter_value = $parameter_source;
				for($p = 0; $p < sizeof($matches[1]); $p++) {
					$l_source = strtolower($matches[1][$p]);
					if (isset($variables[$l_source])) {
						$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
					}
				}
			} else if (isset($variables[$parameter_source])) {
				$parameter_value = $variables[$parameter_source];
			} else {
				$parameter_value = $parameter_source;
			}
			$payment_params[$parameter_name] = $parameter_value;
		}
	} else {
		// invalid data info
		return;
	}

	// get some variables from our payment settings
	$sandbox        = isset($payment_params["sandbox"]) ? $payment_params["sandbox"] : 0;
	$sslcert        = isset($payment_params["SSLCert"]) ? $payment_params["SSLCert"] : "";


	if ($sandbox == 1) {
		$api_url = "https://api-aa.sandbox.paypal.com/2.0/";
		$paypal_url = "https://www.sandbox.paypal.com/cgi-bin/webscr";
	} else {
		$api_url = "https://api-aa.paypal.com/2.0/";
		$paypal_url = "https://www.paypal.com/cgi-bin/webscr";
	}

	$soap = getDetailsSOAP($payment_params);

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_URL, $api_url);
	curl_setopt ($ch, CURLOPT_POST, 1);
	curl_setopt ($ch, CURLOPT_POSTFIELDS, $soap);
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_SSLCERT, $sslcert);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
	set_curl_options ($ch, $payment_params);

	$paypal_response = curl_exec ($ch);
	curl_close ($ch);

	if (strlen($paypal_response)) {
		if (preg_match("/<SOAP-ENV:Fault>/i", $paypal_response)) {
			$faultcode = ""; $faultstring = "";
			if (preg_match("/<faultcode>(.*)<\/faultcode>/i", $paypal_response, $match)) {
				$faultcode = $match[1];
			}
			if (preg_match("/<faultstring>(.*)<\/faultstring>/i", $paypal_response, $match)) {
				$faultstring = $match[1];
			}
			echo "Some errors occurred during handling your transaction:<br>";
			echo $faultcode . ": " . $faultstring;
			exit;
		} else if (preg_match("/<Errors/i", $paypal_response)) {
			$errorcode = ""; $shortmessage = ""; $longmessage = "";
			if (preg_match("/<ErrorCode[^>]*>(.*)<\/ErrorCode>/i", $paypal_response, $match)) {
				$errorcode = $match[1];
			}
			if (preg_match("/<ShortMessage[^>]*>(.*)<\/ShortMessage>/i", $paypal_response, $match)) {
				$shortmessage = $match[1];
			}
			if (preg_match("/<LongMessage[^>]*>(.*)<\/LongMessage>/i", $paypal_response, $match)) {
				$longmessage = $match[1];
			}
			echo "Some errors occurred during handling your transaction:<br>";
			echo $errorcode . ": " . $shortmessage . "<br>";
			echo $longmessage;
			exit;
		} else if (preg_match("/<PayerID[^>]*>(.*)<\/PayerID>/i", $paypal_response, $match)) {
			$payer_id = $match[1];
			set_session("session_payer_id", $payer_id);

			$confirmation_url = "../order_confirmation.php";
			header("Location: " . $confirmation_url);
			exit;
		} else {
			echo "Can't obtain Payer information from PayPal.";
			exit;
		}

	} else {
		echo "Empty response from PayPal, please check your payment settings.";
		exit;
	}


	function getDetailsSOAP($params)
	{
		global $token;

		$soap  = '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope
   xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
   xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
   xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
   xmlns:xsd="http://www.w3.org/1999/XMLSchema"
   SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">';
		$soap .= '
    <SOAP-ENV:Header>
      <RequesterCredentials
        xmlns="urn:ebay:api:PayPalAPI"
        SOAP-ENV:mustUnderstand="1">
         <Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
';
		if(isset($params["Username"]) && strlen($params["Username"])) {
			$soap .= "<Username>" . $params["Username"] . "</Username>\r\n";
		} else {
			$soap .= "<Username/>\r\n";
		}
		if(isset($params["Password"]) && strlen($params["Password"])) {
			$soap .= "<Password>" . $params["Password"] . "</Password>\r\n";
		} else {
			$soap .= "<Password/>\r\n";
		}
		if(isset($params["Subject"]) && strlen($params["Subject"])) {
			$soap .= "<Subject>" . $params["Subject"] . "</Subject>";
		} else {
			$soap .= "<Subject/>";
		}
		$soap .= '
         </Credentials>
      </RequesterCredentials>
		</SOAP-ENV:Header>
		<SOAP-ENV:Body>
		<GetExpressCheckoutDetailsReq xmlns="urn:ebay:api:PayPalAPI">
			<GetExpressCheckoutDetailsRequest>
        <Version xmlns="urn:ebay:apis:eBLBaseComponents">1.00</Version>';
		$soap .= '<Token>' . $token . '</Token>';
		$soap .= '</GetExpressCheckoutDetailsRequest>
    </GetExpressCheckoutDetailsReq>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>';

		return $soap;
	}

?>