<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  paypal_functions.php                                     ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * PayPal functions by ViArt Ltd - http://www.viart.com/
 */

	function paypal_direct_payment($params)
	{
		global $token;

		$soap  = '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope
   xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
   xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
   xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
   xmlns:xsd="http://www.w3.org/1999/XMLSchema"
   SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">';
		$soap .= '
    <SOAP-ENV:Header>
      <RequesterCredentials
        xmlns="urn:ebay:api:PayPalAPI"
        SOAP-ENV:mustUnderstand="1">
         <Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
';
		if(isset($params["username"]) && strlen($params["username"])) {
			$soap .= "<Username>" . $params["username"] . "</Username>\r\n";
		} else {
			$soap .= "<Username/>\r\n";
		}
		if(isset($params["password"]) && strlen($params["password"])) {
			$soap .= "<Password>" . $params["password"] . "</Password>\r\n";
		} else {
			$soap .= "<Password/>\r\n";
		}
		if(isset($params["Subject"]) && strlen($params["Subject"])) {
			$soap .= "<Subject>" . $params["subject"] . "</Subject>";
		} else {
			$soap .= "<Subject/>";
		}
		$soap .= '
         </Credentials>
      </RequesterCredentials>
		</SOAP-ENV:Header>
		<SOAP-ENV:Body>
		<DoDirectPaymentReq xmlns="urn:ebay:api:PayPalAPI">
			<DoDirectPaymentRequest xmlns="urn:ebay:api:PayPalAPI">
				<Version xmlns="urn:ebay:apis:eBLBaseComponents">1.0</Version>
					<DoDirectPaymentRequestDetails xmlns="urn:ebay:apis:eBLBaseComponents">';
		if(isset($params["paymentaction"]) && strlen($params["paymentaction"])) {
			$soap .= "<PaymentAction>" . $params["paymentaction"] . "</PaymentAction>";
		} else {
			$soap .= "<PaymentAction>Sale</PaymentAction>";
		}

		$currencyID = (isset($params["currencyid"]) && strlen($params["currencyid"])) ? $params["currencyid"] : "USD";

		$soap .= "<PaymentDetails>";
		if(isset($params["ordertotal"]) && strlen($params["ordertotal"])) {
			$soap .= '<OrderTotal currencyID="' . $currencyID . '">' . number_format($params["ordertotal"], 2, ".", "") . '</OrderTotal>';
		}
		if(isset($params["itemtotal"]) && strlen($params["itemtotal"])) {
			$soap .= '<ItemTotal currencyID="' . $currencyID . '">' . number_format($params["itemtotal"], 2, ".", "") . '</ItemTotal>';
		}
		if(isset($params["shippingtotal"]) && strlen($params["shippingtotal"])) {
			$soap .= '<ShippingTotal currencyID="' . $currencyID . '">' . number_format($params["shippingtotal"], 2, ".", "") . '</ShippingTotal>';
		}
		if(isset($params["handlingtotal"]) && strlen($params["handlingtotal"])) {
			$soap .= '<HandlingTotal currencyID="' . $currencyID . '">' . number_format($params["handlingtotal"], 2, ".", "") . '</HandlingTotal>';
		}
		if(isset($params["taxtotal"]) && strlen($params["taxtotal"])) {
			$soap .= '<TaxTotal currencyID="' . $currencyID . '">' . number_format($params["taxtotal"], 2, ".", "") . '</TaxTotal>';
		}
		if(isset($params["orderdescription"]) && strlen($params["orderdescription"])) {
			$soap .= "<OrderDescription>" . $params["orderdescription"] . "</OrderDescription>\r\n";
		}
		if(isset($params["custom"]) && strlen($params["custom"])) {
			$soap .= "<Custom>" . $params["custom"] . "</Custom>\r\n";
		}
		if(isset($params["invoiceid"]) && strlen($params["invoiceid"])) {
			$soap .= "<InvoiceID>" . $params["invoiceid"] . "</InvoiceID>\r\n";
		}
		if(isset($params["buttonsource"]) && strlen($params["buttonsource"])) {
			$soap .= "<ButtonSource>" . $params["buttonsource"] . "</ButtonSource>\r\n";
		}

		$shipname = (isset($params["shipname"])) ? $params["shipname"] : "";
		$shipstreet1 = (isset($params["shipstreet1"])) ? $params["shipstreet1"] : "";
		$shipstreet2 = (isset($params["shipstreet2"])) ? $params["shipstreet2"] : "";
		$shipcityname = (isset($params["shipcityname"])) ? $params["shipcityname"] : "";
		$shipstateorprovince = (isset($params["shipstateorprovince"])) ? $params["shipstateorprovince"] : "";
		$shipcountry = (isset($params["shipcountry"])) ? $params["shipcountry"] : "";
		$shippostalcode = (isset($params["shippostalcode"])) ? $params["shippostalcode"] : "";
		if (strlen($shipname) || strlen($shipstreet1) || strlen($shipstreet2) || strlen($shipcityname) || strlen($shipstateorprovince) || strlen($shipcountry) || strlen($shippostalcode)) {
			$soap .= "<ShipToAddress>\r\n";
			if (strlen($shipname)) { $soap .= "<Name>" . $shipname . "</Name>\r\n"; }
			if (strlen($shipstreet1)) { $soap .= "<Street1>" . $shipstreet1. "</Street1>\r\n"; }
			if (strlen($shipstreet2)) { $soap .= "<Street2>" . $shipstreet2. "</Street2>\r\n"; }
			if (strlen($shipcityname)) { $soap .= "<CityName>" . $shipcityname. "</CityName>\r\n"; }
			if (strlen($shipstateorprovince)) { $soap .= "<StateOrProvince>" . $shipstateorprovince. "</StateOrProvince>\r\n"; }
			if (strlen($shipcountry)) { $soap .= "<Country>" . $shipcountry . "</Country>\r\n"; }
			if (strlen($shippostalcode)) { $soap .= "<PostalCode>" . $shippostalcode. "</PostalCode>\r\n"; }
			$soap .= "</ShipToAddress>\r\n";
		}

		/* information about ordering items
			$soap .= "<PaymentItem>";
			$soap .= "<Name>" . $item_name . "</Name>";
			$soap .= "<Number>" . $item_id . "</Number>";
			$soap .= "<Quantity>" . $quantity . "</Quantity>";
			$soap .= '<SalesTax currencyID="' . $currencyID . '">' . $sales_tax . "</SalesTax>\r\n";
			$soap .= '<Amount currencyID="' . $currencyID . '">' . $amount . "</Amount>\r\n";
			$soap .= "</PaymentItem>";
		//*/

		$soap .= "</PaymentDetails>";
		$soap .= "<CreditCard>";
		if(isset($params["creditcardtype"]) && strlen($params["creditcardtype"])) {
			$cc_type = $params["creditcardtype"];
			$cc_types = array ("visa" => "Visa", "mc" => "MasterCard", "mastercard" => "MasterCard", "discover" => "Discover",
			"amex" => "Amex", "american express" => "Amex", "americanexpress" => "Amex", "switch" => "Switch", "solo" => "Solo");
			if (isset($cc_types[strtolower($cc_type)])) {
				$cc_type = $cc_types[strtolower($cc_type)];
			}
			$soap .= "<CreditCardType>" . $cc_type . "</CreditCardType>\r\n";
		}

		if(isset($params["creditcardnumber"]) && strlen($params["creditcardnumber"])) {
			$soap .= "<CreditCardNumber>" . $params["creditcardnumber"] . "</CreditCardNumber>\r\n";
		}
		if(isset($params["expmonth"]) && strlen($params["expmonth"])) {
			$soap .= "<ExpMonth>" . $params["expmonth"] . "</ExpMonth>\r\n";
		}
		if(isset($params["expyear"]) && strlen($params["expyear"])) {
			$soap .= "<ExpYear>" . $params["expyear"] . "</ExpYear>\r\n";
		}
		$soap .= "<CardOwner>";
		if(isset($params["payer"]) && strlen($params["payer"])) {
			$soap .= "<Payer>" . $params["payer"] . "</Payer>\r\n";
		}

		$soap .= "<PayerName>";
		if(isset($params["ccsalutation"]) && strlen($params["ccsalutation"])) {
			$soap .= "<Salutation>" . $params["ccsalutation"] . "</Salutation>\r\n";
		}
		if(isset($params["ccfirstname"]) && strlen($params["ccfirstname"])) {
			$soap .= "<FirstName>" . $params["ccfirstname"] . "</FirstName>\r\n";
		}
		if(isset($params["ccmiddlename"]) && strlen($params["ccmiddlename"])) {
			$soap .= "<MiddleName>" . $params["ccmiddlename"] . "</MiddleName>\r\n";
		}
		if(isset($params["cclastname"]) && strlen($params["cclastname"])) {
			$soap .= "<LastName>" . $params["cclastname"] . "</LastName>\r\n";
		}
		if(isset($params["ccsuffix"]) && strlen($params["ccsuffix"])) {
			$soap .= "<Suffix>" . $params["ccsuffix"] . "</Suffix>\r\n";
		}
		$soap .= "</PayerName>";

		$name = (isset($params["name"])) ? $params["name"] : "";
		$street1 = (isset($params["street1"])) ? $params["street1"] : "";
		$street2 = (isset($params["street2"])) ? $params["street2"] : "";
		$cityname = (isset($params["cityname"])) ? $params["cityname"] : "";
		$stateorprovince = (isset($params["stateorprovince"])) ? $params["stateorprovince"] : "";
		$country = (isset($params["country"])) ? $params["country"] : "";
		$postalcode = (isset($params["postalcode"])) ? $params["postalcode"] : "";
		if (strlen($name) || strlen($street1) || strlen($street2) || strlen($cityname) || strlen($stateorprovince) || strlen($country) || strlen($postalcode)) {
			$soap .= "<Address>\r\n";
			if (strlen($name)) { $soap .= "<Name>" . $name . "</Name>\r\n"; }
			if (strlen($street1)) { $soap .= "<Street1>" . $street1. "</Street1>\r\n"; }
			if (strlen($street2)) { $soap .= "<Street2>" . $street2. "</Street2>\r\n"; }
			if (strlen($cityname)) { $soap .= "<CityName>" . $cityname. "</CityName>\r\n"; }
			if (strlen($stateorprovince)) { $soap .= "<StateOrProvince>" . $stateorprovince. "</StateOrProvince>\r\n"; }
			if (strlen($country)) { $soap .= "<Country>" . $country . "</Country>\r\n"; }
			if (strlen($postalcode)) { $soap .= "<PostalCode>" . $postalcode. "</PostalCode>\r\n"; }
			$soap .= "</Address>\r\n";
		}

		$soap .= "</CardOwner>";
		if(isset($params["cvv2"]) && strlen($params["cvv2"])) {
			$soap .= "<CVV2>" . $params["cvv2"] . "</CVV2>\r\n";
		}
		if(isset($params["startmonth"]) && strlen($params["startmonth"])) {
			$soap .= "<StartMonth>" . $params["startmonth"] . "</StartMonth>\r\n";
		}
		if(isset($params["startyear"]) && strlen($params["startyear"])) {
			$soap .= "<StartYear>" . $params["startyear"] . "</StartYear>\r\n";
		}
		if(isset($params["issuenumber"]) && strlen($params["issuenumber"])) {
			$soap .= "<IssueNumber>" . $params["issuenumber"] . "</IssueNumber>\r\n";
		}

		$soap .= "</CreditCard>";

		if(isset($params["ipaddress"]) && strlen($params["ipaddress"])) {
			$soap .= "<IPAddress>" . $params["ipaddress"] . "</IPAddress>\r\n";
		} else {
			$soap .= "<IPAddress>" . get_ip() . "</IPAddress>\r\n";
		}
		$soap .= "<MerchantSessionId>" . session_id() . "</MerchantSessionId>\r\n";

		$soap .= "
				</DoDirectPaymentRequestDetails>
			</DoDirectPaymentRequest>
		</DoDirectPaymentReq>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>";

		return $soap;
	}

?>