<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  paypal_ipn.php                                           ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * PayPal IPN (www.paypal.com) transaction handler by http://www.viart.com/
 */

	$is_admin_path = true;
	$root_folder_path = "../";
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/order_items.php");
	include_once ($root_folder_path . "includes/order_links.php");
	include_once ($root_folder_path . "includes/date_functions.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");

	// initialize template object
	$t = new VA_Template(".");

	$order_id = get_param("invoice");
	$payment_id = "";

	$sql  = " SELECT * FROM " . $table_prefix . "orders ";
	$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		// payment information
		$payment_id = $db->f("payment_id");
		$is_placed = $db->f("is_placed");
		$current_status = $db->f("order_status");

		// email variables
		$email = $db->f("email");
		$delivery_email = $db->f("delivery_email");

		// shopping variables
		$goods_total = $db->f("goods_total");
		$total_discount = $db->f("total_discount");
		$goods_with_discount = $goods_total - $total_discount;
		$shipping_cost = $db->f("shipping_cost");
		$tax_percent = $db->f("tax_percent");
		$tax_total = $db->f("tax_total");
		$order_total = $db->f("order_total");
		$order_placed_date = $db->f("order_placed_date", DATETIME);
		$cc_start_date = $db->f("cc_start_date", DATETIME);
		$cc_expiry_date = $db->f("cc_expiry_date", DATETIME);
		$cc_type = $db->f("cc_type");

		// info variables
		$company_id = $db->f("company_id");
		$state_code = $db->f("state_code");
		$country_code = $db->f("country_code");
		$delivery_company_id = $db->f("delivery_company_id");
		$delivery_state_code = $db->f("delivery_state_code");
		$delivery_country_code = $db->f("delivery_country_code");
		$t->set_vars($db->Record);

		$t->set_var("goods_total", $currency_left . number_format($goods_total * $currency_rate, 2) . $currency_right);
		$t->set_var("total_discount", $currency_left . number_format($total_discount * $currency_rate, 2) . $currency_right);
		$t->set_var("goods_with_discount", $currency_left . number_format($goods_with_discount * $currency_rate, 2) . $currency_right);
		$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost * $currency_rate, 2) . $currency_right);
		$t->set_var("tax_percent", number_format($tax_percent, 2) . "%");
		$t->set_var("tax_total", $currency_left . number_format($tax_total * $currency_rate, 2) . $currency_right);
		$t->set_var("tax_cost", $currency_left . number_format($tax_total * $currency_rate, 2) . $currency_right);
		$t->set_var("order_total", $currency_left . number_format($order_total * $currency_rate, 2) . $currency_right);
		$t->set_var("order_placed_date", va_date($datetime_show_format, $order_placed_date));
		$t->set_var("cc_start_date", va_date(array("MM"," / ","YYYY"), $cc_start_date));
		$t->set_var("cc_expiry_date", va_date(array("MM"," / ","YYYY"), $cc_expiry_date));

		if($cc_type) {
			$t->set_var("cc_type", get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($cc_type, INTEGER)));
		}
		if($company_id) {
			$t->set_var("company_select", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($company_id, INTEGER)));
		}
		if($state_code) {
			$t->set_var("state", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($state_code, TEXT)));
		}
		if($country_code) {
			$t->set_var("country", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($country_code, TEXT)));
		}
		if($delivery_company_id) {
			$t->set_var("delivery_company_select", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($delivery_company_id, INTEGER)));
		}
		if($delivery_state_code) {
			$t->set_var("delivery_state", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($delivery_state_code, TEXT)));
		}
		if($delivery_country_code) {
			$t->set_var("delivery_country", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($delivery_country_code, TEXT)));
		}

	}

	if (strlen($payment_id)) {
		// get payment parameters
		$payment_params = array(); $pass_parameters = array();
		$sql = " SELECT parameter_name, parameter_source, not_passed FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
		$db->query($sql);
		while ($db->next_record()) {
			$parameter_name = trim($db->f("parameter_name"));
			$parameter_source = trim($db->f("parameter_source"));
			$not_passed = trim($db->f("not_passed"));
			$parameter_passed = ($not_passed == 1) ? 0 : 1;
			$payment_params[$parameter_name] = $parameter_source;
			$pass_parameters[$parameter_name]  = $parameter_passed;
		}

		$order_final = array();
		$setting_type = "order_final_" . $payment_id;
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
		$db->query($sql);
		while($db->next_record()) {
			$order_final[$db->f("setting_name")] = $db->f("setting_value");
		}

	} else {
		// invalid data info
		return;
	}

	// get some variables from our payment settings
	$business_email = isset($payment_params["business"]) ? $payment_params["business"] : 0;
	$sandbox        = isset($payment_params["sandbox"]) ? $payment_params["sandbox"] : 0;
	$ssl            = isset($payment_params["ssl"]) ? $payment_params["ssl"] : 0;

	if ($sandbox == 1) {
		$paypal_url = "www.sandbox.paypal.com";
	} else {
		$paypal_url = "www.paypal.com";
	}

	// read the post from PayPal system and add 'cmd'
	$request_params = "cmd=_notify-validate";

	if (isset($_POST)) {
		foreach ($_POST as $key => $value) {
			$t->set_var($key, $value);
			$value = urlencode(stripslashes($value));
			$request_params .= "&$key=$value";
		}
	} else {
		foreach ($HTTP_POST_VARS as $key => $value) {
			$t->set_var($key, $value);
			$value = urlencode(stripslashes($value));
			$request_params .= "&$key=$value";
		}
	}



	// request header to PayPal system to validate
	$request_header  = "POST /cgi-bin/webscr HTTP/1.0\r\n";
	$request_header .= "Host: " . $paypal_url . "\r\n";
	$request_header .= "Content-Type: application/x-www-form-urlencoded\r\n";
	$request_header .= "Content-Length: " . strlen($request_params) . "\r\n\r\n";

	if($ssl == 1) {
		// If possible, securely post back to paypal using HTTPS
		// Your PHP server will need to be SSL enabled
		$fp = fsockopen ("ssl://" . $paypal_url, 443, $errno, $errstr, 30);
	} else {
		$fp = fsockopen ($paypal_url, 80, $errno, $errstr, 30);
	}


// assign posted variables to local variables
/*
$item_name = $_POST['item_name'];
$item_number = $_POST['item_number'];
$payer_email = $_POST['payer_email'];
*/

	if (!$fp) {
		// HTTP ERROR
		$error_message = "Can't connect to PayPal.";
	} else {
		fputs ($fp, $request_header . $request_params);
		while (!feof($fp)) {
			$res = fgets ($fp, 1024);
			if (strcmp ($res, "VERIFIED") == 0) {
				// check the payment_status is Completed
				// check that txn_id has not been previously processed
				// check that receiver_email is your Primary PayPal email
				// check that payment_amount/payment_currency are correct
				// process payment
				$transaction_id   = get_param("txn_id");
				$payment_status   = get_param("payment_status");
				$payment_currency = get_param("mc_currency");
				$payment_amount   = get_param("mc_gross");
        $receiver_email   = get_param("receiver_email");
        $pending_reason   = get_param("pending_reason");

				if (strtolower($payment_status) == "pending") {
					$pending_message = strlen($pending_reason) ? $pending_reason : "Pending";
				}

				if (strtolower($payment_status) != "completed" && strtolower($payment_status) != "pending") {	// check the payment_status is Completed
					if (strlen($payment_status)) {
						$error_message = "Your payment status is " . $payment_status;
					} else {
						$error_message = "Unknown payment status";
					}
				} else if (strtolower(trim($business_email)) != strtolower(trim($receiver_email))) {	// check that receiver_email is your Primary PayPal email
					$error_message = "Wrong receiver email - " . $receiver_email;
				} else {
					// check that payment_amount/payment_currency are correct
					$error_message = check_payment($order_id, $payment_amount, $payment_currency);
				}

				// get statuses
				$success_status_id = get_setting_value($order_final, "success_status_id", "");
				$pending_status_id = get_setting_value($order_final, "pending_status_id", "");
				$failure_status_id = get_setting_value($order_final, "failure_status_id", "");

				// update order status
				$is_failed = false; $is_pending = false; $is_success = false;
				if (strlen($error_message)) {
					$is_failed = true;
					$t->set_var("error_desc", $error_message);
					$t->set_var("error_message", $error_message);
					$order_status = $failure_status_id;
					$sql  = " UPDATE " . $table_prefix . "orders ";
					$sql .= " SET error_message=" . $db->tosql($error_message, TEXT);
					$sql .= " , transaction_id=" . $db->tosql($transaction_id, TEXT);
					$sql .= " , is_placed=1 ";
					$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER) ;

				} else if (strlen($pending_message)) {
					$is_pending = true;
					$t->set_var("pending_desc", $pending_message);
					$t->set_var("pending_message", $pending_message);
					$order_status = $pending_status_id;
					$sql  = " UPDATE " . $table_prefix . "orders ";
					$sql .= " SET pending_message=" . $db->tosql($pending_message, TEXT);
					$sql .= " , transaction_id=" . $db->tosql($transaction_id, TEXT);
					$sql .= " , is_placed=1 ";
					$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER) ;
				} else {
					$is_success = true;
					$order_status = $success_status_id;
					$sql  = " UPDATE " . $table_prefix . "orders ";
					$sql .= " SET error_message=''";
					$sql .= " , pending_message=''";
					$sql .= " , transaction_id=" . $db->tosql($transaction_id, TEXT);
					$sql .= " , is_placed=1 ";
					$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER) ;
				}
				$db->query($sql);

				// update order status
				update_order_status($order_id, $order_status, true);

				// send emails
				if ($current_status != $order_status) // check if status was changed
				{
					$t->set_var("request_params", $request_params);
					// get download links
					$links = get_order_links($order_id);
					$t->set_var("links",      $links["html"]);
					$t->set_var("links_html", $links["html"]);
					$t->set_var("links_txt",  $links["text"]);

					// get serial numbers
					$order_serials = get_serial_numbers($order_id);
					$t->set_var("serials", $order_serials["html"]);
					$t->set_var("serial_numbers", $order_serials["html"]);

					// get gift vouchers
					$order_vouchers = get_gift_vouchers($order_id);
					$t->set_var("vouchers", $order_vouchers["html"]);
					$t->set_var("gift_vouchers", $order_vouchers["html"]);

					// get admin notify
					$admin_notification   = get_setting_value($order_final, "admin_notification",   0);
					$admin_pending_notify = get_setting_value($order_final, "admin_pending_notify", 0);
					$admin_failure_notify = get_setting_value($order_final, "admin_failure_notify", 0);

					// get user notify
					$user_notification   = get_setting_value($order_final, "user_notification",   0);
					$user_pending_notify = get_setting_value($order_final, "user_pending_notify", 0);
					$user_failure_notify = get_setting_value($order_final, "user_failure_notify", 0);

					$order_admin_email = (isset($order_final["admin_email"]) && $order_final["admin_email"]) ? $order_final["admin_email"] : $settings["admin_email"];

					if(($is_success && $admin_notification) || ($is_pending && $admin_pending_notify) || ($is_failed && $admin_failure_notify))
					{
						$admin_subject = get_final_message($order_final["admin_subject"], $message_type);
						$admin_message = get_final_message($order_final["admin_message"], $message_type);
						$t->set_block("admin_subject", $admin_subject);
						$t->set_block("admin_message", $admin_message);

						$items_text = show_order_items($order_id, true);

						$mail_to = get_setting_value($order_final, "admin_email", $settings["admin_email"]);
						$mail_to = str_replace(";", ",", $mail_to);
						$mail_from = get_setting_value($order_final, "admin_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($order_final, "cc_emails");
						$mail_bcc = get_setting_value($order_final, "admin_mail_bcc");
						$mail_reply_to = get_setting_value($order_final, "admin_mail_reply_to");
						$mail_return_path = get_setting_value($order_final, "admin_mail_return_path");
						$mail_type = get_setting_value($order_final, "admin_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						if (!$mail_type) {
							$t->set_var("basket", $items_text);
							$t->set_var("links",  $links["text"]);
							$t->set_var("serials", $order_serials["text"]);
							$t->set_var("serial_numbers", $order_serials["text"]);
							$t->set_var("vouchers", $order_vouchers["text"]);
							$t->set_var("gift_vouchers", $order_vouchers["text"]);
						}

						$t->parse("admin_subject", false);
						$t->parse("admin_message", false);
						$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
						mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}

					if(($is_success && $user_notification) || ($is_pending && $user_pending_notify) || ($is_failed && $user_failure_notify))
					{
						$user_subject = get_final_message($order_final["user_subject"], $message_type);
						$user_message = get_final_message($order_final["user_message"], $message_type);
						$t->set_block("user_subject", $user_subject);
						$t->set_block("user_message", $user_message);

						$items_text = show_order_items($order_id, true);

						$mail_from = get_setting_value($order_final, "user_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($order_final, "user_mail_cc");
						$mail_bcc = get_setting_value($order_final, "user_mail_bcc");
						$mail_reply_to = get_setting_value($order_final, "user_mail_reply_to");
						$mail_return_path = get_setting_value($order_final, "user_mail_return_path");
						$mail_type = get_setting_value($order_final, "user_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

						if (!$mail_type) {
							$t->set_var("basket", $items_text);
							$t->set_var("links",  $links["text"]);
							$t->set_var("serials", $order_serials["text"]);
							$t->set_var("serial_numbers", $order_serials["text"]);
							$t->set_var("vouchers", $order_vouchers["text"]);
							$t->set_var("gift_vouchers", $order_vouchers["text"]);
						}

						$t->parse("user_subject", false);
						$t->parse("user_message", false);
						$user_email = strlen($email) ? $email : $delivery_email;
						$user_message = str_replace("\r", "", $t->get_var("user_message"));
						mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
					}

				}
			} else if (strcmp ($res, "INVALID") == 0) {
				// log for manual investigation
				// mail("to@youraddress", "Invalid PayPal IPN Request", $request_params)
			}
		}
		fclose ($fp);
	}

?>