<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  paypal_payment.php                                       ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * PayPal Express Checkout (www.paypal.com) handler by http://www.viart.com/
 */

	// get some variables from our payment settings
	$sandbox        = isset($payment_params["sandbox"]) ? $payment_params["sandbox"] : 0;
	$sslcert        = isset($payment_params["SSLCert"]) ? $payment_params["SSLCert"] : "";
	$token          = get_session("session_token");
	$payer_id       = get_session("session_payer_id");


	if ($sandbox == 1) {
		$api_url = "https://api-aa.sandbox.paypal.com/2.0/";
	} else {
		$api_url = "https://api-aa.paypal.com/2.0/";
	}

	$soap = getPaymentSOAP($payment_params);

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_URL, $api_url);
	curl_setopt ($ch, CURLOPT_POST, 1);
	curl_setopt ($ch, CURLOPT_POSTFIELDS, $soap);
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_SSLCERT, $sslcert);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
	set_curl_options ($ch, $payment_params);

	$paypal_response = curl_exec ($ch);
	curl_close ($ch);

	if (strlen($paypal_response)) {
		if (preg_match("/<SOAP-ENV:Fault>/i", $paypal_response)) {
			$faultcode = ""; $faultstring = "";
			if (preg_match("/<faultcode>(.*)<\/faultcode>/i", $paypal_response, $match)) {
				$faultcode = $match[1];
			}
			if (preg_match("/<faultstring>(.*)<\/faultstring>/i", $paypal_response, $match)) {
				$faultstring = $match[1];
			}
			$error_message  = "Some errors occurred during handling your transaction:<br>";
			$error_message .= $faultcode . ": " . $faultstring;
			return;
		} else if (preg_match("/<Errors/i", $paypal_response)) {
			$errorcode = ""; $shortmessage = ""; $longmessage = "";
			if (preg_match("/<ErrorCode[^>]*>(.*)<\/ErrorCode>/i", $paypal_response, $match)) {
				$errorcode = $match[1];
			}
			if (preg_match("/<ShortMessage[^>]*>(.*)<\/ShortMessage>/i", $paypal_response, $match)) {
				$shortmessage = $match[1];
			}
			if (preg_match("/<LongMessage[^>]*>(.*)<\/LongMessage>/i", $paypal_response, $match)) {
				$longmessage = $match[1];
			}
			$error_message  = "Some errors occurred during handling your transaction:<br>";
			$error_message .= $errorcode . ": " . $shortmessage . "<br>";
			$error_message .= $longmessage;
			return;
		} else if (preg_match("/<TransactionID[^>]*>(.*)<\/TransactionID>/i", $paypal_response, $match)) {
			$transaction_id = $match[1];

			$payment_status = ""; $pending_reason = "";
			if (preg_match("/<PaymentStatus[^>]*>(.*)<\/PaymentStatus>/i", $paypal_response, $match)) {
				$payment_status = $match[1];
			}
			if (preg_match("/<PendingReason[^>]*>(.*)<\/PendingReason>/i", $paypal_response, $match)) {
				$pending_reason = $match[1];
			}
			if (strtolower($payment_status) == "pending") {
				$pending_message = strlen($pending_reason) ? $pending_reason : "Pending";
			} else if (!strlen($payment_status)) {
				$error_message = "Can't obtain status for your order.";
			} else if (strtolower($payment_status) != "completed") {	// check the payment_status is Completed
				$error_message = "Your payment status is " . $payment_status;
			}

		} else {
			$error_message  = "Can't obtain transaction information from PayPal.";
			return;
		}

	} else {
		$error_message  = "Empty response from PayPal, please check your payment settings.";
		return;
	}


	function getPaymentSOAP($params)
	{
		global $token, $payer_id;

		$soap  = '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope
   xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
   xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
   xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
   xmlns:xsd="http://www.w3.org/1999/XMLSchema"
   SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">';
		$soap .= '
    <SOAP-ENV:Header>
      <RequesterCredentials
        xmlns="urn:ebay:api:PayPalAPI"
        SOAP-ENV:mustUnderstand="1">
         <Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
';
		if(isset($params["Username"]) && strlen($params["Username"])) {
			$soap .= "<Username>" . $params["Username"] . "</Username>\r\n";
		} else {
			$soap .= "<Username/>\r\n";
		}
		if(isset($params["Password"]) && strlen($params["Password"])) {
			$soap .= "<Password>" . $params["Password"] . "</Password>\r\n";
		} else {
			$soap .= "<Password/>\r\n";
		}
		if(isset($params["Subject"]) && strlen($params["Subject"])) {
			$soap .= "<Subject>" . $params["Subject"] . "</Subject>";
		} else {
			$soap .= "<Subject/>";
		}
		$soap .= '
         </Credentials>
      </RequesterCredentials>
		</SOAP-ENV:Header>
		<SOAP-ENV:Body>
		<DoExpressCheckoutPaymentReq xmlns="urn:ebay:api:PayPalAPI">
			<DoExpressCheckoutPaymentRequest>
				<Version xmlns="urn:ebay:apis:eBLBaseComponents">1.0</Version>
					<DoExpressCheckoutPaymentRequestDetails xmlns="urn:ebay:apis:eBLBaseComponents">';
		if(isset($params["PaymentAction"]) && strlen($params["PaymentAction"])) {
			$soap .= "<PaymentAction>" . $params["PaymentAction"] . "</PaymentAction>";
		} else {
			$soap .= "<PaymentAction>Sale</PaymentAction>";
		}
		$soap .= '<Token>' . $token . '</Token>';
		$soap .= '<PayerID>' . $payer_id . '</PayerID>';
		$soap .= '<PaymentDetails>';

		$currencyID = (isset($params["currencyID"]) && strlen($params["currencyID"])) ? $params["currencyID"] : "USD";
		$OrderTotal = (isset($params["OrderTotal"]) && strlen($params["OrderTotal"])) ? number_format($params["OrderTotal"], 2, ".", "") : "0.00";

		$soap .= '<OrderTotal currencyID="' . $currencyID . '">' . $OrderTotal . "</OrderTotal>\r\n";
		if(isset($params["ItemTotal"]) && strlen($params["ItemTotal"])) {
			$soap .= '<ItemTotal currencyID="' . $currencyID . '">' . number_format($params["ItemTotal"], 2, ".", "") . '</ItemTotal>';
		}
		if(isset($params["ShippingTotal"]) && strlen($params["ShippingTotal"])) {
			$soap .= '<ShippingTotal currencyID="' . $currencyID . '">' . number_format($params["ShippingTotal"], 2, ".", "") . '</ShippingTotal>';
		}
		if(isset($params["HandlingTotal"]) && strlen($params["HandlingTotal"])) {
			$soap .= '<HandlingTotal currencyID="' . $currencyID . '">' . number_format($params["HandlingTotal"], 2, ".", "") . '</HandlingTotal>';
		}
		if(isset($params["TaxTotal"]) && strlen($params["TaxTotal"])) {
			$soap .= '<TaxTotal currencyID="' . $currencyID . '">' . number_format($params["TaxTotal"], 2, ".", "") . '</TaxTotal>';
		}
		if(isset($params["OrderDescription"]) && strlen($params["OrderDescription"])) {
			$soap .= "<OrderDescription>" . $params["OrderDescription"] . "</OrderDescription>\r\n";
		}
		if(isset($params["buttonsource"]) && strlen($params["buttonsource"])) {
			$soap .= "<ButtonSource>" . $params["buttonsource"] . "</ButtonSource>\r\n";
		}

		$ShipName = (isset($params["ShipName"])) ? $params["ShipName"] : "";
		$ShipStreet1 = (isset($params["ShipStreet1"])) ? $params["ShipStreet1"] : "";
		$ShipStreet2 = (isset($params["ShipStreet2"])) ? $params["ShipStreet2"] : "";
		$ShipCityName = (isset($params["ShipCityName"])) ? $params["ShipCityName"] : "";
		$ShipStateOrProvince = (isset($params["ShipStateOrProvince"])) ? $params["ShipStateOrProvince"] : "";
		$ShipCountry = (isset($params["ShipCountry"])) ? $params["ShipCountry"] : "";
		$ShipPostalCode = (isset($params["ShipPostalCode"])) ? $params["ShipPostalCode"] : "";
		if (strlen($ShipName) || strlen($ShipStreet1) || strlen($ShipStreet2) || strlen($ShipCityName) || strlen($ShipStateOrProvince) || strlen($ShipCountry) || strlen($PostalCode)) {
			$soap .= "<ShipToAddress>\r\n";
			if (strlen($ShipName)) { $soap .= "<Name>" . $ShipName . "</Name>\r\n"; }
			if (strlen($ShipStreet1)) { $soap .= "<Street1>" . $ShipStreet1. "</Street1>\r\n"; }
			if (strlen($ShipStreet2)) { $soap .= "<Street2>" . $ShipStreet2. "</Street2>\r\n"; }
			if (strlen($ShipCityName)) { $soap .= "<CityName>" . $ShipCityName. "</CityName>\r\n"; }
			if (strlen($ShipStateOrProvince)) { $soap .= "<StateOrProvince>" . $ShipStateOrProvince. "</StateOrProvince>\r\n"; }
			if (strlen($ShipCountry)) { $soap .= "<Country>" . $ShipCountry . "</Country>\r\n"; }
			if (strlen($ShipPostalCode)) { $soap .= "<PostalCode>" . $ShipPostalCode. "</PostalCode>\r\n"; }
			$soap .= "</ShipToAddress>\r\n";
		}

		/* information about ordering items
			$soap .= "<PaymentItem>";
			$soap .= "<Name>" . $item_name . "</Name>";
			$soap .= "<Number>" . $item_id . "</Number>";
			$soap .= "<Quantity>" . $quantity . "</Quantity>";
			$soap .= '<SalesTax currencyID="' . $currencyID . '">' . $sales_tax . "</SalesTax>\r\n";
			$soap .= '<Amount currencyID="' . $currencyID . '">' . $amount . "</Amount>\r\n";
			$soap .= "</PaymentItem>";
		//*/

			$soap .= '</PaymentDetails>
				</DoExpressCheckoutPaymentRequestDetails>
			</DoExpressCheckoutPaymentRequest>
		</DoExpressCheckoutPaymentReq>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>';

		return $soap;
	}

?>