<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  user_login.php                                           ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./includes/common.php");

	// clear session data for new user if he go to login page
	$new_user_id = get_session("session_new_user_id");
	if ($new_user_id) {
		set_session("session_new_user", "");
		set_session("session_new_user_id", "");
	}

	$secure_url = get_setting_value($settings, "secure_url", "");
	$secure_user_profile = get_setting_value($settings, "secure_user_profile", 0);
	if ($secure_user_profile) {
		$user_profile_url = $secure_url . "user_profile.php";
	} else {
		$user_profile_url = "user_profile.php";
	}

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main", "user_login.html");

	$t->set_var("user_login_href", "user_login.php");
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("user_profile_href", "user_profile.php");
	$t->set_var("user_profile_url",  $user_profile_url);
	$t->set_var("forgot_password_href", "forgot_password.php");


	$return_page = get_param("return_page");
	if (!strlen($return_page)) $return_page = "user_home.php";

	$login = get_cookie("cookie_user_login");
	$password = get_cookie("cookie_user_password");
	if (strlen($login) && strlen($password)) {
		$cookie_login = true;
	} else {
		$cookie_login = false;
		$login = "";
		$password = "";
	}

	$remember_me = get_param("remember_me");
	$operation = get_param("operation");
	$errors = "";
	if (strlen($operation) || ($cookie_login && !get_session("session_user_id")))
	{
		if ($operation == "cancel")
		{
			header("Location: index.php");
			exit;
		}
		elseif($operation == "logout")
		{
			user_logout();
		}
		else
		{
			if (!$cookie_login) {
				$login = get_param("login");
				$password = get_param("password");

				if (!strlen($login)) {
					$error_message = str_replace("{field_name}", LOGIN_FIELD, REQUIRED_MESSAGE);
					$errors .= $error_message . "<br>";
				}

				if (!strlen($password)) {
					$error_message = str_replace("{field_name}", PASSWORD_FIELD, REQUIRED_MESSAGE);
					$errors .= $error_message . "<br>";
				}
			}

			if (!$errors && check_black_ip()) {
				$errors = BLACK_IP_MSG;
			}

			if (!$errors) {
				user_login($login, $password, "", $remember_me, $return_page, true, $errors);
			}
		}
	}

	if ($remember_me) {
		$t->set_var("remember_me", "checked");
	} else {
		$t->set_var("remember_me", "");
	}

	if ($errors) {
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}	else {
		$t->set_var("errors", "");
	}

	if (get_session("session_user_id"))	{
		$user_info = get_session("session_user_info");
		$user_login = get_setting_value($user_info, "nickname", "");
		if (!$user_login) {
			$user_login = get_setting_value($user_info, "login", "");
		}
		$t->set_var("user_login", $user_login);
		$t->set_var("user_name", get_session("session_user_name"));
		$t->set_var("operation", "logout");
		$t->set_var("login_form", "");
		$t->parse("logout_form", false);
	} else {
		// parse user types allowed for registration
		$sql = " SELECT type_id, type_name FROM " . $table_prefix . "user_types WHERE is_active=1 AND show_for_user=1 ";
		$db->query($sql);
		if ($db->next_record()) {
			do {
				$type_id = $db->f("type_id");
				$type_name = get_translation($db->f("type_name"));
				$t->set_var("user_type_name",  $type_name);
				$t->set_var("user_profile_url",  $user_profile_url . "?type=" . $type_id);
				$t->parse("user_types", true);
			} while ($db->next_record());

			$t->sparse("new_user_block", false);
		}

		$t->set_var("return_page", htmlspecialchars($return_page));
		$t->set_var("login", htmlspecialchars($login));
		$t->set_var("operation", "login");
		$t->set_var("logout_form", "");
		$t->parse("login_form", false);
	}

	$type_error = get_param("type_error");
	if ($type_error == 2) {
		//$t->parse("access_error", false);
		//$errors = true;
	}

	include("./header.php");
	include("./footer.php");

	$t->pparse("main");

?>