<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  user_orders.php                                          ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	$includes_path = "./includes/";
	include_once($includes_path . "common.php");
	include_once($includes_path . "sorter.php");
	include_once($includes_path . "navigator.php");
	include_once($includes_path . "record.php");
	include_once("./messages/" . $language_code . "/cart_messages.php");

	check_user_session();

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$currency_code = $currency["code"];

	$orders_currency = get_setting_value($settings, "orders_currency", 0);

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main", "user_orders.html");
	$t->set_var("user_orders_href", "user_orders.php");
	$t->set_var("user_order_href", "user_order.php");
	$t->set_var("user_order_payment_href", "user_order_payment.php");
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("user_invoice_pdf_href", "user_invoice_pdf.php");
	$t->set_var("user_invoice_html_href", "user_invoice_html.php");

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "user_orders.php");
	$s->set_default_sorting(1, "desc");
	$s->set_sorter(ORDER_NUMBER_COLUMN, "sorter_id", "1", "order_id");
	$s->set_sorter(ORDER_ADDED_COLUMN, "sorter_date", "2", "order_placed_date");
	$s->set_sorter(ORDER_STATUS_COLUMN, "sorter_status", "3", "order_status");
	$s->set_sorter(ORDER_TOTAL_COLUMN, "sorter_total", "4", "order_total");

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "user_orders.php");

	include("./header.php");
	include("./footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "orders o WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT o.order_id, o.order_placed_date, os.status_name, o.goods_total, o.order_total, ";
	$sql .= " o.currency_code, o.currency_rate, c.symbol_right, c.symbol_left, o.is_placed, os.paid_status ";
	$sql .= " FROM ((" . $table_prefix . "orders o ";
	$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON o.order_status=os.status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "currencies c ON o.currency_code=c.currency_code) ";
	$sql .= " WHERE o.user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	$db->query($sql . $s->order_by);
	if ($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do
		{
			$order_id = $db->f("order_id");
			$is_placed = $db->f("is_placed");
			$paid_status = $db->f("paid_status");
			$order_total = $db->f("order_total");
			$placed_date = $db->f("order_placed_date", DATETIME);
			$order_currency_code = $db->f("currency_code");
			$order_currency_rate = $db->f("currency_rate");
			$order_currency_left = $db->f("symbol_left");
			$order_currency_right = $db->f("symbol_right");
			$vc = md5($order_id . $placed_date[3].$placed_date[4].$placed_date[5]);
			if ($orders_currency != 1) {
				$order_currency_left = $currency_left;
				$order_currency_right = $currency_right;
				if (strtolower($currency_code) != strtolower($order_currency_code)) {
					$order_currency_rate = $currency_rate;
				}
			}
			$t->set_var("order_id", $order_id);
			$t->set_var("vc", $vc);

			$t->set_var("order_placed_date", va_date($datetime_show_format, $placed_date));

			$t->set_var("order_status", $db->f("status_name"));
			$t->set_var("order_total", $order_currency_left . number_format($order_total * $order_currency_rate, 2) . $order_currency_right);
			if ($is_placed || $paid_status) {
				$t->set_var("pay_link", "");
			} else {
				$t->sparse("pay_link", false);
			}

			$t->parse("records", true);
		} while ($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>