<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  user_product.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/record.php");
	include_once ("./includes/editgrid.php");
	include_once ("./includes/shopping_cart.php");
	include_once ("./includes/friendly_functions.php");
	include_once ("./messages/".$language_code."/cart_messages.php");
	include_once ("./messages/".$language_code."/download_messages.php");

	check_user_session();

	$eol = get_eol();
	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$html_editor = get_setting_value($settings, "user_html_editor", 0);
	$friendly_auto = get_setting_value($settings, "friendly_auto", 0);

	$user_settings = array();
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "user_types_settings WHERE type_id=" . $db->tosql(get_session("session_user_type_id"), INTEGER);
	$db->query($sql);
	while($db->next_record()) {
		$user_settings[$db->f("setting_name")] = $db->f("setting_value");
	}
	$access_products = get_setting_value($user_settings, "access_products", 0);
	if (!$access_products) {
		header("Location: user_home.php");
		exit;
	}
	// get product settings
	$setting_type = "user_product_" . get_session("session_user_type_id");
	$product_settings = array();
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
	$db->query($sql);
	while($db->next_record()) {
		$product_settings[$db->f("setting_name")] = $db->f("setting_value");
	}

	$products_limit = get_setting_value($product_settings, "products_limit", "");
	$show_predefined_serials = get_setting_value($product_settings, "show_predefined_serials", 0);
	$features_editor = get_setting_value($product_settings, "features_editor", 0);
	$short_description_editor = get_setting_value($product_settings, "short_description_editor", 0);
	$full_description_editor = get_setting_value($product_settings, "full_description_editor", 0);
	$special_offer_editor = get_setting_value($product_settings, "special_offer_editor", 0);
	$notes_editor = get_setting_value($product_settings, "notes_editor", 0);
	$show_terms = get_setting_value($product_settings, "show_terms", 0);
	$generate_small_image = get_setting_value($settings, "user_generate_small_image", 0);
	$generate_large_image = get_setting_value($settings, "user_generate_large_image", 0);

	$date_format_msg = str_replace("{date_format}", join("", $date_edit_format), DATE_FORMAT_MSG);

	$content_types = 
		array( 
			array(1, HTML_MSG), array(0, PLAIN_TEXT_MSG)
		);

	$generate_serial_values = 
		array( 
			array(0, SERIAL_DONT_GENERATE_MSG), array(1, SERIAL_RANDOM_GENERATE_MSG), array(2, SERIAL_FROM_PREDEFINED_MSG)
		);

	$approve_values = array(array(1, YES_MSG), array(0, NO_MSG));

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","user_product.html");
  $t->set_var("site_url",        	$settings["site_url"]);
	$t->set_var("user_home_href",  	"user_home.php");
	$t->set_var("user_products_href",  "user_products.php");
	$t->set_var("user_product_href",   "user_product.php");
	$t->set_var("user_upload_href",    "user_upload.php");
	$t->set_var("user_select_href",    "user_select.php");
	$t->set_var("user_product_terms_href", "user_product_terms.php");

	$t->set_var("currency_sign",    $currency_left.$currency_right);
	$t->set_var("currency_left",    $currency_left);
	$t->set_var("currency_right",   $currency_right);
	$t->set_var("currency_rate",    $currency_rate);
	$t->set_var("features_editor",  $features_editor);
	$t->set_var("short_description_editor", $short_description_editor);
	$t->set_var("full_description_editor",  $full_description_editor);
	$t->set_var("special_offer_editor",  $special_offer_editor);
	$t->set_var("notes_editor",  $notes_editor);
	$t->set_var("date_edit_format", join("", $date_edit_format));
	$t->set_var("date_format_msg",  $date_format_msg);

	$t->set_var("HIDE_ADD_BUTTON_MSG",         str_replace("{ADD_TO_CART_MSG}", ADD_TO_CART_MSG, HIDE_ADD_BUTTON_MSG));
	$t->set_var("DISABLE_OUT_STOCK_DESC",      str_replace("{ADD_TO_CART_MSG}", ADD_TO_CART_MSG, DISABLE_OUT_STOCK_DESC));

	$t->set_var("CANCEL_BUTTON", CANCEL_BUTTON);
	$t->set_var("DELETE_BUTTON", DELETE_BUTTON);

	$item_types = get_db_values("SELECT item_type_id,item_type_name FROM " . $table_prefix . "item_types WHERE is_user=1 ", array(array("", "")));
	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states", array(array("", SELECT_STATE_MSG)));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", SELECT_COUNTRY_MSG)));
	// prepare categories options
	$categories = array();
	$sql = "SELECT category_id,category_name,category_path FROM " . $table_prefix . "categories WHERE allowed_post=1 ORDER BY category_order ";
	$db->query($sql);
	while ($db->next_record()) {
		$category_id = $db->f("category_id");
		$category_name = get_translation($db->f("category_name"));
		$category_path = $db->f("category_path");
		$categories[$category_id] = array($category_name, $category_path);
	}

	$categories_options = array();
	$categories_options[] = array("", SELECT_CATEGORY_MSG);
	foreach ($categories as $category_id => $category_info) {
		$category_name = $category_info[0];
		$category_path = $category_info[1];
		if ($category_path != "0,") {
			$categories_ids = explode(",", $category_path);
			$max_index = sizeof($categories_ids) - 2;
			for($i = $max_index; $i > 0; $i--) {
				$parent_id = $categories_ids[$i];
				if(isset($categories[$parent_id])) {
					$parent_name = $categories[$parent_id][0];
				} else {
					$sql = " SELECT category_name FROM " . $table_prefix . "categories WHERE category_id=" . $db->tosql($parent_id, INTEGER);
					$parent_name = get_translation(get_db_value($sql));
					$categories[$parent_id] = array($parent_name);
				}
				$category_name = $parent_name . " > " . $category_name;
			}
		}
		$categories_options[] = array($category_id, $category_name);
	}

	$r = new VA_Record($table_prefix . "items");

	// set up html form parameters
	$r->add_where("item_id", INTEGER);

	$r->add_where("user_id", INTEGER);
	$r->change_property("user_id", USE_IN_INSERT, true);

	$r->add_select("category_id", INTEGER, $categories_options, AD_CATEGORY_MSG);
	$r->change_property("category_id", REQUIRED, true);
	$r->change_property("category_id", USE_IN_INSERT, false);
	$r->change_property("category_id", USE_IN_UPDATE, false);
	$r->change_property("category_id", USE_IN_SELECT, false);

	$r->add_textbox("is_approved", INTEGER);

	// fields
	$r->add_checkbox("is_showing", INTEGER);

	$r->add_select("item_type_id", INTEGER, $item_types, PROD_TYPE_MSG);
	$r->parameters["item_type_id"][REQUIRED] = true;
	$r->add_textbox("item_name", TEXT, PROD_NAME_MSG);
	$r->parameters["item_name"][REQUIRED] = true;
	$r->add_textbox("friendly_url", TEXT, FRIENDLY_URL_MSG);
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("item_order", INTEGER, PROD_ORDER_MSG);
	$r->parameters["item_order"][REQUIRED] = true;
	$manufacturers = get_db_values("SELECT manufacturer_id,manufacturer_name FROM " . $table_prefix . "manufacturers", array(array("", "")));
	$r->add_select("manufacturer_id", INTEGER, $manufacturers, PROD_MANUFACTURER_MSG);
	$r->add_textbox("manufacturer_code", TEXT, PROD_CODE_MSG);
	$r->add_textbox("weight", NUMBER, WEIGHT_MSG);
	$r->add_textbox("issue_date", DATETIME, PROD_ISSUE_DATE_MSG);
	$r->change_property("issue_date", VALUE_MASK, $date_edit_format);
	$r->add_checkbox("is_compared", INTEGER, PROD_ALLOWED_COMPARISON_MSG);
	$r->add_checkbox("tax_free", INTEGER, PROD_TAX_FREE_MSG);

	$languages = get_db_values("SELECT language_code, language_name FROM " . $table_prefix . "languages", array(array("", "")));
	$r->add_select("language_code", TEXT, $languages);

	$r->add_checkbox("is_price_edit", NUMBER, PROD_CHANGE_PRICE_MSG);
	$r->add_textbox("price", NUMBER, PROD_LIST_PRICE_MSG);
	$r->parameters["price"][REQUIRED] = true;
	$r->add_textbox("trade_price", NUMBER, PROD_TRADE_PRICE_MSG);
	$r->add_checkbox("is_sales", INTEGER, PROD_ACTIVATE_DISCOUNT_MSG);
	$r->add_textbox("sales_price", NUMBER, PROD_DISCOUNT_PRICE_MSG);
	$r->add_textbox("trade_sales", NUMBER, PROD_DISCOUNT_TRADE_MSG);
	$r->add_textbox("discount_percent", NUMBER);
	$r->add_textbox("buying_price", NUMBER, PROD_BUYING_PRICE_MSG);
	$r->add_textbox("properties_price", NUMBER, PROD_OPTIONS_PRICE_MSG);

	// descriptions
	$r->add_textbox("features", TEXT, HIGHLIGHTS_MSG);
	$r->add_textbox("short_description", TEXT, SHORT_DESCRIPTION_MSG);
	$r->add_textbox("full_desc_type", INTEGER);
	$r->add_textbox("full_description", TEXT, FULL_DESCRIPTION_MSG);

	// meta data
	$r->add_textbox("meta_title", TEXT, META_TITLE_MSG);
	$r->add_textbox("meta_keywords", TEXT, META_KEYWORDS_MSG);
	$r->add_textbox("meta_description", TEXT, META_DESCRIPTION_MSG);

	// images
	$r->add_textbox("small_image", TEXT, IMAGE_SMALL_MSG);
	$r->add_textbox("small_image_alt", TEXT, IMAGE_SMALL_ALT_MSG);
	$r->add_textbox("big_image", TEXT, IMAGE_LARGE_MSG);
	$r->add_textbox("big_image_alt", TEXT, IMAGE_LARGE_ALT_MSG);
	$r->add_textbox("super_image", TEXT, IMAGE_SUPER_MSG);

	// appearance
	$r->add_textbox("template_name", TEXT, CUSTOM_TEMPLATE_MSG);
	$r->add_checkbox("hide_add_list", INTEGER, HIDE_ADD_BUTTON_MSG . " " . ON_PROD_LIST_MSG);
	$r->add_checkbox("hide_add_details", INTEGER, HIDE_ADD_BUTTON_MSG . " " . ON_PROD_DETAILS_MSG);
	$r->add_textbox("preview_url", TEXT, PROD_PREVIEW_URL_MSG);
	$r->add_textbox("preview_width", INTEGER, PROD_PREVIEW_URL_MSG . " " . WIDTH_MSG);
	$r->add_textbox("preview_height", INTEGER, PROD_PREVIEW_URL_MSG . " " . HEIGHT_MSG);

	// stock
	$r->add_checkbox("use_stock_level", INTEGER, USE_STOCK_MSG);
	$r->add_textbox("stock_level", NUMBER, STOCK_QUANTITY_MSG);
	$r->add_checkbox("hide_out_of_stock", INTEGER, HIDE_OUT_STOCK_MSG);
	$r->change_property("hide_out_of_stock", USE_SQL_NULL, false);
	$r->add_checkbox("disable_out_of_stock", INTEGER, DISABLE_OUT_STOCK_MSG);

	// shipping
	$times = get_db_values("SELECT shipping_time_id,shipping_time_desc FROM " . $table_prefix . "shipping_times", array(array("", "None")), 90);
	$r->add_select("shipping_in_stock", INTEGER, $times, IN_STOCK_AVAILABILITY_MSG);
	$r->add_select("shipping_out_stock", INTEGER, $times, OUT_STOCK_AVAILABILITY_MSG);

	$rules = get_db_values("SELECT shipping_rule_id,shipping_rule_desc FROM " . $table_prefix . "shipping_rules", array(array("", "None")), 90);
	$r->add_select("shipping_rule_id", INTEGER, $rules, SHIPPING_RESTRICTIONS_MSG);

	// terms and conditions
	if ($show_terms) {
		$r->add_checkbox("terms", INTEGER);
		$r->change_property("terms", USE_IN_INSERT, false);
		$r->change_property("terms", USE_IN_UPDATE, false);
		$r->change_property("terms", USE_IN_SELECT, false);
	}

	// downloadable options
	$r->add_checkbox("downloadable", INTEGER, DOWNLOADABLE_MSG);
	$r->add_textbox("download_period", INTEGER, DOWNLOAD_PERIOD_MSG);
	$r->add_textbox("download_path", TEXT, DOWNLOAD_PATH_MSG);
	$r->add_checkbox("download_show_terms", INTEGER, DOWNLOAD_SHOW_TERMS_MSG);
	$r->add_textbox("download_terms_text", TEXT, DOWNLOAD_TERMS_MSG);
	$r->add_radio("generate_serial", INTEGER, $generate_serial_values, SERIAL_GENERATE_MSG);
	$r->add_textbox("serial_period", INTEGER, SERIAL_PERIOD_MSG);
	$r->add_textbox("activations_number", INTEGER, ACTIVATION_MAX_NUMBER_MSG);

	// set up html form parameters
	$is = new VA_Record($table_prefix . "items_serials", "serials");
	$is->add_where("serial_id", INTEGER);
	$is->add_hidden("item_id", INTEGER);
	$is->change_property("item_id", USE_IN_INSERT, true);
	$is->change_property("item_id", PARSE_NAME, "serial_item_id");

	$is->add_textbox("serial_number", TEXT, SERIAL_NUMBER_COLUMN);
	$is->parameters["serial_number"][REQUIRED] = true;
	$is->add_checkbox("used", INTEGER);

	$number_serials = get_param("number_serials");
	$is_eg = new VA_EditGrid($is, "serials");
	$is_eg->get_form_values($number_serials);

	// special
	$r->add_checkbox("is_special_offer", INTEGER, PROD_OFFER_ACTIVATE_MSG);
	$r->add_textbox("special_offer", TEXT, SPECIAL_OFFER_MSG);

	// notification fields
	$r->add_checkbox("mail_notify", INTEGER, EMAIL_USER_IF_STATUS_MSG);
	$r->add_textbox("mail_to", TEXT, EMAIL_TO_MSG);
	$r->add_textbox("mail_from", TEXT, EMAIL_FROM_MSG);
	$r->add_textbox("mail_cc", TEXT, EMAIL_CC_MSG);
	$r->add_textbox("mail_bcc", TEXT, EMAIL_BCC_MSG);
	$r->add_textbox("mail_reply_to", TEXT, EMAIL_REPLY_TO_MSG);
	$r->add_textbox("mail_return_path", TEXT, EMAIL_RETURN_PATH_MSG);
	$r->add_textbox("mail_subject", TEXT, EMAIL_SUBJECT_MSG);
	$r->add_radio("mail_type", INTEGER, $content_types, EMAIL_MESSAGE_TYPE_MSG);
	$r->parameters["mail_type"][DEFAULT_VALUE] = 0;
	$r->add_textbox("mail_body", TEXT, EMAIL_MESSAGE_MSG);

	$r->add_checkbox("sms_notify", INTEGER, SMS_USER_IF_STATUS_MSG);
	$r->add_textbox("sms_recipient", TEXT, SMS_RECIPIENT_MSG);
	$r->add_textbox("sms_originator",TEXT, SMS_ORIGINATOR_MSG);
	$r->add_textbox("sms_message",   TEXT, SMS_MESSAGE_MSG);

	// rating / notes
	$r->add_textbox("votes", INTEGER, TOTAL_VOTES_MSG);
	$r->add_textbox("points", INTEGER, TOTAL_POINTS_MSG);
	$r->add_textbox("notes", TEXT, NOTES_MSG);
	$r->add_textbox("buy_link", TEXT, PROD_DIRECT_LINK_MSG);

	// editing information
	$r->add_textbox("admin_id_added_by", INTEGER);
	$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
	$r->change_property("admin_id_added_by", USE_SQL_NULL, false);
	$r->add_textbox("admin_id_modified_by", INTEGER);
	$r->change_property("admin_id_modified_by", USE_SQL_NULL, false);
	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("date_modified", DATETIME);
	// end of fields

	$common_fields = array("item_id", "user_id", "category_id", "is_approved", "item_type_id", "item_name", "full_desc_type", "admin_id_added_by", "admin_id_modified_by", "date_added", "date_modified");
	foreach($r->parameters as $parameter_name => $parameter_info) {
		if (!in_array($parameter_name, $common_fields)) {
			$show_parameter = get_setting_value($product_settings, "show_" . $parameter_name, 0);
			if ($show_parameter) {
				$parameter_required = get_setting_value($product_settings, $parameter_name . "_required", 0);
				$r->change_property($parameter_name, REQUIRED, $parameter_required);
			} else {
				$r->change_property($parameter_name, SHOW, false);
				$r->change_property($parameter_name, USE_IN_INSERT, false);
				$r->change_property($parameter_name, USE_IN_UPDATE, false);
			}
		}
	}

	if (!$r->parameters["small_image"][SHOW] && $generate_small_image) {
		$r->add_textbox("small_image_hidden", TEXT);
		$r->change_property("small_image_hidden", COLUMN_NAME, "small_image");

	}
	if (!$r->parameters["big_image"][SHOW] && $generate_large_image) {
		$r->add_textbox("big_image_hidden", TEXT);
		$r->change_property("big_image_hidden", COLUMN_NAME, "big_image");
	}

	$generate_small_image = get_setting_value($settings, "user_generate_small_image", 0);
	$generate_large_image = get_setting_value($settings, "user_generate_large_image", 0);

	$r->get_form_values();
	$r->set_value("user_id", get_session("session_user_id"));
	$r->set_value("full_desc_type", 1);
	if (!$r->parameters["is_showing"][SHOW]) {
		$r->change_property("is_showing", USE_IN_INSERT, true);
		$r->set_value("is_showing", 1);
	}
	if (!$r->parameters["friendly_url"][SHOW]) {
		$r->change_property("friendly_url", USE_IN_INSERT, true);
	}
	if (!$r->parameters["item_order"][SHOW]) {
		$r->change_property("item_order", USE_IN_INSERT, true);
		$r->set_value("item_order", 1);
	}
	if (!$r->parameters["is_sales"][SHOW]) {
		$r->change_property("is_sales", USE_IN_INSERT, true);
		$r->set_value("is_sales", 0);
	}
	$r->change_property("price", USE_IN_INSERT, true);
	$r->change_property("trade_price", USE_IN_INSERT, true);
	$r->change_property("sales_price", USE_IN_INSERT, true);
	$r->change_property("trade_sales", USE_IN_INSERT, true);
	$r->change_property("properties_price", USE_IN_INSERT, true);

	if (!$r->parameters["hide_out_of_stock"][SHOW]) {
		$r->change_property("hide_out_of_stock", USE_IN_INSERT, true);
		$r->set_value("hide_out_of_stock", 0);
	}

	$item_id = get_param("item_id");
	$operation = get_param("operation");
	$current_tab = get_param("current_tab");
	if (!$current_tab) { $current_tab = "general"; }
	$return_page = "user_products.php";
	$downloads_errors = "";


	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $item_id)
		{
			if (!isset($user_settings["delete_product"]) || $user_settings["delete_product"] != 1) {
				$r->errors = PROD_DELETE_ERROR;
			} else {
				delete_products($item_id);

				header("Location: " . $return_page);
				exit;
			} 
		} else if ($operation == "more_serials") {
			$number_serials += 5;
		} else if ($operation == "save") {
			$is_valid = true;

			if(strlen($item_id)) {
				if (!isset($user_settings["edit_product"]) || $user_settings["edit_product"] != 1) {
					$is_valid = false;
					$r->errors = PROD_EDIT_ERROR;
				}
			} else {
				if (!isset($user_settings["add_product"]) || $user_settings["add_product"] != 1) {
					$is_valid = false;
					$r->errors = PROD_NEW_ERROR;
				} else if (strlen($products_limit)) {
					$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "items ";
					$sql .= " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
					$products_number = get_db_value($sql);
					if ($products_number >= $products_limit) {
						$products_limit_error = str_replace("{products_limit}", $products_limit, MERCHANT_PRODUCTS_LIMIT_ERROR);
						$is_valid = false;
						$r->errors = $products_limit_error . "<br>";
					}
				}
			}
			if ($is_valid) {
				$is_valid = $r->validate();
			}

			if ($show_terms) {
				if ($r->get_value("terms") != 1) {
					$is_valid = false;
					$r->errors .= PROD_TERMS_USER_ERROR;
				}
			}

			if ($is_valid) {
				$record_valid = $r->validate(); 
				$grid_valid = $is_eg->validate();
				$is_valid = ($record_valid && $grid_valid);
				if (!$is_valid) {
					$current_tab = "downloads";
					$downloads_errors = $r->errors;
					$r->errors = "";
				}
			} else {
				$current_tab = "general";
			}
			
			if($is_valid)
			{
				$r->set_value("admin_id_added_by", get_session("session_admin_id"));
				$r->set_value("admin_id_modified_by", get_session("session_admin_id"));

				if ($r->is_empty("price")) {
					$r->set_value("price", 0);
				}
				if ($r->is_empty("trade_price")) {
					$r->set_value("trade_price", 0);
				}
				if ($r->is_empty("sales_price")) {
					$r->set_value("sales_price", 0);
				}
				if ($r->is_empty("trade_sales")) {
					$r->set_value("trade_sales", 0);
				}
				if ($r->is_empty("properties_price")) {
					$r->set_value("properties_price", 0);
				}

				/* convert prices to default currency
				$price = $r->get_value("price");
				$price = round($price / $currency_rate, 2); 
				$r->set_value("price", $price);*/
	  
				$is_approved = (isset($user_settings["approve_product"]) && $user_settings["approve_product"] == 1) ? 1 : 0;
				$r->set_value("is_approved", $is_approved);
	  
				if (strlen($item_id)) {
					if ($friendly_auto) {
						$r->change_property("friendly_url", USE_IN_UPDATE, true);
						set_friendly_url();
					}
					$r->set_value("date_modified", va_time());
					$record_updated = $r->update_record();
					if ($record_updated) {
						$sql  = " DELETE FROM " . $table_prefix . "items_categories";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$db->query($sql);
						$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id,category_id) VALUES (";
						$sql .= $db->tosql($item_id, INTEGER) . ",";
						$sql .= $db->tosql($r->get_value("category_id"), INTEGER) . ")";
						$db->query($sql);
	        }
				} else {
					set_friendly_url();

					$r->set_value("date_added", va_time());
					$r->set_value("date_modified", va_time());
					if ($db_type == "postgre") {
						$item_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "items') ");
						$r->change_property("item_id", USE_IN_INSERT, true);
						$r->set_value("item_id", $item_id);
					}
					$record_updated = $r->insert_record();
					if ($record_updated) {
						if ($db_type == "mysql") {
							$item_id = get_db_value(" SELECT LAST_INSERT_ID() ");
							$r->set_value("item_id", $item_id);
						} else if ($db_type == "access") {
							$item_id = get_db_value(" SELECT @@IDENTITY ");
							$r->set_value("item_id", $item_id);
						}
						$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id,category_id) VALUES (";
						$sql .= $db->tosql($item_id, INTEGER) . ",";
						$sql .= $db->tosql($r->get_value("category_id"), INTEGER) . ")";
						$db->query($sql);
					} else {
						$item_id = "";
						$r->set_value("item_id", "");
					}
				}

				if ($operation == "save") {
					// update serial numbers
					$is_eg->set_values("item_id", $item_id);
					$is_eg->update_all($number_serials);
				}

				if ($record_updated) {

					$admin_notification = get_setting_value($product_settings, "admin_notification", 0);
					$user_notification = get_setting_value($product_settings, "user_notification", 0);
					$admin_sms_notification = get_setting_value($product_settings, "admin_sms_notification", 0);
					$user_sms_notification = get_setting_value($product_settings, "user_sms_notification", 0);

					if ($admin_notification || $user_notification || $admin_sms_notification || $user_sms_notification) {
						$r->set_parameters();
					}
			  
					if ($admin_notification) {
						$t->set_block("admin_subject", $product_settings["admin_subject"]);
						$t->set_block("admin_message", $product_settings["admin_message"]);
						$t->parse("admin_subject", false);
						$t->parse("admin_message", false);
			  
						$mail_to = get_setting_value($product_settings, "admin_email", $settings["admin_email"]);
						$mail_to = str_replace(";", ",", $mail_to);
						$mail_from = get_setting_value($product_settings, "admin_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($product_settings, "cc_emails");
						$mail_bcc = get_setting_value($product_settings, "admin_mail_bcc");
						$mail_reply_to = get_setting_value($product_settings, "admin_mail_reply_to");
						$mail_return_path = get_setting_value($product_settings, "admin_mail_return_path");
						$mail_type = get_setting_value($product_settings, "admin_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
			  
						$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
						mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}		 
					if ($user_notification) {
						$t->set_block("user_subject", $product_settings["user_subject"]);
						$t->set_block("user_message", $product_settings["user_message"]);
						$t->parse("user_subject", false);
						$t->parse("user_message", false);
			  
			      $mail_to = get_session("session_user_email");
						$mail_from = get_setting_value($product_settings, "user_mail_from", $settings["admin_email"]);
						$mail_cc = get_setting_value($product_settings, "user_mail_cc");
						$mail_bcc = get_setting_value($product_settings, "user_mail_bcc");
						$mail_reply_to = get_setting_value($product_settings, "user_mail_reply_to");
						$mail_return_path = get_setting_value($product_settings, "user_mail_return_path");
						$mail_type = get_setting_value($product_settings, "user_message_type");
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
			  
						$user_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("user_message"));
						mail($mail_to, $t->get_var("user_subject"), $user_message, $email_headers);
					}	
			  
					if ($admin_sms_notification) 
					{
						$admin_sms_recipient  = get_setting_value($order_info, "admin_sms_recipient", "");
						$admin_sms_originator = get_setting_value($order_info, "admin_sms_originator", "");
						$admin_sms_message    = get_setting_value($order_info, "admin_sms_message", "");
			  
						$t->set_block("admin_sms_recipient",  $admin_sms_recipient);
						$t->set_block("admin_sms_originator", $admin_sms_originator);
						$t->set_block("admin_sms_message",    $admin_sms_message);
			  
						$t->parse("admin_sms_recipient", false);
						$t->parse("admin_sms_originator", false);
						$t->parse("admin_sms_message", false);
			  
						sms_send($t->get_var("admin_sms_recipient"), $t->get_var("admin_sms_message"), $t->get_var("admin_sms_originator"));
					}		 
			  
					if ($user_sms_notification) 
					{
						$cell_phone = get_db_value("SELECT cell_phone FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER));

						$user_sms_recipient  = get_setting_value($order_info, "user_sms_recipient", $cell_phone);
						$user_sms_originator = get_setting_value($order_info, "user_sms_originator", "");
						$user_sms_message    = get_setting_value($order_info, "user_sms_message", "");
			      
						$t->set_block("user_sms_recipient",  $user_sms_recipient);
						$t->set_block("user_sms_originator", $user_sms_originator);
						$t->set_block("user_sms_message",    $user_sms_message);
			      
						$t->parse("user_sms_recipient", false);
						$t->parse("user_sms_originator", false);
						$t->parse("user_sms_message", false);
			      
						if (sms_send_allowed($t->get_var("user_sms_recipient"))) {
							sms_send($t->get_var("user_sms_recipient"), $t->get_var("user_sms_message"), $t->get_var("user_sms_originator"));
						}
					}		 
	      
					header("Location: " . $return_page);
					exit;
				}

			}
		}
	} else if(strlen($item_id)) {
		$is_record = $r->get_db_values();
		if (!$is_record) {
			$item_id = "";
			$r->set_value("item_id", "");
		}

		if ($r->get_value("trade_price") == 0) { $r->set_value("trade_price", ""); }
		if ($r->get_value("sales_price") == 0) { $r->set_value("sales_price", ""); }
		if ($r->get_value("trade_sales") == 0) { $r->set_value("trade_sales", ""); }
		if ($r->get_value("buying_price") == 0) {	$r->set_value("buying_price", ""); }
		if ($r->get_value("properties_price") == 0) {	$r->set_value("properties_price", ""); }

		// check data for serial numbers
		$is_eg->set_value("item_id", $item_id);
		$is_eg->change_property("serial_id", USE_IN_SELECT, true);
		$is_eg->change_property("serial_id", USE_IN_WHERE, false);
		$is_eg->change_property("item_id", USE_IN_WHERE, true);
		$is_eg->change_property("item_id", USE_IN_SELECT, true);
		$number_serials = $is_eg->get_db_values();
		if ($number_serials == 0) {
			$number_serials = 5;
		}

		/* convert prices to selected currency
		$price = $r->get_value("price");
		$price = round($price * $currency_rate, 2); 
		$r->set_value("price", $price);//*/

		$sql  = " SELECT category_id FROM " . $table_prefix . "items_categories ";
		$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$category_id = get_db_value($sql);
		$r->set_value("category_id", $category_id);
	}
	else // new record (set default values)
	{
		$sql  = " SELECT MAX(item_order) FROM " . $table_prefix . "items i ";
		$sql .= " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
		$item_order = get_db_value($sql);
		$item_order = ($item_order) ? ($item_order + 1) : 1;
		$r->set_value("item_order", $item_order);
		//$r->set_value("use_stock_level", 1);
		//$r->set_value("hide_out_of_stock", 1);
		$r->set_value("is_showing", 1);

		// serial numbers
		$number_serials = 5;
	}

	$r->set_form_parameters();

	$tabs_parse["general"] = true;

	// set errors
	if ($downloads_errors) {
		$t->set_var("errors_list", $downloads_errors);
		$t->parse("downloads_errors", false);
	}

	// set serial numbers
	$t->set_var("number_serials", $number_serials);
	$is_eg->set_parameters_all($number_serials);


	if (strlen($item_id)) {
		if (isset($user_settings["edit_product"]) && $user_settings["edit_product"] == 1) {
			$t->set_var("save_button_title", UPDATE_BUTTON);
			$t->global_parse("save_button", false, false, true);
		}
		if (isset($user_settings["delete_product"]) && $user_settings["delete_product"] == 1) {
			$t->parse("delete", false);	
		}
	} else {
		if (isset($user_settings["add_product"]) && $user_settings["add_product"] == 1) {
			$t->set_var("save_button_title", ADD_BUTTON);
			$t->global_parse("save_button", false, false, true);
		}
		$t->set_var("delete", "");	
	}

	// parse sections
	if ($r->parameters["manufacturer_id"][SHOW] || $r->parameters["manufacturer_code"][SHOW]) {
		$t->sparse("manufacturer_section", false);
	}
	if ($r->parameters["is_compared"][SHOW] || $r->parameters["tax_free"][SHOW]) {
		$t->sparse("additional_options_section", false);
	}
	if ($r->parameters["features"][SHOW] || $r->parameters["short_description"][SHOW] || $r->parameters["full_description"][SHOW]) {
		$t->sparse("description_section", false);
	}
	if ($r->parameters["price"][SHOW] && $r->parameters["is_sales"][SHOW] && $r->parameters["sales_price"][SHOW] && $r->parameters["discount_percent"][SHOW]) {
		$t->sparse("preview_price_title", false);
		$t->sparse("preview_price_block", false);
	}
	if (
		$r->parameters["is_price_edit"][SHOW] || $r->parameters["price"][SHOW] || $r->parameters["trade_price"][SHOW] ||
		$r->parameters["is_sales"][SHOW] || $r->parameters["sales_price"][SHOW] || $r->parameters["trade_sales"][SHOW] ||
		$r->parameters["discount_percent"][SHOW] || $r->parameters["buying_price"][SHOW] || $r->parameters["properties_price"][SHOW]
	) {
		$t->sparse("pricing_section", false);
	}
	if ($r->parameters["meta_title"][SHOW] || $r->parameters["meta_keywords"][SHOW] || $r->parameters["meta_description"][SHOW]) {
		$t->sparse("meta_section", false);
	}

	if (
		$r->parameters["small_image"][SHOW] || $r->parameters["small_image_alt"][SHOW] || 
		$r->parameters["big_image"][SHOW] || $r->parameters["big_image_alt"][SHOW] || $r->parameters["super_image"][SHOW]
	) {
		$t->sparse("images_section", false);
	}

	if ($r->parameters["hide_add_list"][SHOW] || $r->parameters["hide_add_details"][SHOW]) {
		$t->sparse("hide_add_section", false);
	}
	if ($r->parameters["preview_url"][SHOW] || $r->parameters["preview_width"][SHOW] || $r->parameters["preview_height"][SHOW]) {
		$t->sparse("preview_url_section", false);
	}
	if (
		$r->parameters["template_name"][SHOW] || 
		$r->parameters["hide_add_list"][SHOW] || $r->parameters["hide_add_details"][SHOW] || 
		$r->parameters["preview_url"][SHOW] || $r->parameters["preview_width"][SHOW] || $r->parameters["preview_height"][SHOW]
	) {
		$t->sparse("appearance_section", false);
	}

	if (
		$r->parameters["use_stock_level"][SHOW] || $r->parameters["stock_level"][SHOW] || 
		$r->parameters["hide_out_of_stock"][SHOW] || $r->parameters["disable_out_of_stock"][SHOW] 
	) {
		$t->sparse("stock_section", false);
	}

	if ($r->parameters["shipping_in_stock"][SHOW] || $r->parameters["shipping_out_stock"][SHOW] || $r->parameters["shipping_rule_id"][SHOW]) {
		$t->sparse("shipping_section", false);
	}

	$download_section = false; $serial_section = false;
	if ($r->parameters["downloadable"][SHOW] || $r->parameters["download_period"][SHOW] || $r->parameters["download_path"][SHOW]
		|| $r->parameters["download_show_terms"][SHOW] || $r->parameters["download_terms_text"][SHOW]) {
		$download_section = true;
		$t->sparse("download_section", false);
	}
	if ($r->parameters["generate_serial"][SHOW] || $r->parameters["serial_period"][SHOW] || $r->parameters["activations_number"][SHOW] || $show_predefined_serials) {
		$serial_section = true;
		$t->sparse("serial_section", false);
	}
	if ($show_predefined_serials) {
		$t->sparse("serial_predefined_section", false);
	}
	$tabs_parse["downloads"] = ($download_section || $serial_section);

	$tabs_parse["special_offer"] = ($r->parameters["is_special_offer"][SHOW] || $r->parameters["special_offer"][SHOW]);

	$email_notify_section = false; $sms_notify_section = false;
	if (
		$r->parameters["mail_notify"][SHOW] || $r->parameters["mail_to"][SHOW] || $r->parameters["mail_from"][SHOW] ||
		$r->parameters["mail_cc"][SHOW] || $r->parameters["mail_bcc"][SHOW] || $r->parameters["mail_reply_to"][SHOW] ||
		$r->parameters["mail_return_path"][SHOW] || $r->parameters["mail_subject"][SHOW] || $r->parameters["mail_type"][SHOW] ||
		$r->parameters["mail_body"][SHOW]
	) {
		$email_notify_section = true; 
		$t->sparse("email_notify_section", false);
	}
	if (
		$r->parameters["sms_notify"][SHOW] || $r->parameters["sms_recipient"][SHOW] || 
		$r->parameters["sms_originator"][SHOW] || $r->parameters["sms_message"][SHOW] 
	) {
		$sms_notify_section = true;
		$t->sparse("sms_notify_section", false);
	}
	$tabs_parse["notifications"] = ($email_notify_section || $sms_notify_section);

	$rating_section = false; $other_section = false;
	if ($r->parameters["votes"][SHOW] || $r->parameters["points"][SHOW]) {
		$rating_section = true; 
		$t->sparse("rating_section", false);
	}
	if ($r->parameters["notes"][SHOW] || $r->parameters["buy_link"][SHOW]) {
		$other_section = true;
		$t->sparse("other_section", false);
	}
	$tabs_parse["other"] = ($rating_section || $other_section);

	// set styles for tabs
	$tabs = array("general" => PROD_GENERAL_TAB, "downloads" => PROD_DOWNLOADABLE_TAB, "special_offer" => PROD_SPECIAL_OFFER_TAB, "notifications" => PROD_NOTIFICATION_TAB, "other" => PROD_NOTES_TAB);
	foreach ($tabs as $tab_name => $tab_title) {
		$t->set_var("tab_id", "tab_" . $tab_name);
		$t->set_var("tab_name", $tab_name);
		$t->set_var("tab_title", $tab_title);
		if ($tab_name == $current_tab) {
			$t->set_var("tab_class", "adminTabActive");
			$t->set_var($tab_name . "_style", "display: block;");
		} else {
			$t->set_var("tab_class", "adminTab");
			$t->set_var($tab_name . "_style", "display: none;");
		}
		if ($tabs_parse[$tab_name]) {
			$t->parse("tabs", true);
		}
	}
	$t->set_var("current_tab", $current_tab);


	include("./header.php");
	include("./footer.php");

	$t->pparse("main");

?>