<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  user_products.php                                        ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	$includes_path = "./includes/";
	include_once ($includes_path . "/common.php");
	include_once ($includes_path . "/sorter.php");
	include_once ($includes_path . "/navigator.php");
	include_once ($includes_path . "/record.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	check_user_session();

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","user_products.html");
	$t->set_var("user_products_href",  "user_products.php");
	$t->set_var("user_product_href",   "user_product.php");
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("MY_PRODUCTS_MSG",     MY_PRODUCTS_MSG);
	$t->set_var("MY_ACCOUNT_MSG", MY_ACCOUNT_MSG);
	$t->set_var("NO_PRODUCTS_MSG",     NO_PRODUCTS_MSG);
	$t->set_var("EDIT_PRODUCT_MSG",    EDIT_PRODUCT_MSG);
	$t->set_var("ADD_NEW_PRODUCT_MSG", ADD_NEW_PRODUCT_MSG);
	$t->set_var("AD_STATUS_COLUMN", AD_STATUS_COLUMN);

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "user_products.php");
	$s->set_default_sorting(1, "desc");
	$s->set_sorter(PROD_ID_COLUMN, "sorter_id", "1", "item_id");
	$s->set_sorter(PROD_TITLE_COLUMN, "sorter_title", "2", "item_name");
	$s->set_sorter(PROD_PRICE_COLUMN, "sorter_price", "3", "price");
	$s->set_sorter(PROD_QTY_COLUMN,   "sorter_qty", "4", "stock_level");
	$s->set_sorter(PROD_STATUS_COLUMN, "sorter_status", "5", "is_approved");

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "user_products.php");

	include("./header.php");
	include("./footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "items WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT item_id, item_name, price, stock_level, is_showing, is_approved ";
	$sql .= " FROM " . $table_prefix . "items ";
	$sql .= " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	$db->query($sql . $s->order_by);
	if($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do
		{
			$item_id = $db->f("item_id");
			$item_name = $db->f("item_name");
			$price = $db->f("price");
			$quantity = $db->f("stock_level");
			$price = $price * $currency_rate;

			$t->set_var("item_id", $item_id);
			$t->set_var("item_name", $item_name);
			$t->set_var("price", $currency_left . number_format($price * $currency_rate, 2) . $currency_right);
			$t->set_var("quantity", $quantity);

			$is_approved = $db->f("is_approved");
			$is_showing = $db->f("is_showing");
			if ($is_approved != 1) {
				$status = PROD_NOT_APPROVED_MSG;
			}	else if ($is_showing != 1) {
				$status = PROD_HIDDEN_MSG;
			} else {
				$status = PROD_ACTIVE_MSG;
			}
			$t->set_var("status", $status);


			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>