<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 3.2                                                  ***
  ***      File:  user_support.php                                         ***
  ***      Built: Fri Jun 15 02:54:45 2007                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	$includes_path = "./includes/";
	include_once ($includes_path . "/common.php");
	include_once ($includes_path . "/sorter.php");
	include_once ($includes_path . "/navigator.php");
	include_once ($includes_path . "/record.php");
	include_once ("./messages/".$language_code."/support_messages.php");

	check_user_session();

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","user_support.html");
	$t->set_var("SUPPORT_TITLE",        SUPPORT_TITLE);
	$t->set_var("MY_ACCOUNT_MSG",       MY_ACCOUNT_MSG);
	$t->set_var("DATABASE_ERROR_MSG",   DATABASE_ERROR_MSG);

	$t->set_var("MY_SUPPORT_ISSUES_MSG",    MY_SUPPORT_ISSUES_MSG);
	$t->set_var("MY_SUPPORT_ISSUES_DESC",   MY_SUPPORT_ISSUES_DESC);
	$t->set_var("NEW_SUPPORT_REQUEST_MSG",  NEW_SUPPORT_REQUEST_MSG);
	$t->set_var("SUPPORT_REQUEST_ADDED_MSG",SUPPORT_REQUEST_ADDED_MSG);
	$t->set_var("SUPPORT_VIEW_MSG",         SUPPORT_VIEW_MSG);
	$t->set_var("NO_SUPPORT_REQUEST_MSG",   NO_SUPPORT_REQUEST_MSG);
	                                                                 
	$t->set_var("user_support_href", "user_support.php");
	$t->set_var("support_href", "support.php");
	$t->set_var("support_messages_href", "support_messages.php");
	$t->set_var("user_home_href", "user_home.php");

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "user_support.php");
	$s->set_default_sorting(4, "desc");
	$s->set_sorter(SUPPORT_SUMMARY_COLUMN, "sorter_summary", 1, "summary");
	$s->set_sorter(SUPPORT_STATUS_COLUMN, "sorter_status", 2, "ss.status_name");
	$s->set_sorter(SUPPORT_TYPE_COLUMN, "sorter_type", 3, "st.type_name");
	$s->set_sorter(SUPPORT_UPDATED_COLUMN, "sorter_modified", 4, "s.date_modified");

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "user_support.php");

	include("./header.php");
	include("./footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "support s WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT s.support_id, s.summary, ss.status_name, st.type_name, s.date_added, s.date_modified ";
	$sql .= " FROM ((" . $table_prefix . "support s ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=s.support_status_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id=s.support_type_id) ";
	$sql .= " WHERE s.user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);

	$db->query($sql . $s->order_by);
	if($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do
		{
			$support_id = $db->f("support_id");
			$date_added = $db->f("date_added", DATETIME);
			$vc = md5($support_id . $date_added[3].$date_added[4].$date_added[5]);
			$t->set_var("support_id", $support_id);
			$t->set_var("vc", $vc);

			$t->set_var("summary", htmlspecialchars($db->f("summary")));
			$status_name = strlen($db->f("status_name")) ? $db->f("status_name") : SUPPORT_STATUS_NEW_MSG;
			$t->set_var("status_name", $status_name);
			$t->set_var("type_name", $db->f("type_name"));

			$date_modified = $db->f("date_modified", DATETIME);
			$t->set_var("date_modified", va_date($datetime_show_format, $date_modified));


			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->pparse("main");

?>